/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);


#line 220 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    FCONST = 259,
    SCONST = 260,
    BCONST = 261,
    XCONST = 262,
    Op = 263,
    ICONST = 264,
    PARAM = 265,
    TYPECAST = 266,
    DOT_DOT = 267,
    COLON_EQUALS = 268,
    ABORT_P = 269,
    ABSOLUTE_P = 270,
    ACCESS = 271,
    ACTION = 272,
    ADD_P = 273,
    ADMIN = 274,
    AFTER = 275,
    AGGREGATE = 276,
    ALL = 277,
    ALSO = 278,
    ALTER = 279,
    ALWAYS = 280,
    ANALYSE = 281,
    ANALYZE = 282,
    AND = 283,
    ANY = 284,
    ARRAY = 285,
    AS = 286,
    ASC = 287,
    ASSERTION = 288,
    ASSIGNMENT = 289,
    ASYMMETRIC = 290,
    AT = 291,
    ATTRIBUTE = 292,
    AUTHORIZATION = 293,
    BACKWARD = 294,
    BEFORE = 295,
    BEGIN_P = 296,
    BETWEEN = 297,
    BIGINT = 298,
    BINARY = 299,
    BIT = 300,
    BOOLEAN_P = 301,
    BOTH = 302,
    BY = 303,
    CACHE = 304,
    CALLED = 305,
    CASCADE = 306,
    CASCADED = 307,
    CASE = 308,
    CAST = 309,
    CATALOG_P = 310,
    CHAIN = 311,
    CHAR_P = 312,
    CHARACTER = 313,
    CHARACTERISTICS = 314,
    CHECK = 315,
    CHECKPOINT = 316,
    CLASS = 317,
    CLOSE = 318,
    CLUSTER = 319,
    COALESCE = 320,
    COLLATE = 321,
    COLLATION = 322,
    COLUMN = 323,
    COMMENT = 324,
    COMMENTS = 325,
    COMMIT = 326,
    COMMITTED = 327,
    CONCURRENTLY = 328,
    CONFIGURATION = 329,
    CONNECTION = 330,
    CONSTRAINT = 331,
    CONSTRAINTS = 332,
    CONTENT_P = 333,
    CONTINUE_P = 334,
    CONVERSION_P = 335,
    COPY = 336,
    COST = 337,
    CREATE = 338,
    CROSS = 339,
    CSV = 340,
    CURRENT_P = 341,
    CURRENT_CATALOG = 342,
    CURRENT_DATE = 343,
    CURRENT_ROLE = 344,
    CURRENT_SCHEMA = 345,
    CURRENT_TIME = 346,
    CURRENT_TIMESTAMP = 347,
    CURRENT_USER = 348,
    CURSOR = 349,
    CYCLE = 350,
    DATA_P = 351,
    DATABASE = 352,
    DAY_P = 353,
    DEALLOCATE = 354,
    DEC = 355,
    DECIMAL_P = 356,
    DECLARE = 357,
    DEFAULT = 358,
    DEFAULTS = 359,
    DEFERRABLE = 360,
    DEFERRED = 361,
    DEFINER = 362,
    DELETE_P = 363,
    DELIMITER = 364,
    DELIMITERS = 365,
    DESC = 366,
    DICTIONARY = 367,
    DISABLE_P = 368,
    DISCARD = 369,
    DISTINCT = 370,
    DO = 371,
    DOCUMENT_P = 372,
    DOMAIN_P = 373,
    DOUBLE_P = 374,
    DROP = 375,
    EACH = 376,
    ELSE = 377,
    ENABLE_P = 378,
    ENCODING = 379,
    ENCRYPTED = 380,
    END_P = 381,
    ENUM_P = 382,
    ESCAPE = 383,
    EXCEPT = 384,
    EXCLUDE = 385,
    EXCLUDING = 386,
    EXCLUSIVE = 387,
    EXECUTE = 388,
    EXISTS = 389,
    EXPLAIN = 390,
    EXTENSION = 391,
    EXTERNAL = 392,
    EXTRACT = 393,
    FALSE_P = 394,
    FAMILY = 395,
    FETCH = 396,
    FIRST_P = 397,
    FLOAT_P = 398,
    FOLLOWING = 399,
    FOR = 400,
    FORCE = 401,
    FOREIGN = 402,
    FORWARD = 403,
    FREEZE = 404,
    FROM = 405,
    FULL = 406,
    FUNCTION = 407,
    FUNCTIONS = 408,
    GLOBAL = 409,
    GRANT = 410,
    GRANTED = 411,
    GREATEST = 412,
    GROUP_P = 413,
    HANDLER = 414,
    HAVING = 415,
    HEADER_P = 416,
    HOLD = 417,
    HOUR_P = 418,
    IDENTITY_P = 419,
    IF_P = 420,
    ILIKE = 421,
    IMMEDIATE = 422,
    IMMUTABLE = 423,
    IMPLICIT_P = 424,
    IN_P = 425,
    INCLUDING = 426,
    INCREMENT = 427,
    INDEX = 428,
    INDEXES = 429,
    INHERIT = 430,
    INHERITS = 431,
    INITIALLY = 432,
    INLINE_P = 433,
    INNER_P = 434,
    INOUT = 435,
    INPUT_P = 436,
    INSENSITIVE = 437,
    INSERT = 438,
    INSTEAD = 439,
    INT_P = 440,
    INTEGER = 441,
    INTERSECT = 442,
    INTERVAL = 443,
    INTO = 444,
    INVOKER = 445,
    IS = 446,
    ISNULL = 447,
    ISOLATION = 448,
    JOIN = 449,
    KEY = 450,
    LABEL = 451,
    LANGUAGE = 452,
    LARGE_P = 453,
    LAST_P = 454,
    LC_COLLATE_P = 455,
    LC_CTYPE_P = 456,
    LEADING = 457,
    LEAKPROOF = 458,
    LEAST = 459,
    LEFT = 460,
    LEVEL = 461,
    LIKE = 462,
    LIMIT = 463,
    LISTEN = 464,
    LOAD = 465,
    LOCAL = 466,
    LOCALTIME = 467,
    LOCALTIMESTAMP = 468,
    LOCATION = 469,
    LOCK_P = 470,
    MAPPING = 471,
    MATCH = 472,
    MAXVALUE = 473,
    MINUTE_P = 474,
    MINVALUE = 475,
    MODE = 476,
    MONTH_P = 477,
    MOVE = 478,
    NAME_P = 479,
    NAMES = 480,
    NATIONAL = 481,
    NATURAL = 482,
    NCHAR = 483,
    NEXT = 484,
    NO = 485,
    NONE = 486,
    NOT = 487,
    NOTHING = 488,
    NOTIFY = 489,
    NOTNULL = 490,
    NOWAIT = 491,
    NULL_P = 492,
    NULLIF = 493,
    NULLS_P = 494,
    NUMERIC = 495,
    OBJECT_P = 496,
    OF = 497,
    OFF = 498,
    OFFSET = 499,
    OIDS = 500,
    ON = 501,
    ONLY = 502,
    OPERATOR = 503,
    OPTION = 504,
    OPTIONS = 505,
    OR = 506,
    ORDER = 507,
    OUT_P = 508,
    OUTER_P = 509,
    OVER = 510,
    OVERLAPS = 511,
    OVERLAY = 512,
    OWNED = 513,
    OWNER = 514,
    PARSER = 515,
    PARTIAL = 516,
    PARTITION = 517,
    PASSING = 518,
    PASSWORD = 519,
    PLACING = 520,
    PLANS = 521,
    POSITION = 522,
    PRECEDING = 523,
    PRECISION = 524,
    PRESERVE = 525,
    PREPARE = 526,
    PREPARED = 527,
    PRIMARY = 528,
    PRIOR = 529,
    PRIVILEGES = 530,
    PROCEDURAL = 531,
    PROCEDURE = 532,
    QUOTE = 533,
    RANGE = 534,
    READ = 535,
    REAL = 536,
    REASSIGN = 537,
    RECHECK = 538,
    RECURSIVE = 539,
    REF = 540,
    REFERENCES = 541,
    REINDEX = 542,
    RELATIVE_P = 543,
    RELEASE = 544,
    RENAME = 545,
    REPEATABLE = 546,
    REPLACE = 547,
    REPLICA = 548,
    RESET = 549,
    RESTART = 550,
    RESTRICT = 551,
    RETURNING = 552,
    RETURNS = 553,
    REVOKE = 554,
    RIGHT = 555,
    ROLE = 556,
    ROLLBACK = 557,
    ROW = 558,
    ROWS = 559,
    RULE = 560,
    SAVEPOINT = 561,
    SCHEMA = 562,
    SCROLL = 563,
    SEARCH = 564,
    SECOND_P = 565,
    SECURITY = 566,
    SELECT = 567,
    SEQUENCE = 568,
    SEQUENCES = 569,
    SERIALIZABLE = 570,
    SERVER = 571,
    SESSION = 572,
    SESSION_USER = 573,
    SET = 574,
    SETOF = 575,
    SHARE = 576,
    SHOW = 577,
    SIMILAR = 578,
    SIMPLE = 579,
    SMALLINT = 580,
    SNAPSHOT = 581,
    SOME = 582,
    STABLE = 583,
    STANDALONE_P = 584,
    START = 585,
    STATEMENT = 586,
    STATISTICS = 587,
    STDIN = 588,
    STDOUT = 589,
    STORAGE = 590,
    STRICT_P = 591,
    STRIP_P = 592,
    SUBSTRING = 593,
    SYMMETRIC = 594,
    SYSID = 595,
    SYSTEM_P = 596,
    TABLE = 597,
    TABLES = 598,
    TABLESPACE = 599,
    TEMP = 600,
    TEMPLATE = 601,
    TEMPORARY = 602,
    TEXT_P = 603,
    THEN = 604,
    TIME = 605,
    TIMESTAMP = 606,
    TO = 607,
    TRAILING = 608,
    TRANSACTION = 609,
    TREAT = 610,
    TRIGGER = 611,
    TRIM = 612,
    TRUE_P = 613,
    TRUNCATE = 614,
    TRUSTED = 615,
    TYPE_P = 616,
    TYPES_P = 617,
    UNBOUNDED = 618,
    UNCOMMITTED = 619,
    UNENCRYPTED = 620,
    UNION = 621,
    UNIQUE = 622,
    UNKNOWN = 623,
    UNLISTEN = 624,
    UNLOGGED = 625,
    UNTIL = 626,
    UPDATE = 627,
    USER = 628,
    USING = 629,
    VACUUM = 630,
    VALID = 631,
    VALIDATE = 632,
    VALIDATOR = 633,
    VALUE_P = 634,
    VALUES = 635,
    VARCHAR = 636,
    VARIADIC = 637,
    VARYING = 638,
    VERBOSE = 639,
    VERSION_P = 640,
    VIEW = 641,
    VOLATILE = 642,
    WHEN = 643,
    WHERE = 644,
    WHITESPACE_P = 645,
    WINDOW = 646,
    WITH = 647,
    WITHOUT = 648,
    WORK = 649,
    WRAPPER = 650,
    WRITE = 651,
    XML_P = 652,
    XMLATTRIBUTES = 653,
    XMLCONCAT = 654,
    XMLELEMENT = 655,
    XMLEXISTS = 656,
    XMLFOREST = 657,
    XMLPARSE = 658,
    XMLPI = 659,
    XMLROOT = 660,
    XMLSERIALIZE = 661,
    YEAR_P = 662,
    YES_P = 663,
    ZONE = 664,
    NULLS_FIRST = 665,
    NULLS_LAST = 666,
    WITH_TIME = 667,
    POSTFIXOP = 668,
    UMINUS = 669
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 158 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;

#line 712 "gram.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 740 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  696
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   73834

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  432
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  546
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2261
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  4301

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   669

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   421,     2,     2,
     426,   427,   419,   417,   430,   418,   428,   420,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   431,   429,
     414,   413,   415,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   424,     2,   425,   422,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   416,   423
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   653,   653,   660,   667,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   756,   757,   758,   759,   760,   761,
     762,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,   778,   779,   780,   781,
     782,   783,   784,   785,   786,   788,   798,   809,   810,   819,
     820,   824,   825,   829,   834,   838,   843,   848,   852,   856,
     861,   865,   919,   921,   925,   929,   933,   937,   951,   969,
     980,   981,   985,  1003,  1015,  1036,  1043,  1062,  1069,  1086,
    1104,  1115,  1116,  1128,  1135,  1152,  1164,  1176,  1177,  1181,
    1182,  1190,  1191,  1192,  1193,  1194,  1195,  1209,  1215,  1221,
    1230,  1238,  1246,  1250,  1258,  1266,  1273,  1280,  1288,  1299,
    1307,  1315,  1326,  1334,  1342,  1349,  1358,  1368,  1369,  1376,
    1377,  1380,  1382,  1386,  1387,  1388,  1389,  1393,  1394,  1395,
    1401,  1413,  1417,  1421,  1436,  1459,  1460,  1461,  1465,  1466,
    1467,  1471,  1472,  1476,  1483,  1490,  1497,  1504,  1514,  1515,
    1520,  1521,  1526,  1532,  1538,  1544,  1550,  1560,  1570,  1571,
    1575,  1576,  1584,  1599,  1605,  1611,  1617,  1635,  1644,  1653,
    1662,  1671,  1680,  1689,  1698,  1710,  1711,  1716,  1724,  1732,
    1741,  1749,  1757,  1766,  1775,  1784,  1793,  1803,  1816,  1830,
    1839,  1847,  1855,  1865,  1875,  1882,  1889,  1897,  1905,  1913,
    1921,  1929,  1936,  1943,  1951,  1958,  1965,  1973,  1981,  1989,
    1997,  2005,  2013,  2023,  2030,  2038,  2046,  2054,  2061,  2071,
    2072,  2076,  2077,  2078,  2082,  2090,  2094,  2095,  2099,  2102,
    2103,  2107,  2108,  2113,  2117,  2121,  2126,  2141,  2154,  2155,
    2160,  2169,  2179,  2189,  2214,  2220,  2247,  2269,  2283,  2284,
    2293,  2294,  2295,  2298,  2299,  2304,  2305,  2309,  2313,  2317,
    2321,  2325,  2329,  2333,  2337,  2341,  2345,  2349,  2353,  2362,
    2366,  2370,  2374,  2378,  2382,  2386,  2387,  2392,  2396,  2403,
    2410,  2411,  2412,  2413,  2414,  2418,  2422,  2430,  2441,  2456,
    2472,  2488,  2517,  2518,  2519,  2520,  2521,  2528,  2535,  2536,
    2540,  2541,  2545,  2546,  2550,  2554,  2561,  2565,  2572,  2573,
    2574,  2578,  2579,  2582,  2602,  2622,  2623,  2627,  2635,  2636,
    2637,  2668,  2675,  2682,  2693,  2704,  2714,  2723,  2756,  2763,
    2770,  2777,  2788,  2798,  2799,  2800,  2804,  2805,  2806,  2807,
    2808,  2809,  2818,  2826,  2830,  2843,  2858,  2872,  2887,  2901,
    2919,  2940,  2941,  2945,  2946,  2950,  2951,  2954,  2960,  2964,
    2972,  2977,  2983,  2984,  2988,  2993,  3000,  3001,  3011,  3013,
    3015,  3017,  3020,  3023,  3026,  3030,  3031,  3032,  3033,  3034,
    3037,  3038,  3043,  3044,  3045,  3046,  3049,  3050,  3051,  3052,
    3055,  3056,  3059,  3060,  3063,  3078,  3092,  3105,  3106,  3107,
    3120,  3132,  3140,  3151,  3152,  3155,  3156,  3159,  3163,  3167,
    3171,  3175,  3179,  3183,  3187,  3191,  3195,  3199,  3203,  3209,
    3210,  3214,  3215,  3216,  3221,  3224,  3225,  3237,  3249,  3264,
    3265,  3273,  3274,  3278,  3279,  3283,  3284,  3288,  3289,  3293,
    3304,  3317,  3318,  3328,  3338,  3339,  3352,  3359,  3376,  3384,
    3395,  3398,  3402,  3406,  3410,  3422,  3432,  3435,  3439,  3452,
    3462,  3472,  3481,  3490,  3499,  3509,  3518,  3528,  3538,  3548,
    3557,  3566,  3575,  3584,  3593,  3602,  3611,  3620,  3629,  3638,
    3647,  3665,  3676,  3677,  3678,  3679,  3683,  3684,  3688,  3689,
    3699,  3710,  3730,  3738,  3750,  3751,  3755,  3759,  3767,  3771,
    3775,  3782,  3786,  3791,  3796,  3803,  3810,  3815,  3825,  3839,
    3840,  3845,  3846,  3850,  3851,  3861,  3872,  3892,  3901,  3909,
    3926,  3941,  3959,  3960,  3964,  3968,  3975,  3986,  3995,  4013,
    4025,  4026,  4027,  4037,  4045,  4062,  4081,  4101,  4126,  4127,
    4128,  4132,  4134,  4156,  4158,  4160,  4162,  4164,  4169,  4174,
    4184,  4185,  4189,  4190,  4194,  4195,  4199,  4200,  4201,  4205,
    4211,  4212,  4213,  4217,  4218,  4223,  4224,  4251,  4252,  4253,
    4254,  4255,  4256,  4261,  4272,  4295,  4315,  4338,  4348,  4359,
    4369,  4379,  4390,  4399,  4406,  4413,  4422,  4431,  4440,  4449,
    4458,  4469,  4472,  4473,  4476,  4480,  4487,  4488,  4489,  4490,
    4491,  4494,  4495,  4498,  4501,  4502,  4510,  4517,  4518,  4521,
    4523,  4534,  4543,  4552,  4576,  4591,  4592,  4596,  4606,  4617,
    4626,  4636,  4645,  4646,  4649,  4650,  4653,  4654,  4655,  4658,
    4672,  4677,  4687,  4696,  4708,  4709,  4713,  4721,  4733,  4744,
    4758,  4769,  4792,  4802,  4820,  4831,  4842,  4853,  4867,  4868,
    4869,  4870,  4871,  4872,  4873,  4874,  4875,  4876,  4877,  4878,
    4879,  4880,  4881,  4885,  4886,  4889,  4890,  4893,  4895,  4908,
    4919,  4920,  4921,  4947,  4956,  4965,  4974,  4983,  4992,  5001,
    5011,  5020,  5029,  5038,  5047,  5056,  5065,  5073,  5081,  5089,
    5100,  5101,  5102,  5103,  5104,  5105,  5106,  5107,  5108,  5109,
    5110,  5111,  5112,  5113,  5114,  5115,  5116,  5120,  5121,  5135,
    5146,  5157,  5168,  5179,  5192,  5193,  5197,  5198,  5199,  5200,
    5201,  5202,  5203,  5204,  5205,  5206,  5207,  5210,  5211,  5221,
    5227,  5235,  5243,  5251,  5259,  5267,  5275,  5283,  5291,  5299,
    5307,  5315,  5323,  5331,  5339,  5347,  5355,  5365,  5366,  5369,
    5370,  5380,  5396,  5410,  5436,  5438,  5440,  5442,  5449,  5458,
    5459,  5462,  5469,  5476,  5483,  5497,  5505,  5513,  5521,  5529,
    5537,  5545,  5553,  5561,  5569,  5577,  5585,  5593,  5601,  5609,
    5617,  5629,  5630,  5633,  5643,  5657,  5658,  5662,  5663,  5668,
    5684,  5697,  5707,  5719,  5720,  5723,  5724,  5734,  5744,  5745,
    5749,  5753,  5757,  5768,  5781,  5795,  5812,  5813,  5814,  5815,
    5827,  5854,  5855,  5859,  5860,  5864,  5865,  5869,  5870,  5873,
    5874,  5882,  5893,  5904,  5917,  5918,  5921,  5922,  5923,  5926,
    5927,  5928,  5931,  5932,  5933,  5949,  5961,  5974,  5989,  5990,
    5993,  5994,  5998,  5999,  6007,  6008,  6012,  6013,  6028,  6037,
    6046,  6055,  6064,  6076,  6077,  6078,  6079,  6080,  6086,  6090,
    6105,  6106,  6112,  6122,  6126,  6131,  6141,  6142,  6149,  6153,
    6157,  6161,  6165,  6169,  6173,  6177,  6181,  6185,  6189,  6193,
    6197,  6201,  6205,  6213,  6217,  6221,  6225,  6231,  6232,  6239,
    6240,  6243,  6255,  6259,  6274,  6285,  6286,  6291,  6292,  6307,
    6318,  6332,  6343,  6357,  6368,  6382,  6390,  6392,  6394,  6399,
    6401,  6414,  6423,  6424,  6428,  6432,  6444,  6455,  6466,  6479,
    6480,  6481,  6485,  6498,  6499,  6513,  6521,  6531,  6544,  6545,
    6548,  6549,  6559,  6569,  6578,  6587,  6596,  6605,  6615,  6624,
    6634,  6643,  6652,  6662,  6672,  6681,  6690,  6700,  6710,  6720,
    6730,  6740,  6750,  6760,  6770,  6780,  6790,  6801,  6812,  6822,
    6833,  6844,  6854,  6863,  6872,  6881,  6890,  6899,  6908,  6917,
    6926,  6935,  6944,  6958,  6959,  6962,  6963,  6973,  6983,  6992,
    7001,  7010,  7019,  7029,  7039,  7049,  7059,  7068,  7077,  7086,
    7095,  7104,  7113,  7122,  7131,  7140,  7149,  7158,  7167,  7184,
    7193,  7201,  7209,  7217,  7225,  7234,  7242,  7250,  7259,  7268,
    7277,  7285,  7293,  7301,  7309,  7317,  7325,  7342,  7359,  7360,
    7361,  7366,  7372,  7381,  7382,  7383,  7384,  7385,  7389,  7390,
    7393,  7394,  7395,  7396,  7400,  7401,  7402,  7407,  7418,  7440,
    7450,  7451,  7454,  7463,  7469,  7488,  7495,  7502,  7509,  7516,
    7523,  7530,  7538,  7546,  7554,  7562,  7570,  7577,  7584,  7593,
    7594,  7595,  7599,  7602,  7605,  7608,  7611,  7618,  7620,  7622,
    7627,  7629,  7641,  7653,  7668,  7674,  7680,  7686,  7696,  7712,
    7722,  7723,  7727,  7731,  7735,  7739,  7743,  7747,  7751,  7755,
    7759,  7763,  7767,  7771,  7775,  7779,  7783,  7787,  7797,  7798,
    7809,  7816,  7827,  7838,  7839,  7843,  7857,  7864,  7881,  7894,
    7903,  7911,  7919,  7928,  7939,  7950,  7960,  7961,  7972,  7982,
    7992,  8002,  8012,  8022,  8030,  8051,  8074,  8082,  8091,  8102,
    8103,  8115,  8129,  8143,  8155,  8167,  8184,  8185,  8189,  8190,
    8191,  8192,  8196,  8208,  8223,  8224,  8228,  8229,  8232,  8233,
    8236,  8237,  8241,  8242,  8255,  8262,  8272,  8279,  8289,  8290,
    8291,  8292,  8293,  8294,  8295,  8299,  8303,  8310,  8317,  8318,
    8322,  8323,  8324,  8334,  8344,  8345,  8349,  8350,  8351,  8352,
    8362,  8369,  8386,  8387,  8397,  8403,  8409,  8415,  8431,  8441,
    8447,  8453,  8462,  8464,  8469,  8480,  8481,  8492,  8506,  8507,
    8518,  8529,  8530,  8533,  8534,  8535,  8536,  8537,  8538,  8539,
    8540,  8543,  8544,  8555,  8573,  8574,  8578,  8579,  8583,  8591,
    8619,  8630,  8631,  8641,  8652,  8655,  8656,  8657,  8658,  8659,
    8662,  8663,  8664,  8712,  8713,  8717,  8718,  8732,  8733,  8740,
    8748,  8756,  8764,  8772,  8780,  8791,  8792,  8819,  8834,  8835,
    8854,  8858,  8862,  8877,  8884,  8894,  8895,  8898,  8910,  8911,
    8915,  8926,  8934,  8939,  8944,  8949,  8954,  8962,  8970,  8975,
    8980,  8987,  8988,  8991,  8992,  8993,  9000,  9001,  9002,  9003,
    9007,  9008,  9012,  9016,  9017,  9020,  9029,  9042,  9043,  9044,
    9045,  9049,  9050,  9054,  9056,  9066,  9071,  9074,  9079,  9080,
    9088,  9098,  9099,  9100,  9108,  9112,  9113,  9116,  9117,  9122,
    9123,  9127,  9128,  9132,  9133,  9137,  9138,  9142,  9143,  9147,
    9155,  9166,  9167,  9172,  9178,  9196,  9197,  9201,  9202,  9212,
    9216,  9221,  9228,  9236,  9243,  9253,  9263,  9291,  9298,  9302,
    9328,  9332,  9344,  9357,  9371,  9382,  9397,  9403,  9408,  9414,
    9421,  9422,  9423,  9424,  9428,  9429,  9441,  9442,  9447,  9454,
    9461,  9468,  9479,  9480,  9493,  9497,  9504,  9514,  9519,  9520,
    9525,  9526,  9534,  9539,  9540,  9544,  9548,  9554,  9583,  9588,
    9595,  9600,  9606,  9611,  9620,  9622,  9625,  9629,  9630,  9631,
    9632,  9633,  9634,  9639,  9669,  9670,  9671,  9672,  9683,  9689,
    9697,  9698,  9704,  9709,  9714,  9719,  9724,  9729,  9734,  9739,
    9745,  9751,  9757,  9764,  9786,  9795,  9799,  9807,  9811,  9819,
    9831,  9852,  9856,  9862,  9866,  9879,  9898,  9921,  9923,  9925,
    9927,  9929,  9931,  9936,  9937,  9941,  9942,  9949,  9958,  9966,
    9975,  9986,  9994,  9995,  9996, 10000, 10002, 10004, 10006, 10008,
   10010, 10012, 10017, 10022, 10028, 10036, 10041, 10048, 10055, 10059,
   10063, 10093, 10094, 10096, 10104, 10126, 10128, 10130, 10132, 10134,
   10136, 10138, 10140, 10142, 10144, 10146, 10149, 10151, 10153, 10156,
   10158, 10160, 10163, 10165, 10178, 10180, 10193, 10195, 10208, 10210,
   10224, 10237, 10250, 10263, 10286, 10293, 10300, 10307, 10314, 10337,
   10344, 10351, 10358, 10365, 10372, 10379, 10383, 10391, 10395, 10405,
   10412, 10419, 10432, 10445, 10464, 10485, 10495, 10502, 10518, 10523,
   10541, 10543, 10545, 10547, 10549, 10551, 10553, 10555, 10557, 10559,
   10561, 10563, 10565, 10567, 10569, 10571, 10573, 10577, 10582, 10586,
   10590, 10595, 10612, 10613, 10614, 10629, 10641, 10643, 10645, 10655,
   10678, 10688, 10698, 10706, 10725, 10738, 10751, 10764, 10777, 10790,
   10807, 10820, 10843, 10856, 10882, 10892, 10905, 10922, 10935, 10945,
   10958, 10968, 10981, 10994, 11007, 11020, 11033, 11046, 11059, 11061,
   11074, 11092, 11106, 11122, 11144, 11160, 11173, 11186, 11199, 11203,
   11210, 11218, 11226, 11230, 11234, 11238, 11242, 11246, 11261, 11265,
   11274, 11278, 11282, 11287, 11301, 11303, 11307, 11309, 11311, 11314,
   11317, 11320, 11321, 11324, 11332, 11342, 11343, 11346, 11347, 11348,
   11353, 11357, 11361, 11365, 11376, 11377, 11381, 11382, 11387, 11395,
   11397, 11411, 11414, 11441, 11442, 11445, 11446, 11457, 11475, 11482,
   11491, 11508, 11553, 11561, 11569, 11577, 11585, 11606, 11607, 11608,
   11611, 11612, 11613, 11616, 11617, 11620, 11621, 11622, 11623, 11624,
   11625, 11626, 11627, 11628, 11631, 11633, 11638, 11640, 11645, 11647,
   11649, 11651, 11653, 11655, 11667, 11671, 11678, 11682, 11688, 11692,
   11703, 11704, 11707, 11711, 11715, 11721, 11722, 11727, 11731, 11738,
   11739, 11740, 11741, 11742, 11743, 11744, 11745, 11755, 11759, 11766,
   11773, 11774, 11790, 11794, 11799, 11803, 11818, 11823, 11827, 11830,
   11833, 11834, 11835, 11838, 11845, 11855, 11869, 11870, 11874, 11885,
   11886, 11889, 11890, 11893, 11897, 11904, 11908, 11912, 11919, 11929,
   11930, 11934, 11935, 11938, 11939, 11950, 11951, 11960, 11961, 11969,
   11980, 11981, 11984, 12000, 12008, 12016, 12038, 12039, 12050, 12054,
   12081, 12083, 12088, 12091, 12094, 12096, 12098, 12100, 12110, 12112,
   12123, 12127, 12131, 12135, 12139, 12148, 12155, 12180, 12184, 12190,
   12207, 12211, 12215, 12221, 12222, 12223, 12225, 12227, 12231, 12232,
   12233, 12249, 12250, 12251, 12256, 12257, 12258, 12263, 12264, 12265,
   12266, 12272, 12273, 12274, 12275, 12276, 12296, 12297, 12298, 12299,
   12300, 12301, 12302, 12303, 12304, 12305, 12306, 12307, 12308, 12309,
   12310, 12311, 12312, 12313, 12314, 12315, 12316, 12317, 12318, 12319,
   12320, 12321, 12322, 12323, 12324, 12325, 12326, 12327, 12328, 12329,
   12330, 12331, 12332, 12333, 12334, 12335, 12336, 12337, 12338, 12339,
   12340, 12341, 12342, 12343, 12344, 12345, 12346, 12347, 12348, 12349,
   12350, 12351, 12352, 12353, 12354, 12355, 12356, 12357, 12358, 12359,
   12360, 12361, 12362, 12363, 12364, 12365, 12366, 12367, 12368, 12369,
   12370, 12371, 12372, 12373, 12374, 12375, 12376, 12377, 12378, 12379,
   12380, 12381, 12382, 12383, 12384, 12385, 12386, 12387, 12388, 12389,
   12390, 12391, 12392, 12393, 12394, 12395, 12396, 12397, 12398, 12399,
   12400, 12401, 12402, 12403, 12404, 12405, 12406, 12407, 12408, 12409,
   12410, 12411, 12412, 12413, 12414, 12415, 12416, 12417, 12418, 12419,
   12420, 12421, 12422, 12423, 12424, 12425, 12426, 12427, 12428, 12429,
   12430, 12431, 12432, 12433, 12434, 12435, 12436, 12437, 12438, 12439,
   12440, 12441, 12442, 12443, 12444, 12445, 12446, 12447, 12448, 12449,
   12450, 12451, 12452, 12453, 12454, 12455, 12456, 12457, 12458, 12459,
   12460, 12461, 12462, 12463, 12464, 12465, 12466, 12467, 12468, 12469,
   12470, 12471, 12472, 12473, 12474, 12475, 12476, 12477, 12478, 12479,
   12480, 12481, 12482, 12483, 12484, 12485, 12486, 12487, 12488, 12489,
   12490, 12491, 12492, 12493, 12494, 12495, 12496, 12497, 12498, 12499,
   12500, 12501, 12502, 12503, 12504, 12505, 12506, 12507, 12508, 12509,
   12510, 12511, 12512, 12513, 12514, 12515, 12516, 12517, 12518, 12519,
   12520, 12521, 12522, 12523, 12524, 12525, 12526, 12527, 12528, 12529,
   12530, 12531, 12532, 12533, 12534, 12535, 12536, 12537, 12538, 12539,
   12540, 12541, 12542, 12543, 12544, 12545, 12559, 12560, 12561, 12562,
   12563, 12564, 12565, 12566, 12567, 12568, 12569, 12570, 12571, 12572,
   12573, 12574, 12575, 12576, 12577, 12578, 12579, 12580, 12581, 12582,
   12583, 12584, 12585, 12586, 12587, 12588, 12589, 12590, 12591, 12592,
   12593, 12594, 12595, 12596, 12597, 12598, 12599, 12600, 12601, 12602,
   12603, 12604, 12605, 12619, 12620, 12621, 12622, 12623, 12624, 12625,
   12626, 12627, 12628, 12629, 12630, 12631, 12632, 12633, 12634, 12635,
   12636, 12637, 12638, 12639, 12640, 12641, 12651, 12652, 12653, 12654,
   12655, 12656, 12657, 12658, 12659, 12660, 12661, 12662, 12663, 12664,
   12665, 12666, 12667, 12668, 12669, 12670, 12671, 12672, 12673, 12674,
   12675, 12676, 12677, 12678, 12679, 12680, 12681, 12682, 12683, 12684,
   12685, 12686, 12687, 12688, 12689, 12690, 12691, 12692, 12693, 12694,
   12695, 12696, 12697, 12698, 12699, 12700, 12701, 12702, 12703, 12704,
   12705, 12706, 12707, 12708, 12709, 12710, 12711, 12712, 12713, 12714,
   12715, 12716, 12717, 12718, 12719, 12720, 12721, 12722, 12723, 12724,
   12725, 12726
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT",
  "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN",
  "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL",
  "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT",
  "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "MAPPING", "MATCH", "MAXVALUE",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR",
  "OPTION", "OPTIONS", "OR", "ORDER", "OUT_P", "OUTER_P", "OVER",
  "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POSITION",
  "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY",
  "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE", "RANGE",
  "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE", "REF", "REFERENCES",
  "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE",
  "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING", "RETURNS",
  "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SNAPSHOT", "SOME", "STABLE", "STANDALONE_P", "START",
  "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P",
  "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING", "VACUUM",
  "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR",
  "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VOLATILE",
  "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK",
  "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME",
  "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "copy_file_name", "copy_options", "copy_opt_list", "copy_opt_item",
  "opt_binary", "opt_oids", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "OptForeignTableElementList", "ForeignTableElementList",
  "ForeignTableElement", "AlterForeignTableStmt", "CreateUserMappingStmt",
  "auth_ident", "DropUserMappingStmt", "AlterUserMappingStmt",
  "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opclass_purpose", "opt_recheck", "CreateOpFamilyStmt",
  "AlterOpFamilyStmt", "opclass_drop_list", "opclass_drop",
  "DropOpClassStmt", "DropOpFamilyStmt", "DropOwnedStmt",
  "ReassignOwnedStmt", "DropStmt", "drop_type", "any_name_list",
  "any_name", "attrs", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_type", "comment_text", "SecLabelStmt", "opt_provider",
  "security_label_type", "security_label", "FetchStmt", "fetch_args",
  "from_in", "opt_from_in", "GrantStmt", "RevokeStmt", "privileges",
  "privilege_list", "privilege", "privilege_target", "grantee_list",
  "grantee", "opt_grant_grant_option", "function_with_argtypes_list",
  "function_with_argtypes", "GrantRoleStmt", "RevokeRoleStmt",
  "opt_grant_admin_option", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique", "opt_concurrently",
  "opt_index_name", "access_method_clause", "index_params", "index_elem",
  "opt_collate", "opt_class", "opt_asc_desc", "opt_nulls_order",
  "CreateFunctionStmt", "opt_or_replace", "func_args", "func_args_list",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "locked_rels_list", "values_clause", "from_clause", "from_list",
  "table_ref", "joined_table", "alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "func_expr", "xml_root_version", "opt_xml_root_standalone",
  "xml_attributes", "xml_attribute_list", "xml_attribute_el",
  "document_or_content", "xml_whitespace_option", "xmlexists_argument",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "role_list", "SignedIconst", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,    61,    60,    62,   668,    43,    45,    42,
      47,    37,    94,   669,    91,    93,    40,    41,    46,    59,
      44,    58
};
# endif

#define YYPACT_NINF -3717

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-3717)))

#define YYTABLE_NINF -2169

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2169)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    5529,  1089,  6737, -3717, -3717,  1089, -3717, 50303,   443,   123,
      45,   135, 12784, 50710, 57629,   440,   793,  3596,  1089, 57629,
    1050, 37686, 47861, 57629,   831,   615, 37686, 57629, 58036,   775,
    1151, 58443, 51117, 46640,   497, 57629,   917,   909, 58850, 51524,
     700, 51931,   615, 34857,    67,   691, 59257,  1500,  1254,   814,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717,   443, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717,   247, -3717,   101,   327,  1344,   732,   843, -3717,
   -3717, -3717, 42163, 57629, 57629, 57629,  1074, 57629, 57629,   133,
   42163, 42570, 59664,  1131, 31521, -3717, 42570, 57629, 60071, 57629,
   52338, 57629,  1052, 57629, 57629, 42977, 60478,  1223,   887, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, 57629,  6247,   831, -3717, -3717, 57629,
    1079, 42163, 57629,  1083, 57629,  1121, 57629, -3717, 57629, 60885,
     378,  1327, 42570,  1563, 31941,  1236, 42570, 57629, 57629, 57629,
   -3717, -3717,  1277, 57629, 57629, -3717, -3717, 43384,  1358,  1559,
    1476,    99, -3717, 52745, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, 40942,   793, -3717, -3717, 43791, 57629,  1532, -3717, -3717,
   61292, -3717, -3717,   661, 44198, 44605,  1637, 32361,  1678, 45012,
   61699, -3717, -3717, 62106, -3717, 62513,  1407, 62920, -3717, 45419,
   -3717,  1590, 63327, -3717,  1353,   623,  1185, 28210, -3717,   443,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,   291,  1435,
     298,   186,   346, -3717, -3717,   189,   192,   211,   291,  1802,
    1802, -3717, 57629, -3717, -3717,  1435,    -2,  1403,  1403,  1403,
    1610,   685, -3717,  1403, -3717, -3717, -3717, -3717, 51931, -3717,
    1449,   831,  1471,  1853, 57629, -3717, 57629, -3717, 57629, 57629,
   -3717, -3717,  1897,  1540,  1777,  1558, -3717,  1715,  1733,  1746,
      94,   831,  1647, -3717,  1869, -3717,  1806, 19389,   831, 53152,
   63734,   389, 40942,   831, 53559,  1656,   818,  1854, -3717, -3717,
     668, -3717,  2044,  1679,  1918,  1558,   887, 29449, -3717,  1702,
     -81, 51931, -3717, -3717, -3717,   416,  1977, 19813, -3717, 57629,
    1729, -3717,  1709,  1727,  1774,  1344, -3717,  5529, 57629,  1168,
    1168,  2150,  1168,  1668,  1875, -3717,  1582, -3717,  2057,  2043,
   51931,   691,   183, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717,  1807,   -81, -3717,   194,
   -3717,  1301,  1809,  1348,  1322, -3717, -3717,   717,  1924,   188,
      -5,  1860, 53966,  4232,  1838, -3717,   198, -3717, -3717, -3717,
   -3717,  2146,  2776,   320, -3717, 57629, 57629, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717,  1876, -3717, -3717,  1887,
     940,    85,  2161,  5647,  1265,  2189,  3189,  1300,   893,  2079,
     805,  2184,  1212,  2197,  3425, 57629, -3717,  2137,  2239,     9,
   -3717,   103, -3717,  1979,  2109,    22, 42163,  1931, -3717, -3717,
   57629, -3717, -3717, -3717, -3717,   677, 42163, -3717,  2130, 32781,
   -3717, 57629, -3717, -3717, -3717, -3717, -3717,  2067, 57629, -3717,
   -3717,  2180, 57629, -3717,  1403,   250,  1952,  2324, 72237,    69,
   57629,  1993,  2363,  2173,  1993,  2020, 64141, -3717, -3717,  1993,
   -3717, -3717, 57629, 57629,  2010,  1115,  1993,  2382,  2392,  2077,
    2183,   911,  1025,   150,  2301,  1993, 57629, 64548, 57629, 57629,
    2374, 42163, 57629, -3717,  2175, -3717, -3717,  1226, -3717, -3717,
   -3717, -3717,  2320,  1807,   239,  2325,  2035,  2331, -3717,  2071,
   -3717,  2333,  1838,  2334, -3717,  2039, 64955, 65362, 65769,  2336,
    1876, 42570,  2338,  2039,  2340,  2229,  2342,   239,  2343, -3717,
    1120,  2344,  2234,  2349,   215,  2039, 41349,  2350,   134, -3717,
   21509, -3717,  2151, -3717,   691, -3717,  1329, -3717, 37279, -3717,
    1185,  1435, -3717, 57629,  1435, 57629,  1435, 57629,  1435, 57629,
    1435, 57629, 57629, 57629,  1435, -3717, -3717, -3717, 57629,  2066,
   57629, 57629, -3717, -3717, -3717, 48268, 42570, 48675, -3717, -3717,
      50,   831, -3717, -3717, 72237,  2463, 42570,  2351,  2351,  2351,
   -3717, -3717, -3717,  2289, 57629,  2353,  2354, 48268, 42570, -3717,
   66176, 40942,  2250,  2074, -3717, -3717, -3717, -3717, -3717,  1441,
    2497,   173,  2499, 21509,  2080,   179,   179,  2081,  2360, -3717,
   -3717, -3717,   212,  2084,  2085, -3717,   221,   221,  2243,  2087,
    2088, -3717,   234,  2089,  2511,  2512,   235,  2093,  2094,  2096,
    1714,   179, 21509, -3717,  2097,   221,  2098,  2099,  2100,  2523,
    2104, -3717,  2526,  2108,   238,   244,  2111,  2112, -3717,  2087,
   -3717,   218,  2113,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
   21509, 21509, -3717, 18541,   -81,   831, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717,   132, -3717,   237,  4904, -3717, -3717,  2279,
   21509, -3717, -3717,    57, -3717,   245, -3717, -3717, -3717,   -81,
   -3717, -3717,  1271,  2122, -3717,   804, -3717, -3717, -3717, -3717,
   -3717, -3717, 39721,  2517, -3717,   361,   831,   103,  1393,  2464,
   36465, 36872, -3717, -3717,  2345, -3717, 57629, -3717, -3717, 21509,
   34450, -3717,   -81,   125, -3717, -3717, -3717,  1401, -3717, -3717,
   -3717,   443, -3717, 12251, -3717,  1514,  1729, 57629, 57629,  2518,
   -3717, -3717, -3717,  1709, -3717, -3717,  1344,  1344, 21509,  1344,
     947,   985, 20237, 21509,  2408,  2311,   184,   165,  2411, -3717,
    1668,  1875, 51931, 57629, 66583,  2238, -3717, 35671,  1428,   -81,
    2207,  2208,  2254, 38500,  2134,  2211,  2213,  2259,  2215,  2216,
   66990, -3717, -3717, -3717, -3717,   156,   227,   785,  2217,   202,
     164,  2495, -3717,  2265, -3717, -3717, -3717,  3198, 57629,  2441,
    3806,  2330,   320,  2266, -3717, -3717,  2377,  2230,  2232,  2348,
     320,   243, 67397, -3717, -3717, -3717, -3717, -3717, -3717,  2999,
   16911, -3717,  2235,  2219, 57629, 45826,  2520,  2347,  1008,  1675,
     210, 57629,  2414,  2352, 57629,  2160,  2244,  2245,  2164,  1103,
    2525,  2169, -3717, -3717, -3717,  1536,  1771,  2355, -3717,  2228,
    2237, 71038,    63, 33201,  2507,  2257, -3717,  1343,  2261,  2263,
   57629,   320, -3717,  2568,   320,   320,  1473,  2569,  2268,   394,
    1481,  1993,  2169,  1520, -3717,  2275,  2278,   233, -3717,  2368,
   51931,   185,  1629,  2169,  2280,  2281,  2164,  2164, 57629, 57629,
   57629, 57629, 57629,   172,  2602,  2603,  2293,   175,  2339,  2220,
   -3717, 40128,  2297, -3717,  1343, 57629,  2300,  1658,  2169,  1018,
    1039, -3717, -3717, -3717,   887, -3717, 57629, -3717, 57629,  1807,
   72237,  2395,  2252, -3717,  1838,   320, 57629, 57629,  1876,   141,
    1192,  2409, 57629,  2465,  2262, -3717, -3717,  1993, -3717, 36068,
    2010, -3717,  2236, -3717, -3717,  2282, -3717,  2282,  2282,  2241,
    2241,  2247, -3717, -3717, -3717,  1714,  2282,  2241, -3717, 73029,
   -3717,  1144,  1391, -3717,  2629,  2633, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717,   692,  1612, -3717, 57629, 38500,
   -3717,  2644, -3717, -3717, 72237,  2537, -3717, 57629,  2442,  2251,
   -3717,  2573,  2304, -3717,  2294, -3717, 42570,   240,   831,  2296,
   57629,  2468, 57629, 57629, 57629, 57629, -3717, -3717,  2444,   716,
      73, -3717, 40128, -3717,  1520,  2447,  2652,    10,  1403,  2542,
   -3717, 57629,  2269,  2665,  2500, -3717,  1446, -3717,  2399, -3717,
   42163,   239, -3717, -3717, -3717, -3717, 72237, 57629, 67804, 42163,
     239, 42570, 42570,  2574,   134,  2576,  2341,  2578,  2346, 33201,
     239,   182, 42570, 57629, 57629, 57629, -3717, 57629, -3717, -3717,
   -3717, -3717, 57629, 57629, 42570, 40128,  2579,  2580,   239, 57629,
   57629, -3717, 12251,  1602, 57629,  1185, 40535, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, 57629, -3717, 57629, -3717, 57629,
   -3717, 57629, -3717, 57629, -3717, -3717, -3717, 57629, -3717, 57629,
    1604, -3717, -3717,  1606,   906, 57629, 57629,   136, 42163, 57629,
    2475, 57629, 57629, 57629, 57629, 57629,  2365,  2122,   974, -3717,
     205, 51931,  2482, -3717, -3717,  1615,  1500,   803, -3717, -3717,
   -3717, -3717, -3717, -3717, 48675, 47861,  2572,   256, 57629, -3717,
   -3717,  3280, 21509,   -81, 18965, -3717, -3717, -3717,  2298, 12251,
    2335, 21509, -3717, -3717, 21509,  2302,  1802,  1802, 21509, -3717,
   -3717, -3717, -3717,   838,  1802, -3717, 21509, 21509,  1802,  1802,
    2282,  2282, -3717,  7796, 21509, -3717, 33201, 21509, 24053, 16081,
   21509,  2369,  2317,  1802, -3717,  1802, -3717, 21509, 18117, -3717,
   21509,  2503, 24895, 21509,  1393,  2505, 21509,  1393,  2719,  2719,
    1872,  5006,  2305,   -81, -3717,  2412,  1802, -3717,  1802,   694,
   -3717,   236, 72237, 21509, 38500,  2384,   162, 57629, 21509,  2306,
    1705, -3717, 21509,   703, -3717,  2312, 21509,  2387, 21509, 21509,
   21509, 21509, 21509, 21509, 21509, 21509, 21509, -3717, 25721,   248,
     565,  1287, 54373, 19389,  2594, 15656, -3717,   259, -3717, -3717,
   -3717, 57629,  2517, -3717, -3717,  2391, -3717, -3717, -3717, -3717,
   -3717,   249, -3717, -3717, -3717, -3717, -3717, -3717, -3717,  2316,
   -3717, -3717, -3717, -3717,  2316, -3717,  2322,  4263, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717,  2588,  2589,   239, 57629,   416, 49082, -3717,
   19813, -3717,  1617, -3717,  2328, -3717,  2571, -3717,  2327, -3717,
    9776,  2571, -3717, -3717,   286,  2508,  2521,  2521, -3717,  2329,
   12251, -3717,  1490, 12251,  1584, -3717, -3717, -3717, -3717, -3717,
   -3717,  1014, -3717,  2408,   165,  2390,   652, 57629, -3717, 29862,
    2356,  1630,  2413,  2415,  2459, 42570, 57629, 57629, -3717, 38500,
   42570, 57629, 57629, 42570, 57629, 57629, -3717,  2693,   544, 47861,
    2462, 47047, -3717, -3717,  2358, 57629,  2398,  2583,  2585,   441,
   -3717, -3717, 68211, -3717,  2536, 42570, 57629, 57629, 21509,  2538,
   57629, 57629, 57629,  2422, 42163,  2359, 57629, 57629, 57629,   687,
   42163, 33621, 57629, 57629, 57629, 57629,  2473, 57629, 57629,  2591,
    1371, 51931,   195,  1730,  2169,  2552, -3717,   699, -3717, 42570,
   57629,  2545, -3717, -3717, -3717, 54780,  2755,  2469, -3717, -3717,
   68618, -3717, -3717,  2544, -3717, -3717, 73029, -3717, -3717,  1641,
   -3717, 72633, 69025, -3717, -3717,   736, 42570, 42570,  3969, 57629,
     864, -3717, -3717, 72237, -3717, 57629, 57629, 57629, 49489, 69421,
   69828,  1102,  1167, 57629, 49896, -3717, 57629, -3717, -3717, 38907,
   42570, 57629, 38500, -3717, 57629,  2553,   208, -3717, 57629,  4048,
   -3717, -3717,  2449, 57629, 57629,  2373,  1659,  2452,  2492, -3717,
   57629, 42570,   972, 63734, -3717, 42570, 57629,  6138, -3717, -3717,
     320, -3717, -3717, -3717, -3717, -3717, 57629, 57629,   320, 57629,
     320,   978, -3717, 42570, 57629, -3717, -3717, -3717,  4892, 57629,
   57629, 57629, 57629, 42570, 57629, -3717, -3717,   902,   815,  1156,
    1243,  2516, 57629,   831, 57629, 70235, 42570, 57629, 57629, 57629,
    1367, -3717, -3717,  2491, -3717, 42570,   972, -3717,  4958, 57629,
   57629,  2457,  2458,   138,  2531, -3717, -3717, -3717, -3717, -3717,
   -3717,  2621,  2782, 57629, -3717,  2624,  2626,  2445,  2451,  2632,
     252, 57629, 57629, 57629, 57629, 57629, 57629,  2635,   252,  2582,
     109,  2402,  2417,  1660, -3717, -3717, 21509,  2794, 72237,  2407,
    2420,  2480,  2483,  2484, -3717,  2419,  2485,  1802, -3717, -3717,
    1650, -3717, -3717,  1667, -3717,  2425,   716,  1375, -3717, 57629,
     664,   640,  2712, 17307,  2533,  1670,  2708, 57629, 57629,  1670,
   -3717,  1815, 47861, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717,  2713, -3717,   831,  2010,  2010,  2010,  2010, -3717,
   -3717, -3717, -3717,  2620,  1554, -3717,  2438,  2010, 57629,  2547,
    1670, -3717,  1520,  2731,  1077, 57629, 46233,  1631,  2474,   831,
    2622, -3717, 17721,  4410,  2623, 40942,  2705,  2709,  2725, -3717,
    1807, -3717,  2841, -3717,  2739,   239,  1838, -3717,  2039, -3717,
   57629, -3717, 57629, 57629, 57629, 57629,  1876, -3717, -3717,  2039,
    2630,   239,   239, -3717,  2634,   239,  2039,  2559,  2738, 40942,
   -3717,   134, -3717, -3717, 21509,  1403, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717,  1671, -3717, 57629, -3717,  2714,  2715,
    2716,  2460,  2470,  2506, 57629,  2472, -3717,  2460,   320,  2460,
    2122,  2122,  2460,  2470, 41756,  2873,  2742,    96, -3717,   626,
      46,  2673, -3717, -3717, -3717, -3717, 72237, -3717, -3717, -3717,
   -3717, -3717, 57629,   149,  2657,  2476, 41756,  2859,   239, -3717,
   42163, -3717, -3717, -3717,  2566, 42163,  2669, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717,  2717, 57629,  1682, -3717, -3717,  1376,
   -3717,  1445, 21509, 21509,   190, -3717, 10460,  1698, 21509,  2486,
    2489,  1700, -3717, -3717, -3717, -3717, -3717, -3717, -3717,  2490,
    2762, -3717,  2496,  1721,  1728,  2502,  2514, -3717, -3717,  4438,
    2519, 10721,  2522, 24053, 24053,  1263, -3717, -3717, 24053,  2527,
   -3717,  1736,  6573,  2494,  2528,  2524, -3717,  2529,  2530, 10800,
   20661, 21509, 20661, 20661, 11003,  2494,  2534,  1751, 38500,  2663,
   11349,  1757, -3717, 21509, 38500,  4465, 21509, -3717, 21509, 57629,
    2535,  2539, -3717, -3717,  7796, -3717,  2541, -3717, 24053, 24053,
   -3717,  2204, 18541, -3717, -3717,  2777, -3717, -3717,  1910, -3717,
    2532, -3717, -3717,  3757,   167, 21509,  2306, 21509,  2592, 33201,
    2570, 21509,  3363,  2437,  2437,   455,   455,   274,   274,   274,
     322,  1287, -3717, -3717, -3717,  2543,  2104, 21509, -3717,  1711,
    1847, 57629,  2277,  2450,  4193, -3717, -3717, -3717, 26971,  2554,
   21509, 21509, 21509,  2540,  2677,  2932, 12251,   569, -3717,  2939,
   -3717,   887,  1802,   694, 37279, -3717, -3717, 21509, -3717, -3717,
   -3717,  1709, -3717, -3717, -3717, -3717, -3717, 57629,  1500, 21509,
   -3717, -3717,   465,  1685, 21509,  1490, -3717, -3717, 57629,  2482,
    2482, 21509, -3717, -3717, -3717, -3717, -3717, 26971,  2575,  2593,
   29036,  2666, -3717, -3717, 57629,   288, -3717, -3717, -3717,  2555,
   -3717, -3717, -3717, 42570, 57629, 57629, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717,  2763, -3717, 42570, 42570,
    2726, 57629,  2727,  2728, 21509,   955, 57629,  2549,  2551,  1009,
    2807, 57629, -3717,  2847,   239, -3717, -3717,  2642, -3717, 12251,
   -3717, -3717, -3717, -3717, 40942, -3717,  1807, 72237, -3717, -3717,
   -3717,  2587, 57629, -3717, 57629, 57629,  1876, -3717, -3717, -3717,
   -3717,  1247, -3717, -3717, 57629, 57629,   107,  2643,  2645, 57629,
   -3717,  1209,  2368,  5973, 57629, 57629, 57629,  2805, -3717, -3717,
   -3717, -3717,  2759, -3717, -3717,  1612, -3717, 69025, 72633, -3717,
   72633, -3717,  1612,  1409, -3717,  2039,  2647,  2169, -3717,  2750,
     609, -3717, -3717, -3717, -3717, -3717,  2867,   239,  2870,   239,
   57629, 57629, 57629, 57629, -3717, -3717, -3717, -3717, -3717, 38500,
   38500, 38500,  1759, -3717, -3717,   831, -3717, -3717, -3717,  1761,
   -3717,  1309, -3717, -3717, -3717, -3717, -3717, -3717, 42570,  1458,
   -3717,  1037, 72237, -3717, 71434, 42570, 57629, -3717, -3717, -3717,
    2797,  2743, -3717,   566,  2746, 42570,  2640, -3717, -3717, -3717,
    2660,  1741,  2169,  1520, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717,   229,  1813,  2169,  2661, -3717,  2664, -3717, -3717,
   -3717,  2799,  2801,  2803,  2668,  2670,  2718,  2671,  2672,  2720,
   -3717,  2679,  2734,  2682,  2735,  2686,   239, 72237,  1577,  2702,
    2909,   239, -3717,  2692, -3717, -3717,  3008, -3717, 57629, -3717,
    2694,  1935,  2169, -3717, -3717, 42570, 57629, -3717, -3717, -3717,
     252, 72237,  2856,   252,   252, 57629, 57629,   252, -3717, -3717,
   -3717,  2857,  2860,  2861,  2862,  2863,  2864,   252, -3717, -3717,
   -3717, -3717,   250, 38500, -3717,  2295, 31101, -3717,  3047,  5272,
    2637,  2420,  2631,  1802,   253,   916,   635,  2747,  1802,  2834,
    2636, -3717, -3717, 38500, 31101,  1648,  2851,  2649,  2649,  2649,
    2649,  2649,  2649,  2649, -3717,  1268,  1993, 40942, 57629, 40942,
   -3717,   640,  2750, 57629, -3717, -3717,  1763, -3717, 57629, 42570,
     858, 42570,  1802, -3717, -3717,  2706, -3717,  1403,   240,  2780,
    1399,  2972, -3717, -3717, -3717, -3717, -3717, 57629, 57629,   716,
     831, -3717,  2646,  2639, -3717, 57629, 57629, 57629,  2684,  2648,
   57629,  2653,  2655, -3717, -3717, -3717, -3717, 72237,   476,  2837,
    2833,  2164,  3052,  2737, 57629, -3717,  1769,    98, -3717,   831,
   40942, 70642, -3717,  2611, -3717, -3717,   642,  2927, -3717, -3717,
    1500,   239, 72237, 57629, -3717,   239,   134,  2722,   239,  2729,
     239,   239, 57629, -3717, -3717, 57629, -3717, 57629, 40128,   239,
   -3717, 12251, -3717, -3717,  2783,  2785,  2787, 57629,  2460, 42163,
   -3717,  2676, 42570,  1143, -3717, -3717,  2838, -3717, -3717, -3717,
   -3717, -3717,  2967,  2968, -3717, -3717, -3717, 42570, 48268,   254,
   42570, -3717,  1807, -3717,  1838,   320, 57629,  2916, -3717, -3717,
   -3717,  2685,  1787, 11360, 21509, -3717,  2982, 72237, -3717,  6327,
   -3717, -3717, -3717, -3717, 21509, -3717, -3717, -3717, -3717, -3717,
   21509, -3717, 21509,  2960, -3717,  3100,  3100, 72237, 24053,  1549,
    2098, 24053, 24053, 24053, 24053, 24053, 24053, 24053, 24053, 24053,
   26145,   475, -3717, -3717, 21509, 21509,  2970,  2960, -3717, -3717,
     408,   408, 72237,  2689,  2494,  2695,  2696, 21509, -3717, -3717,
    1814, 25308,  2697, 38500, -3717, 21509,  9840,  1818,  2744, 11885,
     -81,  7195, -3717,  3054,   831, 21509,  1440,  1538, 21509,  1823,
   21509,  2963, -3717, -3717, -3717,  2701, -3717, -3717, 72237, 21509,
   24053, 24053,  5506, -3717,  5591, 21509,  2703,  6251, 18541, -3717,
     615,   615,   615,   615, -3717, 57629, 57629, 57629, 26558, 55187,
    2698,  1690, -3717, 55187, 55594, -3717,  2707,   -81, 21509,  2974,
     567,   567,  2721,  2677, 30275, -3717, 21509,   304, 21085,  2723,
     103,  2733, -3717, -3717,  5033, -3717, -3717,  2736, -3717,  2730,
   -3717,  1685, -3717, -3717, -3717,  7395,  2887,  2122, -3717, -3717,
   -3717,  2698, 21933,  2666, -3717,  1824, -3717, -3717, 19389, -3717,
   -3717,  1839, 29862,  2575, 19813,   -81, -3717, -3717, -3717,  2649,
    2039,  2039,  1003,  2460,  2990,  1003,  7758, -3717, -3717, 27384,
   57629, 57629, -3717, 57629,  1845,  1321, 57629, -3717, 57629, -3717,
   -3717,  3112, 57629, -3717,  2770,  2771, -3717, 57629, 57629, 57629,
   57629, -3717, -3717,  1809, -3717, -3717, 42570, 57629, -3717, -3717,
   -3717,   303,  1942,  2169, -3717,  2800, -3717, -3717,  2965,  1472,
   -3717, -3717, -3717,  2788, 57629,  2732, -3717,   990,  2164,   119,
   -3717, -3717,  2804, 57629, -3717, 57629, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, 38907, -3717, -3717, -3717, 38500,
   31101, 38500, -3717,  2809,  2810,  2848,   834,   163,  2812,  2814,
    2865,  2748,  2749,  2751, -3717, -3717,   291,   831, -3717, -3717,
     831,  2039,   831, 57629, 57629, 57629, 57629, 57629, 57629, 57629,
    3025,   924,  1550, 42570, 57629, 57629, 42570, 57629, 57629, 57629,
   57629, 57629, 57629, 57629, -3717,  3105,   831,   831,  3077,  2813,
   57629, -3717, 57629,  2368, 57629, 57629, -3717, -3717, -3717,  2752,
     252, -3717, -3717,  2986,  2989, -3717,   252,   252,   252,   252,
     252,   252, -3717,   131,  1867, -3717, 27797, -3717, -3717,  2363,
     831,  2363,   106, -3717,  2363, -3717,  2363, -3717,  2730,  1536,
    1771, -3717, -3717, -3717, -3717, -3717, -3717,  2417, -3717, -3717,
    1802,  1772,  2757, -3717,  2758, -3717, -3717, -3717, -3717, -3717,
   -3717,  2760, -3717,   694, -3717, -3717, 57629,  2649, -3717,  1141,
     326,  1067,  1186, 56001, 56408, 56815,  2772, 57629, 57629, 24053,
   -3717,  1294,   684, -3717,  2991, 57629,  2792, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717,  2251, -3717, 57629,  2750,  2039,
   42570, 42570,  2039, -3717, 72237,  2474,   623, 64548,  2790,  2766,
    3043, -3717,  2779,  2767, -3717, -3717, 57629,  2750,   472,  1353,
     965, -3717, 47454,  1631, -3717,  3013, 46233, -3717, -3717, -3717,
    3128,  2866, -3717,  1500,   831,  2398, -3717, 69025, 21509, 21509,
   -3717,  2773, -3717,  2778,  4697, -3717,  2010, -3717, -3717, -3717,
   -3717, -3717, -3717,  2868, 57629, -3717, -3717,  2781,   239, -3717,
   -3717, 57629, -3717, 57629, -3717, -3717,   239,   239, -3717,  2893,
   -3717, 57629, 57629, 57629,  2460, -3717,   320, -3717,  3056, 41756,
   -3717, -3717, -3717, -3717,   256,  3062, -3717, -3717,  3023,  3026,
    3027,  3030,   572, -3717, -3717, 21509, 12251, -3717,  2789, -3717,
   12251,  7906, 12251,  2970, -3717,  1870,  3072, -3717,  1180,  2802,
    1870,   760,   760,   411,   411,   176,   176,   176,  3100,   475,
   12251, 12251, -3717, -3717, -3717, -3717,  2798, -3717, -3717, -3717,
    2494, -3717, 22357,  2941,  3179, -3717, -3717, -3717,  2843,  2845,
    2816, -3717, 21509, 22781,  2806, 73029, -3717, -3717,   694,  1244,
   24053, 24053,   786, -3717,   977, 21509, 72237,  1874,   786,  1724,
    1755, 21509, 21509,  8846,   384, 21509,  7935, 57629, 57629, 57629,
   57629, -3717, -3717, -3717, 16497,  1690,  2817, 57629, -3717,  2811,
   26971,  3053,  2987, -3717, 26971,  2987,  1552,  2987,  3055, -3717,
   30688, -3717,  2825, 15656,  1495, 12251,  3206,  3098, 21509,  2832,
   -3717,  2842,  2677, -3717, 71830, -3717, -3717, 12251, -3717, -3717,
   21509, -3717,  2677,   831, -3717, -3717, 33201, -3717, -3717, -3717,
    3018, 12251, -3717,  1500, 57629,   -81,  2831,  2855, 57629, -3717,
    2666, -3717,   291, -3717, -3717, -3717, -3717,  2919, 47861,  3122,
   -3717, 21509,  1878, -3717,  2881,  3208,   129,  1879,  1880,  1321,
   -3717,  2792, -3717,  1303,  3101,   122, -3717,   239, -3717, 72237,
   -3717, 57629, 57629, -3717, -3717, -3717, -3717,  2134, -3717, -3717,
   57629, 57629, 57629, 57629, -3717,  2920, -3717, -3717, 38500,  1268,
    3040, -3717, -3717,  3046,   291, 57629, -3717, 72237,   239,   239,
   -3717, -3717, -3717,  2871, 42570, 57629, 57629,  1802,  1802, 72237,
    2850, -3717,  1802,  1802,  2858, -3717, 42570, 57629, 57629, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,  2933,
   -3717, -3717, -3717, 57629, 57629, 57629, 57629,  3152, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, 57629,
   -3717, -3717, -3717, 72237,   239,   239, -3717, -3717, -3717,  3096,
   -3717,   252,   252, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
    1993,  3181, -3717, 38500, -3717, 39314, -3717, -3717, -3717,   831,
   -3717,   831,  3057, 35264,   831,   831,  1321,  2874,  1412,  3140,
   -3717, -3717, -3717, -3717,  3146,   291, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
   -3717, 21509, -3717,   798,  1870, -3717, -3717, -3717, -3717,  2792,
    1403,  2924,   664,  2984, -3717, -3717,  2039,  2039,  2930,  3274,
     501, 57629,  3185,  2923, -3717,   831, -3717, -3717, 57629, 46233,
    2684, -3717,  3211,  1884, -3717, -3717, -3717,  2925,  2833,  1318,
    2889,  1631, -3717,  1221, 57629, -3717,  2928,  3169,  2895, -3717,
   12251, 12251,   831, 73425,  2611, -3717, 57629,  3144,   239, -3717,
     239,   239, -3717, -3717, 57629,  2460,  2460,  2460, -3717,  3074,
   -3717,   239, 41756,   572,   572,   572,   572, -3717, -3717, -3717,
   12251, -3717, -3717, -3717, 24053,  3174, -3717,  2899, 72237, -3717,
    2900,  1886,  1890, 24895,  3044, -3717, -3717, -3717,  8447,  2949,
   12251,  3003,  2906,  2907, -3717,   272,   272,   977,  1892, -3717,
   24053, 24053,   786,   786, 21509,   786, -3717, -3717, -3717, -3717,
   -3717, 55187,  2910, 57629,  1690, 26971, -3717, -3717,   140, -3717,
   26971,  3143, -3717, 26971, 57629,  2912, 57629,   601, 21509, 21509,
    2948,  2677,  2677, -3717,  3078, -3717,  2914, -3717,   694,  2915,
   57629, -3717, -3717,   691, -3717, -3717, -3717, 41756,  3097, 41756,
    1321,  8517,  2792, 27384, 34041, 57629, 57222, 57222,  3058,  2792,
    2924, -3717, -3717, -3717, -3717, -3717, -3717,  2922, -3717, -3717,
   -3717,  2994, -3717, -3717, -3717,  1894, -3717, -3717, -3717, -3717,
   -3717,  3105, -3717, -3717, 31101, -3717, -3717, -3717, 28623, 33201,
   -3717,   834,  2921,  2929,   163, -3717, -3717, -3717, 57629,  1169,
     939,  2959,  2460,  3209, -3717,  3105, -3717, -3717,   252, -3717,
   -3717,  2402,   831, -3717, -3717,  1903, -3717, -3717, -3717, 57629,
   -3717,  2766, -3717, -3717, -3717, 42163,  3322,  3322, 57629, -3717,
   -3717,  9181,  3119, -3717,  2924,  3141,  3184, -3717, 57629, 57629,
    1500, 46233,  2750, -3717,  1279,  2934,  3226, -3717,  2648,  2935,
   -3717, -3717, -3717, 47454,  3111,  2866,  1068,  1068, 57629,  2833,
    3059, -3717,  3061, -3717,   261, -3717, 57629, 27384, -3717, 72633,
   -3717,  1920, -3717, -3717,  2554, 57629,    30, -3717, -3717, -3717,
   -3717, -3717, -3717,   254, -3717, -3717, -3717, -3717,   562, 24053,
   72237,  1921, 21509, -3717, 21509, -3717,  3319, -3717, -3717, -3717,
     634, -3717, -3717, -3717,   272,   272,   786, -3717, 57629,  1922,
   -3717, 21509,  2942, -3717, -3717, 26971,   140,  1932, 57629,  1936,
   72237,  2677,  2494, 12251, 57629, -3717, -3717, -3717,  3321,  3123,
    2677, -3717, -3717, -3717, -3717,  1143,  1003,   254,  3208,  2924,
   -3717,  2950, -3717, -3717, 57629, -3717,  1273,  1273, 57629,  2924,
   -3717, -3717, 57629, -3717, 38500,  3004, -3717, 72237,  1838,    68,
   -3717, 72237, 72237, -3717, -3717, 57629, 57629, 57629, 57629, 57629,
     239, -3717, -3717, -3717, -3717, 39314,  2766,  3322,   258, -3717,
   -3717, -3717,  1469,  3158, -3717,   992,  3147,  3048,  2750,  3250,
    2928, -3717, -3717, -3717, -3717, 21509,  3117,  1631,  3013, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
    1937,  2866, -3717, -3717,  3340,  3153,  3344, -3717,  1945, -3717,
   -3717,  4697, 73425,  3290, -3717,  3029, 57629, -3717, -3717, -3717,
     562,  1956, -3717,  1971,  1973,  3124,  3032, -3717,  1982, -3717,
   12251, 57629, -3717, -3717, -3717,  1986, -3717,  2978, -3717,  3381,
   21509,  1361, -3717, -3717,  3263, -3717, 57222,  3028, 33201, -3717,
    1685,  1685,  1403, -3717,  1321, -3717, -3717, 21509, -3717,  1987,
   -3717,    76,  3132,  3271,  1994,  1998,  2470,  3031,  2470, -3717,
    2460, -3717, -3717, -3717, -3717, -3717,  3297,  3245, -3717, -3717,
   -3717, -3717,   307, -3717,  3176,  3178, 57629, -3717, 57629,  3394,
   -3717,  9378, 42163,  2833,  1631,  1268, -3717, -3717,  3177, -3717,
    3186,  2474, 27384,  2611, -3717,   263, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717,  1999, -3717, 57629,  3002,  2494, 23205,
   23205,  3009, 41756,  1273,  3014, -3717,  3015, -3717, -3717,  3141,
    1321, 12251, 42163,  3382, -3717, -3717, -3717,  3132, -3717, -3717,
   57629,  3138, -3717,   744,   744,  3336, -3717,  3073, -3717, -3717,
   -3717,   834, -3717,  3024,  2866,  2833, -3717, -3717,  2866, -3717,
   -3717, -3717, -3717,  1638, -3717, -3717, -3717, 24477,  3149,   158,
   10450, -3717, -3717, -3717, -3717,   254,  1685, 21509,  1321, -3717,
    3147,  1838, 57629, -3717, -3717,  2923, -3717,  3438, -3717,  1051,
   -3717, -3717,  2850, 38093, -3717,  2866,  2554, -3717,  1456, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717,  3428, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717,  9511, -3717, -3717, -3717,  3324, -3717,
   -3717, -3717, -3717,  2004, -3717, -3717, -3717, -3717, -3717, -3717,
    1791, -3717, -3717,  1833,  1774, 23629, -3717,  1321,  3183, -3717,
   38093, -3717,  1456, -3717, 42163, -3717, -3717,  3035, 38093,  2013,
   -3717
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1329,  1131,   512,  1215,  1214,  1131,   232,     0,  1217,     0,
    1131,   340,   909,     0,     0,     0,     0,   512,  1131,     0,
    1329,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
       0,     0,     0,     0,  1131,     0,     0,  1349,     0,     0,
       0,     0,  1342,     0,  1219,     0,     0,     0,     0,     2,
       4,    56,    57,    23,    22,    28,    27,    79,    80,    46,
      16,    70,    51,   112,   111,   113,    34,    30,    64,    20,
      21,    31,    35,    53,    36,    52,    19,    50,    74,    54,
      77,    41,    10,    11,    42,    68,    12,    43,    69,    13,
      44,    14,    58,    81,    26,    55,    78,    37,    66,    62,
       9,    47,    48,    49,    71,    72,    73,    95,    76,   107,
      33,   104,    85,    86,   101,    87,   102,     7,    88,    45,
      15,    98,    97,    99,    65,    38,    67,    96,   100,    17,
      18,   103,    75,    93,    90,   108,   106,   114,    91,    59,
       5,     6,    82,    40,     8,    25,    24,    39,    32,   110,
      29,  1217,    84,    94,    83,    60,    89,    63,    92,   109,
      61,   105,  1316,  1303,  1351,  1315,  1328,     0,  1318,  1130,
    1129,  1115,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   511,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1141,  1851,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,   315,  1874,
    1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  2116,
    2117,  2118,  2119,  1884,  1885,  1886,  1887,  1888,  1889,  1890,
    2120,  2121,  1891,  1892,  1893,  1894,  1895,  2122,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  2123,  2124,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  2125,  1940,  1941,  1942,  2126,  1943,
    1944,  2127,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  2128,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  2129,  1968,  1969,  1970,
    1971,  2130,  2131,  2132,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  2133,  1982,  1983,  1984,  1985,  1986,
    1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,
    1997,  2134,  2135,  1998,  1999,  2136,  2000,  2001,  2002,  2137,
    2003,  2138,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2139,
    2140,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2141,
    2019,  2142,  2022,  2020,  2021,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2143,  2030,  2031,  2032,  2033,  2034,  2035,  2036,
    2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,
    2047,  2144,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2145,  2062,  2063,  2064,
    2146,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2147,  2076,  2077,  2078,  2079,  2080,  2081,  2082,
    2083,  2148,  2149,  2084,  2150,  2085,  2151,  2086,  2087,  2088,
    2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,
    2099,  2100,  2101,  2102,  2152,  2153,  2103,  2104,  2105,  2106,
    2107,  2108,  2109,  2110,  2111,  2112,  2154,  2155,  2156,  2157,
    2158,  2159,  2160,  2161,  2162,  2113,  2114,  2115,   314,  1294,
    1822,  1852,  1853,  1216,  1197,   512,     0,  1118,   339,     0,
       0,     0,     0,     0,     0,     0,     0,   692,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   158,     0,     0,
     363,   362,     0,     0,     0,   881,   368,     0,     0,     0,
       0,   500,  1256,  2020,  1254,  1295,   233,   236,   234,   235,
    1844,     0,   981,   982,   984,     0,     0,   994,   725,   726,
       0,   724,   728,     0,     0,     0,   721,     0,     0,     0,
       0,   727,   719,     0,   718,     0,     0,     0,   723,     0,
     720,     0,     0,  1119,  1253,   369,  1329,     0,  1233,  1217,
    1224,  1234,  1229,  1231,  1230,  1232,  1228,  1843,  1867,   820,
     820,   820,   820,   817,   818,   820,   820,   820,  2035,     0,
       0,   799,     0,   801,  1848,   820,   825,   424,   424,   424,
       0,   824,   829,   424,  1112,  1148,  1827,  1341,     0,   800,
    1111,  2084,  1245,     0,     0,   998,     0,   999,     0,  2050,
    1123,   217,  2060,  2148,  2084,   213,   187,  1871,     0,     0,
     824,     0,  1120,  1121,   785,  1348,  1346,     0,  1889,  1902,
    1985,   210,  2046,  2051,  2060,  2148,  2084,  2112,   167,   172,
       0,   226,  2060,  2148,  2084,   222,  1141,     0,  1319,  1428,
    1818,     0,  1114,  1113,  1218,     0,  1221,     0,  1393,  2032,
    1323,  1325,  1223,  1316,     0,     0,     1,  1329,  1212,  1345,
    1345,     0,  1345,     0,  1308,  1316,  1311,  1315,     0,     0,
       0,     0,  1851,  2163,  2164,  2165,  2166,  2167,  2168,  2169,
    2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,
    2180,  2181,  2182,  2183,  2184,  2185,     0,     0,  1828,  1852,
    1856,     0,   735,     0,   118,  1823,   869,     0,     0,     0,
    1822,     0,     0,     0,     0,  1857,     0,  1845,  1858,  1859,
    1860,  1957,     0,     0,  1723,  1893,  1943,  1733,  1731,  1732,
    1725,  1726,  1727,  1728,  1729,  1730,     0,   979,  1724,     0,
     118,     0,  1957,     0,     0,  1957,     0,     0,     0,     0,
       0,  1988,   118,  1957,     0,     0,  1135,     0,     0,     0,
    1137,  1140,  1116,  1200,     0,  1818,     0,     0,   769,   760,
       0,   770,   761,   766,   772,     0,     0,   763,     0,     0,
     773,     0,   762,   764,   775,   765,   771,     0,     0,   767,
     768,     0,     0,  1127,   424,     0,     0,     0,     0,     0,
       0,   118,  1187,  1957,   118,     0,     0,   367,   366,   118,
     365,   364,  1893,  1943,     0,   908,   118,     0,   160,   580,
     515,     0,     0,   651,  1988,   118,     0,     0,     0,     0,
     884,     0,     0,   499,   512,  1257,  1255,     0,   985,   212,
     211,   983,  1957,     0,   293,     0,     0,  1957,  1176,     0,
     722,  1957,     0,  1957,  1846,   153,     0,  1893,  1943,  1957,
       0,     0,  1957,   145,  1957,     0,  1957,   293,  1957,   516,
       0,  1957,     0,  1957,  1988,   147,     0,  1957,   293,   733,
       0,  1250,     0,  1226,  2152,  1239,     0,  1235,  1242,  1238,
    1329,   820,   819,     0,   820,     0,   820,     0,   820,     0,
     820,     0,     0,     0,   820,  1849,  1850,   802,     0,   826,
       0,     0,   833,   832,   831,     0,     0,     0,   834,  1432,
    1272,     0,  1109,  1126,     0,     0,     0,  1001,  1001,  1001,
    1122,   216,   214,     0,     0,     0,     0,     0,     0,  1128,
       0,     0,     0,     0,  1831,  1833,  1834,  1734,  1801,     0,
    2117,  2118,  2119,  1792,     0,  2120,  2121,  2122,  2165,  1646,
    1633,  1642,  1647,  1634,  1636,  1643,  2123,  2124,  1928,  2125,
    2126,  1841,  2127,  2128,  2130,  2131,  2132,  2133,  1638,  1640,
    2134,  2135,     0,  1842,  2137,  2138,  2008,  2140,  2141,  2143,
    2144,  1644,  2146,  2147,  2148,  2149,  2150,  2151,  1840,     0,
    1645,  2153,  2155,  2156,  2157,  2158,  2159,  2160,  2161,  2162,
       0,     0,  1815,     0,  1618,     0,  1464,  1465,  1487,  1488,
    1466,  1493,  1494,  1506,  1467,     0,  1814,  1531,  1617,  1623,
       0,  1616,  1612,  1331,  1810,     0,  1613,  1830,  1832,  1793,
     179,   228,     0,   229,  1816,  2060,   168,   209,   181,   208,
     182,   180,     0,  1891,   169,     0,     0,   170,     0,     0,
       0,     0,   225,   223,     0,  1117,     0,  1430,  1429,     0,
       0,  1799,  1819,   742,  1210,  1211,  1209,     0,  1206,  1208,
    1220,  1217,  1806,  1805,  1807,     0,  1324,     0,     0,     0,
    1306,  1305,     3,  1223,  1343,  1344,     0,     0,     0,     0,
       0,     0,     0,     0,  1386,  1359,  1360,  1362,  1383,  1387,
       0,  1312,     0,     0,  1434,     0,  1394,     0,     0,  1829,
       0,     0,     0,     0,   736,     0,     0,     0,     0,     0,
       0,   117,  1174,   219,  1172,     0,     0,     0,     0,     0,
       0,     0,  1179,     0,   151,   152,   527,   512,     0,  1957,
       0,     0,     0,     0,   941,   948,     0,     0,     0,     0,
       0,     0,     0,   942,   940,   943,   221,   952,   965,   968,
       0,   859,     0,     0,     0,     0,  1044,     0,     0,  1044,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   239,   245,   288,   491,     0,     0,     0,   494,     0,
       0,     0,     0,     0,     0,     0,   122,     0,     0,     0,
       0,     0,   478,   490,     0,     0,     0,     0,     0,   487,
       0,   118,   241,   471,   475,     0,     0,     0,   589,   588,
       0,  1044,     0,   237,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   307,
     308,     0,     0,   122,     0,     0,     0,     0,   243,     0,
       0,  1136,  1133,  1134,     0,  1139,     0,  1196,     0,     0,
       0,     0,     0,   774,     0,     0,  1893,  1943,     0,     0,
       0,     0,     0,     0,   342,   321,   322,   118,   320,     0,
       0,   648,     0,  1854,  1475,  1504,  1482,  1504,  1504,  1471,
    1471,  1484,  1472,  1473,  1511,     0,  1504,  1471,  1476,     0,
    1474,  1514,  1514,  1499,     0,  1456,  1457,  1458,  1459,  1485,
    1486,  1460,  1491,  1492,  1461,  1528,  1471,  1855,     0,     0,
     659,     0,  1151,  1186,     0,     0,   521,     0,  1957,     0,
     120,   693,     0,   649,     0,   120,     0,   156,     0,   584,
       0,     0,     0,     0,     0,     0,   609,   608,     0,     0,
       0,   650,     0,   120,   474,  1957,     0,   424,   424,     0,
     883,   886,     0,     0,     0,  1298,  1300,  1299,     0,  1297,
       0,   293,   291,   292,   646,   993,     0,     0,     0,     0,
     293,     0,     0,  1957,   293,  1957,     0,  1957,     0,     0,
     293,   293,     0,     0,     0,     0,   585,     0,   732,   730,
     729,   731,     0,     0,     0,     0,     0,  1957,   293,     0,
       0,   715,  1744,     0,     0,  1329,     0,   198,   199,   197,
    1240,   200,  1241,  1237,  1225,     0,   810,     0,   814,     0,
     805,     0,   811,     0,   806,   803,   804,     0,   809,     0,
       0,   425,   427,     0,     0,  1913,  1927,     0,  1948,  1976,
    1977,  2051,  2056,     0,  2079,  2088,     0,   835,   864,   830,
       0,     0,  1282,  1110,  1750,     0,  1329,     0,  1000,   997,
     996,   995,   215,   188,     0,     0,     0,   866,  2050,  1125,
     784,   512,     0,  1614,     0,  1621,  1622,  1503,  1490,  1791,
       0,     0,  1498,  1497,     0,     0,     0,     0,     0,  1480,
    1479,  1478,  1620,  1758,     0,  1477,     0,     0,     0,     0,
    1504,  1504,  1502,  1551,     0,  1481,     0,     0,  1771,     0,
    1777,     0,     0,     0,  1510,     0,  1508,     0,     0,  1587,
       0,     0,     0,     0,     0,     0,     0,     0,  1535,  1536,
    1618,  1744,     0,  1619,  1837,     0,     0,  1496,     0,  1528,
    1813,  1734,     0,     0,     0,     0,  1804,     0,  1742,     0,
       0,  1565,  1740,     0,  1567,     0,     0,     0,  1733,  1731,
    1732,  1725,  1726,  1727,  1728,  1729,  1730,  1738,  1548,     0,
       0,  1547,     0,     0,  1396,     0,  1835,  1794,   230,   231,
     227,     0,     0,   184,   183,     0,   202,   206,   207,   178,
     205,     0,   201,   186,  1686,  1685,   185,   177,   175,   173,
     189,   191,   192,   176,   174,   224,     0,     0,  1861,  2186,
    2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,  2216,
    2217,  2218,  2219,  2220,  2221,  2222,  2223,  2224,  2225,  2226,
    2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,  2235,  2236,
    2237,  2238,  2239,  2240,  2241,  2242,  2243,  2244,  2245,  2246,
    2247,  2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,
    2257,  2258,  2259,  2260,  2261,  1796,  1795,  1825,  1862,  1863,
    1864,  1865,  1800,     0,     0,   293,  1204,     0,  1201,  1809,
       0,  1326,     0,  1820,     0,  1213,  1322,  1321,  1352,  1353,
     901,  1320,  1377,  1378,  1373,     0,  1392,  1392,  1369,  1363,
    1368,  1366,     0,  1370,  1531,  1385,  1310,  1357,  1358,  1361,
    1309,     0,  1388,  1386,  1362,  1269,     0,     0,  1435,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   737,     0,
       0,     0,     0,     0,     0,  2079,   218,  1170,     0,     0,
       0,     0,   868,   867,     0,     0,   888,     0,     0,     0,
    1182,   413,     0,   290,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   525,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     559,     0,  1044,     0,   597,     0,   950,     0,   949,     0,
       0,     0,   951,   946,   947,  2051,  2060,  2084,   220,   967,
       0,   966,   964,   923,   925,   924,     0,   927,   911,     0,
     912,     0,     0,   922,   930,   928,     0,     0,     0,     0,
    1936,   247,   260,     0,  1043,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   280,     0,   283,   282,     0,
       0,     0,     0,   287,     0,     0,     0,   286,     0,     0,
     492,   493,     0,     0,     0,     0,     0,     0,     0,   980,
       0,     0,   139,     0,   142,     0,     0,     0,   477,   489,
       0,   481,   482,   479,   483,   484,     0,     0,     0,     0,
       0,     0,   476,     0,     0,   582,   581,   587,     0,     0,
       0,     0,     0,     0,     0,  1036,  1035,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   600,   601,     0,   602,     0,   143,   144,     0,     0,
       0,     0,     0,     0,     0,   196,  1132,  1138,  1199,  1826,
    1198,     0,     0,     0,   776,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   326,  1854,     0,   674,   647,     0,  1456,     0,  1452,
    1448,  1517,  1518,  1519,  1516,  1529,  1515,     0,  1462,  1520,
    1471,  1468,   660,     0,   662,   665,     0,  1149,   386,     0,
     518,   559,     0,     0,     0,   149,     0,     0,     0,   116,
     160,   369,     0,   159,   161,   163,   164,   165,   162,   166,
     579,   583,     0,   514,     0,     0,     0,     0,     0,   610,
     614,   613,   617,   615,     0,   611,     0,     0,  1444,     0,
     138,   470,   473,     0,     0,     0,   371,   455,   300,     0,
       0,   885,     0,     0,     0,     0,     0,     0,     0,  1296,
       0,   971,     0,  1177,  1957,   293,     0,   969,   154,  1847,
       0,   716,     0,     0,     0,     0,     0,   973,   712,   146,
       0,   293,   293,   517,     0,   293,   148,     0,     0,     0,
     509,   293,   734,  1252,     0,   424,  1227,  1236,   807,   816,
     815,   813,   812,   808,     0,   827,     0,   423,     0,     0,
       0,   841,   842,     0,     0,   840,   857,   843,     0,   845,
     837,   836,   846,   847,     0,     0,   866,     0,  1279,     0,
    1277,     0,  1433,  1281,  1270,  1244,     0,  1243,  1247,  1249,
    1248,  1246,     0,     0,     0,   824,     0,     0,   293,  1124,
       0,   786,   787,   792,     0,     0,     0,   793,   789,   790,
     791,   794,   795,   796,     0,     0,     0,  1802,  1754,     0,
    1755,     0,     0,     0,  1790,  1786,     0,     0,     0,     0,
       0,     0,  1759,  1762,  1763,  1764,  1761,  1765,  1760,     0,
       0,  1766,     0,     0,     0,     0,     0,  1501,  1500,     0,
       0,     0,     0,     0,     0,     0,  1590,  1623,     0,     0,
    1718,     0,  1744,  1776,     0,     0,  1512,     0,     0,     0,
       0,     0,     0,     0,  1744,  1782,     0,     0,     0,     0,
    1684,     0,  1681,     0,     0,     0,     0,  1801,     0,     0,
       0,     0,  1838,  1532,  1549,  1812,     0,  1803,     0,     0,
    1533,  1556,     0,  1783,  1583,     0,  1588,  1571,     0,  1564,
       0,  1569,  1573,  1552,  1804,  1743,     0,  1741,     0,     0,
    1550,     0,  1545,  1543,  1544,  1537,  1538,  1539,  1540,  1541,
    1542,  1546,  1722,  1720,  1721,     0,     0,     0,  1568,  1950,
    1985,     0,  1342,  1342,  1342,  1330,  1340,  1811,     0,  1439,
       0,     0,     0,     0,  1701,     0,  1748,     0,  1746,  1828,
    1817,     0,     0,  1528,     0,  1431,  1797,     0,   740,   741,
     739,  1223,  1207,  1203,  1202,  1808,  1222,     0,  1329,     0,
     899,   900,     0,   904,     0,     0,  1371,  1384,     0,  1282,
    1282,     0,  1375,  1376,  1367,  1314,  1313,     0,  1442,     0,
       0,  1266,  1259,  1436,     0,  1396,  1284,  1286,  1287,     0,
    1801,   672,   671,     0,     0,     0,  1070,  1003,  1048,   738,
    1071,  1004,  1049,  1072,  1005,  1171,     0,  1173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   635,  1957,   293,  1180,  1073,     0,  1006,   289,
    1181,  1050,  1185,  1051,     0,   526,     0,     0,   531,   532,
     533,     0,     0,   534,  1893,  1943,     0,   539,   545,   549,
     540,     0,   550,   546,     0,     0,     0,     0,     0,     0,
     556,   563,     0,     0,     0,     0,     0,     0,   944,   945,
    1074,  1009,     0,  1052,   926,  1471,   910,     0,     0,   921,
       0,   920,  1471,  1471,  1010,   150,     0,   240,   248,   565,
    1046,   266,   279,   274,   275,   273,  1957,   293,  1957,   293,
       0,     0,     0,     0,   276,   271,   272,   268,   281,  1870,
    1929,  2061,     0,   569,   571,     0,   576,   284,  1022,     0,
     301,   304,   285,   264,   267,   265,   261,   246,     0,     0,
    1824,     0,     0,   975,     0,     0,     0,   141,  1032,   131,
       0,     0,   127,     0,     0,     0,     0,   121,  1080,  1014,
       0,     0,   242,   472,   480,   485,  1018,   488,  1062,   486,
    1086,  1015,  1044,     0,   238,     0,  1016,     0,  1056,  1082,
    1034,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1188,     0,     0,     0,     0,     0,   293,     0,   681,  1046,
    1957,   293,  1081,     0,  1041,  1068,     0,   309,     0,  1033,
       0,     0,   244,  1020,  1064,     0,     0,   194,   193,   195,
       0,     0,     0,     0,     0,     0,     0,     0,   778,   749,
     777,     0,     0,     0,     0,     0,     0,     0,   743,   341,
     318,   319,     0,     0,   317,   323,     0,   673,     0,     0,
    1453,  1449,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1469,   661,     0,     0,     0,     0,  1169,  1169,  1169,
    1169,  1169,  1169,  1169,  1150,  1178,   118,     0,     0,     0,
     520,   558,   565,     0,   593,   596,     0,   594,     0,     0,
       0,     0,     0,   132,   119,     0,   701,   424,   155,     0,
       0,     0,   513,   658,   656,   655,   657,     0,     0,     0,
     678,   654,     0,  1443,  1445,     0,     0,     0,   469,   373,
       0,     0,   370,   374,   378,   379,   380,   427,     0,     0,
     459,     0,     0,     0,     0,   915,     0,   933,   916,     0,
       0,     0,   955,   960,   956,   936,     0,   497,  1301,  1302,
       0,   293,     0,     0,   560,   293,   293,     0,   293,     0,
     293,   293,     0,  1107,   586,     0,   643,     0,     0,   293,
     714,  1745,   828,   426,     0,     0,     0,     0,   839,     0,
     495,   844,     0,   856,   851,   853,     0,   860,  1280,  1273,
    1275,  1274,     0,     0,  1271,  1751,   713,     0,     0,   293,
       0,   861,     0,   788,     0,     0,     0,     0,  1347,  1752,
    1753,     0,     0,     0,     0,  1787,     0,     0,  1659,     0,
    1635,  1637,  1470,  1649,     0,  1483,  1660,  1661,  1639,  1641,
       0,  1735,     0,     0,  1650,  1592,  1593,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1605,  1604,  1651,  1717,     0,     0,  1774,  1775,  1652,  1513,
    1514,  1514,     0,     0,  1781,     0,     0,     0,  1657,  1662,
       0,     0,     0,     0,  1668,     0,  1689,     0,     0,     0,
    1615,  1745,  1505,  1506,     0,     0,     0,     0,     0,     0,
       0,     0,  1589,  1572,  1566,     0,  1570,  1574,     0,     0,
       0,     0,  1558,  1584,  1554,     0,     0,  1560,     0,  1585,
    1342,  1342,  1342,  1342,  1339,     0,     0,     0,     0,  1406,
    1395,  1397,  1408,  1399,  1401,  1437,     0,  1818,     0,  1380,
    1351,  1351,     0,  1701,     0,  1624,     0,  1701,     0,     0,
     171,     0,   203,   190,     0,  1205,  1821,     0,  1354,     0,
    1736,   904,   902,   903,  1356,     0,     0,  1391,  1390,  1389,
    1364,  1268,     0,  1266,  1261,     0,  1262,  1801,     0,  1258,
    1291,     0,     0,  1442,     0,  1290,  1069,  1002,  1047,  1169,
     871,   872,     0,   870,     0,     0,     0,   412,   887,     0,
       0,     0,   635,     0,     0,   416,     0,  1183,     0,   528,
     529,     0,     0,   547,     0,     0,   536,     0,     0,     0,
       0,   535,   552,   501,   553,   555,     0,     0,   554,   557,
     562,  1044,     0,   598,  1024,     0,  1066,   938,     0,  1471,
     913,   918,   919,     0,     0,     0,   386,     0,     0,     0,
     249,   259,     0,     0,   263,     0,   257,   277,   269,   278,
     270,   573,   574,   572,   568,     0,   575,   577,   298,     0,
       0,     0,  1076,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1077,  1053,     0,     0,   124,   123,
       0,   130,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   310,   295,     0,     0,     0,     0,
       0,   312,     0,     0,     0,     0,  1075,  1011,   744,     0,
       0,   745,   753,     0,     0,   746,     0,     0,     0,     0,
       0,     0,   755,   344,     0,   347,   354,   327,   331,  1187,
       0,  1187,     0,   332,  1187,   328,  1187,   325,  2008,  1725,
    1726,   669,   676,   666,   668,   670,   667,     0,   675,   635,
       0,     0,     0,  1454,     0,  1522,  1523,  1524,  1525,  1526,
    1527,     0,  1521,  1528,   663,   664,     0,  1169,  1168,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     398,     0,     0,   392,     0,     0,   960,   385,   388,   389,
     521,   524,   522,   523,   551,     0,   592,     0,   565,   134,
       0,     0,   135,   133,     0,   300,   369,     0,     0,   616,
     619,   612,     0,   677,   679,   652,     0,   565,     0,  1253,
       0,   465,     0,   455,   405,   451,     0,   453,   452,   454,
       0,   461,   299,     0,     0,   888,   914,     0,     0,     0,
     953,   957,   954,     0,     0,   929,     0,   937,   907,  1102,
    1103,  1100,  1101,     0,     0,  1293,   972,     0,   293,   970,
     717,     0,   708,     0,   710,   974,   293,   293,   603,     0,
     510,     0,     0,     0,   838,   858,     0,   854,     0,     0,
     821,   863,  1278,  1276,   866,     0,   822,   865,     0,     0,
       0,     0,     0,  1756,  1489,     0,  1789,  1785,     0,  1632,
    1757,     0,  1769,  1768,  1591,  1770,     0,  1610,     0,     0,
    1602,  1600,  1601,  1594,  1595,  1596,  1597,  1598,  1599,  1603,
    1779,  1778,  1772,  1773,  1509,  1507,     0,  1654,  1655,  1656,
    1780,  1663,     0,  1884,  1690,  1667,  1683,  1682,     0,     0,
       0,  1670,     0,     0,  1679,     0,  1719,  1495,  1528,  1534,
       0,     0,  1557,  1784,  1575,     0,     0,     0,  1553,     0,
       0,     0,     0,  1562,  1735,     0,     0,     0,     0,     0,
       0,  1333,  1332,  1338,  1316,     0,  1408,     0,  1407,  1419,
       0,     0,  1425,  1423,     0,  1425,     0,  1425,     0,  1400,
       0,  1402,  1419,     0,  1819,  1438,     0,  1382,     0,     0,
    1350,     0,  1701,  1631,  1704,  1699,  1700,  1749,  1625,  1836,
       0,  1747,  1701,     0,  1798,  1327,     0,  1355,  1372,  1365,
    1909,  1440,  1267,     0,     0,  1264,  1265,     0,     0,  1285,
    1266,  1288,     0,   877,   878,   876,   879,     0,     0,     0,
     635,     0,     0,   432,     0,   895,   895,     0,     0,   418,
     464,   960,   638,     0,     0,     0,   636,   293,  1007,     0,
     548,     0,     0,   544,   542,   541,   543,   502,  1085,  1008,
       0,     0,     0,     0,   939,     0,   931,  1023,     0,   383,
       0,   254,  1045,     0,     0,     0,   253,     0,   293,   293,
     570,   302,   303,   306,     0,     0,     0,     0,     0,     0,
     702,   685,     0,     0,   703,   704,     0,     0,     0,   977,
     978,   976,   128,   125,   126,   129,  1019,  1063,  1017,     0,
    1057,  1028,  1026,     0,     0,     0,     0,     0,  1084,  1040,
    1061,  1083,  1038,  1059,  1037,  1058,  1039,  1060,  1031,     0,
    1447,   683,   682,     0,   293,   293,   605,  1021,  1065,     0,
     747,     0,     0,   748,   759,   757,   756,   758,   750,   345,
     118,     0,   324,     0,   352,     0,   350,   349,   351,     0,
     338,     0,     0,     0,     0,     0,   645,     0,     0,     0,
    1450,  1455,  1530,  1463,   634,     0,  1160,  1159,  1158,  1162,
    1161,  1164,  1163,  1155,  1154,  1167,  1166,  1153,  1152,  1157,
    1156,     0,   390,     0,   396,   400,   401,   399,   391,   960,
     424,   463,   519,     0,   595,   590,   137,   136,     0,     0,
       0,     0,   621,   625,   653,     0,  1446,   599,     0,   371,
     469,   467,     0,     0,   376,   381,   382,     0,   459,   402,
       0,   455,   375,     0,     0,   466,  1147,     0,     0,   917,
     934,   935,     0,     0,   960,   959,     0,   504,   293,   561,
     293,   293,  1108,   644,     0,   850,   849,   848,   496,     0,
     852,   293,     0,     0,     0,     0,     0,   798,   779,   797,
    1788,  1648,  1658,  1767,     0,     0,  1611,     0,     0,  1653,
    2154,     0,     0,     0,     0,  1687,  1688,  1669,     0,  1999,
    1674,     0,     0,     0,  1839,  1581,  1579,  1576,     0,  1577,
       0,     0,  1559,  1555,     0,  1561,  1586,  1337,  1336,  1335,
    1334,  1410,  1417,     0,  1398,     0,  1424,  1420,     0,  1421,
       0,     0,  1422,     0,     0,  1417,     0,     0,     0,     0,
    1695,  1701,  1701,  1626,  1706,  1703,     0,  1628,  1528,     0,
       0,  1260,  1263,     0,  1292,  1283,  1175,     0,     0,     0,
     414,     0,   960,     0,     0,     0,   898,   898,     0,   960,
     463,   640,   639,   642,   637,   641,  1184,     0,   537,   538,
    1025,     0,  1067,  1029,   932,     0,   566,   250,   251,   252,
     255,   295,   262,   256,     0,  1078,  1012,  1054,     0,     0,
     691,     0,     0,     0,     0,  1079,  1013,  1055,     0,     0,
       0,     0,  1193,     0,   294,   295,   311,  1042,     0,   751,
     752,   326,     0,   348,   357,     0,   355,   329,   334,     0,
     336,   335,   330,   333,  1451,     0,   991,   991,     0,   635,
    1165,     0,     0,   387,   463,   431,     0,   393,     0,     0,
       0,   371,   565,   620,     0,     0,     0,   680,   373,     0,
    1251,   468,   372,     0,     0,   461,     0,     0,     0,   459,
       0,   456,     0,   460,     0,  1142,     0,     0,   958,     0,
     962,     0,   928,   905,  1439,     0,   508,   992,   709,   711,
     604,   855,   862,   293,   780,   781,   782,   783,  1606,     0,
       0,     0,     0,  1664,     0,  1665,  1692,  1691,  1671,  1675,
       0,  1672,  1673,  1578,  1582,  1580,  1563,  1409,     0,     0,
    1411,     0,     0,  1413,  1415,     0,     0,     0,     0,     0,
    1822,  1701,  1379,  1381,     0,  1317,  1629,  1630,     0,  1351,
    1701,   204,  1737,  1441,  1289,   856,     0,   293,   895,   463,
     433,  2008,   434,   894,     0,   896,   901,   901,     0,   463,
     635,   530,     0,   564,     0,   297,   305,     0,     0,   698,
     686,     0,     0,   705,  1027,     0,     0,     0,     0,     0,
     293,   754,   316,   343,   353,     0,   337,   991,     0,   988,
     987,   633,     0,   422,   394,     0,   442,     0,   565,   695,
    1147,   578,   622,   623,   618,     0,     0,   455,   451,   377,
     386,   360,   411,   410,   407,   406,   408,   409,   404,   403,
       0,   461,   457,   458,     0,     0,     0,  1195,     0,   889,
     961,     0,     0,     0,   503,     0,     0,   507,   498,   823,
    1607,     0,  1608,     0,     0,     0,  1677,  1676,     0,  1418,
    1427,     0,  1414,  1412,  1403,     0,  1405,  1694,  1696,     0,
       0,  1709,  1627,   873,     0,   874,   898,   437,     0,   897,
     904,   904,   424,   635,   415,  1030,   567,     0,   258,     0,
     689,     0,   700,   698,     0,     0,  1189,     0,  1190,  1191,
    1194,   313,   356,   986,   990,   989,     0,     0,   395,   428,
     429,   430,     0,   397,   438,   439,     0,   591,     0,     0,
    1143,     0,     0,   459,   455,   384,   450,   358,     0,  1144,
       0,   300,     0,   960,   963,  1106,   506,   505,  1609,  1680,
    1666,  1693,  1678,  1416,     0,  1404,     0,     0,  1705,     0,
       0,     0,     0,   901,     0,   635,     0,   892,   891,   431,
     417,   296,     0,     0,   696,   699,   687,   700,   707,   706,
       0,     0,   421,     0,     0,     0,   440,     0,   441,   462,
     694,     0,   624,     0,   461,   459,  1145,  1146,   461,   890,
     906,  1105,  1104,  1329,  1426,  1697,  1698,  2116,  1909,  2090,
       0,  1707,  1710,  1708,  1702,   293,   904,     0,   419,   435,
     442,     0,     0,   688,  1192,   625,   447,     0,   446,     0,
     444,   443,   684,   628,   361,   461,  1439,  1088,  1329,  1087,
    1089,  1097,  1094,  1096,  1095,  1093,     0,  1714,  1713,  1712,
    1716,  1715,   875,   893,     0,   635,   690,   697,     0,   445,
     449,   448,   630,     0,   626,   629,   631,   632,   359,   880,
       0,  1098,  1092,  1316,  1303,     0,   436,   420,     0,   606,
       0,  1090,  1329,  1711,     0,   627,  1091,     0,   628,     0,
     607
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3717, -3717, -3717,  2761, -3717,  -742,   241,  2170,  -969, -3717,
   -3717, -3717,  2674, -3717, -3717, -3717, -3717, -3717, -3717, -3717,
    2711, -3717, -3717, -3717,  1394, -3717, -3717,   120, -1045,  1681,
    2364,  1094, -3717,  -895, -3717, -3717,  -502,   116,  -105, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -3717,  -683,  1542,   949,
    -318, -2278, -3717, -1145, -3093, -3717,   393, -3717, -3717,  1483,
   -3717, -3717, -3717,   813,  -374, -3717, -3717, -3717, -3717, -3717,
   -3717, -3717,  -113, -3717, -3717,  -534, -1295,    43,  -177,  -404,
   -3717, -3717,   230,  -408, -1157, -3717, -2919, -3717,  -145, -3717,
   -3717, -3717,  -403, -1137,  1054, -3717,  -600,  -919,  1330,  -684,
   -3717,  -296, -3717,  -732,  -635,  -633,  -691,  -532, -3103, -3498,
   -3304, -2453,  1055,   147, -3717,  -153, -1293, -3717, -3717, -1242,
   -1165, -3717,  -723, -3717, -3717, -3717, -2403, -3717, -3717, -3717,
   -3717,    91, -3717, -3717, -3717, -3717,   289, -3717, -3717, -3717,
   -3717, -3717, -3717, -2243,  1451,  1452, -3717, -3717, -2596, -3717,
    -731, -3717,   435, -2446,   979, -3717, -3717, -3717,  2128, -3717,
   -3717, -3717, -3717,   296, -3717,   297, -3717, -3717, -1325, -3717,
   -3717, -1290, -3717,  1467,   796, -3717, -3717, -3717,  -709,  -771,
    -762, -3717, -2863, -3717, -3717, -3717, -3717, -3717,  -794, -3717,
     847, -2557,  -768, -3717, -3717,   863, -3717, -3717, -3717, -3717,
    -669,  -297,  2154, -3717,  -577,  -650, -3717, -3717, -3717,  -293,
   -3717, -3717, -3717, -3717, -3717, -3717,  -848,   -93, -1294, -3717,
   -3717, -3717, -3717, -1735, -3717, -3717, -3717, -1727, -3717,  3516,
    1917,  1053, -1282, -3717,   -17,    54,  2586,  -912, -2144,   242,
    -431, -3717, -1457, -3717, -3717, -3717, -2058, -3717, -3717, -3717,
   -3717, -2862, -1277, -3717, -3717, -3717,   282, -3717, -3671, -3313,
   -3583, -3121, -2850, -3717, -3717,  -879, -3717, -3717, -3717, -1114,
    1657, -1174, -3717, -1828,   283, -3126,  -573, -2689, -3717, -3025,
    -500, -3717, -3717, -3717, -3717, -3717, -3717, -3717,  -874,  -515,
   -3717, -3717,  3011, -3717, -2949, -3717, -3717, -3717, -3717,  1181,
   -3717, -1152,   945, -3717, -3717, -3717, -3717, -3717,  -646,  -724,
   -3717, -3717, -3717,   151, -3717, -3717, -3717, -3717,  1906,  -756,
    -595,  2898, -1274,  -461, -3717, -3717, -3717, -3717, -2516, -3717,
   -3717, -3717, -3717, -3717, -3717, -3717, -1198, -3717, -3717, -3717,
   -3717, -3717, -3717, -3717,  1819,  1817,    59,   -15, -3717, -3717,
   -1011, -3717,  -440, -3717,  2105, -3717, -3717, -3717, -3717,  1189,
     152,   329, -3717,     3, -3717, -3717,   126, -2819,     4, -3717,
   -3717, -3717, -3717,  -220,     5, -3717,   587, -3717, -3717, -2285,
   -3717,   153,     7, -3717, -3717,     1,     0,   -41,   -28,    -7,
       2,  2896,  2455, -3717, -3717, -3717,   -12,  1408, -3717,  -694,
    -154, -3717,  1199,  -521,  1795,  2448,  2446, -3717,  1196, -3717,
   -3717,  1204, -3717, -3717, -3717,  -520,  1808, -3717,  2454,  1826,
   -3717,  1191,  1197, -2797,   670, -2789,   193, -1141,  -346,    41,
    2938,  2504, -3717, -3716,   621, -3717, -3482, -1865,  -564,  1579,
   -1306, -3717, -3717,  -950,  4622, -3717, -3717, -3717,  7066, 10489,
   -3717, -3717, 10604, 10733, -3717,  -828,   718, 11407,  3492,  -976,
   -1557,  -339, 10616,   769,  -639, -2213, -3717, -3717, -3717,  -312,
     731,   338, -3717, -3717, -3717, -3717,  -538, -2291,  -525, -3717,
   -3717, -3717,  -527, -2879,  1252, -3717,  -176, -3717, 11468,  1255,
   -3717,  -808, -2221, -2228,  -937, -1414, -3717, -3717, -3717, -3717,
   -3717, -3717, -3717, -1220, -2707,  -275,  1323, -3717, -3717,  1410,
   -3717, -3717, -3717, -1068,  -700, -2141,  1328, -1636, -3717,  -686,
     663,  2021,  -631,    93, -1067,  8597,  -427, -1864, -1002, -1240,
   -3717,  -148, -3717,    25,    -9,   -77,  -444,     8,  3207,  6859,
    -497, -1075,  6126,  9285, 10581, -2540
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    48,    49,    50,    51,  1172,  2065,  1942,  2713,  2714,
      52,    53,  1247,    54,    55,    56,    57,    58,    59,    60,
    1187,    61,    62,   857,  1387,  2073,    63,  1816,   669,   670,
    1659,  1660,  2006,  1661,  1649,  1088,  1471,  1206,  1174,  1207,
      65,    66,  1082,  1640,    67,    68,    69,  1231,  1232,  1182,
    1424,  3570,  4108,  1927,  2752,  2549,  2550,    70,  1289,  1290,
      71,    72,  2662,  1327,  2664,  2665,  3167,   509,  2030,  3590,
    3591,  3154,  3155,  3597,  3855,  3856,    73,  1384,  2741,  3253,
    2742,  3663,  2743,  3664,  2744,  3665,  2695,  3217,  3218,  3219,
    2745,  3669,  4048,  2746,  1831,  4128,  2107,  1493,  1491,  4026,
    3472,  3473,  4175,  4133,  4134,  4135,  4240,  3671,  2750,  3261,
    3675,  3877,  2452,   588,  1406,  3251,    75,    76,  2101,  1263,
    1264,  1950,  3171,  2801,    77,   874,  3032,  3916,  4067,  4068,
      78,   197,    79,  1391,    80,    81,  2060,  2700,    82,  1843,
    2465,    83,    84,  2490,  2491,  2492,    85,    86,  3056,  3815,
    1233,  2542,  2543,  2544,  2545,  3076,    87,  1389,  1269,  2082,
      88,    89,    90,  2064,  2706,  2707,    91,    92,  1993,    93,
      94,    95,  1399,  2094,  2095,  3653,  3884,  4034,  3886,  4273,
    4274,  3869,  3015,  3486,    96,    97,    98,    99,  1370,  2053,
    2054,  3172,  1158,  1331,  2033,  2034,  3242,  3243,   100,   101,
    3530,  3531,   539,  4139,  4112,  4186,   102,   103,  3534,  3535,
     104,   105,   106,   107,   108,   582,   918,   919,  1164,   109,
    1755,   110,   832,  2649,   111,   982,  2225,  3708,   112,   611,
     932,   933,   113,   114,   620,  2205,   622,  1506,  2803,  2804,
    3310,  2175,   753,   115,   116,  2186,  2208,   117,  1175,  1822,
    1823,  3467,   118,   540,  1411,  2110,  2447,  4058,  3474,  3796,
    3986,  2393,  2974,   119,   541,  1211,  1889,  2113,  2756,  2757,
    1891,  2365,  3274,  1893,  2758,  2763,  2764,  2765,  3270,  3278,
    3910,  3911,   120,  1209,  1882,   121,   122,   123,  1242,   776,
     124,   552,   553,   125,  4019,   126,   886,   127,   638,  1519,
     128,  1905,  3062,   129,   130,   131,  4249,  4280,  4281,  4282,
    3283,  4213,   132,  4251,   962,   134,   135,   136,   171,   800,
     801,   802,   137,  3905,   138,   139,  2057,  2694,  3199,   140,
     141,  1817,  2437,   142,   143,   144,  1374,   145,   146,   147,
     148,  1307,   149,  1117,  1118,   150,   151,   504,   686,  1121,
    1129,   152,   590,   926,   927,   928,  1473,   153,   965,  2197,
     591,   921,   155,   592,  2411,  2985,  2986,  2989,   593,  2408,
     158,  1512,  2191,  2194,   594,  2415,  2416,  2417,  2418,  2419,
    2991,   595,   613,   877,  2118,   596,  1054,   163,   164,   165,
     695,   690,   691,   167,  1634,  2355,   628,  1136,   657,   703,
    3430,  1768,  1769,  1789,  1790,  1145,  1146,  1779,  1781,  2395,
    1782,  2404,  1774,  3427,  3770,  1785,  1786,  1148,  1149,  2399,
     168,  2359,  2940,  2941,  2942,  3408,  3418,  3757,  3953,  2943,
     960,  1155,  2944,  2949,  2983,  2732,  2733,  2734,  1894,  2040,
    1355,  1055,  1356,  2051,  1056,  1555,  1358,  1057,  1058,  1059,
    1361,  1060,  1061,  1062,  1063,  1538,  1597,  1064,  1065,  1574,
    2048,  2049,  1462,  2265,  1067,  1068,  3374,  3732,  3721,  2291,
    2292,  1656,  3370,  2892,  3965,  4087,  4088,  3438,  3435,  3774,
    3969,  4171,  4221,  4222,  1069,  2345,  1627,   778,  1070,  3174,
    1629,  2285,  2367,  2368,  1801,  1536,  2231,  2249,  2250,  2262,
    2853,  2269,  2274,  2876,  2877,  2286,  2314,  1071,  2234,  2235,
    2836,  1540,  1072,  1111,  1112,  1533,  2309,  1124,  1125,   688,
    1073,  1074,  1507,   679,  3949,   499,   744,  2559,  1746,   804,
     625,  1075,  1076,  1077,  1078,   894,   895,  1238,   500,   738,
     757,  2546,   501,   502,   740,  1751
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     162,   161,   166,   156,   157,   159,   694,   554,   777,   854,
     704,   510,  1150,  1430,   498,   626,   649,   952,   953,   954,
     162,   545,   166,   958,   736,  1156,  1440,  1515,  1083,   615,
     681,  1490,   754,  1470,   615,  1747,  1892,  1159,  1246,  1830,
    1237,  2176,  2302,  2037,  1752,  1305,   614,   693,  1434,   878,
    1293,   614,   900,  1268,   880,   538,  1549,  1550,  1901,  1576,
    1383,  1762,  2819,  2509,  2511,  1526,  2008,  1910,  1330,  1401,
    2561,  1097,  2050,  2955,  3277,  1565,   621,  2099,  1902,   589,
     741,   743,   678,  1923,   747,   748,  3038,   650,  1747,   841,
     929,  1752,  2074,  3071,  2075,  3073,  1890,  2076,  1962,  1372,
    1262,   790,  1376,  1273,   756,  2077,  3224,  1380,   581,   780,
    2078,  1298,  1463,  2079,  1385,  1421,    64,  2616,   792,  1971,
    2230,  3447,  1765,  1403,  2385,   903,  3176,  3195,  2807,  2990,
    2147,  1975,  1976,   888,  2952,   915,   698,  3509,   706,  2950,
    2951,  3405,  3649,  3469,  3176,  2945,   923,    74,  3684,  3479,
    3668,   133,   154,   160,  3419,  3421,  2900,  1878,   668,   707,
    1090,  1808,  2102,  3797,  3452,   880,   705,  1542,  1543,  3352,
    3895,  2111,  3200,  3201,  3202,  3203,  3204,  3205, -1504,   508,
    1208,  1400,  1144,  1147, -1504,  1422, -1944,  2857, -1854, -1978,
    1595,  3641, -1998,  1562,  2945,  3795, -1854,  2307,  4063, -1855,
    2096,  3268,  2307,  2716,  1753,  1472,  1184, -1855,   796,  1982,
    2637, -2023,  1987,  4111,  3987,  3512,  1184, -2168,   684,  1368,
    1510,  2187,  1838, -1499,  3411, -2168, -1471,  3804,  2808,   751,
     699,   786,  2173,  1422,  1324,  1911,  4059, -1504,   550, -1484,
   -1511,  -346,   550, -1514,   978,  1592,  1632, -1304,  3039, -1514,
     550,   871,  2105,  1904,   550,   550,  1302,   550, -1723,  2660,
    4065,  1969,   597,  1904, -1829, -1723,  3034,  1838, -1826,  2778,
    2342,  2780,  2554,   949,  1354,   762, -1499,  2343,  1836,  2995,
     987,   783,  3957,  2857,  3959,  1602,  4211,  1824,   700,   794,
    1422,  3412,  4124,  2658,  2055,   597,   797,  1904, -1881,  2817,
     597,  1818,  4258,  1825,  1318,  1422,  1140,   597,  1185,   550,
    1605,  1819,  2834,  4054,  -735,  3532,  3606,   506,  1185,  3413,
     934,  4055,  1937,  2071,  1234,  1140,  1820, -1307,  4183,   597,
   -1304,   550,  2020,  1602,  3414,   798,   603,  2188,  3602,   603,
    1607,  1305,   603,  1109,  1248,  3415, -1947,  1110,   777,  2812,
    1873,  3513,  2097,   701,  1593,   597,   604,  1826,  1605,   604,
    1455,   603,   604,   836,  1646,  1234,   550,  3416,   938,   505,
     597,  1904,  1650,  1142,  1827,  1249,  1576,  1662,  1662,  1637,
    1456,   604,  1938,   799,  3603,  4184,  3951,  2021,  1607,  1549,
    1550,   777,  1142,  2473,   550,  2072,  1839,  1565,  -118,   169,
    1514,  4051, -1304,  -118,   872,  1303, -1739,   883,  4066,  1143,
   -1307,  3533,  2207, -1739,  1458,  4193,   892,  2809,  2813,   880,
    1754,   839,  2857,  1163,   950,   842,  4259,  4125,  2171,  3619,
    1423,   880,  2177,  1874,  2179,  2015,  2106,  2182,  2358,   170,
    3417,   863,     3,     4,  2019,   849,  1109,  4212,   603,   856,
    1110,  3514,  2174,  2555,  3515,  1821,  3800,  1441,  3039,   873,
     865,  2661,   546,  2859,  1647,  2227,  1602,   702,   604,  1866,
    1965,  1840,  4056,   764,   845,   752,  4085,  1872,  1423,  1530,
    1511,  4209, -1307,  3462,   880,  3035,  2857,  1633,  1212,  2648,
    1474,  1605,  1087,   685,  1241,  1369,   603,   833,  3805,  2098,
    1828,  2308,  2638,  1912,  1784,  3589,  2920,  1864,  2189,  1542,
    1543,  3269,  1508,  4173,  3952,  1913,   604,  1958,  1562,  1960,
    2860,  1607,  1517,  3522,   957,  1752,  2190,  1988,  1948,  2305,
    4279,  1951,  1952,  1304,  1527,  1423,  2035,  1970,  1967, -1997,
    3176,  2011,   879,   554, -1304,  1922,   694,  2494,  2007,  1344,
    1423,  1983,  1151,  1109,  1837,  1511,  1537,  1110,  1596,  2954,
    1186,    47,  1537, -1723,  1460,  1114,  1914,  1115,  3899,  1752,
    2164,   550,  1648,  2857,   930,  2344,  1369,   550,  2233,   957,
    2037,  3105,  3008,  1325,  1326,  2031,   162,   693,   166,  1446,
    1644,  4041,  2016,  1514,  1829,   880,   831,   803,  2869, -1504,
    1461,  2513,   834,   880,   880, -1504,   931,  3790,   936, -1854,
     940,  2151,  1432,  3754,  3874, -1944,   944,  3758, -1978,   947,
   -1855, -1998,   963,   614, -1307,   614,  3713,   614,   922,  1793,
    1794,  1571,  3645,   614,   945,   946,  1881,  1571, -2168, -1304,
   -2023,  3785,   979,   777, -1499,  4204,   925,  1548,  2172,  1080,
    1572,  3657,  1089,   879,  1091,  3500,  1572,  2183,  1309,  3913,
    1554, -1511,  3433,  1598,  1573,  4096,  2859,   706,  1314,   959,
    1575,  1635,  1239,  1240, -1304,  2372, -1304,  1936,  3183,  4194,
    3051,  3615,  3052,  1109,  3309, -1829,  1432,  1110,   707,  2864,
    2865,  2866,  2867,  2868,  2869,   705,  1626,   162,   161,   166,
     156,   157,   159,   609,   610,  2583,   547,  4245,   609,   610,
    2495, -1739,  2394,  2969,  3658,   609,   610,  2508,  2992, -1307,
     846,  3257,   959,  1412,  2226,  2945,  2229, -1881,  1939,  3057,
    3441,   969,  2257,  2258,  1747,  1176,  2237,  1235,  1236,  1323,
    2241, -1997,  2518,  2105,  1119,  2324,  2012,  4147,  2253,  2254,
    3279,  1154,  1084, -2169, -1307,  2409, -1307,   889,  2810,  1381,
    1382,  2271,  2273,   609,   610,  1514, -1471,  3979,   987,   651,
    1107,  2857,  2287,  1312,  3989, -1947,  1409,   521,  1235,  1236,
    1086,  3143,  3144,  2471,  1094,   548,  1171,   549,   614,  3637,
    2041,  1133,  2041,  1190,  1601,  4236,  3475,  1602,   550,  2485,
    1116,  1571, -1997,  3098,  1436,  1438,  2498,  2429,  2108,  3707,
    2058,  -118,  -118,    64,  2697,  2450,  2962, -1997,  1099,   701,
    1572,   701,  1605,  1283,  2090,  3280,  1328,   503,  1606,  1284,
    2866,  2867,  2868,  2869,   523,  1878,   550,  1177,  3173, -1471,
     708,  2242,  1092,   550,    74,  2438,  3455,  2551,   133,   154,
     160,   169,  1607,   701,  3188,  2042,  3173,  2042,  3206,  1225,
    1173,  1832,  2122,  1642,  4076,  4100,  4101,  2451,  2346,  2325,
    2486,  2180,  2181,  2326,  1623,  1624,  1625,  1626,   767,   768,
     769,  3687,   770,   771,   772,   773,   774,   775,  1833,  2499,
    1593,   170,  2864,  2865,  2866,  2867,  2868,  2869,  3659,  2091,
    4244,  3209,  1922,  3058,  4246,  3138,  2705,   879,  3141,  3142,
    2327,  2043,  3145,  2043,  2044,   709,  2044,  2439,  4020,   879,
    2601,  3638,  3152,   796,  2136,  1285,  2602,  3881,  3059,  2266,
     162,   655,   166,  3275,  4143,  4153,  2243,  1962,  1892,  1379,
    1476,  4278,  1478,  2289,  1480,  2045,  1482,  2811,  1484,  1485,
    1486,  2859,  1513,   614,  3281,  1488,  1609,   627,  3950,  1404,
    1407,  1408,  3947,  3954,    37,  1414,  3956,  1278,   530,   929,
     531,  2698,   879,  2577,  4237,  2569,  1178,  1610,  1611,  2864,
    2865,  2866,  2867,  2868,  2869,  1392,  3527,  2128,  1602,  1535,
     551,  2347,   796,   536,    41,  3277,  2957,  3428,  2139,  2958,
    2123,  2244,  2045,   890,  2045,  1279,  4022,  1179,  2860,  1552,
    2146,   797,   694,  1605,  3282,  1824,  3230,  1834,  2489,  1313,
    1100,  1614,  2603,  1393,   656,  2156,  2328,  2577,  3961,  2472,
    3872,  2958,    45,   633,  1615,  3213,  1180,   956,  2303,  1579,
    4238,  4205,  4077,  1607,    46,  1396,  1594,  2570,  1084,  2699,
     798,  2260,  4226,  1590,   676,  3086,  1599,  2245,  4208,  2168,
    2246,  3661,  3816,  4239,  1286,  1397,  1636,   777,  4123,  3554,
    1084,  3214,   550,  1953,  2607,  2092,     3,     4,  2410,  3185,
     797,  1101,  3528,   879,  3215,  1826,  1652,  1653,  2093,  1772,
    4042,   879,   879,  1833,  1181,  1287,   974,  2571,   799,  2046,
    2681,  2046,  1827,  2121,   710,  2608,  1758,  2798,  1766,  1767,
    1244,  1771,  2127,   654,  4094,   957,  2131,   687,  2047,   798,
     614,  4145,  2137,  2138,  1288,   614,   614,  4104,  4210,   707,
     707,  1918,   707,   585,  2609,  3186,   705,   705,  4043,   705,
    2150,  3773,  1944,  4129,  1096,  4044,   550,  2572,  2247, -1471,
     597,  3777,    14,  1280,  4270,  2202,  3463,  3087,  4082,  3231,
   -1471,  2604,  1548, -1471,  1163,  3216, -1471,   799, -2169,  3529,
    3621,  1394,  4045,  3784, -2169, -2169,  1773,  2864,  2865,  2866,
    2867,  2868,  2869,    19,  2610,  1977,  1978,  1979,  1980,  1997,
    1134,   550,  2605,  1154,  1448,  3662,  1954,  2945,  1955,  1666,
    3441,  2945,  3767,  1621,  1622,  1623,  1624,  1625,  1626,  1398,
    2737,  3049,  3776,  2890,  1994,  2517,  3555,   614,  2513,  2897,
    2169,  2606,  3510,  2017,  2018,   614,  2045,  2584,  1828,  2027,
    1245,  4006,  1449,  1432,  -140,  2587,  2573,  2589,  2446,  1281,
    4180,  1369,  4046,   697,  3616,  2248,  1796,  2775,   634,  2170,
    4177,  4178,  3173,  4130,   696,  1602,  3701,  1395,  1966,  -140,
     945,   946,  2781,   777,  2582,  1775,  2022,  3996,   585,   521,
    1415,   987,  2120,   711,  2857,  2052,   614,  2001,  1859,   614,
     614,  2126,  2776,  1135,  3176,  2594,  4031,    14,  4271,  3623,
    -888,  2723,  2724,  2725,  2726,  3715,  3088,  3716,  1602,  2085,
    2086,  2087,  2088,  2731,  2023,  2390,  1776,  1898,  2002,  2070,
    1607,  1968,  4228,  1907,  1915,  2632,  4131,  3464,    19,  2003,
    1416,  3027,  1829,  1605,   635,  1994,   523,  3089,  3206,  3900,
    2004,  4007,  1171,  1892,  3207,  1776,  2476,  2574,  4256,  2519,
     614,  3901,  3305,  1947,  3208,  2575,  3465,  3990,  2576,   746,
     754,  2141,  2771,  1607,  2005,  2129,  3090,  1777,  3461,  3028,
    2145,   788,    37,  1173,  1908,  3466,  2185,  2152,  2485,  2387,
    2965,  3209,   763,  3210,  3003,  1981,  4263,  1638,  1994,  2080,
    1450,  3656,  1244,  2450,  2391,  2626,  1777,  2434,  1998,    37,
     777,  1284,    41,  3050,  1621,  1622,  1623,  1624,  1625,  1626,
    3635,  2010,  4287,  4047,  1432,  3580,  4293,  2530,  1417,  3801,
    1173,  3583,  3584,  3585,  3586,  3587,  3588,  3323,  1962,    41,
     795,  4024,  3717,  2074,  2832,  2075,  3482,  3690,  2076,  3691,
      45,   835,  4137,  2858,   586,  3011,  2077,  2380,  1639,  2486,
    3106,  2078,    46,   169,  2079,  3211,  2611,  1924,   987,  3896,
    2686,  2857,  2024,  2515,  2859,  2800,  1418,    45,  2531,  -558,
     530,  3636,   531,  3299,  3277,   162,  1451,   166,  3380,    46,
    3802,  1654,  2532,  2884,  2672,  2612,   587,   840,  1610,  1611,
    3966,  3967,  2158,   170,  2159,   536,  2160,  1285,  2161,  3897,
    2162,  3902,   636,   637,  2163,  1925,  1926,    37,  3483,  2687,
    3212,  -369,  1292,    47,  2909,  3213,  -140,  3029,  2204,   838,
    1655,  2860,  4064,  2567,  2310,  1225,   162,  2201,   166,  2198,
    2199,  2200,  1614,  2533,  1265,   925,  4097,    41,   855,  1922,
    2485,  -140,  3014,  2613,  1419,  3308,  4103,  1571,  2025,  1592,
    1930,  3214,  2945,  3995,  2251,   597,   987,  2945,  4106,  2857,
    2945,  3484,  2192,  3485,  3215,  1266,  1572,  2155,  3923,  1274,
    1160,  4005,  2614,  2681,  3865,    45,  3381,  4010,  1953,  1251,
    1573,  2239,  2240,  3309,  3482,  2688,  2689,    46,  2203,  2252,
    3475,  1168,  4032,  2255,  2256,   603,   861,  2489,  3156,  2690,
    1275,  1161,  3866,  3030,  1276,  1084,  1084,  3126,  2277,  2387,
    2278,  2486,  3026,  3258,  1171,   604,  3262,  1165,  2055,  2313,
    4033,    47,  1169,  2767,  4126,  1252,    32,  3127,   880,  1277,
    1162,  2300,  2224,  2301,  2266,  2266,  2069,  3808,  3809,  2266,
    2487,  2859,  2815,  3333,  2691,  3216,  3613,    32,  1166,   869,
    4169,  1170,  2373,  3975,  2100,  3977,  3483,  2789,  1916,   870,
    1267,  1662,   880,   935,   937,   939,    37,  3353,   941,   942,
     943,  2488,  1943,  4157,  3336,  4170,  3337,  1167,   948,  2266,
    2266,   866,   847,  2569,   848,   777,  2861,  2862,  2863,  4092,
    2864,  2865,  2866,  2867,  2868,  2869,    41,  1802,  2860,  2709,
      27,  1954,  1253,  1955,  3475,  3556,  2466,   885,  3020,  3484,
     867,  3485,   754,  3412,  1621,  1622,  1623,  1624,  1625,  1626,
     896,   699,   866,   645,  1171,  3557,   910,  3083,  1803,  2692,
     675,  2693,  3080, -1351,    45,  2356,   901, -1351,  2426,  2859,
    3304,  3413,   987,  2430,  2370,  2857,  2433,  3081,  1254,  3497,
    1255,  3237,  2945,  1904,   868,  2570,  3760,  1804,  3084,  2489,
    1961,  1909,  3740,  2468,  2469,  2470,  1465,  3415,  2456,  1466,
    2478,  3040,  2480,   987,  2482,  2483,  2857,  2977,    37,   700,
      47,  1560,  1561,  3480,  3411,  1931,  2960,  3085,  1257,   920,
     597,  3338,  2396,  3741,  1571,   868,  2860,   916,  1959,  3061,
   -1351,  3339,  2500,  2402,  2403,  2571,   162,  2412,    41,   614,
    2728,  2829,  2440,  1572,  2443,  2729,  2154,  2774,  3239,  1140,
    3043,   597,    37,  1141,  2926,  1259,  1119,  1575,  3366,  2514,
    2315,  3734,  2316,  2783,  2784,  1924, -1351,  2786,  1756,   951,
    3053,  1757,  2227,  2790,   701,  1548,    45,  1809,  2116,  2117,
    2710,  3412,    41,  2547,  2317,  2572,  3849,  3850,    46,  2381,
    1261,  2384,  3417,  2861,  2862,  2863,   955,  2864,  2865,  2866,
    2867,  2868,  2869,  2585,  2568,  1534,  1091,    47,  2578,  3413,
    2830,  4247,    27,  1925,  1926,  2831,  1142,   880,   987,   961,
      45,  2857,    47, -1099,  3414, -1099,  2590, -1374, -1374,  3501,
    2821,   515,    46,  3505,  3196,  3415,  2599,   964,  1548,  2729,
    1809,   966,  2493,  3021,  3354,  3355,  3315,  1922,   850,  2622,
     851,   198,  1143,  3511,  3516,  2859,   507,  3416,  2629,  1109,
    2642, -1829,  2293,  1110,   583,  2296,    47,  2227,  2651,  2652,
    2653,  2654,  2655,  2656,  2573,   971,  1972,  2318,   612,  3475,
     652,  1759,  2319,   612,  1760,  3319,  2859,  2320,   702,   972,
      37,  2861,  2862,  2863,  3220,  2864,  2865,  2866,  2867,  2868,
    2869,  3599,  3019,  3601,   975,  2000,  3604,   880,  3605,   521,
     973,  2711,  2860,  1924,  2618,   614,  3924,  3925,  3926,  3927,
      41,  3387,   976,   614,  1475,   614,   974,  1477,  -882,  1479,
    3417,  1481,   977,  1483,  3000,  3001,  3173,  1487,  3091,   980,
    3093, -1316,  1924,  2860,  2551,  2883,  3523,  2885,  2886,  2538,
    2712,  2650,  2739, -1316,   981,  4029, -1350, -1316,    45,  2650,
   -1350,  1925,  1926,  2748,  2749,  2911,   523,  2912,  4225,  2153,
      46,  2165,  2154,  2167,  2166,  2574,  2166,  2496,  1548,  2777,
    1163,  2779,  2195,  2575,  2386,  2196,  2576,  2387,  3104,  2913,
    1925,  1926,   983,  3125,  3318,  1922,  2930,  2422,  2931, -1316,
    2196,  2859,  2822,  2321,  4248,  1095,  2719,  2824,  2506,  3733,
    2705,  2507,  2680,  2322,  1924,  2722,  1548,  3139,  1809,  3360,
   -1316,  4060,  1102, -1350,  1922,  1924,  2563,  2667,  1103,  2564,
    2668,  3477,  3478,  1892,  2682,  2972,  2973,  2683,  2792,  2681,
    2753,  2166,  3320,  1098,   162,  2738,   879,  2805,  1137,  2828,
    1139,  1104,  2154,  4011,  2720,  3666, -1316,  3235,  2860, -1350,
    3107,  1108,  1925,  1926, -1316,  2838,  1120,  2842,  2154,  2805,
    2154,  3101,  2827,  1925,  1926,  1128,  3017,  2861,  2862,  2863,
     879,  2864,  2865,  2866,  2867,  2868,  2869,  2914,  2846,  1520,
    1521,  2154,  2915,   777,  1130,  2847,  1922,  1924,  2154,  1127,
     530,  2717,   531,  2873,  3608,  3609,  2154,  1922,  2861,  2862,
    2863,   533,  2864,  2865,  2866,  2867,  2868,  2869,  2889,  2978,
    2979,  2154,   535,  2519,  2894,   536,  3074,  2895,  3078,  3075,
    3226,  3079,  2932,  3227,  2933,  3221,  3266,  3223,  1138,  3267,
     880,  1131,   880,   614,  1305,  1925,  1926,  1152,  3287,  3064,
    2946,  3066,  1601,  2959,  3324,  1602,  2970,  2154,  4291,  2266,
    4292,  3971,  2266,  2266,  2266,  2266,  2266,  2266,  2266,  2266,
    2266,  2266,  1153,  1157,  3695,  3696,  3697,  1163, -1316,  1922,
    1605,  3361,  3135,  1183,  3362,  3371,  1606,  3424,  3372,  3502,
    3383,  3453,  3364,  2154,  3454,  1188,  3429,  3431,  3272,  2946,
    1130,  3596, -1304,   880,  1210,  3229,  3457,  3232,  2916,  3458,
    1607,   694,  3481,  3328,  3759,  2166,  3762, -2080,  2917,  1924,
    1214,  2266,  2266,  2861,  2862,  2863,  1924,  2864,  2865,  2866,
    2867,  2868,  2869,  3334,  3592,  1250,  1109,  3593,  3124,  1130,
    1110,  3739,  1241,  3131,  2196,  3792,  3798,  3799,  3793,  2166,
    2166,  3892,  1590,  3933,  3893,  1243,  3934,  3935,  3356,  3943,
    2154,  3993,  2196,  1270,  3994,  1282,  2313,  1925,  1926,  1291,
    4014,  1295,  2908,  4015,  1925,  1926,  3187,  3189,  3190,  3157,
    2935,  2936,  2937,  1300,  1301,  2929,  2996,  4061,  4072,  4079,
    4062,  2196,  2387,  1306,  1514,  1308,  1752,  1310,  2939,  4084,
   -2080,  1922,  3246,  4086,  4146,   879,  3246,  1641,  1922,   694,
   -2169,  1315,  4151,  3314,  1609,  4152,  1320,  1322,  1329,  3023,
    3158,  3024,  3025,  4158,  1332,  1171,  2196,  2227,   162,  2201,
     166,  2198,  2199,  2200,  1373,  1610,  1611,  2961,  4159,   614,
    4160,  2895,  3576,  2154,  3159,  1375, -2080,  2939,  4017,  4163,
     693, -2169,  2387,  4165,  4182,  1377,  3246,  2196, -2080,  3160,
    1386,  4188, -2080,  3161,  2196,  4189,  4214, -2080,  2196,  2387,
    -157,  4289, -2080,  3598,  4290, -2080,  1369, -2080,  1388,  1614,
    4300,  3162,  1390,  4290,  2934,  1601,  1402,  1410,  1602,  3738,
   -2082,   185,  1615,  3286,  1420,   879,  3163,  3289,  3290,  1425,
    3292,  1426,  3294,  3295, -2080,  1427,  1428,  1429,  1431,  1432,
    1439,  3300,  1442,  1605,  1443,  1444,  1445,  1447,  1452,  1606,
    1453,  3082,  3685,  1454,  1459, -2080,  3839,  3840,  3094,  3842,
    2970,  1084,  1489,  1464,  1516,  1522,  1531,  1518,  1524,  1525,
    1532,  3316, -1475,  1607, -1482,  1545,  1541,  1544,  2970,  3909,
    1546,  1547,  1551,    47,  1553,  1556, -1472, -1473,  3156,  1557,
    1558, -2080,  1559,  1564,  1566,  1567,  1568, -2169, -1476, -2080,
    1569, -1474,  3164, -2082,  1570,  1630,  3077,  1577,  1578,  1580,
    3165,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1645,  1764,
    1657,  1665,  1641,  1141,  3722,  1143,  1791,  1799,  3136,  1805,
    1806,  1807,  1809,  1810,  3099,  1811,  1812,  1813,  1814,  1835,
    2266,  1841,  1842,  3166, -2080,  1861,  1865,  1867,  1601, -2082,
    1868,  1602,  1869,  3698,  1870,  1871,  1919,  1896,  1904,  1916,
    1922, -2082,  1897,  1906,  1917, -2082,  1920,  1921,  1603,  1929,
   -2082,  1928,  1933,  1608,  1940, -2082,  1605,  1609, -2082,  1941,
   -2082,  1934,  1606,  1945,  1932,  1946,  1949,  1956,  1225,   627,
    1957,  1621,  1622,  1623,  1624,  1625,  1626,  1963,  1610,  1611,
    1964,  2650,  1973,  1974,  2650,  2650,  1607, -2082,  2650,  1984,
    1985,  2013,  2759, -2080,  1612,  1986,  1989,  2014,  2650,  1995,
    1990,   754,  1999,  1328,  2029,  2026,  2028,  3175, -2082,   880,
    2038,  1191,  2036,  2039,  2056,  1537, -2080,  1548, -2080, -2080,
    3648,  2059,  1614,  1554,  2062,  3175,   517,  2063,  2067,  2103,
    2068,  1267,  2084,  2104,  3861,  1615,  2089,  2109,   879,  3296,
     879,   614,  3297,  1192, -2082,  2112,  2114,  2115,  3182,  3184,
    3854, -2080, -2082,  3191, -2080, -2080, -2080,  2119,  2130,   614,
    2132,  1994,  2134,  2148,  2149,  2133,  2178,  2184,  2193,  2275,
    2135,  3244,  2206,  2233,  2232,  3307,  2276,  2288,  2238,  2294,
    1602,  2299,  2312,  3321,  2306,  2298,  1608,  3233,  2329,  2331,
    1609,  2266,  2266,  3317,  2358,  2371,  2374, -2082,  1193,  2375,
    3271,   879,  2378,  2379,  2388,  2397,  3666,  2389,   700,  2401,
    1617,  1610,  1611,  2398,  2407,  2423,  2425,  2424,  2436,  2441,
     162,  3285,  2446,  2455,  2464,  2460,  1159,  1612,  2448,  1194,
    2449,  3931,  2481,  2421,  2444,  2467,  3646,  3647,  2484,  2497,
    2946,  2502,   627,  1092,  1215,  1096,  3225,  2504,  2553,  2566,
    1216,  2558,  1613,  2562,  2565,  1614,  2615,  2628,  2760,  2635,
    2636,  2639,  2640,  2641,  1195,  2643, -2082,  2644,  1615,  2645,
    2267,  3240,  1514,  2647,  2670,  2646,  2657,  2659,  2663,  3248,
    2666,  2673,  2675,  3254,  2267,  2676,  2677,  2679,  2684, -2082,
    1217, -2082, -2082,  1196,  2674,  2678,  2703,  3265,  3851,  2708,
     614, -2169, -2169,  2715,  1621,  1622,  1623,  1624,  1625,  1626,
    2721,  2946,  2727,  2735,  2730,  2736,  2751,  2768,  2754,  2766,
    2770,  2769,  2772,  2773, -2082,  2787,  2782, -2082, -2082, -2082,
    2785,  4078,  2348,  2788,  2794,  2795,  2796,   694,  3909,  1218,
    2387,  4078,  2806,  1617,  2814,  3378,  1219,   694,  2207,  1220,
    1460,  2797,  2799,  2818,  2970,    32,   957,  2820,  2823,  1199,
    2825,  1084,  2844,  2840,  2826,  1200,  2841,  2843,  3397,  3398,
    3399,  3400,  1201,  2845,  2154,  3807,  2891,  2910,  1590,  2848,
    1880,  3779,  2954,  2879,  3493,  3494,  3495,  3496,  3404,  1203,
    4016,  2849,  4120,  2948,  2925,  2956,  2851,  1204,  3439,  2854,
    2905,  1221,  -928,  3821,  2872,  2878,  2880,  2881,  2918,  3498,
    3962,  2888,  2903,  2988,  2982,  3830,  2904,  2953,  2994,  2928,
    3689,  2999,  3002,  2984,  3005,  3009,  3004,  3010,  3692,  3693,
    3013,  3016,  3022,  1618,  1619,  1620,  3047,  1621,  1622,  1623,
    1624,  1625,  1626,  4071,  3018,  3036,  3048,  3037,  1205,  3054,
    3055,  3063,  2762,  3276,  3065,  3096,  1222,  3097,  1223,  3845,
    3100,  3102,  3103,  3108,  4164,  3110,  3109,  3111,  1224,  3112,
    3113,  3128,  3114,  3116,  3117,  3115,  1225,  3118,  3401,  3402,
    3403,  3119,  2855,  2856,  3121,  1226,  3558,  2871,  3123,  3561,
    3875,  3120,  3122,  3130,  3132,  1982,  3134,  3140,  3146,  1191,
    3177,  3147,  3148,  3149,  3150,  3151,  3192,  2045,  3181,  3197,
    4109,  3180,  3198,  3193,  4114,  4115,  1227,  3234,  3238,  3246,
    1228,  3175,  3236,  3245,  3252,  2266,  3250,  2906,  2907,  3260,
    3255,  1192,  3259,  3263,  3936,  3256,  3284,  3311,  3543,  3264,
    3301,  3544,  3302,  3545,  3303,  1229,  3291,  3974,   880,  3312,
    3313,  2266,  2266,  3293,  3542,   614,  3306,  3322,  3327,  1534,
    2875,  2857,  1595,  3385,  3632,  2874,  3357,  3571,  3572,  4110,
    3854,   614,  3358,  3359,  3365,  4113,  4074,  3386,  3410,  3373,
    3394,  2650,  3426,  3423,  3449,  3468,  1193,  2650,  2650,  2650,
    2650,  2650,  2650,  3489,  3491,  3492,  3504,   879,  3432,  3506,
    3442,  3600,  3503,  1230,  1514,  3526,  3446,  4116,  3508,  4118,
    3443,  3524,  3525,  3445,  3536,  3517,  3537,  1194,  4277,  3806,
    3553,  3569,  3538,  3512,  3573,  3539,  3540,  3581,  3541,  3579,
    3582,   614,  3610,  3611,  3276,  3651,  3639,  3612,  3652,  3670,
    3618,  3620,  3622,  3624,   945,   946,  2166,  3655,  3631,  3673,
    3822,  3823,  1195,  3682,  3683,  3607,  3654,  1215,  3688,  3694,
    3674,  3699,  3702,  1216,  3703,  4277,  3711,  3704,  3705,  1844,
    3686,  3706,  3714,  4277,  3617,  3719,  3723,  3724,  3718,   623,
     624,  1196,  2805,  3725,   630,  3726,  3731,  3753,   640,   646,
     623,  3756,   653,  3727,  3751,   646,   646,  3755,   680,  3763,
     683,  3766,  1845,  1217,  3768,  3677,  3846,  3847,  3769,  3771,
    3780,  1633,  2946,   162,  3676,  1846,  2946,  4050,  3783,  3772,
     777,  3787,  3789,  3794,  3795,  4091,  3803,  3817,  1847,  3982,
    3831,  3814,  4168,  3818,  3824,  3838,  3843,  3848,  3834,  3614,
    2266,  3852,  3867,    32,  3859,  1879,  3868,  1199,  3876,  3864,
    3878,  2210,  1218,  1200,  3879,  3880,  3883,  3891,  3640,  1219,
    1201,  3885,  1220,  3709,  3999,  3898,  1848,  3894,  1880,  3906,
    3904,  3907,  3915,  3921,  3929,  3930,  3932,  1203,  3939,  3937,
    3650,   614,  3940,  3941,  3942,  1204,  3948,  3955,  3958,  3964,
    3968,  3970,  3972,  3976,  3988,  1849,  3992,  4001,  2211,  3991,
    1850,  4008,  4266,  4018,  4009,  4002,  3638,  4027,  4025,  4036,
    4035,  4040,  4038,  4052,  1221,  4053,  1514,  4075,  4081,  4090,
    3917,  1601,  3918,  3919,  1602,   701,  4098,  2212,  4107,   737,
     742,   742,   745,  3922,   742,   750,  1205,   737,  4127,   680,
    4138,   779,  4136,  4132,  4142,   680,  3125,   680,  2213,  1605,
    4148,   742,  4149,   680,  4150,  1606,  4155,  4156,  4166,  4161,
    2939,  4162,  4167,  4172,  2939,  4185,  4111,  4174,  4191,  1222,
    4192,  1223,  4195,  4190,  4197,  4201,  4206,  2214,  3434,  1607,
    4232,  1224,  2215,  1514,  3778,  4207,  4224,  1514,  1514,  1225,
    4227,  4235,  4229,  1215,  4193,  4194,  1851,  3825,  1226,  1216,
    4243,  3788,  4257,   162,  3781,  4269,  4285,  4288,  1132,  3835,
    4294,  4298,  3841,  1996,  2718,  1664,  1294,  1213,  2963,  3060,
    3786,  2557,  3521,  2627,   185,  3153,  3844,  4012,  2216,  1271,
    3853,  4122,  3889,  1228,  4037,  4039,  3672,   614,  3873,  1217,
    3747,  3748,  3749,  3750,  4049,  4230,  2793,  3980,  4265,  3007,
    4198,  4196,  4179,  4241,  3012,  1852,  4144,  3890,  1272,  3642,
    3520,  1853,  2701,  2702,  1854,  2267,  2267,  2081,   880,  3072,
    2267,  3643,  3819,  2685,  3644,  3241,  4268,  4299,  4295,  1608,
    3194,  3178,  4242,  1609,  4000,  2066,  4187,  4233,  1218,   614,
    1855,  4003,   629,  1509,  4093,  1219,  1856,  3678,  1220,  2510,
    3679,  3700,  3828,  3829,  1610,  1611,   185,  3832,  3833,  1857,
    2267,  2267,  4154,   881,  3129,  3888,  1230,  4250,  4296,  4140,
    1612,  2157,  2650,  2650,  1105,  2383,  2382,  2967,  3660,  3459,
    3782,  2217,  1761,  4176,  1858,  1126,   879,  2218,  2968,  2406,
    3857,  1787,  3858,  2219,  1788,  3862,  3863,  2980,  1614,  2976,
    1221,  2405,  1792,  2400,  2981,  4069,  2993,  2946,  3406,  3761,
    4083,  1615,  2946,  2959,  3460,  2946,  2671,   555,   777,  1113,
    4073,  3377,  2220,  3870,  2221,  2805,  3367,  3335,  4215,   556,
    3340,  3341,  3342,  3343,  3344,  3345,  3346,  3347,  3348,  3349,
     614,  2222,  4216,  4223,  2835,  2946,  3887,  2971,  2970,  2923,
     557,  3456,  2921,   777,  2357,  1222,  1795,  1223,     0,  4095,
       0,     0,     0,   558,     0,     0,  2223,  1224,     0,     0,
       0,     0,     0,  3908,     0,  1225,   559,     0,     0,     0,
    3998,     0,     0,     0,  1226,     0,  1617,     0,     0,  3389,
    3390,     0,  4121,   560,  3709,  3709,  3709,  3709,     0,     0,
       0,     0,  3983,  3985,  3985,     0,     0,     0,     0,     0,
    2805,   805,  2805,     0,   561,  1296,   680,   754,   737,  1228,
       0,   742,     0,   745,     0,   742,     0,     0,     0,     0,
       0,   779,   562,     0,   858,     0,     0,     0,     0,     0,
       0,   742,     0,   563,  1297,     0,     0,     0,   564,     0,
       0,     0,     0,     0,   565,  2939,     0,     0,     0,  2946,
    2939,     0,   737,  2939,     0,  1601,     0,   745,  1602,   566,
       0,   737,     0,     0,   779,     0,  1618,  1619,  1620,  3914,
    1621,  1622,  1623,  1624,  1625,  1626,     0,  3973,     0,   742,
       0,     0,     0,  1605,     0,     0,     0,     0,     0,  1606,
       0,     0,  1230,     0,     0,     0,     0,  2946,     0,     0,
       0,     0,     0,  4057,     0,  3175,     0,     0,     0,     0,
       0,     0,     0,  1607,  1215,     0,     0,     0,     0,     0,
    1216,     0,     0,     0,     0,   680,     0,     0,     0,  2650,
       0,     0,     0,  4013,   567,   680,   970,     0,     0,   614,
       0,     0,     0,     0,   568,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1079,     0,   680,   646,     0,     0,
    1217,   646,   185,     0,     0,     0,     0,     0,     0,     0,
     162,  4030,     0,     0,   680,  2919,     0,     0,   680,     0,
       0,  4099,     0,     0,  1079,     0,     0,   569,     0,     0,
       0,   570,     0,   571,     0,   680,     0,  4262,     0,   572,
       0,     0,   573,  4117,     0,  4119,     0,   680,     0,  1218,
       0,     0,   777, -2169,     0,     0,  1219,  1609,     0,  1220,
       0,     0,     0,     0,     0,     0,     0,     0,   574,     0,
     575,     0,     0,     0,   576,     0,     0,     0,  1610,  1611,
       0,     0,   577,     0,     0,  2939,     0,   578,     0,   680,
       0,  4021,     0,     0, -2169,     0,     0,     0,     0,   579,
       0,     0,   742,   742,     0,     0,     0,     0,  3634,     0,
       0,  1221,   580,     0,     0,     0,     0,  1215,     0,     0,
       0,  1084,  1614,  1216,  4203,     0,     0,     0,     0,     0,
       0,     0,     0,  3985,  2946,  1615,   879,     0,     0,     0,
       0,     0,     0,   737,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   737,     0,     0,   779,     0,     0,     0,
       0,     0,     0,  1217,  4231,     0,  1222,     0,  1223,   742,
       0,     0,     0,     0,     0,  4200,     0,     0,  1224,     0,
       0,     0,     0,   680,     0,     0,  1225,     0,     0,   742,
     742,     0,     0,     0,     0,  1226,  1215,     0,     0,     0,
       0,     0,  1216,   680,   680,   680,   742,     0,   737,     0,
   -2169,  4102,  1218,     0,     0,     0,     0,     0,     0,  1219,
       0,     0,  1220,     0,     0,  2805,  1862,  4234,     0,     0,
    1228,     0,     0,   742,   742,   742,     0,     0,     0,     0,
    2267,     0,  1217,  2267,  2267,  2267,  2267,  2267,  2267,  2267,
    2267,  2267,  2267,     0,     0,  1863,     0,  1079,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4267,
       0,     0,     0,  2267,  1221,     0,  4297,     0,     0,  3735,
    3736,     0,     0,     0,     0,     0,     0,  1492,  1492,     0,
       0,  1218,   680,     0,   623,     0,     0,     0,  1219,     0,
       0,  1220,  2267,  2267,  1621,  1622,  1623,  1624,  1625,  1626,
       0,  1523,     0,  1230,   680,     0,     0,  1529,     0,     0,
       0,     0,     0, -2095,     0,     0,     0,     0,     0,  1222,
    1079,  1223,     0,     0,     0,     0,     0,  4284,     0,     0,
       0,  1224,     0,   162,  4255,   166,  4252,  4253,  4254,  1225,
       0,     0,     0,  1221,     0,     0,     0,     0,  1226,  1079,
       0,     0,     0,     0,  4276,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4283,  4255,
     166,  4252,  4253,  4254,     0,     0,     0,  1079,  1079,  2516,
    1079,     0,     0,  1228,     0,     0,     0,     0,  4275,     0,
       0,  1601,     0,     0,  1602,     0, -2095,  1079,  1222,     0,
    1223,  4276,  1191,     0,     0,     0,     0,     0,  1229,  4276,
    1224,  1603,   162,  4255,   166,  4252,  4253,  4254,  1225,  1605,
       0,     0,     0,     0,     0,  1606,     0,  1226,     0,     0,
       0,     0,     0,   680,  1192,  4275,  1079,     0,     0,     0,
       0,     0, -2095,  4275,     0,     0,     0,     0,     0,  1607,
    1365,     0,     0,     0, -2095,     0,     0,     0, -2095,     0,
       0,     0,  1228, -2095,     0,  1079,  1230,     0, -2095,  1079,
    1079, -2095,     0, -2095,     0,     0,     0,     0,     0,   680,
     680,  1798,     0,     0,     0,     0,     0,  1229,     0,  1193,
       0,     0,     0,     0,     0,     0,     0,   646,     0,     0,
   -2095,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1194, -2095,     0,     0,     0,     0,     0,     0,     0,   646,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   680,  1903,     0,     0,  1230,     0,     0,   680,  1608,
       0,   742,     0,  1609,     0,  1195,     0, -2095,     0,     0,
       0,  2759,     0,     0,     0, -2095,  1601,     0,     0,  1602,
     779,     0,     0,     0,  1610,  1611,  1365,   680,     0,     0,
    1191,  2267,     0,     0,  1196,     0,  1603,     0,     0,     0,
    1612,     0,     0,  1601,  1605,     0,  1602,   680,     0,     0,
    1606,     0,     0,  3928,     0,   742,   742,   742,   742,   680,
   -2095,  1197,  1192,  1603,     0,  1613,     0,     0,  1614,     0,
       0,  1605,   680,     0,  1607,     0,     0,  1606,     0,  3944,
    3945,  1615,     0,  2009,  1616,   680,     0,     0,     0,     0,
       0,     0,  1198,   742,   742,     0,    32,     0,     0,   742,
    1199,  1607,     0,     0,     0,   627,  1200,     0,     0,     0,
       0,     0,     0,  1201,     0,     0,     0,  1193,     0,     0,
       0,  1202,     0,     0,     0,     0,     0,     0,     0, -2095,
    1203,     0,     0,     0,     0,     0,     0,     0,  1204,     0,
       0,     0,     0,     0,     0,   742,     0,     0,  1194,     0,
       0,     0, -2095,     0, -2095, -2095,  1617,  1651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   742,
     742,   742,   742,     0,  1608,     0,     0,  2760,  1609,     0,
       0,     0,     0,  1195,     0,     0,     0, -2095,  2009,  1205,
   -2095, -2095, -2095,     0,     0,     0,     0,   737,     0,  1610,
    1611,  1608,  2267,  2267,   745,  1609,   737,     0,     0,     0,
       0,     0,  1196,     0,     0,  1612,   779,     0,     0,  1365,
       0,   742,     0,     0,     0,     0,  1610,  1611,     0,     0,
     742,     0,     0,     0,     0,     0,   742,   742,     0,     0,
    1613,   680,  1612,  1614,     0,     0,  1618,  1619,  1620,     0,
    1621,  1622,  1623,  1624,  1625,  1626,  1615,     0,  2376,  1616,
       0,     0,     0,     0,  2377,     0,  1492,  1613,  4070,     0,
    1614,     0,  1365,   742,    32,   737,     0,     0,  2761,   680,
     680,     0,   742,  1615,  1200,     0,  1616,     0,   680,     0,
       0,  1201,     0,     0,     0,     0,     0,     0,  2759,  1880,
       0,   623,   623,  1365,     0,  2209,     0,     0,  1203,  1079,
       0,  1079,     0,     0,     0,     0,  1204,  1191,  1079,     0,
       0,  1079,     0,     0,     0,  1079,     0,     0,     0,     0,
       0,  1617,     0,  1079,  1079,     0,     0,     0,     0,     0,
       0,  1079,     0,   779,  1079,  1079,  1079,  1079,     0,  1192,
       0,     0,     0,     0,  1079,  1079,     0,  1079,  1617,  1079,
    1079,     0,     0,  1079,     0,     0,     0,  1205,     0,     0,
       0,  2762,  1365,     0,     0,     0,     0,     0,     0,     0,
    1079,     0,     0,     0,   742,  1079,     0,     0,     0,  1079,
       0,  1365,     0,  1079,     0,  1079,  1079,  1079,  1079,  1079,
    1079,  1079,  1079,  1079,  1193,  1079,     0,     0,     0,   680,
    1079,  1365,  1079,     0,     0,     0,     0,     0,   680,     0,
       0,  1618,  1619,  1620,     0,  1621,  1622,  1623,  1624,  1625,
    1626,     0,     0,     0,     0,  1194,  1365,     0,  2850,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1618,  1619,
    1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,     0,     0,
       0,     0,     0,     0,  2760,  2898,     0,     0,     0,     0,
    1195,     0,     0,     0,     0,     0,     0,  1600,     0,     0,
    1215,     0,  1601,     0,     0,  1602,  1216,     0,  1365,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1196,
       0,     0,  1603,     0,     0,  1604,     0,     0,     0,     0,
    1605,     0,     0,     0,     0,     0,  1606,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1217,     0,     0,     0,
       0,     0,     0,   680,     0,   680,  2267,  1079,     0,     0,
    1607,     0,     0,     0,     0,  2267,  1215,     0,     0,     0,
       0,     0,  1216,     0,     0,     0,     0,     0,     0,     0,
       0,    32,  2267,  2267,     0,  1199,     0,     0,     0,     0,
       0,  1200,     0,     0,  2413,  1218,  2420,     0,  1201,     0,
       0,     0,  1219,     0,  1601,  1220,  1880,  1602,     0,     0,
       0,   745,  1217,     0,     0,  1203,   623,     0,   623,     0,
       0,     0,     0,  1204,  1603,     0,     0,     0,     0,     0,
       0,  1601,  1605,     0,  1602,  1079,     0,     0,  1606,     0,
       0,   737,     0,   742,   742,   742,     0,   737,   779,     0,
     742,  1603,   742,     0,   742,   742,     0,  1221,   680,  1605,
    1608,  1218,  1607,     0,  1609,  1606,     0,     0,  1219,     0,
       0,  1220,     0,     0,  1205,     0,     0,   646,  2762,     0,
       0,     0,     0,     0,  1365,  1610,  1611,     0,     0,  1607,
       0,     0,     0,     0,     0,     0,  1903,     0,     0,     0,
       0,  1612,  2520,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,  1222,   680,  1223,     0,     0,     0,     0,     0,
       0,     0,     0,  1221,  1224,     0,  1613,     0,     0,  1614,
    2560,  2560,  1225,     0,     0,     0,     0,   745,     0,     0,
     646,  1226,  1615,     0,     0,  1616,     0,     0,     0,     0,
       0,     0,     0,   742,     0,     0,     0,     0,     0,     0,
       0,     0,  1608,     0,     0,     0,  1609,     0,     0,     0,
       0,  2267,  2592,     0,     0,     0,  1228,     0,  1222,  2617,
    1223,  2619,  2621,     0,     0,     0,     0,  1610,  1611,  1608,
    1224,     0,     0,  1609,     0,     0,     0,     0,  1225,     0,
       0,  2593,     0,  1612,     0,     0,     0,  1226,     0,     0,
     742,     0,     0,     0,  1610,  1611,     0,  1617,   742,   742,
     742,   742,   742,   742,     0,     0,     0,     0,  1613,     0,
    1612,  1614,     0,  1079,     0,     0,     0,     0,  2630,     0,
       0,     0,  1228,     0,  1615,     0,     0,  1616,     0,     0,
       0,     0,     0,     0,     0,  1613,     0,     0,  1614,  1230,
    1903,     0,     0,     0,  2560,   680,     0,  2631,     0,   623,
    1601,  1615,     0,  1602,  1616,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1603,     0,     0,     0,     0,  2617,     0,     0,  1605,     0,
       0,     0,   742,  2747,  1606,     0,     0,  1618,  1619,  1620,
       0,  1621,  1622,  1623,  1624,  1625,  1626,     0,     0,  1617,
       0,     0,     0,     0,     0,  1230,     0,   742,  1607,   742,
    2560,   742,  2560,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1617,     0,     0,     0,
       0,  1079,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1492,     0,     0,     0,     0,  1365,     0,
       0,     0,     0,  1365,  1365,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1365,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   737,     0,  1618,
    1619,  1620,   737,  1621,  1622,  1623,  1624,  1625,  1626,     0,
       0,     0,   742,  2297,     0,     0,     0,     0,  1608,  1079,
    1079,     0,  1609,     0,     0,  1079,  1618,  1619,  1620,     0,
    1621,  1622,  1623,  1624,  1625,  1626,     0,     0,  3444,     0,
    1357,     0,     0,  1610,  1611,     0,     0,     0,     0,     0,
    1079,  1079,     0,     0,     0,  1079,     0,     0,     0,  1612,
       0,     0,     0,     0,     0,     0,     0,  1079,  1079,  1079,
    1079,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1079,     0,     0,  1079,  1613,  1079,  2902,  1614,     0,     0,
       0,     0,     0,     0,  1601,  1079,  1079,  1602,     0,  1079,
    1615,     0,     0,  1616,     0,     0,     0,     0,     0,  -115,
    1365,     0,  1079,     0,  1079,     0,   779,     0,  1079,     0,
       0,     0,  1605,     1,     0,     0,     0,     0,  1606,     0,
       0,     0,     0,     2,  1079,     3,     4,     0,   680,     0,
       0,     0,     0,     0,     0,  2947,     0,  1079,  1079,  1079,
       5,     0,  1607,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1079,     0,  1357,     0,     0,     0,
       6,     0,     7,     8,     0,  1617,  1079,     0,     9,  1601,
      10,  1079,  1602,     0,  1365,   680,     0,     0,  1079,     0,
      11,     0,    12,     0,  2947,     0,     0,  2987,     0,     0,
       0,  2420,     0,     0,     0,     0,     0,  1605,    13,     0,
       0,    14,     0,  1606,  3391,     0,     0,     0,     0,     0,
       0,     0,     0,    15,     0,    16,     0,     0,     0,    17,
       0,  1079,     0,  2560,     0,    18,     0,  1607,  1492,     0,
       0,     0,    19,     0,    20,  1215,     0,     0,     0,     0,
      21,  1216, -2169,     0,     0,     0,  1609,     0,     0,   742,
       0,   742,   742,     0,    22,  1618,  1619,  1620,  1365,  1621,
    1622,  1623,  1624,  1625,  1626,     0,  1251,  1610,  1611,  3179,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1217,     0, -2169,     0,     0,     0,     0,     0,  3392,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    23,    24,
       0,  1614,  1252,     0,    25,     0,     0,     0,     0,     0,
       0,     0,    26,     0,  1615,     0,     0, -2169,     0,     0,
    1218,  1609,     0,    27,     0,     0,     0,  1219,     0,     0,
    1220,     0,     0,     0,     0,     0,     0,     0,     0,  1357,
       0,     0,  1610,  1611,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2169,     0,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    29,     0,     0,     0,     0,    30,     0,    31,  1253,
       0,     0,  1221,    32,     0,     0,  1614,     0,    33, -2169,
       0,    34,  1357,     0,     0,    35,     0,     0,     0,  1615,
      36,    37,     0,     0,     0,     0,     0,     0,    38,     0,
       0,    39,  2560,  2560,     0,     0,     0,     0,     0,    40,
       0,     0,     0,  1357,     0,  1254,     0,  1255,     0,     0,
       0,    41,     0,     0,     0,     0,     0,  1256,     0,  1223,
       0,     0,     0,     0,     0,     0,     0,     0,    42,  1224,
       0,     0,     0,     0,     0,     0,     0,  1225,    43,     0,
       0,     0,     0,     0,    44,  1257,  1226,     0,     0,    45,
     680,     0,     0,     0, -2169,     0,     0,     0,     0,     0,
       0,    46,     0,  1621,  1622,  1623,  1624,  1625,  1626,     0,
       0,     0,  1357,     0,  1492,   680,     0,  1258,     0,     0,
       0,  1228,  1259,   680,     0,     0,     0,   680,     0,     0,
       0,  1357,     0,     0,     0,    47,     0,     0,  -115,  1365,
       0,   680,     0,     0,     0,     0,  1260,     0,     0,     0,
       0,  1357,     0,     0,     0,     0,     0,  1261,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   742,
       0,  1215,   742,     0,     0,     0,  1357,  1216,     0,  1365,
    1365,     0,  1365,     0,     0,     0,   737,     0,  1621,  1622,
    1623,  1624,  1625,  1626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1230,   680,     0,     0,     0,     0,
       0,     0,     0,   742,     0,     0,     0,  1217,     0,     0,
       0,  1079,     0,     0,     0,     0,     0,     0,  1357,     0,
       0,  1079,     0,     0,  1365,     0,  1365,  1079,     0,  1079,
       0,     0,     0,     0,     0,  1079,     0,     0,  1079,  1079,
    1079,  1079,  1079,  1079,  1079,  1079,  1079,  1079,     0,     0,
       0,  1079,  1079,     0,     0,     0,  1218,     0,     0,     0,
       0,     0,     0,  1219,  1079,     0,  1220,     0,  1079,     0,
       0,     0,  1079,     0,     0,     0,     0,     0,     0,  1365,
       0,     0,  1079,     0,     0,  1079,     0,  1079,     0,     0,
       0,     0,     0,     0,     0,     0,  1079,  1079,  1079,     0,
       0,     0,  1079,  1365,     0,  1079,     0,     0,     0,     0,
       0,     0,   680,   680,   680,  2947,  3409,     0,  1221,     0,
    3409,  3422,     0,     0,     0,  1079,  1215,     0,  1365,     0,
       0,  3436,  1216,  1079,     0,  1079,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1365,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1251,     0,  1079,
       0,     0,     0,     0,     0,  1079,     0,     0,     0,  2420,
       0,  1079,  1217,  1222,     0,  1223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1224,  3476,  1492,  1492,     0,
    2009,     0,     0,  1225,  1357,     0,     0,     0,     0,     0,
       0,     0,  1226,  1252,   742,   742,   742,   742,     0,  1365,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1218,     0,  1365,     0,     0,     0,     0,  1219,  1601,
       0,  1220,  1602,  3041,  1365,     0,     0,  1228,   806,     0,
       0,     0,  3519,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1605,     0,     0,
       0,     0,  3042,  1606,     0,     0,     0,     0,   739,     0,
       0,   807,     0,     0,     0,     0,   739,   758,     0,     0,
    1253,     0,   758,  1221,   808,   809,     0,  1607,     0,     0,
       0,   758,     0,   810,     0,     0,     0,   811,     0,  1365,
       0,     0,     0,     0,     0,  1601,     0,  3574,  1602,     0,
       0,     0,     0,     0,   812,     0,     0,     0,     0,  1365,
    1230,     0,     0,     0,     0,  1603,  1254,     0,  1255,     0,
       0,     0,     0,  1605,     0,   813,     0,     0,  1256,  1606,
    1223,     0,     0,     0,  1365,     0,     0,     0,     0,  3395,
    1224,     0,     0,   814,     0,     0,     0,     0,  1225,     0,
       0,     0,     0,  1607,   815,     0,  1257,  1226,     0,   816,
       0,     0,     0,   680,     0,     0,     0,     0,     0,     0,
    1365,     0,     0,     0,   742,     0,  1079, -2169,     0,     0,
     817,  1609,   680,     0,     0,     0,     0,     0,  2580,     0,
       0,     0,  1228,  1259,  1903,     0,     0,     0,     0,     0,
       0,     0,  1610,  1611,   680,   818,     0,     0,     0,     0,
       0,     0,     0,  2617,     0,     0,     0,  2581, -2169,  3667,
       0,     0,     0,  1903,     0,     0,     0,     0,  1261,     0,
       0,     0,     0,     0,     0,  1079,  1079,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1614,     0,     0,     0,
       0,     0,     0,  1608,     0,   819,     0,  1609,  2560,  1615,
    2560,     0,     0,     0,     0,     0,     0,     0,  1357,     0,
       0,     0,     0,  1357,  1357,  1230,     0,     0,  1610,  1611,
       0,     0,     0,   185,     0,  1357,     0,     0,     0,     0,
       0,     0,  1079,     0,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   820,     0,
       0,     0,   821,     0,   822,     0,     0,     0,     0,  1613,
     823,     0,  1614,   824,     0,     0,     0,     0,     0,  1079,
       0,     0,  1365,     0, -2169,  1615,     0,     0,  1616,  1079,
    1079,  1601,     0,     0,  1602,     0,     0,  1079,  1079,   825,
       0,   826,  1079,     0,     0,   827,     0,     0,  1079,  1079,
       0,  1603,  1079,   828,   680,   680,   680,   680,   829,  1605,
       0,  3409,     0,     0,  3752,  1606,     0,  2947,     0,     0,
       0,  2947,     0,     0,     0,     0,     0,  3765,     0,     0,
    1079,     0,     0,   830,     0,  1079,     0,   739,     0,  1607,
       0,  3775,     0,     0,     0,     0,     0,  1079,   758,     0,
    1617,     0,   758,   779,     0,     0,     0,     0,     0,     0,
    1357,  2987,     0,   758,     0,  2420,     0,     0,  1621,  1622,
    1623,  1624,  1625,  1626,     0,   623,     0,   758,  1079,     0,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
     739,   758,     0,     0,     0,   758,     0,     0,  2560,  2560,
       0,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,   758,     0,     0,     0,     0,  2874,     0,
       0,     0,  3820,  2875,     0,     0,  1365,     0,     0,     0,
       0,     0,     0,     0,  1357,     0,     0,     0,     0,  1608,
    1618,  1619,  1620,  1609,  1621,  1622,  1623,  1624,  1625,  1626,
       0,     0,     0,     0,  3329,     0,     0,     0,   172,  1365,
       0,     0,   742,     0,  1610,  1611,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   742,     0,     0,     0,
    1612,     0,     0,   739,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   173,  1613,     0,     0,  1614,     0,
    1492,     0,     0,   739,     0,     0,     0,   174,  1357,     0,
       0,  1615,     0,     0,  1616,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   175,     0,     0,     0,  1079,     0,
     176,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   177,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   742,  1903,  1365,     0,     0,
       0,     0,     0,   178,     0,     0,     0,     0,  1365,     0,
       0,     0,     0,     0,   179,     0,     0,     0,     0,   180,
       0,     0,     0,   680,     0,   181,  1617,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     182,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1079,     0,     0,     0,     0,     0,     0,     0,     0,
    1079,     0,   739,     0,     0,   183,     0,     0,     0,     0,
       0,     0,   739,     0,     0,     0,     0,  1079,  1079,     0,
       0,  1079,     0,     0,     0,     0,     0,     0,  3409,     0,
       0,     0,  2947,     0,  1367,     0,     0,  2947,     0,     0,
    2947,  2617,     0,  3960,     0,  1079,  1079,     0,     0,     0,
       0,  1365,     0,     0,     0,   184,  1618,  1619,  1620,     0,
    1621,  1622,  1623,  1624,  1625,  1626,     0,   739,     0,     0,
    3476,   779,   742,   742,   742,     0,     0,     0,     0,  1365,
       0,     0,     0,   185,     0,     0,     0,     0,     0,     0,
       0,  1365,     0,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,   737,   779,     0,   186,     0,
       0,     0,   758,     0,   187,     0,   739,     0,     0,     0,
     188,     0,     0,   189,   758,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1365,  1492,     0,     0,     0,
       0,     0,   737,     0,     0,   680,     0,     0,     0,   190,
       0,   191,   758,     0,     0,   192,  2560,     0,  1903,  1357,
    1367,     0,   758,   193,     0,     0,     0,     0,   194,     0,
    3667,     0,     0,     0,   758,   680,     0,   758,     0,     0,
     195,     0,     0,   742,  3476,     0,     0,     0,     0,   739,
       0,     0,     0,   196,     0,     0,     0,     0,     0,  1357,
    1357,     0,  1357,     0,     0,     0,  1079,     0,     0,  1079,
       0,  1079,     0,     0,     0,     0,     0,     0,   739,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1079,     0,
       0,     0,  2947,     0,     0,  3960,     0,     0,     0,     0,
       0,  4089,     0,     0,     0,     0,   739,   739,     0,   739,
       0,     0,     0,     0,  1357,     0,  1357,     0,     0,     0,
       0,   742,     0,     0,     0,   680,   739,     0,     0,     0,
       0,     0,     0,  1601,     0,     0,  1602,     0,     0,     0,
    1365,     0,   742,   742,   742,   742,     0,     0,   758,     0,
       0,     0,     0,  1603,     0,     0,   758,   758,     0,     0,
       0,  1605,     0,     0,     0,   739,  1748,  1606,     0,  1357,
       0,     0,  1079,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1607,     0,  1357,   739,     0,     0,     0,   739,   739,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1367,     0,     0,     0,     0,  1357,  1748,
       0,     0,     0,     0,     0,     0,     0,  1079,     0,     0,
       0,     0,     0,   742,     0,   779,  1357,     0,     0,     0,
       0,     0,     0,     0,  1079,     0,  1365,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1367,     0,     0,     0,
       0,     0,     0,     0,     0,   742,     0,     0,     0,   737,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3476,
       0,  1608,     0,     0,     0,  1609,     0,  1367,     0,  1357,
       0,     0,     0,  4089,     0,     0,  1079,  1079,     0,     0,
       0,     0,     0,  1357,     0,     0,  1610,  1611,     0,   737,
       0,     0,     0,     0,  1357,     0,     0,   742,     0,     0,
       0,  1365,  1612,  1601,     0,     0,  1602,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   758,     0,     0,
       0,     0,  1365,  1603,  1079,     0,     0,  1613,     0,     0,
    1614,  1605,     0,     0,  1079,     0,  1367,  1606,     0,   742,
       0,     0,     0,  1615,     0,     0,  1616,     0,     0,     0,
       0,     0,  1365,     0,     0,  1367,     0,     0,     0,  1357,
       0,  1607,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1367,     0,     0,     0,  1357,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1365,
       0,     0,  1079,  1365,  1365,  1748,     0,     0,     0,     0,
    1367,   737,     0,     0,  1357,     0,     0,     0,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,  1617,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1357,     0,     0,     0,     0,     0,   739,     0,     0,     0,
       0,     0,  1367,     0,     0,   739,     0,   758,   758,     0,
       0,  1608,     0,     0,     0,  1609,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     758,   758,     0,     0,     0,     0,  1610,  1611,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1612,     0,     0,     0,     0,     0,  1618,  1619,
    1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,     0,     0,
       0,     0,  3376,     0,   739,     0,     0,  1613,     0,     0,
    1614,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1615,     0,     0,  1616,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   739,     0,
     739,     0,     0,     0,     0,     0,     0,   739,     0,     0,
     739,     0,     0,     0,   739,     0,     0,     0,     0,     0,
       0,     0,   739,   739,     0,     0,     0,     0,     0,     0,
     739,     0,     0,   739,   739,   739,   739,  1366,     0,     0,
       0,     0,  1357,   739,   739,     0,   739,     0,   739,   739,
       0,     0,   739,     0,     0,     0,     0,     0,  1617,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1367,   739,
    1748,     0,     0,     0,   739,     0,     0,     0,   739,     0,
       0,     0,   739,     0,   739,   739,   739,   739,   739,   739,
     739,   739,   739,     0,   739,     0,     0,     0,     0,   739,
       0,   739,     0,     0,     0,     0,  1601,     0,     0,  1602,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1603,     0,     0,     0,
       0,     0,     0,     0,  1605,     0,     0,     0,     0,     0,
    1606,     0,     0,     0,  1601,     0,     0,  1602,  1618,  1619,
    1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,     0,     0,
       0,     0,  3448,  1366,  1607,     0,     0,     0,     0,     0,
       0,     0,  1605,     0,     0,     0,     0,     0,  1606,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1357,     0,     0,     0,
       0,     0,  1607,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   739,     0,     0,  1357,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1359,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1601,     0,     0,  1602,     0,     0,
       0,     0,     0,     0,  1608,     0,     0,     0,  1609,     0,
       0,   758,     0,     0,  1603,  1748,   758,     0,     0,   758,
       0,     0,  1605,  1601,     0,     0,  1602,     0,  1606,  1610,
    1611,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   758,  1608,  1603,   739,  1612,  1609,     0,     0,     0,
     739,  1605,  1607,     0,     0,     0,   739,  1606,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1610,  1611,     0,
    1613,     0,     0,  1614,     0,   758,     0,  1357,     0,     0,
       0,  1607,     0,  1612,     0,     0,  1615,     0,  1357,  1616,
       0,     0,  1367,     0,     0,     0,  1366,  1367,  1367,     0,
       0,     0,   758,   758,     0,     0,     0,     0,  1613,  1367,
    1359,  1614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1615,  1748,   758,     0,  1748,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   758,     0,  1895,
       0,   758,  1608,     0,     0,     0,  1609,     0,     0,     0,
       0,  1617,     0,     0,     0,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,  1610,  1611,   758,
    1366,  1608,     0,     0,     0,  1609,     0,     0,     0,     0,
       0,  1357,   758,  1612,     0,     0,     0,     0,     0,  1617,
       0,   758,     0,     0,     0,     0,  1610,  1611,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1613,  1357,
       0,  1614,  1612,     0,     0,     0,     0,     0,     0,     0,
       0,  1357,     0,     0,  1615,     0,     0,  1616,     0,     0,
       0,     0,   739,     0,  1367,     0,     0,  1613,     0,  1366,
    1614,  1618,  1619,  1620,     0,  1621,  1622,  1623,  1624,  1625,
    1626,     0,     0,  1615,     0,  3470,  1616,     0,  1366,     0,
       0,     0,     0,     0,     0,  1357,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1366,  1618,
    1619,  1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,     0,
       0,     0,     0,  1359,     0,     0,     0,     0,     0,  1617,
       0,     0,     0,  1366,     0,     0,     0,     0,  1367,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1617,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   758,  1359,     0,     0,     0,
     739,     0,     0,     0,     0,  1366,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1359,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,  1618,
    1619,  1620,  1367,  1621,  1622,  1623,  1624,  1625,  1626,     0,
       0,     0,   758,  3712,     0,     0,   739,     0,     0,     0,
    1357,   739,     0,     0,     0,     0,     0,     0,  1618,  1619,
    1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,   739,   739,
       0,     0,  3746,     0,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1359,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   739,
     739,     0,     0,     0,   739,  1359,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   739,   739,   739,   739,
       0,     0,     0,     0,  1748,  1359,     0,     0,     0,   739,
    1748,     0,   739,     0,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   739,   739,     0,     0,   739,     0,
    1359,     0,     0,     0,     0,     0,  1357,     0,     0,     0,
       0,   739,     0,   739,     0,  1601,     0,   739,  1602,     0,
       0,  1366,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   739,     0,  1603,     0,     0,     0,     0,
       0,     0,     0,  1605,   739,     0,   739,   739,   739,  1606,
       0,     0,  1359,     0,  2369,     0,     0,     0,     0,     0,
     758,     0,     0,   739,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1607,     0,   739,     0,     0,     0,     0,
     739,     0,     0,     0,     0,  1601,     0,   739,  1602,     0,
       0,  1357,     0,   739,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1603,     0,     0,     0,   758,
       0,     0,  1357,  1605,     0,     0,     0,     0,     0,  1606,
       0,     0,     0,     0,   758,   758,     0,     0,     0,     0,
     739,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1357,  1607,     0,     0,     0,     0,     0,     0,
     758,     0,     0,  1367,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     544,     0,     0,  1608,     0,     0,   584,  1609,     0,  1357,
       0,     0,     0,  1357,  1357,   632,     0,     0,     0,     0,
       0,     0,     0,  1367,  1367,     0,  1367,     0,  1610,  1611,
       0,     0,     0,   692,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1748,  1748,  1748,  1359,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1613,
       0,     0,  1614,  1608,   758,     0,     0,  1609,  1367,     0,
    1367,   758,     0,     0,     0,  1615,     0,     0,  1616,     0,
       0,   758,     0,     0,     0,     0,     0,     0,  1610,  1611,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1367,     0,  2505,     0,     0,     0,  1613,
    1895,  2512,  1614,     0,     0,     0,     0,     0,     0,     0,
       0,   758,  1366,     0,     0,  1615,     0,  1367,  1616,     0,
    1617,     0,     0,     0,     0,   749,     0,     0,     0,     0,
       0,     0,     0,     0,   781,     0,   784,     0,   787,  1748,
     789,     0,  1367,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1748,
    1367,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   758,     0,   758,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   758,     0,   758,     0,     0,
    1617,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1601,     0,     0,  1602,     0,     0,
    1618,  1619,  1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,
       0,     0,     0,  1367,  3938,     0,     0,     0,     0,     0,
       0,     0,  1605,     0,     0,     0,   758,  1367,  1606,     0,
       0,     0,     0,     0,     0,     0,     0,  1366,  1367,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1607,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   739,     0,     0,   758,     0,
    1618,  1619,  1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,
       0,     0,     0,   758,  3978,     0,   758,     0,     0,     0,
       0,     0,  1359,     0,     0,     0,     0,  1359,  1359,     0,
     739,     0,     0,  1367,     0,     0,     0,     0,     0,  1359,
     739,  1895,     0,     0,  3744,     0,   739,     0,   739,     0,
       0,     0,     0,  1367,   739,     0,     0,   739,   739,   739,
     739,   739,   739,   739,   739,   739,   739,     0,     0,     0,
     739,   739,     0,     0,     0,     0,     0,     0,  1367,     0,
       0,     0, -2169,   739,     0,     0,  1609,   739,     0,  1748,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   739,     0,     0,   739,     0,   739,  1610,  1611,     0,
       0,     0,     0,     0,  1367,   739,   739,   739,     0,     0,
       0,   739,     0, -2169,   739,  1366,     0,     0,     0,     0,
       0,     0,     0,     0,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   739,     0,     0,     0,     0,     0,
       0,  1614,   739,     0,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1615,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1359,     0,     0,     0,   739,   837,
       0,     0,     0,     0,   739,     0,   844,     0,     0,     0,
     739,     0,     0,     0,     0,   859,   860,     0,     0,     0,
     862,     0,     0,     0,     0,   739,     0,     0,     0,     0,
     876,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,   758,     0,     0,     0,     0,   905,     0, -2169,
     907,     0,   909,     0,   912,     0,     0,     0,  1359,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1601,
       0,     0,  1602,     0,     0,     0,     0,     0,     0,     0,
       0,  1748,     0,     0,     0,  1748,  1367,  1748,     0,  1603,
       0,     0,     0,     0,     0,     0,     0,  1605,     0,  2369,
    2369,  2369,     0,  1606,     0,     0,     0,     0,     0,     0,
       0,   967,     0,   968,     0,     0,     0,     0,     0,   758,
       0,     0,   758,     0,     0,     0,     0,  1607,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1359,  1621,  1622,  1623,  1624,  1625,  1626,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   758,     0,     0,     0,   692,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1366,     0,     0,     0,
       0,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1608,     0,     0,
       0,  1609,     0,     0,     0,     0,   758,   758,     0,     0,
    1367,     0,     0,     0,     0,     0,  1895,  2512,     0,  2512,
       0,     0,  1610,  1611,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1601,     0,  1612,  1602,
       0,     0,  1299,  1367,   739,   739,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1603,  1311,     0,     0,
       0,     0,     0,  1613,  1605,     0,  1614,     0,  1319,     0,
    1606,  1366,     0,  1366,     0,  1321,     0,     0,     0,  1615,
       0,     0,  1616,     0,     0,   758,     0,  1371,     0,     0,
       0,     0,     0,     0,  1607,     0,     0,     0,     0,     0,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,     0,  1413,
       0,   759,     0,     0,     0,     0,  1366,     0,     0,     0,
     759,     0,     0,     0,     0,     0,     0,     0,   739,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   739,   739,
    1366,  1367,     0,     0,  1617,     0,   739,   739,     0,     0,
       0,   739,  1367,     0,     0,     0,     0,   739,   739,  1601,
       0,   739,  1602,     0,     0,  2512,     0,     0,     0,     0,
       0,     0,     0,  1359,     0,     0,   739,     0,     0,  1603,
     739,     0,     0,  2512,  1608,     0,     0,  1605,  1609,   739,
       0,     0,     0,  1606,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   739,     0,     0,  1610,
    1611,     0,     0,  1359,  1359,     0,  1359,  1607,     0,     0,
       0,     0,     0,     0,     0,  1612,     0,     0,     0,     0,
       0,     0,     0,     0,  1618,  1619,  1620,   739,  1621,  1622,
    1623,  1624,  1625,  1626,     0,     0,  1366,     0,  4023,     0,
    1613,     0,     0,  1614,     0,  1367,     0,     0,     0,     0,
    2512,     0,     0,     0,     0,     0,  1615,     0,  1359,  1616,
    1359,  1366,     0,     0,  1748,     0,     0,     0,     0,     0,
       0,     0,     0,  1367,     0,     0,     0,     0,     0,     0,
     758,     0,     0,     0,     0,  1367,     0,     0,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1608,     0,     0,
       0,  1609,     0,  1359,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1366,     0,     0,  1367,
       0,  1617,  1610,  1611,     0,     0,     0,  1359,     0,     0,
       0,     0,     0,     0,     0,     0,  1366,     0,  1612,  1748,
       0,   758,     0,     0,   692,  1763,     0,     0,     0,     0,
       0,     0,  1359,     0,     0,     0,     0,     0,     0,     0,
       0,  1366,     0,  1613,     0,     0,  1614,     0,     0,     0,
    1359,     0,     0,     0,     0,     0,     0,   739,     0,  1615,
       0,     0,  1616,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1366,     0,     0,
       0,     0,     0,     0,  1601,  1860,     0,  1602,     0,     0,
       0,  1618,  1619,  1620,     0,  1621,  1622,  1623,  1624,  1625,
    1626,     0,     0,     0,  1603,  4202,     0,   759,  2390,  1367,
       0,   759,  1605,  1359,     0,     0,     0,  2369,  1606,     0,
       0,     0,   759,     0,     0,     0,     0,  1359,   758,     0,
       0,     0,     0,     0,  1617,     0,   759,     0,  1359,     0,
     739,     0,  1607,     0,  1367,     0,     0,     0,  1601,   739,
     759,  1602,     0,     0,   759,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,   739,   739,  1603,     0,
     739,     0,   759,     0,     0,     0,  1605,     0,     0,     0,
       0,   739,  1606,     0,     0,     0,   739,  2391,     0,   739,
       0,     0,     0,     0,   739,   739,     0,     0,     0,     0,
       0,     0,     0,  1359,     0,     0,  1607,     0,     0,     0,
       0,     0,     0,   758,     0,   758,     0,     0,     0,   739,
       0,     0,     0,  1359,  1618,  1619,  1620,     0,  1621,  1622,
    1623,  1624,  1625,  1626,     0,     0,     0,     0,  4286,  2512,
       0,     0,  1608,     0,     0,     0,  1609,   759,  1359,     0,
    1367,     0,     0,     0,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1610,  1611,     0,
       0,     0,     0,     0,  2061,     0,     0,     0,     0,     0,
       0,     0,     0,  1612,  1359,     0,     0,  2083,     0,     0,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1608,     0,  1613,     0,
    1609,  1614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1615,  2125,     0,  1616,     0,     0,
       0,  1610,  1611,   739,     0,  1367,     0,     0,     0,     0,
    2140,     0,  2142,     0,  2143,     0,     0,  1612,     0,  2144,
       0,     0,     0,     0,     0,   739,  1367,     0,   739,     0,
     739,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1613,     0,     0,  1614,     0,   739,     0,     0,
       0,   739,     0,     0,     0,     0,  1367,     0,  1615,     0,
       0,  1616,  1763,  1366,     0,     0,  1763,     0,  1763,  1617,
       0,  1763,     0,     0,     0,     0,     0,     0,     0,     0,
    3368,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1748,     0,     0,  1367,     0,     0,  1895,  1367,  1367,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   758,     0,     0,     0,     0,  1359,     0,     0,     0,
    2392,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   739,     0,  1617,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3369,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,  1367,  1618,
    1619,  1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,     0,
       0,   759,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,     0,   739,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   739,  1366,     0,     0,     0,     0,     0,
       0,   759,     0,     0,     0,  1366,     0,     0,     0,     0,
       0,   759,     0,  1618,  1619,  1620,     0,  1621,  1622,  1623,
    1624,  1625,  1626,   759,     0,     0,   759,     0,   739,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   739,     0,
       0,     0,  2369,     0,     0,     0,     0,  2369,     0,     0,
       0,     0,     0,     0,     0,   739,   739,     0,   758,  2369,
    1359,     0,     0,     0,     0,     0,     0,     0,   739,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1359,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   739,     0,     0,     0,     0,  1366,     0,
       0,     0,     0,   739,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1748,
       0,     0,     0,     0,     0,     0,  1366,   759,     0,     0,
       0,     0,     0,     0,     0,   759,   759,     0,  1366,     0,
       0,     0,     0,     0,     0,  1749,     0,     0,     0,     0,
       0,     0,     0,  2427,  2428,     0,     0,     0,  2431,  2432,
       0,   739,  2435,     0,     0,     0,  1748,     0,     0,     0,
     739,     0,  2445,     0,  1748,     0,     0,     0,     0,  2454,
       0,     0,  1366,  2457,  2458,     0,     0,  2461,  2462,  2463,
       0,  1359,     0,     0,     0,     0,     0,     0,  1749,  2477,
       0,  2479,  1359,     0,     0,     0,     0,     0,  1601,     0,
       0,  1602,     0,     0,     0,     0,     0,  2501,  1601,     0,
       0,  1602,  2503,     0,     0,     0,     0,     0,  1603,     0,
       0,     0,     0,     0,     0,     0,  1605,     0,  1603,     0,
       0,  2837,  1606,     0,     0,     0,  1605,     0,     0,     0,
       0,     0,  1606,  2521,  2522,  2525,  2527,     0,     0,     0,
    2534,  2537,     0,     0,     0,     0,  1607,     0,  2548,     0,
       0,  2552,     0,     0,     0,  2556,  1607,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3912,  2579,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2586,  1359,  2588,     0,     0,     0,
       0,  2591,     0,     0,     0,     0,  2595,  2596,  2597,  2598,
       0,  2600,     0,     0,     0,     0,   759,  1366,     0,     0,
       0,     0,     0,  1359,  2623,  2624,  2625,     0,     0,     0,
       0,     0,     0,     0,  4260,  1359,  2633,  2634,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1608,     0,     0,     0,
    1609,     0,     0,     0,     0,     0,  1608,     0,     0,     0,
    1609,     0,     0,     0,     0,     0,     0,     0,     0,  1359,
       0,  1610,  1611,     0,     0,     0,     0,     0,     0,     0,
       0,  1610,  1611,     0,  1749,     0,  2696,  1612,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1612,     0,     0,
       0,   759,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1613,  2512,     0,  1614,     0,   759,     0,     0,
       0,     0,  1613,     0,     0,  1614,     0,     0,  1615,     0,
       0,  1616,     0,     0,     0,     0,     0,     0,  1615,     0,
       0,  1616,     0,     0,     0,     0,   759,   759,  4261,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,  1601,
       0,     0,  1602,     0,     0,     0,     0,     0,     0,   759,
     759,     0,     0,     0,     0,     0,     0,     0,     0,  1603,
       0,   759,     0,     0,     0,     0,     0,  1605,     0,     0,
       0,     0,   760,  1606,     0,     0,     0,   760,  2512,     0,
       0,  1763,     0,  1617,     0,     0,   760,     0,     0,     0,
       0,     0,     0,  1617,  1359,     0,     0,  1607,     0,  1366,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2816,
       0,     0,     0,     0,     0,     0,     0,     0,  1601,     0,
       0,  1602,     0,     0,     0,     0,     0,     0,     0,  1366,
       0,     0,     0,     0,     0,     0,     0,     0,  1603,     0,
       0,  2882,     0,     0,     0,     0,  1605,     0,     0,     0,
       0,     0,  1606,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1366,     0,     0,     0,
    1366,  1366,     0,  1618,  1619,  1620,  1607,  1621,  1622,  1623,
    1624,  1625,  1626,  1618,  1619,  1620,     0,  1621,  1622,  1623,
    1624,  1625,  1626,     0,     0,     0,     0,  1608,     0,  1749,
    1359,  1609,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1610,  1611,     0,     0,     0,     0,     0,     0,
       0,  3912,     0,     0,     0,     0,     0,     0,  1612,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1613,     0,     0,  1614,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1608,     0,     0,  1615,
    1609,     0,  1616,     0,     0,  1359,     0,     0,     0,     0,
       0,     0,     0,     0,  2966,     0,  2852,     0,     0,     0,
       0,  1610,  1611,     0,     0,     0,  1359,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1612,     0,     0,
       0,  1601,     0,     0,  1602,     0,     0,     0,     0,     0,
       0,  2997,  2998,     0,     0,     0,  1359,     0,     0,     0,
       0,  1603,  1613,     0,     0,  1614,     0,     0,  1763,  1605,
       0,     0,     0,     0,  1617,  1606,     0,     0,  1615,     0,
       0,  1616,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1359,     0,     0,     0,  1359,  1359,  1607,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3031,  3033,     0,     0,     0,  3033,     0,     0,     0,
     759,  3044,  3045,  3046,  1749,   759,     0,     0,   759,     0,
       0,     0,     0,   760,     0,     0,     0,   760,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   760,     0,
     759,     0,     0,  1617,     0,     0,     0,  3067,  3068,  3069,
    3070,     0,   760,     0,  1618,  1619,  1620,     0,  1621,  1622,
    1623,  1624,  1625,  1626,     0,     0,   760,     0,     0,     0,
     760,     0,     0,  2887,   759,     0,     0,     0,     0,     0,
     760,     0,     0,  3095,     0,     0,     0,     0,   760,  1608,
       0,     0,     0,  1609,     0,     0,     0,     0,     0,     0,
       0,   759,   759,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1610,  1611,     0,     0,     0,     0,
       0,     0,     0,     0,  1749,   759,     0,  1749,     0,     0,
    1612,     0,     0,  1618,  1619,  1620,     0,  1621,  1622,  1623,
    1624,  1625,  1626,     0,     0,  3133,   759,     0,     0,     0,
     759,     0,     0,  3137,     0,  1613,     0,     0,  1614,     0,
       0,     0,     0,   760,     0,     0,     0,     0,   759,     0,
       0,  1615,     0,     0,  1616,     0,     0,     0,   759,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,  1066,     0,     0,     0,     0,     0,     0,
     759,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3222,     0,     0,     0,     0,
       0,     0,     0,  1123,     0,  3228,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1617,  1360,     0,     0,
       0,     0,  3247,     0,  3249,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1601,     0,     0,
    1602,     0,     0,     0,     0,     0,     0,     0,  1601,     0,
    3288,  1602,     0,     0,     0,     0,     0,  1603,     0,     0,
    2893,     0,     0,     0,  3298,  1605,     0,     0,  1603,     0,
       0,  1606,     0,     0,  1763,     0,  1605,     0,     0,     0,
     759,     0,  1606,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1607,  1618,  1619,  1620,     0,
    1621,  1622,  1623,  1624,  1625,  1626,  1607,     0,     0,     0,
       0,     0,     0,     0,   759,     0,     0,     0,     0,     0,
       0,     0,  1362,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1360,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   760,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,     0,     0,     0,     0,   760,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   760,
       0,     0,     0,     0,     0,  1608,     0,     0,     0,  1609,
       0,     0,     0,     0,     0,     0,  1608,     0,     0,     0,
    1609,     0,     0,     0,     0,     0,     0,   760,     0,     0,
    1610,  1611,     0,     0,     0,     0,     0,   760,     0,     0,
       0,  1610,  1611,     0,     0,     0,  1612,     0,     0,   760,
       0,     0,   760,     0,     0,     0,     0,  1612,  1362,     0,
       0,  1363,     0,  1749,     0,     0,     0,     0,     0,  1749,
       0,  1613,     0,     0,  1614,     0,     0,     0,     0,     0,
       0,     0,  1613,     0,     0,  1614,     0,  1615,     0,     0,
    1616,     0,     0,     0,     0,     0,     0,     0,  1615,  1539,
       0,  1616,     0,  3487,     0,  3488,     0,     0,     0,  3490,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3499,     0,     0,     0,  1563,     0,
       0,     0,     0,     0,     0,     0,  1360,     0,     0,     0,
       0,  3507,     0,     0,     0,     0,     0,     0,     0,   759,
    3518,     0,     0,     0,     0,     0,  1588,  1589,     0,  1591,
       0,     0,  1617,   760,     0,     0,     0,     0,     0,     0,
       0,   760,   760,  1617,     0,     0,  1631,     0,     0,     0,
       0,  1750,     0,     0,     0,     0,     0,  1363,     0,  1360,
    3546,  3547,  3548,  3549,  3550,  3551,  3552,     0,   759,  3325,
       0,  3559,  3560,     0,  3562,  3563,  3564,  3565,  3566,  3567,
    3568,     0,     0,   759,   759,  1667,     0,     0,     0,  3575,
    1360,  3577,  3578,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1750,     0,     0,     0,     0,   759,
       0,     0,     0,     0,  1770,     0,     0,     0,  1780,  1783,
       0,  1362,  1618,  1619,  1620,     0,  1621,  1622,  1623,  1624,
    1625,  1626,     0,  1618,  1619,  1620,     0,  1621,  1622,  1623,
    1624,  1625,  1626,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1360,
    3626,  3628,  3630,     0,     0,  3633,     0,     0,     0,     0,
       0,     0,     0,     0,  1362,     0,     0,     0,  1360,     0,
       0,     0,     0,     0,  1749,  1749,  1749,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1360,     0,
       0,     0,     0,   759,     0,  1362,     0,     0,     0,     0,
     759,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     759,     0,     0,  1360,     0,     0,     0,     0,     0,     0,
       0,     0,   760,     0,     0,     0,     0,     0,     0,     0,
       0,  3033,     0,     0,     0,     0,     0,     0,     0,     0,
    1363,     0,     0,  1601,     0,     0,  1602,     0,  1763,  1763,
    1763,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1603,  1362,  1360,  3375,     0,     0,     0,
     759,  1605,     0,     0,     0,     0,     0,  1606,     0,     0,
       0,     0,     0,  1362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1363,     0,     0,     0,     0,  1749,     0,
    1750,  1607,     0,  1362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   760,  1749,     0,
       0,     0,     0,     0,  1363,     0,     0,     0,  1362,     0,
       0,     0,   759,   760,   759,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,   759,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   760,   760,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   760,     0,     0,     0,     0,     0,     0,
    1362,     0,     0,     0,     0,   760,   760,     0,     0,     0,
       0,     0,     0,  1363,     0,   759,     0,   760,     0,     0,
       0,  1608,     0,     0,     0,  1609,     0,     0,     0,     0,
       0,     0,  1363,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,     0,  1610,  1611,     0,     0,
       0,     0,  1363,     0,     0,     0,     0,   759,     0,     0,
       0,  1360,  1612,     0,     0,     0,     0,  3810,  3811,  3812,
    3813,     0,   759,     0,     0,   759,     0,  1363,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1613,     0,     0,
    1614,     0,  3826,  3827,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1615,  3836,  3837,  1616,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1763,  1763,     0,  1763,     0,     0,     0,  2236,     0,  1363,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1749,     0,
    2259,     0,     0,  2261,     0,  1750,  2272,     0,     0,     0,
       0,     0,     0,  2279,  2284,     0,     0,     0,     0,  2290,
       0,     0,  2295,     0,     0,     0,  1362,     0,  1617,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2304,
       0,     0,     0,     0,  2311,     0,     0,     0,  2323,     0,
       0,     0,  2330,     0,  2332,  2333,  2334,  2335,  2336,  2337,
    2338,  2339,  2340,     0,  2341,  1364,     0,     0,  3882,  1066,
       0,  2366,     0,     0,     0,     0,     0,     0,     0,  1601,
       0,     0,  1602,     0,     0,     0,     0,     0,     0,     0,
       0,  3903,     0,     0,     0,     0,     0,     0,     0,  1603,
       0,     0,     0,     0,     0,     0,     0,  1605,     0,     0,
       0,  3920,     0,  1606,     0,     0,     0,     0,  1618,  1619,
    1620,     0,  1621,  1622,  1623,  1624,  1625,  1626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1607,     0,     0,
       0,   759,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1363,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1763,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1749,     0,     0,  1763,  1749,     0,  1749,     0,     0,     0,
       0,  1364,     0,     0,     0,  1360,  1123,     0,     0,     0,
    1360,  1360,     0,     0,     0,     0,   760,     0,     0,     0,
    1750,   760,  1360,     0,   760,     0,     0,     0,   759,     0,
       0,   759,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   760,  1608,     0,     0,
       0,  1609,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4004,     0,     0,     0,     0,
       0,   759,  1610,  1611,     0,     0,     0,     0,     0,     0,
     760,     0,     0,     0,  2459,     0,     0,     0,  1612,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4028,     0,   760,   760,     0,
       0,     0,     0,  1613,     0,     0,  1614,     0,     0,     0,
    1362,     0,     0,     0,     0,  1362,  1362,     0,     0,  1615,
    1750,   760,  1616,  1750,     0,     0,     0,  1362,     0,     0,
       0,     0,  3033,     0,     0,   759,   759,     0,     0,     0,
       0,     0,   760,     0,     0,     0,   760,  1360,     0,     0,
       0,     0,     0,     0,  1628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   760,  1763,     0,     0,     0,     0,
       0,     0,     0,     0,   760,  1763,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,   760,     0,     0,
       0,     0,     0,     0,  1617,     0,   760,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4105,
       0,  1628,     0,     0,   759,     0,     0,     0,     0,     0,
       0,  1360,     0,     0,     0,     0,  1763,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1364,     0,  1363,
       0,     0,     0,     0,  1363,  1363,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1363,     0,     0,     0,
       0,     0,  1362,     0,     0,     0,     0,     0,  1364,     0,
       0,     0,  2669,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3033,  1618,  1619,  1620,     0,  1621,  1622,
    1623,  1624,  1625,  1626,     0,     0,     0,     0,  1763,     0,
       0,     0,     0,     0,     0,  1360,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   760,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1362,  1364,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     760,     0,     0,  4199,     0,     0,  1364,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1364,     0,     0,     0,
       0,     0,     0,     0,     0,   760,     0,     0,     0,     0,
    2791,  1363,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1364,     0,     0,     0,     0,     0,   760,     0,     0,
       0,     0,     0,  1749,     0,     0,     0,     0,     0,     0,
    1362,     0,     0,     0,     0,   511,     0,     0,     0,   759,
       0,     0,     0,     0,     0,     0,     0,   512,     0,     0,
       0,   759,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1364,     0,     0,     0,     0,   513,     0,
       0,     0,     0,     0,     0,  1363,     0,     0,     0,  2833,
       0,   514,     0,     0,  2839,     0,     0,     0,     0,     0,
     515,     0,     0,     0,  -693,     0,     0,     0,     0,  1750,
       0,     0,     0,     0,     0,  1750,     0,     0,  1749,     0,
     759,   516,     0,     0,     0,     0,     0,   517,     0,     0,
       0,     0,     0,     0,     0,     0,  2284,     0,  2284,  2284,
       0,     0,   518,     0,     0,     0,     0,     0,     0,  2896,
       0,     0,  2899,     0,  2901,     0,     0,     0,     0,     0,
     519,     0,     0,     0,     0,     0,     0,     0,     0,  1363,
    1628,   520,     0,     0,     0,     0,     0,     0,   521,     0,
       0,  2922,   522,  2924,     0,     0,     0,  2927,     0,     0,
       0,     0,     0,     0,     0,   760,  1360,  -882,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2366,  2366,  2366,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,     0,
       0,     0,     0,  2964,     0,   523,  1360,  1360,     0,  1360,
       0,     0,     0,     0,   760,  1770,     0,  1628,     0,  1364,
    2975,     0,     0,     0,     0,     0,     0,  1783,     0,   760,
     760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1628,   524,     0,     0,   525,  2268,     0,     0,     0,
       0,     0,     0,     0,     0,   760,     0,     0,     0,     0,
       0,  1360,     0,  1360,     0,     0,  1628,  1628,     0,  1628,
    3006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1362,   759,     0,   759,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   526,     0,     0,     0,     0,
       0,   527,     0,     0,     0,     0,     0,  -369,     0,  1628,
     528,     0,     0,     0,     0,     0,  1360,     0,     0,     0,
       0,  1362,  1362,     0,  1362,     0,     0,     0,     0,     0,
    1750,  1750,  1750,     0,     0,     0,  -369,     0,   529,   530,
    1360,   531,   532,     0,     0,  1628,     0,     0,     0,   760,
     533,     0,     0,     0,     0,   534,   760,     0,     0,     0,
       0,   535,     0,     0,   536,  1360,   760,   537,     0,     0,
       0,     0,     0,     0,     0,     0,  1362,     0,  1362,     0,
    -369,     0,     0,  1360,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1363,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   760,     0,     0,     0,
       0,  1362,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1360,     0,  1628,     0,
    1363,  1363,     0,  1363,  1750,  1362,     0,     0,  1628,     0,
    1360,  1628,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1360,     0,     0,  1750,     0,     0,     0,     0,     0,
    1362,     0,     0,     0,     0,     0,     0,     0,   760,  1749,
     760,     0,     0,     0,     0,     0,     0,     0,  1362,     0,
     760,     0,   760,  1364,     0,  1363,     0,  1363,  1364,  1364,
     759,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1364,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1360,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   760,     0,     0,     0,     0,  1360,     0,     0,     0,
    1363,  1362,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1362,     0,     0,     0,   760,
       0,  1360,     0,     0,  1363,     0,  1362,     0,     0,     0,
       0,     0,     0,   760,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   760,  1363,
       0,   760,     0,     0,     0,     0,     0,  1360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1363,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1362,     0,     0,     0,  1364,     0,     0,     0,     0,
    3326,     0,     0,     0,     0,     0,     0,   759,     0,     0,
    3330,  1362,     0,     0,     0,     0,  3331,     0,  3332,     0,
       0,     0,     0,     0,  1750,     0,     0,     0,     0,     0,
    1363,     0,     0,     0,     0,     0,  1362,     0,     0,     0,
    3350,  3351,     0,     0,  1363,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1363,     0,     0,     0,     0,
       0,  2290,     0,     0,     0,     0,     0,     0,     0,  1364,
       0,  3379,  1362,     0,  3382,     0,  3384,     0,  1749,     0,
       0,     0,     0,     0,     0,  3388,     0,     0,     0,     0,
       0,  3393,     0,     0,  3396,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3425,     0,     0,     0,     0,  1360,
    1363,     0,  3437,     0,  2366,  1749,     0,     0,     0,     0,
       0,     0,     0,  1749,     0,     0,     0,     0,     0,     0,
    1363,     0,     0,     0,     0,     0,     0,     0,  3451,     0,
       0,     0,     0,  1364,  1066,     0,     0,     0,     0,     0,
    1123,     0,     0,     0,     0,  1363,     0,   760,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1363,     0,     0,     0,     0,  1750,     0,     0,     0,
    1750,     0,  1750,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1362,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   760,     0,     0,   760,     0,     0,
       0,     0,     0,     0,  1628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1360,     0,     0,     0,  1628,     0,  1628,
       0,  2268,  2268,  2870,     0,     0,  2268,   760,     0,     0,
    1628,     0,     0,     0,     0,     0,     0,  1628,     0,     0,
       0,     0,  1628,     0,     0,     0,  1360,     0,  1628,     0,
       0,     0,     0,  1628,     0,     0,     0,     0,     0,     0,
       0,     0,  1628,     0,     0,     0,  2268,  2268,     0,  1628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1628,     0,     0,     0,     0,     0,     0,  1628,     0,
    1628,  1628,  1628,  1628,  1628,  1628,  1628,  1628,  1628,  1628,
       0,   760,   760,  1363,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1628,     0,     0,     0,  1362,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1360,     0,     0,     0,     0,     0,
       0,  1362,     0,     0,  1364,  1360,     0,     0,     0,     0,
       0,     0,     0,     0,  3680,  3681,     0,     0,     0,     0,
     760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,  1364,     0,  1364,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1628,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3710,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1363,     0,  1364,
       0,  1364,     0,     0,     0,     0,     0,     0,  1360,  1362,
       0,     0,     0,     0,     0,     0,     0,     0,  3728,  3730,
    1362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1363,  3737,     0,     0,     0,     0,  1360,  3742,  3743,     0,
       0,  3745,     0,     0,     0,     0,     0,     0,  1360,     0,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2366,
       0,     0,     0,     0,  2366,     0,     0,     0,  1364,     0,
       0,     0,     0,     0,     0,     0,  2366,     0,     0,     0,
       0,     0,  1360,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1364,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3791,     0,  1750,
       0,  1364,     0,  1362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   760,     0,     0,  1363,     0,
       0,     0,     0,     0,     0,     0,     0,   760,     0,  1363,
       0,  1362,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1362,     0,     0,     0,  1628,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1364,     0,
       0,     0,     0,     0,  1750,     0,   760,  1362,     0,  1364,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1363,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,  3871,     0,     0,
    1363,     0,     0,     0,     0,     0,     0,     0,     0,  1628,
       0,     0,  1363,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   760,     0,     0,     0,     0,     0,  1364,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1628,     0,     0,     0,     0,  1363,  1628,     0,     0,
       0,     0,     0,  1360,     0,     0,     0,     0,     0,     0,
       0,     0,  1362,  2870,  2870,  1364,  2268,     0,     0,  2268,
    2268,  2268,  2268,  2268,  2268,  2268,  2268,  2268,  2268,  2870,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3946,     0,     0,     0,  1628,     0,     0,  1628,   760,  1628,
     760,     0,     0,     0,  2870,  2870,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3963,     0,     0,  2268,  2268,
    1628,     0,  1628,     0,     0,  1628,     0,     0,  1360,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1360,
       0,     0,     0,     0,     0,     0,     0,     0,  1362,     0,
       0,     0,  1628,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1628,     0,     0,     0,     0,     0,  1360,
       0,  1363,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1360,  1364,     0,     0,
    1360,  1360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1362,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2290,     0,
       0,     0,     0,     0,     0,     0,     0,  1363,     0,     0,
       0,     0,     0,     0,  1362,     0,     0,  4080,     0,     0,
       0,     0,     0,     0,     0,  1750,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   760,     0,     0,     0,
       0,  1362,     0,     0,     0,  1362,  1362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1364,  1363,     0,     0,     0,     0,     0,     0,     0,
       0,  4141,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1363,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,  2268,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1363,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4181,     0,     0,     0,     0,     0,     0,
    1363,     0,     0,     0,  1363,  1363,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   760,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1364,     0,     0,  4220,  4220,     0,     0,     0,
       0,     0,     0,  1364,  1628,     0,     0,     0,  1628,  1628,
    1628,     0,     0,  2870,     0,     0,     0,     0,  2870,  2870,
    2870,  2870,  2870,  2870,  2870,  2870,  2870,  2870,  1628,  1628,
       0,     0,     0,     0,  1750,     0,     0,     0,     0,     0,
       0,     0,     0,  4220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4264,     0,     0,     0,  1628,  2268,  2268,
    1628,     0,  1628,     0,     0,     0,  1628,  2870,  2870,     0,
       0,  1628,     0,     0,  1628,     0,     0,     0,     0,     0,
       0,  1750,     0,     0,     0,     0,     0,     0,     0,  1750,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1628,     0,     0,  1364,     0,     0,     0,
       0,  4220,     0,     0,     0,  1628,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1628,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1364,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1364,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2870,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1364,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1628,  1628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1628,     0,
       0,     0,  2268,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1628,     0,  1628,     0,
       0,     0,     0,  2870,  2870,  1628,     0,     0,  2268,  2268,
    1628,  1628,     0,  1628,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1364,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1364,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1364,     0,  1628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1364,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2870,  2268,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,     0,  1364,  1364,
       0,     0,  2870,  2870,  1628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1628,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2870,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1628,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   712,
     984,   550,   985,   986,   987,   597,   988,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,  2360,   209,
     210,   211,     0,     0,     0,     0,   989,     0,  1628,   212,
     213,     0,   214,   215,   713,   216,   217,   218,   219,   990,
     714,   991,   992,     0,   223,   224,   225,   226,   227,   993,
     994,   228,   229,   995,   996,   232,     0,   233,   234,   235,
     236,   997,     0,   998,     0,   238,   239,   240,   241,   716,
     242,   243,  1628,   244,   245,   246,   247,   248,   249,     0,
     717,   250,   251,   999,  1000,  1001,  1002,  1003,  1004,  1005,
     252,   253,   254,   255,   256,   257,  1006,  1007,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,  2361,     0,   270,   271,  1008,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
    1009,   285,   286,   287,  1010,  1011,   289,     0,   290,  1012,
     292,     0,   293,     0,   294,   719,     0,   720,   295,   296,
     297,     0,   298,  1013,     0,   300,     0,   301,   302,   303,
     304,   305,   721,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,   722,   316,   317,   318,   319,
     320,  1014,  1015,     0,  1016,     0,   324,   723,   724,   325,
     725,   326,   327,   328,   329,   330,   331,   332,     0,   333,
    1017,   726,   335,   727,     0,   336,   337,   338,  1018,  1019,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,  1020,   728,  1021,   353,   354,   355,  1022,   356,
     357,   729,   358,  1023,  1024,   360,  1025,   362,   363,   364,
       0,   365,     0,     0,  1026,   367,   368,     0,     0,   369,
     730,   731,   732,  1027,   371,   372,   373,   374,   375,   376,
     377,     0,   378,  1028,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1029,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   733,   409,   410,  1030,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,  1031,   425,   426,   427,   428,   734,
     429,  1032,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,  1033,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,  1034,  1035,     0,     0,
     453,  1036,   455,  1037,  1038,   457,   458,   459,   460,   461,
     462,   463,     0,  1039,   464,   465,   466,   467,   468,  1040,
       0,   469,   470,   471,   472,   473,   474,  1041,  2362,   476,
     735,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,   495,   496,   497,     0,     0,     0,     0,
       0,     0,     0,  1050,  1051,  2363,     0,     0,     0,     0,
       0,     0,  1053,  2364,   712,   984,   550,   985,   986,   987,
     597,   988,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   989,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,   219,   990,   714,   991,   992,     0,   223,
     224,   225,   226,   227,   993,   994,   228,   229,   995,   996,
     232,     0,   233,   234,   235,   236,   997,     0,   998,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,   999,  1000,
    1001,  1002,  1003,  1004,  1005,   252,   253,   254,   255,   256,
     257,  1006,  1007,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
    1008,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,  1009,   285,   286,   287,  1010,
    1011,   289,     0,   290,  1012,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,  1013,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,   316,   317,   318,   319,   320,  1014,  1015,     0,  1016,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,  1017,   726,   335,   727,     0,
     336,   337,   338,  1018,  1019,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1020,   728,  1021,
     353,   354,   355,  1022,   356,   357,   729,   358,  1023,  1024,
     360,  1025,   362,   363,   364,     0,   365,     0,     0,  1026,
     367,   368,     0,     0,   369,   730,   731,   732,  1027,   371,
     372,   373,   374,   375,   376,   377,     0,   378,  1028,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1029,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,  1030,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,  1031,
     425,   426,   427,   428,   734,   429,  1032,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,  1033,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,  1034,  1035,     0,     0,   453,  1036,   455,  1037,  1038,
     457,   458,   459,   460,   461,   462,   463,     0,  1039,   464,
     465,   466,   467,   468,  1040,     0,   469,   470,   471,   472,
     473,   474,  1041,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,   495,   496,
     497,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
     199,     0,     0,     0,     0,     0,     0,  1053,  2270,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,  3407,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0, -1406,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0, -1406,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315, -1406,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325, -1406,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334, -1406,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351, -1406,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408, -1406,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,     0,     0,     0,
       0,     0,     0,     0,  1333,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1130,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,     0,  1334,   714,  1335,  1336,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,  1337,  1338,
     232,     0,   233,   234,   235,   236,     0,     0,   715,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,     0,     0,
       0,   718,     0,     0,     0,   252,   253,   254,   255,   256,
     257,  1339,  1340,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
    1008,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,     0,   285,   286,   287,     0,
       0,   289,     0,   290,  1341,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,     0,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,  1883,   309,   310,   311,   312,   313,   314,     0,   315,
     722,  1884,   317,   318,   319,   320,  1342,  1343,     0,  1344,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   726,   335,   727,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1345,   728,  1346,
     353,   354,     0,     0,   356,   357,   729,   358,     0,     0,
     360,  1347,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,  1885,   730,   731,   732,     0,   371,
     372,   373,   374,   375,   376,   377,     0,   378,     0,   380,
       0,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1348,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,     0,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,  1886,   427,   428,   734,   429,  1350,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,     0,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,  1351,  1352,     0,     0,   453,     0,   455,     0,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,     0,  1353,  1887,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,     0,
     199,     0,     0,     0,     0,     0,     0,     0,   495,   496,
     497,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,  1888,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,     0,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0,     0,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,     0,     0,     0,
       0,     0,     0,     0,  1333,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2704,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,     0,  1334,   714,  1335,  1336,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,  1337,  1338,
     232,     0,   233,   234,   235,   236,     0,     0,   715,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,     0,     0,
       0,   718,     0,     0,     0,   252,   253,   254,   255,   256,
     257,  1339,  1340,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
    1008,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,     0,   285,   286,   287,     0,
       0,   289,     0,   290,  1341,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,     0,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,  1883,   309,   310,   311,   312,   313,   314,     0,   315,
     722,  1884,   317,   318,   319,   320,  1342,  1343,     0,  1344,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   726,   335,   727,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1345,   728,  1346,
     353,   354,     0,     0,   356,   357,   729,   358,     0,     0,
     360,  1347,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,  1885,   730,   731,   732,     0,   371,
     372,   373,   374,   375,   376,   377,     0,   378,     0,   380,
       0,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1348,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,     0,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,  1886,   427,   428,   734,   429,  1350,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,     0,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,  1351,  1352,     0,     0,   453,     0,   455,     0,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,     0,  1353,  1887,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,     0,
     712,   984,   550,   985,   986,   987,   597,   988,   495,   496,
     497,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   989,  2755,     0,
     212,   213,     0,   214,   215,   713,   216,   217,   218,   219,
     990,   714,   991,   992,  2280,   223,   224,   225,   226,   227,
     993,   994,   228,   229,   995,   996,   232,     0,   233,   234,
     235,   236,   997,     0,   998,     0,   238,   239,   240,   241,
     716,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,   717,   250,   251,   999,  1000,  1001,  1002,  1003,  1004,
    1005,   252,   253,   254,   255,   256,   257,  1006,  1007,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,  1008,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,  1009,   285,   286,   287,  1010,  1011,   289,     0,   290,
    1012,   292,     0,   293,     0,   294,   719,  2281,   720,   295,
     296,   297,     0,   298,  1013,     0,   300,     0,   301,   302,
     303,   304,   305,   721,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,   722,   316,   317,   318,
     319,   320,  1014,  1015,     0,  1016,     0,   324,   723,   724,
     325,   725,   326,   327,   328,   329,   330,   331,   332,  2282,
     333,  1017,   726,   335,   727,     0,   336,   337,   338,  1018,
    1019,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,  1020,   728,  1021,   353,   354,   355,  1022,
     356,   357,   729,   358,  1023,  1024,   360,  1025,   362,   363,
     364,     0,   365,     0,     0,  1026,   367,   368,     0,     0,
     369,   730,   731,   732,  1027,   371,   372,   373,   374,   375,
     376,   377,     0,   378,  1028,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1029,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   733,   409,   410,
    1030,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,  1031,   425,   426,   427,   428,
     734,   429,  1032,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,  1033,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,  1034,  1035,     0,
    2283,   453,  1036,   455,  1037,  1038,   457,   458,   459,   460,
     461,   462,   463,     0,  1039,   464,   465,   466,   467,   468,
    1040,     0,   469,   470,   471,   472,   473,   474,  1041,     0,
     476,   735,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,   495,   496,   497,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,  1053,   712,   984,   550,   985,   986,   987,
     597,   988,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   989,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,   219,   990,   714,   991,   992,     0,   223,
     224,   225,   226,   227,   993,   994,   228,   229,   995,   996,
     232,     0,   233,   234,   235,   236,   997,     0,   998,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,   999,  1000,
    1001,  1002,  1003,  1004,  1005,   252,   253,   254,   255,   256,
     257,  1006,  1007,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
    1008,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,  1009,   285,   286,   287,  1010,
    1011,   289,     0,   290,  1012,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,  1013,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,   316,   317,   318,   319,   320,  1014,  1015,     0,  1016,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,  1017,   726,   335,   727,     0,
     336,   337,   338,  1018,  1019,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1020,   728,  1021,
     353,   354,   355,  1022,   356,   357,   729,   358,  1023,  1024,
     360,  1025,   362,   363,   364,     0,   365,     0,     0,  1026,
     367,   368,     0,     0,   369,   730,   731,   732,  1027,   371,
     372,   373,   374,   375,   376,   377,     0,   378,  1028,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1029,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,  1030,   412,   413,   414,   415,   416,
     417,   418,   419,    37,   420,   421,   422,   423,   424,  1031,
     425,   426,   427,   428,   734,   429,  1032,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,  1033,
       0,   443,   444,    41,   445,   446,   447,   448,   449,   450,
       0,  1034,  1035,     0,     0,   453,  1036,   455,  1037,  1038,
     457,   458,   459,   460,   461,   462,   463,     0,  1039,   464,
     465,   466,   467,   468,  1040,     0,   469,   470,   471,   472,
     473,   924,  1041,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,    46,   481,   482,   483,   484,   485,   486,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,   495,   496,
     497,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,  1053,   712,   984,
     550,   985,   986,   987,   597,   988,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   989,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,   219,   990,   714,
     991,   992,     0,   223,   224,   225,   226,   227,   993,   994,
     228,   229,   995,   996,   232,     0,   233,   234,   235,   236,
     997,     0,   998,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,   999,  1000,  1001,  1002,  1003,  1004,  1005,   252,
     253,   254,   255,   256,   257,  1006,  1007,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,  1008,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,  1009,
     285,   286,   287,  1010,  1011,   289,     0,   290,  1012,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,  1013,     0,   300,     0,   301,   302,   303,   304,
     305,   721,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,   316,   317,   318,   319,   320,
    1014,  1015,     0,  1016,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,  1017,
     726,   335,   727,     0,   336,   337,   338,  1018,  1019,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,  1020,   728,  1021,   353,   354,   355,  1022,   356,   357,
     729,   358,  1023,  1024,   360,  1025,   362,   363,   364,     0,
     365,     0,     0,  1026,   367,   368,     0,     0,   369,   730,
     731,   732,  1027,   371,   372,   373,   374,   375,   376,   377,
       0,   378,  1028,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1029,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,  1030,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,  1031,   425,   426,   427,   428,   734,   429,
    1032,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,  1033,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,  1034,  1035,     0,     0,   453,
    1036,   455,  1037,  1038,   457,   458,   459,   460,   461,   462,
     463,     0,  1039,   464,   465,   466,   467,   468,  1040,     0,
     469,   470,   471,   472,   473,   474,  1041,     0,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,   495,   496,   497,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,     0,     0,     0,     0,     0,  1534,
    2228,  1053,   712,   984,   550,   985,   986,   987,   597,   988,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   989,
       0,     0,   212,   213,     0,   214,   215,   713,   216,   217,
     218,   219,   990,   714,   991,   992,     0,   223,   224,   225,
     226,   227,   993,   994,   228,   229,   995,   996,   232,     0,
     233,   234,   235,   236,   997,     0,   998,     0,   238,   239,
     240,   241,   716,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,   717,   250,   251,   999,  1000,  1001,  1002,
    1003,  1004,  1005,   252,   253,   254,   255,   256,   257,  1006,
    1007,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,  1008,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,  1009,   285,   286,   287,  1010,  1011,   289,
       0,   290,  1012,   292,     0,   293,     0,   294,   719,     0,
     720,   295,   296,   297,     0,   298,  1013,     0,   300,     0,
     301,   302,   303,   304,   305,   721,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,   722,   316,
     317,   318,   319,   320,  1014,  1015,     0,  1016,     0,   324,
     723,   724,   325,   725,   326,   327,   328,   329,   330,   331,
     332,     0,   333,  1017,   726,   335,   727,     0,   336,   337,
     338,  1018,  1019,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,  1020,   728,  1021,   353,   354,
     355,  1022,   356,   357,   729,   358,  1023,  1024,   360,  1025,
     362,   363,   364,     0,   365,     0,     0,  1026,   367,   368,
       0,     0,   369,   730,   731,   732,  1027,   371,   372,   373,
     374,   375,   376,   377,     0,   378,  1028,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1029,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   733,
     409,   410,  1030,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,  1031,   425,   426,
     427,   428,   734,   429,  1032,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,  1033,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,  1034,
    1035,     0,     0,   453,  1036,   455,  1037,  1038,   457,   458,
     459,   460,   461,   462,   463,     0,  1039,   464,   465,   466,
     467,   468,  1040,     0,   469,   470,   471,   472,   473,   474,
    1041,     0,   476,   735,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,  1042,  1043,
    1044,  1045,  1046,  1047,  1048,  1049,   495,   496,   497,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,     0,
       0,     0,     0,     0,     0,  1053,   712,   984,   550,   985,
     986,   987,   597,   988,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   989,     0,     0,   212,   213,     0,   214,
     215,   713,   216,   217,   218,   219,   990,   714,   991,   992,
       0,   223,   224,   225,   226,   227,   993,   994,   228,   229,
     995,   996,   232,     0,   233,   234,   235,   236,   997,     0,
     998,     0,   238,   239,   240,   241,   716,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,   717,   250,   251,
     999,  1000,  1001,  1002,  1003,  1004,  1005,   252,   253,   254,
     255,   256,   257,  1006,  1007,   260,  1122,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,  1008,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,  1009,   285,   286,
     287,  1010,  1011,   289,     0,   290,  1012,   292,     0,   293,
       0,   294,   719,     0,   720,   295,   296,   297,     0,   298,
    1013,     0,   300,     0,   301,   302,   303,   304,   305,   721,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,   722,   316,   317,   318,   319,   320,  1014,  1015,
       0,  1016,     0,   324,   723,   724,   325,   725,   326,   327,
     328,   329,   330,   331,   332,     0,   333,  1017,   726,   335,
     727,     0,   336,   337,   338,  1018,  1019,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,  1020,
     728,  1021,   353,   354,   355,  1022,   356,   357,   729,   358,
    1023,  1024,   360,  1025,   362,   363,   364,     0,   365,     0,
       0,  1026,   367,   368,     0,     0,   369,   730,   731,   732,
    1027,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1028,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1029,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   733,   409,   410,  1030,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,  1031,   425,   426,   427,   428,   734,   429,  1032,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,  1033,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,  1034,  1035,     0,     0,   453,  1036,   455,
    1037,  1038,   457,   458,   459,   460,   461,   462,   463,     0,
    1039,   464,   465,   466,   467,   468,  1040,     0,   469,   470,
     471,   472,   473,   474,  1041,     0,   476,   735,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
     495,   496,   497,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,  1053,
     712,   984,   550,   985,   986,   987,   597,   988,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,  1778,
     209,   210,   211,     0,     0,     0,     0,   989,     0,     0,
     212,   213,     0,   214,   215,   713,   216,   217,   218,   219,
     990,   714,   991,   992,     0,   223,   224,   225,   226,   227,
     993,   994,   228,   229,   995,   996,   232,     0,   233,   234,
     235,   236,   997,     0,   998,     0,   238,   239,   240,   241,
     716,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,   717,   250,   251,   999,  1000,  1001,  1002,  1003,  1004,
    1005,   252,   253,   254,   255,   256,   257,  1006,  1007,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,  1008,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,  1009,   285,   286,   287,  1010,  1011,   289,     0,   290,
    1012,   292,     0,   293,     0,   294,   719,     0,   720,   295,
     296,   297,     0,   298,  1013,     0,   300,     0,   301,   302,
     303,   304,   305,   721,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,   722,   316,   317,   318,
     319,   320,  1014,  1015,     0,  1016,     0,   324,   723,   724,
     325,   725,   326,   327,   328,   329,   330,   331,   332,     0,
     333,  1017,   726,   335,   727,     0,   336,   337,   338,  1018,
    1019,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,  1020,   728,  1021,   353,   354,   355,  1022,
     356,   357,   729,   358,  1023,  1024,   360,  1025,   362,   363,
     364,     0,   365,     0,     0,  1026,   367,   368,     0,     0,
     369,   730,   731,   732,  1027,   371,   372,   373,   374,   375,
     376,   377,     0,   378,  1028,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1029,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   733,   409,   410,
    1030,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,  1031,   425,   426,   427,   428,
     734,   429,  1032,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,  1033,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,  1034,  1035,     0,
       0,   453,  1036,   455,  1037,  1038,   457,   458,   459,   460,
     461,   462,   463,     0,  1039,   464,   465,   466,   467,   468,
    1040,     0,   469,   470,   471,   472,   473,   474,  1041,     0,
     476,   735,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,   495,   496,   497,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,  1053,   712,   984,   550,   985,   986,   987,
     597,   988,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   989,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,   219,   990,   714,   991,   992,     0,   223,
     224,   225,   226,   227,   993,   994,   228,   229,   995,   996,
     232,     0,   233,   234,   235,   236,   997,     0,   998,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,   999,  1000,
    1001,  1002,  1003,  1004,  1005,   252,   253,   254,   255,   256,
     257,  1006,  1007,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
    1008,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,  1009,   285,   286,   287,  1010,
    1011,   289,     0,   290,  1012,   292,     0,   293,     0,   294,
     719,  2281,   720,   295,   296,   297,     0,   298,  1013,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,   316,   317,   318,   319,   320,  1014,  1015,     0,  1016,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,  1017,   726,   335,   727,     0,
     336,   337,   338,  1018,  1019,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1020,   728,  1021,
     353,   354,   355,  1022,   356,   357,   729,   358,  1023,  1024,
     360,  1025,   362,   363,   364,     0,   365,     0,     0,  1026,
     367,   368,     0,     0,   369,   730,   731,   732,  1027,   371,
     372,   373,   374,   375,   376,   377,     0,   378,  1028,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1029,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,  1030,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,  1031,
     425,   426,   427,   428,   734,   429,  1032,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,  1033,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,  1034,  1035,     0,     0,   453,  1036,   455,  1037,  1038,
     457,   458,   459,   460,   461,   462,   463,     0,  1039,   464,
     465,   466,   467,   468,  1040,     0,   469,   470,   471,   472,
     473,   474,  1041,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,   495,   496,
     497,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,  1053,   712,   984,
     550,   985,   986,   987,   597,   988,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   989,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,   219,   990,   714,
     991,   992,     0,   223,   224,   225,   226,   227,   993,   994,
     228,   229,   995,   996,   232,     0,   233,   234,   235,   236,
     997,     0,   998,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,   999,  1000,  1001,  1002,  1003,  1004,  1005,   252,
     253,   254,   255,   256,   257,  1006,  1007,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,  1008,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,  1009,
     285,   286,   287,  1010,  1011,   289,     0,   290,  1012,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,  1013,     0,   300,     0,   301,   302,   303,   304,
     305,   721,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,   316,   317,   318,   319,   320,
    1014,  1015,     0,  1016,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,  1017,
     726,   335,   727,     0,   336,   337,   338,  1018,  1019,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,  1020,   728,  1021,   353,   354,   355,  1022,   356,   357,
     729,   358,  1023,  1024,   360,  1025,   362,   363,   364,     0,
     365,     0,     0,  1026,   367,   368,     0,     0,   369,   730,
     731,   732,  1027,   371,   372,   373,   374,   375,   376,   377,
       0,   378,  1028,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1029,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,  1030,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,  1031,   425,   426,   427,   428,   734,   429,
    1032,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,  1033,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,  1034,  1035,     0,     0,   453,
    1036,   455,  1037,  1038,   457,   458,   459,   460,   461,   462,
     463,     0,  1039,   464,   465,   466,   467,   468,  1040,     0,
     469,   470,   471,   472,   473,   474,  1041,  3440,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,   495,   496,   497,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,  1053,   712,   984,   550,   985,   986,   987,   597,   988,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   989,
       0,     0,   212,   213,     0,   214,   215,   713,   216,   217,
     218,   219,   990,   714,   991,   992,     0,   223,   224,   225,
     226,   227,   993,   994,   228,   229,   995,   996,   232,     0,
     233,   234,   235,   236,   997,     0,   998,     0,   238,   239,
     240,   241,   716,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,   717,   250,   251,   999,  1000,  1001,  1002,
    1003,  1004,  1005,   252,   253,   254,   255,   256,   257,  1006,
    1007,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,  1008,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,  1009,   285,   286,   287,  1010,  1011,   289,
       0,   290,  1012,   292,     0,   293,     0,   294,   719,     0,
     720,   295,   296,   297,     0,   298,  1013,     0,   300,     0,
     301,   302,   303,   304,   305,   721,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,   722,   316,
     317,   318,   319,   320,  1014,  1015,     0,  1016,     0,   324,
     723,   724,   325,   725,   326,   327,   328,   329,   330,   331,
     332,     0,   333,  1017,   726,   335,   727,     0,   336,   337,
     338,  1018,  1019,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,  1020,   728,  1021,   353,   354,
     355,  1022,   356,   357,   729,   358,  1023,  1024,   360,  1025,
     362,   363,   364,     0,   365,     0,     0,  1026,   367,   368,
       0,     0,   369,   730,   731,   732,  1027,   371,   372,   373,
     374,   375,   376,   377,     0,   378,  1028,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1029,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   733,
     409,   410,  1030,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,  1031,   425,   426,
     427,   428,   734,   429,  1032,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,  1033,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,  1034,
    1035,     0,     0,   453,  1036,   455,  1037,  1038,   457,   458,
     459,   460,   461,   462,   463,     0,  1039,   464,   465,   466,
     467,   468,  1040,     0,   469,   470,   471,   472,   473,   474,
    1041,     0,   476,   735,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,  1042,  1043,
    1044,  1045,  1046,  1047,  1048,  1049,   495,   496,   497,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,  1053,   712,   984,   550,   985,
     986,   987,   597,   988,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   989,     0,     0,   212,   213,     0,   214,
     215,   713,   216,   217,   218,   219,   990,   714,   991,   992,
       0,   223,   224,   225,   226,   227,   993,   994,   228,   229,
     995,   996,   232,     0,   233,   234,   235,   236,   997,     0,
     998,     0,   238,   239,   240,   241,   716,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,   717,   250,  3450,
     999,  1000,  1001,  1002,  1003,  1004,  1005,   252,   253,   254,
     255,   256,   257,  1006,  1007,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,  1008,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,  1009,   285,   286,
     287,  1010,  1011,   289,     0,   290,  1012,   292,     0,   293,
       0,   294,   719,     0,   720,   295,   296,   297,     0,   298,
    1013,     0,   300,     0,   301,   302,   303,   304,   305,   721,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,   722,   316,   317,   318,   319,   320,  1014,  1015,
       0,  1016,     0,   324,   723,   724,   325,   725,   326,   327,
     328,   329,   330,   331,   332,     0,   333,  1017,   726,   335,
     727,     0,   336,   337,   338,  1018,  1019,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,  1020,
     728,  1021,   353,   354,   355,  1022,   356,   357,   729,   358,
    1023,  1024,   360,  1025,   362,   363,   364,     0,   365,     0,
       0,  1026,   367,   368,     0,     0,   369,   730,   731,   732,
    1027,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1028,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1029,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   733,   409,   410,  1030,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,  1031,   425,   426,   427,   428,   734,   429,  1032,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,  1033,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,  1034,  1035,     0,     0,   453,  1036,   455,
    1037,  1038,   457,   458,   459,   460,   461,   462,   463,     0,
    1039,   464,   465,   466,   467,   468,  1040,     0,   469,   470,
     471,   472,   473,   474,  1041,     0,   476,   735,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
     495,   496,   497,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,     0,     0,     0,     0,     0,     0,     0,  1053,
     712,   984,   550,   985,   986,   987,   597,   988,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   989,     0,     0,
     212,   213,     0,   214,   215,   713,   216,   217,   218,   219,
     990,   714,   991,   992,     0,   223,   224,   225,   226,   227,
     993,   994,   228,   229,   995,   996,   232,     0,   233,   234,
     235,   236,   997,     0,   998,     0,   238,   239,   240,   241,
     716,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,   717,   250,   251,   999,  1000,  1001,  1002,  1003,  1004,
    1005,   252,   253,   254,   255,   256,   257,  1006,  1007,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,  1008,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,  1009,   285,   286,   287,  1010,  1011,   289,     0,   290,
    1012,   292,     0,   293,     0,   294,   719,     0,   720,   295,
     296,   297,     0,   298,  1013,     0,   300,     0,   301,   302,
     303,   304,   305,   721,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,   722,   316,   317,   318,
     319,   320,  1014,  1015,     0,  1016,     0,   324,   723,   724,
     325,   725,   326,   327,   328,   329,   330,   331,   332,     0,
     333,  1017,   726,   335,   727,     0,   336,   337,   338,  1018,
    1019,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,  1020,   728,  1021,   353,   354,   355,  1022,
     356,   357,   729,   358,  1023,  1024,   360,  1025,   362,   363,
     364,     0,   365,     0,     0,  1026,   367,   368,     0,     0,
     369,   730,   731,   732,  1027,   371,   372,   373,   374,   375,
     376,   377,     0,   378,  1028,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1029,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   733,   409,   410,
    1030,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,  1031,   425,   426,   427,   428,
     734,   429,  1032,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,  1033,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,  1034,  1035,     0,
       0,   453,  1036,   455,  1037,  1038,   457,   458,   459,   460,
     461,   462,   463,     0,  1039,   464,   465,   466,   467,   468,
    1040,     0,   469,   470,   471,   472,   473,   474,  1041,     0,
     476,   735,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,  3720,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,   495,   496,   497,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,     0,     0,     0,     0,
       0,     0,     0,  1053,   712,   984,   550,   985,   986,   987,
     597,   988,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   989,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,   219,   990,   714,   991,   992,     0,   223,
     224,   225,   226,   227,   993,   994,   228,   229,   995,   996,
     232,     0,   233,   234,   235,   236,   997,     0,   998,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,   999,  1000,
    1001,  1002,  1003,  1004,  1005,   252,   253,   254,   255,   256,
     257,  1006,  1007,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
    1008,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,  1009,   285,   286,   287,  1010,
    1011,   289,     0,   290,  1012,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,  1013,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,   316,   317,   318,   319,   320,  1014,  1015,     0,  1016,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,  1017,   726,   335,   727,     0,
     336,   337,   338,  1018,  1019,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1020,   728,  1021,
     353,  3729,   355,  1022,   356,   357,   729,   358,  1023,  1024,
     360,  1025,   362,   363,   364,     0,   365,     0,     0,  1026,
     367,   368,     0,     0,   369,   730,   731,   732,  1027,   371,
     372,   373,   374,   375,   376,   377,     0,   378,  1028,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1029,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,  1030,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,  1031,
     425,   426,   427,   428,   734,   429,  1032,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,  1033,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,  1034,  1035,     0,     0,   453,  1036,   455,  1037,  1038,
     457,   458,   459,   460,   461,   462,   463,     0,  1039,   464,
     465,   466,   467,   468,  1040,     0,   469,   470,   471,   472,
     473,   474,  1041,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,   495,   496,
     497,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,  1053,   712,   984,
     550,   985,   986,   987,   597,   988,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   989,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,  4217,   990,   714,
     991,   992,     0,   223,   224,   225,   226,   227,   993,   994,
     228,   229,   995,   996,   232,     0,   233,   234,   235,   236,
     997,     0,   998,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,  4218,   999,  1000,  1001,  1002,  1003,  1004,  1005,   252,
     253,   254,   255,   256,   257,  1006,  1007,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,  1008,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,  1009,
     285,   286,   287,  1010,  1011,   289,     0,   290,  1012,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,  1013,     0,   300,     0,   301,   302,   303,   304,
     305,   721,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,   316,   317,   318,   319,   320,
    1014,  1015,     0,  1016,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,  1017,
     726,   335,   727,     0,   336,   337,   338,  1018,  1019,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,  1020,   728,  1021,   353,   354,   355,  1022,   356,   357,
     729,   358,  1023,  1024,   360,  1025,   362,   363,   364,     0,
     365,     0,     0,  1026,   367,   368,     0,     0,   369,   730,
     731,   732,  1027,   371,   372,   373,   374,   375,   376,   377,
       0,   378,  1028,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1029,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,  1030,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,  1031,   425,   426,   427,   428,   734,   429,
    1032,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,  1033,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,  1034,  1035,     0,     0,   453,
    1036,   455,  1037,  1038,   457,   458,   459,   460,  4219,   462,
     463,     0,  1039,   464,   465,   466,   467,   468,  1040,     0,
     469,   470,   471,   472,   473,   474,  1041,     0,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,   495,   496,   497,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,     0,     0,     0,     0,     0,     0,
       0,  1053,   712,   984,   550,   985,   986,   987,   597,   988,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   989,
       0,     0,   212,   213,     0,   214,   215,   713,   216,   217,
     218,   219,   990,   714,   991,   992,     0,   223,   224,   225,
     226,   227,   993,   994,   228,   229,   995,   996,   232,     0,
     233,   234,   235,   236,   997,     0,   998,     0,   238,   239,
     240,   241,   716,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,   717,   250,  4218,   999,  1000,  1001,  1002,
    1003,  1004,  1005,   252,   253,   254,   255,   256,   257,  1006,
    1007,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,  1008,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,  1009,   285,   286,   287,  1010,  1011,   289,
       0,   290,  1012,   292,     0,   293,     0,   294,   719,     0,
     720,   295,   296,   297,     0,   298,  1013,     0,   300,     0,
     301,   302,   303,   304,   305,   721,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,   722,   316,
     317,   318,   319,   320,  1014,  1015,     0,  1016,     0,   324,
     723,   724,   325,   725,   326,   327,   328,   329,   330,   331,
     332,     0,   333,  1017,   726,   335,   727,     0,   336,   337,
     338,  1018,  1019,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,  1020,   728,  1021,   353,   354,
     355,  1022,   356,   357,   729,   358,  1023,  1024,   360,  1025,
     362,   363,   364,     0,   365,     0,     0,  1026,   367,   368,
       0,     0,   369,   730,   731,   732,  1027,   371,   372,   373,
     374,   375,   376,   377,     0,   378,  1028,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1029,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   733,
     409,   410,  1030,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,  1031,   425,   426,
     427,   428,   734,   429,  1032,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,  1033,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,  1034,
    1035,     0,     0,   453,  1036,   455,  1037,  1038,   457,   458,
     459,   460,  4219,   462,   463,     0,  1039,   464,   465,   466,
     467,   468,  1040,     0,   469,   470,   471,   472,   473,   474,
    1041,     0,   476,   735,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,  1042,  1043,
    1044,  1045,  1046,  1047,  1048,  1049,   495,   496,   497,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,     0,     0,
       0,     0,     0,     0,     0,  1053,   712,   984,   550,   985,
     986,   987,   597,   988,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   989,     0,     0,   212,   213,     0,   214,
     215,   713,   216,   217,   218,   219,   990,   714,   991,   992,
       0,   223,   224,   225,   226,   227,   993,   994,   228,   229,
     995,   996,   232,     0,   233,   234,   235,   236,   997,     0,
     998,     0,   238,   239,   240,   241,   716,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,   717,   250,   251,
     999,  1000,  1001,  1002,  1003,  1004,  1005,   252,   253,   254,
     255,   256,   257,  1006,  1007,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,  1008,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,  1009,   285,   286,
     287,  1010,  1011,   289,     0,   290,  1012,   292,     0,   293,
       0,   294,   719,     0,   720,   295,   296,   297,     0,   298,
    1013,     0,   300,     0,   301,   302,   303,   304,   305,   721,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,   722,   316,   317,   318,   319,   320,  1014,  1015,
       0,  1016,     0,   324,   723,   724,   325,   725,   326,   327,
     328,   329,   330,   331,   332,     0,   333,  1017,   726,   335,
     727,     0,   336,   337,   338,  1018,  1019,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,  1020,
     728,  1021,   353,   354,   355,     0,   356,   357,   729,   358,
    1023,  1024,   360,  1025,   362,   363,   364,     0,   365,     0,
       0,  1026,   367,   368,     0,     0,   369,   730,   731,   732,
    1027,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1028,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1029,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   733,   409,   410,  1030,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,  1031,   425,   426,   427,   428,   734,   429,  1032,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,  1033,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,  1034,  1035,     0,     0,   453,  1036,   455,
    1037,  1038,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,  1040,     0,   469,   470,
     471,   472,   473,   474,  1041,     0,   476,   735,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
     495,   496,   497,     0,     0,     0,     0,     0,     0,     0,
    2263,  2264,     0,     0,     0,     0,     0,     0,     0,  1053,
     712,   984,   550,   985,   986,   987,   597,   988,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   989,     0,     0,
     212,   213,     0,   214,   215,   713,   216,   217,   218, -2169,
     990,   714,   991,   992,     0,   223,   224,   225,   226,   227,
     993,   994,   228,   229,   995,   996,   232,     0,   233,   234,
     235,   236,   997,     0,   998,     0,   238,   239,   240,   241,
     716,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,   717,   250,  4218,   999,  1000,  1001,  1002,  1003,  1004,
    1005,   252,   253,   254,   255,   256,   257,  1006,  1007,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,  1008,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,  1009,   285,   286,   287,  1010,  1011,   289,     0,   290,
    1012,   292,     0,   293,     0,   294,   719,     0,   720,   295,
     296,   297,     0,   298,  1013,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,   722,   316,   317,   318,
     319,   320,  1014,  1015,     0,  1016,     0,   324,   723,   724,
     325,   725,   326,   327,   328,   329,   330,   331,   332,     0,
     333,  1017,   726,   335,     0,     0,   336,   337,   338,  1018,
    1019,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,  1020,   728,  1021,   353,   354,   355,     0,
     356,   357,   729,   358,  1023,  1024,   360,  1025,   362,   363,
     364,     0,   365,     0,     0,  1026,   367,   368,     0,     0,
     369,   730,   731,   732,  1027,   371,   372,   373,   374,   375,
     376,   377,     0,   378,  1028,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1029,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   733,   409,   410,
    1030,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,  1031,   425,   426,   427,   428,
       0,   429,  1032,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,  1033,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,  1034,  1035,     0,
       0,   453,  1036,   455,  1037,  1038,   457,   458,   459,   460,
    4219,   462,   463,     0,  1039,   464,   465,   466,   467,   468,
    1040,     0,   469,   470,   471,   472,   473,   474,  1041,     0,
     476,   735,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,   495,   496,   497,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,     0,     0,   712,   984,
     550,   985,   986,  1053,   597,   988,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   989,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,   219,   990,   714,
     991,   992,     0,   223,   224,   225,   226,   227,   993,   994,
     228,   229,   995,   996,   232,     0,   233,   234,   235,   236,
     997,     0,   998,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,   999,  1000,  1001,  1002,  1003,  1004,  1005,   252,
     253,   254,   255,   256,   257,  1006,  1007,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,  1008,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,  1009,
     285,   286,   287,  1010,  1011,   289,     0,   290,  1012,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,  1013,     0,   300,     0,   301,   302,   303,   304,
     305,   721,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,   316,   317,   318,   319,   320,
    1014,  1015,     0,  1016,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,  1017,
     726,   335,   727,     0,   336,   337,   338,  1018,  1019,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,  1020,   728,  1021,   353,   354,   355,     0,   356,   357,
     729,   358,  1023,  1024,   360,  1025,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,   730,
     731,   732,  1027,   371,   372,   373,   374,   375,   376,   377,
       0,   378,  1028,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1029,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,  1030,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,  1031,   425,   426,   427,   428,   734,   429,
    1032,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,  1033,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,  1034,  1035,     0,     0,   453,
    1036,   455,  1037,  1038,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,  1040,     0,
     469,   470,   471,   472,   473,   474,  1041,     0,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,   495,   496,   497,     0,     0,     0,     0,     0,
       0,   712,   984,   550,   985,   986,     0,   597,   988,     0,
       0,  1053,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   989,     0,
       0,   212,   213,     0,   214,   215,   713,   216,   217,   218,
     219,   990,   714,   991,   992,     0,  3363,   224,   225,   226,
     227,   993,   994,   228,   229,   995,   996,   232,     0,   233,
     234,   235,   236,   997,     0,   998,     0,   238,   239,   240,
     241,   716,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,   717,   250,   251,   999,  1000,  1001,  1002,  1003,
    1004,  1005,   252,   253,   254,   255,   256,   257,  1006,  1007,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,  1008,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,  1009,   285,   286,   287,  1010,  1011,   289,     0,
     290,  1012,   292,     0,   293,     0,   294,   719,     0,   720,
     295,   296,   297,     0,   298,  1013,     0,   300,     0,   301,
     302,   303,   304,   305,   721,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,   722,   316,   317,
     318,   319,   320,  1014,  1015,     0,  1016,     0,   324,   723,
     724,   325,   725,   326,   327,   328,   329,   330,   331,   332,
       0,   333,  1017,   726,   335,   727,     0,   336,   337,   338,
    1018,  1019,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,  1020,   728,  1021,   353,   354,   355,
       0,   356,   357,   729,   358,  1023,  1024,   360,  1025,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,   730,   731,   732,  1027,   371,   372,   373,   374,
     375,   376,   377,     0,   378,  1028,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1029,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   733,   409,
     410,  1030,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,  1031,   425,   426,   427,
     428,   734,   429,  1032,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,  1033,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,  1034,  1035,
       0,     0,   453,  1036,   455,  1037,  1038,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,  1040,     0,   469,   470,   471,   472,   473,   474,  1041,
       0,   476,   735,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,   495,   496,   497,     0,     0,
       0,     0,     0,     0,   712,   984,   550,   985,   986,   987,
     597,   988,     0,     0,  1053,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   989,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,     0,   990,   714,   991,   992,     0,   223,
     224,   225,   226,   227,   993,   994,   228,   229,   995,   996,
     232,     0,   233,   234,   235,   236,   997,     0,   998,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,   999,  1000,
    1001,  1002,  1003,  1004,  1005,   252,   253,   254,   255,   256,
     257,  1006,  1007,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
    1008,   273,   274,     0,   275,   276,   277,     0,   278,     0,
       0,   280,   281,   282,   283,  1009,   285,   286,   287,  1010,
    1011,   289,     0,   290,  1012,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,  1013,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,   316,   317,   318,   319,   320,  1014,  1015,     0,  1016,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,  1017,   726,   335,     0,     0,
     336,   337,   338,  1018,  1019,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1020,   728,  1021,
     353,   354,   355,     0,   356,   357,   729,   358,  1023,  1024,
     360,  1025,   362,   363,   364,     0,   365,     0,     0,  1026,
     367,   368,     0,     0,   369,   730,   731,   732,  1027,   371,
     372,   373,   374,   375,   376,   377,     0,   378,  1028,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1029,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,  1030,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,  1031,
     425,   426,   427,   428,     0,   429,  1032,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,  1033,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,  1034,  1035,     0,     0,   453,  1036,   455,  1037,  1038,
     457,   458,   459,   460,   461,   462,   463,     0,  1039,   464,
     465,   466,   467,   468,  1040,     0,   469,   470,   471,   472,
     473,   474,  1041,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,   495,   496,
     497,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
       0,     0,     0,     0,     0,     0,     0,  1053,   712,   984,
     550,   985,   986,   987,   597,   988,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   989,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,     0,   990,   714,
     991,   992,     0,   223,   224,   225,   226,   227,   993,   994,
     228,   229,   995,   996,   232,     0,   233,   234,   235,   236,
     997,     0,   998,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,   999,  1000,  1001,  1002,  1003,  1004,  1005,   252,
     253,   254,   255,   256,   257,  1006,  1007,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,  1008,   273,   274,     0,   275,   276,
     277,     0,   278,     0,     0,   280,   281,   282,   283,  1009,
     285,   286,   287,  1010,  1011,   289,     0,   290,  1012,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,  1013,     0,   300,     0,   301,   302,   303,   304,
     305,     0,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,   316,   317,   318,   319,   320,
    1014,  1015,     0,  1016,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,  1017,
     726,   335,     0,     0,   336,   337,   338,  1018,  1019,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,  1020,   728,  1021,   353,   354,   355,     0,   356,   357,
     729,   358,  1023,  1024,   360,  1025,   362,   363,   364,     0,
     365,     0,     0,  1026,   367,   368,     0,     0,   369,   730,
     731,   732,  1027,   371,   372,   373,   374,   375,   376,   377,
       0,   378,  1028,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1029,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,  1030,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,  1031,   425,   426,   427,   428,     0,   429,
    1032,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,  1033,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,  1034,  1035,     0,     0,   453,
    1036,   455,  1037,  1038,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,  1040,     0,
     469,   470,   471,   472,   473,   474,  1041,     0,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,   495,   496,   497,     0,     0,     0,     0,     0,
       0,   712,  2263,  2264,     0,     0,     0,     0,     0,     0,
       0,  1053,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,   713,   216,   217,   218,
     219,   220,   714,   221,   222,     0,   223,   224,   225,   226,
     227,     0,   994,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   997,     0,   998,     0,   238,   239,   240,
     241,   716,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,   717,   250,   251,   999,  1000,  1001,  1002,  1003,
    1004,  1005,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,  1010,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,   719,     0,   720,
     295,   296,   297,     0,   298,  1013,     0,   300,     0,   301,
     302,   303,   304,   305,   721,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,   722,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,   723,
     724,   325,   725,   326,   327,   328,   329,   330,   331,   332,
       0,   333,  1017,   726,   335,   727,     0,   336,   337,   338,
    1018,  1019,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   728,   352,   353,   354,   355,
       0,   356,   357,   729,   358,     0,  1024,   360,   361,   362,
     363,   364,     0,   365,     0,   677,   366,   367,   368,     0,
       0,   369,   730,   731,   732,  1027,   371,   372,   373,   374,
     375,   376,   377,     0,   378,  1028,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   733,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      37,   420,   421,   422,   423,   424,  1031,   425,   426,   427,
     428,   734,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,  1033,     0,   443,   444,
      41,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,  1036,   455,  1037,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,  1040,     0,   469,   470,   471,   472,   473,   924,   475,
       0,   476,   735,   477,   478,   479,     0,     0,   480,     0,
      46,   481,   482,   483,   484,   485,   486,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,   495,   496,   497,     0,     0,
       0,     0,     0,     0,   712,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2938,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,   219,   220,   714,   221,   222,     0,   223,
     224,   225,   226,   227,     0,   994,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   997,     0,   998,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,   999,  1000,
    1001,  1002,  1003,  1004,  1005,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,  1010,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,  1013,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,  1017,   726,   335,   727,     0,
     336,   337,   338,  1018,  1019,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   728,   352,
     353,   354,   355,     0,   356,   357,   729,   358,     0,  1024,
     360,   361,   362,   363,   364,     0,   365,     0,   677,   366,
     367,   368,     0,     0,   369,   730,   731,   732,  1027,   371,
     372,   373,   374,   375,   376,   377,     0,   378,  1028,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,  1031,
     425,   426,   427,   428,   734,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,  1033,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,  1036,   455,  1037,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,  1040,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,   495,   496,
     497,     0,     0,     0,     0,     0,     0,   712,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2938,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   713,   216,   217,   218,   219,   220,   714,   221,
     222,     0,   223,   224,   225,   226,   227,     0,   994,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   997,
       0,   998,     0,   238,   239,   240,   241,   716,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,   717,   250,
     251,   999,  1000,  1001,  1002,  1003,  1004,  1005,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,  1010,     0,   289,     0,   290,   291,   292,     0,
     293,     0,   294,   719,     0,   720,   295,   296,   297,     0,
     298,  1013,     0,   300,     0,   301,   302,   303,   304,   305,
     721,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,   722,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,   723,   724,   325,   725,   326,
     327,   328,   329,   330,   331,   332,     0,   333,  1017,   726,
     335,   727,     0,   336,   337,   338,  1018,  1019,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   728,   352,   353,   354,   355,     0,   356,   357,   729,
     358,     0,  1024,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,   730,   731,
     732,  1027,   371,   372,   373,   374,   375,   376,   377,     0,
     378,  1028,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   733,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,  1031,   425,   426,   427,   428,   734,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,  1033,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   451,   452,     0,     0,   453,  1036,
     455,  1037,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,  1040,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,   735,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,   495,   496,   497,     0,     0,     0,     0,     0,     0,
     755,  1234,   550,     0,     0,     0,   597,     0,     0,     0,
    3471,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   713,   216,   217,   218,   219,
     220,   714,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   715,     0,   238,   239,   240,   241,
     716,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,   717,   250,   251,     0,     0,     0,   718,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,  1467,   289,     0,   290,
     291,   292,     0,   293,     0,   294,   719,     0,   720,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,   721,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,   722,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,   723,   724,
     325,   725,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,   726,   335,   727,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   728,   352,   353,   354,   355,     0,
     356,   357,   729,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,  1468,     0,   366,   367,   368,     0,     0,
     369,   730,   731,   732,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   733,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
     734,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,  1469,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,   735,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,     0,     0,     0,
       0,     0,     0,   755,  1235,  1236,  3594,     0,     0,     0,
       0,     0,     0,  3595,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     3,     4,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,   713,   216,
     217,   218,   219,   220,   714,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,   715,     0,   238,
     239,   240,   241,   716,   242,   243,     0,   244,   245,   246,
     247,   248,   249,     0,   717,   250,   251,     0,     0,     0,
     718,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,   719,
       0,   720,   295,   296,   297,     0,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   305,   721,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,   722,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,   723,   724,   325,   725,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,   726,   335,   727,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   728,   352,   353,
     354,   355,     0,   356,   357,   729,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,   730,   731,   732,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     733,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,    37,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   734,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,    41,   445,   446,   447,   448,   449,   450,     0,
     451,   452,     0,     0,   453,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     924,   475,     0,   476,   735,   477,   478,   479,     0,     0,
     480,     0,    46,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
       0,     0,     0,     0,     0,     0,   712,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    47,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,   713,   216,   217,   218,   219,   220,   714,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     715,     0,   238,   239,   240,   241,   716,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,   717,   250,   251,
       0,     0,     0,   718,     0,     0,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,     0,   293,
       0,   294,   719,     0,   720,   295,   296,   297,     0,   298,
     299,     0,   300,     0,   301,   302,   303,   304,   305,   721,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,   722,   316,   317,   318,   319,   320,   321,   322,
       0,   323,     0,   324,   723,   724,   325,   725,   326,   327,
     328,   329,   330,   331,   332,     0,   333,   334,   726,   335,
     727,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     728,   352,   353,   354,   355,     0,   356,   357,   729,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,   730,   731,   732,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   733,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,   734,   429,   430,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,   451,   452,     0,     0,   453,   454,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,   476,   735,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     0,     0,     0,     0,     0,     0,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3997,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,     0,     0,   238,   239,   240,   241,     0,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
       0,   250,   251,     0,     0,     0,     0,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,     0,   293,     0,   294,     0,     0,     0,   295,   296,
     297,     0,   298,   299,     0,   300,     0,   301,   302,   303,
     304,   305,     0,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   331,   332,     0,   333,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    37,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,    41,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     453,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,     0,
       0,   469,   470,   471,   472,   473,   924,   475,     0,   476,
       0,   477,   478,   479,     0,     0,   480,     0,    46,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,     0,     0,     0,     0,
       0,     0,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    47,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,     0,     0,   238,   239,
     240,   241,     0,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,     0,   250,   251,     0,     0,     0,     0,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,     0,   293,     0,   294,     0,     0,
       0,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,   305,     0,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,     0,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
       0,     0,   325,     0,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,     0,   335,     0,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,     0,   352,   353,   354,
     355,     0,   356,   357,     0,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,   369,     0,     0,     0,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,     0,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   451,
     452,     0,     0,   453,   454,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,     0,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,     0,
       0,     0,     0,     0,     0,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1106,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
       0,   216,   217,   218,   219,   220,     0,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,     0,
       0,   238,   239,   240,   241,     0,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,     0,   250,   251,     0,
       0,     0,     0,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,     0,   293,     0,
     294,     0,     0,     0,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,   305,     0,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,     0,     0,   325,     0,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,   476,     0,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,     0,     0,     0,     0,     0,     0,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2414,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,     0,     0,   238,   239,   240,   241,     0,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,     0,
     250,   251,     0,     0,     0,     0,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,     0,     0,     0,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
     305,     0,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,     0,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,     0,     0,     0,     0,     0,
       0,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3434,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,     0,     0,   238,   239,   240,
     241,     0,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,     0,   250,   251,     0,     0,     0,     0,     0,
       0,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,     0,     0,     0,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,   305,     0,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,     0,
       0,   325,     0,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,     0,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     0,     0,
       0,     0,     0,     0,  1333,  1234,   550,     0,     0,   764,
     597,     0,     0,     0,  3764,   200,   201,   202,   203,   204,
     205,   206,   207,  1669,   209,   210,   211,  1670,  1671,  1672,
    1673,  1674,  1675,  1676,   212,   213,  1677,   214,   215,   713,
     216,   217,   218,     0,  1334,   714,  1335,  1336,  1678,   223,
     224,   225,   226,   227,  1679,  1680,   228,   229,  1337,  1338,
     232,  1681,   233,   234,   235,   236,     0,  1682,   715,  1683,
     238,   239,   240,   241,   716,   242,   243,  1684,   244,   245,
     246,   247,   248,   249,  1685,   717,   250,   251,  1686,  1687,
    1688,   718,  1689,  1690,  1691,   252,   253,   254,   255,   256,
     257,  1339,  1340,   260,  1692,   261,  1693,   262,   263,   264,
     265,   266,  1694,   267,   268,   269,  1695,  1696,   270,   271,
    1008,   273,   274,  1697,   275,   276,   277,  1698,   278,   279,
    1699,   280,   281,   282,   283,     0,   285,   286,   287,     0,
    1700,   289,  1701,   290,  1341,   292,  1702,   293,  1703,   294,
     719,  1704,   720,   295,   296,   297,  1705,   298,     0,  1706,
     300,  1707,   301,   302,   303,   304,   305,   721,   306,   307,
     308,  1708,   309,   310,   311,   312,   313,   314,  1709,   315,
     722,     0,   317,   318,   319,   320,  1342,  1343,  1710,  1344,
    1711,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,  1712,   333,     0,   726,   335,   727,  1713,
     336,   337,   338,  1714,  1715,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1345,   728,  1346,
     353,   354,     0,  1716,   356,   357,   729,   358,  1717,     0,
     360,  1347,   362,   363,   364,  1718,   365,  1719,  1720,  3168,
     367,   368,  1721,  1722,     0,   730,   731,   732,     0,   371,
     372,   373,   374,   375,   376,   377,  1723,   378,     0,   380,
       0,   382,   383,   384,  1724,   385,   386,   387,   388,   389,
     390,   391,  1348,   393,   394,   395,   396,  1725,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,  1726,   407,
     408,   733,   409,   410,     0,   412,   413,   414,   415,   416,
     417,   418,   419,  1727,   420,   421,   422,   423,   424,  1728,
     425,  1886,   427,   428,   734,   429,  1350,   431,  1729,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,     0,
    1730,   443,   444,  1731,   445,   446,   447,   448,   449,   450,
    1732,  1351,  1352,  1733,  1734,   453,     0,   455,     0,  1735,
     457,   458,   459,   460,   461,   462,   463,  1736,  1737,   464,
     465,   466,   467,   468,  1738,  1739,   469,   470,   471,   472,
     473,     0,  1353,  1740,   476,   735,   477,   478,   479,  1741,
    1742,   480,  1743,  1744,   481,   482,   483,   484,   485,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   495,   496,
     497,     0,     0,     0,   767,   768,   769,     0,  3169,  3170,
     772,   773,   774,   775,   199,     0,     0,     0,     0,   764,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   765,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   766,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     0,     0,     0,   767,   768,   769,     0,   770,   771,
     772,   773,   774,   775,   199,     0,     0,     0,     0,   764,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   852,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   853,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     0,     0,     0,   767,   768,   769,     0,   770,   771,
     772,   773,   774,   775,   199,     0,     0,     0,     0,   764,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   897,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   898,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   899,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     0,     0,     0,   767,   768,   769,     0,   770,   771,
     772,   773,   774,   775,   199,     0,     0,     0,     0,   764,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,  1316,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,  1317,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     0,     0,     0,   767,   768,   769,     0,   770,   771,
     772,   773,   774,   775,   199,     0,     0,     0,     0,   764,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     0,     0,     0,   767,   768,   769,     0,   770,   771,
     772,   773,   774,   775,   199,     0,     0,     0,     0,   764,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,  2474,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,  2475,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     0,     0,     0,   767,   768,   769,     0,   770,   771,
     772,   773,   774,   775,   199,     0,     0,     0,     0,   764,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,  3981,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     0,     0,  1668,   767,   768,   769,     0,   770,   771,
     772,   773,   774,   775,   200,   201,   202,   203,   204,   205,
     206,   207,  1669,   209,   210,   211,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,   212,   213,  1677,   214,   215,   713,   216,
     217,   218,   219,   220,   714,   221,   222,  1678,   223,   224,
     225,   226,   227,  1679,  1680,   228,   229,   230,   231,   232,
    1681,   233,   234,   235,   236,   237,  1682,   715,  1683,   238,
     239,   240,   241,   716,   242,   243,  1684,   244,   245,   246,
     247,   248,   249,  1685,   717,   250,   251,  1686,  1687,  1688,
     718,  1689,  1690,  1691,   252,   253,   254,   255,   256,   257,
     258,   259,   260,  1692,   261,  1693,   262,   263,   264,   265,
     266,  1694,   267,   268,   269,  1695,  1696,   270,   271,   272,
     273,   274,  1697,   275,   276,   277,  1698,   278,   279,  1699,
     280,   281,   282,   283,   284,   285,   286,   287,   288,  1700,
     289,  1701,   290,   291,   292,  1702,   293,  1703,   294,   719,
    1704,   720,   295,   296,   297,  1705,   298,   299,  1706,   300,
    1707,   301,   302,   303,   304,   305,   721,   306,   307,   308,
    1708,   309,   310,   311,   312,   313,   314,  1709,   315,   722,
     316,   317,   318,   319,   320,   321,   322,  1710,   323,  1711,
     324,   723,   724,   325,   725,   326,   327,   328,   329,   330,
     331,   332,  1712,   333,   334,   726,   335,   727,  1713,   336,
     337,   338,  1714,  1715,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   728,   352,   353,
     354,   355,  1716,   356,   357,   729,   358,  1717,   359,   360,
     361,   362,   363,   364,  1718,   365,  1719,  1720,   366,   367,
     368,  1721,  1722,   369,   730,   731,   732,   370,   371,   372,
     373,   374,   375,   376,   377,  1723,   378,   379,   380,   381,
     382,   383,   384,  1724,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,  1725,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,  1726,   407,   408,
     733,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,  1727,   420,   421,   422,   423,   424,  1728,   425,
     426,   427,   428,   734,   429,   430,   431,  1729,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  1730,
     443,   444,  1731,   445,   446,   447,   448,   449,   450,  1732,
     451,   452,  1733,  1734,   453,   454,   455,   456,  1735,   457,
     458,   459,   460,   461,   462,   463,  1736,  1737,   464,   465,
     466,   467,   468,  1738,  1739,   469,   470,   471,   472,   473,
     474,   475,  1740,   476,   735,   477,   478,   479,  1741,  1742,
     480,  1743,  1744,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     199,     0,     0,     0,     0,     0,     0,     0,     0,  1745,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,     0,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0,     0,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   199,     0,     0,
       0,     0,     0,     0,     0,     0,   682,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,     0,     0,   238,   239,   240,   241,     0,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,     0,   250,
     251,     0,     0,     0,     0,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,     0,
     293,     0,   294,     0,     0,     0,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,   305,
       0,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,     0,     0,   325,     0,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   451,   452,     0,     0,   453,   454,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,     0,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,  1333,     0,     0,     0,     0,     0,
       0,     0,     0,  3860,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,     0,  1334,   714,  1335,  1336,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,  1337,  1338,
     232,     0,   233,   234,   235,   236,     0,     0,   715,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,     0,     0,
       0,   718,     0,     0,     0,   252,   253,   254,   255,   256,
     257,  1339,  1340,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
    1008,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,     0,   285,   286,   287,     0,
       0,   289,     0,   290,  1341,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,     0,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,     0,   317,   318,   319,   320,  1342,  1343,     0,  1344,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,     0,   726,   335,   727,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1345,   728,  1346,
     353,   354,     0,     0,   356,   357,   729,   358,     0,     0,
     360,  1347,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,     0,   730,   731,   732,     0,   371,
     372,   373,   374,   375,   376,   377,     0,   378,     0,   380,
       0,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1348,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,     0,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,  1349,   427,   428,   734,   429,  1350,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,     0,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,  1351,  1352,     0,     0,   453,     0,   455,     0,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,     0,  1353,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,     0,
       0,  2032,     0,     0,     0,     0,     0,     0,   495,   496,
     497,     0,   200,   201,   202,   203,   204,   205,   206,   207,
    1800,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,   713,   216,   217,   218,
       0,  1334,   714,  1335,  1336,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,  1337,  1338,   232,     0,   233,
     234,   235,   236,     0,     0,   715,     0,   238,   239,   240,
     241,   716,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,   717,   250,   251,     0,     0,     0,   718,     0,
       0,     0,   252,   253,   254,   255,   256,   257,  1339,  1340,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,  1008,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,     0,   285,   286,   287,     0,     0,   289,     0,
     290,  1341,   292,     0,   293,     0,   294,   719,     0,   720,
     295,   296,   297,     0,   298,     0,     0,   300,     0,   301,
     302,   303,   304,   305,   721,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,   722,     0,   317,
     318,   319,   320,  1342,  1343,     0,  1344,     0,   324,   723,
     724,   325,   725,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   726,   335,   727,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,  1345,   728,  1346,   353,   354,     0,
       0,   356,   357,   729,   358,     0,     0,   360,  1347,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,     0,   730,   731,   732,     0,   371,   372,   373,   374,
     375,   376,   377,     0,   378,     0,   380,     0,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1348,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   733,   409,
     410,     0,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,  1349,   427,
     428,   734,   429,  1350,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,  1351,  1352,
       0,     0,   453,     0,   455,     0,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,     0,  1353,
       0,   476,   735,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,     0,     0,   755,  1234,
     550,     0,     0,     0,   597,   495,   496,   497,     0,   200,
     201,   202,   203,   204,   205,   206,   207,  1800,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,   219,   220,   714,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   715,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,     0,     0,     0,   718,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,  1658,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,  1467,   289,     0,   290,   291,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
     305,   721,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
     726,   335,   727,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   728,   352,   353,   354,   355,     0,   356,   357,
     729,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,  1468,     0,   366,   367,   368,     0,     0,   369,   730,
     731,   732,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,   734,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,  1469,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   755,  1234,   550,     0,     0,
       0,   597,  1235,  1236,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
     713,   216,   217,   218,   219,   220,   714,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,   715,
       0,   238,   239,   240,   241,   716,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,   717,   250,   251,     0,
       0,     0,   718,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,  1663,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,  1467,   289,     0,   290,   291,   292,     0,   293,     0,
     294,   719,     0,   720,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,   305,   721,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,   722,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,   723,   724,   325,   725,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,   726,   335,   727,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   728,
     352,   353,   354,   355,     0,   356,   357,   729,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,  1468,     0,
     366,   367,   368,     0,     0,   369,   730,   731,   732,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   733,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   734,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
    1469,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,   476,   735,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   755,  1234,   550,     0,     0,     0,   597,  1235,
    1236,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   713,   216,   217,
     218,   219,   220,   714,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   715,     0,   238,   239,
     240,   241,   716,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,   717,   250,   251,     0,     0,     0,   718,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,  1467,   289,
       0,   290,   291,   292,     0,   293,     0,   294,   719,     0,
     720,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,   305,   721,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,   722,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
     723,   724,   325,   725,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,   726,   335,   727,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   728,   352,   353,   354,
     355,     0,   356,   357,   729,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,  1468,     0,   366,   367,   368,
       0,     0,   369,   730,   731,   732,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   733,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   734,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   451,
     452,     0,     0,   453,   454,   455,   456,  1469,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,   735,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   199,
       0,     0,     0,     0,     0,   597,  1235,  1236,     0,     0,
     200,   598,   202,   203,   204,   205,   206,   207,   599,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   600,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,     0,     0,   238,   239,   240,   241,     0,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
       0,   250,   251,     0,     0,     0,     0,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   601,   291,
     292,     0,   293,     0,   602,     0,   603,     0,   295,   296,
     297,     0,   298,   299,     0,   300,     0,   301,   302,   303,
     304,   305,     0,   306,   307,   308,   604,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,     0,     0,   325,
       0,   326,   327,   328,   329,   605,   331,   332,     0,   333,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   606,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     607,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   608,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     453,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,   476,
       0,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,  1668,  4272,   550,     0,
       0,     0,   597,   609,   610,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,  1669,   209,   210,   211,  1670,
    1671,  1672,  1673,  1674,  1675,  1676,   212,   213,  1677,   214,
     215,   713,   216,   217,   218,   219,   220,   714,   221,   222,
    1678,   223,   224,   225,   226,   227,  1679,  1680,   228,   229,
     230,   231,   232,  1681,   233,   234,   235,   236,   237,  1682,
     715,  1683,   238,   239,   240,   241,   716,   242,   243,  1684,
     244,   245,   246,   247,   248,   249,  1685,   717,   250,   251,
    1686,  1687,  1688,   718,  1689,  1690,  1691,   252,   253,   254,
     255,   256,   257,   258,   259,   260,  1692,   261,  1693,   262,
     263,   264,   265,   266,  1694,   267,   268,   269,  1695,  1696,
     270,   271,   272,   273,   274,  1697,   275,   276,   277,  1698,
     278,   279,  1699,   280,   281,   282,   283,   284,   285,   286,
     287,   288,  1700,   289,  1701,   290,   291,   292,  1702,   293,
    1703,   294,   719,  1704,   720,   295,   296,   297,  1705,   298,
     299,  1706,   300,  1707,   301,   302,   303,   304,   305,   721,
     306,   307,   308,  1708,   309,   310,   311,   312,   313,   314,
    1709,   315,   722,   316,   317,   318,   319,   320,   321,   322,
    1710,   323,  1711,   324,   723,   724,   325,   725,   326,   327,
     328,   329,   330,   331,   332,  1712,   333,   334,   726,   335,
     727,  1713,   336,   337,   338,  1714,  1715,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     728,   352,   353,   354,   355,  1716,   356,   357,   729,   358,
    1717,   359,   360,   361,   362,   363,   364,  1718,   365,  1719,
    1720,   366,   367,   368,  1721,  1722,   369,   730,   731,   732,
     370,   371,   372,   373,   374,   375,   376,   377,  1723,   378,
     379,   380,   381,   382,   383,   384,  1724,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,  1725,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
    1726,   407,   408,   733,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,  1727,   420,   421,   422,   423,
     424,  1728,   425,   426,   427,   428,   734,   429,   430,   431,
    1729,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,  1730,   443,   444,  1731,   445,   446,   447,   448,
     449,   450,  1732,   451,   452,  1733,  1734,   453,   454,   455,
     456,  1735,   457,   458,   459,   460,   461,   462,   463,  1736,
    1737,   464,   465,   466,   467,   468,  1738,  1739,   469,   470,
     471,   472,   473,   474,   475,  1740,   476,   735,   477,   478,
     479,  1741,  1742,   480,  1743,  1744,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,  1668,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,  1669,   209,   210,   211,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,   212,   213,  1677,   214,   215,   713,   216,
     217,   218,   219,   220,   714,   221,   222,  1678,   223,   224,
     225,   226,   227,  1679,  1680,   228,   229,   230,   231,   232,
    1681,   233,   234,   235,   236,   237,  1682,   715,  1683,   238,
     239,   240,   241,   716,   242,   243,  1684,   244,   245,   246,
     247,   248,   249,  1685,   717,   250,   251,  1686,  1687,  1688,
     718,  1689,  1690,  1691,   252,   253,   254,   255,   256,   257,
     258,   259,   260,  1692,   261,  1693,   262,   263,   264,   265,
     266,  1694,   267,   268,   269,  1695,  1696,   270,   271,   272,
     273,   274,  1697,   275,   276,   277,  1698,   278,   279,  1699,
     280,   281,   282,   283,   284,   285,   286,   287,   288,  1700,
     289,  1701,   290,   291,   292,  1702,   293,  1703,   294,   719,
    1704,   720,   295,   296,   297,  1705,   298,   299,  1706,   300,
    1707,   301,   302,   303,   304,   305,   721,   306,   307,   308,
    1708,   309,   310,   311,   312,   313,   314,  1709,   315,   722,
     316,   317,   318,   319,   320,   321,   322,  1710,   323,  1711,
     324,   723,   724,   325,   725,   326,   327,   328,   329,   330,
     331,   332,  1712,   333,   334,   726,   335,   727,  1713,   336,
     337,   338,  1714,  1715,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   728,   352,   353,
     354,   355,  1716,   356,   357,   729,   358,  1717,   359,   360,
     361,   362,   363,   364,  1718,   365,  1719,  1720,   366,   367,
     368,  1721,  1722,   369,   730,   731,   732,   370,   371,   372,
     373,   374,   375,   376,   377,  1723,   378,   379,   380,   381,
     382,   383,   384,  1724,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,  1725,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,  1726,   407,   408,
     733,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,  1727,   420,   421,   422,   423,   424,  1728,   425,
     426,   427,   428,   734,   429,   430,   431,  1729,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  1730,
     443,   444,  1731,   445,   446,   447,   448,   449,   450,  1732,
     451,   452,  1733,  1734,   453,   454,   455,   456,  1735,   457,
     458,   459,   460,   461,   462,   463,  1736,  1737,   464,   465,
     466,   467,   468,  1738,  1739,   469,   470,   471,   472,   473,
     474,   475,  1740,   476,   735,   477,   478,   479,  1741,  1742,
     480,  1743,  1744,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
    1668,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,  2539,   205,   206,   207,  1669,
     209,   210,   211,  1670,  1671,  1672,  1673,  1674,  1675,  1676,
     212,   213,  1677,   214,   215,   713,   216,   217,   218,   219,
     220,   714,   221,   222,  1678,   223,   224,   225,   226,   227,
    1679,  1680,   228,   229,   230,   231,   232,  1681,   233,   234,
     235,   236,   237,  1682,   715,  1683,   238,   239,   240,   241,
     716,   242,   243,  1684,   244,   245,   246,   247,   248,   249,
    1685,   717,   250,   251,  1686,  1687,  1688,   718,  1689,  1690,
    1691,   252,   253,   254,   255,   256,   257,   258,   259,   260,
    1692,   261,  1693,   262,   263,   264,   265,   266,  1694,   267,
     268,   269,  1695,  1696,   270,   271,   272,  2540,   274,  1697,
     275,   276,   277,  1698,   278,   279,  1699,   280,   281,   282,
     283,   284,   285,   286,   287,   288,  1700,   289,  1701,   290,
     291,   292,  1702,   293,  1703,   294,   719,  1704,   720,   295,
     296,   297,  1705,   298,   299,  1706,   300,  1707,   301,   302,
     303,   304,   305,   721,   306,   307,   308,  1708,   309,   310,
     311,   312,   313,   314,  1709,   315,   722,   316,   317,   318,
     319,   320,   321,   322,  1710,   323,  1711,   324,   723,   724,
     325,   725,   326,   327,   328,   329,   330,   331,   332,  1712,
     333,   334,   726,   335,   727,  1713,   336,   337,   338,  1714,
    1715,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   728,   352,   353,   354,   355,  1716,
     356,   357,   729,   358,  1717,   359,   360,   361,   362,   363,
     364,  1718,   365,  1719,  1720,   366,   367,   368,  1721,  1722,
     369,   730,   731,   732,   370,   371,   372,   373,   374,   375,
     376,   377,  1723,   378,   379,   380,   381,   382,   383,   384,
    1724,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,  1725,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,  1726,   407,   408,   733,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,  1727,
     420,   421,   422,   423,   424,  1728,  2541,   426,   427,   428,
     734,   429,   430,   431,  1729,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1730,   443,   444,  1731,
     445,   446,   447,   448,   449,   450,  1732,   451,   452,  1733,
    1734,   453,   454,   455,   456,  1735,   457,   458,   459,   460,
     461,   462,   463,  1736,  1737,   464,   465,   466,   467,   468,
    1738,  1739,   469,   470,   471,   472,   473,   474,   475,  1740,
     476,   735,   477,   478,   479,  1741,  1742,   480,  1743,  1744,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   755,     0,   550,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   713,   216,   217,   218,   219,   220,   714,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   715,     0,   238,   239,   240,   241,   716,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,   717,   250,
     251,     0,     0,     0,   718,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,  1467,   289,     0,   290,   291,   292,     0,
     293,     0,   294,   719,     0,   720,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,   305,
     721,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,   722,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,   723,   724,   325,   725,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,   726,
     335,   727,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   728,   352,   353,   354,   355,     0,   356,   357,   729,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
    1468,     0,   366,   367,   368,     0,     0,   369,   730,   731,
     732,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   733,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   734,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   451,   452,     0,     0,   453,   454,
     455,   456,  1469,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,   735,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   755,     0,   550,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,   219,   220,   714,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   715,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,     0,     0,
       0,   718,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,  1643,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,   721,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,   726,   335,   727,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   728,   352,
     353,   354,   355,     0,   356,   357,   729,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,   730,   731,   732,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,   734,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   755,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,   713,   216,   217,   218,
     219,   220,   714,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,   715,     0,   238,   239,   240,
     241,   716,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,   717,   250,   251,     0,     0,     0,   718,     0,
       0,  1991,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,   719,     0,   720,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,   305,   721,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,   722,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,   723,
     724,   325,   725,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,   726,   335,   727,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   728,   352,   353,   354,   355,
       0,   356,   357,   729,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,   730,   731,   732,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   733,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   734,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,  1992,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,   735,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   755,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     3,     4,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,   219,   220,   714,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   715,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,     0,     0,     0,   718,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
     305,   721,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
     726,   335,   727,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   728,   352,   353,   354,   355,     0,   356,   357,
     729,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,   730,
     731,   732,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,   734,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   755,     0,   550,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
     713,   216,   217,   218,   219,   220,   714,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,   715,
       0,   238,   239,   240,   241,   716,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,   717,   250,   251,     0,
       0,     0,   718,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,     0,   293,     0,
     294,   719,     0,   720,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,   305,   721,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,   722,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,   723,   724,   325,   725,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,   726,   335,   727,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   728,
     352,   353,   354,   355,     0,   356,   357,   729,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,   730,   731,   732,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   733,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   734,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,   476,   735,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   755,     0,   550,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   713,   216,   217,
     218,   219,   220,   714,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   715,     0,   238,   239,
     240,   241,   716,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,   717,   250,   251,     0,     0,     0,   718,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,     0,   293,     0,   294,   719,     0,
     720,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,  1457,   721,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,   722,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
     723,   724,   325,   725,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,   726,   335,   727,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   728,   352,   353,   354,
     355,     0,   356,   357,   729,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,   369,   730,   731,   732,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   733,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   734,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   451,
     452,     0,     0,   453,   454,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,   735,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   755,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,   713,   216,   217,   218,   219,   220,
     714,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,   715,     0,   238,   239,   240,   241,   716,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
     717,   250,   251,     0,     0,     0,   718,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,     0,   293,     0,   294,   719,     0,   720,   295,   296,
     297,     0,   298,   299,  2802,   300,     0,   301,   302,   303,
     304,   305,   721,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,   722,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,   723,   724,   325,
     725,   326,   327,   328,   329,   330,   331,   332,     0,   333,
     334,   726,   335,   727,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   728,   352,   353,   354,   355,     0,   356,
     357,   729,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
     730,   731,   732,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   733,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   734,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     453,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,   476,
     735,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   712,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,   713,   216,   217,   218,   219,   220,   714,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     715,     0,   238,   239,   240,   241,   716,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,   717,   250,   251,
       0,     0,     0,   718,     0,     0,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,     0,   293,
       0,   294,   719,     0,   720,   295,   296,   297,     0,   298,
     299,     0,   300,     0,   301,   302,   303,   304,   305,   721,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,   722,   316,   317,   318,   319,   320,   321,   322,
       0,   323,     0,   324,   723,   724,   325,   725,   326,   327,
     328,   329,   330,   331,   332,     0,   333,   334,   726,   335,
     727,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     728,   352,   353,   354,   355,     0,   356,   357,   729,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,   730,   731,   732,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   733,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,   734,   429,   430,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,   451,   452,     0,     0,   453,   454,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,   476,   735,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   755,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,   713,   216,
     217,   218,   219,   220,   714,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,   715,     0,   238,
     239,   240,   241,   716,   242,   243,     0,   244,   245,   246,
     247,   248,   249,     0,   717,   250,   251,     0,     0,     0,
     718,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,   719,
       0,   720,   295,   296,   297,     0,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   305,   721,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,   722,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,   723,   724,   325,   725,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,   726,   335,   727,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   728,   352,   353,
     354,   355,     0,   356,   357,   729,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,   730,   731,   732,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     733,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   734,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,     0,   445,   446,   447,   448,   449,   450,     0,
     451,   452,     0,     0,   453,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,   476,   735,   477,   478,   479,     0,     0,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     755,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   713,   216,   217,   218,   219,
     220,   714,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   715,     0,   238,   239,   240,   241,
     716,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,   717,   250,   251,     0,     0,     0,   718,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,   719,     0,   720,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,   721,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,   722,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,   723,   724,
     325,   725,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,   726,   335,   727,     0,   336,   337,   338,     0,
       0,   339,   340,   791,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   728,   352,   353,   354,   355,     0,
     356,   357,   729,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,   730,   731,   732,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   733,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
     734,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,   735,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   755,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   713,   216,   217,   218,   219,   220,   714,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   715,     0,   238,   239,   240,   241,   716,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,   717,   250,
     251,     0,     0,     0,   718,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,     0,
     293,     0,   294,   719,     0,   720,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,   305,
     721,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,   722,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,   723,   724,   325,   725,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,   726,
     335,   727,     0,   336,   337,   338,     0,     0,   339,   340,
     864,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   728,   352,   353,   354,   355,     0,   356,   357,   729,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,   730,   731,
     732,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   733,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   734,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   451,   452,     0,     0,   453,   454,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,   735,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   712,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   713,
     216,   217,   218,   219,   220,   714,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   715,     0,
     238,   239,   240,   241,   716,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,   717,   250,   251,     0,     0,
       0,   718,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
     719,     0,   720,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   882,   721,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
     722,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,   723,   724,   325,   725,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,   726,   335,   727,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   728,   352,
     353,   354,   355,     0,   356,   357,   729,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,   730,   731,   732,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   733,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,   734,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,   735,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   712,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,   713,   216,   217,   218,
     219,   220,   714,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,   715,     0,   238,   239,   240,
     241,   716,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,   717,   250,   251,     0,     0,     0,   718,     0,
       0,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,   719,     0,   720,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,   891,   721,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,   722,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,   723,
     724,   325,   725,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,   726,   335,   727,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   728,   352,   353,   354,   355,
       0,   356,   357,   729,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,   730,   731,   732,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   733,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   734,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,   735,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   755,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,   219,   220,   714,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   715,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,     0,     0,     0,   718,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
     893,   721,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
     726,   335,   727,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   728,   352,   353,   354,   355,     0,   356,   357,
     729,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,   730,
     731,   732,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,   734,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   755,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
     713,   216,   217,   218,   219,   220,   714,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,   715,
       0,   238,   239,   240,   241,   716,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,   717,   250,   251,     0,
       0,     0,   718,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,     0,   293,     0,
     294,   719,     0,   720,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,   902,   721,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,   722,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,   723,   724,   325,   725,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,   726,   335,   727,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   728,
     352,   353,   354,   355,     0,   356,   357,   729,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,   730,   731,   732,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   733,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   734,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,   476,   735,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   755,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   713,   216,   217,
     218,   219,   220,   714,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   715,     0,   238,   239,
     240,   241,   716,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,   717,   250,   251,     0,     0,     0,   718,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,     0,   293,     0,   294,   719,     0,
     720,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,   913,   721,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,   722,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
     723,   724,   325,   725,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,   726,   335,   727,     0,   336,   337,
     338,     0,     0,   339,   340,   914,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   728,   352,   353,   354,
     355,     0,   356,   357,   729,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,   369,   730,   731,   732,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   733,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   734,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   451,
     452,     0,     0,   453,   454,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,   735,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,  1824,   233,   234,   235,
     236,   237,     0,     0,  1899,   238,   239,   240,   241,     0,
     242,   243,  1825,   244,   245,   246,   247,   248,   249,     0,
       0,   250,   251,     0,     0,     0,     0,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,  1900,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,     0,   293,  1827,   294,     0,     0,     0,   295,   296,
     297,     0,   298,   299,     0,   300,     0,   301,   302,   303,
     304,   305,     0,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   331,   332,     0,   333,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,  1828,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     453,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,  1829,   464,   465,   466,   467,   468,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,   476,
       0,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,  1824,   233,   234,   235,   236,   237,     0,
       0,     0,   238,   239,   240,   241,     0,   242,   243,  1825,
     244,   245,   246,   247,   248,   249,     0,     0,   250,   251,
       0,     0,     0,     0,     0,     0,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,  1900,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,     0,   293,
    1827,   294,     0,     0,     0,   295,   296,   297,     0,   298,
     299,     0,   300,     0,   301,   302,   303,   304,   305,     0,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,     0,   316,   317,   318,   319,   320,   321,   322,
       0,   323,     0,   324,     0,     0,   325,     0,   326,   327,
     328,   329,   330,   331,   332,     0,   333,   334,     0,   335,
    2740,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,  1828,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,   451,   452,     0,     0,   453,   454,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,     0,
    1829,   464,   465,   466,   467,   468,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,   476,     0,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   647,
     206,   207,   616,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,     0,   216,
     217,   218,   219,   220,     0,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,     0,     0,   238,
     239,   240,   241,     0,   242,   243,     0,   244,   245,   246,
     247,   248,   249,   617,     0,   250,   251,     0,     0,     0,
       0,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,     0,
       0,     0,   295,   296,   297,   648,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   305,     0,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,     0,     0,   325,     0,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   618,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   619,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,     0,   445,   446,   447,   448,   449,   450,     0,
     451,   452,     0,     0,   453,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,   476,     0,   477,   478,   479,     0,     0,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,   616,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
     617,     0,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0,     0,   295,
     296,   297,  2442,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   618,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   619,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,  1824,   233,   234,   235,   236,   237,
       0,     0,     0,   238,   239,   240,   241,     0,   242,   243,
    1825,   244,   245,   246,   247,   248,   249,     0,     0,   250,
     251,     0,     0,     0,     0,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,  1900,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,     0,
     293,  1827,   294,     0,     0,     0,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,   305,
       0,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,     0,     0,   325,     0,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,  1828,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   451,   452,     0,     0,   453,   454,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
       0,  1829,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,     0,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,   616,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,   617,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   618,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   619,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
    1494,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,     0,     0,   238,   239,   240,
     241,     0,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,     0,   250,   251,     0,     0,     0,     0,     0,
       0,     0,   252,   253,   254,  1495,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,  1496,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,  1497,   294,     0,     0,     0,
    1498,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,   305,     0,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,     0,
       0,   325,     0,   326,   327,  1499,  1500,   330,   331,   332,
       0,   333,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,  1501,   416,   417,   418,   419,
       0,  1502,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
    1503,   445,  1504,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,  1505,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,     0,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,     0,     0,   238,   239,   240,   241,     0,   242,
     243,     0,   244,   245,   246,   247,   248,   249,   617,     0,
     250,   251,     0,     0,     0,     0,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,     0,     0,     0,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
     305,     0,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   618,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   619,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,     0,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     3,     4,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
       0,   216,   217,   218,   219,   220,     0,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,     0,
       0,   238,   239,   240,   241,     0,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,     0,   250,   251,     0,
       0,     0,     0,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,     0,   293,     0,
     294,     0,     0,     0,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,   305,     0,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,     0,     0,   325,     0,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,   476,     0,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,  2523,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,     0,     0,   238,   239,
     240,   241,     0,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,     0,   250,   251,     0,     0,     0,     0,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,     0,   293,     0,   294,     0,     0,
       0,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,   305,     0,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,     0,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
       0,     0,   325,     0,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,     0,   335,     0,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,     0,   352,   353,   354,
     355,     0,   356,   357,     0,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,   369,     0,     0,     0,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,     0,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   451,
     452,     0,     0,   453,   454,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,  2524,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,     0,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,  2535,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,     0,     0,   238,   239,   240,   241,     0,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
       0,   250,   251,     0,     0,     0,     0,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,     0,   293,     0,   294,     0,     0,     0,   295,   296,
     297,     0,   298,   299,     0,   300,     0,   301,   302,   303,
     304,   305,     0,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   331,   332,     0,   333,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     453,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,  2536,
       0,   469,   470,   471,   472,   473,   474,   475,     0,   476,
       0,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
       0,     0,   238,   239,   240,   241,     0,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,     0,   250,   251,
       0,     0,     0,     0,     0,     0,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,     0,   293,
       0,   294,     0,     0,     0,   295,   296,   297,     0,   298,
     299,     0,   300,     0,   301,   302,   303,   304,   305,     0,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,     0,   316,   317,   318,   319,   320,   321,   322,
       0,   323,     0,   324,     0,     0,   325,     0,   326,   327,
     328,   329,   330,   331,   332,     0,   333,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,   451,   452,     0,     0,   453,   454,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,   476,     0,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,   542,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,     0,   216,
     217,   218,   219,   220,     0,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,     0,     0,   238,
     239,   240,   241,     0,   242,   243,     0,   244,   245,   246,
     247,   248,   249,     0,     0,   250,   251,     0,     0,     0,
       0,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,     0,
       0,     0,   295,   296,   297,     0,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   305,     0,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,     0,     0,   325,     0,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   543,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,     0,   445,   446,   447,   448,   449,   450,     0,
     451,   452,     0,     0,   453,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,   476,     0,   477,   478,   479,     0,     0,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,   641,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,     0,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0,     0,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   642,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   643,   452,     0,
       0,   644,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,   671,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,     0,     0,   238,   239,   240,   241,     0,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,     0,   250,
     251,     0,     0,     0,     0,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,     0,
     293,     0,   294,     0,     0,     0,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,   305,
       0,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,     0,     0,   325,     0,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   672,     0,   425,   426,   427,   428,     0,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   673,   452,     0,     0,   674,   454,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,     0,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,   677,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,     0,     0,   238,   239,   240,
     241,     0,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,     0,   250,   251,     0,     0,     0,     0,     0,
       0,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,     0,     0,     0,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,   785,     0,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,     0,
       0,   325,     0,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,   677,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,     0,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,   875,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,     0,     0,   238,   239,   240,   241,     0,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,     0,
     250,   251,     0,     0,     0,     0,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,     0,     0,     0,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
     305,     0,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,     0,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,  1081,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
       0,   216,   217,   218,   219,   220,     0,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,     0,
       0,   238,   239,   240,   241,     0,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,     0,   250,   251,     0,
       0,     0,     0,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,     0,   293,     0,
     294,     0,     0,     0,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,   305,     0,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,     0,     0,   325,     0,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,   476,     0,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,  1092,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   658,   229,   230,   231,  1093,     0,
     233,   234,   235,   236,   237,     0,     0,     0,   238,   239,
     240,   241,     0,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,     0,   250,   251,     0,     0,     0,     0,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,     0,   293,     0,   294,     0,     0,
       0,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,   305,     0,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,     0,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
       0,     0,   325,     0,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,     0,   335,     0,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   661,   351,     0,   352,   353,   354,
     355,     0,   356,   357,     0,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,   369,     0,     0,     0,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,     0,
     662,   410,   411,   412,   413,   414,   663,   416,   417,   418,
     419,     0,   420,   421,   422,   423,  1085,     0,   425,   426,
     427,   428,     0,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   665,
     452,     0,     0,   666,   454,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,     0,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   667,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,     0,     0,   238,   239,   240,   241,     0,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
       0,   250,   251,     0,     0,     0,     0,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,     0,   293,     0,   294,     0,     0,     0,   295,   296,
     297,     0,   298,   299,     0,   300,     0,   301,   302,   303,
     304,  1189,     0,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   331,   332,     0,   333,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,   677,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     453,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,   476,
       0,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
       0,     0,   238,   239,   240,   241,     0,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,     0,   250,   251,
       0,     0,     0,     0,     0,     0,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,     0,   293,
       0,   294,     0,     0,     0,   295,   296,  2349,     0,   298,
     299,     0,   300,     0,   301,   302,   303,   304,   305,     0,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,     0,   316,   317,   318,   319,   320,   321,   322,
       0,   323,     0,   324,     0,     0,   325,     0,   326,   327,
     328,   329,   330,   331,   332,     0,   333,   334,     0,   335,
       0,     0,   336,   337,  2350,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,  2351,   445,   446,  2352,   448,
    2353,   450,     0,   451,   452,     0,     0,   453,   454,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,  2354,   467,   468,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,   476,     0,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   199,     0,   550,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,     0,   216,
     217,   218,   219,   220,     0,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,     0,     0,   238,
     239,   240,   241,     0,   242,   243,     0,   244,   245,   246,
     247,   248,   249,     0,     0,   250,   251,     0,     0,     0,
       0,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,     0,
       0,     0,   295,   296,   297,     0,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   305,     0,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,     0,     0,   325,     0,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,     0,   445,   446,   447,   448,   449,   450,     0,
     451,   452,     0,     0,   453,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,   476,     0,   477,   478,   479,     0,     0,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,  3407,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,     0,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0,     0,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,  3420,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,     0,     0,   238,   239,   240,   241,     0,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,     0,   250,
     251,     0,     0,     0,     0,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,     0,
     293,     0,   294,     0,     0,     0,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,   305,
       0,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,     0,     0,   325,     0,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   451,   452,     0,     0,   453,   454,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,     0,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,  3625,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   305,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,     0,     0,   238,   239,   240,
     241,     0,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,     0,   250,   251,     0,     0,     0,     0,     0,
       0,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,  3627,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,     0,     0,     0,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,   305,     0,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,     0,
       0,   325,     0,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,     0,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,     0,     0,   238,   239,   240,   241,     0,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,     0,
     250,   251,     0,     0,     0,     0,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,  3629,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,     0,     0,     0,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
     305,     0,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,     0,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
       0,   216,   217,   218,   219,   220,     0,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,     0,
       0,   238,   239,   240,   241,     0,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,     0,   250,   251,     0,
       0,     0,     0,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,     0,   293,     0,
     294,     0,     0,     0,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,   305,     0,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,     0,     0,   325,     0,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,  3984,   469,   470,   471,
     472,   473,   474,   475,     0,   476,     0,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,     0,     0,   238,   239,
     240,   241,     0,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,     0,   250,   251,     0,     0,     0,     0,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,     0,   293,     0,   294,     0,     0,
       0,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,   305,     0,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,     0,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
       0,     0,   325,     0,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,     0,   335,     0,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,     0,   352,   353,   354,
     355,     0,   356,   357,     0,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,   369,     0,     0,     0,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,     0,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   451,
     452,     0,     0,   453,   454,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,     0,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,     0,     0,   238,   239,   240,   241,     0,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
       0,   250,   251,     0,     0,     0,     0,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,     0,   293,     0,   294,     0,     0,     0,   295,   296,
     297,     0,   298,   299,     0,   300,     0,   301,   302,   303,
     304,   305,     0,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   331,   332,     0,   333,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     631,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,   476,
       0,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
       0,     0,   238,   239,   240,   241,     0,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,     0,   250,   251,
       0,     0,     0,     0,     0,     0,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,     0,   293,
       0,   294,     0,     0,     0,   295,   296,   297,     0,   298,
     299,     0,   300,     0,   301,   302,   303,   304,   305,     0,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,     0,   316,   317,   318,   319,   320,   321,   322,
       0,   323,     0,   324,     0,     0,   325,     0,   326,   327,
     328,   329,   330,   331,   332,     0,   333,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   639,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,   451,   452,     0,     0,   453,   454,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,   476,     0,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,     0,   216,
     217,   218,   219,   220,     0,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   658,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,     0,     0,   238,
     239,   240,   241,     0,   242,   243,     0,   659,   245,   246,
     247,   248,   249,     0,     0,   250,   251,     0,     0,     0,
       0,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,     0,
       0,     0,   295,   296,   297,     0,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   305,     0,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,     0,     0,   325,     0,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,     0,   335,     0,     0,   336,
     337,   660,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   661,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   662,   410,   411,   412,   413,   414,   663,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   664,     0,   425,
     426,   427,   428,     0,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,     0,   445,   446,   447,   448,   449,   450,     0,
     665,   452,     0,     0,   666,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,   476,     0,   477,   478,   479,     0,     0,
     480,     0,     0,   481,   482,   483,   484,   667,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,     0,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0,     0,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   689,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,     0,     0,   238,   239,   240,   241,     0,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,     0,   250,
     251,     0,     0,     0,     0,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,     0,
     293,     0,   294,     0,     0,     0,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,   761,
       0,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,     0,     0,   325,     0,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   451,   452,     0,     0,   453,   454,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,     0,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,   782,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,     0,     0,   238,   239,   240,
     241,     0,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,     0,   250,   251,     0,     0,     0,     0,     0,
       0,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,     0,     0,     0,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,   793,     0,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,     0,
       0,   325,     0,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,     0,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,     0,     0,   238,   239,   240,   241,     0,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,     0,
     250,   251,     0,     0,     0,     0,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,     0,     0,     0,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
     843,     0,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,     0,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
       0,   216,   217,   218,   219,   220,     0,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,     0,
       0,   238,   239,   240,   241,     0,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,     0,   250,   251,     0,
       0,     0,     0,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,     0,   293,     0,
     294,     0,     0,     0,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,   887,     0,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,     0,     0,   325,     0,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,   476,     0,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,     0,     0,   238,   239,
     240,   241,     0,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,     0,   250,   251,     0,     0,     0,     0,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,     0,   293,     0,   294,     0,     0,
       0,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,   904,     0,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,     0,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
       0,     0,   325,     0,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,     0,   335,     0,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,     0,   352,   353,   354,
     355,     0,   356,   357,     0,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,   369,     0,     0,     0,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,     0,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   451,
     452,     0,     0,   453,   454,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,     0,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,     0,     0,   238,   239,   240,   241,     0,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
       0,   250,   251,     0,     0,     0,     0,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,     0,   293,     0,   294,     0,     0,     0,   295,   296,
     297,     0,   298,   299,     0,   300,     0,   301,   302,   303,
     304,   906,     0,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   331,   332,     0,   333,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     453,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,   476,
       0,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
       0,     0,   238,   239,   240,   241,     0,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,     0,   250,   251,
       0,     0,     0,     0,     0,     0,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,     0,   293,
       0,   294,     0,     0,     0,   295,   296,   297,     0,   298,
     299,     0,   300,     0,   301,   302,   303,   304,   908,     0,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,     0,   316,   317,   318,   319,   320,   321,   322,
       0,   323,     0,   324,     0,     0,   325,     0,   326,   327,
     328,   329,   330,   331,   332,     0,   333,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,   451,   452,     0,     0,   453,   454,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,   476,     0,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,     0,   216,
     217,   218,   219,   220,     0,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,     0,     0,   238,
     239,   240,   241,     0,   242,   243,     0,   244,   245,   246,
     247,   248,   249,     0,     0,   250,   251,     0,     0,     0,
       0,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,     0,
       0,     0,   295,   296,   297,     0,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   911,     0,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,     0,     0,   325,     0,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,     0,   445,   446,   447,   448,   449,   450,     0,
     451,   452,     0,     0,   453,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,   476,     0,   477,   478,   479,     0,     0,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,     0,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0,     0,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   917,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   451,   452,     0,
       0,   453,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   658,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,     0,     0,   238,   239,   240,   241,     0,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,     0,   250,
     251,     0,     0,     0,     0,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,     0,
     293,     0,   294,     0,     0,     0,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,   305,
       0,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,     0,     0,   325,     0,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   661,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   662,   410,   411,   412,   413,
     414,   663,   416,   417,   418,   419,     0,   420,   421,   422,
     423,  1085,     0,   425,   426,   427,   428,     0,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   665,   452,     0,     0,   666,   454,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,     0,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   667,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,  1378,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,     0,     0,   238,   239,   240,
     241,     0,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,     0,   250,   251,     0,     0,     0,     0,     0,
       0,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,     0,     0,     0,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,  1405,     0,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,     0,
       0,   325,     0,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,     0,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,     0,     0,   238,   239,   240,   241,     0,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,     0,
     250,   251,     0,     0,     0,     0,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,     0,     0,     0,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
    1433,     0,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,     0,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
       0,   216,   217,   218,   219,   220,     0,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,     0,     0,
       0,   238,   239,   240,   241,     0,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,     0,   250,   251,     0,
       0,     0,     0,     0,     0,     0,   252,   253,   254,   255,
     256,   257,   258,   259,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,     0,   293,     0,
     294,     0,     0,     0,   295,   296,   297,     0,   298,   299,
       0,   300,     0,   301,   302,   303,   304,  1435,     0,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,   317,   318,   319,   320,   321,   322,     0,
     323,     0,   324,     0,     0,   325,     0,   326,   327,   328,
     329,   330,   331,   332,     0,   333,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,     0,   445,   446,   447,   448,   449,
     450,     0,   451,   452,     0,     0,   453,   454,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,   476,     0,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,     0,     0,   238,   239,
     240,   241,     0,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,     0,   250,   251,     0,     0,     0,     0,
       0,     0,     0,   252,   253,   254,   255,   256,   257,   258,
     259,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,     0,   293,     0,   294,     0,     0,
       0,   295,   296,   297,     0,   298,   299,     0,   300,     0,
     301,   302,   303,   304,  1437,     0,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,     0,   316,
     317,   318,   319,   320,   321,   322,     0,   323,     0,   324,
       0,     0,   325,     0,   326,   327,   328,   329,   330,   331,
     332,     0,   333,   334,     0,   335,     0,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,     0,   352,   353,   354,
     355,     0,   356,   357,     0,   358,     0,   359,   360,   361,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,   369,     0,     0,     0,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,     0,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,     0,   429,   430,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,   451,
     452,     0,     0,   453,   454,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,   476,     0,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,     0,     0,   238,   239,   240,   241,     0,
     242,   243,     0,   244,   245,   246,   247,   248,   249,     0,
       0,   250,   251,     0,     0,     0,     0,     0,     0,     0,
     252,   253,   254,   255,   256,   257,   258,   259,   260,     0,
     261,     0,   262,   263,   264,   265,   266,     0,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,   278,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,     0,   293,     0,   294,     0,     0,     0,   295,   296,
     297,     0,   298,   299,     0,   300,     0,   301,   302,   303,
     304,   305,     0,   306,   307,   308,     0,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,   317,   318,   319,
     320,   321,   322,     0,   323,     0,   324,     0,     0,   325,
       0,   326,   327,   328,   329,   330,   331,   332,     0,   333,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,  1528,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,   431,     0,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,     0,   445,
     446,   447,   448,   449,   450,     0,   451,   452,     0,     0,
     453,   454,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,   476,
       0,   477,   478,   479,     0,     0,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,  1797,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
       0,     0,   238,   239,   240,   241,     0,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,     0,   250,   251,
       0,     0,     0,     0,     0,     0,     0,   252,   253,   254,
     255,   256,   257,   258,   259,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,     0,   293,
       0,   294,     0,     0,     0,   295,   296,   297,     0,   298,
     299,     0,   300,     0,   301,   302,   303,   304,   305,     0,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,     0,   316,   317,   318,   319,   320,   321,   322,
       0,   323,     0,   324,     0,     0,   325,     0,   326,   327,
     328,   329,   330,   331,   332,     0,   333,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,     0,   426,   427,   428,     0,   429,   430,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,   451,   452,     0,     0,   453,   454,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,   476,     0,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,     0,   216,
     217,   218,   219,   220,     0,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   658,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,     0,     0,   238,
     239,   240,   241,     0,   242,   243,     0,   244,   245,   246,
     247,   248,   249,     0,     0,   250,   251,     0,     0,     0,
       0,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,     0,
       0,     0,   295,   296,   297,     0,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   305,     0,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,     0,     0,   325,     0,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   661,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   662,   410,   411,   412,   413,   414,   663,   416,   417,
     418,   419,     0,   420,   421,   422,   423,  1085,     0,   425,
     426,   427,   428,     0,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,     0,   445,  1815,   447,   448,   449,   450,     0,
     665,   452,     0,     0,   666,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,   476,     0,   477,   478,   479,     0,     0,
     480,     0,     0,   481,   482,   483,   484,   667,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   658,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,     0,     0,   238,   239,   240,   241,
       0,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,     0,   250,   251,     0,     0,     0,     0,     0,     0,
       0,   252,   253,   254,   255,   256,   257,   258,   259,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,     0,   293,     0,   294,     0,     0,     0,   295,
     296,   297,     0,   298,   299,     0,   300,     0,   301,   302,
     303,   304,   305,     0,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,   317,   318,
     319,   320,   321,   322,     0,   323,     0,   324,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,     0,
     333,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   661,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   662,   410,
     411,   412,   413,   414,  1875,   416,   417,   418,   419,     0,
     420,   421,   422,   423,  1876,     0,   425,   426,   427,   428,
       0,   429,   430,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,   665,   452,     0,
       0,  1877,   454,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
     476,     0,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   667,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,     0,     0,   238,   239,   240,   241,     0,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,     0,   250,
     251,     0,     0,     0,     0,     0,     0,     0,   252,   253,
     254,   255,   256,   257,   258,   259,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,     0,
     293,     0,   294,     0,     0,     0,   295,   296,   297,     0,
     298,   299,     0,   300,     0,   301,   302,   303,   304,  2124,
       0,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   317,   318,   319,   320,   321,
     322,     0,   323,     0,   324,     0,     0,   325,     0,   326,
     327,   328,   329,   330,   331,   332,     0,   333,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,   451,   452,     0,     0,   453,   454,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,   476,     0,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,  2453,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   658,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,     0,     0,   238,   239,   240,
     241,     0,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,     0,   250,   251,     0,     0,     0,     0,     0,
       0,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,     0,     0,     0,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,   305,     0,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,     0,
       0,   325,     0,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   661,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   662,
     410,   411,   412,   413,   414,   663,   416,   417,   418,   419,
       0,   420,   421,   422,   423,  1876,     0,   425,   426,   427,
     428,     0,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   665,   452,
       0,     0,  1877,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,     0,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   667,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,  1333,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,     0,  1334,   714,
    1335,  1336,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,  1337,  1338,   232,     0,   233,   234,   235,   236,
       0,     0,   715,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,     0,     0,     0,   718,     0,     0,     0,   252,
     253,   254,   255,   256,   257,  1339,  1340,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,  1008,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,     0,
     285,   286,   287,     0,     0,   289,     0,   290,  1341,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,     0,     0,   300,     0,   301,   302,   303,   304,
     305,   721,   306,   307,   308,  1883,   309,   310,   311,   312,
     313,   314,     0,   315,   722,  1884,   317,   318,   319,   320,
    1342,  1343,     0,  1344,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     726,   335,   727,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,  1345,   728,  1346,   353,   354,     0,     0,   356,   357,
     729,   358,     0,     0,   360,  1347,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,  1885,   730,
     731,   732,     0,   371,   372,   373,   374,   375,   376,   377,
       0,   378,     0,   380,     0,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1348,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,     0,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,  1886,   427,   428,   734,   429,
    1350,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,     0,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,  1351,  1352,     0,     0,   453,
       0,   455,     0,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,     0,  1353,  1887,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,     0,   199,     0,     0,     0,     0,     0,
       0,     0,   495,   496,   497,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,     0,     0,
     238,   239,   240,   241,     0,   242,   243,     0,   244,   245,
     246,   247,   248,   249,     0,     0,   250,   251,     0,     0,
       0,     0,     0,     0,     0,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,   261,     0,   262,   263,   264,
     265,   266,     0,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,   278,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,     0,   293,     0,   294,
       0,     0,     0,   295,   296,   297,     0,   298,   299,     0,
     300,     0,   301,   302,   303,   304,  2526,     0,   306,   307,
     308,     0,   309,   310,   311,   312,   313,   314,     0,   315,
       0,   316,   317,   318,   319,   320,   321,   322,     0,   323,
       0,   324,     0,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,     0,   333,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,   431,     0,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,     0,   445,   446,   447,   448,   449,   450,
       0,   451,   452,     0,     0,   453,   454,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,   476,     0,   477,   478,   479,     0,
       0,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,     0,     0,     0,   238,   239,   240,
     241,     0,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,     0,   250,   251,     0,     0,     0,     0,     0,
       0,     0,   252,   253,   254,   255,   256,   257,   258,   259,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,     0,   293,     0,   294,     0,     0,     0,
     295,   296,   297,     0,   298,   299,     0,   300,     0,   301,
     302,   303,   304,  2528,     0,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   317,
     318,   319,   320,   321,   322,     0,   323,     0,   324,     0,
       0,   325,     0,   326,   327,   328,   329,   330,   331,   332,
       0,   333,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,   451,   452,
       0,     0,   453,   454,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,   476,     0,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,     0,     0,   238,   239,   240,   241,     0,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,     0,
     250,   251,     0,     0,     0,     0,     0,     0,     0,   252,
     253,   254,   255,   256,   257,   258,   259,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
       0,   293,     0,   294,     0,     0,     0,   295,   296,   297,
       0,   298,   299,     0,   300,     0,   301,   302,   303,   304,
    2620,     0,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,   317,   318,   319,   320,
     321,   322,     0,   323,     0,   324,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   331,   332,     0,   333,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,   451,   452,     0,     0,   453,
     454,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,   474,   475,     0,   476,     0,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,  1333,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
     713,   216,   217,   218,     0,  1334,   714,  1335,  1336,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,  1337,
    1338,   232,     0,   233,   234,   235,   236,     0,     0,   715,
       0,   238,   239,   240,   241,   716,   242,   243,     0,   244,
     245,   246,   247,   248,   249,     0,   717,   250,   251,     0,
       0,     0,   718,     0,     0,     0,   252,   253,   254,   255,
     256,   257,  1339,  1340,   260,     0,   261,     0,   262,   263,
     264,   265,   266,     0,   267,   268,   269,     0,     0,   270,
     271,  1008,   273,   274,     0,   275,   276,   277,     0,   278,
     279,     0,   280,   281,   282,   283,     0,   285,   286,   287,
       0,     0,   289,     0,   290,  1341,   292,     0,   293,     0,
     294,   719,     0,   720,   295,   296,   297,     0,   298,     0,
       0,   300,     0,   301,   302,   303,   304,   305,   721,   306,
     307,   308,     0,   309,   310,   311,   312,   313,   314,     0,
     315,   722,     0,   317,   318,   319,   320,  1342,  1343,     0,
    1344,     0,   324,   723,   724,   325,   725,   326,   327,   328,
     329,   330,   331,   332,     0,   333,     0,   726,   335,   727,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,  1345,   728,
    1346,   353,   354,     0,     0,   356,   357,   729,   358,  1871,
       0,   360,  1347,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,     0,   730,   731,   732,     0,
     371,   372,   373,   374,   375,   376,   377,     0,   378,     0,
     380,     0,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1348,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   733,   409,   410,     0,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,  1886,   427,   428,   734,   429,  1350,   431,     0,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,     0,   443,   444,  3273,   445,   446,   447,   448,   449,
     450,     0,  1351,  1352,     0,     0,   453,     0,   455,     0,
       0,   457,   458,   459,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,   469,   470,   471,
     472,   473,     0,  1353,     0,   476,   735,   477,   478,   479,
       0,     0,   480,     0,     0,   481,   482,   483,   484,   485,
       0,  1333,     0,     0,     0,     0,     0,     0,     0,   495,
     496,   497,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,   713,   216,   217,   218,
       0,  1334,   714,  1335,  1336,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,  1337,  1338,   232,     0,   233,
     234,   235,   236,     0,     0,   715,     0,   238,   239,   240,
     241,   716,   242,   243,     0,   244,   245,   246,   247,   248,
     249,     0,   717,   250,   251,     0,     0,     0,   718,     0,
       0,     0,   252,   253,   254,   255,   256,   257,  1339,  1340,
     260,     0,   261,     0,   262,   263,   264,   265,   266,     0,
     267,   268,   269,     0,     0,   270,   271,  1008,   273,   274,
       0,   275,   276,   277,     0,   278,   279,     0,   280,   281,
     282,   283,     0,   285,   286,   287,     0,     0,   289,     0,
     290,  1341,   292,     0,   293,     0,   294,   719,     0,   720,
     295,   296,   297,     0,   298,     0,     0,   300,     0,   301,
     302,   303,   304,   305,   721,   306,   307,   308,     0,   309,
     310,   311,   312,   313,   314,     0,   315,   722,     0,   317,
     318,   319,   320,  1342,  1343,     0,  1344,     0,   324,   723,
     724,   325,   725,   326,   327,   328,   329,   330,   331,   332,
       0,   333,     0,   726,   335,   727,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,  1345,   728,  1346,   353,   354,  1935,
       0,   356,   357,   729,   358,     0,     0,   360,  1347,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,     0,   730,   731,   732,     0,   371,   372,   373,   374,
     375,   376,   377,     0,   378,     0,   380,     0,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1348,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   733,   409,
     410,     0,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,  1349,   427,
     428,   734,   429,  1350,   431,     0,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,     0,   443,   444,
       0,   445,   446,   447,   448,   449,   450,     0,  1351,  1352,
       0,     0,   453,     0,   455,     0,     0,   457,   458,   459,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,     0,     0,   469,   470,   471,   472,   473,     0,  1353,
       0,   476,   735,   477,   478,   479,     0,     0,   480,     0,
       0,   481,   482,   483,   484,   485,     0,  1333,     0,     0,
       0,     0,     0,     0,     0,   495,   496,   497,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   713,   216,   217,   218,     0,  1334,   714,  1335,
    1336,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,  1337,  1338,   232,     0,   233,   234,   235,   236,     0,
       0,   715,     0,   238,   239,   240,   241,   716,   242,   243,
       0,   244,   245,   246,   247,   248,   249,     0,   717,   250,
     251,     0,     0,     0,   718,     0,     0,     0,   252,   253,
     254,   255,   256,   257,  1339,  1340,   260,     0,   261,     0,
     262,   263,   264,   265,   266,     0,   267,   268,   269,     0,
       0,   270,   271,  1008,   273,   274,     0,   275,   276,   277,
       0,   278,   279,     0,   280,   281,   282,   283,     0,   285,
     286,   287,     0,     0,   289,     0,   290,  1341,   292,     0,
     293,     0,   294,   719,     0,   720,   295,   296,   297,     0,
     298,     0,     0,   300,     0,   301,   302,   303,   304,   305,
     721,   306,   307,   308,     0,   309,   310,   311,   312,   313,
     314,     0,   315,   722,     0,   317,   318,   319,   320,  1342,
    1343,     0,  1344,     0,   324,   723,   724,   325,   725,   326,
     327,   328,   329,   330,   331,   332,     0,   333,     0,   726,
     335,   727,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
    1345,   728,  1346,   353,   354,  3092,     0,   356,   357,   729,
     358,     0,     0,   360,  1347,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,     0,   730,   731,
     732,     0,   371,   372,   373,   374,   375,   376,   377,     0,
     378,     0,   380,     0,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1348,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   733,   409,   410,     0,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,  1349,   427,   428,   734,   429,  1350,
     431,     0,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,     0,   443,   444,     0,   445,   446,   447,
     448,   449,   450,     0,  1351,  1352,     0,     0,   453,     0,
     455,     0,     0,   457,   458,   459,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,   469,
     470,   471,   472,   473,     0,  1353,     0,   476,   735,   477,
     478,   479,     0,     0,   480,     0,     0,   481,   482,   483,
     484,   485,     0,   199,     0,     0,     0,     0,     0,     0,
       0,   495,   496,   497,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
       0,     0,     0,   212,   213,     0,   214,   215,     0,   216,
     217,   218,   219,   220,     0,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,     0,     0,     0,   238,
     239,   240,   241,     0,   242,   243,     0,   244,   245,   246,
     247,   248,   249,     0,     0,   250,   251,     0,     0,     0,
       0,     0,     0,     0,   252,   253,   254,   255,   256,   257,
     258,   259,   260,     0,   261,     0,   262,   263,   264,   265,
     266,     0,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,   278,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,     0,   293,     0,   294,     0,
       0,     0,   295,   296,   297,     0,   298,   299,     0,   300,
       0,   301,   302,   303,   304,   305,     0,   306,   307,   308,
       0,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   317,   318,   319,   320,   321,   322,     0,   323,     0,
     324,     0,     0,   325,     0,   326,   327,   328,   329,   330,
     331,   332,     0,   333,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,     0,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,     0,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,     0,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,   431,     0,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,     0,   445,   446,   447,   448,   449,   450,     0,
     451,   452,     0,     0,   453,   454,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,   476,     0,   477,   478,   479,     0,     0,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
    1333,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   713,   216,   217,   218,     0,
    1334,   714,  1335,  1336,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,  1337,  1338,   232,     0,   233,   234,
     235,   236,     0,     0,   715,     0,   238,   239,   240,   241,
     716,   242,   243,     0,   244,   245,   246,   247,   248,   249,
       0,   717,   250,   251,     0,     0,     0,   718,     0,     0,
       0,   252,   253,   254,   255,   256,   257,  1339,  1340,   260,
       0,   261,     0,   262,   263,   264,   265,   266,     0,   267,
     268,   269,     0,     0,   270,   271,  1008,   273,   274,     0,
     275,   276,   277,     0,   278,   279,     0,   280,   281,   282,
     283,     0,   285,   286,   287,     0,     0,   289,     0,   290,
    1341,   292,     0,   293,     0,   294,   719,     0,   720,   295,
     296,   297,     0,   298,     0,     0,   300,     0,   301,   302,
     303,   304,   305,   721,   306,   307,   308,     0,   309,   310,
     311,   312,   313,   314,     0,   315,   722,     0,   317,   318,
     319,   320,  1342,  1343,     0,  1344,     0,   324,   723,   724,
     325,   725,   326,   327,   328,   329,   330,   331,   332,     0,
     333,     0,   726,   335,   727,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,  1345,   728,  1346,   353,   354,     0,     0,
     356,   357,   729,   358,     0,     0,   360,  1347,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
       0,   730,   731,   732,     0,   371,   372,   373,   374,   375,
     376,   377,     0,   378,     0,   380,     0,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1348,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   733,   409,   410,
       0,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,  1349,   427,   428,
     734,   429,  1350,   431,     0,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,     0,     0,   443,   444,     0,
     445,   446,   447,   448,   449,   450,     0,  1351,  1352,     0,
       0,   453,     0,   455,     0,     0,   457,   458,   459,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
       0,     0,   469,   470,   471,   472,   473,     0,  1353,     0,
     476,   735,   477,   478,   479,     0,     0,   480,     0,     0,
     481,   482,   483,   484,   485,     0,  1333,     0,     0,     0,
       0,     0,     0,     0,   495,   496,   497,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,   713,   216,   217,   218,     0,  1334,   714,  1335,  1336,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
    1337,  1338,   232,     0,   233,   234,   235,   236,     0,     0,
     715,     0,   238,   239,   240,   241,   716,   242,   243,     0,
     244,   245,   246,   247,   248,   249,     0,   717,   250,   251,
       0,     0,     0,   718,     0,     0,     0,   252,   253,   254,
     255,   256,   257,  1339,  1340,   260,     0,   261,     0,   262,
     263,   264,   265,   266,     0,   267,   268,   269,     0,     0,
     270,   271,  1008,   273,   274,     0,   275,   276,   277,     0,
     278,   279,     0,   280,   281,   282,   283,     0,   285,   286,
     287,     0,     0,   289,     0,   290,  1341,   292,     0,   293,
       0,   294,   719,     0,   720,   295,   296,   297,     0,   298,
       0,     0,   300,     0,   301,   302,   303,   304,   305,   721,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
       0,   315,   722,     0,   317,   318,   319,   320,  1342,  1343,
       0,  1344,     0,   324,   723,   724,   325,   725,   326,   327,
     328,   329,   330,   331,   332,     0,   333,     0,   726,   335,
     727,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,  1345,
     728,  1346,   353,   354,     0,     0,   356,   357,   729,   358,
       0,     0,   360,  1347,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,     0,   730,   731,   732,
       0,   371,   372,   373,   374,   375,   376,   377,     0,   378,
       0,   380,     0,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1348,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   733,   409,   410,     0,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,  1886,   427,   428,   734,   429,  1350,   431,
       0,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,     0,   443,   444,     0,   445,   446,   447,   448,
     449,   450,     0,  1351,  1352,     0,     0,   453,     0,   455,
       0,     0,   457,   458,   459,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,   469,   470,
     471,   472,   473,     0,  1353,     0,   476,   735,   477,   478,
     479,     0,     0,   480,     0,     0,   481,   482,   483,   484,
     485,     0,  1333,     0,     0,     0,     0,     0,     0,     0,
     495,   496,   497,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   713,   216,   217,
     218,     0,  1334,   714,  1335,  1336,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,  1337,  1338,   232,     0,
     233,   234,   235,   236,     0,     0,   715,     0,   238,   239,
     240,   241,   716,   242,   243,     0,   244,   245,   246,   247,
     248,   249,     0,   717,   250,   251,     0,     0,     0,   718,
       0,     0,     0,   252,   253,   254,   255,   256,   257,  1339,
    1340,   260,     0,   261,     0,   262,   263,   264,   265,   266,
       0,   267,   268,   269,     0,     0,   270,   271,  1008,   273,
     274,     0,   275,   276,   277,     0,   278,   279,     0,   280,
     281,   282,   283,     0,   285,   286,   287,     0,     0,   289,
       0,   290,  1341,   292,     0,   293,     0,   294,   719,     0,
     720,   295,   296,   297,     0,   298,     0,     0,   300,     0,
     301,   302,   303,   304,   305,   721,   306,   307,   308,     0,
     309,   310,   311,   312,   313,   314,     0,   315,   722,     0,
     317,   318,   319,   320,  1342,  1343,     0,  1344,     0,   324,
     723,   724,   325,   725,   326,   327,   328,   329,   330,   331,
     332,     0,   333,     0,   726,   335,   727,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,  1345,   728,  1346,   353,   354,
       0,     0,   356,   357,   729,   358,     0,     0,   360,  1347,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,     0,   730,   731,   732,     0,   371,   372,   373,
     374,   375,   376,   377,     0,   378,     0,   380,     0,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1348,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   733,
     409,   410,     0,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,     0,
     427,   428,   734,   429,  1350,   431,     0,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,     0,     0,   443,
     444,     0,   445,   446,   447,   448,   449,   450,     0,  1351,
    1352,     0,     0,   453,     0,   455,     0,     0,   457,   458,
     459,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,   469,   470,   471,   472,   473,     0,
    1353,     0,   476,   735,   477,   478,   479,     0,     0,   480,
       0,     0,   481,   482,   483,   484,   485,     0,  1333,     0,
       0,     0,     0,     0,     0,     0,   495,   496,   497,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   713,   216,   217,   218,     0,     0,   714,
       0,     0,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,     0,     0,   232,     0,   233,   234,   235,   236,
       0,     0,   715,     0,   238,   239,   240,   241,   716,   242,
     243,     0,   244,   245,   246,   247,   248,   249,     0,   717,
     250,   251,     0,     0,     0,   718,     0,     0,     0,   252,
     253,   254,   255,   256,   257,     0,     0,   260,     0,   261,
       0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,   278,   279,     0,   280,   281,   282,   283,     0,
     285,   286,   287,     0,     0,   289,     0,   290,     0,   292,
       0,   293,     0,   294,   719,     0,   720,   295,   296,   297,
       0,   298,     0,     0,   300,     0,   301,   302,   303,   304,
     305,   721,   306,   307,   308,     0,   309,   310,   311,   312,
     313,   314,     0,   315,   722,     0,   317,   318,   319,   320,
       0,     0,     0,     0,     0,   324,   723,   724,   325,   725,
     326,   327,   328,   329,   330,   331,   332,     0,   333,     0,
     726,   335,   727,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,     0,   728,     0,   353,   354,     0,     0,   356,   357,
     729,   358,     0,     0,   360,     0,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,     0,   730,
     731,   732,     0,   371,   372,   373,   374,   375,   376,   377,
       0,   378,     0,   380,     0,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   733,   409,   410,     0,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,     0,   427,   428,   734,   429,
       0,   431,     0,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,     0,     0,   443,   444,     0,   445,   446,
     447,   448,   449,   450,     0,     0,     0,     0,     0,   453,
       0,   455,     0,     0,   457,   458,   459,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
     469,   470,   471,   472,   473,     0,     0,     0,   476,   735,
     477,   478,   479,     0,     0,   480,     0,     0,   481,   482,
     483,   484,   485,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   495,   496,   497
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    47,    16,   184,   524,
     164,    11,   706,   892,     7,    24,    33,   617,   618,   619,
      20,    14,    20,   623,   172,   711,   900,   964,   659,    21,
      42,   950,   180,   928,    26,  1110,  1210,   737,   780,  1176,
     763,  1498,  1599,  1349,  1112,   801,    21,    47,   896,   551,
     792,    26,   567,   784,   551,    12,  1006,  1007,  1215,  1035,
     854,  1128,  2206,  1891,  1892,   977,  1306,  1219,   836,   863,
    1934,   666,  1366,  2364,  2763,  1025,    22,  1402,  1215,    20,
     173,   174,    41,  1228,   177,   178,  2489,    33,  1163,   516,
     587,  1159,  1387,  2539,  1387,  2541,  1210,  1387,  1263,   841,
     783,   194,   844,   786,   181,  1387,  2702,   849,    17,   186,
    1387,   794,   920,  1387,   856,   883,     0,  1982,   195,  1271,
    1534,  2971,  1133,   865,  1760,   569,  2666,  2684,  2186,  2414,
    1455,  1276,  1277,   560,  2362,   579,   151,  3056,   166,  2360,
    2361,  2938,  3235,  3005,  2684,  2358,   586,     0,  3274,  3012,
    3253,     0,     0,     0,  2943,  2944,  2297,  1202,    38,   166,
     662,  1163,  1404,  3476,  2983,   662,   166,   995,   996,  2876,
    3668,  1411,  2688,  2689,  2690,  2691,  2692,  2693,     5,    44,
     753,    31,   703,   703,     5,    51,     0,    11,     5,     0,
      58,  3216,     0,  1021,  2407,    66,    13,    35,  3914,     5,
     127,   103,    35,  2067,    79,   928,    18,    13,   105,    37,
      72,     0,    37,   145,  3797,    96,    18,     5,   151,   150,
     170,    16,   103,     5,    84,    13,     5,   105,   132,    96,
     129,   190,    96,    51,   834,    25,  3907,    58,     5,     5,
       5,   110,     5,     5,   150,  1053,   189,     0,  2491,     5,
       5,   152,   242,    68,     5,     5,   247,     5,    22,   150,
     230,    76,     9,    68,     5,    29,   159,   103,   246,  2133,
      22,  2135,    64,   275,   838,   182,    58,    29,    76,  2420,
       8,   188,  3764,    11,  3766,    11,    23,    60,   187,   196,
      51,   151,    34,  2028,  1369,     9,   193,    68,     0,   150,
       9,   145,   144,    76,   819,    51,   141,     9,   120,     5,
      36,   155,   122,    52,   319,   152,  3179,   272,   120,   179,
      22,    60,   259,    83,     4,   141,   170,     0,   252,     9,
      83,     5,   191,    11,   194,   232,   150,   132,   232,   150,
      66,  1097,   150,   424,   259,   205,     0,   428,   524,   303,
     107,   232,   279,   252,  1054,     9,   170,   130,    36,   170,
     145,   150,   170,   511,     3,     4,     5,   227,    22,   246,
       9,    68,  1095,   208,   147,   290,  1352,  1100,  1101,  1079,
     165,   170,   319,   280,   278,   309,   246,   246,    66,  1339,
    1340,   567,   208,  1850,     5,   155,   232,  1347,     4,   354,
     964,  3899,   155,     9,   305,   396,    22,   555,   378,   244,
      83,   248,   156,    29,   916,   108,   564,   321,   372,   916,
     295,   514,    11,   428,   426,   518,   268,   169,  1495,   103,
     296,   928,  1499,   190,  1501,  1314,   426,  1504,   150,   394,
     300,   534,    26,    27,  1318,   522,   424,   184,   150,   526,
     428,   332,   316,   245,   335,   299,  3481,   901,  2701,   360,
     537,   352,    22,   191,   103,  1533,    11,   366,   170,  1192,
     237,   307,   211,     8,    96,   342,  3958,  1200,   296,   981,
     430,  4152,   155,  2999,   981,   378,    11,   430,   290,   237,
     930,    36,   103,   426,   426,   426,   150,   506,   376,   426,
     273,   339,   364,   293,  1143,   374,   339,  1190,   303,  1337,
    1338,   413,   956,  4096,   374,   305,   170,  1259,  1346,  1261,
     248,    66,   966,  3080,   430,  1593,   321,   352,  1251,  1604,
    4246,  1254,  1255,   430,   978,   296,  1330,   352,  1269,   150,
    3080,  1309,   551,   552,   297,   426,   587,   352,  1304,   188,
     296,   379,   706,   424,   352,   430,   383,   428,   426,   255,
     372,   426,   383,   327,   430,   149,   356,   151,  3671,  1637,
    1489,     5,   211,    11,   589,   327,   426,     5,   388,   430,
    1886,   352,  2446,   333,   334,  1327,   586,   587,   586,   907,
    1092,  3895,  1315,  1157,   367,  1092,   505,   504,   422,   426,
     918,  1895,   509,  1100,  1101,   426,   598,  3470,   600,   426,
     602,  1459,   430,  3410,  3639,   429,   608,  3414,   429,   612,
     426,   429,   631,   598,   297,   600,  3333,   602,   585,  1150,
    1150,   393,  3228,   608,   609,   610,  1209,   393,   426,   392,
     429,  3460,   651,   819,   426,  4143,   587,   426,  1496,   658,
     412,  3247,   661,   662,   663,   352,   412,  1505,   806,  3684,
     426,   426,  2953,   426,   426,  3978,   191,   695,   816,   628,
     426,   426,   765,   766,   427,   426,   429,  1241,   425,   372,
    2508,  3197,  2510,   424,   430,   426,   430,   428,   695,   417,
     418,   419,   420,   421,   422,   695,   422,   697,   697,   697,
     697,   697,   697,   417,   418,  1947,   266,  4205,   417,   418,
    1862,   327,   426,   248,   242,   417,   418,  1891,   430,   392,
     342,   245,   681,   871,  1532,  2938,  1534,   429,  1243,   120,
    2958,   638,  1560,  1561,  1809,    18,  1544,   417,   418,   832,
    1548,   352,  1899,   242,   685,    42,  1310,  4051,  1556,  1557,
     108,   710,   659,   191,   427,   103,   429,    96,   132,   852,
     853,  1569,  1570,   417,   418,  1329,    30,  3792,     8,   272,
     677,    11,  1580,    96,  3799,   429,   869,   154,   417,   418,
     660,  2645,  2646,    96,   664,   345,   392,   347,   763,   105,
      98,   698,    98,   752,     8,    51,  3009,    11,     5,   159,
     384,   393,   413,   237,   897,   898,   107,  1809,  1408,   237,
    1374,   417,   418,   697,   150,   374,  2373,   428,   150,   252,
     412,   252,    36,    18,   108,   183,   835,   384,    42,    24,
     419,   420,   421,   422,   211,  1880,     5,   120,  2666,   103,
     108,     3,    38,     5,   697,   301,  2987,  1922,   697,   697,
     697,   354,    66,   252,   219,   163,  2684,   163,    60,   250,
     744,    76,  1426,    59,   230,  3986,  3987,   426,   303,   166,
     230,  1502,  1503,   170,   419,   420,   421,   422,   413,   414,
     415,  3284,   417,   418,   419,   420,   421,   422,   103,   190,
    1590,   394,   417,   418,   419,   420,   421,   422,   426,   183,
    4204,   103,   426,   294,  4208,  2640,  2063,   916,  2643,  2644,
     207,   219,  2647,   219,   222,   183,   222,   373,  3867,   928,
      18,   237,  2657,   105,  1439,   120,    24,   426,   319,  1568,
     930,    22,   930,  2761,  4037,  4061,    98,  2102,  2112,   846,
     933,  4245,   935,  1582,   937,   310,   939,   321,   941,   942,
     943,   191,   961,   928,   312,   948,   170,   342,  3755,   866,
     867,   868,  3751,  3760,   312,   874,  3763,    74,   345,  1466,
     347,   307,   981,  1942,   230,     3,   259,   191,   192,   417,
     418,   419,   420,   421,   422,    74,   152,  1431,    11,   989,
     197,   426,   105,   370,   342,  3684,   427,   430,  1442,   430,
    1427,   163,   310,   342,   310,   112,  3869,   290,   248,  1009,
    1454,   193,  1053,    36,   372,    60,   158,   232,   378,   342,
     352,   235,   120,   112,   115,  1465,   323,  1996,   427,   342,
     232,   430,   380,   258,   248,   237,   319,   352,  1602,  1039,
     296,  4144,   408,    66,   392,    20,  1055,    75,   955,   385,
     232,  1566,  4173,  1053,   354,    18,  1065,   219,  4151,   153,
     222,    96,  3508,   319,   259,    40,  1075,  1243,  4017,   145,
     977,   273,     5,    95,   259,   359,    26,    27,   426,   163,
     193,   413,   248,  1092,   286,   130,  1095,  1096,   372,   142,
      22,  1100,  1101,   103,   377,   290,   428,   125,   280,   407,
    2050,   407,   147,  1421,   372,   290,  1121,  2174,  1136,  1137,
     170,  1139,  1430,   196,  3976,   430,  1434,   426,   426,   232,
    1095,  4040,  1440,  1441,   319,  1100,  1101,  3990,  4153,  1136,
    1137,  1224,  1139,    83,   319,   219,  1136,  1137,    70,  1139,
    1458,  3432,  1247,   151,   326,    77,     5,   175,   310,   413,
       9,  3442,   102,   260,   103,   352,   153,   120,  3955,   301,
     424,   259,   426,   427,   428,   367,   430,   280,   191,   335,
     103,   260,   104,  3458,   414,   415,   229,   417,   418,   419,
     420,   421,   422,   133,  1978,  1278,  1279,  1280,  1281,  1294,
      22,     5,   290,  1152,    74,   230,   218,  3410,   220,  1106,
    3428,  3414,  3423,   417,   418,   419,   420,   421,   422,   184,
     133,  2505,  3440,  2288,  1291,  1898,   292,  1192,  2512,  2294,
     314,   319,   232,  1316,  1317,  1200,   310,  1950,   273,  1322,
     290,   292,   112,   430,   294,  1958,   264,  1960,   374,   346,
    4103,   426,   174,   429,   103,   407,  1153,  2126,    97,   343,
    4100,  4101,  3080,   261,     0,    11,  3314,   346,  1267,   319,
    1235,  1236,  2136,  1439,  1947,   280,    74,  3824,    83,   154,
      44,     8,  1420,   430,    11,  1368,  1251,   259,  1187,  1254,
    1255,  1429,  2130,   115,  3824,  1968,  3882,   102,   237,   103,
     426,  2085,  2086,  2087,  2088,   115,   259,   117,    11,  1392,
    1393,  1394,  1395,  2097,   112,    32,   321,  1214,   290,  1386,
      66,  1270,  4175,   305,  1221,  1998,   324,   314,   133,   280,
      94,    74,   367,    36,   173,  1402,   211,   290,    60,   108,
     291,   392,   392,  2507,    66,   321,  1851,   365,  4217,  1903,
    1315,   120,  2799,  1250,    76,   373,   343,  3800,   376,   275,
    1498,  1444,  2120,    66,   315,  1432,   319,   372,  2994,   112,
    1453,   309,   312,  1247,   356,   362,   392,  1460,   159,   430,
    2381,   103,   241,   105,  2441,  1282,  4226,   106,  1455,  1388,
     260,  3246,   170,   374,   111,    18,   372,  1814,  1295,   312,
    1566,    24,   342,  2507,   417,   418,   419,   420,   421,   422,
     106,  1308,  4265,   335,   430,  3140,  4285,   305,   182,   106,
    1294,  3146,  3147,  3148,  3149,  3150,  3151,  2831,  2583,   342,
     197,  3874,   242,  2718,  2232,  2718,   105,  3291,  2718,  3293,
     380,   352,  4028,   170,   384,   426,  2718,  1755,   167,   230,
    2592,  2718,   392,   354,  2718,   177,   290,   344,     8,   131,
      75,    11,   260,  1897,   191,  2178,   230,   380,   356,   250,
     345,   167,   347,  2788,  4153,  1465,   346,  1465,    28,   392,
     167,    78,   305,  2281,  2038,   319,   426,   356,   191,   192,
    3771,  3772,  1475,   394,  1477,   370,  1479,   120,  1481,   171,
    1483,   270,   341,   342,  1487,   392,   393,   312,   177,   124,
     232,   386,   290,   426,  2312,   237,   294,   260,  1525,   426,
     117,   248,  3915,  1940,  1607,   250,  1516,  1516,  1516,  1516,
    1516,  1516,   235,   356,   259,  1466,  3979,   342,   292,   426,
     159,   319,  2451,   290,   308,   392,  3989,   393,   346,  2347,
       4,   273,  3755,  3821,  1553,     9,     8,  3760,  3994,    11,
    3763,   230,  1511,   232,   286,   290,   412,  1464,  3702,   259,
     259,   392,   319,  2513,   152,   380,    28,  3845,    95,    49,
     426,  1546,  1547,   430,   105,   200,   201,   392,  1524,  1554,
    3793,   259,   303,  1558,  1559,   150,   309,   378,  2663,   214,
     290,   290,   180,   346,   294,  1502,  1503,    20,  1573,   430,
    1575,   230,  2476,  2748,   392,   170,  2751,   259,  2683,  1609,
     331,   426,   290,  2115,   145,    95,   294,    40,  2115,   319,
     319,  1596,  1531,  1598,  2263,  2264,  1385,  3491,  3492,  2268,
     259,   191,  2196,  2853,   259,   367,  3193,   294,   290,    80,
     279,   319,  1651,  3787,  1403,  3789,   177,  2149,   175,   173,
     385,  2374,  2149,   600,   601,   602,   312,  2877,   605,   606,
     607,   290,   319,  4066,   115,   304,   117,   319,   615,  2308,
    2309,   313,   345,     3,   347,  1851,   413,   414,   415,  3970,
     417,   418,   419,   420,   421,   422,   342,   259,   248,    19,
     234,   218,   172,   220,  3907,   145,  1844,   165,  2466,   230,
     342,   232,  1850,   151,   417,   418,   419,   420,   421,   422,
      73,   129,   313,    32,   392,   165,   309,   259,   290,   344,
      39,   346,   413,   141,   380,  1632,    48,   145,  1805,   191,
    2797,   179,     8,  1810,  1641,    11,  1813,   428,   218,  3033,
     220,   342,  3955,    68,   386,    75,   194,   319,   290,   378,
     230,    76,    28,  1846,  1847,  1848,   427,   205,  1835,   430,
    1853,  2492,  1855,     8,  1857,  1858,    11,  2398,   312,   187,
     426,    57,    58,  3013,    84,     4,  2371,   319,   258,   426,
       9,   232,  1774,    28,   393,   386,   248,   197,   307,  2520,
     208,   242,  1869,   303,   304,   125,  1796,  1796,   342,  1774,
     246,   425,  1819,   412,  1821,   251,   430,  2125,  2727,   141,
    2493,     9,   312,   145,  2329,   295,  1757,   426,  2893,  1896,
     115,  3378,   117,  2141,  2142,   344,   244,  2145,   427,   426,
     421,   430,  2900,  2151,   252,   426,   380,   428,   392,   393,
     170,   151,   342,  1920,   139,   175,  3581,  3582,   392,  1756,
     330,  1758,   300,   413,   414,   415,   246,   417,   418,   419,
     420,   421,   422,  1956,  1941,   424,  1875,   426,  1945,   179,
     425,   233,   234,   392,   393,   430,   208,  2374,     8,   430,
     380,    11,   426,   427,   194,   429,  1963,   303,   304,  3041,
    2208,    76,   392,   421,   246,   205,  1973,   426,   426,   251,
     428,    48,  1861,  2467,  2880,  2881,  2818,   426,   345,  1986,
     347,     5,   244,  3058,  3059,   191,    10,   227,  1995,   424,
    2013,   426,  1584,   428,    18,  1587,   426,  2995,  2021,  2022,
    2023,  2024,  2025,  2026,   264,    38,   307,   232,    21,  4152,
      34,   427,   237,    26,   430,  2824,   191,   242,   366,   409,
     312,   413,   414,   415,  2696,   417,   418,   419,   420,   421,
     422,  3159,  2464,  3161,   249,   307,  3164,  2464,  3166,   154,
     193,   301,   248,   344,  1983,  1950,  3703,  3704,  3705,  3706,
     342,  2918,   249,  1958,   931,  1960,   428,   934,   173,   936,
     300,   938,   246,   940,  2438,  2439,  3824,   944,  2562,   352,
    2564,   129,   344,   248,  3079,  2280,  3081,  2282,  2283,  1916,
     340,  2020,  2105,   141,   145,  3879,   141,   145,   380,  2028,
     145,   392,   393,   392,   393,   115,   211,   117,  4172,   427,
     392,   427,   430,   427,   430,   365,   430,   307,   426,  2132,
     428,  2134,   427,   373,   427,   430,   376,   430,   307,   139,
     392,   393,   246,  2617,  2822,   426,   345,   427,   347,   187,
     430,   191,  2210,   358,   426,   409,   251,  2215,   427,  3375,
    3227,   430,  2047,   368,   344,  2084,   426,  2641,   428,  2887,
     208,  3909,    38,   208,   426,   344,   427,   427,   409,   430,
     430,  3010,  3011,  3267,   427,   410,   411,   430,   427,  3049,
    2109,   430,  2825,   249,  2104,  2104,  2115,  2184,   700,   427,
     702,   193,   430,  3848,  2071,  3252,   244,  2717,   248,   244,
     307,   419,   392,   393,   252,   427,   149,   427,   430,  2206,
     430,  2575,  2225,   392,   393,   426,  2454,   413,   414,   415,
    2149,   417,   418,   419,   420,   421,   422,   237,   427,   968,
     969,   430,   242,  2329,   427,   427,   426,   344,   430,   430,
     345,  2068,   347,   427,   392,   393,   430,   426,   413,   414,
     415,   356,   417,   418,   419,   420,   421,   422,   427,  2399,
    2400,   430,   367,  2747,   427,   370,   427,   430,   427,   430,
     427,   430,   345,   430,   347,  2697,   427,  2699,    48,   430,
    2697,   427,  2699,  2178,  2960,   392,   393,   150,  2772,  2527,
    2358,  2529,     8,  2367,   427,    11,  2392,   430,   427,  2858,
     429,  3778,  2861,  2862,  2863,  2864,  2865,  2866,  2867,  2868,
    2869,  2870,   189,   426,  3301,  3302,  3303,   428,   366,   426,
      36,   427,   307,   319,   430,   427,    42,  2947,   430,   307,
     427,   427,  2891,   430,   430,   395,  2950,  2951,  2760,  2407,
     427,  3156,   429,  2760,   426,  2709,   427,  2711,   358,   430,
      66,  2312,   427,  2837,  3415,   430,  3417,     0,   368,   344,
     134,  2920,  2921,   413,   414,   415,   344,   417,   418,   419,
     420,   421,   422,  2857,   427,   134,   424,   430,  2616,   427,
     428,   427,   426,  2621,   430,   427,   427,   427,   430,   430,
     430,   427,  2312,   427,   430,   428,   430,   427,  2882,   427,
     430,   427,   430,   134,   430,   246,  2326,   392,   393,   145,
     427,   134,   128,   430,   392,   393,  2675,  2676,  2677,    44,
    2352,  2353,  2354,   206,   105,  2345,  2423,   427,   427,   427,
     430,   430,   430,   374,  2918,   246,  3424,   426,  2358,   427,
      83,   426,   430,   427,   427,  2374,   430,   430,   426,  2410,
     166,   241,   427,  2817,   170,   430,   309,   197,   426,  2472,
      85,  2474,  2475,   427,    60,   392,   430,  3455,  2388,  2388,
    2388,  2388,  2388,  2388,    31,   191,   192,  2372,   427,  2374,
     427,   430,  3133,   430,   109,   232,   129,  2407,  3865,   427,
    2410,   207,   430,   427,   427,   395,   430,   430,   141,   124,
      38,   427,   145,   128,   430,   427,   427,   150,   430,   430,
      38,   427,   155,  3156,   430,   158,   426,   160,   361,   235,
     427,   146,   259,   430,  2351,     8,   145,    73,    11,  3386,
       0,   276,   248,  2771,   134,  2464,   161,  2775,  2776,   134,
    2778,   426,  2780,  2781,   187,   134,   395,   134,   134,   430,
     134,  2789,   134,    36,   134,   246,   134,   134,   134,    42,
     246,  2558,  3276,   134,   134,   208,  3553,  3554,  2565,  3556,
    2666,  2398,   426,   342,    31,   206,   246,   146,   145,   145,
     426,  2819,     5,    66,     5,   145,   426,   426,  2684,  3683,
     426,   426,   269,   426,   426,   426,     5,     5,  3593,   426,
     426,   244,   426,   426,   426,   426,   426,   323,     5,   252,
     426,     5,   237,    83,   426,   256,  2545,   426,   426,   426,
     245,   426,   426,   426,   426,   426,   426,   426,    31,    31,
      86,   206,   430,   145,  3362,   244,   145,   319,  2635,   352,
     352,   307,   428,   352,  2573,   352,   307,   352,   352,   352,
    3209,    76,   307,   278,   297,   134,   246,   311,     8,   129,
     203,    11,   352,  3306,   352,   237,   426,   352,    68,   175,
     426,   141,   373,   246,   242,   145,   352,   352,    28,   430,
     150,    76,   374,   166,    97,   155,    36,   170,   158,   352,
     160,   374,    42,   352,   259,   352,    48,    48,   250,   342,
     352,   417,   418,   419,   420,   421,   422,   352,   191,   192,
     352,  2640,   352,   352,  2643,  2644,    66,   187,  2647,    37,
      37,   246,    31,   366,   207,   352,   307,   395,  2657,   352,
     430,  2799,   352,  2662,   392,   246,   191,  2666,   208,  3156,
      31,    50,   426,    30,    20,   383,   389,   426,   391,   392,
    3234,   134,   235,   426,   232,  2684,   103,   426,   374,   232,
     386,   385,   214,    31,  3603,   248,   242,   145,  2697,  2782,
    2699,  2666,  2785,    82,   244,   426,    31,   197,  2673,  2674,
    3595,   424,   252,  2678,   427,   428,   429,   308,   134,  2684,
     134,  2788,   134,   134,   134,   374,   241,   352,   236,   350,
     374,  2730,   150,   388,   426,  2802,   409,   224,   426,   224,
      11,   319,   426,  2826,   350,   430,   166,  2712,   426,   352,
     170,  3380,  3381,  2820,   150,   354,   430,   297,   137,   427,
    2759,  2760,   164,   164,   426,   247,  3893,   430,   187,   430,
     323,   191,   192,   242,   374,   352,   307,   352,    75,   307,
    2770,  2770,   374,   237,   352,   237,  3476,   207,   195,   168,
     195,  3718,   309,   427,   426,   426,  3230,  3231,   197,   237,
    2938,   246,   342,    38,    18,   326,  2703,   253,   245,   307,
      24,   352,   232,   430,   352,   235,   290,   316,   197,   352,
     352,   280,   191,    31,   203,   191,   366,   191,   248,   374,
    1568,  2728,  3386,   191,    30,   374,   191,   245,   426,  2736,
     413,   424,   352,  2740,  1582,   352,   352,   352,   413,   389,
      64,   391,   392,   232,   424,   426,   134,  2754,  3590,   316,
    2825,   414,   415,   145,   417,   418,   419,   420,   421,   422,
     147,  3009,   242,   316,   426,   134,   392,   162,   246,   246,
     145,   162,    31,   134,   424,   316,   246,   427,   428,   429,
     246,  3948,  1630,   145,   170,   170,   170,  2928,  4062,   113,
     430,  3958,    19,   323,   221,  2904,   120,  2938,   156,   123,
     430,   395,   430,   246,  3080,   294,   430,    48,   342,   298,
     241,  2818,   150,   427,   197,   304,   427,   427,  2930,  2931,
    2932,  2933,   311,   427,   430,  3489,   263,   150,  2928,   427,
     319,  3446,   255,   409,  3027,  3028,  3029,  3030,  2938,   328,
    3859,   427,  4009,   389,   352,    13,   427,   336,  2957,   427,
     409,   175,    13,  3517,   427,   427,   427,   427,   426,  3036,
    3768,   427,   427,   297,   389,  3529,   427,   427,   413,   426,
    3288,   208,   246,   380,   246,   426,   249,   426,  3296,  3297,
     173,   134,   395,   413,   414,   415,   181,   417,   418,   419,
     420,   421,   422,  3930,   352,   352,   237,   352,   387,   352,
     250,   134,   391,   392,   134,   208,   230,   264,   232,  3573,
     264,   371,   352,   352,  4081,   216,   352,   216,   242,   216,
     352,   319,   352,   352,   352,   307,   250,   307,  2935,  2936,
    2937,   352,  2263,  2264,   352,   259,  3113,  2268,   352,  3116,
    3640,   307,   307,   134,   352,    37,   352,   191,   191,    50,
       3,   191,   191,   191,   191,   191,   222,   310,   427,   208,
    3997,   424,   413,   427,  4001,  4002,   290,   361,    96,   430,
     294,  3080,   292,   427,   426,  3714,   392,  2308,  2309,   246,
     427,    82,   245,    31,  3723,   430,   159,   249,  3097,   352,
     307,  3100,   307,  3102,   307,   319,   374,  3783,  3595,   132,
     132,  3740,  3741,   374,  3096,  3080,   430,   191,   126,   424,
     150,    11,    58,   150,  3207,   145,   427,  3126,  3127,  3998,
    4015,  3096,   427,   427,   427,  3999,  3934,   426,   430,   385,
     427,  3140,   158,   426,   247,   145,   137,  3146,  3147,  3148,
    3149,  3150,  3151,    31,   374,   374,   181,  3156,   427,   361,
     427,  3160,   352,   377,  3718,   307,   426,  4005,   426,  4007,
     427,   352,   352,   427,   352,   361,   352,   168,  4243,  3487,
     145,    66,   307,    96,   361,   427,   427,   191,   427,   427,
     191,  3156,   425,   425,   392,   395,   195,   427,   145,   176,
    3199,  3200,  3201,  3202,  3169,  3170,   430,   430,   426,    71,
    3518,  3519,   203,   430,   426,  3180,   427,    18,   427,   316,
     344,   155,   150,    24,   191,  4290,   427,   191,   191,    21,
     352,   191,   150,  4298,  3199,   427,   285,    48,   426,    22,
      23,   232,  3309,   390,    27,   390,   430,   426,    31,    32,
      33,   254,    35,   427,   427,    38,    39,   194,    41,   194,
      43,   426,    54,    64,    48,  3264,  3574,  3575,   160,   427,
     242,   430,  3410,  3263,  3263,    67,  3414,  3898,   413,   427,
    3446,   352,   150,   392,    66,  3969,   175,   237,    80,  3794,
     430,   361,  4090,   237,   413,   352,   134,   191,   430,  3196,
    3929,   110,   152,   294,   237,   296,   150,   298,   374,   425,
     316,    21,   113,   304,   374,    31,   121,    96,  3215,   120,
     311,   388,   123,  3322,  3829,   426,   118,   392,   319,   150,
     392,   426,   178,   249,   150,   426,   426,   328,   379,   285,
    3237,  3306,   329,   427,   427,   336,   426,   194,   426,   391,
     262,   427,   427,   246,   286,   147,   352,   426,    68,   427,
     152,   392,  4231,    31,   145,   426,   237,   173,   217,   133,
     426,   250,   427,   304,   175,   304,  3930,    48,   426,    48,
    3688,     8,  3690,  3691,    11,   252,   426,    97,   374,   172,
     173,   174,   175,  3701,   177,   178,   387,   180,   230,   182,
     140,   184,   344,   246,   277,   188,  3960,   190,   118,    36,
      60,   194,   249,   196,    60,    42,   116,   378,   430,   285,
    3410,   379,    31,   150,  3414,   283,   145,   389,   121,   230,
     175,   232,   246,   392,   246,    31,   249,   147,   426,    66,
      48,   242,   152,  3997,  3443,   249,   427,  4001,  4002,   250,
     426,   303,   427,    18,   108,   372,   248,  3524,   259,    24,
     426,  3468,   303,  3453,  3453,    17,    28,   133,   697,  3536,
     277,   426,  3555,  1293,  2070,  1101,   792,   756,  2374,  2520,
    3462,  1929,  3079,  1990,   276,  2662,  3569,  3851,   198,   290,
    3593,  4015,  3659,   294,  3888,  3893,  3256,  3462,  3633,    64,
    3397,  3398,  3399,  3400,  3897,  4179,  2166,  3793,  4230,  2445,
    4135,  4134,  4102,  4194,  2449,   307,  4038,  3660,   319,  3220,
    3075,   313,  2061,  2061,   316,  2263,  2264,  1389,  4015,  2540,
    2268,  3225,  3514,  2056,  3227,  2729,  4235,  4298,  4290,   166,
    2683,  2668,  4201,   170,  3831,  1381,  4113,  4187,   113,  3514,
     342,  3834,    26,   957,  3975,   120,   348,  3265,   123,  1892,
    3267,  3309,  3527,  3528,   191,   192,   276,  3532,  3533,   361,
    2308,  2309,  4062,   552,  2619,  3658,   377,  4213,  4292,  4030,
     207,  1466,  3581,  3582,   676,  1758,  1757,  2388,  3249,  2992,
    3454,   301,  1127,  4098,   386,   689,  3595,   307,  2389,  1794,
    3599,  1145,  3601,   313,  1146,  3604,  3605,  2401,   235,  2395,
     175,  1793,  1148,  1777,  2407,  3923,  2415,  3755,  2938,  3416,
    3956,   248,  3760,  3767,  2993,  3763,  2037,    21,  3794,   681,
    3932,  2903,   342,  3615,   344,  3702,  2895,  2858,  4166,    33,
    2861,  2862,  2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,
    3615,   361,  4167,  4170,  2234,  3793,  3655,  2392,  3824,  2326,
      54,  2988,  2324,  3829,  1633,   230,  1152,   232,    -1,  3977,
      -1,    -1,    -1,    67,    -1,    -1,   386,   242,    -1,    -1,
      -1,    -1,    -1,  3682,    -1,   250,    80,    -1,    -1,    -1,
    3828,    -1,    -1,    -1,   259,    -1,   323,    -1,    -1,  2920,
    2921,    -1,  4010,    97,  3703,  3704,  3705,  3706,    -1,    -1,
      -1,    -1,  3795,  3796,  3797,    -1,    -1,    -1,    -1,    -1,
    3787,   504,  3789,    -1,   118,   290,   509,  3865,   511,   294,
      -1,   514,    -1,   516,    -1,   518,    -1,    -1,    -1,    -1,
      -1,   524,   136,    -1,   527,    -1,    -1,    -1,    -1,    -1,
      -1,   534,    -1,   147,   319,    -1,    -1,    -1,   152,    -1,
      -1,    -1,    -1,    -1,   158,  3755,    -1,    -1,    -1,  3907,
    3760,    -1,   555,  3763,    -1,     8,    -1,   560,    11,   173,
      -1,   564,    -1,    -1,   567,    -1,   413,   414,   415,  3686,
     417,   418,   419,   420,   421,   422,    -1,  3780,    -1,   582,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,   377,    -1,    -1,    -1,    -1,  3955,    -1,    -1,
      -1,    -1,    -1,  3906,    -1,  3824,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    18,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,    -1,    -1,   628,    -1,    -1,    -1,  3848,
      -1,    -1,    -1,  3852,   248,   638,   639,    -1,    -1,  3824,
      -1,    -1,    -1,    -1,   258,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   657,    -1,   659,   660,    -1,    -1,
      64,   664,   276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3880,  3880,    -1,    -1,   677,   128,    -1,    -1,   681,    -1,
      -1,  3984,    -1,    -1,   687,    -1,    -1,   301,    -1,    -1,
      -1,   305,    -1,   307,    -1,   698,    -1,  4225,    -1,   313,
      -1,    -1,   316,  4006,    -1,  4008,    -1,   710,    -1,   113,
      -1,    -1,  4098,   166,    -1,    -1,   120,   170,    -1,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,
     344,    -1,    -1,    -1,   348,    -1,    -1,    -1,   191,   192,
      -1,    -1,   356,    -1,    -1,  3955,    -1,   361,    -1,   752,
      -1,  3868,    -1,    -1,   207,    -1,    -1,    -1,    -1,   373,
      -1,    -1,   765,   766,    -1,    -1,    -1,    -1,  3209,    -1,
      -1,   175,   386,    -1,    -1,    -1,    -1,    18,    -1,    -1,
      -1,  3898,   235,    24,  4142,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4096,  4152,   248,  4015,    -1,    -1,    -1,
      -1,    -1,    -1,   806,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   816,    -1,    -1,   819,    -1,    -1,    -1,
      -1,    -1,    -1,    64,  4182,    -1,   230,    -1,   232,   832,
      -1,    -1,    -1,    -1,    -1,  4138,    -1,    -1,   242,    -1,
      -1,    -1,    -1,   846,    -1,    -1,   250,    -1,    -1,   852,
     853,    -1,    -1,    -1,    -1,   259,    18,    -1,    -1,    -1,
      -1,    -1,    24,   866,   867,   868,   869,    -1,   871,    -1,
     323,  3988,   113,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,   123,    -1,    -1,  4172,   290,  4190,    -1,    -1,
     294,    -1,    -1,   896,   897,   898,    -1,    -1,    -1,    -1,
    2858,    -1,    64,  2861,  2862,  2863,  2864,  2865,  2866,  2867,
    2868,  2869,  2870,    -1,    -1,   319,    -1,   920,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4232,
      -1,    -1,    -1,  2891,   175,    -1,  4294,    -1,    -1,  3380,
    3381,    -1,    -1,    -1,    -1,    -1,    -1,   950,   951,    -1,
      -1,   113,   955,    -1,   957,    -1,    -1,    -1,   120,    -1,
      -1,   123,  2920,  2921,   417,   418,   419,   420,   421,   422,
      -1,   974,    -1,   377,   977,    -1,    -1,   980,    -1,    -1,
      -1,    -1,    -1,     0,    -1,    -1,    -1,    -1,    -1,   230,
     993,   232,    -1,    -1,    -1,    -1,    -1,  4248,    -1,    -1,
      -1,   242,    -1,  4213,  4213,  4213,  4213,  4213,  4213,   250,
      -1,    -1,    -1,   175,    -1,    -1,    -1,    -1,   259,  1022,
      -1,    -1,    -1,    -1,  4243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4248,  4248,
    4248,  4248,  4248,  4248,    -1,    -1,    -1,  1050,  1051,   290,
    1053,    -1,    -1,   294,    -1,    -1,    -1,    -1,  4243,    -1,
      -1,     8,    -1,    -1,    11,    -1,    83,  1070,   230,    -1,
     232,  4290,    50,    -1,    -1,    -1,    -1,    -1,   319,  4298,
     242,    28,  4292,  4292,  4292,  4292,  4292,  4292,   250,    36,
      -1,    -1,    -1,    -1,    -1,    42,    -1,   259,    -1,    -1,
      -1,    -1,    -1,  1106,    82,  4290,  1109,    -1,    -1,    -1,
      -1,    -1,   129,  4298,    -1,    -1,    -1,    -1,    -1,    66,
     838,    -1,    -1,    -1,   141,    -1,    -1,    -1,   145,    -1,
      -1,    -1,   294,   150,    -1,  1138,   377,    -1,   155,  1142,
    1143,   158,    -1,   160,    -1,    -1,    -1,    -1,    -1,  1152,
    1153,  1154,    -1,    -1,    -1,    -1,    -1,   319,    -1,   137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1170,    -1,    -1,
     187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     168,   208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1202,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1214,  1215,    -1,    -1,   377,    -1,    -1,  1221,   166,
      -1,  1224,    -1,   170,    -1,   203,    -1,   244,    -1,    -1,
      -1,    31,    -1,    -1,    -1,   252,     8,    -1,    -1,    11,
    1243,    -1,    -1,    -1,   191,   192,   964,  1250,    -1,    -1,
      50,  3209,    -1,    -1,   232,    -1,    28,    -1,    -1,    -1,
     207,    -1,    -1,     8,    36,    -1,    11,  1270,    -1,    -1,
      42,    -1,    -1,  3714,    -1,  1278,  1279,  1280,  1281,  1282,
     297,   259,    82,    28,    -1,   232,    -1,    -1,   235,    -1,
      -1,    36,  1295,    -1,    66,    -1,    -1,    42,    -1,  3740,
    3741,   248,    -1,  1306,   251,  1308,    -1,    -1,    -1,    -1,
      -1,    -1,   290,  1316,  1317,    -1,   294,    -1,    -1,  1322,
     298,    66,    -1,    -1,    -1,   342,   304,    -1,    -1,    -1,
      -1,    -1,    -1,   311,    -1,    -1,    -1,   137,    -1,    -1,
      -1,   319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   366,
     328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,    -1,
      -1,    -1,    -1,    -1,    -1,  1368,    -1,    -1,   168,    -1,
      -1,    -1,   389,    -1,   391,   392,   323,  1095,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1392,
    1393,  1394,  1395,    -1,   166,    -1,    -1,   197,   170,    -1,
      -1,    -1,    -1,   203,    -1,    -1,    -1,   424,  1411,   387,
     427,   428,   429,    -1,    -1,    -1,    -1,  1420,    -1,   191,
     192,   166,  3380,  3381,  1427,   170,  1429,    -1,    -1,    -1,
      -1,    -1,   232,    -1,    -1,   207,  1439,    -1,    -1,  1157,
      -1,  1444,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
    1453,    -1,    -1,    -1,    -1,    -1,  1459,  1460,    -1,    -1,
     232,  1464,   207,   235,    -1,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   248,    -1,   425,   251,
      -1,    -1,    -1,    -1,   431,    -1,  1489,   232,  3929,    -1,
     235,    -1,  1210,  1496,   294,  1498,    -1,    -1,   298,  1502,
    1503,    -1,  1505,   248,   304,    -1,   251,    -1,  1511,    -1,
      -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,    31,   319,
      -1,  1524,  1525,  1241,    -1,  1528,    -1,    -1,   328,  1532,
      -1,  1534,    -1,    -1,    -1,    -1,   336,    50,  1541,    -1,
      -1,  1544,    -1,    -1,    -1,  1548,    -1,    -1,    -1,    -1,
      -1,   323,    -1,  1556,  1557,    -1,    -1,    -1,    -1,    -1,
      -1,  1564,    -1,  1566,  1567,  1568,  1569,  1570,    -1,    82,
      -1,    -1,    -1,    -1,  1577,  1578,    -1,  1580,   323,  1582,
    1583,    -1,    -1,  1586,    -1,    -1,    -1,   387,    -1,    -1,
      -1,   391,  1310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1603,    -1,    -1,    -1,  1607,  1608,    -1,    -1,    -1,  1612,
      -1,  1329,    -1,  1616,    -1,  1618,  1619,  1620,  1621,  1622,
    1623,  1624,  1625,  1626,   137,  1628,    -1,    -1,    -1,  1632,
    1633,  1349,  1635,    -1,    -1,    -1,    -1,    -1,  1641,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    -1,    -1,    -1,    -1,   168,  1374,    -1,   430,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,    -1,
      -1,    -1,    -1,    -1,   197,   430,    -1,    -1,    -1,    -1,
     203,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      18,    -1,     8,    -1,    -1,    11,    24,    -1,  1426,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   232,
      -1,    -1,    28,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,  1756,    -1,  1758,  3714,  1760,    -1,    -1,
      66,    -1,    -1,    -1,    -1,  3723,    18,    -1,    -1,    -1,
      -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   294,  3740,  3741,    -1,   298,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,  1797,   113,  1799,    -1,   311,    -1,
      -1,    -1,   120,    -1,     8,   123,   319,    11,    -1,    -1,
      -1,  1814,    64,    -1,    -1,   328,  1819,    -1,  1821,    -1,
      -1,    -1,    -1,   336,    28,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    36,    -1,    11,  1838,    -1,    -1,    42,    -1,
      -1,  1844,    -1,  1846,  1847,  1848,    -1,  1850,  1851,    -1,
    1853,    28,  1855,    -1,  1857,  1858,    -1,   175,  1861,    36,
     166,   113,    66,    -1,   170,    42,    -1,    -1,   120,    -1,
      -1,   123,    -1,    -1,   387,    -1,    -1,  1880,   391,    -1,
      -1,    -1,    -1,    -1,  1602,   191,   192,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,  1899,    -1,    -1,    -1,
      -1,   207,  1905,    -1,    -1,    -1,    -1,  1910,    -1,    -1,
      -1,    -1,   230,  1916,   232,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   242,    -1,   232,    -1,    -1,   235,
    1933,  1934,   250,    -1,    -1,    -1,    -1,  1940,    -1,    -1,
    1943,   259,   248,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1956,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,
      -1,  3929,   290,    -1,    -1,    -1,   294,    -1,   230,  1982,
     232,  1984,  1985,    -1,    -1,    -1,    -1,   191,   192,   166,
     242,    -1,    -1,   170,    -1,    -1,    -1,    -1,   250,    -1,
      -1,   319,    -1,   207,    -1,    -1,    -1,   259,    -1,    -1,
    2013,    -1,    -1,    -1,   191,   192,    -1,   323,  2021,  2022,
    2023,  2024,  2025,  2026,    -1,    -1,    -1,    -1,   232,    -1,
     207,   235,    -1,  2036,    -1,    -1,    -1,    -1,   290,    -1,
      -1,    -1,   294,    -1,   248,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   232,    -1,    -1,   235,   377,
    2063,    -1,    -1,    -1,  2067,  2068,    -1,   319,    -1,  2072,
       8,   248,    -1,    11,   251,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    -1,  2098,    -1,    -1,    36,    -1,
      -1,    -1,  2105,  2106,    42,    -1,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,    -1,    -1,   323,
      -1,    -1,    -1,    -1,    -1,   377,    -1,  2130,    66,  2132,
    2133,  2134,  2135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,
      -1,  2154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2166,    -1,    -1,    -1,    -1,  1886,    -1,
      -1,    -1,    -1,  1891,  1892,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1903,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2210,    -1,   413,
     414,   415,  2215,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,  2225,   427,    -1,    -1,    -1,    -1,   166,  2232,
    2233,    -1,   170,    -1,    -1,  2238,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,    -1,    -1,   425,    -1,
     838,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,
    2263,  2264,    -1,    -1,    -1,  2268,    -1,    -1,    -1,   207,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2280,  2281,  2282,
    2283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2293,    -1,    -1,  2296,   232,  2298,  2299,   235,    -1,    -1,
      -1,    -1,    -1,    -1,     8,  2308,  2309,    11,    -1,  2312,
     248,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,     0,
    2038,    -1,  2325,    -1,  2327,    -1,  2329,    -1,  2331,    -1,
      -1,    -1,    36,    14,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    24,  2347,    26,    27,    -1,  2351,    -1,
      -1,    -1,    -1,    -1,    -1,  2358,    -1,  2360,  2361,  2362,
      41,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2377,    -1,   964,    -1,    -1,    -1,
      61,    -1,    63,    64,    -1,   323,  2389,    -1,    69,     8,
      71,  2394,    11,    -1,  2112,  2398,    -1,    -1,  2401,    -1,
      81,    -1,    83,    -1,  2407,    -1,    -1,  2410,    -1,    -1,
      -1,  2414,    -1,    -1,    -1,    -1,    -1,    36,    99,    -1,
      -1,   102,    -1,    42,   128,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,    -1,    -1,   120,
      -1,  2444,    -1,  2446,    -1,   126,    -1,    66,  2451,    -1,
      -1,    -1,   133,    -1,   135,    18,    -1,    -1,    -1,    -1,
     141,    24,   166,    -1,    -1,    -1,   170,    -1,    -1,  2472,
      -1,  2474,  2475,    -1,   155,   413,   414,   415,  2196,   417,
     418,   419,   420,   421,   422,    -1,    49,   191,   192,   427,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,   207,    -1,    -1,    -1,    -1,    -1,   128,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,   235,    95,    -1,   215,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   223,    -1,   248,    -1,    -1,   166,    -1,    -1,
     113,   170,    -1,   234,    -1,    -1,    -1,   120,    -1,    -1,
     123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1157,
      -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,    -1,
     271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,   287,    -1,   289,   172,
      -1,    -1,   175,   294,    -1,    -1,   235,    -1,   299,   323,
      -1,   302,  1210,    -1,    -1,   306,    -1,    -1,    -1,   248,
     311,   312,    -1,    -1,    -1,    -1,    -1,    -1,   319,    -1,
      -1,   322,  2645,  2646,    -1,    -1,    -1,    -1,    -1,   330,
      -1,    -1,    -1,  1241,    -1,   218,    -1,   220,    -1,    -1,
      -1,   342,    -1,    -1,    -1,    -1,    -1,   230,    -1,   232,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   250,   369,    -1,
      -1,    -1,    -1,    -1,   375,   258,   259,    -1,    -1,   380,
    2703,    -1,    -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,
      -1,   392,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,  1310,    -1,  2727,  2728,    -1,   290,    -1,    -1,
      -1,   294,   295,  2736,    -1,    -1,    -1,  2740,    -1,    -1,
      -1,  1329,    -1,    -1,    -1,   426,    -1,    -1,   429,  2467,
      -1,  2754,    -1,    -1,    -1,    -1,   319,    -1,    -1,    -1,
      -1,  1349,    -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2782,
      -1,    18,  2785,    -1,    -1,    -1,  1374,    24,    -1,  2507,
    2508,    -1,  2510,    -1,    -1,    -1,  2799,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   377,  2818,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2826,    -1,    -1,    -1,    64,    -1,    -1,
      -1,  2834,    -1,    -1,    -1,    -1,    -1,    -1,  1426,    -1,
      -1,  2844,    -1,    -1,  2562,    -1,  2564,  2850,    -1,  2852,
      -1,    -1,    -1,    -1,    -1,  2858,    -1,    -1,  2861,  2862,
    2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,    -1,    -1,
      -1,  2874,  2875,    -1,    -1,    -1,   113,    -1,    -1,    -1,
      -1,    -1,    -1,   120,  2887,    -1,   123,    -1,  2891,    -1,
      -1,    -1,  2895,    -1,    -1,    -1,    -1,    -1,    -1,  2617,
      -1,    -1,  2905,    -1,    -1,  2908,    -1,  2910,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2919,  2920,  2921,    -1,
      -1,    -1,  2925,  2641,    -1,  2928,    -1,    -1,    -1,    -1,
      -1,    -1,  2935,  2936,  2937,  2938,  2939,    -1,   175,    -1,
    2943,  2944,    -1,    -1,    -1,  2948,    18,    -1,  2666,    -1,
      -1,  2954,    24,  2956,    -1,  2958,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2684,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,  2982,
      -1,    -1,    -1,    -1,    -1,  2988,    -1,    -1,    -1,  2992,
      -1,  2994,    64,   230,    -1,   232,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   242,  3009,  3010,  3011,    -1,
    3013,    -1,    -1,   250,  1602,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   259,    95,  3027,  3028,  3029,  3030,    -1,  2747,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,    -1,  2761,    -1,    -1,    -1,    -1,   120,     8,
      -1,   123,    11,   290,  2772,    -1,    -1,   294,    21,    -1,
      -1,    -1,  3065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,   319,    42,    -1,    -1,    -1,    -1,   172,    -1,
      -1,    54,    -1,    -1,    -1,    -1,   180,   181,    -1,    -1,
     172,    -1,   186,   175,    67,    68,    -1,    66,    -1,    -1,
      -1,   195,    -1,    76,    -1,    -1,    -1,    80,    -1,  2837,
      -1,    -1,    -1,    -1,    -1,     8,    -1,  3130,    11,    -1,
      -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,  2857,
     377,    -1,    -1,    -1,    -1,    28,   218,    -1,   220,    -1,
      -1,    -1,    -1,    36,    -1,   118,    -1,    -1,   230,    42,
     232,    -1,    -1,    -1,  2882,    -1,    -1,    -1,    -1,   128,
     242,    -1,    -1,   136,    -1,    -1,    -1,    -1,   250,    -1,
      -1,    -1,    -1,    66,   147,    -1,   258,   259,    -1,   152,
      -1,    -1,    -1,  3196,    -1,    -1,    -1,    -1,    -1,    -1,
    2918,    -1,    -1,    -1,  3207,    -1,  3209,   166,    -1,    -1,
     173,   170,  3215,    -1,    -1,    -1,    -1,    -1,   290,    -1,
      -1,    -1,   294,   295,  3227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,   192,  3237,   198,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3246,    -1,    -1,    -1,   319,   207,  3252,
      -1,    -1,    -1,  3256,    -1,    -1,    -1,    -1,   330,    -1,
      -1,    -1,    -1,    -1,    -1,  3268,  3269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   166,    -1,   248,    -1,   170,  3291,   248,
    3293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1886,    -1,
      -1,    -1,    -1,  1891,  1892,   377,    -1,    -1,   191,   192,
      -1,    -1,    -1,   276,    -1,  1903,    -1,    -1,    -1,    -1,
      -1,    -1,  3325,    -1,   207,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   301,    -1,
      -1,    -1,   305,    -1,   307,    -1,    -1,    -1,    -1,   232,
     313,    -1,   235,   316,    -1,    -1,    -1,    -1,    -1,  3362,
      -1,    -1,  3080,    -1,   323,   248,    -1,    -1,   251,  3372,
    3373,     8,    -1,    -1,    11,    -1,    -1,  3380,  3381,   342,
      -1,   344,  3385,    -1,    -1,   348,    -1,    -1,  3391,  3392,
      -1,    28,  3395,   356,  3397,  3398,  3399,  3400,   361,    36,
      -1,  3404,    -1,    -1,  3407,    42,    -1,  3410,    -1,    -1,
      -1,  3414,    -1,    -1,    -1,    -1,    -1,  3420,    -1,    -1,
    3423,    -1,    -1,   386,    -1,  3428,    -1,   511,    -1,    66,
      -1,  3434,    -1,    -1,    -1,    -1,    -1,  3440,   522,    -1,
     323,    -1,   526,  3446,    -1,    -1,    -1,    -1,    -1,    -1,
    2038,  3454,    -1,   537,    -1,  3458,    -1,    -1,   417,   418,
     419,   420,   421,   422,    -1,  3468,    -1,   551,  3471,    -1,
      -1,   555,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     564,   565,    -1,    -1,    -1,   569,    -1,    -1,  3491,  3492,
      -1,    -1,    -1,    -1,    -1,   579,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   587,    -1,    -1,    -1,    -1,   145,    -1,
      -1,    -1,  3515,   150,    -1,    -1,  3234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2112,    -1,    -1,    -1,    -1,   166,
     413,   414,   415,   170,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,    -1,   427,    -1,    -1,    -1,    21,  3267,
      -1,    -1,  3555,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3569,    -1,    -1,    -1,
     207,    -1,    -1,   657,    -1,    -1,    -1,    -1,   662,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    67,   232,    -1,    -1,   235,    -1,
    3603,    -1,    -1,   687,    -1,    -1,    -1,    80,  2196,    -1,
      -1,   248,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,  3631,    -1,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3658,  3659,  3375,    -1,    -1,
      -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,  3386,    -1,
      -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,   152,
      -1,    -1,    -1,  3686,    -1,   158,   323,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3714,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3723,    -1,   806,    -1,    -1,   198,    -1,    -1,    -1,    -1,
      -1,    -1,   816,    -1,    -1,    -1,    -1,  3740,  3741,    -1,
      -1,  3744,    -1,    -1,    -1,    -1,    -1,    -1,  3751,    -1,
      -1,    -1,  3755,    -1,   838,    -1,    -1,  3760,    -1,    -1,
    3763,  3764,    -1,  3766,    -1,  3768,  3769,    -1,    -1,    -1,
      -1,  3489,    -1,    -1,    -1,   248,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,    -1,   871,    -1,    -1,
    3793,  3794,  3795,  3796,  3797,    -1,    -1,    -1,    -1,  3517,
      -1,    -1,    -1,   276,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3529,    -1,    -1,    -1,    -1,    -1,   901,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3828,  3829,    -1,   301,    -1,
      -1,    -1,   916,    -1,   307,    -1,   920,    -1,    -1,    -1,
     313,    -1,    -1,   316,   928,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3573,  3859,    -1,    -1,    -1,
      -1,    -1,  3865,    -1,    -1,  3868,    -1,    -1,    -1,   342,
      -1,   344,   956,    -1,    -1,   348,  3879,    -1,  3881,  2467,
     964,    -1,   966,   356,    -1,    -1,    -1,    -1,   361,    -1,
    3893,    -1,    -1,    -1,   978,  3898,    -1,   981,    -1,    -1,
     373,    -1,    -1,  3906,  3907,    -1,    -1,    -1,    -1,   993,
      -1,    -1,    -1,   386,    -1,    -1,    -1,    -1,    -1,  2507,
    2508,    -1,  2510,    -1,    -1,    -1,  3929,    -1,    -1,  3932,
      -1,  3934,    -1,    -1,    -1,    -1,    -1,    -1,  1022,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3951,    -1,
      -1,    -1,  3955,    -1,    -1,  3958,    -1,    -1,    -1,    -1,
      -1,  3964,    -1,    -1,    -1,    -1,  1050,  1051,    -1,  1053,
      -1,    -1,    -1,    -1,  2562,    -1,  2564,    -1,    -1,    -1,
      -1,  3984,    -1,    -1,    -1,  3988,  1070,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
    3718,    -1,  4005,  4006,  4007,  4008,    -1,    -1,  1092,    -1,
      -1,    -1,    -1,    28,    -1,    -1,  1100,  1101,    -1,    -1,
      -1,    36,    -1,    -1,    -1,  1109,  1110,    42,    -1,  2617,
      -1,    -1,  4035,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    -1,  2641,  1138,    -1,    -1,    -1,  1142,  1143,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1157,    -1,    -1,    -1,    -1,  2666,  1163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4090,    -1,    -1,
      -1,    -1,    -1,  4096,    -1,  4098,  2684,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4107,    -1,  3824,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4138,    -1,    -1,    -1,  4142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4152,
      -1,   166,    -1,    -1,    -1,   170,    -1,  1241,    -1,  2747,
      -1,    -1,    -1,  4166,    -1,    -1,  4169,  4170,    -1,    -1,
      -1,    -1,    -1,  2761,    -1,    -1,   191,   192,    -1,  4182,
      -1,    -1,    -1,    -1,  2772,    -1,    -1,  4190,    -1,    -1,
      -1,  3909,   207,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1291,    -1,    -1,
      -1,    -1,  3930,    28,  4217,    -1,    -1,   232,    -1,    -1,
     235,    36,    -1,    -1,  4227,    -1,  1310,    42,    -1,  4232,
      -1,    -1,    -1,   248,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,  3960,    -1,    -1,  1329,    -1,    -1,    -1,  2837,
      -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1349,    -1,    -1,    -1,  2857,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3997,
      -1,    -1,  4285,  4001,  4002,  1369,    -1,    -1,    -1,    -1,
    1374,  4294,    -1,    -1,  2882,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1386,    -1,    -1,    -1,    -1,    -1,   323,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1402,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2918,    -1,    -1,    -1,    -1,    -1,  1420,    -1,    -1,    -1,
      -1,    -1,  1426,    -1,    -1,  1429,    -1,  1431,  1432,    -1,
      -1,   166,    -1,    -1,    -1,   170,    -1,    -1,  1442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1454,  1455,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
      -1,    -1,  1466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,    -1,
      -1,    -1,   427,    -1,  1498,    -1,    -1,   232,    -1,    -1,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   248,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1532,    -1,
    1534,    -1,    -1,    -1,    -1,    -1,    -1,  1541,    -1,    -1,
    1544,    -1,    -1,    -1,  1548,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1556,  1557,    -1,    -1,    -1,    -1,    -1,    -1,
    1564,    -1,    -1,  1567,  1568,  1569,  1570,   838,    -1,    -1,
      -1,    -1,  3080,  1577,  1578,    -1,  1580,    -1,  1582,  1583,
      -1,    -1,  1586,    -1,    -1,    -1,    -1,    -1,   323,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1602,  1603,
    1604,    -1,    -1,    -1,  1608,    -1,    -1,    -1,  1612,    -1,
      -1,    -1,  1616,    -1,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,    -1,  1628,    -1,    -1,    -1,    -1,  1633,
      -1,  1635,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,     8,    -1,    -1,    11,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,    -1,
      -1,    -1,   427,   964,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3234,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1760,    -1,    -1,  3267,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   838,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
      -1,  1805,    -1,    -1,    28,  1809,  1810,    -1,    -1,  1813,
      -1,    -1,    36,     8,    -1,    -1,    11,    -1,    42,   191,
     192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1835,   166,    28,  1838,   207,   170,    -1,    -1,    -1,
    1844,    36,    66,    -1,    -1,    -1,  1850,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,
     232,    -1,    -1,   235,    -1,  1869,    -1,  3375,    -1,    -1,
      -1,    66,    -1,   207,    -1,    -1,   248,    -1,  3386,   251,
      -1,    -1,  1886,    -1,    -1,    -1,  1157,  1891,  1892,    -1,
      -1,    -1,  1896,  1897,    -1,    -1,    -1,    -1,   232,  1903,
     964,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   248,  1919,  1920,    -1,  1922,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1941,    -1,  1210,
      -1,  1945,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,
      -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1963,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,  1973,
    1241,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,
      -1,  3489,  1986,   207,    -1,    -1,    -1,    -1,    -1,   323,
      -1,  1995,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   232,  3517,
      -1,   235,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3529,    -1,    -1,   248,    -1,    -1,   251,    -1,    -1,
      -1,    -1,  2036,    -1,  2038,    -1,    -1,   232,    -1,  1310,
     235,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    -1,    -1,   248,    -1,   427,   251,    -1,  1329,    -1,
      -1,    -1,    -1,    -1,    -1,  3573,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1349,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,    -1,  1157,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,  1374,    -1,    -1,    -1,    -1,  2112,    -1,
      -1,  2115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2149,  1210,    -1,    -1,    -1,
    2154,    -1,    -1,    -1,    -1,  1426,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1241,    -1,    -1,
    2184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,
     414,   415,  2196,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,  2206,   427,    -1,    -1,  2210,    -1,    -1,    -1,
    3718,  2215,    -1,    -1,    -1,    -1,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,  2232,  2233,
      -1,    -1,   427,    -1,  2238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2263,
    2264,    -1,    -1,    -1,  2268,  1329,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2280,  2281,  2282,  2283,
      -1,    -1,    -1,    -1,  2288,  1349,    -1,    -1,    -1,  2293,
    2294,    -1,  2296,    -1,  2298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2308,  2309,    -1,    -1,  2312,    -1,
    1374,    -1,    -1,    -1,    -1,    -1,  3824,    -1,    -1,    -1,
      -1,  2325,    -1,  2327,    -1,     8,    -1,  2331,    11,    -1,
      -1,  1602,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2347,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,  2358,    -1,  2360,  2361,  2362,    42,
      -1,    -1,  1426,    -1,  1635,    -1,    -1,    -1,    -1,    -1,
    2374,    -1,    -1,  2377,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    -1,  2389,    -1,    -1,    -1,    -1,
    2394,    -1,    -1,    -1,    -1,     8,    -1,  2401,    11,    -1,
      -1,  3909,    -1,  2407,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,  2423,
      -1,    -1,  3930,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,  2438,  2439,    -1,    -1,    -1,    -1,
    2444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3960,    66,    -1,    -1,    -1,    -1,    -1,    -1,
    2464,    -1,    -1,  2467,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      13,    -1,    -1,   166,    -1,    -1,    19,   170,    -1,  3997,
      -1,    -1,    -1,  4001,  4002,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2507,  2508,    -1,  2510,    -1,   191,   192,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2539,  2540,  2541,  1602,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   232,
      -1,    -1,   235,   166,  2558,    -1,    -1,   170,  2562,    -1,
    2564,  2565,    -1,    -1,    -1,   248,    -1,    -1,   251,    -1,
      -1,  2575,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2617,    -1,  1886,    -1,    -1,    -1,   232,
    1891,  1892,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2635,  1903,    -1,    -1,   248,    -1,  2641,   251,    -1,
     323,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   187,    -1,   189,    -1,   191,  2663,
     193,    -1,  2666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2683,
    2684,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2697,    -1,  2699,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2709,    -1,  2711,    -1,    -1,
     323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,  2747,   427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,  2760,  2761,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2038,  2772,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    -1,  2788,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2799,    -1,    -1,  2802,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,  2817,   427,    -1,  2820,    -1,    -1,    -1,
      -1,    -1,  1886,    -1,    -1,    -1,    -1,  1891,  1892,    -1,
    2834,    -1,    -1,  2837,    -1,    -1,    -1,    -1,    -1,  1903,
    2844,  2112,    -1,    -1,   128,    -1,  2850,    -1,  2852,    -1,
      -1,    -1,    -1,  2857,  2858,    -1,    -1,  2861,  2862,  2863,
    2864,  2865,  2866,  2867,  2868,  2869,  2870,    -1,    -1,    -1,
    2874,  2875,    -1,    -1,    -1,    -1,    -1,    -1,  2882,    -1,
      -1,    -1,   166,  2887,    -1,    -1,   170,  2891,    -1,  2893,
      -1,  2895,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2905,    -1,    -1,  2908,    -1,  2910,   191,   192,    -1,
      -1,    -1,    -1,    -1,  2918,  2919,  2920,  2921,    -1,    -1,
      -1,  2925,    -1,   207,  2928,  2196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2938,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2948,    -1,    -1,    -1,    -1,    -1,
      -1,   235,  2956,    -1,  2958,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2038,    -1,    -1,    -1,  2982,   512,
      -1,    -1,    -1,    -1,  2988,    -1,   519,    -1,    -1,    -1,
    2994,    -1,    -1,    -1,    -1,   528,   529,    -1,    -1,    -1,
     533,    -1,    -1,    -1,    -1,  3009,    -1,    -1,    -1,    -1,
     543,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3036,    -1,    -1,    -1,    -1,   570,    -1,   323,
     573,    -1,   575,    -1,   577,    -1,    -1,    -1,  2112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3075,    -1,    -1,    -1,  3079,  3080,  3081,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,  2360,
    2361,  2362,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   634,    -1,   636,    -1,    -1,    -1,    -1,    -1,  3113,
      -1,    -1,  3116,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2196,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3156,    -1,    -1,    -1,   689,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2467,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,    -1,    -1,  3230,  3231,    -1,    -1,
    3234,    -1,    -1,    -1,    -1,    -1,  2507,  2508,    -1,  2510,
      -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,   207,    11,
      -1,    -1,   795,  3267,  3268,  3269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,   810,    -1,    -1,
      -1,    -1,    -1,   232,    36,    -1,   235,    -1,   821,    -1,
      42,  2562,    -1,  2564,    -1,   828,    -1,    -1,    -1,   248,
      -1,    -1,   251,    -1,    -1,  3309,    -1,   840,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,
      -1,  3325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,   872,
      -1,   186,    -1,    -1,    -1,    -1,  2617,    -1,    -1,    -1,
     195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3362,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3372,  3373,
    2641,  3375,    -1,    -1,   323,    -1,  3380,  3381,    -1,    -1,
      -1,  3385,  3386,    -1,    -1,    -1,    -1,  3391,  3392,     8,
      -1,  3395,    11,    -1,    -1,  2666,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2467,    -1,    -1,  3410,    -1,    -1,    28,
    3414,    -1,    -1,  2684,   166,    -1,    -1,    36,   170,  3423,
      -1,    -1,    -1,    42,  3428,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3440,    -1,    -1,   191,
     192,    -1,    -1,  2507,  2508,    -1,  2510,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   413,   414,   415,  3471,   417,   418,
     419,   420,   421,   422,    -1,    -1,  2747,    -1,   427,    -1,
     232,    -1,    -1,   235,    -1,  3489,    -1,    -1,    -1,    -1,
    2761,    -1,    -1,    -1,    -1,    -1,   248,    -1,  2562,   251,
    2564,  2772,    -1,    -1,  3508,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3517,    -1,    -1,    -1,    -1,    -1,    -1,
    3524,    -1,    -1,    -1,    -1,  3529,    -1,    -1,    -1,    -1,
      -1,    -1,  3536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,  2617,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2837,    -1,    -1,  3573,
      -1,   323,   191,   192,    -1,    -1,    -1,  2641,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2857,    -1,   207,  3593,
      -1,  3595,    -1,    -1,  1127,  1128,    -1,    -1,    -1,    -1,
      -1,    -1,  2666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2882,    -1,   232,    -1,    -1,   235,    -1,    -1,    -1,
    2684,    -1,    -1,    -1,    -1,    -1,    -1,  3631,    -1,   248,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2918,    -1,    -1,
      -1,    -1,    -1,    -1,     8,  1188,    -1,    11,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    -1,    -1,    -1,    28,   427,    -1,   522,    32,  3683,
      -1,   526,    36,  2747,    -1,    -1,    -1,  2958,    42,    -1,
      -1,    -1,   537,    -1,    -1,    -1,    -1,  2761,  3702,    -1,
      -1,    -1,    -1,    -1,   323,    -1,   551,    -1,  2772,    -1,
    3714,    -1,    66,    -1,  3718,    -1,    -1,    -1,     8,  3723,
     565,    11,    -1,    -1,   569,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   579,    -1,  3740,  3741,    28,    -1,
    3744,    -1,   587,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,  3755,    42,    -1,    -1,    -1,  3760,   111,    -1,  3763,
      -1,    -1,    -1,    -1,  3768,  3769,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2837,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,    -1,  3787,    -1,  3789,    -1,    -1,    -1,  3793,
      -1,    -1,    -1,  2857,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,    -1,   427,  3080,
      -1,    -1,   166,    -1,    -1,    -1,   170,   662,  2882,    -1,
    3824,    -1,    -1,    -1,  3828,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,
      -1,    -1,    -1,    -1,  1377,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   207,  2918,    -1,    -1,  1390,    -1,    -1,
      -1,  3865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,   232,    -1,
     170,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   248,  1428,    -1,   251,    -1,    -1,
      -1,   191,   192,  3907,    -1,  3909,    -1,    -1,    -1,    -1,
    1443,    -1,  1445,    -1,  1447,    -1,    -1,   207,    -1,  1452,
      -1,    -1,    -1,    -1,    -1,  3929,  3930,    -1,  3932,    -1,
    3934,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   232,    -1,    -1,   235,    -1,  3951,    -1,    -1,
      -1,  3955,    -1,    -1,    -1,    -1,  3960,    -1,   248,    -1,
      -1,   251,  1495,  3234,    -1,    -1,  1499,    -1,  1501,   323,
      -1,  1504,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3994,    -1,    -1,  3997,    -1,    -1,  3267,  4001,  4002,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4015,    -1,    -1,    -1,    -1,  3080,    -1,    -1,    -1,
     374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4035,    -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   901,    -1,  4062,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,   916,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   928,    -1,    -1,  4090,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4107,  3375,    -1,    -1,    -1,    -1,    -1,
      -1,   956,    -1,    -1,    -1,  3386,    -1,    -1,    -1,    -1,
      -1,   966,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   978,    -1,    -1,   981,    -1,  4142,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4152,    -1,
      -1,    -1,  3423,    -1,    -1,    -1,    -1,  3428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4169,  4170,    -1,  4172,  3440,
    3234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4182,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3267,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4217,    -1,    -1,    -1,    -1,  3489,    -1,
      -1,    -1,    -1,  4227,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4243,
      -1,    -1,    -1,    -1,    -1,    -1,  3517,  1092,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1100,  1101,    -1,  3529,    -1,
      -1,    -1,    -1,    -1,    -1,  1110,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1806,  1807,    -1,    -1,    -1,  1811,  1812,
      -1,  4285,  1815,    -1,    -1,    -1,  4290,    -1,    -1,    -1,
    4294,    -1,  1825,    -1,  4298,    -1,    -1,    -1,    -1,  1832,
      -1,    -1,  3573,  1836,  1837,    -1,    -1,  1840,  1841,  1842,
      -1,  3375,    -1,    -1,    -1,    -1,    -1,    -1,  1163,  1852,
      -1,  1854,  3386,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,  1870,     8,    -1,
      -1,    11,  1875,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    28,    -1,
      -1,    31,    42,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,  1906,  1907,  1908,  1909,    -1,    -1,    -1,
    1913,  1914,    -1,    -1,    -1,    -1,    66,    -1,  1921,    -1,
      -1,  1924,    -1,    -1,    -1,  1928,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3683,  1946,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1957,  3489,  1959,    -1,    -1,    -1,
      -1,  1964,    -1,    -1,    -1,    -1,  1969,  1970,  1971,  1972,
      -1,  1974,    -1,    -1,    -1,    -1,  1291,  3718,    -1,    -1,
      -1,    -1,    -1,  3517,  1987,  1988,  1989,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,  3529,  1999,  2000,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3573,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,  1369,    -1,  2059,   207,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,    -1,    -1,
      -1,  1386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   232,  3824,    -1,   235,    -1,  1402,    -1,    -1,
      -1,    -1,   232,    -1,    -1,   235,    -1,    -1,   248,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,   248,    -1,
      -1,   251,    -1,    -1,    -1,    -1,  1431,  1432,   268,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1442,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,  1454,
    1455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,  1466,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,   181,    42,    -1,    -1,    -1,   186,  3909,    -1,
      -1,  2174,    -1,   323,    -1,    -1,   195,    -1,    -1,    -1,
      -1,    -1,    -1,   323,  3718,    -1,    -1,    66,    -1,  3930,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2202,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3960,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3997,    -1,    -1,    -1,
    4001,  4002,    -1,   413,   414,   415,    66,   417,   418,   419,
     420,   421,   422,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,   166,    -1,  1604,
    3824,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4062,    -1,    -1,    -1,    -1,    -1,    -1,   207,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   232,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,   248,
     170,    -1,   251,    -1,    -1,  3909,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2387,    -1,   265,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,  3930,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,  2424,  2425,    -1,    -1,    -1,  3960,    -1,    -1,    -1,
      -1,    28,   232,    -1,    -1,   235,    -1,    -1,  2441,    36,
      -1,    -1,    -1,    -1,   323,    42,    -1,    -1,   248,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3997,    -1,    -1,    -1,  4001,  4002,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2484,  2485,    -1,    -1,    -1,  2489,    -1,    -1,    -1,
    1805,  2494,  2495,  2496,  1809,  1810,    -1,    -1,  1813,    -1,
      -1,    -1,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   537,    -1,
    1835,    -1,    -1,   323,    -1,    -1,    -1,  2530,  2531,  2532,
    2533,    -1,   551,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,   565,    -1,    -1,    -1,
     569,    -1,    -1,   150,  1869,    -1,    -1,    -1,    -1,    -1,
     579,    -1,    -1,  2566,    -1,    -1,    -1,    -1,   587,   166,
      -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1896,  1897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1919,  1920,    -1,  1922,    -1,    -1,
     207,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,  2628,  1941,    -1,    -1,    -1,
    1945,    -1,    -1,  2636,    -1,   232,    -1,    -1,   235,    -1,
      -1,    -1,    -1,   662,    -1,    -1,    -1,    -1,  1963,    -1,
      -1,   248,    -1,    -1,   251,    -1,    -1,    -1,  1973,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1986,    -1,   657,    -1,    -1,    -1,    -1,    -1,    -1,
    1995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2698,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   687,    -1,  2708,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,   838,    -1,    -1,
      -1,    -1,  2735,    -1,  2737,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
    2773,    11,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      31,    -1,    -1,    -1,  2787,    36,    -1,    -1,    28,    -1,
      -1,    42,    -1,    -1,  2797,    -1,    36,    -1,    -1,    -1,
    2115,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   964,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2184,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2206,    -1,    -1,    -1,    -1,    -1,   916,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   928,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,   956,    -1,    -1,
     191,   192,    -1,    -1,    -1,    -1,    -1,   966,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,   207,    -1,    -1,   978,
      -1,    -1,   981,    -1,    -1,    -1,    -1,   207,   964,    -1,
      -1,   838,    -1,  2288,    -1,    -1,    -1,    -1,    -1,  2294,
      -1,   232,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   232,    -1,    -1,   235,    -1,   248,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,   993,
      -1,   251,    -1,  3016,    -1,  3018,    -1,    -1,    -1,  3022,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3037,    -1,    -1,    -1,  1022,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1157,    -1,    -1,    -1,
      -1,  3054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2374,
    3063,    -1,    -1,    -1,    -1,    -1,  1050,  1051,    -1,  1053,
      -1,    -1,   323,  1092,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1100,  1101,   323,    -1,    -1,  1070,    -1,    -1,    -1,
      -1,  1110,    -1,    -1,    -1,    -1,    -1,   964,    -1,  1210,
    3103,  3104,  3105,  3106,  3107,  3108,  3109,    -1,  2423,   349,
      -1,  3114,  3115,    -1,  3117,  3118,  3119,  3120,  3121,  3122,
    3123,    -1,    -1,  2438,  2439,  1109,    -1,    -1,    -1,  3132,
    1241,  3134,  3135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1163,    -1,    -1,    -1,    -1,  2464,
      -1,    -1,    -1,    -1,  1138,    -1,    -1,    -1,  1142,  1143,
      -1,  1157,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1310,
    3203,  3204,  3205,    -1,    -1,  3208,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1210,    -1,    -1,    -1,  1329,    -1,
      -1,    -1,    -1,    -1,  2539,  2540,  2541,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1349,    -1,
      -1,    -1,    -1,  2558,    -1,  1241,    -1,    -1,    -1,    -1,
    2565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2575,    -1,    -1,  1374,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3284,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1157,    -1,    -1,     8,    -1,    -1,    11,    -1,  3301,  3302,
    3303,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,  1310,  1426,    31,    -1,    -1,    -1,
    2635,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    -1,  1329,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1210,    -1,    -1,    -1,    -1,  2663,    -1,
    1369,    66,    -1,  1349,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1386,  2683,    -1,
      -1,    -1,    -1,    -1,  1241,    -1,    -1,    -1,  1374,    -1,
      -1,    -1,  2697,  1402,  2699,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2709,    -1,  2711,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1431,  1432,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1442,    -1,    -1,    -1,    -1,    -1,    -1,
    1426,    -1,    -1,    -1,    -1,  1454,  1455,    -1,    -1,    -1,
      -1,    -1,    -1,  1310,    -1,  2760,    -1,  1466,    -1,    -1,
      -1,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,
      -1,    -1,  1329,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2788,    -1,    -1,   191,   192,    -1,    -1,
      -1,    -1,  1349,    -1,    -1,    -1,    -1,  2802,    -1,    -1,
      -1,  1602,   207,    -1,    -1,    -1,    -1,  3500,  3501,  3502,
    3503,    -1,  2817,    -1,    -1,  2820,    -1,  1374,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   232,    -1,    -1,
     235,    -1,  3525,  3526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   248,  3537,  3538,   251,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3553,  3554,    -1,  3556,    -1,    -1,    -1,  1541,    -1,  1426,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2893,    -1,
    1564,    -1,    -1,  1567,    -1,  1604,  1570,    -1,    -1,    -1,
      -1,    -1,    -1,  1577,  1578,    -1,    -1,    -1,    -1,  1583,
      -1,    -1,  1586,    -1,    -1,    -1,  1602,    -1,   323,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1603,
      -1,    -1,    -1,    -1,  1608,    -1,    -1,    -1,  1612,    -1,
      -1,    -1,  1616,    -1,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,    -1,  1628,   838,    -1,    -1,  3651,  1633,
      -1,  1635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3674,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,  3694,    -1,    42,    -1,    -1,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      -1,  3036,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1602,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3753,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3075,    -1,    -1,  3766,  3079,    -1,  3081,    -1,    -1,    -1,
      -1,   964,    -1,    -1,    -1,  1886,  1760,    -1,    -1,    -1,
    1891,  1892,    -1,    -1,    -1,    -1,  1805,    -1,    -1,    -1,
    1809,  1810,  1903,    -1,  1813,    -1,    -1,    -1,  3113,    -1,
      -1,  3116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1835,   166,    -1,    -1,
      -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3838,    -1,    -1,    -1,    -1,
      -1,  3156,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
    1869,    -1,    -1,    -1,  1838,    -1,    -1,    -1,   207,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3878,    -1,  1896,  1897,    -1,
      -1,    -1,    -1,   232,    -1,    -1,   235,    -1,    -1,    -1,
    1886,    -1,    -1,    -1,    -1,  1891,  1892,    -1,    -1,   248,
    1919,  1920,   251,  1922,    -1,    -1,    -1,  1903,    -1,    -1,
      -1,    -1,  3915,    -1,    -1,  3230,  3231,    -1,    -1,    -1,
      -1,    -1,  1941,    -1,    -1,    -1,  1945,  2038,    -1,    -1,
      -1,    -1,    -1,    -1,  1066,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1963,  3948,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1973,  3958,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1157,    -1,    -1,  1986,    -1,    -1,
      -1,    -1,    -1,    -1,   323,    -1,  1995,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3992,
      -1,  1123,    -1,    -1,  3309,    -1,    -1,    -1,    -1,    -1,
      -1,  2112,    -1,    -1,    -1,    -1,  4009,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1210,    -1,  1886,
      -1,    -1,    -1,    -1,  1891,  1892,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1903,    -1,    -1,    -1,
      -1,    -1,  2038,    -1,    -1,    -1,    -1,    -1,  1241,    -1,
      -1,    -1,  2036,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4066,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    -1,    -1,    -1,    -1,  4081,    -1,
      -1,    -1,    -1,    -1,    -1,  2196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2115,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2112,  1310,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2149,    -1,    -1,  4136,    -1,    -1,  1329,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1349,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2184,    -1,    -1,    -1,    -1,
    2154,  2038,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1374,    -1,    -1,    -1,    -1,    -1,  2206,    -1,    -1,
      -1,    -1,    -1,  3508,    -1,    -1,    -1,    -1,    -1,    -1,
    2196,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,  3524,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      -1,  3536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1426,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,  2112,    -1,    -1,    -1,  2233,
      -1,    67,    -1,    -1,  2238,    -1,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,  2288,
      -1,    -1,    -1,    -1,    -1,  2294,    -1,    -1,  3593,    -1,
    3595,    97,    -1,    -1,    -1,    -1,    -1,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2280,    -1,  2282,  2283,
      -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,  2293,
      -1,    -1,  2296,    -1,  2298,    -1,    -1,    -1,    -1,    -1,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2196,
    1462,   147,    -1,    -1,    -1,    -1,    -1,    -1,   154,    -1,
      -1,  2325,   158,  2327,    -1,    -1,    -1,  2331,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2374,  2467,   173,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2360,  2361,  2362,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3702,    -1,    -1,
      -1,    -1,    -1,  2377,    -1,   211,  2507,  2508,    -1,  2510,
      -1,    -1,    -1,    -1,  2423,  2389,    -1,  1539,    -1,  1602,
    2394,    -1,    -1,    -1,    -1,    -1,    -1,  2401,    -1,  2438,
    2439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1563,   248,    -1,    -1,   251,  1568,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2464,    -1,    -1,    -1,    -1,
      -1,  2562,    -1,  2564,    -1,    -1,  1588,  1589,    -1,  1591,
    2444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2467,  3787,    -1,  3789,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,
      -1,   307,    -1,    -1,    -1,    -1,    -1,   313,    -1,  1631,
     316,    -1,    -1,    -1,    -1,    -1,  2617,    -1,    -1,    -1,
      -1,  2507,  2508,    -1,  2510,    -1,    -1,    -1,    -1,    -1,
    2539,  2540,  2541,    -1,    -1,    -1,   342,    -1,   344,   345,
    2641,   347,   348,    -1,    -1,  1667,    -1,    -1,    -1,  2558,
     356,    -1,    -1,    -1,    -1,   361,  2565,    -1,    -1,    -1,
      -1,   367,    -1,    -1,   370,  2666,  2575,   373,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2562,    -1,  2564,    -1,
     386,    -1,    -1,  2684,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2635,    -1,    -1,    -1,
      -1,  2617,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2747,    -1,  1770,    -1,
    2507,  2508,    -1,  2510,  2663,  2641,    -1,    -1,  1780,    -1,
    2761,  1783,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2772,    -1,    -1,  2683,    -1,    -1,    -1,    -1,    -1,
    2666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2697,  3994,
    2699,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2684,    -1,
    2709,    -1,  2711,  1886,    -1,  2562,    -1,  2564,  1891,  1892,
    4015,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2837,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2760,    -1,    -1,    -1,    -1,  2857,    -1,    -1,    -1,
    2617,  2747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2761,    -1,    -1,    -1,  2788,
      -1,  2882,    -1,    -1,  2641,    -1,  2772,    -1,    -1,    -1,
      -1,    -1,    -1,  2802,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2817,  2666,
      -1,  2820,    -1,    -1,    -1,    -1,    -1,  2918,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2684,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2837,    -1,    -1,    -1,  2038,    -1,    -1,    -1,    -1,
    2834,    -1,    -1,    -1,    -1,    -1,    -1,  4172,    -1,    -1,
    2844,  2857,    -1,    -1,    -1,    -1,  2850,    -1,  2852,    -1,
      -1,    -1,    -1,    -1,  2893,    -1,    -1,    -1,    -1,    -1,
    2747,    -1,    -1,    -1,    -1,    -1,  2882,    -1,    -1,    -1,
    2874,  2875,    -1,    -1,  2761,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2772,    -1,    -1,    -1,    -1,
      -1,  2895,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2112,
      -1,  2905,  2918,    -1,  2908,    -1,  2910,    -1,  4243,    -1,
      -1,    -1,    -1,    -1,    -1,  2919,    -1,    -1,    -1,    -1,
      -1,  2925,    -1,    -1,  2928,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2948,    -1,    -1,    -1,    -1,  3080,
    2837,    -1,  2956,    -1,  2958,  4290,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4298,    -1,    -1,    -1,    -1,    -1,    -1,
    2857,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2982,    -1,
      -1,    -1,    -1,  2196,  2988,    -1,    -1,    -1,    -1,    -1,
    2994,    -1,    -1,    -1,    -1,  2882,    -1,  3036,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2918,    -1,    -1,    -1,    -1,  3075,    -1,    -1,    -1,
    3079,    -1,  3081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3080,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3113,    -1,    -1,  3116,    -1,    -1,
      -1,    -1,    -1,    -1,  2236,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3234,    -1,    -1,    -1,  2259,    -1,  2261,
      -1,  2263,  2264,  2265,    -1,    -1,  2268,  3156,    -1,    -1,
    2272,    -1,    -1,    -1,    -1,    -1,    -1,  2279,    -1,    -1,
      -1,    -1,  2284,    -1,    -1,    -1,  3267,    -1,  2290,    -1,
      -1,    -1,    -1,  2295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2304,    -1,    -1,    -1,  2308,  2309,    -1,  2311,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2323,    -1,    -1,    -1,    -1,    -1,    -1,  2330,    -1,
    2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,
      -1,  3230,  3231,  3080,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2366,    -1,    -1,    -1,  3234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3375,    -1,    -1,    -1,    -1,    -1,
      -1,  3267,    -1,    -1,  2467,  3386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3268,  3269,    -1,    -1,    -1,    -1,
    3309,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2507,  2508,    -1,  2510,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2459,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3234,    -1,  2562,
      -1,  2564,    -1,    -1,    -1,    -1,    -1,    -1,  3489,  3375,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3372,  3373,
    3386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3267,  3385,    -1,    -1,    -1,    -1,  3517,  3391,  3392,    -1,
      -1,  3395,    -1,    -1,    -1,    -1,    -1,    -1,  3529,    -1,
      -1,    -1,    -1,    -1,  2617,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3423,
      -1,    -1,    -1,    -1,  3428,    -1,    -1,    -1,  2641,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3440,    -1,    -1,    -1,
      -1,    -1,  3573,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2666,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3471,    -1,  3508,
      -1,  2684,    -1,  3489,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3524,    -1,    -1,  3375,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3536,    -1,  3386,
      -1,  3517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3529,    -1,    -1,    -1,  2669,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2747,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2761,    -1,
      -1,    -1,    -1,    -1,  3593,    -1,  3595,  3573,    -1,  2772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3718,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3489,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2837,    -1,    -1,  3631,    -1,    -1,
    3517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2791,
      -1,    -1,  3529,    -1,  2857,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3702,    -1,    -1,    -1,    -1,    -1,  2882,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2833,    -1,    -1,    -1,    -1,  3573,  2839,    -1,    -1,
      -1,    -1,    -1,  3824,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3718,  2855,  2856,  2918,  2858,    -1,    -1,  2861,
    2862,  2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3744,    -1,    -1,    -1,  2896,    -1,    -1,  2899,  3787,  2901,
    3789,    -1,    -1,    -1,  2906,  2907,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3769,    -1,    -1,  2920,  2921,
    2922,    -1,  2924,    -1,    -1,  2927,    -1,    -1,  3909,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3930,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3824,    -1,
      -1,    -1,  2964,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2975,    -1,    -1,    -1,    -1,    -1,  3960,
      -1,  3718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3006,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3997,  3080,    -1,    -1,
    4001,  4002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3909,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3930,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3932,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3824,    -1,    -1,
      -1,    -1,    -1,    -1,  3960,    -1,    -1,  3951,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3994,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4015,    -1,    -1,    -1,
      -1,  3997,    -1,    -1,    -1,  4001,  4002,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3234,  3909,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4035,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3930,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3267,    -1,    -1,  3209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3960,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4107,    -1,    -1,    -1,    -1,    -1,    -1,
    3997,    -1,    -1,    -1,  4001,  4002,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3375,    -1,    -1,  4169,  4170,    -1,    -1,    -1,
      -1,    -1,    -1,  3386,  3326,    -1,    -1,    -1,  3330,  3331,
    3332,    -1,    -1,  3335,    -1,    -1,    -1,    -1,  3340,  3341,
    3342,  3343,  3344,  3345,  3346,  3347,  3348,  3349,  3350,  3351,
      -1,    -1,    -1,    -1,  4243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4217,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4227,    -1,    -1,    -1,  3379,  3380,  3381,
    3382,    -1,  3384,    -1,    -1,    -1,  3388,  3389,  3390,    -1,
      -1,  3393,    -1,    -1,  3396,    -1,    -1,    -1,    -1,    -1,
      -1,  4290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4298,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3425,    -1,    -1,  3489,    -1,    -1,    -1,
      -1,  4285,    -1,    -1,    -1,  3437,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3451,
      -1,    -1,    -1,    -1,  3517,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3529,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3573,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3634,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3718,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3680,  3681,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3710,    -1,
      -1,    -1,  3714,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3728,    -1,  3730,    -1,
      -1,    -1,    -1,  3735,  3736,  3737,    -1,    -1,  3740,  3741,
    3742,  3743,    -1,  3745,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3824,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3791,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3909,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3930,    -1,  3871,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3960,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3928,  3929,    -1,    -1,
      -1,    -1,    -1,    -1,  3997,    -1,    -1,    -1,  4001,  4002,
      -1,    -1,  3944,  3945,  3946,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3963,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4070,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4080,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4141,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4181,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,  4220,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,  4264,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,   115,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,    -1,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,   426,   427,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,    -1,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,   426,   427,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,    -1,   135,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,    -1,   233,   234,   235,   236,    -1,    -1,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,    -1,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,
     409,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,   427,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,    -1,   135,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,    -1,   233,   234,   235,   236,    -1,    -1,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,    -1,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,   407,   408,
     409,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,   427,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,    -1,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,    -1,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,   424,
     425,   426,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,    -1,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,   419,    -1,
      -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,    -1,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,    -1,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,    -1,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,    -1,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,    -1,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,    -1,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,    -1,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,    -1,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,    -1,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,    -1,    -1,     3,     4,
       5,     6,     7,   426,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,    -1,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,    -1,     9,    10,    -1,
      -1,   426,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,   426,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,    -1,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,    -1,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,    -1,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,    -1,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,     3,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,   247,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,    -1,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,   247,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,    -1,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,   373,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,
     426,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,   246,    -1,   248,   249,   250,    -1,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,     3,   417,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,   426,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,    -1,    -1,
     390,    -1,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,    -1,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   426,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,    -1,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,    -1,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,    -1,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,    -1,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,    -1,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,
       9,    -1,    -1,    -1,   426,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,    -1,   135,   136,   137,    -1,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,
     409,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,     3,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   419,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,    -1,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   419,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,    -1,   135,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,    -1,   233,   234,   235,   236,    -1,    -1,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,    -1,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,    -1,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,    -1,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,
     409,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
     419,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,    -1,   135,   136,   137,    -1,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,   206,   207,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,    -1,
      -1,   233,   234,   235,   236,    -1,    -1,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,    -1,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,    -1,   356,    -1,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,    -1,     3,     4,
       5,    -1,    -1,    -1,     9,   407,   408,   409,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,   419,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,   246,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,     4,     5,    -1,    -1,
      -1,     9,   417,   418,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,   246,    -1,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,   384,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,     4,     5,    -1,    -1,    -1,     9,   417,
     418,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,   246,    -1,   248,   249,   250,
      -1,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,     9,   417,   418,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,   150,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,    -1,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,     4,     5,    -1,
      -1,    -1,     9,   417,   418,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
     246,    -1,   248,   249,   250,    -1,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,   384,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,   158,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,   207,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
     384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
     207,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,   207,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,   207,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,   207,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,   207,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,   207,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,   207,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,   384,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,   207,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    -1,    -1,    68,    69,    70,    71,    72,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,    -1,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
     207,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,   319,   320,   321,   322,    -1,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,    -1,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,    -1,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,    -1,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,    -1,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,    -1,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,    -1,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,    -1,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,    -1,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,    -1,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
      -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,   319,   320,   321,   322,    -1,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,    -1,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,    -1,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,    -1,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,   247,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,   247,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,    -1,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,    -1,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,    -1,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,    -1,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,    -1,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,   247,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,    -1,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
      -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,   319,   320,   321,   322,    -1,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,    -1,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,    -1,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,    -1,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,    -1,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,    -1,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,    -1,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,    -1,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,    -1,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,    -1,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
      -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,   319,   320,   321,   322,    -1,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,    -1,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,    -1,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,    -1,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,    -1,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,    -1,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,    -1,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,    -1,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,    -1,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,    -1,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
      -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,   319,   320,   321,   322,    -1,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,    -1,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,    -1,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,    -1,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,    -1,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,    -1,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,    -1,   206,    -1,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,    -1,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,   355,   356,   357,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,   267,   268,   269,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,   320,
     321,   322,    -1,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,   355,   356,   357,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
      -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   266,   267,   268,   269,   270,   271,   272,    -1,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,    -1,   319,   320,   321,   322,    -1,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,    -1,    -1,
     354,   355,   356,   357,    -1,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,   368,   369,   370,   371,   372,    -1,
      -1,   375,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,    -1,   206,
      -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,    -1,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
     267,   268,   269,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,    -1,   320,   321,   322,    -1,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,   355,   356,
     357,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,    -1,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,    -1,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,    -1,   206,    -1,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,    -1,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,   267,   268,   269,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
      -1,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,   355,   356,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,    -1,
     206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,    -1,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,    -1,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,   355,
     356,   357,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,    -1,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,    -1,
     135,   136,   137,    -1,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,    -1,   233,   234,
     235,   236,    -1,    -1,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,    -1,   268,    -1,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
      -1,   356,    -1,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   407,   408,   409,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,    -1,   245,    -1,    -1,   248,
     249,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,   266,   267,   268,
     269,   270,   271,   272,    -1,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,    -1,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,    -1,
     319,   320,   321,   322,    -1,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
      -1,   350,   351,    -1,    -1,   354,   355,   356,   357,    -1,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,   368,
     369,   370,   371,   372,    -1,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,    -1,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,    -1,   206,    -1,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,    -1,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,    -1,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,   355,   356,   357,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
      -1,   206,    -1,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,   253,    -1,
      -1,    -1,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,   320,   321,   322,    -1,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,   350,   351,    -1,    -1,   354,
     355,   356,   357,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,    -1,   135,   136,   137,
      -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,    -1,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,   207,
      -1,   209,   210,   211,    -1,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,    -1,   233,   234,   235,   236,   237,
      -1,   239,   240,   241,   242,   243,    -1,   245,    -1,    -1,
     248,   249,   250,    -1,    -1,    -1,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,   271,   272,    -1,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,   350,   351,    -1,    -1,   354,    -1,   356,    -1,
      -1,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
     368,   369,   370,   371,   372,    -1,    -1,   375,   376,   377,
     378,   379,    -1,   381,    -1,   383,   384,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
     408,   409,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,    -1,   135,   136,   137,    -1,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,   206,   207,    -1,   209,   210,   211,
      -1,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,    -1,   239,   240,   241,
     242,   243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,
      -1,    -1,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,   271,
     272,    -1,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,    -1,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,    -1,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,    -1,   350,   351,
      -1,    -1,   354,    -1,   356,    -1,    -1,   359,   360,   361,
     362,   363,   364,   365,    -1,    -1,   368,   369,   370,   371,
     372,    -1,    -1,   375,   376,   377,   378,   379,    -1,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   407,   408,   409,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,    -1,   135,
     136,   137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,    -1,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
     206,   207,    -1,   209,   210,   211,    -1,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,    -1,   239,   240,   241,   242,   243,    -1,   245,
      -1,    -1,   248,   249,   250,    -1,    -1,    -1,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,   271,   272,    -1,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,    -1,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,    -1,    -1,   354,    -1,
     356,    -1,    -1,   359,   360,   361,   362,   363,   364,   365,
      -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,   375,
     376,   377,   378,   379,    -1,   381,    -1,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,   408,   409,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,    -1,   206,    -1,    -1,   209,
     210,   211,    -1,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,    -1,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,   253,    -1,    -1,    -1,   257,   258,   259,
     260,   261,    -1,   263,   264,    -1,   266,   267,   268,   269,
     270,   271,   272,    -1,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
      -1,   301,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,    -1,   319,
     320,   321,   322,    -1,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,    -1,
     350,   351,    -1,    -1,   354,   355,   356,   357,    -1,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,   368,   369,
     370,   371,   372,    -1,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,    -1,   135,   136,   137,    -1,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,    -1,   209,   210,   211,    -1,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,    -1,
     233,   234,   235,   236,    -1,    -1,   239,   240,   241,   242,
     243,    -1,   245,    -1,    -1,   248,   249,   250,    -1,    -1,
      -1,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,   264,    -1,   266,    -1,   268,    -1,   270,   271,   272,
      -1,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,    -1,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,    -1,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,    -1,   350,   351,    -1,
      -1,   354,    -1,   356,    -1,    -1,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,   368,   369,   370,   371,   372,
      -1,    -1,   375,   376,   377,   378,   379,    -1,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   407,   408,   409,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,    -1,   135,   136,
     137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
      -1,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,    -1,   209,   210,   211,    -1,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,    -1,   233,   234,   235,   236,
      -1,    -1,   239,   240,   241,   242,   243,    -1,   245,    -1,
      -1,   248,   249,   250,    -1,    -1,    -1,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,   264,    -1,   266,
      -1,   268,    -1,   270,   271,   272,    -1,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,    -1,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,    -1,   350,   351,    -1,    -1,   354,    -1,   356,
      -1,    -1,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,   368,   369,   370,   371,   372,    -1,    -1,   375,   376,
     377,   378,   379,    -1,   381,    -1,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,   408,   409,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,    -1,   135,   136,   137,    -1,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,    -1,   209,   210,
     211,    -1,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,    -1,   233,   234,   235,   236,    -1,    -1,   239,   240,
     241,   242,   243,    -1,   245,    -1,    -1,   248,   249,   250,
      -1,    -1,    -1,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,    -1,   266,    -1,   268,    -1,   270,
     271,   272,    -1,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,    -1,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,    -1,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,    -1,   350,
     351,    -1,    -1,   354,    -1,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   368,   369,   370,
     371,   372,    -1,    -1,   375,   376,   377,   378,   379,    -1,
     381,    -1,   383,   384,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   407,   408,   409,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    -1,    44,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    -1,    -1,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,    -1,    -1,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,    -1,
     135,   136,   137,    -1,    -1,   140,    -1,   142,    -1,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,    -1,   181,   182,   183,   184,
      -1,    -1,    -1,    -1,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,    -1,   209,   210,   211,    -1,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,    -1,   229,   230,    -1,    -1,   233,   234,
     235,   236,    -1,    -1,   239,    -1,   241,   242,   243,    -1,
     245,    -1,    -1,   248,   249,   250,    -1,    -1,    -1,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
      -1,   266,    -1,   268,    -1,   270,   271,   272,    -1,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
     285,    -1,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,    -1,    -1,    -1,    -1,    -1,   354,
      -1,   356,    -1,    -1,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,   368,   369,   370,   371,   372,    -1,    -1,
     375,   376,   377,   378,   379,    -1,    -1,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   407,   408,   409
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    41,    61,    63,    64,    69,
      71,    81,    83,    99,   102,   114,   116,   120,   126,   133,
     135,   141,   155,   209,   210,   215,   223,   234,   271,   282,
     287,   289,   294,   299,   302,   306,   311,   312,   319,   322,
     330,   342,   359,   369,   375,   380,   392,   426,   433,   434,
     435,   436,   442,   443,   445,   446,   447,   448,   449,   450,
     451,   453,   454,   458,   469,   472,   473,   476,   477,   478,
     489,   492,   493,   508,   545,   548,   549,   556,   562,   564,
     566,   567,   570,   573,   574,   578,   579,   588,   592,   593,
     594,   598,   599,   601,   602,   603,   616,   617,   618,   619,
     630,   631,   638,   639,   642,   643,   644,   645,   646,   651,
     653,   656,   660,   664,   665,   675,   676,   679,   684,   695,
     714,   717,   718,   719,   722,   725,   727,   729,   732,   735,
     736,   737,   744,   745,   747,   748,   749,   754,   756,   757,
     761,   762,   765,   766,   767,   769,   770,   771,   772,   774,
     777,   778,   783,   789,   792,   794,   795,   800,   802,   806,
     813,   817,   818,   819,   820,   821,   822,   825,   852,   354,
     394,   750,    21,    67,    80,    97,   103,   118,   136,   147,
     152,   158,   173,   198,   248,   276,   301,   307,   313,   316,
     342,   344,   348,   356,   361,   373,   386,   563,   750,     3,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    33,    34,    36,    37,    39,    40,    41,    42,
      43,    45,    46,    48,    49,    50,    51,    52,    55,    56,
      57,    58,    59,    61,    62,    63,    64,    65,    69,    70,
      71,    72,    74,    75,    77,    78,    79,    80,    81,    82,
      85,    86,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   104,   106,   107,   108,   109,   110,   112,   113,   114,
     117,   118,   119,   120,   121,   123,   124,   125,   127,   128,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   140,
     142,   143,   144,   146,   148,   152,   153,   154,   156,   157,
     159,   161,   162,   163,   164,   165,   167,   168,   169,   171,
     172,   173,   174,   175,   176,   178,   180,   181,   182,   183,
     184,   185,   186,   188,   190,   193,   195,   196,   197,   198,
     199,   200,   201,   203,   204,   206,   209,   210,   211,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   228,   229,   230,   231,   233,   234,   236,   238,
     239,   240,   241,   242,   243,   245,   248,   249,   250,   253,
     257,   258,   259,   260,   261,   262,   263,   264,   266,   267,
     268,   269,   270,   271,   272,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   298,   299,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     313,   314,   315,   316,   317,   319,   320,   321,   322,   324,
     325,   326,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   340,   341,   343,   344,   345,   346,   347,
     348,   350,   351,   354,   355,   356,   357,   359,   360,   361,
     362,   363,   364,   365,   368,   369,   370,   371,   372,   375,
     376,   377,   378,   379,   380,   381,   383,   385,   386,   387,
     390,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   814,   957,
     970,   974,   975,   384,   779,   246,   272,   750,    44,   499,
     818,    21,    33,    54,    67,    76,    97,   103,   118,   136,
     147,   154,   158,   211,   248,   251,   301,   307,   316,   344,
     345,   347,   348,   356,   361,   367,   370,   373,   509,   634,
     685,   696,    22,   271,   957,   814,    22,   266,   345,   347,
       5,   197,   723,   724,   966,    21,    33,    54,    67,    80,
      97,   118,   136,   147,   152,   158,   173,   248,   258,   301,
     305,   307,   313,   316,   342,   344,   348,   356,   361,   373,
     386,   563,   647,   750,   957,    83,   384,   426,   545,   778,
     784,   792,   795,   800,   806,   813,   817,     9,    15,    22,
      39,   142,   148,   150,   170,   199,   229,   274,   288,   417,
     418,   661,   662,   814,   965,   969,    22,    83,   286,   312,
     666,   667,   668,   970,   970,   962,   966,   342,   828,   661,
     970,   354,   957,   258,    97,   173,   341,   342,   730,   306,
     970,    22,   317,   350,   354,   461,   970,    19,   155,   666,
     667,   272,   750,   970,   196,    22,   115,   830,    55,    77,
     211,   225,   301,   307,   317,   350,   354,   397,   459,   460,
     461,    22,   317,   350,   354,   461,   354,   247,   861,   955,
     970,   828,   419,   970,   151,   426,   780,   426,   951,   284,
     823,   824,   957,   818,   819,   822,     0,   429,   779,   129,
     187,   252,   366,   831,   832,   818,   820,   821,   108,   183,
     372,   430,     3,    38,    44,    67,    73,    84,    90,   149,
     151,   166,   179,   191,   192,   194,   205,   207,   227,   235,
     254,   255,   256,   300,   323,   384,   963,   970,   971,   974,
     976,   649,   970,   649,   958,   970,   275,   649,   649,   957,
     970,    96,   342,   674,   963,     3,   967,   972,   974,   975,
     976,   165,   955,   241,     8,    62,   140,   413,   414,   415,
     417,   418,   419,   420,   421,   422,   721,   918,   919,   970,
     967,   957,   165,   955,   957,   165,   861,   957,   309,   957,
     649,   216,   967,   165,   955,   197,   105,   193,   232,   280,
     751,   752,   753,   955,   961,   970,    21,    54,    67,    68,
      76,    80,    97,   118,   136,   147,   152,   173,   198,   248,
     301,   305,   307,   313,   316,   342,   344,   348,   356,   361,
     386,   563,   654,   966,   955,   352,   963,   957,   426,   649,
     356,   958,   649,   165,   957,    96,   342,   345,   347,   967,
     345,   347,    62,   140,   721,   292,   967,   455,   970,   957,
     957,   309,   957,   649,   216,   967,   313,   342,   386,    80,
     173,   152,   305,   360,   557,    22,   957,   815,   468,   966,
     972,   724,   165,   963,   957,   165,   728,   165,   958,    96,
     342,   165,   963,   165,   967,   968,    73,    62,   140,   165,
     721,    48,   165,   968,   165,   957,   165,   957,   165,   957,
     309,   165,   957,   165,   216,   968,   197,   165,   648,   649,
     426,   793,   509,   784,   380,   778,   785,   786,   787,   972,
     779,   969,   662,   663,    22,   663,   969,   663,    22,   663,
     969,   663,   663,   663,   969,   965,   965,   814,   663,   275,
     426,   426,   528,   528,   528,   246,   352,   430,   528,   861,
     862,   430,   746,   966,   426,   790,    48,   957,   957,   955,
     970,    38,   409,   193,   428,   249,   249,   246,   150,   966,
     352,   145,   657,   246,     4,     6,     7,     8,    10,    30,
      43,    45,    46,    53,    54,    57,    58,    65,    67,    87,
      88,    89,    90,    91,    92,    93,   100,   101,   119,   134,
     138,   139,   143,   157,   185,   186,   188,   204,   212,   213,
     226,   228,   232,   237,   238,   240,   248,   257,   267,   281,
     303,   318,   325,   338,   350,   351,   355,   357,   358,   367,
     373,   381,   399,   400,   401,   402,   403,   404,   405,   406,
     417,   418,   419,   426,   818,   873,   876,   879,   880,   881,
     883,   884,   885,   886,   889,   890,   894,   896,   897,   916,
     920,   939,   944,   952,   953,   963,   964,   965,   966,   970,
     966,    22,   474,   954,   955,   317,   459,   103,   467,   966,
     468,   966,    38,    59,   459,   409,   326,   752,   249,   150,
     352,   413,    38,   409,   193,   753,   426,   955,   419,   424,
     428,   945,   946,   862,   149,   151,   384,   775,   776,   778,
     149,   781,   103,   894,   949,   950,   823,   430,   426,   782,
     427,   427,   435,   955,    22,   115,   829,   829,    48,   829,
     141,   145,   208,   244,   835,   837,   838,   847,   849,   850,
     831,   832,   150,   189,   861,   863,   951,   426,   624,   946,
     259,   290,   319,   428,   650,   259,   290,   319,   259,   290,
     319,   392,   437,   469,   470,   680,    18,   120,   259,   290,
     319,   377,   481,   319,    18,   120,   372,   452,   395,   165,
     861,    50,    82,   137,   168,   203,   232,   259,   290,   298,
     304,   311,   319,   328,   336,   387,   469,   471,   708,   715,
     426,   697,   290,   452,   134,    18,    24,    64,   113,   120,
     123,   175,   230,   232,   242,   250,   259,   290,   294,   319,
     377,   479,   480,   582,     4,   417,   418,   554,   969,   649,
     649,   426,   720,   428,   170,   290,   437,   444,   259,   290,
     134,    49,    95,   172,   218,   220,   230,   258,   290,   295,
     319,   330,   479,   551,   552,   259,   290,   385,   582,   590,
     134,   290,   319,   479,   259,   290,   294,   319,    74,   112,
     260,   346,   246,    18,    24,   120,   259,   290,   319,   490,
     491,   145,   290,   437,   444,   134,   290,   319,   479,   957,
     206,   105,   247,   396,   430,   751,   374,   773,   246,   963,
     426,   957,    96,   342,   963,   241,    62,   140,   721,   957,
     309,   957,   197,   649,   528,   333,   334,   495,   966,   426,
     624,   625,    60,     3,    43,    45,    46,    57,    58,   100,
     101,   143,   185,   186,   188,   226,   228,   240,   281,   320,
     325,   350,   351,   381,   870,   872,   874,   876,   878,   880,
     881,   882,   884,   885,   889,   890,   971,   974,   150,   426,
     620,   957,   437,    31,   768,   232,   437,   395,   165,   955,
     437,   649,   649,   620,   509,   437,    38,   456,   361,   589,
     259,   565,    74,   112,   260,   346,    20,    40,   184,   604,
      31,   620,   145,   437,   955,   165,   546,   955,   955,   649,
      73,   686,   963,   957,   563,    44,    94,   182,   230,   308,
     134,   624,    51,   296,   482,   134,   426,   134,   395,   134,
     697,   134,   430,   165,   648,   165,   649,   165,   649,   134,
     720,   968,   134,   134,   246,   134,   482,   134,    74,   112,
     260,   346,   134,   246,   134,   145,   165,   165,   468,   134,
     430,   482,   894,   923,   342,   427,   430,   139,   246,   358,
     465,   468,   554,   788,   784,   663,   814,   663,   814,   663,
     814,   663,   814,   663,   814,   814,   814,   663,   814,   426,
     529,   530,   970,   529,    22,    97,   118,   147,   152,   197,
     198,   307,   313,   342,   344,   361,   669,   954,   968,   668,
     170,   430,   803,   966,   870,   926,    31,   968,   146,   731,
     731,   731,   206,   970,   145,   145,   669,   968,   306,   970,
     468,   246,   426,   947,   424,   818,   927,   383,   887,   894,
     943,   426,   887,   887,   426,   145,   426,   426,   426,   875,
     875,   269,   818,   426,   426,   877,   426,   426,   426,   426,
      57,    58,   887,   894,   426,   875,   426,   426,   426,   426,
     426,   393,   412,   426,   891,   426,   891,   426,   426,   818,
     426,   426,   426,   426,   426,   426,   426,   426,   894,   894,
     818,   894,   923,   946,   966,    58,   426,   888,   426,   966,
       3,     8,    11,    28,    31,    36,    42,    66,   166,   170,
     191,   192,   207,   232,   235,   248,   251,   323,   413,   414,
     415,   417,   418,   419,   420,   421,   422,   918,   920,   922,
     256,   894,   189,   430,   826,   426,   966,   946,   106,   167,
     475,   430,    59,   103,   468,    31,     3,   103,   211,   466,
     554,   890,   966,   966,    78,   117,   903,    86,   103,   462,
     463,   465,   554,   103,   462,   206,   955,   894,     3,    22,
      26,    27,    28,    29,    30,    31,    32,    35,    47,    53,
      54,    60,    66,    68,    76,    83,    87,    88,    89,    91,
      92,    93,   103,   105,   111,   115,   116,   122,   126,   129,
     139,   141,   145,   147,   150,   155,   158,   160,   170,   177,
     187,   189,   202,   208,   212,   213,   232,   237,   244,   246,
     247,   251,   252,   265,   273,   286,   297,   312,   318,   327,
     339,   342,   349,   352,   353,   358,   366,   367,   373,   374,
     382,   388,   389,   391,   392,   419,   960,   973,   974,   975,
     976,   977,   945,    79,   295,   652,   427,   430,   779,   427,
     430,   824,   956,   957,    31,   782,   820,   820,   833,   834,
     894,   820,   142,   229,   844,   280,   321,   372,    22,   839,
     894,   840,   842,   894,   896,   847,   848,   838,   837,   835,
     836,   145,   850,   835,   847,   863,   955,    31,   970,   319,
     419,   926,   259,   290,   319,   352,   352,   307,   960,   428,
     352,   352,   307,   352,   352,   344,   459,   763,   145,   155,
     170,   299,   681,   682,    60,    76,   130,   147,   273,   367,
     525,   526,    76,   103,   232,   352,    76,   352,   103,   232,
     307,    76,   307,   571,    21,    54,    67,    80,   118,   147,
     152,   248,   307,   313,   316,   342,   348,   361,   386,   563,
     957,   134,   290,   319,   479,   246,   554,   311,   203,   352,
     352,   237,   554,   107,   190,   307,   317,   354,   460,   296,
     319,   708,   716,   170,   180,   253,   320,   382,   427,   698,
     701,   702,   703,   705,   870,   971,   352,   373,   955,    68,
     130,   516,   525,   970,    68,   733,   246,   305,   356,    76,
     733,    25,   293,   305,   356,   955,   175,   242,   649,   426,
     352,   352,   426,   485,   344,   392,   393,   485,    76,   430,
       4,     4,   259,   374,   374,   231,   870,   259,   319,   721,
      97,   352,   439,   319,   470,   352,   352,   955,   554,    48,
     553,   554,   554,    95,   218,   220,    48,   352,   437,   307,
     437,   230,   552,   352,   352,   237,   966,   582,   861,    76,
     352,   733,   307,   352,   352,   485,   485,   649,   649,   649,
     649,   955,    37,   379,    37,    37,   352,    37,   352,   307,
     430,    93,   373,   600,   967,   352,   439,   470,   955,   352,
     307,   259,   290,   280,   291,   315,   464,   751,   961,   970,
     955,   624,   870,   246,   395,   697,   554,   649,   649,   720,
     191,   246,    74,   112,   260,   346,   246,   649,   191,   392,
     500,   437,     3,   626,   627,   620,   426,   872,    31,    30,
     871,    98,   163,   219,   222,   310,   407,   426,   892,   893,
     650,   875,   649,   621,   622,   973,    20,   758,   870,   134,
     568,   957,   232,   426,   595,   438,   634,   374,   386,   438,
     967,    83,   155,   457,   508,   548,   603,   664,   684,   754,
     966,   590,   591,   957,   214,   649,   649,   649,   649,   242,
     108,   183,   359,   372,   605,   606,   127,   279,   426,   600,
     438,   550,   551,   232,    31,   242,   426,   528,   528,   145,
     687,   961,   426,   699,    31,   197,   392,   393,   816,   308,
     963,   482,   870,   958,   165,   957,   963,   482,   968,   967,
     134,   482,   134,   374,   134,   374,   721,   482,   482,   968,
     957,   649,   957,   957,   957,   649,   968,   600,   134,   134,
     482,   648,   649,   427,   430,   955,   784,   786,   814,   814,
     814,   814,   814,   814,   529,   427,   430,   427,   153,   314,
     343,   956,   648,    96,   316,   673,   674,   956,   241,   956,
     954,   954,   956,   648,   352,   392,   677,    16,   132,   303,
     321,   804,   861,   236,   805,   427,   430,   791,   795,   800,
     806,   817,   352,   667,   666,   667,   150,   156,   678,   970,
      21,    68,    97,   118,   147,   152,   198,   301,   307,   313,
     342,   344,   361,   386,   563,   658,   923,   945,   425,   923,
     927,   928,   426,   388,   940,   941,   894,   923,   426,   965,
     965,   923,     3,    98,   163,   219,   222,   310,   407,   929,
     930,   966,   965,   923,   923,   965,   965,   887,   887,   894,
     721,   894,   931,   417,   418,   895,   896,   916,   920,   933,
     427,   923,   894,   923,   934,   350,   409,   965,   965,   894,
      47,   150,   202,   353,   894,   923,   937,   923,   224,   896,
     894,   901,   902,   903,   224,   894,   903,   427,   430,   319,
     965,   965,   892,   870,   894,   973,   350,    35,   339,   948,
     649,   894,   426,   818,   938,   115,   117,   139,   232,   237,
     242,   358,   368,   894,    42,   166,   170,   207,   323,   426,
     894,   352,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,    22,    29,   327,   917,   303,   426,   916,   154,
     211,   342,   345,   347,   370,   827,   955,   953,   150,   853,
      22,   115,   382,   419,   427,   703,   894,   924,   925,   971,
     955,   354,   426,   966,   430,   427,   425,   431,   164,   164,
     482,   955,   776,   777,   955,   949,   427,   430,   426,   430,
      32,   111,   374,   693,   426,   841,   969,   247,   242,   851,
     851,   430,   303,   304,   843,   848,   836,   374,   801,   103,
     426,   796,   817,   970,   426,   807,   808,   809,   810,   811,
     970,   427,   427,   352,   352,   307,   967,   957,   957,   960,
     967,   957,   957,   967,   958,   957,    75,   764,   301,   373,
     666,   307,   155,   666,   426,   957,   374,   688,   195,   195,
     374,   426,   544,   165,   957,   237,   967,   957,   957,   894,
     237,   957,   957,   957,   352,   572,   963,   426,   649,   649,
     649,    96,   342,   674,    62,   140,   721,   957,   649,   957,
     649,   309,   649,   649,   197,   159,   230,   259,   290,   378,
     575,   576,   577,   861,   352,   733,   307,   237,   107,   190,
     967,   957,   246,   957,   253,   971,   427,   430,   703,   705,
     702,   705,   971,   650,   967,   968,   290,   479,   516,   870,
     970,   957,   957,    22,   373,   957,   165,   957,   165,   970,
     305,   356,   305,   356,   957,    22,   373,   957,   955,    18,
     120,   319,   583,   584,   585,   586,   973,   967,   957,   487,
     488,   973,   957,   245,    64,   245,   957,   480,   352,   959,
     970,   959,   430,   427,   430,   352,   307,   958,   967,     3,
      75,   125,   175,   264,   365,   373,   376,   440,   967,   957,
     290,   319,   479,   551,   554,   649,   957,   554,   957,   554,
     967,   957,   290,   319,   479,   957,   957,   957,   957,   967,
     957,    18,    24,   120,   259,   290,   319,   259,   290,   319,
     620,   290,   319,   290,   319,   290,   869,   970,   966,   970,
     165,   970,   967,   957,   957,   957,    18,   491,   316,   967,
     290,   319,   479,   957,   957,   352,   352,    72,   364,   280,
     191,    31,   649,   191,   191,   374,   374,   191,   237,   655,
     966,   649,   649,   649,   649,   649,   649,   191,   655,   245,
     150,   352,   494,   426,   496,   497,   413,   427,   430,   894,
      30,   871,   870,   424,   424,   352,   352,   352,   426,   352,
     965,   875,   427,   430,   413,   605,    75,   124,   200,   201,
     214,   259,   344,   346,   759,   518,   957,   150,   307,   385,
     569,   576,   577,   134,   427,   516,   596,   597,   316,    19,
     170,   301,   340,   440,   441,   145,   959,   955,   456,   251,
     509,   147,   966,   620,   620,   620,   620,   242,   246,   251,
     426,   620,   867,   868,   869,   316,   134,   133,   817,   649,
     207,   510,   512,   514,   516,   522,   525,   970,   392,   393,
     540,   392,   486,   966,   246,   427,   700,   701,   706,    31,
     197,   298,   391,   707,   708,   709,   246,   468,   162,   162,
     145,   624,    31,   134,   482,   697,   648,   649,   959,   649,
     959,   720,   246,   482,   482,   246,   482,   316,   145,   468,
     482,   894,   427,   530,   170,   170,   170,   395,   956,   430,
     554,   555,   158,   670,   671,   967,    19,   678,   132,   321,
     132,   321,   303,   372,   221,   870,   957,   150,   246,   670,
      48,   482,   963,   342,   963,   241,   197,   649,   427,   425,
     425,   430,   923,   894,   122,   941,   942,    31,   427,   894,
     427,   427,   427,   427,   150,   427,   427,   427,   427,   427,
     430,   427,   265,   932,   427,   895,   895,    11,   170,   191,
     248,   413,   414,   415,   417,   418,   419,   420,   421,   422,
     920,   895,   427,   427,   145,   150,   935,   936,   427,   409,
     427,   427,    31,   937,   923,   937,   937,   150,   427,   427,
     973,   263,   905,    31,   427,   430,   894,   973,   430,   894,
     947,   894,   970,   427,   427,   409,   895,   895,   128,   923,
     150,   115,   117,   139,   237,   242,   358,   368,   426,   128,
     339,   948,   894,   938,   894,   352,   721,   894,   426,   818,
     345,   347,   345,   347,   955,   828,   828,   828,   426,   818,
     854,   855,   856,   861,   864,   897,   963,   970,   389,   865,
     924,   924,   925,   427,   255,   909,    13,   427,   430,   832,
     752,   965,   892,   463,   894,   782,   957,   791,   834,   248,
     918,   921,   410,   411,   694,   894,   843,   954,   805,   805,
     840,   854,   389,   866,   380,   797,   798,   970,   297,   799,
     811,   812,   430,   853,   413,   947,   967,   957,   957,   208,
     968,   968,   246,   956,   249,   246,   894,   526,   959,   426,
     426,   426,   544,   173,   529,   614,   134,   482,   352,   468,
     624,   870,   395,   649,   649,   649,   720,    74,   112,   260,
     346,   957,   558,   957,   159,   378,   352,   352,   558,   575,
     582,   290,   319,   479,   957,   957,   957,   181,   237,   650,
     701,   705,   705,   421,   352,   250,   580,   120,   294,   319,
     481,   582,   734,   134,   482,   134,   482,   957,   957,   957,
     957,   585,   586,   585,   427,   430,   587,   966,   427,   430,
     413,   428,   967,   259,   290,   319,    18,   120,   259,   290,
     319,   870,   231,   870,   967,   957,   208,   264,   237,   966,
     264,   968,   371,   352,   307,   352,   733,   307,   352,   352,
     216,   216,   216,   352,   352,   307,   352,   352,   307,   352,
     307,   352,   307,   352,   482,   870,    20,    40,   319,   734,
     134,   482,   352,   957,   352,   307,   967,   957,   655,   870,
     191,   655,   655,   959,   959,   655,   191,   191,   191,   191,
     191,   191,   655,   495,   503,   504,   973,    44,    85,   109,
     124,   128,   146,   161,   237,   245,   278,   498,   248,   417,
     418,   554,   623,   705,   921,   966,   977,     3,   627,   427,
     424,   427,   965,   425,   965,   163,   219,   893,   219,   893,
     893,   965,   222,   427,   622,   623,   246,   208,   413,   760,
     760,   760,   760,   760,   760,   760,    60,    66,    76,   103,
     105,   177,   232,   237,   273,   286,   367,   519,   520,   521,
     437,   468,   957,   468,   580,   955,   427,   430,   957,   968,
     158,   301,   968,   965,   361,   528,   292,   342,    96,   529,
     955,   606,   628,   629,   966,   427,   430,   957,   955,   957,
     392,   547,   426,   511,   955,   427,   430,   245,   485,   245,
     246,   541,   485,    31,   352,   955,   427,   430,   103,   413,
     710,   966,   468,   342,   704,   705,   392,   709,   711,   108,
     183,   312,   372,   742,   159,   817,   482,   870,   957,   482,
     482,   374,   482,   374,   482,   482,   649,   649,   957,   600,
     482,   307,   307,   307,   956,   674,   430,   967,   392,   430,
     672,   249,   132,   132,   968,   669,   482,   967,   624,   697,
     554,   649,   191,   927,   427,   349,   894,   126,   870,   427,
     894,   894,   894,   935,   870,   895,   115,   117,   232,   242,
     895,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     894,   894,   936,   935,   891,   891,   870,   427,   427,   427,
     923,   427,   430,    48,   896,   427,   973,   902,   270,   337,
     904,   427,   430,   385,   898,    31,   427,   888,   966,   894,
      28,    28,   894,   427,   894,   150,   426,   926,   894,   895,
     895,   128,   128,   894,   427,   128,   894,   828,   828,   828,
     828,   955,   955,   955,   818,   855,   856,    31,   857,   970,
     430,    84,   151,   179,   194,   205,   227,   300,   858,   857,
      31,   857,   970,   426,   946,   894,   158,   845,   430,   831,
     832,   831,   427,   909,   426,   910,   970,   894,   909,   966,
     382,   925,   427,   427,   425,   427,   426,   694,   427,   247,
      86,   894,   799,   427,   430,   947,   952,   427,   430,   808,
     866,   949,   760,   153,   314,   343,   362,   683,   145,   683,
     427,   426,   532,   533,   690,   897,   970,   529,   529,   614,
     961,   427,   105,   177,   230,   232,   615,   957,   957,    31,
     957,   374,   374,   649,   649,   649,   649,   650,   967,   957,
     352,   733,   307,   352,   181,   421,   361,   957,   426,   518,
     232,   485,    96,   232,   332,   335,   485,   361,   957,   970,
     584,   488,   623,   973,   352,   352,   307,   152,   248,   335,
     632,   633,   152,   248,   640,   641,   352,   352,   307,   427,
     427,   427,   969,   966,   966,   966,   957,   957,   957,   957,
     957,   957,   957,   145,   145,   292,   145,   165,   967,   957,
     957,   967,   957,   957,   957,   957,   957,   957,   957,    66,
     483,   966,   966,   361,   970,   957,   582,   957,   957,   427,
     655,   191,   191,   655,   655,   655,   655,   655,   655,   374,
     501,   502,   427,   430,   419,   426,   465,   505,   554,   768,
     966,   768,   232,   278,   768,   768,   614,   965,   392,   393,
     425,   425,   427,   892,   955,   760,   103,   965,   966,   103,
     966,   103,   966,   103,   966,   103,   957,   103,   957,   103,
     957,   426,   649,   957,   895,   106,   167,   105,   237,   195,
     955,   711,   568,   595,   597,   580,   968,   968,   870,   486,
     955,   395,   145,   607,   427,   430,   869,   580,   242,   426,
     793,    96,   230,   513,   515,   517,   525,   970,   540,   523,
     176,   539,   514,    71,   344,   542,   817,   966,   688,   706,
     894,   894,   430,   426,   707,   620,   352,   558,   427,   482,
     959,   959,   482,   482,   316,   956,   956,   956,   554,   155,
     671,   678,   150,   191,   191,   191,   191,   237,   659,   966,
     894,   427,   427,   936,   150,   115,   117,   242,   426,   427,
     398,   900,   923,   285,    48,   390,   390,   427,   894,   230,
     894,   430,   899,   872,   892,   895,   895,   894,   926,   427,
      28,    28,   894,   894,   128,   894,   427,   955,   955,   955,
     955,   427,   970,   426,   855,   194,   254,   859,   855,   859,
     194,   858,   859,   194,   426,   970,   426,   924,    48,   160,
     846,   427,   427,   909,   911,   970,   925,   909,   966,   721,
     242,   817,   798,   413,   811,   799,   969,   352,   666,   150,
     614,   894,   427,   430,   392,    66,   691,   691,   427,   427,
     711,   106,   167,   175,   105,   376,   482,   870,   959,   959,
     957,   957,   957,   957,   361,   581,   585,   237,   237,   969,
     970,   870,   482,   482,   413,   967,   957,   957,   965,   965,
     870,   430,   965,   965,   430,   967,   957,   957,   352,   956,
     956,   649,   956,   134,   649,   870,   482,   482,   191,   655,
     655,   437,   110,   504,   465,   506,   507,   966,   966,   237,
     419,   529,   966,   966,   425,   152,   180,   152,   150,   613,
     969,   894,   232,   520,   711,   528,   374,   543,   316,   374,
      31,   426,   957,   121,   608,   388,   610,   966,   649,   510,
     547,    96,   427,   430,   392,   541,   131,   171,   426,   540,
     108,   120,   270,   957,   392,   755,   150,   426,   966,   703,
     712,   713,   971,   711,   955,   178,   559,   482,   482,   482,
     957,   249,   482,   670,   659,   659,   659,   659,   895,   150,
     426,   926,   426,   427,   430,   427,   896,   285,   427,   379,
     329,   427,   427,   427,   895,   895,   894,   857,   426,   956,
     855,   246,   374,   860,   855,   194,   855,   868,   426,   868,
     970,   427,   923,   894,   391,   906,   909,   909,   262,   912,
     427,   892,   427,   814,   951,   670,   246,   670,   427,   711,
     533,   248,   721,   649,   374,   649,   692,   692,   286,   711,
     543,   427,   352,   427,   430,   483,   623,   426,   963,   721,
     633,   426,   426,   641,   957,   392,   292,   392,   392,   145,
     483,   655,   496,   966,   427,   430,   529,   674,    31,   726,
     726,   955,   614,   427,   543,   217,   531,   173,   957,   959,
     817,   580,   303,   331,   609,   426,   133,   511,   427,   515,
     250,   542,    22,    70,    77,   104,   174,   335,   524,   524,
     954,   541,   304,   304,    52,    60,   211,   649,   689,   690,
     705,   427,   430,   865,   558,   230,   378,   560,   561,   482,
     895,   926,   427,   901,   923,    48,   230,   408,   956,   427,
     894,   426,   855,   860,   427,   868,   427,   907,   908,   970,
      48,   831,   909,   672,   683,   482,   691,   543,   426,   649,
     693,   693,   955,   543,   614,   957,   585,   374,   484,   926,
     697,   145,   636,   720,   926,   926,   648,   649,   648,   649,
     956,   482,   507,   726,    34,   169,   145,   230,   527,   151,
     261,   324,   246,   535,   536,   537,   344,   580,   140,   635,
     755,   894,   277,   540,   539,   518,   427,   542,    60,   249,
      60,   427,   430,   707,   712,   116,   378,   558,   427,   427,
     427,   285,   379,   427,   956,   427,   430,    31,   923,   279,
     304,   913,   150,   692,   389,   534,   721,   694,   694,   528,
     614,   894,   427,   252,   309,   283,   637,   636,   427,   427,
     392,   121,   175,   108,   372,   246,   537,   246,   536,   957,
     649,    31,   427,   963,   541,   540,   249,   249,   486,   690,
     711,    23,   184,   743,   427,   908,   910,    42,    86,   363,
     894,   914,   915,   914,   427,   670,   693,   426,   614,   427,
     531,   963,    48,   637,   649,   303,    51,   230,   296,   319,
     538,   538,   632,   426,   542,   541,   542,   233,   426,   738,
     740,   745,   795,   800,   806,   817,   915,   303,   144,   268,
     144,   268,   482,   694,   894,   535,   697,   649,   610,    17,
     103,   237,     4,   611,   612,   965,   966,   973,   542,   865,
     739,   740,   741,   818,   819,    28,   427,   614,   133,   427,
     430,   427,   429,   915,   277,   612,   741,   963,   426,   611,
     427
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   432,   433,   434,   434,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   436,   437,   437,   438,
     438,   439,   439,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   441,   441,   441,   441,   441,   441,   442,   443,
     444,   444,   445,   446,   447,   448,   448,   449,   449,   450,
     451,   452,   452,   453,   453,   454,   454,   455,   455,   456,
     456,   457,   457,   457,   457,   457,   457,   458,   458,   458,
     459,   459,   459,   460,   460,   460,   460,   460,   460,   460,
     460,   460,   460,   460,   460,   460,   460,   461,   461,   462,
     462,   463,   463,   464,   464,   464,   464,   465,   465,   465,
     465,   466,   466,   466,   466,   466,   466,   466,   467,   467,
     467,   468,   468,   469,   469,   469,   469,   469,   470,   470,
     471,   471,   472,   472,   472,   472,   472,   473,   474,   474,
     475,   475,   476,   477,   477,   477,   477,   478,   478,   478,
     478,   478,   478,   478,   478,   479,   479,   480,   480,   480,
     480,   480,   480,   480,   480,   480,   480,   480,   480,   480,
     480,   480,   480,   480,   480,   480,   480,   480,   480,   480,
     480,   480,   480,   480,   480,   480,   480,   480,   480,   480,
     480,   480,   480,   480,   480,   480,   480,   480,   480,   481,
     481,   482,   482,   482,   483,   483,   484,   484,   485,   486,
     486,   487,   487,   488,   488,   488,   488,   489,   490,   490,
     491,   491,   491,   491,   492,   492,   493,   493,   494,   494,
     495,   495,   495,   496,   496,   497,   497,   498,   498,   498,
     498,   498,   498,   498,   498,   498,   498,   498,   498,   499,
     499,   500,   500,   501,   501,   502,   502,   503,   503,   504,
     505,   505,   505,   505,   505,   506,   506,   507,   508,   508,
     508,   508,   509,   509,   509,   509,   509,   509,   509,   509,
     510,   510,   511,   511,   512,   512,   513,   513,   514,   514,
     514,   515,   515,   516,   517,   518,   518,   519,   519,   519,
     519,   520,   520,   520,   520,   520,   520,   520,   521,   521,
     521,   521,   522,   523,   523,   523,   524,   524,   524,   524,
     524,   524,   525,   525,   526,   526,   526,   526,   526,   526,
     526,   527,   527,   528,   528,   529,   529,   530,   531,   531,
     531,   531,   532,   532,   533,   533,   534,   534,   535,   535,
     535,   535,   535,   536,   537,   538,   538,   538,   538,   538,
     539,   539,   540,   540,   540,   540,   541,   541,   541,   541,
     542,   542,   543,   543,   544,   545,   546,   547,   547,   547,
     548,   549,   549,   550,   550,   551,   551,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   553,
     553,   554,   554,   554,   554,   555,   555,   556,   556,   557,
     557,   558,   558,   559,   559,   560,   560,   561,   561,   562,
     562,   563,   563,   564,   565,   565,   566,   566,   567,   567,
     568,   568,   569,   569,   569,   570,   571,   571,   572,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   574,   575,   575,   575,   575,   576,   576,   577,   577,
     578,   578,   579,   579,   580,   580,   581,   581,   582,   583,
     583,   584,   584,   584,   584,   585,   586,   587,   588,   589,
     589,   590,   590,   591,   591,   592,   592,   593,   593,   593,
     594,   594,   595,   595,   596,   596,   597,   598,   598,   599,
     600,   600,   600,   601,   601,   602,   603,   603,   604,   604,
     604,   605,   605,   606,   606,   606,   606,   606,   607,   607,
     608,   608,   609,   609,   610,   610,   611,   611,   611,   612,
     612,   612,   612,   613,   613,   614,   614,   615,   615,   615,
     615,   615,   615,   616,   616,   617,   618,   619,   619,   619,
     619,   619,   619,   619,   619,   619,   619,   619,   619,   619,
     619,   620,   621,   621,   622,   622,   623,   623,   623,   623,
     623,   624,   624,   625,   626,   626,   627,   628,   628,   629,
     629,   630,   630,   630,   631,   632,   632,   633,   633,   633,
     633,   633,   634,   634,   635,   635,   636,   636,   636,   637,
     637,   638,   639,   639,   640,   640,   641,   641,   642,   642,
     643,   643,   644,   645,   646,   646,   646,   646,   647,   647,
     647,   647,   647,   647,   647,   647,   647,   647,   647,   647,
     647,   647,   647,   648,   648,   649,   649,   650,   650,   651,
     652,   652,   652,   653,   653,   653,   653,   653,   653,   653,
     653,   653,   653,   653,   653,   653,   653,   653,   653,   653,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   655,   655,   656,
     656,   656,   656,   656,   657,   657,   658,   658,   658,   658,
     658,   658,   658,   658,   658,   658,   658,   659,   659,   660,
     660,   661,   661,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   661,   661,   661,   661,   661,   662,   662,   663,
     663,   664,   665,   665,   666,   666,   666,   666,   666,   667,
     667,   668,   668,   668,   668,   669,   669,   669,   669,   669,
     669,   669,   669,   669,   669,   669,   669,   669,   669,   669,
     669,   670,   670,   671,   671,   672,   672,   673,   673,   674,
     675,   676,   676,   677,   677,   678,   678,   679,   680,   680,
     681,   681,   681,   682,   682,   682,   683,   683,   683,   683,
     684,   685,   685,   686,   686,   687,   687,   688,   688,   689,
     689,   690,   690,   690,   691,   691,   692,   692,   692,   693,
     693,   693,   694,   694,   694,   695,   695,   695,   696,   696,
     697,   697,   698,   698,   699,   699,   700,   700,   701,   701,
     701,   701,   701,   702,   702,   702,   702,   702,   703,   704,
     705,   705,   705,   706,   706,   706,   707,   707,   708,   708,
     708,   708,   708,   708,   708,   708,   708,   708,   708,   708,
     708,   708,   708,   709,   709,   709,   709,   710,   710,   711,
     711,   712,   713,   713,   714,   715,   715,   716,   716,   717,
     717,   718,   718,   719,   719,   720,   720,   720,   720,   721,
     721,   722,   723,   723,   724,   724,   725,   725,   725,   726,
     726,   726,   727,   728,   728,   729,   729,   729,   730,   730,
     731,   731,   732,   732,   732,   732,   732,   732,   732,   732,
     732,   732,   732,   732,   732,   732,   732,   732,   732,   732,
     732,   732,   732,   732,   732,   732,   732,   732,   732,   732,
     732,   732,   732,   732,   732,   732,   732,   732,   732,   732,
     732,   732,   732,   733,   733,   734,   734,   735,   735,   735,
     735,   735,   735,   735,   735,   735,   735,   735,   735,   735,
     735,   735,   735,   735,   735,   735,   735,   735,   735,   736,
     736,   736,   736,   736,   736,   736,   736,   736,   736,   736,
     736,   736,   736,   736,   736,   736,   736,   737,   738,   738,
     738,   739,   739,   740,   740,   740,   740,   740,   741,   741,
     742,   742,   742,   742,   743,   743,   743,   744,   744,   745,
     746,   746,   747,   748,   748,   749,   749,   749,   749,   749,
     749,   749,   749,   749,   749,   749,   749,   749,   749,   750,
     750,   750,   751,   751,   751,   751,   751,   752,   752,   752,
     753,   753,   754,   754,   755,   755,   755,   755,   756,   757,
     758,   758,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   760,   760,
     761,   761,   762,   763,   763,   764,   765,   765,   766,   767,
     767,   767,   767,   767,   767,   767,   768,   768,   769,   770,
     770,   770,   770,   770,   770,   771,   772,   772,   772,   773,
     773,   774,   774,   774,   774,   774,   775,   775,   776,   776,
     776,   776,   777,   777,   778,   778,   779,   779,   780,   780,
     781,   781,   782,   782,   783,   783,   783,   783,   784,   784,
     784,   784,   784,   784,   784,   785,   785,   786,   787,   787,
     788,   788,   788,   789,   790,   790,   791,   791,   791,   791,
     792,   792,   793,   793,   794,   794,   794,   794,   795,   796,
     796,   796,   797,   797,   798,   799,   799,   800,   801,   801,
     802,   803,   803,   804,   804,   804,   804,   804,   804,   804,
     804,   805,   805,   806,   807,   807,   808,   808,   809,   810,
     811,   812,   812,   813,   814,   815,   815,   815,   815,   815,
     816,   816,   816,   817,   817,   818,   818,   819,   819,   819,
     819,   819,   819,   819,   819,   820,   820,   821,   821,   821,
     821,   821,   821,   822,   822,   823,   823,   824,   825,   825,
     826,   826,   827,   827,   827,   827,   827,   827,   827,   827,
     827,   828,   828,   829,   829,   829,   830,   830,   830,   830,
     831,   831,   832,   833,   833,   834,   834,   835,   835,   835,
     835,   836,   836,   837,   837,   837,   838,   838,   839,   839,
     840,   841,   841,   841,   842,   843,   843,   844,   844,   845,
     845,   846,   846,   847,   847,   848,   848,   849,   849,   850,
     850,   851,   851,   852,   852,   853,   853,   854,   854,   855,
     855,   855,   855,   855,   855,   855,   855,   855,   855,   855,
     856,   856,   856,   856,   856,   856,   857,   857,   857,   857,
     858,   858,   858,   858,   859,   859,   860,   860,   861,   861,
     861,   861,   862,   862,   863,   863,   863,   864,   865,   865,
     866,   866,   866,   867,   867,   868,   868,   869,   870,   870,
     870,   870,   870,   870,   871,   871,   871,   872,   872,   872,
     872,   872,   872,   872,   873,   873,   873,   873,   874,   874,
     875,   875,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   877,   877,   878,   878,   879,   879,   880,
     881,   882,   882,   883,   883,   884,   885,   886,   886,   886,
     886,   886,   886,   887,   887,   888,   888,   889,   889,   889,
     889,   890,   891,   891,   891,   892,   892,   892,   892,   892,
     892,   892,   892,   892,   892,   892,   892,   892,   892,   893,
     893,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     895,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     895,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     895,   895,   896,   896,   896,   896,   896,   896,   896,   896,
     896,   896,   896,   896,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   898,   898,   899,   899,   899,   899,
     900,   901,   901,   902,   902,   903,   903,   904,   904,   904,
     905,   905,   905,   905,   906,   906,   907,   907,   908,   909,
     909,   909,   910,   911,   911,   912,   912,   913,   913,   913,
     914,   914,   915,   915,   915,   915,   915,   916,   916,   916,
     917,   917,   917,   918,   918,   919,   919,   919,   919,   919,
     919,   919,   919,   919,   920,   920,   921,   921,   922,   922,
     922,   922,   922,   922,   923,   923,   924,   924,   925,   925,
     926,   926,   927,   927,   927,   928,   928,   929,   929,   930,
     930,   930,   930,   930,   930,   930,   930,   931,   931,   932,
     933,   933,   934,   934,   934,   934,   934,   934,   935,   936,
     937,   937,   937,   938,   938,   939,   940,   940,   941,   942,
     942,   943,   943,   944,   944,   945,   945,   945,   945,   946,
     946,   947,   947,   948,   948,   949,   949,   950,   950,   951,
     952,   952,   953,   953,   953,   953,   954,   954,   955,   955,
     956,   956,   957,   958,   959,   960,   961,   962,   963,   963,
     964,   964,   964,   964,   964,   964,   964,   964,   964,   964,
     964,   964,   964,   965,   966,   967,   968,   968,   969,   969,
     969,   970,   970,   970,   971,   971,   971,   972,   972,   972,
     972,   973,   973,   973,   973,   973,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   976,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   976,   976,   976,   976,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   977,   977,
     977,   977
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     1,     0,     2,
       0,     2,     0,     2,     2,     3,     3,     1,     3,     3,
       2,     1,     1,     2,     2,     2,     3,     3,     5,     5,
       0,     3,     5,     5,     5,     3,     5,     3,     5,     5,
       6,     1,     1,     3,     5,     6,     4,     1,     0,     2,
       0,     1,     1,     1,     1,     1,     1,     2,     3,     3,
       2,     5,     1,     3,     3,     3,     3,     3,     3,     2,
       2,     2,     2,     3,     3,     3,     3,     1,     3,     1,
       3,     1,     1,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     6,     1,     1,     1,     1,     1,
       0,     1,     1,     2,     3,     4,     3,     2,     2,     1,
       2,     1,     2,     3,     4,     3,     2,     4,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     4,     6,     4,
       6,     4,     6,     4,     6,     1,     3,     2,     3,     4,
       6,     6,     6,     5,     5,     6,     6,     4,     8,     4,
       2,     3,     6,     4,     3,     3,     3,     3,     3,     4,
       4,     3,     3,     3,     3,     3,     3,     4,     4,     3,
       2,     3,     2,     2,     3,     3,     2,     2,     1,     3,
       2,     1,     1,     0,     2,     0,     2,     0,     3,     2,
       0,     1,     3,     3,     1,     5,     3,     4,     1,     3,
       4,     6,     4,     8,     2,     2,    10,     6,     1,     1,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     3,
       3,     1,     1,     3,     3,     3,     3,     4,     2,     1,
       0,     2,     0,     3,     0,     1,     0,     1,     3,     2,
       1,     1,     1,     3,     0,     1,     3,     1,    11,    14,
      10,    13,     1,     1,     2,     2,     2,     2,     1,     0,
       1,     0,     3,     0,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     4,     4,     2,     0,     3,     1,     1,
       2,     2,     1,     3,     4,     5,     2,     5,     1,     2,
       2,     2,     3,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     3,     1,     5,     7,     3,     8,     4,     9,
      11,     2,     0,     3,     0,     1,     3,     1,     2,     2,
       2,     0,     1,     3,     3,     6,     4,     0,     1,     1,
       2,     2,     0,     3,     3,     2,     1,     1,     2,     2,
       4,     0,     2,     2,     2,     0,     3,     4,     4,     0,
       2,     0,     4,     0,     3,     7,     5,     2,     3,     0,
       5,     4,     6,     1,     0,     1,     2,     2,     1,     2,
       3,     2,     2,     2,     2,     3,     3,     1,     3,     1,
       0,     1,     2,     2,     1,     1,     3,     6,    10,     1,
       0,     1,     2,     2,     0,     2,     2,     1,     0,     5,
       7,     1,     0,     6,     2,     0,     3,     5,     5,     8,
       2,     0,     2,     2,     2,     5,     2,     0,     2,     7,
      10,     6,     6,     6,     6,     7,     7,     9,     9,     6,
       6,     8,     8,     8,     8,     6,     6,     7,     8,     6,
       6,     7,     2,     2,     2,     2,     1,     2,     1,     0,
       6,     8,     7,     6,     4,     0,     1,     3,     4,     1,
       3,     1,     2,     2,     2,     2,     1,     1,    10,     2,
       0,     2,     2,     1,     0,     4,     6,     5,     4,     4,
       8,    11,     3,     2,     1,     3,     1,     5,     7,     8,
       1,     1,     1,     7,     9,     8,    15,    20,     1,     1,
       2,     1,     3,     1,     1,     1,     3,     1,     3,     0,
       1,     0,     1,     1,     4,     0,     1,     3,     0,     1,
       1,     1,     1,     2,     0,     0,     2,     2,     1,     2,
       2,     2,     2,     6,     8,     8,     4,     5,     4,     4,
       4,     3,     7,     8,     6,     6,     6,     6,     6,     4,
       5,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     1,     3,     3,     1,     0,     1,
       3,     6,     8,     8,    13,     1,     3,     5,     6,     4,
       7,     2,     1,     0,     2,     0,     2,     4,     0,     1,
       0,     6,     8,     8,     1,     3,     5,     5,     7,     9,
       7,     9,     5,     6,     6,     4,     5,     7,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     1,     3,     1,     2,     2,     3,     5,
       2,     2,     0,     6,     7,     7,     7,     8,     8,     6,
       8,     9,     9,     7,    10,     7,     8,     8,     8,     8,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     3,     1,     1,     8,
       9,     9,     9,     9,     2,     0,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     2,     3,     3,     3,     3,     4,     4,     3,
       3,     3,     4,     4,     3,     4,     4,     1,     1,     1,
       0,     7,     7,    10,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     1,     2,     2,     4,     3,
       2,     2,     2,     2,     3,     2,     2,     2,     5,     5,
       5,     1,     3,     1,     2,     3,     0,     1,     3,     2,
       6,     6,     9,     3,     0,     3,     0,     5,     2,     0,
       3,     3,     3,     7,     7,    10,     1,     1,     1,     1,
      14,     1,     0,     1,     0,     1,     0,     2,     0,     1,
       3,     5,     5,     7,     2,     0,     1,     2,     0,     1,
       1,     0,     1,     1,     0,     9,    12,     7,     2,     0,
       3,     2,     1,     3,     3,     2,     1,     3,     3,     3,
       2,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     4,     5,     1,     3,     3,     1,     2,     4,     5,
       1,     1,     1,     1,     3,     3,     2,     2,     1,     2,
       2,     2,     1,     2,     2,     1,     1,     1,     3,     2,
       0,     2,     1,     3,     5,     1,     2,     1,     0,     5,
       7,     5,     7,     5,     7,     3,     5,     5,     5,     1,
       3,     2,     1,     2,     1,     2,    11,    10,    10,     2,
       2,     0,     9,     2,     0,     4,     4,     4,     1,     1,
       1,     0,     7,     6,     6,     6,     6,     8,     8,     6,
       6,     7,     9,     9,     6,     6,     6,     8,     6,     8,
       6,     8,     6,     8,     7,     9,     8,    10,     8,     9,
      11,     8,     6,     6,     6,     5,     5,     8,     8,     8,
       8,     6,     9,     1,     0,     2,     0,     7,     6,     6,
       6,     6,     6,     7,     9,     9,     6,     8,     8,     8,
       8,     8,     6,     8,     6,     8,     7,     9,     6,     7,
       6,     6,     6,     6,     6,     7,     7,     7,     9,     9,
       6,     6,     6,     8,     8,     8,     6,    13,     1,     1,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     0,     6,     8,     3,
       2,     0,     2,     2,     2,     2,     3,     3,     2,     2,
       2,     2,     3,     2,     5,     4,     3,     3,     3,     1,
       1,     0,     3,     2,     2,     1,     2,     1,     3,     2,
       1,     0,     9,    11,     3,     4,     4,     0,     2,     5,
       2,     0,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     3,     3,     1,     0,
       5,     6,     4,     2,     0,     4,     3,     5,     6,     4,
       6,     6,     5,     7,     9,     6,     1,     0,     6,    11,
      11,    11,    13,     9,    11,    10,     4,     2,     5,     2,
       0,     4,     5,     5,     4,     6,     1,     3,     1,     1,
       1,     1,     2,     4,     1,     1,     1,     0,     1,     0,
       1,     0,     3,     0,     2,     4,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     2,     1,     1,
       1,     1,     0,     5,     3,     0,     1,     1,     1,     1,
       3,     9,     3,     0,     2,     3,     2,     3,     6,     1,
       4,     2,     1,     3,     2,     2,     0,     7,     2,     0,
       5,     3,     0,     2,     2,     2,     3,     1,     3,     1,
       2,     1,     0,     8,     1,     3,     1,     1,     3,     5,
       2,     1,     3,     7,     1,     0,     3,     2,     2,     2,
       0,     2,     2,     1,     1,     3,     3,     1,     2,     4,
       4,     2,     3,     5,     5,     1,     1,     9,     1,     2,
       4,     4,     4,     2,     3,     1,     3,     6,     1,     0,
       2,     0,     3,     3,     4,     4,     4,     4,     3,     2,
       1,     1,     0,     1,     1,     0,     1,     5,     1,     0,
       1,     0,     3,     1,     3,     4,     3,     2,     2,     1,
       1,     1,     0,     2,     4,     5,     2,     3,     1,     1,
       1,     1,     3,     0,     1,     1,     1,     1,     1,     3,
       0,     2,     0,     1,     3,     1,     0,     1,     2,     4,
       4,     2,     0,     2,     3,     2,     0,     1,     3,     1,
       2,     1,     2,     5,     6,     5,     1,     2,     1,     4,
       3,     4,     5,     4,     5,     4,     5,     2,     4,     1,
       2,     2,     2,     1,     1,     0,     4,     2,     1,     2,
       2,     4,     1,     3,     1,     2,     3,     1,     2,     0,
       2,     4,     0,     1,     0,     1,     3,     3,     2,     3,
       5,     6,     2,     3,     3,     4,     0,     1,     1,     1,
       1,     1,     2,     5,     1,     1,     1,     1,     2,     3,
       3,     0,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     1,     3,     0,     1,     1,     1,     1,     5,
       2,     1,     1,     1,     1,     5,     2,     2,     2,     1,
       3,     3,     2,     1,     0,     3,     0,     5,     2,     5,
       2,     1,     2,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     0,     1,
       4,     1,     3,     3,     5,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     3,
       3,     2,     3,     5,     4,     6,     3,     5,     4,     6,
       4,     6,     5,     7,     3,     2,     4,     2,     3,     3,
       4,     3,     4,     3,     4,     5,     6,     6,     7,     6,
       7,     6,     7,     3,     4,     4,     6,     2,     3,     4,
       1,     3,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     5,     6,     6,     7,
       3,     4,     1,     1,     2,     4,     1,     1,     1,     2,
       2,     2,     2,     1,     4,     5,     6,     8,     6,     7,
       7,     5,     5,     1,     1,     4,     1,     4,     1,     4,
       1,     4,     1,     1,     1,     1,     1,     1,     6,     4,
       4,     4,     4,     6,     5,     5,     5,     4,     6,     4,
       4,     4,     4,     5,     7,     7,     9,     5,     4,     6,
       5,     7,     7,     7,     2,     3,     3,     3,     4,     0,
       4,     1,     3,     3,     1,     1,     1,     2,     2,     0,
       2,     4,     4,     6,     2,     0,     1,     3,     3,     2,
       2,     0,     6,     1,     0,     3,     0,     2,     2,     0,
       1,     4,     2,     2,     2,     2,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     4,     1,     4,
       1,     2,     1,     2,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     3,     2,     1,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     2,
       3,     0,     3,     3,     2,     2,     1,     0,     2,     2,
       3,     2,     1,     1,     3,     5,     1,     2,     4,     2,
       0,     1,     0,     1,     2,     2,     2,     3,     5,     1,
       2,     0,     2,     1,     0,     1,     1,     1,     3,     3,
       1,     3,     3,     2,     1,     1,     1,     3,     1,     2,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     2,     5,     2,     3,     6,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 654 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 19054 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 661 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 19065 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 668 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1((yyvsp[0].node));
					else
						(yyval.list) = NIL;
				}
#line 19076 "gram.c" /* yacc.c:1646  */
    break;

  case 115:
#line 788 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19082 "gram.c" /* yacc.c:1646  */
    break;

  case 116:
#line 799 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19094 "gram.c" /* yacc.c:1646  */
    break;

  case 117:
#line 809 "gram.y" /* yacc.c:1646  */
    {}
#line 19100 "gram.c" /* yacc.c:1646  */
    break;

  case 118:
#line 810 "gram.y" /* yacc.c:1646  */
    {}
#line 19106 "gram.c" /* yacc.c:1646  */
    break;

  case 119:
#line 819 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 19112 "gram.c" /* yacc.c:1646  */
    break;

  case 120:
#line 820 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 19118 "gram.c" /* yacc.c:1646  */
    break;

  case 121:
#line 824 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 19124 "gram.c" /* yacc.c:1646  */
    break;

  case 122:
#line 825 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 19130 "gram.c" /* yacc.c:1646  */
    break;

  case 123:
#line 830 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 19139 "gram.c" /* yacc.c:1646  */
    break;

  case 124:
#line 835 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
#line 19147 "gram.c" /* yacc.c:1646  */
    break;

  case 125:
#line 839 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 19156 "gram.c" /* yacc.c:1646  */
    break;

  case 126:
#line 844 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 19165 "gram.c" /* yacc.c:1646  */
    break;

  case 127:
#line 849 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
#line 19173 "gram.c" /* yacc.c:1646  */
    break;

  case 128:
#line 853 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 19181 "gram.c" /* yacc.c:1646  */
    break;

  case 129:
#line 857 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)));
				}
#line 19189 "gram.c" /* yacc.c:1646  */
    break;

  case 130:
#line 862 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 19197 "gram.c" /* yacc.c:1646  */
    break;

  case 131:
#line 866 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[0].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 19252 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 919 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 19258 "gram.c" /* yacc.c:1646  */
    break;

  case 133:
#line 922 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 19266 "gram.c" /* yacc.c:1646  */
    break;

  case 134:
#line 926 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list));
				}
#line 19274 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 930 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 19282 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 934 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 19290 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 938 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 19298 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 952 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19310 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 970 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 19322 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 980 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 19328 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 981 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19334 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 986 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 19346 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1004 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 19358 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1016 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 19370 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1037 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19381 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1044 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19392 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1063 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19403 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1070 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 19414 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1087 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19426 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1105 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 19439 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1115 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 19445 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1116 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 19451 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1129 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19462 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1136 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19473 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1153 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					n->schemaElts = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19489 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1165 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19502 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1176 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19508 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1177 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 19514 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1181 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 19520 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1182 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 19526 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1210 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 19536 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1216 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 19546 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1222 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 19556 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1231 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 19568 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1239 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 19580 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1251 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 19592 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1259 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 19604 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1267 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 19615 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1274 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 19626 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1281 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 19637 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1289 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 19652 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1300 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 19664 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1308 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 19676 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1316 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 19691 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1327 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 19703 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1335 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 19715 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1343 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 19726 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1350 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 19738 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1359 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 19750 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1368 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19756 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1370 "gram.y" /* yacc.c:1646  */
    {
					(yyval.str) = palloc(strlen((yyvsp[-2].str)) + strlen((yyvsp[0].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
				}
#line 19765 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1376 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 19771 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1377 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 19777 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1381 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 19783 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1383 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 19789 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1386 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 19795 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1387 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 19801 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1388 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 19807 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1389 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 19813 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1393 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 19819 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1394 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 19825 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1395 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 19831 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1401 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19837 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1414 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 19845 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1418 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 19853 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1422 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 19872 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1437 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 19899 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1459 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 19905 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1460 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19911 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1461 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19917 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1465 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19923 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1466 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 19929 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1467 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 19935 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1471 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19941 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1472 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19947 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1477 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 19958 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1484 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 19969 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1491 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 19980 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1498 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 19991 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1505 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				}
#line 20001 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1514 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 20007 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1515 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 20013 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1520 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 20019 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1521 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 20025 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1527 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 20035 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1533 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 20045 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1539 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 20055 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1545 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 20065 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1551 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 20075 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1561 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 20086 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1570 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20092 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1571 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 20098 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1575 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 20104 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1576 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 20110 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1585 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 20119 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1600 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 20129 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1606 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 20139 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1612 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 20149 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1618 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 20159 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1636 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20172 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1645 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20185 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1654 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20198 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1663 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20211 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1672 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20224 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1681 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20237 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1690 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20250 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1699 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20263 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1710 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 20269 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1711 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 20275 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1717 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 20286 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1725 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 20297 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1733 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 20309 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1742 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 20320 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1750 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 20331 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1758 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 20343 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1767 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20355 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1776 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20367 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1785 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 20379 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1794 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 20392 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1804 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 20405 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1817 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 20422 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1831 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20434 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1840 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 20445 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1848 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20456 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1856 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 20469 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1866 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 20482 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1876 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 20492 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1883 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 20502 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1890 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20513 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1898 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 20524 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1906 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20535 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1914 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20546 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1922 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20557 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1930 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 20567 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1937 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 20577 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1944 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20588 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1952 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 20598 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1959 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 20608 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1966 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20619 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1974 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20630 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1982 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20641 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1990 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20652 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1998 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 20663 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2006 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 20674 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2014 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 20687 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2024 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 20697 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2031 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20708 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2039 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20719 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2047 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20730 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2055 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20741 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2062 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 20752 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2071 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20758 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2072 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 20764 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2076 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 20770 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2077 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 20776 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2078 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 20782 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2083 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 20794 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2090 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 20800 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2094 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20806 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2095 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 20812 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2099 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 20818 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2102 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 20824 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2103 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20830 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2107 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 20836 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2108 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 20842 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2114 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 20850 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2118 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 20858 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2122 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC);
				}
#line 20867 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2127 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC);
				}
#line 20875 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2142 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 20889 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2154 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 20895 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2155 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 20901 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2161 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 20913 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2170 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 20926 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2180 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 20939 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2190 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					(yyval.node) = (Node *)n;
				}
#line 20957 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2215 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20967 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2221 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 20977 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2249 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-7].range);
					n->query = NULL;
					n->attlist = (yyvsp[-6].list);
					n->is_from = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-8].defelt))
						n->options = lappend(n->options, (yyvsp[-8].defelt));
					if ((yyvsp[-5].defelt))
						n->options = lappend(n->options, (yyvsp[-5].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 21002 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2270 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-4].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21017 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2283 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 21023 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2284 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 21029 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2293 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21035 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2294 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21041 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2295 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21047 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2298 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21053 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2299 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 21059 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2304 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 21065 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2305 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21071 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2310 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 21079 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2314 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 21087 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2318 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 21095 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2322 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
				}
#line 21103 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2326 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
#line 21111 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2330 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
#line 21119 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2334 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
				}
#line 21127 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2338 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
				}
#line 21135 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2342 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
				}
#line 21143 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2346 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
#line 21151 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2350 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
				}
#line 21159 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2354 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 21167 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2363 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 21175 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2366 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 21181 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2371 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 21189 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2374 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 21195 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2379 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 21203 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2382 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 21209 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2386 "gram.y" /* yacc.c:1646  */
    {}
#line 21215 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2387 "gram.y" /* yacc.c:1646  */
    {}
#line 21221 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2393 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 21229 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 21237 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2404 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 21245 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2410 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 21251 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2411 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 21257 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2412 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 21263 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2413 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 21269 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2414 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21275 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2419 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 21283 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2423 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 21291 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2430 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 21297 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2443 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-9].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 21315 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2459 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 21333 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2474 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-8].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 21352 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2490 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 21371 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2517 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 21377 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2518 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 21383 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2519 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 21389 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2520 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 21395 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2522 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 21406 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2529 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 21417 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2535 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 21423 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2536 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 21429 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2540 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21435 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2541 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21441 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2545 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 21447 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2546 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21453 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 21461 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2555 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 21469 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2562 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 21477 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2566 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 21485 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2572 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21491 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2573 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21497 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2574 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21503 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2578 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21509 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2579 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21515 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2583 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 21537 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2603 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 21558 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2622 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 21564 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2623 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21570 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2628 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 21582 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2635 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21588 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2636 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21594 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2638 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 21611 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2669 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 21622 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2676 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 21633 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2683 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21648 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2694 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21663 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2705 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 21677 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2715 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 21690 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2724 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 21709 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2757 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 21720 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2764 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 21731 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2771 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 21742 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2778 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 21753 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2789 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 21764 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2798 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 21770 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2799 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 21776 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2800 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 21782 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2804 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 21788 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2805 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 21794 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2806 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 21800 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2807 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 21806 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2808 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 21812 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2809 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 21818 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2819 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 21830 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2826 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21836 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2831 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 21853 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2845 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 21871 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2859 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 21889 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2874 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 21907 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2888 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 21925 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2904 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 21945 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2921 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 21967 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2940 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 21973 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2941 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 21979 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2945 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 21985 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2946 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21991 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2950 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 21997 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2951 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 22003 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2955 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 22011 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2961 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 22019 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2965 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 22031 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2973 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			}
#line 22039 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2977 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			}
#line 22047 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2983 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 22053 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2985 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 22059 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2989 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 22067 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2994 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 22075 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3000 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 22081 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3001 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22087 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3012 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 22093 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3014 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 22099 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3016 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 22105 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3018 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 22111 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3020 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 22117 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3023 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 22123 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3026 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 22129 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3030 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 22135 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3031 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 22141 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3032 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 22147 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3033 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 22153 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3034 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 22159 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3037 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22165 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3038 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22171 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3043 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22177 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3044 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(true)); }
#line 22183 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3045 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(false)); }
#line 22189 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3046 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22195 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3049 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 22201 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3050 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 22207 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3051 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 22213 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3052 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 22219 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3055 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22225 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3056 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22231 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3059 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22237 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3060 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22243 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3063 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22249 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3079 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 22264 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3093 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 22278 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3105 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22284 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3106 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 22290 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3107 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22296 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3121 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 22309 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3133 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 22321 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3141 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 22333 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3151 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22339 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22345 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3155 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 22351 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3156 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 22357 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3160 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value));
				}
#line 22365 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3164 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
#line 22373 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3168 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
#line 22381 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3172 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value));
				}
#line 22389 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3176 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value));
				}
#line 22397 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3180 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value));
				}
#line 22405 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3184 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
#line 22413 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3188 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
#line 22421 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3192 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list));
				}
#line 22429 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3196 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value));
				}
#line 22437 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3200 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
#line 22445 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3204 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value));
				}
#line 22453 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3209 "gram.y" /* yacc.c:1646  */
    {}
#line 22459 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3210 "gram.y" /* yacc.c:1646  */
    {}
#line 22465 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3214 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 22471 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3215 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 22477 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3217 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 22486 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3221 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 22492 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3224 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 22498 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3225 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 22504 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3238 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 22520 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3251 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 22535 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3264 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22541 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3265 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 22547 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3273 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 22553 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 22559 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3278 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22565 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3279 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22571 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3283 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22577 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3284 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22583 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3288 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22589 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3289 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22595 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3294 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 22610 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3305 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 22624 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3317 "gram.y" /* yacc.c:1646  */
    {}
#line 22630 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3318 "gram.y" /* yacc.c:1646  */
    {}
#line 22636 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3329 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-3].str);
					n->owner = (yyvsp[-2].str);
					n->location = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 22648 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3338 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22654 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3339 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22660 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3353 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 22671 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3360 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 22682 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3377 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22694 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3385 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22706 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3396 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 22712 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3398 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22718 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3403 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)));
				}
#line 22726 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3407 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 22734 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3411 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 22742 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3423 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22753 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3433 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 22759 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3435 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22765 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3440 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 22773 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3453 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22787 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3463 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-3].typnam));
					n->objargs = list_make1((yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 22801 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3473 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22814 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3482 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22827 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3491 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22840 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3500 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[0].funwithargs)->funcname;
					n->objargs = (yyvsp[0].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
#line 22854 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3510 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 22867 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3519 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22881 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3529 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 22895 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3539 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 22909 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3549 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 22922 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3558 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22935 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3567 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22948 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3576 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22961 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3585 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22974 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3594 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22987 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3603 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23000 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3612 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23013 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3621 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23026 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3630 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23039 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3639 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23052 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3648 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23065 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3666 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23077 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3676 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list)); }
#line 23083 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3677 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL); }
#line 23089 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3678 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list)); }
#line 23095 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3679 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL); }
#line 23101 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 23107 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3684 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23113 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3688 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23119 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3689 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23125 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3700 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 23140 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3711 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 23155 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3731 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23167 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3739 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 23179 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3750 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23185 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 3751 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23191 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3756 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 23199 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3760 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 23207 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 3767 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23213 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3772 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 23221 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 3776 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 23229 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3783 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 23237 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 3787 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 23246 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3792 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 23255 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 3797 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP);
				}
#line 23263 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 3804 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 23271 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3810 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23277 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3815 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 23283 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3827 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23297 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3839 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23303 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3840 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23309 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3845 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23315 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3846 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23321 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3850 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23327 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3851 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23333 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3862 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 23348 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3873 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 23363 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 3893 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 23376 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 3902 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 23388 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 3910 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23399 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 3929 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-4].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-4].range);
					n->base.tableElts = (yyvsp[-3].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23416 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 3944 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-4].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-4].range);
					n->base.tableElts = (yyvsp[-3].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23433 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 3959 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23439 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 3960 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23445 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 3965 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 23453 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 3969 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 23461 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 3975 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 23467 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 3987 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 23480 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 3996 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 23493 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4014 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23505 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4025 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 23511 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4026 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 23517 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4027 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (strcmp((yyvsp[0].str), "public") == 0) ? NULL : (yyvsp[0].str); }
#line 23523 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4038 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 23535 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4046 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 23547 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4063 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23559 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4084 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-12].str);
					n->relation = (yyvsp[-8].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-11].ival);
					n->events = intVal(linitial((yyvsp[-10].list)));
					n->columns = (List *) lsecond((yyvsp[-10].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 23581 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4105 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 23604 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4126 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 23610 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4127 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 23616 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4128 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 23622 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4133 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23628 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4135 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 23651 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4157 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 23657 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4159 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 23663 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4161 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 23669 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4163 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 23675 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4165 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 23681 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4170 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 23689 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4174 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 23701 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4184 "gram.y" /* yacc.c:1646  */
    {}
#line 23707 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4185 "gram.y" /* yacc.c:1646  */
    {}
#line 23713 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4189 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 23719 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4190 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 23725 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4194 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 23731 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4195 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 23737 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4199 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 23743 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4200 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 23749 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23755 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4206 "gram.y" /* yacc.c:1646  */
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[0].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
#line 23765 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4211 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 23771 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4212 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 23777 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4213 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 23783 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4217 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 23789 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4218 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 23795 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4223 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 23801 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4225 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 23829 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4251 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 23835 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4252 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 23841 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4253 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 23847 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4254 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 23853 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4255 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 23859 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4256 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 23865 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4262 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 23880 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4273 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 23895 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4297 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 23915 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4316 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 23931 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4339 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23945 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4349 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23960 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4360 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23974 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4370 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23988 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4380 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 24003 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4391 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 24016 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4400 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 24027 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4407 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24038 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4414 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24051 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4423 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24064 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4432 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24077 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4441 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24090 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4450 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24103 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4459 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 24116 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4469 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 24122 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4472 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 24128 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4473 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 24134 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4477 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 24142 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 24150 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4487 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 24156 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4488 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 24162 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4489 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 24168 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4490 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 24174 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4491 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 24180 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4494 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 24186 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4495 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24192 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 24198 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4501 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 24204 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4502 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 24210 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4511 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node));
				}
#line 24218 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4517 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24224 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4518 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24230 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4522 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 24236 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4524 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 24242 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4535 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-3].list);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				(yyval.node) = (Node *) n;
			}
#line 24255 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4544 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-5].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				(yyval.node) = (Node *) n;
			}
#line 24268 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4553 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-5].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				(yyval.node) = (Node *) n;
			}
#line 24281 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4578 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24296 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4591 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 24302 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4592 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 24308 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4597 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = NIL;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 24322 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4608 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-3].list);
					n->args = (yyvsp[-2].list);
					n->number = (yyvsp[-4].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 24336 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4618 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 24349 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4627 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-5].ival);
					n->class_args = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 24363 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4637 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 24374 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4645 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 24380 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4646 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24386 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4649 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24392 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4650 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24398 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4653 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24404 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4654 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24410 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4655 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24416 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4659 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 24434 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4672 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24440 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4678 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24451 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4688 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24464 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4697 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24477 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 24483 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4709 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 24489 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 4714 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 24501 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 4722 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 24513 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 4734 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24528 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 4745 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24543 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 4759 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24558 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 4770 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24573 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 4793 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 24584 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 4803 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24595 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 4821 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 24610 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 4832 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 24625 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 4843 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 24640 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 4854 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 24655 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 4867 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 24661 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 4868 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 24667 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 4869 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 24673 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 4870 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 24679 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 4871 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 24685 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 4872 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 24691 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 4873 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 24697 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 4874 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 24703 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 4875 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 24709 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 4876 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 24715 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 4877 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 24721 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 4878 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 24727 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 4879 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 24733 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 4880 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 24739 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 4881 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 24745 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 4885 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 24751 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 4886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 24757 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 4889 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 24763 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 4890 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 24769 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 4894 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 24775 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 4896 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 24781 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 4909 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 24793 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 4919 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 24799 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 4920 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 24805 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 4921 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 24811 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 4948 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24824 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 4957 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24837 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 4966 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24850 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 4975 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24863 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 4984 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24876 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 4993 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24889 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5002 "gram.y" /* yacc.c:1646  */
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[-2].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24903 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5012 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24916 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5021 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24929 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5030 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24942 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5039 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24955 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5048 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-5].typnam));
					n->objargs = list_make1((yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24968 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5057 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24981 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5066 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24993 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5074 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25005 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5082 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25017 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5090 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25029 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5100 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 25035 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5101 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 25041 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5102 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 25047 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5103 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 25053 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5104 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 25059 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5105 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 25065 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5106 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 25071 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5107 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 25077 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5108 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 25083 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5109 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 25089 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5110 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 25095 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5111 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 25101 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5112 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 25107 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5113 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 25113 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5114 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 25119 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5115 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 25125 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5116 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 25131 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5120 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25137 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5121 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25143 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5137 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25157 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5148 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25171 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5159 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25185 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5170 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25199 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5181 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25213 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5192 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25219 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5193 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25225 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5197 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 25231 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5198 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 25237 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5199 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 25243 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5200 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 25249 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5201 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 25255 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5202 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 25261 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5203 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 25267 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5204 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 25273 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5205 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 25279 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5206 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 25285 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5207 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 25291 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5210 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25297 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5211 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25303 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5222 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 25313 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5228 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 25323 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5236 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 25335 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5244 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 25347 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5252 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 25359 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5260 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 25371 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5268 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 25383 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5276 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 25395 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5284 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 25407 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5292 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 25419 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5300 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 25431 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5308 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 25443 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5316 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 25455 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5324 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 25467 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5332 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 25479 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5340 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 25491 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5348 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 25503 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5356 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 25515 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5365 "gram.y" /* yacc.c:1646  */
    {}
#line 25521 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5366 "gram.y" /* yacc.c:1646  */
    {}
#line 25527 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5369 "gram.y" /* yacc.c:1646  */
    {}
#line 25533 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5370 "gram.y" /* yacc.c:1646  */
    {}
#line 25539 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5382 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 25555 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5398 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 25572 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5412 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 25589 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5437 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25595 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5439 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25601 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5441 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25607 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5443 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 25618 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5450 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 25629 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5458 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 25635 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5459 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 25641 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5463 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 25652 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5470 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 25663 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5477 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 25674 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5484 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 25685 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5498 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25697 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5506 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25709 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5514 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25721 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5522 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25733 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5530 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25745 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5538 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25757 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5546 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25769 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5554 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25781 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5562 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25793 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5570 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25805 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5578 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25817 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5586 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25829 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5594 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25841 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5602 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25853 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5610 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25865 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 5618 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 25877 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 5629 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 25883 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 5630 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 25889 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 5634 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 25903 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 5644 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 25917 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 5657 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25923 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 5658 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25929 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 5662 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].funwithargs)); }
#line 25935 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 5664 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].funwithargs)); }
#line 25941 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 5669 "gram.y" /* yacc.c:1646  */
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[-1].list);
					n->funcargs = extractArgTypes((yyvsp[0].list));
					(yyval.funwithargs) = n;
				}
#line 25952 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 5685 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].str);
					(yyval.node) = (Node*)n;
				}
#line 25966 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 5698 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 25980 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 5708 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 25994 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 5719 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26000 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 5720 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26006 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 5723 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26012 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 5724 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26018 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 5735 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 26029 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 5744 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26035 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 5745 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26041 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 5750 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list));
				}
#line 26049 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 5754 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 26057 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 5758 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 26065 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 5770 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 26081 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 5783 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26098 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 5797 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26115 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 5812 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 26121 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 5813 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 26127 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 5814 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 26133 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 5815 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 26139 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 5830 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					(yyval.node) = (Node *)n;
				}
#line 26165 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 5854 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26171 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 5855 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26177 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 5859 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26183 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 5860 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26189 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 5864 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26195 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 5865 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26201 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 5869 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26207 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 5870 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 26213 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 5873 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 26219 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 5874 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 26225 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 5883 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 26240 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 5894 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 26255 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 5905 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 26270 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 5917 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26276 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 5918 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26282 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 5921 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26288 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 5922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26294 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 5923 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26300 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 5926 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 26306 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 5927 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 26312 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 5928 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 26318 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 5931 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 26324 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 5932 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 26330 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 5933 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 26336 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 5951 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26351 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 5963 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26367 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 5976 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26382 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 5989 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26388 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 5990 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26394 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 5993 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 26400 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 5994 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26406 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 5998 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 26412 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 5999 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 26418 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6007 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 26424 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6008 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26430 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 26436 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6014 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 26442 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6029 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 26455 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6038 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 26468 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6047 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 26481 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6056 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 26494 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6065 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 26507 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6076 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 26513 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6077 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 26519 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6078 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 26525 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6079 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 26531 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6080 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 26537 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6091 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 26549 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6105 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 26555 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 26565 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6113 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 26576 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 26584 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6127 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 26593 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6132 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 26602 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6141 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 26608 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6142 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26614 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6150 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
#line 26622 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6154 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 26630 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6158 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 26638 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6162 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
#line 26646 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6166 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
#line 26654 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6170 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
#line 26662 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6174 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 26670 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6178 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 26678 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6182 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 26686 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6186 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 26694 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6190 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
#line 26702 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6194 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
#line 26710 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6198 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value));
				}
#line 26718 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6202 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value));
				}
#line 26726 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6206 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt));
				}
#line 26735 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6214 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list));
				}
#line 26743 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6218 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 26751 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6222 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
#line 26759 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6226 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 26767 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 26773 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6233 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 26781 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6239 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26787 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6240 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26793 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6244 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 26806 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6256 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 26814 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6260 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 26822 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6275 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].funwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 26833 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6285 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 26839 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6286 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26845 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6308 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26860 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6319 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26875 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6333 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26890 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6344 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26905 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6358 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26920 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6369 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 26935 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6383 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 26947 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6391 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 26953 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6393 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 26959 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6395 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 26965 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6400 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 26971 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6402 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 26977 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6415 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26987 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6423 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 26993 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6424 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26999 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6429 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)));
				}
#line 27007 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6433 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 27015 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6446 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].funwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 27029 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6457 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 27043 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6468 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 27057 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6479 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 27063 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6480 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 27069 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6481 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 27075 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6486 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[-4].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27090 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6498 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27096 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6499 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27102 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6514 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].objtype);
					n->relation = (yyvsp[-1].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 27114 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6522 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
#line 27128 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6532 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
#line 27142 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6544 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 27148 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6545 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 27154 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6548 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 27160 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6549 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 27166 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6560 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27180 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6570 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27193 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6579 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27206 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6588 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27219 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6597 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27232 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6606 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27246 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6616 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27259 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6625 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27273 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6635 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27286 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6644 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27299 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6653 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27313 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6663 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27327 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6673 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27340 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6682 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27353 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6691 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27367 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6701 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27381 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6711 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27395 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 6721 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27409 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 6731 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27423 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 6741 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27437 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 6751 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27451 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 6761 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27465 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 6771 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27479 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 6781 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27493 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 6791 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27508 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 6802 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27523 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 6813 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27537 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 6823 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27552 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 6834 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27567 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 6845 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27581 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 6855 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27594 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 6864 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27607 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 6873 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27620 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 6882 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 27633 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 6891 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 27646 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 6900 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27659 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 6909 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27672 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 6918 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27685 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 6927 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27698 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 6936 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27711 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 6945 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27727 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 6958 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 27733 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 6959 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 27739 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 6962 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 27745 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 6963 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 27751 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 6974 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27765 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 6984 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27778 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 6993 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27791 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7002 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27804 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7011 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27817 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7020 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27831 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7030 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27845 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7040 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->addname = (yyvsp[-3].str);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27859 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7050 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->addname = (yyvsp[-3].str);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27873 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7060 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27886 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7069 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27899 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7078 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27912 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7087 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27925 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7096 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27938 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7105 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27951 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7114 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27964 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7123 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 27977 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7132 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 27990 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7141 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28003 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7150 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28016 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7159 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28029 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7168 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28042 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7185 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28055 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7194 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28067 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7202 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28079 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7210 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28091 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7218 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28103 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7226 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28116 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7235 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28128 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7243 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[-3].value));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28140 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7251 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28153 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7260 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->addname = (yyvsp[-3].str);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28166 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7269 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->addname = (yyvsp[-3].str);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28179 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7278 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28191 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7286 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28203 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7294 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28215 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7302 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28227 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7310 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28239 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7318 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28251 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7326 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28263 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7345 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28279 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7359 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28285 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7360 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 28291 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7361 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28297 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7367 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 28307 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7373 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 28317 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7389 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28323 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7390 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28329 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7393 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 28335 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7394 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 28341 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7395 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 28347 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7396 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 28353 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7400 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28359 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7401 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28365 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7402 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28371 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7408 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28386 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7419 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 28401 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7441 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28412 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7450 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28418 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7451 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28424 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7455 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28434 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7464 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28444 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7470 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 28454 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7489 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 28465 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7496 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28476 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7503 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28487 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7510 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 28498 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7517 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 28509 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7524 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 28520 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7531 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 28532 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7539 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 28544 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7547 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 28556 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7555 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 28568 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7563 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 28580 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7571 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28591 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7578 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28602 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7585 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28613 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7593 "gram.y" /* yacc.c:1646  */
    {}
#line 28619 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7594 "gram.y" /* yacc.c:1646  */
    {}
#line 28625 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7595 "gram.y" /* yacc.c:1646  */
    {}
#line 28631 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7600 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0]))); }
#line 28638 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7603 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1]))); }
#line 28645 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7606 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 28652 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7609 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0]))); }
#line 28659 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7612 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 28666 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7619 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 28672 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7621 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 28678 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7623 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28684 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7629 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28690 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7643 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 28705 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7655 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 28720 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7669 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 28730 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7675 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 28740 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7681 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 28750 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7686 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28756 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7697 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28766 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7713 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28777 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28783 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7723 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28789 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7728 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[0].str)));
				}
#line 28797 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7732 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
#line 28805 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7736 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[0].str)));
				}
#line 28813 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7740 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
#line 28821 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7744 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[0].str)));
				}
#line 28829 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7748 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
#line 28837 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7752 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 28845 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7756 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 28853 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7760 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
#line 28861 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 7764 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[0].str)));
				}
#line 28869 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 7768 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
#line 28877 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 7772 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[0].str)));
				}
#line 28885 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 7776 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
#line 28893 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 7780 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 28901 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7784 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[0].str)));
				}
#line 28909 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7788 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
#line 28917 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7797 "gram.y" /* yacc.c:1646  */
    {}
#line 28923 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7798 "gram.y" /* yacc.c:1646  */
    {}
#line 28929 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7810 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 28940 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7817 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				 }
#line 28952 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 7828 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28963 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 7838 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28969 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 7839 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28975 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 7844 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 28983 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 7858 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 28994 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 7865 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 29005 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 7882 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 29018 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 7895 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29030 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 7904 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 29041 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 7912 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 29052 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 7920 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29064 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 7929 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29078 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 7940 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29092 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 7951 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29104 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 7960 "gram.y" /* yacc.c:1646  */
    {}
#line 29110 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 7961 "gram.y" /* yacc.c:1646  */
    {}
#line 29116 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 7973 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29127 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 7983 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 29141 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 7993 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 29155 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8003 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 29169 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8013 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 29183 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8023 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 29195 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8031 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 29207 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8053 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 29221 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8075 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 29233 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8083 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 29245 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8092 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 29257 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8102 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29263 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8103 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29269 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8116 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 29287 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8130 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 29305 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8144 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
#line 29321 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8156 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 29337 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8168 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 29355 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8184 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 29361 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8185 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 29367 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8189 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_ANALYZE; }
#line 29373 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8190 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 29379 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8191 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FREEZE; }
#line 29385 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8192 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FULL; }
#line 29391 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8197 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 29407 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8209 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29423 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8223 "gram.y" /* yacc.c:1646  */
    {}
#line 29429 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8224 "gram.y" /* yacc.c:1646  */
    {}
#line 29435 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8228 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 29441 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8229 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29447 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8232 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 29453 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8233 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29459 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8236 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 29465 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8237 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29471 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8241 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29477 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8242 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29483 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8256 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 29494 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8263 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 29508 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8273 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 29519 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8280 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 29530 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8300 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 29538 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8304 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 29546 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8311 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 29554 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8317 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29560 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8318 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 29566 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8322 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 29572 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8323 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 29578 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8324 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29584 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8335 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 29596 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8344 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29602 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8345 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29608 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8363 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29619 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8371 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 29637 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29643 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8387 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29649 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8398 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 29659 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8404 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 29669 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8410 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 29679 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8416 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 29689 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8432 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].istmt)->relation = (yyvsp[-2].range);
					(yyvsp[-1].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-1].istmt)->withClause = (yyvsp[-5].with);
					(yyval.node) = (Node *) (yyvsp[-1].istmt);
				}
#line 29700 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8442 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 29710 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8448 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 29720 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8454 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 29730 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8463 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 29736 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8465 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 29742 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8470 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 29754 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8480 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29760 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8481 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29766 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8494 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 29780 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8506 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29786 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8507 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29792 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8519 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29805 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8529 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 29811 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8530 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 29817 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8533 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 29823 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8534 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 29829 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8535 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 29835 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8536 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 29841 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8537 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 29847 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8538 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 29853 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8539 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 29859 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8540 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 29865 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8543 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 29871 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8544 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29877 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8560 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 29892 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8573 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29898 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8574 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 29904 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8578 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 29910 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8579 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29916 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8584 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = (yyvsp[-2].target);
					(yyval.target)->val = (Node *) (yyvsp[0].node);
				}
#line 29925 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8592 "gram.y" /* yacc.c:1646  */
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[-3].list)) != list_length((yyvsp[0].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[-4]))));
					forboth(col_cell, (yyvsp[-3].list), val_cell, (yyvsp[0].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 29954 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8620 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 29966 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8630 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 29972 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 8631 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 29978 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8642 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29991 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8652 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29997 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8655 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30003 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8656 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 30009 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8657 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 30015 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8658 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 30021 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8659 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 30027 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 8662 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30033 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 8663 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 30039 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 8664 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30045 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 8717 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 30051 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 8718 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 30057 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 8732 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30063 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 8734 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 30074 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 8741 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 30086 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 8749 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 30098 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 8757 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 30110 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 8765 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 30122 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 8773 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 30134 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 8781 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 30146 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 8791 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30152 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 8792 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30158 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 8822 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30175 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 8834 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30181 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 8836 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 30204 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 8855 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 30212 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 8859 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 30220 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 8863 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 30228 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 8878 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 30239 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 8885 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 30250 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 8894 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30256 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 8895 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30262 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 8899 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 30275 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 8910 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 30281 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 8911 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 30287 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 8916 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->skipData = false;
				}
#line 30301 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 8926 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 30307 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 8935 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 30316 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 8940 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 30325 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 8945 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 30334 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 8950 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 30343 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 8955 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 30355 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 8963 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 30367 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 8971 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 30376 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 8976 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 30385 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 8981 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 30394 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 8987 "gram.y" /* yacc.c:1646  */
    {}
#line 30400 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 8988 "gram.y" /* yacc.c:1646  */
    {}
#line 30406 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 8991 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30412 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 8992 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30418 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 8993 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30424 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9000 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 30430 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9001 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30436 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9002 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30442 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9003 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30448 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9007 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 30454 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9008 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30460 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30466 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9016 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 30472 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9017 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 30478 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9021 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 30491 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9030 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 30504 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9042 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 30510 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9043 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 30516 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9044 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 30522 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9045 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 30528 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9049 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30534 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9050 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL,NULL); }
#line 30540 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9055 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30546 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9057 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 30559 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9067 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 30565 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9072 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30571 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9075 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 30577 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9079 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30583 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9081 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 30592 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9088 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30598 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9098 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0])); }
#line 30604 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9099 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 30610 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9100 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(1, -1); }
#line 30616 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9108 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30622 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9112 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30628 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9113 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30634 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9116 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30640 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9117 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 30646 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9122 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30652 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9123 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30658 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9127 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30664 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9128 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30670 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30676 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9133 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30682 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9137 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30688 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 9138 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30694 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 9142 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30700 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9143 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 30706 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9148 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30718 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9156 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30730 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9166 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30736 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9167 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30742 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9173 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 30752 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9179 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-2].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 30762 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9196 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30768 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9197 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30774 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30780 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9202 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30786 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9213 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].range);
				}
#line 30794 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9217 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 30803 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9222 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[0].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				}
#line 30814 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9229 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				}
#line 30826 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9237 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[-4].node);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 30837 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9244 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[-5].node);
					a->aliasname = (yyvsp[-3].str);
					n->alias = a;
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 30851 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9254 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[-4].node);
					a->aliasname = (yyvsp[-3].str);
					n->alias = a;
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 30865 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9264 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[0].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[0].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 parser_errposition((yylsp[0]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = NULL;
				}
#line 30897 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9292 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 30908 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9299 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 30916 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9303 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 30925 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9329 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 30933 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9333 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 30949 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9345 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 30966 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9358 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 30984 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 9372 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 30999 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 9383 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 31015 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 9398 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 31025 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 9404 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 31034 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 9409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 31044 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9415 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 31053 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9421 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 31059 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9422 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 31065 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9423 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 31071 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9424 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 31077 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9428 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31083 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9429 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31089 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9441 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 31095 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9442 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31101 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9448 "gram.y" /* yacc.c:1646  */
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
#line 31112 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9455 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
#line 31123 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9462 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 31134 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9469 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 31145 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9479 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 31151 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 9480 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 31157 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 9494 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 31165 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 9498 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 31176 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 9505 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 31187 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 9514 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31193 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 9519 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31199 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 9520 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31205 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 9525 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31211 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 9527 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 31223 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 9534 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31229 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 9539 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31235 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 9540 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31241 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 9545 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31249 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 9549 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31257 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 9555 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				}
#line 31278 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 9584 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 31287 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 9589 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 31297 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 9596 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 31306 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 9601 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 31316 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 9607 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 31325 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 9612 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 31335 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 9621 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 31341 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 9623 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 31347 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 9625 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 31353 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 9629 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31359 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 9630 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31365 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 9631 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31371 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 9632 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31377 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 9633 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31383 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 9635 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 31392 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 9640 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-4]))));
						(yyval.typnam)->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
				}
#line 31412 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 9669 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31418 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 9670 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31424 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 9671 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31430 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 9672 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 31436 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 9684 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31446 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 9690 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 31456 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 9697 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31462 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 9698 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31468 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 9705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 31477 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 9710 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 31486 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 9715 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 31495 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 9720 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 31504 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 9725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 31513 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 9730 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31522 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 9735 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31531 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 9740 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31541 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 9746 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31551 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 9752 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31561 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 9758 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 31570 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 9765 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 31595 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 9786 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 31603 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 9796 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 31611 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 9800 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 31619 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 9808 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 31627 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 9812 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 31636 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 9820 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 31649 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 9832 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31667 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 9853 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 31675 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 9857 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 31683 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 9863 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 31691 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 9867 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 31706 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 9880 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[-4].str)) + 1 + strlen((yyvsp[0].str)) + 1);
						strcpy(type, (yyvsp[-4].str));
						strcat(type, "_");
						strcat(type, (yyvsp[0].str));
						(yyvsp[-4].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[-4].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 31727 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 9899 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[-1].str)) + 1 + strlen((yyvsp[0].str)) + 1);
						strcpy(type, (yyvsp[-1].str));
						strcat(type, "_");
						strcat(type, (yyvsp[0].str));
						(yyvsp[-1].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[-1].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[-1].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31752 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 9922 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 31758 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 9924 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 31764 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 9926 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 31770 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 9928 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 31776 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 9930 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 31782 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 9932 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 31788 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 9936 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31794 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 9937 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31800 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 9941 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31806 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 9942 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31812 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 9950 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 31825 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 9959 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31837 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 9967 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 31850 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 9976 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 31862 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 9987 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 31871 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 9994 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31877 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 9995 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31883 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 9996 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31889 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10001 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 31895 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10003 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 31901 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10005 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 31907 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10007 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 31913 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10009 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 31919 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10011 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31925 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10013 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 31934 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10018 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 31943 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10023 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 31953 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10029 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 31965 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10037 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 31974 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10042 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 31985 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10049 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 31995 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10055 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32001 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10060 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 32009 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10064 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 32018 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10093 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32024 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10095 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 32030 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10097 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32042 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10105 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[0].node), (yyvsp[-4].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 32059 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10127 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 32065 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10129 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 32071 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10131 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32077 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10133 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32083 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10135 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32089 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10137 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32095 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10139 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32101 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10141 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32107 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10143 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32113 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10145 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32119 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10147 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32125 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10150 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32131 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10152 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 32137 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10154 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 32143 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10157 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32149 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10159 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32155 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10161 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 32161 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10164 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32167 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10166 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 32184 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10179 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 32190 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10181 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 32207 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10194 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32213 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10196 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 32230 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10209 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 32236 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10211 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 32253 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10225 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[0].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 32270 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10238 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 32287 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 10251 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[0].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 32304 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 10264 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 32321 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 10287 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 32332 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 10294 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 32343 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 10301 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 32354 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 10308 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 32365 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 10315 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlaps");
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					n->args = list_concat((yyvsp[-2].list), (yyvsp[0].list));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 32392 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 10338 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 32403 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 10345 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 32414 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10352 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 32425 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10359 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 32436 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10366 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 32447 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10373 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 32458 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10380 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 32466 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10384 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));

				}
#line 32478 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10392 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 32486 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10396 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 32494 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10406 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));
				}
#line 32505 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10413 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											 (yylsp[-5]));
				}
#line 32516 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10420 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											(yylsp[-4])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
											(yylsp[-4])),
											 (yylsp[-4]));
				}
#line 32533 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 10433 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											(yylsp[-5])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
											(yylsp[-5])),
											 (yylsp[-5]));
				}
#line 32550 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 10446 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-2].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 32573 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 10465 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-3].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 32598 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 10486 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 32612 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10496 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 32623 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10503 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 32643 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 10519 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 32652 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 10524 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 32663 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 10542 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32669 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 10544 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 32675 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 10546 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 32681 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 10548 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 32687 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 10550 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32693 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 10552 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32699 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 10554 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32705 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 10556 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32711 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 10558 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32717 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 10560 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32723 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 10562 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32729 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 10564 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32735 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 10566 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32741 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 10568 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 32747 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 10570 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 32753 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 10572 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 32759 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 10574 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 32767 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 10578 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])), (yylsp[-4]));
				}
#line 32776 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 10583 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 32784 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 10587 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 32792 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 10591 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 32801 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 10596 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 32812 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 10612 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32818 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 10613 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32824 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 10615 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 32843 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 10630 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 32859 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 10642 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32865 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 10644 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32871 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 10646 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 32885 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 10656 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 32912 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 10679 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 32926 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 10689 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 32940 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 10699 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[0].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 32952 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 10707 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 32965 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 10726 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-3].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 32982 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 10739 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 32999 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 10752 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-5].list);
					n->args = list_make1((yyvsp[-2].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 33016 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 10765 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-7].list);
					n->args = lappend((yyvsp[-5].list), (yyvsp[-2].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *)n;
				}
#line 33033 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 10778 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-5].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 33050 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 10791 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-6].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 33071 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 10808 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-6].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 33088 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 10821 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-4].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 33115 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 10844 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("pg_collation_for");
					n->args = list_make1((yyvsp[-1].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 33132 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 10857 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[0]));
				}
#line 33162 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 10883 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[0]));
				}
#line 33176 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 10893 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 33193 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 10906 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 33214 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 10923 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 33231 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 10936 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[0]));
				}
#line 33245 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 10946 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[-3]));
				}
#line 33262 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 10959 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[0]));
				}
#line 33276 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 10969 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 33293 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 10982 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 33310 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 10995 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 33327 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 11008 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 33344 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 11021 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 33361 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 11034 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 33378 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 11047 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 33395 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 11060 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 33401 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 11062 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 33418 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 11075 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 33440 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 11093 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 33458 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 11107 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 33478 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 11123 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[-3].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 33504 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 11145 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 33524 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 11161 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 33541 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 11174 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 33558 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 11187 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 33575 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 11200 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 33583 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 11204 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 33594 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 11211 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 33606 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11219 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 33618 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11227 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 33626 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11231 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 33634 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11235 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 33642 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11239 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 33650 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11243 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 33658 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11247 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("xmlexists");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[-1].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 33677 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11262 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 33685 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11266 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 33698 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11275 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 33706 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11279 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 33714 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11283 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 33723 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11288 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 33736 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11302 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33742 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11304 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 33748 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11308 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 33754 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11310 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 33760 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11312 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 33766 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11314 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 33772 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11317 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33778 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11320 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 33784 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11321 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 33790 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11325 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 33802 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11333 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 33814 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11342 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 33820 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11343 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 33826 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11346 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 33832 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11347 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33838 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11348 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 33844 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11354 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 33852 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11358 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 33860 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11362 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 33868 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11366 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 33876 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11376 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33882 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11377 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33888 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11381 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 33894 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11383 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 33900 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11388 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 33910 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11396 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 33916 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11398 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 33933 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11411 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 33939 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11416 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 33957 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11441 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33963 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11442 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33969 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11445 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33975 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11446 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33981 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11458 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 34003 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11476 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 34013 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11482 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 34025 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11492 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 34046 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11509 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 34087 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11554 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 34099 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11562 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 34111 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11570 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 34123 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11578 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 34135 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11586 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 34147 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11606 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34153 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11607 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34159 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11608 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 34165 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11611 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 34171 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11612 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 34177 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11613 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 34183 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11616 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34189 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11617 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34195 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11620 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 34201 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11621 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 34207 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11622 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 34213 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11623 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 34219 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11624 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 34225 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11625 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 34231 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11626 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 34237 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11627 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 34243 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11628 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 34249 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11632 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34255 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11634 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34261 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11639 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34267 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11641 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34273 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11646 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34279 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11648 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34285 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11650 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 34291 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11652 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 34297 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11654 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 34303 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11656 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 34309 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11668 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34317 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34325 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11679 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34333 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11683 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34341 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 11689 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 34349 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 11693 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 34362 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 11703 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 34368 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 11704 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 34374 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 11708 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 34382 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 11712 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 34390 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 11716 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 34398 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 11721 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34404 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 11722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34410 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 11728 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 34418 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 11731 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34424 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 11738 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34430 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 11739 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 34436 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 11740 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 34442 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 11741 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 34448 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 11742 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 34454 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 11743 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 34460 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 11744 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 34466 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 11745 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34472 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 11756 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 34480 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 11760 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 34488 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 11767 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34494 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 11773 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 34500 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 11774 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34506 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 11791 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 34514 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 11795 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 34523 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 11800 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 34531 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 11804 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 34550 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 11819 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 34558 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 11823 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34564 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 11827 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34570 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 11830 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34576 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 11833 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 34582 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 11834 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34588 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 11835 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34594 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 11839 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 34605 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 11845 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 34611 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 11856 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 34625 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 11869 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34631 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 11870 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34637 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 11875 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 34649 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 11885 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34655 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 11886 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34661 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 11889 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34667 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 11890 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34673 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 11894 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 34681 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 11898 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 34689 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 11905 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 34697 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 11909 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 34705 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 11913 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 34716 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 11920 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 34727 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 11929 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34733 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 11930 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34739 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 11934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34745 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 11935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34751 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 11950 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 34757 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 11952 "gram.y" /* yacc.c:1646  */
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34767 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 11960 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34773 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 11961 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34779 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 11969 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34785 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 11980 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 34791 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 11981 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 34797 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 11985 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 34809 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12001 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 34821 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12009 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 34833 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12017 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 34849 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12038 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 34855 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12039 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 34861 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12051 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 34869 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12055 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 34898 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12082 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34904 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 34910 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12088 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34916 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12091 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34922 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12094 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34928 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12096 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34934 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12098 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34940 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12100 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34946 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12111 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34952 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12113 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 34961 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12124 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 34969 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12128 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 34977 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12132 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 34985 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12136 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 34993 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12140 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 35006 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12149 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 35017 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12156 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-4].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[-2].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[-2].list);
					t->location = (yylsp[-4]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 35046 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12181 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 35054 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12185 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 35064 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12191 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 35085 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12208 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 35093 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12212 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 35101 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12216 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 35109 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12221 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 35115 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12222 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35121 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12223 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35127 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12226 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35133 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12228 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35139 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12231 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 35145 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12232 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 35151 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12233 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 35157 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12249 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35163 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12250 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35169 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12251 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35175 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12256 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35181 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12257 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35187 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12258 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35193 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12263 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35199 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12264 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35205 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12265 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35211 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12266 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35217 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12272 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35223 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12273 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35229 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12274 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35235 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12275 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35241 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12276 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 35247 "gram.c" /* yacc.c:1646  */
    break;


#line 35251 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 12729 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
