/* A Bison parser, made by GNU Bison 3.7.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30705

/* Bison version string.  */
#define YYBISON_VERSION "3.7.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs

/* First part of user prologue.  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "parser/parse_expr.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 268 "gram.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "gram.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENT = 3,                      /* IDENT  */
  YYSYMBOL_FCONST = 4,                     /* FCONST  */
  YYSYMBOL_SCONST = 5,                     /* SCONST  */
  YYSYMBOL_BCONST = 6,                     /* BCONST  */
  YYSYMBOL_XCONST = 7,                     /* XCONST  */
  YYSYMBOL_Op = 8,                         /* Op  */
  YYSYMBOL_ICONST = 9,                     /* ICONST  */
  YYSYMBOL_PARAM = 10,                     /* PARAM  */
  YYSYMBOL_TYPECAST = 11,                  /* TYPECAST  */
  YYSYMBOL_DOT_DOT = 12,                   /* DOT_DOT  */
  YYSYMBOL_COLON_EQUALS = 13,              /* COLON_EQUALS  */
  YYSYMBOL_EQUALS_GREATER = 14,            /* EQUALS_GREATER  */
  YYSYMBOL_LESS_EQUALS = 15,               /* LESS_EQUALS  */
  YYSYMBOL_GREATER_EQUALS = 16,            /* GREATER_EQUALS  */
  YYSYMBOL_NOT_EQUALS = 17,                /* NOT_EQUALS  */
  YYSYMBOL_ABORT_P = 18,                   /* ABORT_P  */
  YYSYMBOL_ABSOLUTE_P = 19,                /* ABSOLUTE_P  */
  YYSYMBOL_ACCESS = 20,                    /* ACCESS  */
  YYSYMBOL_ACTION = 21,                    /* ACTION  */
  YYSYMBOL_ADD_P = 22,                     /* ADD_P  */
  YYSYMBOL_ADMIN = 23,                     /* ADMIN  */
  YYSYMBOL_AFTER = 24,                     /* AFTER  */
  YYSYMBOL_AGGREGATE = 25,                 /* AGGREGATE  */
  YYSYMBOL_ALL = 26,                       /* ALL  */
  YYSYMBOL_ALSO = 27,                      /* ALSO  */
  YYSYMBOL_ALTER = 28,                     /* ALTER  */
  YYSYMBOL_ALWAYS = 29,                    /* ALWAYS  */
  YYSYMBOL_ANALYSE = 30,                   /* ANALYSE  */
  YYSYMBOL_ANALYZE = 31,                   /* ANALYZE  */
  YYSYMBOL_AND = 32,                       /* AND  */
  YYSYMBOL_ANY = 33,                       /* ANY  */
  YYSYMBOL_ARRAY = 34,                     /* ARRAY  */
  YYSYMBOL_AS = 35,                        /* AS  */
  YYSYMBOL_ASC = 36,                       /* ASC  */
  YYSYMBOL_ASSERTION = 37,                 /* ASSERTION  */
  YYSYMBOL_ASSIGNMENT = 38,                /* ASSIGNMENT  */
  YYSYMBOL_ASYMMETRIC = 39,                /* ASYMMETRIC  */
  YYSYMBOL_AT = 40,                        /* AT  */
  YYSYMBOL_ATTACH = 41,                    /* ATTACH  */
  YYSYMBOL_ATTRIBUTE = 42,                 /* ATTRIBUTE  */
  YYSYMBOL_AUTHORIZATION = 43,             /* AUTHORIZATION  */
  YYSYMBOL_BACKWARD = 44,                  /* BACKWARD  */
  YYSYMBOL_BEFORE = 45,                    /* BEFORE  */
  YYSYMBOL_BEGIN_P = 46,                   /* BEGIN_P  */
  YYSYMBOL_BETWEEN = 47,                   /* BETWEEN  */
  YYSYMBOL_BIGINT = 48,                    /* BIGINT  */
  YYSYMBOL_BINARY = 49,                    /* BINARY  */
  YYSYMBOL_BIT = 50,                       /* BIT  */
  YYSYMBOL_BOOLEAN_P = 51,                 /* BOOLEAN_P  */
  YYSYMBOL_BOTH = 52,                      /* BOTH  */
  YYSYMBOL_BY = 53,                        /* BY  */
  YYSYMBOL_CACHE = 54,                     /* CACHE  */
  YYSYMBOL_CALLED = 55,                    /* CALLED  */
  YYSYMBOL_CASCADE = 56,                   /* CASCADE  */
  YYSYMBOL_CASCADED = 57,                  /* CASCADED  */
  YYSYMBOL_CASE = 58,                      /* CASE  */
  YYSYMBOL_CAST = 59,                      /* CAST  */
  YYSYMBOL_CATALOG_P = 60,                 /* CATALOG_P  */
  YYSYMBOL_CHAIN = 61,                     /* CHAIN  */
  YYSYMBOL_CHAR_P = 62,                    /* CHAR_P  */
  YYSYMBOL_CHARACTER = 63,                 /* CHARACTER  */
  YYSYMBOL_CHARACTERISTICS = 64,           /* CHARACTERISTICS  */
  YYSYMBOL_CHECK = 65,                     /* CHECK  */
  YYSYMBOL_CHECKPOINT = 66,                /* CHECKPOINT  */
  YYSYMBOL_CLASS = 67,                     /* CLASS  */
  YYSYMBOL_CLOSE = 68,                     /* CLOSE  */
  YYSYMBOL_CLUSTER = 69,                   /* CLUSTER  */
  YYSYMBOL_COALESCE = 70,                  /* COALESCE  */
  YYSYMBOL_COLLATE = 71,                   /* COLLATE  */
  YYSYMBOL_COLLATION = 72,                 /* COLLATION  */
  YYSYMBOL_COLUMN = 73,                    /* COLUMN  */
  YYSYMBOL_COLUMNS = 74,                   /* COLUMNS  */
  YYSYMBOL_COMMENT = 75,                   /* COMMENT  */
  YYSYMBOL_COMMENTS = 76,                  /* COMMENTS  */
  YYSYMBOL_COMMIT = 77,                    /* COMMIT  */
  YYSYMBOL_COMMITTED = 78,                 /* COMMITTED  */
  YYSYMBOL_CONCURRENTLY = 79,              /* CONCURRENTLY  */
  YYSYMBOL_CONFIGURATION = 80,             /* CONFIGURATION  */
  YYSYMBOL_CONFLICT = 81,                  /* CONFLICT  */
  YYSYMBOL_CONNECTION = 82,                /* CONNECTION  */
  YYSYMBOL_CONSTRAINT = 83,                /* CONSTRAINT  */
  YYSYMBOL_CONSTRAINTS = 84,               /* CONSTRAINTS  */
  YYSYMBOL_CONTENT_P = 85,                 /* CONTENT_P  */
  YYSYMBOL_CONTINUE_P = 86,                /* CONTINUE_P  */
  YYSYMBOL_CONVERSION_P = 87,              /* CONVERSION_P  */
  YYSYMBOL_COPY = 88,                      /* COPY  */
  YYSYMBOL_COST = 89,                      /* COST  */
  YYSYMBOL_CREATE = 90,                    /* CREATE  */
  YYSYMBOL_CROSS = 91,                     /* CROSS  */
  YYSYMBOL_CSV = 92,                       /* CSV  */
  YYSYMBOL_CUBE = 93,                      /* CUBE  */
  YYSYMBOL_CURRENT_P = 94,                 /* CURRENT_P  */
  YYSYMBOL_CURRENT_CATALOG = 95,           /* CURRENT_CATALOG  */
  YYSYMBOL_CURRENT_DATE = 96,              /* CURRENT_DATE  */
  YYSYMBOL_CURRENT_ROLE = 97,              /* CURRENT_ROLE  */
  YYSYMBOL_CURRENT_SCHEMA = 98,            /* CURRENT_SCHEMA  */
  YYSYMBOL_CURRENT_TIME = 99,              /* CURRENT_TIME  */
  YYSYMBOL_CURRENT_TIMESTAMP = 100,        /* CURRENT_TIMESTAMP  */
  YYSYMBOL_CURRENT_USER = 101,             /* CURRENT_USER  */
  YYSYMBOL_CURSOR = 102,                   /* CURSOR  */
  YYSYMBOL_CYCLE = 103,                    /* CYCLE  */
  YYSYMBOL_DATA_P = 104,                   /* DATA_P  */
  YYSYMBOL_DATABASE = 105,                 /* DATABASE  */
  YYSYMBOL_DAY_P = 106,                    /* DAY_P  */
  YYSYMBOL_DEALLOCATE = 107,               /* DEALLOCATE  */
  YYSYMBOL_DEC = 108,                      /* DEC  */
  YYSYMBOL_DECIMAL_P = 109,                /* DECIMAL_P  */
  YYSYMBOL_DECLARE = 110,                  /* DECLARE  */
  YYSYMBOL_DEFAULT = 111,                  /* DEFAULT  */
  YYSYMBOL_DEFAULTS = 112,                 /* DEFAULTS  */
  YYSYMBOL_DEFERRABLE = 113,               /* DEFERRABLE  */
  YYSYMBOL_DEFERRED = 114,                 /* DEFERRED  */
  YYSYMBOL_DEFINER = 115,                  /* DEFINER  */
  YYSYMBOL_DELETE_P = 116,                 /* DELETE_P  */
  YYSYMBOL_DELIMITER = 117,                /* DELIMITER  */
  YYSYMBOL_DELIMITERS = 118,               /* DELIMITERS  */
  YYSYMBOL_DEPENDS = 119,                  /* DEPENDS  */
  YYSYMBOL_DESC = 120,                     /* DESC  */
  YYSYMBOL_DETACH = 121,                   /* DETACH  */
  YYSYMBOL_DICTIONARY = 122,               /* DICTIONARY  */
  YYSYMBOL_DISABLE_P = 123,                /* DISABLE_P  */
  YYSYMBOL_DISCARD = 124,                  /* DISCARD  */
  YYSYMBOL_DISTINCT = 125,                 /* DISTINCT  */
  YYSYMBOL_DO = 126,                       /* DO  */
  YYSYMBOL_DOCUMENT_P = 127,               /* DOCUMENT_P  */
  YYSYMBOL_DOMAIN_P = 128,                 /* DOMAIN_P  */
  YYSYMBOL_DOUBLE_P = 129,                 /* DOUBLE_P  */
  YYSYMBOL_DROP = 130,                     /* DROP  */
  YYSYMBOL_EACH = 131,                     /* EACH  */
  YYSYMBOL_ELSE = 132,                     /* ELSE  */
  YYSYMBOL_ENABLE_P = 133,                 /* ENABLE_P  */
  YYSYMBOL_ENCODING = 134,                 /* ENCODING  */
  YYSYMBOL_ENCRYPTED = 135,                /* ENCRYPTED  */
  YYSYMBOL_END_P = 136,                    /* END_P  */
  YYSYMBOL_ENUM_P = 137,                   /* ENUM_P  */
  YYSYMBOL_ESCAPE = 138,                   /* ESCAPE  */
  YYSYMBOL_EVENT = 139,                    /* EVENT  */
  YYSYMBOL_EXCEPT = 140,                   /* EXCEPT  */
  YYSYMBOL_EXCLUDE = 141,                  /* EXCLUDE  */
  YYSYMBOL_EXCLUDING = 142,                /* EXCLUDING  */
  YYSYMBOL_EXCLUSIVE = 143,                /* EXCLUSIVE  */
  YYSYMBOL_EXECUTE = 144,                  /* EXECUTE  */
  YYSYMBOL_EXISTS = 145,                   /* EXISTS  */
  YYSYMBOL_EXPLAIN = 146,                  /* EXPLAIN  */
  YYSYMBOL_EXTENSION = 147,                /* EXTENSION  */
  YYSYMBOL_EXTERNAL = 148,                 /* EXTERNAL  */
  YYSYMBOL_EXTRACT = 149,                  /* EXTRACT  */
  YYSYMBOL_FALSE_P = 150,                  /* FALSE_P  */
  YYSYMBOL_FAMILY = 151,                   /* FAMILY  */
  YYSYMBOL_FETCH = 152,                    /* FETCH  */
  YYSYMBOL_FILTER = 153,                   /* FILTER  */
  YYSYMBOL_FIRST_P = 154,                  /* FIRST_P  */
  YYSYMBOL_FLOAT_P = 155,                  /* FLOAT_P  */
  YYSYMBOL_FOLLOWING = 156,                /* FOLLOWING  */
  YYSYMBOL_FOR = 157,                      /* FOR  */
  YYSYMBOL_FORCE = 158,                    /* FORCE  */
  YYSYMBOL_FOREIGN = 159,                  /* FOREIGN  */
  YYSYMBOL_FORWARD = 160,                  /* FORWARD  */
  YYSYMBOL_FREEZE = 161,                   /* FREEZE  */
  YYSYMBOL_FROM = 162,                     /* FROM  */
  YYSYMBOL_FULL = 163,                     /* FULL  */
  YYSYMBOL_FUNCTION = 164,                 /* FUNCTION  */
  YYSYMBOL_FUNCTIONS = 165,                /* FUNCTIONS  */
  YYSYMBOL_GENERATED = 166,                /* GENERATED  */
  YYSYMBOL_GLOBAL = 167,                   /* GLOBAL  */
  YYSYMBOL_GRANT = 168,                    /* GRANT  */
  YYSYMBOL_GRANTED = 169,                  /* GRANTED  */
  YYSYMBOL_GREATEST = 170,                 /* GREATEST  */
  YYSYMBOL_GROUP_P = 171,                  /* GROUP_P  */
  YYSYMBOL_GROUPING = 172,                 /* GROUPING  */
  YYSYMBOL_HANDLER = 173,                  /* HANDLER  */
  YYSYMBOL_HAVING = 174,                   /* HAVING  */
  YYSYMBOL_HEADER_P = 175,                 /* HEADER_P  */
  YYSYMBOL_HOLD = 176,                     /* HOLD  */
  YYSYMBOL_HOUR_P = 177,                   /* HOUR_P  */
  YYSYMBOL_IDENTITY_P = 178,               /* IDENTITY_P  */
  YYSYMBOL_IF_P = 179,                     /* IF_P  */
  YYSYMBOL_ILIKE = 180,                    /* ILIKE  */
  YYSYMBOL_IMMEDIATE = 181,                /* IMMEDIATE  */
  YYSYMBOL_IMMUTABLE = 182,                /* IMMUTABLE  */
  YYSYMBOL_IMPLICIT_P = 183,               /* IMPLICIT_P  */
  YYSYMBOL_IMPORT_P = 184,                 /* IMPORT_P  */
  YYSYMBOL_IN_P = 185,                     /* IN_P  */
  YYSYMBOL_INCLUDING = 186,                /* INCLUDING  */
  YYSYMBOL_INCREMENT = 187,                /* INCREMENT  */
  YYSYMBOL_INDEX = 188,                    /* INDEX  */
  YYSYMBOL_INDEXES = 189,                  /* INDEXES  */
  YYSYMBOL_INHERIT = 190,                  /* INHERIT  */
  YYSYMBOL_INHERITS = 191,                 /* INHERITS  */
  YYSYMBOL_INITIALLY = 192,                /* INITIALLY  */
  YYSYMBOL_INLINE_P = 193,                 /* INLINE_P  */
  YYSYMBOL_INNER_P = 194,                  /* INNER_P  */
  YYSYMBOL_INOUT = 195,                    /* INOUT  */
  YYSYMBOL_INPUT_P = 196,                  /* INPUT_P  */
  YYSYMBOL_INSENSITIVE = 197,              /* INSENSITIVE  */
  YYSYMBOL_INSERT = 198,                   /* INSERT  */
  YYSYMBOL_INSTEAD = 199,                  /* INSTEAD  */
  YYSYMBOL_INT_P = 200,                    /* INT_P  */
  YYSYMBOL_INTEGER = 201,                  /* INTEGER  */
  YYSYMBOL_INTERSECT = 202,                /* INTERSECT  */
  YYSYMBOL_INTERVAL = 203,                 /* INTERVAL  */
  YYSYMBOL_INTO = 204,                     /* INTO  */
  YYSYMBOL_INVOKER = 205,                  /* INVOKER  */
  YYSYMBOL_IS = 206,                       /* IS  */
  YYSYMBOL_ISNULL = 207,                   /* ISNULL  */
  YYSYMBOL_ISOLATION = 208,                /* ISOLATION  */
  YYSYMBOL_JOIN = 209,                     /* JOIN  */
  YYSYMBOL_KEY = 210,                      /* KEY  */
  YYSYMBOL_LABEL = 211,                    /* LABEL  */
  YYSYMBOL_LANGUAGE = 212,                 /* LANGUAGE  */
  YYSYMBOL_LARGE_P = 213,                  /* LARGE_P  */
  YYSYMBOL_LAST_P = 214,                   /* LAST_P  */
  YYSYMBOL_LATERAL_P = 215,                /* LATERAL_P  */
  YYSYMBOL_LEADING = 216,                  /* LEADING  */
  YYSYMBOL_LEAKPROOF = 217,                /* LEAKPROOF  */
  YYSYMBOL_LEAST = 218,                    /* LEAST  */
  YYSYMBOL_LEFT = 219,                     /* LEFT  */
  YYSYMBOL_LEVEL = 220,                    /* LEVEL  */
  YYSYMBOL_LIKE = 221,                     /* LIKE  */
  YYSYMBOL_LIMIT = 222,                    /* LIMIT  */
  YYSYMBOL_LISTEN = 223,                   /* LISTEN  */
  YYSYMBOL_LOAD = 224,                     /* LOAD  */
  YYSYMBOL_LOCAL = 225,                    /* LOCAL  */
  YYSYMBOL_LOCALTIME = 226,                /* LOCALTIME  */
  YYSYMBOL_LOCALTIMESTAMP = 227,           /* LOCALTIMESTAMP  */
  YYSYMBOL_LOCATION = 228,                 /* LOCATION  */
  YYSYMBOL_LOCK_P = 229,                   /* LOCK_P  */
  YYSYMBOL_LOCKED = 230,                   /* LOCKED  */
  YYSYMBOL_LOGGED = 231,                   /* LOGGED  */
  YYSYMBOL_MAPPING = 232,                  /* MAPPING  */
  YYSYMBOL_MATCH = 233,                    /* MATCH  */
  YYSYMBOL_MATERIALIZED = 234,             /* MATERIALIZED  */
  YYSYMBOL_MAXVALUE = 235,                 /* MAXVALUE  */
  YYSYMBOL_METHOD = 236,                   /* METHOD  */
  YYSYMBOL_MINUTE_P = 237,                 /* MINUTE_P  */
  YYSYMBOL_MINVALUE = 238,                 /* MINVALUE  */
  YYSYMBOL_MODE = 239,                     /* MODE  */
  YYSYMBOL_MONTH_P = 240,                  /* MONTH_P  */
  YYSYMBOL_MOVE = 241,                     /* MOVE  */
  YYSYMBOL_NAME_P = 242,                   /* NAME_P  */
  YYSYMBOL_NAMES = 243,                    /* NAMES  */
  YYSYMBOL_NATIONAL = 244,                 /* NATIONAL  */
  YYSYMBOL_NATURAL = 245,                  /* NATURAL  */
  YYSYMBOL_NCHAR = 246,                    /* NCHAR  */
  YYSYMBOL_NEW = 247,                      /* NEW  */
  YYSYMBOL_NEXT = 248,                     /* NEXT  */
  YYSYMBOL_NO = 249,                       /* NO  */
  YYSYMBOL_NONE = 250,                     /* NONE  */
  YYSYMBOL_NOT = 251,                      /* NOT  */
  YYSYMBOL_NOTHING = 252,                  /* NOTHING  */
  YYSYMBOL_NOTIFY = 253,                   /* NOTIFY  */
  YYSYMBOL_NOTNULL = 254,                  /* NOTNULL  */
  YYSYMBOL_NOWAIT = 255,                   /* NOWAIT  */
  YYSYMBOL_NULL_P = 256,                   /* NULL_P  */
  YYSYMBOL_NULLIF = 257,                   /* NULLIF  */
  YYSYMBOL_NULLS_P = 258,                  /* NULLS_P  */
  YYSYMBOL_NUMERIC = 259,                  /* NUMERIC  */
  YYSYMBOL_OBJECT_P = 260,                 /* OBJECT_P  */
  YYSYMBOL_OF = 261,                       /* OF  */
  YYSYMBOL_OFF = 262,                      /* OFF  */
  YYSYMBOL_OFFSET = 263,                   /* OFFSET  */
  YYSYMBOL_OIDS = 264,                     /* OIDS  */
  YYSYMBOL_OLD = 265,                      /* OLD  */
  YYSYMBOL_ON = 266,                       /* ON  */
  YYSYMBOL_ONLY = 267,                     /* ONLY  */
  YYSYMBOL_OPERATOR = 268,                 /* OPERATOR  */
  YYSYMBOL_OPTION = 269,                   /* OPTION  */
  YYSYMBOL_OPTIONS = 270,                  /* OPTIONS  */
  YYSYMBOL_OR = 271,                       /* OR  */
  YYSYMBOL_ORDER = 272,                    /* ORDER  */
  YYSYMBOL_ORDINALITY = 273,               /* ORDINALITY  */
  YYSYMBOL_OUT_P = 274,                    /* OUT_P  */
  YYSYMBOL_OUTER_P = 275,                  /* OUTER_P  */
  YYSYMBOL_OVER = 276,                     /* OVER  */
  YYSYMBOL_OVERLAPS = 277,                 /* OVERLAPS  */
  YYSYMBOL_OVERLAY = 278,                  /* OVERLAY  */
  YYSYMBOL_OVERRIDING = 279,               /* OVERRIDING  */
  YYSYMBOL_OWNED = 280,                    /* OWNED  */
  YYSYMBOL_OWNER = 281,                    /* OWNER  */
  YYSYMBOL_PARALLEL = 282,                 /* PARALLEL  */
  YYSYMBOL_PARSER = 283,                   /* PARSER  */
  YYSYMBOL_PARTIAL = 284,                  /* PARTIAL  */
  YYSYMBOL_PARTITION = 285,                /* PARTITION  */
  YYSYMBOL_PASSING = 286,                  /* PASSING  */
  YYSYMBOL_PASSWORD = 287,                 /* PASSWORD  */
  YYSYMBOL_PLACING = 288,                  /* PLACING  */
  YYSYMBOL_PLANS = 289,                    /* PLANS  */
  YYSYMBOL_POLICY = 290,                   /* POLICY  */
  YYSYMBOL_POSITION = 291,                 /* POSITION  */
  YYSYMBOL_PRECEDING = 292,                /* PRECEDING  */
  YYSYMBOL_PRECISION = 293,                /* PRECISION  */
  YYSYMBOL_PRESERVE = 294,                 /* PRESERVE  */
  YYSYMBOL_PREPARE = 295,                  /* PREPARE  */
  YYSYMBOL_PREPARED = 296,                 /* PREPARED  */
  YYSYMBOL_PRIMARY = 297,                  /* PRIMARY  */
  YYSYMBOL_PRIOR = 298,                    /* PRIOR  */
  YYSYMBOL_PRIVILEGES = 299,               /* PRIVILEGES  */
  YYSYMBOL_PROCEDURAL = 300,               /* PROCEDURAL  */
  YYSYMBOL_PROCEDURE = 301,                /* PROCEDURE  */
  YYSYMBOL_PROGRAM = 302,                  /* PROGRAM  */
  YYSYMBOL_PUBLICATION = 303,              /* PUBLICATION  */
  YYSYMBOL_QUOTE = 304,                    /* QUOTE  */
  YYSYMBOL_RANGE = 305,                    /* RANGE  */
  YYSYMBOL_READ = 306,                     /* READ  */
  YYSYMBOL_REAL = 307,                     /* REAL  */
  YYSYMBOL_REASSIGN = 308,                 /* REASSIGN  */
  YYSYMBOL_RECHECK = 309,                  /* RECHECK  */
  YYSYMBOL_RECURSIVE = 310,                /* RECURSIVE  */
  YYSYMBOL_REF_P = 311,                    /* REF_P  */
  YYSYMBOL_REFERENCES = 312,               /* REFERENCES  */
  YYSYMBOL_REFERENCING = 313,              /* REFERENCING  */
  YYSYMBOL_REFRESH = 314,                  /* REFRESH  */
  YYSYMBOL_REINDEX = 315,                  /* REINDEX  */
  YYSYMBOL_RELATIVE_P = 316,               /* RELATIVE_P  */
  YYSYMBOL_RELEASE = 317,                  /* RELEASE  */
  YYSYMBOL_RENAME = 318,                   /* RENAME  */
  YYSYMBOL_REPEATABLE = 319,               /* REPEATABLE  */
  YYSYMBOL_REPLACE = 320,                  /* REPLACE  */
  YYSYMBOL_REPLICA = 321,                  /* REPLICA  */
  YYSYMBOL_RESET = 322,                    /* RESET  */
  YYSYMBOL_RESTART = 323,                  /* RESTART  */
  YYSYMBOL_RESTRICT = 324,                 /* RESTRICT  */
  YYSYMBOL_RETURNING = 325,                /* RETURNING  */
  YYSYMBOL_RETURNS = 326,                  /* RETURNS  */
  YYSYMBOL_REVOKE = 327,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 328,                    /* RIGHT  */
  YYSYMBOL_ROLE = 329,                     /* ROLE  */
  YYSYMBOL_ROLLBACK = 330,                 /* ROLLBACK  */
  YYSYMBOL_ROLLUP = 331,                   /* ROLLUP  */
  YYSYMBOL_ROW = 332,                      /* ROW  */
  YYSYMBOL_ROWS = 333,                     /* ROWS  */
  YYSYMBOL_RULE = 334,                     /* RULE  */
  YYSYMBOL_SAVEPOINT = 335,                /* SAVEPOINT  */
  YYSYMBOL_SCHEMA = 336,                   /* SCHEMA  */
  YYSYMBOL_SCHEMAS = 337,                  /* SCHEMAS  */
  YYSYMBOL_SCROLL = 338,                   /* SCROLL  */
  YYSYMBOL_SEARCH = 339,                   /* SEARCH  */
  YYSYMBOL_SECOND_P = 340,                 /* SECOND_P  */
  YYSYMBOL_SECURITY = 341,                 /* SECURITY  */
  YYSYMBOL_SELECT = 342,                   /* SELECT  */
  YYSYMBOL_SEQUENCE = 343,                 /* SEQUENCE  */
  YYSYMBOL_SEQUENCES = 344,                /* SEQUENCES  */
  YYSYMBOL_SERIALIZABLE = 345,             /* SERIALIZABLE  */
  YYSYMBOL_SERVER = 346,                   /* SERVER  */
  YYSYMBOL_SESSION = 347,                  /* SESSION  */
  YYSYMBOL_SESSION_USER = 348,             /* SESSION_USER  */
  YYSYMBOL_SET = 349,                      /* SET  */
  YYSYMBOL_SETS = 350,                     /* SETS  */
  YYSYMBOL_SETOF = 351,                    /* SETOF  */
  YYSYMBOL_SHARE = 352,                    /* SHARE  */
  YYSYMBOL_SHOW = 353,                     /* SHOW  */
  YYSYMBOL_SIMILAR = 354,                  /* SIMILAR  */
  YYSYMBOL_SIMPLE = 355,                   /* SIMPLE  */
  YYSYMBOL_SKIP = 356,                     /* SKIP  */
  YYSYMBOL_SMALLINT = 357,                 /* SMALLINT  */
  YYSYMBOL_SNAPSHOT = 358,                 /* SNAPSHOT  */
  YYSYMBOL_SOME = 359,                     /* SOME  */
  YYSYMBOL_SQL_P = 360,                    /* SQL_P  */
  YYSYMBOL_STABLE = 361,                   /* STABLE  */
  YYSYMBOL_STANDALONE_P = 362,             /* STANDALONE_P  */
  YYSYMBOL_START = 363,                    /* START  */
  YYSYMBOL_STATEMENT = 364,                /* STATEMENT  */
  YYSYMBOL_STATISTICS = 365,               /* STATISTICS  */
  YYSYMBOL_STDIN = 366,                    /* STDIN  */
  YYSYMBOL_STDOUT = 367,                   /* STDOUT  */
  YYSYMBOL_STORAGE = 368,                  /* STORAGE  */
  YYSYMBOL_STRICT_P = 369,                 /* STRICT_P  */
  YYSYMBOL_STRIP_P = 370,                  /* STRIP_P  */
  YYSYMBOL_SUBSCRIPTION = 371,             /* SUBSCRIPTION  */
  YYSYMBOL_SUBSTRING = 372,                /* SUBSTRING  */
  YYSYMBOL_SYMMETRIC = 373,                /* SYMMETRIC  */
  YYSYMBOL_SYSID = 374,                    /* SYSID  */
  YYSYMBOL_SYSTEM_P = 375,                 /* SYSTEM_P  */
  YYSYMBOL_TABLE = 376,                    /* TABLE  */
  YYSYMBOL_TABLES = 377,                   /* TABLES  */
  YYSYMBOL_TABLESAMPLE = 378,              /* TABLESAMPLE  */
  YYSYMBOL_TABLESPACE = 379,               /* TABLESPACE  */
  YYSYMBOL_TEMP = 380,                     /* TEMP  */
  YYSYMBOL_TEMPLATE = 381,                 /* TEMPLATE  */
  YYSYMBOL_TEMPORARY = 382,                /* TEMPORARY  */
  YYSYMBOL_TEXT_P = 383,                   /* TEXT_P  */
  YYSYMBOL_THEN = 384,                     /* THEN  */
  YYSYMBOL_TIME = 385,                     /* TIME  */
  YYSYMBOL_TIMESTAMP = 386,                /* TIMESTAMP  */
  YYSYMBOL_TO = 387,                       /* TO  */
  YYSYMBOL_TRAILING = 388,                 /* TRAILING  */
  YYSYMBOL_TRANSACTION = 389,              /* TRANSACTION  */
  YYSYMBOL_TRANSFORM = 390,                /* TRANSFORM  */
  YYSYMBOL_TREAT = 391,                    /* TREAT  */
  YYSYMBOL_TRIGGER = 392,                  /* TRIGGER  */
  YYSYMBOL_TRIM = 393,                     /* TRIM  */
  YYSYMBOL_TRUE_P = 394,                   /* TRUE_P  */
  YYSYMBOL_TRUNCATE = 395,                 /* TRUNCATE  */
  YYSYMBOL_TRUSTED = 396,                  /* TRUSTED  */
  YYSYMBOL_TYPE_P = 397,                   /* TYPE_P  */
  YYSYMBOL_TYPES_P = 398,                  /* TYPES_P  */
  YYSYMBOL_UNBOUNDED = 399,                /* UNBOUNDED  */
  YYSYMBOL_UNCOMMITTED = 400,              /* UNCOMMITTED  */
  YYSYMBOL_UNENCRYPTED = 401,              /* UNENCRYPTED  */
  YYSYMBOL_UNION = 402,                    /* UNION  */
  YYSYMBOL_UNIQUE = 403,                   /* UNIQUE  */
  YYSYMBOL_UNKNOWN = 404,                  /* UNKNOWN  */
  YYSYMBOL_UNLISTEN = 405,                 /* UNLISTEN  */
  YYSYMBOL_UNLOGGED = 406,                 /* UNLOGGED  */
  YYSYMBOL_UNTIL = 407,                    /* UNTIL  */
  YYSYMBOL_UPDATE = 408,                   /* UPDATE  */
  YYSYMBOL_USER = 409,                     /* USER  */
  YYSYMBOL_USING = 410,                    /* USING  */
  YYSYMBOL_VACUUM = 411,                   /* VACUUM  */
  YYSYMBOL_VALID = 412,                    /* VALID  */
  YYSYMBOL_VALIDATE = 413,                 /* VALIDATE  */
  YYSYMBOL_VALIDATOR = 414,                /* VALIDATOR  */
  YYSYMBOL_VALUE_P = 415,                  /* VALUE_P  */
  YYSYMBOL_VALUES = 416,                   /* VALUES  */
  YYSYMBOL_VARCHAR = 417,                  /* VARCHAR  */
  YYSYMBOL_VARIADIC = 418,                 /* VARIADIC  */
  YYSYMBOL_VARYING = 419,                  /* VARYING  */
  YYSYMBOL_VERBOSE = 420,                  /* VERBOSE  */
  YYSYMBOL_VERSION_P = 421,                /* VERSION_P  */
  YYSYMBOL_VIEW = 422,                     /* VIEW  */
  YYSYMBOL_VIEWS = 423,                    /* VIEWS  */
  YYSYMBOL_VOLATILE = 424,                 /* VOLATILE  */
  YYSYMBOL_WHEN = 425,                     /* WHEN  */
  YYSYMBOL_WHERE = 426,                    /* WHERE  */
  YYSYMBOL_WHITESPACE_P = 427,             /* WHITESPACE_P  */
  YYSYMBOL_WINDOW = 428,                   /* WINDOW  */
  YYSYMBOL_WITH = 429,                     /* WITH  */
  YYSYMBOL_WITHIN = 430,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 431,                  /* WITHOUT  */
  YYSYMBOL_WORK = 432,                     /* WORK  */
  YYSYMBOL_WRAPPER = 433,                  /* WRAPPER  */
  YYSYMBOL_WRITE = 434,                    /* WRITE  */
  YYSYMBOL_XML_P = 435,                    /* XML_P  */
  YYSYMBOL_XMLATTRIBUTES = 436,            /* XMLATTRIBUTES  */
  YYSYMBOL_XMLCONCAT = 437,                /* XMLCONCAT  */
  YYSYMBOL_XMLELEMENT = 438,               /* XMLELEMENT  */
  YYSYMBOL_XMLEXISTS = 439,                /* XMLEXISTS  */
  YYSYMBOL_XMLFOREST = 440,                /* XMLFOREST  */
  YYSYMBOL_XMLNAMESPACES = 441,            /* XMLNAMESPACES  */
  YYSYMBOL_XMLPARSE = 442,                 /* XMLPARSE  */
  YYSYMBOL_XMLPI = 443,                    /* XMLPI  */
  YYSYMBOL_XMLROOT = 444,                  /* XMLROOT  */
  YYSYMBOL_XMLSERIALIZE = 445,             /* XMLSERIALIZE  */
  YYSYMBOL_XMLTABLE = 446,                 /* XMLTABLE  */
  YYSYMBOL_YEAR_P = 447,                   /* YEAR_P  */
  YYSYMBOL_YES_P = 448,                    /* YES_P  */
  YYSYMBOL_ZONE = 449,                     /* ZONE  */
  YYSYMBOL_NOT_LA = 450,                   /* NOT_LA  */
  YYSYMBOL_NULLS_LA = 451,                 /* NULLS_LA  */
  YYSYMBOL_WITH_LA = 452,                  /* WITH_LA  */
  YYSYMBOL_453_ = 453,                     /* '<'  */
  YYSYMBOL_454_ = 454,                     /* '>'  */
  YYSYMBOL_455_ = 455,                     /* '='  */
  YYSYMBOL_POSTFIXOP = 456,                /* POSTFIXOP  */
  YYSYMBOL_457_ = 457,                     /* '+'  */
  YYSYMBOL_458_ = 458,                     /* '-'  */
  YYSYMBOL_459_ = 459,                     /* '*'  */
  YYSYMBOL_460_ = 460,                     /* '/'  */
  YYSYMBOL_461_ = 461,                     /* '%'  */
  YYSYMBOL_462_ = 462,                     /* '^'  */
  YYSYMBOL_UMINUS = 463,                   /* UMINUS  */
  YYSYMBOL_464_ = 464,                     /* '['  */
  YYSYMBOL_465_ = 465,                     /* ']'  */
  YYSYMBOL_466_ = 466,                     /* '('  */
  YYSYMBOL_467_ = 467,                     /* ')'  */
  YYSYMBOL_468_ = 468,                     /* '.'  */
  YYSYMBOL_469_ = 469,                     /* ';'  */
  YYSYMBOL_470_ = 470,                     /* ','  */
  YYSYMBOL_471_ = 471,                     /* ':'  */
  YYSYMBOL_YYACCEPT = 472,                 /* $accept  */
  YYSYMBOL_stmtblock = 473,                /* stmtblock  */
  YYSYMBOL_stmtmulti = 474,                /* stmtmulti  */
  YYSYMBOL_stmt = 475,                     /* stmt  */
  YYSYMBOL_CreateRoleStmt = 476,           /* CreateRoleStmt  */
  YYSYMBOL_opt_with = 477,                 /* opt_with  */
  YYSYMBOL_OptRoleList = 478,              /* OptRoleList  */
  YYSYMBOL_AlterOptRoleList = 479,         /* AlterOptRoleList  */
  YYSYMBOL_AlterOptRoleElem = 480,         /* AlterOptRoleElem  */
  YYSYMBOL_CreateOptRoleElem = 481,        /* CreateOptRoleElem  */
  YYSYMBOL_CreateUserStmt = 482,           /* CreateUserStmt  */
  YYSYMBOL_AlterRoleStmt = 483,            /* AlterRoleStmt  */
  YYSYMBOL_opt_in_database = 484,          /* opt_in_database  */
  YYSYMBOL_AlterRoleSetStmt = 485,         /* AlterRoleSetStmt  */
  YYSYMBOL_DropRoleStmt = 486,             /* DropRoleStmt  */
  YYSYMBOL_CreateGroupStmt = 487,          /* CreateGroupStmt  */
  YYSYMBOL_AlterGroupStmt = 488,           /* AlterGroupStmt  */
  YYSYMBOL_add_drop = 489,                 /* add_drop  */
  YYSYMBOL_CreateSchemaStmt = 490,         /* CreateSchemaStmt  */
  YYSYMBOL_OptSchemaName = 491,            /* OptSchemaName  */
  YYSYMBOL_OptSchemaEltList = 492,         /* OptSchemaEltList  */
  YYSYMBOL_schema_stmt = 493,              /* schema_stmt  */
  YYSYMBOL_VariableSetStmt = 494,          /* VariableSetStmt  */
  YYSYMBOL_set_rest = 495,                 /* set_rest  */
  YYSYMBOL_generic_set = 496,              /* generic_set  */
  YYSYMBOL_set_rest_more = 497,            /* set_rest_more  */
  YYSYMBOL_var_name = 498,                 /* var_name  */
  YYSYMBOL_var_list = 499,                 /* var_list  */
  YYSYMBOL_var_value = 500,                /* var_value  */
  YYSYMBOL_iso_level = 501,                /* iso_level  */
  YYSYMBOL_opt_boolean_or_string = 502,    /* opt_boolean_or_string  */
  YYSYMBOL_zone_value = 503,               /* zone_value  */
  YYSYMBOL_opt_encoding = 504,             /* opt_encoding  */
  YYSYMBOL_NonReservedWord_or_Sconst = 505, /* NonReservedWord_or_Sconst  */
  YYSYMBOL_VariableResetStmt = 506,        /* VariableResetStmt  */
  YYSYMBOL_reset_rest = 507,               /* reset_rest  */
  YYSYMBOL_generic_reset = 508,            /* generic_reset  */
  YYSYMBOL_SetResetClause = 509,           /* SetResetClause  */
  YYSYMBOL_FunctionSetResetClause = 510,   /* FunctionSetResetClause  */
  YYSYMBOL_VariableShowStmt = 511,         /* VariableShowStmt  */
  YYSYMBOL_ConstraintsSetStmt = 512,       /* ConstraintsSetStmt  */
  YYSYMBOL_constraints_set_list = 513,     /* constraints_set_list  */
  YYSYMBOL_constraints_set_mode = 514,     /* constraints_set_mode  */
  YYSYMBOL_CheckPointStmt = 515,           /* CheckPointStmt  */
  YYSYMBOL_DiscardStmt = 516,              /* DiscardStmt  */
  YYSYMBOL_AlterTableStmt = 517,           /* AlterTableStmt  */
  YYSYMBOL_alter_table_cmds = 518,         /* alter_table_cmds  */
  YYSYMBOL_partition_cmd = 519,            /* partition_cmd  */
  YYSYMBOL_alter_table_cmd = 520,          /* alter_table_cmd  */
  YYSYMBOL_alter_column_default = 521,     /* alter_column_default  */
  YYSYMBOL_opt_drop_behavior = 522,        /* opt_drop_behavior  */
  YYSYMBOL_opt_collate_clause = 523,       /* opt_collate_clause  */
  YYSYMBOL_alter_using = 524,              /* alter_using  */
  YYSYMBOL_replica_identity = 525,         /* replica_identity  */
  YYSYMBOL_reloptions = 526,               /* reloptions  */
  YYSYMBOL_opt_reloptions = 527,           /* opt_reloptions  */
  YYSYMBOL_reloption_list = 528,           /* reloption_list  */
  YYSYMBOL_reloption_elem = 529,           /* reloption_elem  */
  YYSYMBOL_alter_identity_column_option_list = 530, /* alter_identity_column_option_list  */
  YYSYMBOL_alter_identity_column_option = 531, /* alter_identity_column_option  */
  YYSYMBOL_ForValues = 532,                /* ForValues  */
  YYSYMBOL_partbound_datum = 533,          /* partbound_datum  */
  YYSYMBOL_partbound_datum_list = 534,     /* partbound_datum_list  */
  YYSYMBOL_range_datum_list = 535,         /* range_datum_list  */
  YYSYMBOL_PartitionRangeDatum = 536,      /* PartitionRangeDatum  */
  YYSYMBOL_AlterCompositeTypeStmt = 537,   /* AlterCompositeTypeStmt  */
  YYSYMBOL_alter_type_cmds = 538,          /* alter_type_cmds  */
  YYSYMBOL_alter_type_cmd = 539,           /* alter_type_cmd  */
  YYSYMBOL_ClosePortalStmt = 540,          /* ClosePortalStmt  */
  YYSYMBOL_CopyStmt = 541,                 /* CopyStmt  */
  YYSYMBOL_copy_from = 542,                /* copy_from  */
  YYSYMBOL_opt_program = 543,              /* opt_program  */
  YYSYMBOL_copy_file_name = 544,           /* copy_file_name  */
  YYSYMBOL_copy_options = 545,             /* copy_options  */
  YYSYMBOL_copy_opt_list = 546,            /* copy_opt_list  */
  YYSYMBOL_copy_opt_item = 547,            /* copy_opt_item  */
  YYSYMBOL_opt_binary = 548,               /* opt_binary  */
  YYSYMBOL_opt_oids = 549,                 /* opt_oids  */
  YYSYMBOL_copy_delimiter = 550,           /* copy_delimiter  */
  YYSYMBOL_opt_using = 551,                /* opt_using  */
  YYSYMBOL_copy_generic_opt_list = 552,    /* copy_generic_opt_list  */
  YYSYMBOL_copy_generic_opt_elem = 553,    /* copy_generic_opt_elem  */
  YYSYMBOL_copy_generic_opt_arg = 554,     /* copy_generic_opt_arg  */
  YYSYMBOL_copy_generic_opt_arg_list = 555, /* copy_generic_opt_arg_list  */
  YYSYMBOL_copy_generic_opt_arg_list_item = 556, /* copy_generic_opt_arg_list_item  */
  YYSYMBOL_CreateStmt = 557,               /* CreateStmt  */
  YYSYMBOL_OptTemp = 558,                  /* OptTemp  */
  YYSYMBOL_OptTableElementList = 559,      /* OptTableElementList  */
  YYSYMBOL_OptTypedTableElementList = 560, /* OptTypedTableElementList  */
  YYSYMBOL_TableElementList = 561,         /* TableElementList  */
  YYSYMBOL_TypedTableElementList = 562,    /* TypedTableElementList  */
  YYSYMBOL_TableElement = 563,             /* TableElement  */
  YYSYMBOL_TypedTableElement = 564,        /* TypedTableElement  */
  YYSYMBOL_columnDef = 565,                /* columnDef  */
  YYSYMBOL_columnOptions = 566,            /* columnOptions  */
  YYSYMBOL_ColQualList = 567,              /* ColQualList  */
  YYSYMBOL_ColConstraint = 568,            /* ColConstraint  */
  YYSYMBOL_ColConstraintElem = 569,        /* ColConstraintElem  */
  YYSYMBOL_generated_when = 570,           /* generated_when  */
  YYSYMBOL_ConstraintAttr = 571,           /* ConstraintAttr  */
  YYSYMBOL_TableLikeClause = 572,          /* TableLikeClause  */
  YYSYMBOL_TableLikeOptionList = 573,      /* TableLikeOptionList  */
  YYSYMBOL_TableLikeOption = 574,          /* TableLikeOption  */
  YYSYMBOL_TableConstraint = 575,          /* TableConstraint  */
  YYSYMBOL_ConstraintElem = 576,           /* ConstraintElem  */
  YYSYMBOL_opt_no_inherit = 577,           /* opt_no_inherit  */
  YYSYMBOL_opt_column_list = 578,          /* opt_column_list  */
  YYSYMBOL_columnList = 579,               /* columnList  */
  YYSYMBOL_columnElem = 580,               /* columnElem  */
  YYSYMBOL_key_match = 581,                /* key_match  */
  YYSYMBOL_ExclusionConstraintList = 582,  /* ExclusionConstraintList  */
  YYSYMBOL_ExclusionConstraintElem = 583,  /* ExclusionConstraintElem  */
  YYSYMBOL_ExclusionWhereClause = 584,     /* ExclusionWhereClause  */
  YYSYMBOL_key_actions = 585,              /* key_actions  */
  YYSYMBOL_key_update = 586,               /* key_update  */
  YYSYMBOL_key_delete = 587,               /* key_delete  */
  YYSYMBOL_key_action = 588,               /* key_action  */
  YYSYMBOL_OptInherit = 589,               /* OptInherit  */
  YYSYMBOL_OptPartitionSpec = 590,         /* OptPartitionSpec  */
  YYSYMBOL_PartitionSpec = 591,            /* PartitionSpec  */
  YYSYMBOL_part_strategy = 592,            /* part_strategy  */
  YYSYMBOL_part_params = 593,              /* part_params  */
  YYSYMBOL_part_elem = 594,                /* part_elem  */
  YYSYMBOL_OptWith = 595,                  /* OptWith  */
  YYSYMBOL_OnCommitOption = 596,           /* OnCommitOption  */
  YYSYMBOL_OptTableSpace = 597,            /* OptTableSpace  */
  YYSYMBOL_OptConsTableSpace = 598,        /* OptConsTableSpace  */
  YYSYMBOL_ExistingIndex = 599,            /* ExistingIndex  */
  YYSYMBOL_CreateStatsStmt = 600,          /* CreateStatsStmt  */
  YYSYMBOL_CreateAsStmt = 601,             /* CreateAsStmt  */
  YYSYMBOL_create_as_target = 602,         /* create_as_target  */
  YYSYMBOL_opt_with_data = 603,            /* opt_with_data  */
  YYSYMBOL_CreateMatViewStmt = 604,        /* CreateMatViewStmt  */
  YYSYMBOL_create_mv_target = 605,         /* create_mv_target  */
  YYSYMBOL_OptNoLog = 606,                 /* OptNoLog  */
  YYSYMBOL_RefreshMatViewStmt = 607,       /* RefreshMatViewStmt  */
  YYSYMBOL_CreateSeqStmt = 608,            /* CreateSeqStmt  */
  YYSYMBOL_AlterSeqStmt = 609,             /* AlterSeqStmt  */
  YYSYMBOL_OptSeqOptList = 610,            /* OptSeqOptList  */
  YYSYMBOL_OptParenthesizedSeqOptList = 611, /* OptParenthesizedSeqOptList  */
  YYSYMBOL_SeqOptList = 612,               /* SeqOptList  */
  YYSYMBOL_SeqOptElem = 613,               /* SeqOptElem  */
  YYSYMBOL_opt_by = 614,                   /* opt_by  */
  YYSYMBOL_NumericOnly = 615,              /* NumericOnly  */
  YYSYMBOL_NumericOnly_list = 616,         /* NumericOnly_list  */
  YYSYMBOL_CreatePLangStmt = 617,          /* CreatePLangStmt  */
  YYSYMBOL_opt_trusted = 618,              /* opt_trusted  */
  YYSYMBOL_handler_name = 619,             /* handler_name  */
  YYSYMBOL_opt_inline_handler = 620,       /* opt_inline_handler  */
  YYSYMBOL_validator_clause = 621,         /* validator_clause  */
  YYSYMBOL_opt_validator = 622,            /* opt_validator  */
  YYSYMBOL_DropPLangStmt = 623,            /* DropPLangStmt  */
  YYSYMBOL_opt_procedural = 624,           /* opt_procedural  */
  YYSYMBOL_CreateTableSpaceStmt = 625,     /* CreateTableSpaceStmt  */
  YYSYMBOL_OptTableSpaceOwner = 626,       /* OptTableSpaceOwner  */
  YYSYMBOL_DropTableSpaceStmt = 627,       /* DropTableSpaceStmt  */
  YYSYMBOL_CreateExtensionStmt = 628,      /* CreateExtensionStmt  */
  YYSYMBOL_create_extension_opt_list = 629, /* create_extension_opt_list  */
  YYSYMBOL_create_extension_opt_item = 630, /* create_extension_opt_item  */
  YYSYMBOL_AlterExtensionStmt = 631,       /* AlterExtensionStmt  */
  YYSYMBOL_alter_extension_opt_list = 632, /* alter_extension_opt_list  */
  YYSYMBOL_alter_extension_opt_item = 633, /* alter_extension_opt_item  */
  YYSYMBOL_AlterExtensionContentsStmt = 634, /* AlterExtensionContentsStmt  */
  YYSYMBOL_CreateFdwStmt = 635,            /* CreateFdwStmt  */
  YYSYMBOL_fdw_option = 636,               /* fdw_option  */
  YYSYMBOL_fdw_options = 637,              /* fdw_options  */
  YYSYMBOL_opt_fdw_options = 638,          /* opt_fdw_options  */
  YYSYMBOL_AlterFdwStmt = 639,             /* AlterFdwStmt  */
  YYSYMBOL_create_generic_options = 640,   /* create_generic_options  */
  YYSYMBOL_generic_option_list = 641,      /* generic_option_list  */
  YYSYMBOL_alter_generic_options = 642,    /* alter_generic_options  */
  YYSYMBOL_alter_generic_option_list = 643, /* alter_generic_option_list  */
  YYSYMBOL_alter_generic_option_elem = 644, /* alter_generic_option_elem  */
  YYSYMBOL_generic_option_elem = 645,      /* generic_option_elem  */
  YYSYMBOL_generic_option_name = 646,      /* generic_option_name  */
  YYSYMBOL_generic_option_arg = 647,       /* generic_option_arg  */
  YYSYMBOL_CreateForeignServerStmt = 648,  /* CreateForeignServerStmt  */
  YYSYMBOL_opt_type = 649,                 /* opt_type  */
  YYSYMBOL_foreign_server_version = 650,   /* foreign_server_version  */
  YYSYMBOL_opt_foreign_server_version = 651, /* opt_foreign_server_version  */
  YYSYMBOL_AlterForeignServerStmt = 652,   /* AlterForeignServerStmt  */
  YYSYMBOL_CreateForeignTableStmt = 653,   /* CreateForeignTableStmt  */
  YYSYMBOL_AlterForeignTableStmt = 654,    /* AlterForeignTableStmt  */
  YYSYMBOL_ImportForeignSchemaStmt = 655,  /* ImportForeignSchemaStmt  */
  YYSYMBOL_import_qualification_type = 656, /* import_qualification_type  */
  YYSYMBOL_import_qualification = 657,     /* import_qualification  */
  YYSYMBOL_CreateUserMappingStmt = 658,    /* CreateUserMappingStmt  */
  YYSYMBOL_auth_ident = 659,               /* auth_ident  */
  YYSYMBOL_DropUserMappingStmt = 660,      /* DropUserMappingStmt  */
  YYSYMBOL_AlterUserMappingStmt = 661,     /* AlterUserMappingStmt  */
  YYSYMBOL_CreatePolicyStmt = 662,         /* CreatePolicyStmt  */
  YYSYMBOL_AlterPolicyStmt = 663,          /* AlterPolicyStmt  */
  YYSYMBOL_RowSecurityOptionalExpr = 664,  /* RowSecurityOptionalExpr  */
  YYSYMBOL_RowSecurityOptionalWithCheck = 665, /* RowSecurityOptionalWithCheck  */
  YYSYMBOL_RowSecurityDefaultToRole = 666, /* RowSecurityDefaultToRole  */
  YYSYMBOL_RowSecurityOptionalToRole = 667, /* RowSecurityOptionalToRole  */
  YYSYMBOL_RowSecurityDefaultPermissive = 668, /* RowSecurityDefaultPermissive  */
  YYSYMBOL_RowSecurityDefaultForCmd = 669, /* RowSecurityDefaultForCmd  */
  YYSYMBOL_row_security_cmd = 670,         /* row_security_cmd  */
  YYSYMBOL_CreateAmStmt = 671,             /* CreateAmStmt  */
  YYSYMBOL_CreateTrigStmt = 672,           /* CreateTrigStmt  */
  YYSYMBOL_TriggerActionTime = 673,        /* TriggerActionTime  */
  YYSYMBOL_TriggerEvents = 674,            /* TriggerEvents  */
  YYSYMBOL_TriggerOneEvent = 675,          /* TriggerOneEvent  */
  YYSYMBOL_TriggerReferencing = 676,       /* TriggerReferencing  */
  YYSYMBOL_TriggerTransitions = 677,       /* TriggerTransitions  */
  YYSYMBOL_TriggerTransition = 678,        /* TriggerTransition  */
  YYSYMBOL_TransitionOldOrNew = 679,       /* TransitionOldOrNew  */
  YYSYMBOL_TransitionRowOrTable = 680,     /* TransitionRowOrTable  */
  YYSYMBOL_TransitionRelName = 681,        /* TransitionRelName  */
  YYSYMBOL_TriggerForSpec = 682,           /* TriggerForSpec  */
  YYSYMBOL_TriggerForOptEach = 683,        /* TriggerForOptEach  */
  YYSYMBOL_TriggerForType = 684,           /* TriggerForType  */
  YYSYMBOL_TriggerWhen = 685,              /* TriggerWhen  */
  YYSYMBOL_TriggerFuncArgs = 686,          /* TriggerFuncArgs  */
  YYSYMBOL_TriggerFuncArg = 687,           /* TriggerFuncArg  */
  YYSYMBOL_OptConstrFromTable = 688,       /* OptConstrFromTable  */
  YYSYMBOL_ConstraintAttributeSpec = 689,  /* ConstraintAttributeSpec  */
  YYSYMBOL_ConstraintAttributeElem = 690,  /* ConstraintAttributeElem  */
  YYSYMBOL_CreateEventTrigStmt = 691,      /* CreateEventTrigStmt  */
  YYSYMBOL_event_trigger_when_list = 692,  /* event_trigger_when_list  */
  YYSYMBOL_event_trigger_when_item = 693,  /* event_trigger_when_item  */
  YYSYMBOL_event_trigger_value_list = 694, /* event_trigger_value_list  */
  YYSYMBOL_AlterEventTrigStmt = 695,       /* AlterEventTrigStmt  */
  YYSYMBOL_enable_trigger = 696,           /* enable_trigger  */
  YYSYMBOL_CreateAssertStmt = 697,         /* CreateAssertStmt  */
  YYSYMBOL_DropAssertStmt = 698,           /* DropAssertStmt  */
  YYSYMBOL_DefineStmt = 699,               /* DefineStmt  */
  YYSYMBOL_definition = 700,               /* definition  */
  YYSYMBOL_def_list = 701,                 /* def_list  */
  YYSYMBOL_def_elem = 702,                 /* def_elem  */
  YYSYMBOL_def_arg = 703,                  /* def_arg  */
  YYSYMBOL_old_aggr_definition = 704,      /* old_aggr_definition  */
  YYSYMBOL_old_aggr_list = 705,            /* old_aggr_list  */
  YYSYMBOL_old_aggr_elem = 706,            /* old_aggr_elem  */
  YYSYMBOL_opt_enum_val_list = 707,        /* opt_enum_val_list  */
  YYSYMBOL_enum_val_list = 708,            /* enum_val_list  */
  YYSYMBOL_AlterEnumStmt = 709,            /* AlterEnumStmt  */
  YYSYMBOL_opt_if_not_exists = 710,        /* opt_if_not_exists  */
  YYSYMBOL_CreateOpClassStmt = 711,        /* CreateOpClassStmt  */
  YYSYMBOL_opclass_item_list = 712,        /* opclass_item_list  */
  YYSYMBOL_opclass_item = 713,             /* opclass_item  */
  YYSYMBOL_opt_default = 714,              /* opt_default  */
  YYSYMBOL_opt_opfamily = 715,             /* opt_opfamily  */
  YYSYMBOL_opclass_purpose = 716,          /* opclass_purpose  */
  YYSYMBOL_opt_recheck = 717,              /* opt_recheck  */
  YYSYMBOL_CreateOpFamilyStmt = 718,       /* CreateOpFamilyStmt  */
  YYSYMBOL_AlterOpFamilyStmt = 719,        /* AlterOpFamilyStmt  */
  YYSYMBOL_opclass_drop_list = 720,        /* opclass_drop_list  */
  YYSYMBOL_opclass_drop = 721,             /* opclass_drop  */
  YYSYMBOL_DropOpClassStmt = 722,          /* DropOpClassStmt  */
  YYSYMBOL_DropOpFamilyStmt = 723,         /* DropOpFamilyStmt  */
  YYSYMBOL_DropOwnedStmt = 724,            /* DropOwnedStmt  */
  YYSYMBOL_ReassignOwnedStmt = 725,        /* ReassignOwnedStmt  */
  YYSYMBOL_DropStmt = 726,                 /* DropStmt  */
  YYSYMBOL_drop_type_any_name = 727,       /* drop_type_any_name  */
  YYSYMBOL_drop_type_name = 728,           /* drop_type_name  */
  YYSYMBOL_drop_type_name_on_any_name = 729, /* drop_type_name_on_any_name  */
  YYSYMBOL_any_name_list = 730,            /* any_name_list  */
  YYSYMBOL_any_name = 731,                 /* any_name  */
  YYSYMBOL_attrs = 732,                    /* attrs  */
  YYSYMBOL_type_name_list = 733,           /* type_name_list  */
  YYSYMBOL_TruncateStmt = 734,             /* TruncateStmt  */
  YYSYMBOL_opt_restart_seqs = 735,         /* opt_restart_seqs  */
  YYSYMBOL_CommentStmt = 736,              /* CommentStmt  */
  YYSYMBOL_comment_type_any_name = 737,    /* comment_type_any_name  */
  YYSYMBOL_comment_type_name = 738,        /* comment_type_name  */
  YYSYMBOL_comment_text = 739,             /* comment_text  */
  YYSYMBOL_SecLabelStmt = 740,             /* SecLabelStmt  */
  YYSYMBOL_opt_provider = 741,             /* opt_provider  */
  YYSYMBOL_security_label_type_any_name = 742, /* security_label_type_any_name  */
  YYSYMBOL_security_label_type_name = 743, /* security_label_type_name  */
  YYSYMBOL_security_label = 744,           /* security_label  */
  YYSYMBOL_FetchStmt = 745,                /* FetchStmt  */
  YYSYMBOL_fetch_args = 746,               /* fetch_args  */
  YYSYMBOL_from_in = 747,                  /* from_in  */
  YYSYMBOL_opt_from_in = 748,              /* opt_from_in  */
  YYSYMBOL_GrantStmt = 749,                /* GrantStmt  */
  YYSYMBOL_RevokeStmt = 750,               /* RevokeStmt  */
  YYSYMBOL_privileges = 751,               /* privileges  */
  YYSYMBOL_privilege_list = 752,           /* privilege_list  */
  YYSYMBOL_privilege = 753,                /* privilege  */
  YYSYMBOL_privilege_target = 754,         /* privilege_target  */
  YYSYMBOL_grantee_list = 755,             /* grantee_list  */
  YYSYMBOL_grantee = 756,                  /* grantee  */
  YYSYMBOL_opt_grant_grant_option = 757,   /* opt_grant_grant_option  */
  YYSYMBOL_GrantRoleStmt = 758,            /* GrantRoleStmt  */
  YYSYMBOL_RevokeRoleStmt = 759,           /* RevokeRoleStmt  */
  YYSYMBOL_opt_grant_admin_option = 760,   /* opt_grant_admin_option  */
  YYSYMBOL_opt_granted_by = 761,           /* opt_granted_by  */
  YYSYMBOL_AlterDefaultPrivilegesStmt = 762, /* AlterDefaultPrivilegesStmt  */
  YYSYMBOL_DefACLOptionList = 763,         /* DefACLOptionList  */
  YYSYMBOL_DefACLOption = 764,             /* DefACLOption  */
  YYSYMBOL_DefACLAction = 765,             /* DefACLAction  */
  YYSYMBOL_defacl_privilege_target = 766,  /* defacl_privilege_target  */
  YYSYMBOL_IndexStmt = 767,                /* IndexStmt  */
  YYSYMBOL_opt_unique = 768,               /* opt_unique  */
  YYSYMBOL_opt_concurrently = 769,         /* opt_concurrently  */
  YYSYMBOL_opt_index_name = 770,           /* opt_index_name  */
  YYSYMBOL_access_method_clause = 771,     /* access_method_clause  */
  YYSYMBOL_index_params = 772,             /* index_params  */
  YYSYMBOL_index_elem = 773,               /* index_elem  */
  YYSYMBOL_opt_collate = 774,              /* opt_collate  */
  YYSYMBOL_opt_class = 775,                /* opt_class  */
  YYSYMBOL_opt_asc_desc = 776,             /* opt_asc_desc  */
  YYSYMBOL_opt_nulls_order = 777,          /* opt_nulls_order  */
  YYSYMBOL_CreateFunctionStmt = 778,       /* CreateFunctionStmt  */
  YYSYMBOL_opt_or_replace = 779,           /* opt_or_replace  */
  YYSYMBOL_func_args = 780,                /* func_args  */
  YYSYMBOL_func_args_list = 781,           /* func_args_list  */
  YYSYMBOL_function_with_argtypes_list = 782, /* function_with_argtypes_list  */
  YYSYMBOL_function_with_argtypes = 783,   /* function_with_argtypes  */
  YYSYMBOL_func_args_with_defaults = 784,  /* func_args_with_defaults  */
  YYSYMBOL_func_args_with_defaults_list = 785, /* func_args_with_defaults_list  */
  YYSYMBOL_func_arg = 786,                 /* func_arg  */
  YYSYMBOL_arg_class = 787,                /* arg_class  */
  YYSYMBOL_param_name = 788,               /* param_name  */
  YYSYMBOL_func_return = 789,              /* func_return  */
  YYSYMBOL_func_type = 790,                /* func_type  */
  YYSYMBOL_func_arg_with_default = 791,    /* func_arg_with_default  */
  YYSYMBOL_aggr_arg = 792,                 /* aggr_arg  */
  YYSYMBOL_aggr_args = 793,                /* aggr_args  */
  YYSYMBOL_aggr_args_list = 794,           /* aggr_args_list  */
  YYSYMBOL_aggregate_with_argtypes = 795,  /* aggregate_with_argtypes  */
  YYSYMBOL_aggregate_with_argtypes_list = 796, /* aggregate_with_argtypes_list  */
  YYSYMBOL_createfunc_opt_list = 797,      /* createfunc_opt_list  */
  YYSYMBOL_common_func_opt_item = 798,     /* common_func_opt_item  */
  YYSYMBOL_createfunc_opt_item = 799,      /* createfunc_opt_item  */
  YYSYMBOL_func_as = 800,                  /* func_as  */
  YYSYMBOL_transform_type_list = 801,      /* transform_type_list  */
  YYSYMBOL_opt_definition = 802,           /* opt_definition  */
  YYSYMBOL_table_func_column = 803,        /* table_func_column  */
  YYSYMBOL_table_func_column_list = 804,   /* table_func_column_list  */
  YYSYMBOL_AlterFunctionStmt = 805,        /* AlterFunctionStmt  */
  YYSYMBOL_alterfunc_opt_list = 806,       /* alterfunc_opt_list  */
  YYSYMBOL_opt_restrict = 807,             /* opt_restrict  */
  YYSYMBOL_RemoveFuncStmt = 808,           /* RemoveFuncStmt  */
  YYSYMBOL_RemoveAggrStmt = 809,           /* RemoveAggrStmt  */
  YYSYMBOL_RemoveOperStmt = 810,           /* RemoveOperStmt  */
  YYSYMBOL_oper_argtypes = 811,            /* oper_argtypes  */
  YYSYMBOL_any_operator = 812,             /* any_operator  */
  YYSYMBOL_operator_with_argtypes_list = 813, /* operator_with_argtypes_list  */
  YYSYMBOL_operator_with_argtypes = 814,   /* operator_with_argtypes  */
  YYSYMBOL_DoStmt = 815,                   /* DoStmt  */
  YYSYMBOL_dostmt_opt_list = 816,          /* dostmt_opt_list  */
  YYSYMBOL_dostmt_opt_item = 817,          /* dostmt_opt_item  */
  YYSYMBOL_CreateCastStmt = 818,           /* CreateCastStmt  */
  YYSYMBOL_cast_context = 819,             /* cast_context  */
  YYSYMBOL_DropCastStmt = 820,             /* DropCastStmt  */
  YYSYMBOL_opt_if_exists = 821,            /* opt_if_exists  */
  YYSYMBOL_CreateTransformStmt = 822,      /* CreateTransformStmt  */
  YYSYMBOL_transform_element_list = 823,   /* transform_element_list  */
  YYSYMBOL_DropTransformStmt = 824,        /* DropTransformStmt  */
  YYSYMBOL_ReindexStmt = 825,              /* ReindexStmt  */
  YYSYMBOL_reindex_target_type = 826,      /* reindex_target_type  */
  YYSYMBOL_reindex_target_multitable = 827, /* reindex_target_multitable  */
  YYSYMBOL_reindex_option_list = 828,      /* reindex_option_list  */
  YYSYMBOL_reindex_option_elem = 829,      /* reindex_option_elem  */
  YYSYMBOL_AlterTblSpcStmt = 830,          /* AlterTblSpcStmt  */
  YYSYMBOL_RenameStmt = 831,               /* RenameStmt  */
  YYSYMBOL_opt_column = 832,               /* opt_column  */
  YYSYMBOL_opt_set_data = 833,             /* opt_set_data  */
  YYSYMBOL_AlterObjectDependsStmt = 834,   /* AlterObjectDependsStmt  */
  YYSYMBOL_AlterObjectSchemaStmt = 835,    /* AlterObjectSchemaStmt  */
  YYSYMBOL_AlterOperatorStmt = 836,        /* AlterOperatorStmt  */
  YYSYMBOL_operator_def_list = 837,        /* operator_def_list  */
  YYSYMBOL_operator_def_elem = 838,        /* operator_def_elem  */
  YYSYMBOL_operator_def_arg = 839,         /* operator_def_arg  */
  YYSYMBOL_AlterOwnerStmt = 840,           /* AlterOwnerStmt  */
  YYSYMBOL_CreatePublicationStmt = 841,    /* CreatePublicationStmt  */
  YYSYMBOL_opt_publication_for_tables = 842, /* opt_publication_for_tables  */
  YYSYMBOL_publication_for_tables = 843,   /* publication_for_tables  */
  YYSYMBOL_AlterPublicationStmt = 844,     /* AlterPublicationStmt  */
  YYSYMBOL_CreateSubscriptionStmt = 845,   /* CreateSubscriptionStmt  */
  YYSYMBOL_publication_name_list = 846,    /* publication_name_list  */
  YYSYMBOL_publication_name_item = 847,    /* publication_name_item  */
  YYSYMBOL_AlterSubscriptionStmt = 848,    /* AlterSubscriptionStmt  */
  YYSYMBOL_DropSubscriptionStmt = 849,     /* DropSubscriptionStmt  */
  YYSYMBOL_RuleStmt = 850,                 /* RuleStmt  */
  YYSYMBOL_RuleActionList = 851,           /* RuleActionList  */
  YYSYMBOL_RuleActionMulti = 852,          /* RuleActionMulti  */
  YYSYMBOL_RuleActionStmt = 853,           /* RuleActionStmt  */
  YYSYMBOL_RuleActionStmtOrEmpty = 854,    /* RuleActionStmtOrEmpty  */
  YYSYMBOL_event = 855,                    /* event  */
  YYSYMBOL_opt_instead = 856,              /* opt_instead  */
  YYSYMBOL_NotifyStmt = 857,               /* NotifyStmt  */
  YYSYMBOL_notify_payload = 858,           /* notify_payload  */
  YYSYMBOL_ListenStmt = 859,               /* ListenStmt  */
  YYSYMBOL_UnlistenStmt = 860,             /* UnlistenStmt  */
  YYSYMBOL_TransactionStmt = 861,          /* TransactionStmt  */
  YYSYMBOL_opt_transaction = 862,          /* opt_transaction  */
  YYSYMBOL_transaction_mode_item = 863,    /* transaction_mode_item  */
  YYSYMBOL_transaction_mode_list = 864,    /* transaction_mode_list  */
  YYSYMBOL_transaction_mode_list_or_empty = 865, /* transaction_mode_list_or_empty  */
  YYSYMBOL_ViewStmt = 866,                 /* ViewStmt  */
  YYSYMBOL_opt_check_option = 867,         /* opt_check_option  */
  YYSYMBOL_LoadStmt = 868,                 /* LoadStmt  */
  YYSYMBOL_CreatedbStmt = 869,             /* CreatedbStmt  */
  YYSYMBOL_createdb_opt_list = 870,        /* createdb_opt_list  */
  YYSYMBOL_createdb_opt_items = 871,       /* createdb_opt_items  */
  YYSYMBOL_createdb_opt_item = 872,        /* createdb_opt_item  */
  YYSYMBOL_createdb_opt_name = 873,        /* createdb_opt_name  */
  YYSYMBOL_opt_equal = 874,                /* opt_equal  */
  YYSYMBOL_AlterDatabaseStmt = 875,        /* AlterDatabaseStmt  */
  YYSYMBOL_AlterDatabaseSetStmt = 876,     /* AlterDatabaseSetStmt  */
  YYSYMBOL_DropdbStmt = 877,               /* DropdbStmt  */
  YYSYMBOL_AlterCollationStmt = 878,       /* AlterCollationStmt  */
  YYSYMBOL_AlterSystemStmt = 879,          /* AlterSystemStmt  */
  YYSYMBOL_CreateDomainStmt = 880,         /* CreateDomainStmt  */
  YYSYMBOL_AlterDomainStmt = 881,          /* AlterDomainStmt  */
  YYSYMBOL_opt_as = 882,                   /* opt_as  */
  YYSYMBOL_AlterTSDictionaryStmt = 883,    /* AlterTSDictionaryStmt  */
  YYSYMBOL_AlterTSConfigurationStmt = 884, /* AlterTSConfigurationStmt  */
  YYSYMBOL_any_with = 885,                 /* any_with  */
  YYSYMBOL_CreateConversionStmt = 886,     /* CreateConversionStmt  */
  YYSYMBOL_ClusterStmt = 887,              /* ClusterStmt  */
  YYSYMBOL_cluster_index_specification = 888, /* cluster_index_specification  */
  YYSYMBOL_VacuumStmt = 889,               /* VacuumStmt  */
  YYSYMBOL_vacuum_option_list = 890,       /* vacuum_option_list  */
  YYSYMBOL_vacuum_option_elem = 891,       /* vacuum_option_elem  */
  YYSYMBOL_AnalyzeStmt = 892,              /* AnalyzeStmt  */
  YYSYMBOL_analyze_keyword = 893,          /* analyze_keyword  */
  YYSYMBOL_opt_verbose = 894,              /* opt_verbose  */
  YYSYMBOL_opt_full = 895,                 /* opt_full  */
  YYSYMBOL_opt_freeze = 896,               /* opt_freeze  */
  YYSYMBOL_opt_name_list = 897,            /* opt_name_list  */
  YYSYMBOL_ExplainStmt = 898,              /* ExplainStmt  */
  YYSYMBOL_ExplainableStmt = 899,          /* ExplainableStmt  */
  YYSYMBOL_explain_option_list = 900,      /* explain_option_list  */
  YYSYMBOL_explain_option_elem = 901,      /* explain_option_elem  */
  YYSYMBOL_explain_option_name = 902,      /* explain_option_name  */
  YYSYMBOL_explain_option_arg = 903,       /* explain_option_arg  */
  YYSYMBOL_PrepareStmt = 904,              /* PrepareStmt  */
  YYSYMBOL_prep_type_clause = 905,         /* prep_type_clause  */
  YYSYMBOL_PreparableStmt = 906,           /* PreparableStmt  */
  YYSYMBOL_ExecuteStmt = 907,              /* ExecuteStmt  */
  YYSYMBOL_execute_param_clause = 908,     /* execute_param_clause  */
  YYSYMBOL_DeallocateStmt = 909,           /* DeallocateStmt  */
  YYSYMBOL_InsertStmt = 910,               /* InsertStmt  */
  YYSYMBOL_insert_target = 911,            /* insert_target  */
  YYSYMBOL_insert_rest = 912,              /* insert_rest  */
  YYSYMBOL_override_kind = 913,            /* override_kind  */
  YYSYMBOL_insert_column_list = 914,       /* insert_column_list  */
  YYSYMBOL_insert_column_item = 915,       /* insert_column_item  */
  YYSYMBOL_opt_on_conflict = 916,          /* opt_on_conflict  */
  YYSYMBOL_opt_conf_expr = 917,            /* opt_conf_expr  */
  YYSYMBOL_returning_clause = 918,         /* returning_clause  */
  YYSYMBOL_DeleteStmt = 919,               /* DeleteStmt  */
  YYSYMBOL_using_clause = 920,             /* using_clause  */
  YYSYMBOL_LockStmt = 921,                 /* LockStmt  */
  YYSYMBOL_opt_lock = 922,                 /* opt_lock  */
  YYSYMBOL_lock_type = 923,                /* lock_type  */
  YYSYMBOL_opt_nowait = 924,               /* opt_nowait  */
  YYSYMBOL_opt_nowait_or_skip = 925,       /* opt_nowait_or_skip  */
  YYSYMBOL_UpdateStmt = 926,               /* UpdateStmt  */
  YYSYMBOL_set_clause_list = 927,          /* set_clause_list  */
  YYSYMBOL_set_clause = 928,               /* set_clause  */
  YYSYMBOL_set_target = 929,               /* set_target  */
  YYSYMBOL_set_target_list = 930,          /* set_target_list  */
  YYSYMBOL_DeclareCursorStmt = 931,        /* DeclareCursorStmt  */
  YYSYMBOL_cursor_name = 932,              /* cursor_name  */
  YYSYMBOL_cursor_options = 933,           /* cursor_options  */
  YYSYMBOL_opt_hold = 934,                 /* opt_hold  */
  YYSYMBOL_SelectStmt = 935,               /* SelectStmt  */
  YYSYMBOL_select_with_parens = 936,       /* select_with_parens  */
  YYSYMBOL_select_no_parens = 937,         /* select_no_parens  */
  YYSYMBOL_select_clause = 938,            /* select_clause  */
  YYSYMBOL_simple_select = 939,            /* simple_select  */
  YYSYMBOL_with_clause = 940,              /* with_clause  */
  YYSYMBOL_cte_list = 941,                 /* cte_list  */
  YYSYMBOL_common_table_expr = 942,        /* common_table_expr  */
  YYSYMBOL_opt_with_clause = 943,          /* opt_with_clause  */
  YYSYMBOL_into_clause = 944,              /* into_clause  */
  YYSYMBOL_OptTempTableName = 945,         /* OptTempTableName  */
  YYSYMBOL_opt_table = 946,                /* opt_table  */
  YYSYMBOL_all_or_distinct = 947,          /* all_or_distinct  */
  YYSYMBOL_distinct_clause = 948,          /* distinct_clause  */
  YYSYMBOL_opt_all_clause = 949,           /* opt_all_clause  */
  YYSYMBOL_opt_sort_clause = 950,          /* opt_sort_clause  */
  YYSYMBOL_sort_clause = 951,              /* sort_clause  */
  YYSYMBOL_sortby_list = 952,              /* sortby_list  */
  YYSYMBOL_sortby = 953,                   /* sortby  */
  YYSYMBOL_select_limit = 954,             /* select_limit  */
  YYSYMBOL_opt_select_limit = 955,         /* opt_select_limit  */
  YYSYMBOL_limit_clause = 956,             /* limit_clause  */
  YYSYMBOL_offset_clause = 957,            /* offset_clause  */
  YYSYMBOL_select_limit_value = 958,       /* select_limit_value  */
  YYSYMBOL_select_offset_value = 959,      /* select_offset_value  */
  YYSYMBOL_select_fetch_first_value = 960, /* select_fetch_first_value  */
  YYSYMBOL_I_or_F_const = 961,             /* I_or_F_const  */
  YYSYMBOL_row_or_rows = 962,              /* row_or_rows  */
  YYSYMBOL_first_or_next = 963,            /* first_or_next  */
  YYSYMBOL_group_clause = 964,             /* group_clause  */
  YYSYMBOL_group_by_list = 965,            /* group_by_list  */
  YYSYMBOL_group_by_item = 966,            /* group_by_item  */
  YYSYMBOL_empty_grouping_set = 967,       /* empty_grouping_set  */
  YYSYMBOL_rollup_clause = 968,            /* rollup_clause  */
  YYSYMBOL_cube_clause = 969,              /* cube_clause  */
  YYSYMBOL_grouping_sets_clause = 970,     /* grouping_sets_clause  */
  YYSYMBOL_having_clause = 971,            /* having_clause  */
  YYSYMBOL_for_locking_clause = 972,       /* for_locking_clause  */
  YYSYMBOL_opt_for_locking_clause = 973,   /* opt_for_locking_clause  */
  YYSYMBOL_for_locking_items = 974,        /* for_locking_items  */
  YYSYMBOL_for_locking_item = 975,         /* for_locking_item  */
  YYSYMBOL_for_locking_strength = 976,     /* for_locking_strength  */
  YYSYMBOL_locked_rels_list = 977,         /* locked_rels_list  */
  YYSYMBOL_values_clause = 978,            /* values_clause  */
  YYSYMBOL_from_clause = 979,              /* from_clause  */
  YYSYMBOL_from_list = 980,                /* from_list  */
  YYSYMBOL_table_ref = 981,                /* table_ref  */
  YYSYMBOL_joined_table = 982,             /* joined_table  */
  YYSYMBOL_alias_clause = 983,             /* alias_clause  */
  YYSYMBOL_opt_alias_clause = 984,         /* opt_alias_clause  */
  YYSYMBOL_func_alias_clause = 985,        /* func_alias_clause  */
  YYSYMBOL_join_type = 986,                /* join_type  */
  YYSYMBOL_join_outer = 987,               /* join_outer  */
  YYSYMBOL_join_qual = 988,                /* join_qual  */
  YYSYMBOL_relation_expr = 989,            /* relation_expr  */
  YYSYMBOL_relation_expr_list = 990,       /* relation_expr_list  */
  YYSYMBOL_relation_expr_opt_alias = 991,  /* relation_expr_opt_alias  */
  YYSYMBOL_tablesample_clause = 992,       /* tablesample_clause  */
  YYSYMBOL_opt_repeatable_clause = 993,    /* opt_repeatable_clause  */
  YYSYMBOL_func_table = 994,               /* func_table  */
  YYSYMBOL_rowsfrom_item = 995,            /* rowsfrom_item  */
  YYSYMBOL_rowsfrom_list = 996,            /* rowsfrom_list  */
  YYSYMBOL_opt_col_def_list = 997,         /* opt_col_def_list  */
  YYSYMBOL_opt_ordinality = 998,           /* opt_ordinality  */
  YYSYMBOL_where_clause = 999,             /* where_clause  */
  YYSYMBOL_where_or_current_clause = 1000, /* where_or_current_clause  */
  YYSYMBOL_OptTableFuncElementList = 1001, /* OptTableFuncElementList  */
  YYSYMBOL_TableFuncElementList = 1002,    /* TableFuncElementList  */
  YYSYMBOL_TableFuncElement = 1003,        /* TableFuncElement  */
  YYSYMBOL_xmltable = 1004,                /* xmltable  */
  YYSYMBOL_xmltable_column_list = 1005,    /* xmltable_column_list  */
  YYSYMBOL_xmltable_column_el = 1006,      /* xmltable_column_el  */
  YYSYMBOL_xmltable_column_option_list = 1007, /* xmltable_column_option_list  */
  YYSYMBOL_xmltable_column_option_el = 1008, /* xmltable_column_option_el  */
  YYSYMBOL_xml_namespace_list = 1009,      /* xml_namespace_list  */
  YYSYMBOL_xml_namespace_el = 1010,        /* xml_namespace_el  */
  YYSYMBOL_Typename = 1011,                /* Typename  */
  YYSYMBOL_opt_array_bounds = 1012,        /* opt_array_bounds  */
  YYSYMBOL_SimpleTypename = 1013,          /* SimpleTypename  */
  YYSYMBOL_ConstTypename = 1014,           /* ConstTypename  */
  YYSYMBOL_GenericType = 1015,             /* GenericType  */
  YYSYMBOL_opt_type_modifiers = 1016,      /* opt_type_modifiers  */
  YYSYMBOL_Numeric = 1017,                 /* Numeric  */
  YYSYMBOL_opt_float = 1018,               /* opt_float  */
  YYSYMBOL_Bit = 1019,                     /* Bit  */
  YYSYMBOL_ConstBit = 1020,                /* ConstBit  */
  YYSYMBOL_BitWithLength = 1021,           /* BitWithLength  */
  YYSYMBOL_BitWithoutLength = 1022,        /* BitWithoutLength  */
  YYSYMBOL_Character = 1023,               /* Character  */
  YYSYMBOL_ConstCharacter = 1024,          /* ConstCharacter  */
  YYSYMBOL_CharacterWithLength = 1025,     /* CharacterWithLength  */
  YYSYMBOL_CharacterWithoutLength = 1026,  /* CharacterWithoutLength  */
  YYSYMBOL_character = 1027,               /* character  */
  YYSYMBOL_opt_varying = 1028,             /* opt_varying  */
  YYSYMBOL_ConstDatetime = 1029,           /* ConstDatetime  */
  YYSYMBOL_ConstInterval = 1030,           /* ConstInterval  */
  YYSYMBOL_opt_timezone = 1031,            /* opt_timezone  */
  YYSYMBOL_opt_interval = 1032,            /* opt_interval  */
  YYSYMBOL_interval_second = 1033,         /* interval_second  */
  YYSYMBOL_a_expr = 1034,                  /* a_expr  */
  YYSYMBOL_b_expr = 1035,                  /* b_expr  */
  YYSYMBOL_c_expr = 1036,                  /* c_expr  */
  YYSYMBOL_func_application = 1037,        /* func_application  */
  YYSYMBOL_func_expr = 1038,               /* func_expr  */
  YYSYMBOL_func_expr_windowless = 1039,    /* func_expr_windowless  */
  YYSYMBOL_func_expr_common_subexpr = 1040, /* func_expr_common_subexpr  */
  YYSYMBOL_xml_root_version = 1041,        /* xml_root_version  */
  YYSYMBOL_opt_xml_root_standalone = 1042, /* opt_xml_root_standalone  */
  YYSYMBOL_xml_attributes = 1043,          /* xml_attributes  */
  YYSYMBOL_xml_attribute_list = 1044,      /* xml_attribute_list  */
  YYSYMBOL_xml_attribute_el = 1045,        /* xml_attribute_el  */
  YYSYMBOL_document_or_content = 1046,     /* document_or_content  */
  YYSYMBOL_xml_whitespace_option = 1047,   /* xml_whitespace_option  */
  YYSYMBOL_xmlexists_argument = 1048,      /* xmlexists_argument  */
  YYSYMBOL_within_group_clause = 1049,     /* within_group_clause  */
  YYSYMBOL_filter_clause = 1050,           /* filter_clause  */
  YYSYMBOL_window_clause = 1051,           /* window_clause  */
  YYSYMBOL_window_definition_list = 1052,  /* window_definition_list  */
  YYSYMBOL_window_definition = 1053,       /* window_definition  */
  YYSYMBOL_over_clause = 1054,             /* over_clause  */
  YYSYMBOL_window_specification = 1055,    /* window_specification  */
  YYSYMBOL_opt_existing_window_name = 1056, /* opt_existing_window_name  */
  YYSYMBOL_opt_partition_clause = 1057,    /* opt_partition_clause  */
  YYSYMBOL_opt_frame_clause = 1058,        /* opt_frame_clause  */
  YYSYMBOL_frame_extent = 1059,            /* frame_extent  */
  YYSYMBOL_frame_bound = 1060,             /* frame_bound  */
  YYSYMBOL_row = 1061,                     /* row  */
  YYSYMBOL_explicit_row = 1062,            /* explicit_row  */
  YYSYMBOL_implicit_row = 1063,            /* implicit_row  */
  YYSYMBOL_sub_type = 1064,                /* sub_type  */
  YYSYMBOL_all_Op = 1065,                  /* all_Op  */
  YYSYMBOL_MathOp = 1066,                  /* MathOp  */
  YYSYMBOL_qual_Op = 1067,                 /* qual_Op  */
  YYSYMBOL_qual_all_Op = 1068,             /* qual_all_Op  */
  YYSYMBOL_subquery_Op = 1069,             /* subquery_Op  */
  YYSYMBOL_expr_list = 1070,               /* expr_list  */
  YYSYMBOL_func_arg_list = 1071,           /* func_arg_list  */
  YYSYMBOL_func_arg_expr = 1072,           /* func_arg_expr  */
  YYSYMBOL_type_list = 1073,               /* type_list  */
  YYSYMBOL_array_expr = 1074,              /* array_expr  */
  YYSYMBOL_array_expr_list = 1075,         /* array_expr_list  */
  YYSYMBOL_extract_list = 1076,            /* extract_list  */
  YYSYMBOL_extract_arg = 1077,             /* extract_arg  */
  YYSYMBOL_overlay_list = 1078,            /* overlay_list  */
  YYSYMBOL_overlay_placing = 1079,         /* overlay_placing  */
  YYSYMBOL_position_list = 1080,           /* position_list  */
  YYSYMBOL_substr_list = 1081,             /* substr_list  */
  YYSYMBOL_substr_from = 1082,             /* substr_from  */
  YYSYMBOL_substr_for = 1083,              /* substr_for  */
  YYSYMBOL_trim_list = 1084,               /* trim_list  */
  YYSYMBOL_in_expr = 1085,                 /* in_expr  */
  YYSYMBOL_case_expr = 1086,               /* case_expr  */
  YYSYMBOL_when_clause_list = 1087,        /* when_clause_list  */
  YYSYMBOL_when_clause = 1088,             /* when_clause  */
  YYSYMBOL_case_default = 1089,            /* case_default  */
  YYSYMBOL_case_arg = 1090,                /* case_arg  */
  YYSYMBOL_columnref = 1091,               /* columnref  */
  YYSYMBOL_indirection_el = 1092,          /* indirection_el  */
  YYSYMBOL_opt_slice_bound = 1093,         /* opt_slice_bound  */
  YYSYMBOL_indirection = 1094,             /* indirection  */
  YYSYMBOL_opt_indirection = 1095,         /* opt_indirection  */
  YYSYMBOL_opt_asymmetric = 1096,          /* opt_asymmetric  */
  YYSYMBOL_opt_target_list = 1097,         /* opt_target_list  */
  YYSYMBOL_target_list = 1098,             /* target_list  */
  YYSYMBOL_target_el = 1099,               /* target_el  */
  YYSYMBOL_qualified_name_list = 1100,     /* qualified_name_list  */
  YYSYMBOL_qualified_name = 1101,          /* qualified_name  */
  YYSYMBOL_name_list = 1102,               /* name_list  */
  YYSYMBOL_name = 1103,                    /* name  */
  YYSYMBOL_database_name = 1104,           /* database_name  */
  YYSYMBOL_access_method = 1105,           /* access_method  */
  YYSYMBOL_attr_name = 1106,               /* attr_name  */
  YYSYMBOL_index_name = 1107,              /* index_name  */
  YYSYMBOL_file_name = 1108,               /* file_name  */
  YYSYMBOL_func_name = 1109,               /* func_name  */
  YYSYMBOL_AexprConst = 1110,              /* AexprConst  */
  YYSYMBOL_Iconst = 1111,                  /* Iconst  */
  YYSYMBOL_Sconst = 1112,                  /* Sconst  */
  YYSYMBOL_SignedIconst = 1113,            /* SignedIconst  */
  YYSYMBOL_RoleId = 1114,                  /* RoleId  */
  YYSYMBOL_RoleSpec = 1115,                /* RoleSpec  */
  YYSYMBOL_role_list = 1116,               /* role_list  */
  YYSYMBOL_ColId = 1117,                   /* ColId  */
  YYSYMBOL_type_function_name = 1118,      /* type_function_name  */
  YYSYMBOL_NonReservedWord = 1119,         /* NonReservedWord  */
  YYSYMBOL_ColLabel = 1120,                /* ColLabel  */
  YYSYMBOL_unreserved_keyword = 1121,      /* unreserved_keyword  */
  YYSYMBOL_col_name_keyword = 1122,        /* col_name_keyword  */
  YYSYMBOL_type_func_name_keyword = 1123,  /* type_func_name_keyword  */
  YYSYMBOL_reserved_keyword = 1124         /* reserved_keyword  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  784
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   99601

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  472
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  653
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2663
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5323

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   709


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   461,     2,     2,
     466,   467,   459,   457,   470,   458,   468,   460,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   471,   469,
     453,   455,   454,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   464,     2,   465,   462,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   456,   463
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   775,   775,   792,   804,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   938,   948,
     959,   960,   961,   970,   971,   975,   976,   980,   985,   989,
     999,  1007,  1011,  1015,  1020,  1024,  1072,  1074,  1078,  1082,
    1086,  1090,  1104,  1122,  1130,  1141,  1142,  1146,  1154,  1162,
    1170,  1191,  1198,  1205,  1212,  1219,  1226,  1243,  1261,  1272,
    1273,  1284,  1294,  1304,  1319,  1337,  1338,  1342,  1349,  1357,
    1358,  1359,  1360,  1361,  1362,  1376,  1382,  1388,  1397,  1405,
    1413,  1417,  1425,  1433,  1440,  1450,  1451,  1459,  1470,  1478,
    1486,  1497,  1505,  1513,  1520,  1529,  1539,  1540,  1544,  1545,
    1548,  1550,  1554,  1555,  1556,  1557,  1561,  1562,  1563,  1569,
    1581,  1585,  1589,  1604,  1611,  1612,  1613,  1617,  1618,  1619,
    1623,  1624,  1628,  1632,  1633,  1640,  1647,  1657,  1664,  1674,
    1675,  1680,  1681,  1686,  1692,  1698,  1704,  1710,  1720,  1730,
    1731,  1735,  1736,  1744,  1759,  1765,  1771,  1777,  1783,  1802,
    1811,  1820,  1829,  1838,  1849,  1860,  1869,  1878,  1889,  1900,
    1909,  1918,  1927,  1936,  1945,  1954,  1965,  1979,  1980,  1985,
    1998,  2014,  2023,  2032,  2041,  2050,  2059,  2067,  2075,  2084,
    2093,  2102,  2111,  2128,  2137,  2146,  2155,  2165,  2178,  2193,
    2202,  2210,  2225,  2233,  2243,  2253,  2260,  2267,  2275,  2283,
    2290,  2297,  2305,  2313,  2321,  2328,  2335,  2343,  2350,  2357,
    2365,  2373,  2381,  2389,  2397,  2405,  2415,  2422,  2430,  2438,
    2446,  2454,  2462,  2469,  2476,  2483,  2489,  2499,  2500,  2504,
    2505,  2506,  2510,  2518,  2522,  2523,  2527,  2534,  2541,  2548,
    2558,  2561,  2562,  2566,  2567,  2572,  2576,  2580,  2585,  2592,
    2594,  2599,  2603,  2607,  2618,  2626,  2638,  2652,  2653,  2654,
    2655,  2656,  2660,  2661,  2666,  2667,  2672,  2682,  2692,  2712,
    2725,  2726,  2731,  2740,  2750,  2760,  2786,  2792,  2825,  2854,
    2876,  2877,  2881,  2882,  2891,  2892,  2893,  2896,  2897,  2902,
    2903,  2907,  2911,  2915,  2919,  2923,  2927,  2931,  2935,  2939,
    2943,  2947,  2951,  2955,  2959,  2968,  2972,  2976,  2980,  2984,
    2988,  2992,  2993,  2998,  3002,  3009,  3016,  3017,  3018,  3019,
    3020,  3024,  3028,  3036,  3047,  3064,  3082,  3101,  3120,  3139,
    3171,  3172,  3173,  3174,  3175,  3182,  3189,  3190,  3194,  3195,
    3199,  3200,  3204,  3208,  3215,  3219,  3226,  3227,  3228,  3232,
    3233,  3236,  3257,  3275,  3296,  3297,  3301,  3308,  3309,  3310,
    3341,  3348,  3355,  3366,  3377,  3389,  3398,  3407,  3425,  3426,
    3445,  3452,  3459,  3466,  3477,  3488,  3489,  3490,  3494,  3495,
    3496,  3497,  3498,  3499,  3500,  3501,  3510,  3517,  3521,  3534,
    3549,  3563,  3578,  3592,  3610,  3631,  3632,  3636,  3637,  3641,
    3642,  3645,  3651,  3655,  3663,  3668,  3674,  3675,  3679,  3684,
    3691,  3692,  3702,  3704,  3706,  3708,  3711,  3714,  3717,  3721,
    3722,  3723,  3724,  3725,  3728,  3729,  3733,  3734,  3737,  3749,
    3750,  3753,  3754,  3757,  3768,  3779,  3793,  3794,  3795,  3796,
    3799,  3800,  3801,  3802,  3805,  3806,  3809,  3810,  3813,  3831,
    3842,  3866,  3879,  3895,  3909,  3910,  3911,  3923,  3936,  3952,
    3965,  3966,  3978,  3998,  4008,  4021,  4029,  4040,  4041,  4044,
    4045,  4048,  4049,  4052,  4056,  4060,  4064,  4068,  4072,  4076,
    4080,  4084,  4088,  4092,  4097,  4101,  4105,  4111,  4112,  4116,
    4117,  4118,  4123,  4126,  4127,  4139,  4151,  4166,  4167,  4175,
    4176,  4180,  4181,  4185,  4186,  4190,  4191,  4195,  4205,  4218,
    4219,  4229,  4240,  4241,  4254,  4261,  4278,  4286,  4297,  4300,
    4304,  4308,  4312,  4316,  4328,  4338,  4341,  4345,  4358,  4367,
    4376,  4385,  4394,  4403,  4412,  4421,  4430,  4439,  4448,  4457,
    4466,  4475,  4484,  4493,  4502,  4511,  4520,  4529,  4538,  4547,
    4556,  4565,  4574,  4583,  4601,  4612,  4613,  4614,  4615,  4619,
    4620,  4624,  4625,  4635,  4643,  4655,  4656,  4660,  4664,  4672,
    4676,  4680,  4687,  4691,  4696,  4701,  4708,  4715,  4720,  4730,
    4742,  4757,  4758,  4763,  4764,  4768,  4769,  4779,  4788,  4796,
    4813,  4833,  4853,  4874,  4905,  4914,  4935,  4950,  4951,  4955,
    4963,  4978,  4987,  4999,  5000,  5012,  5020,  5037,  5061,  5078,
    5092,  5093,  5097,  5098,  5102,  5103,  5107,  5108,  5112,  5126,
    5130,  5131,  5135,  5136,  5137,  5138,  5139,  5149,  5167,  5188,
    5214,  5215,  5216,  5220,  5222,  5244,  5246,  5248,  5250,  5252,
    5257,  5258,  5262,  5263,  5267,  5278,  5279,  5283,  5292,  5296,
    5300,  5305,  5315,  5316,  5320,  5321,  5325,  5326,  5330,  5331,
    5332,  5336,  5340,  5341,  5342,  5346,  5347,  5352,  5353,  5380,
    5381,  5382,  5383,  5384,  5385,  5398,  5408,  5422,  5424,  5429,
    5434,  5436,  5441,  5451,  5452,  5453,  5454,  5466,  5486,  5508,
    5518,  5529,  5539,  5549,  5560,  5569,  5576,  5583,  5592,  5601,
    5610,  5619,  5628,  5638,  5647,  5659,  5662,  5663,  5666,  5670,
    5677,  5678,  5679,  5680,  5681,  5682,  5685,  5688,  5689,  5697,
    5704,  5705,  5708,  5710,  5721,  5732,  5743,  5754,  5767,  5768,
    5784,  5799,  5800,  5804,  5816,  5826,  5834,  5843,  5852,  5853,
    5856,  5857,  5860,  5861,  5862,  5865,  5879,  5884,  5894,  5903,
    5915,  5916,  5920,  5928,  5940,  5950,  5963,  5973,  5995,  6005,
    6023,  6033,  6043,  6053,  6063,  6073,  6083,  6093,  6103,  6113,
    6123,  6133,  6147,  6148,  6149,  6150,  6151,  6152,  6153,  6154,
    6155,  6156,  6157,  6158,  6159,  6164,  6165,  6166,  6167,  6168,
    6169,  6170,  6175,  6176,  6177,  6181,  6182,  6185,  6186,  6189,
    6191,  6196,  6197,  6208,  6219,  6220,  6221,  6255,  6263,  6271,
    6279,  6287,  6295,  6303,  6311,  6319,  6332,  6340,  6348,  6356,
    6364,  6372,  6380,  6388,  6400,  6401,  6402,  6403,  6404,  6405,
    6406,  6407,  6408,  6409,  6410,  6411,  6412,  6413,  6418,  6419,
    6420,  6421,  6422,  6423,  6424,  6425,  6426,  6427,  6428,  6429,
    6433,  6434,  6448,  6458,  6468,  6478,  6488,  6498,  6508,  6520,
    6521,  6526,  6527,  6528,  6529,  6530,  6531,  6536,  6537,  6538,
    6539,  6540,  6541,  6542,  6543,  6546,  6547,  6557,  6563,  6571,
    6579,  6587,  6595,  6603,  6611,  6619,  6627,  6635,  6643,  6651,
    6659,  6667,  6675,  6683,  6691,  6701,  6702,  6705,  6706,  6716,
    6732,  6746,  6772,  6774,  6776,  6778,  6785,  6794,  6795,  6798,
    6805,  6812,  6819,  6833,  6841,  6849,  6857,  6865,  6873,  6881,
    6889,  6897,  6905,  6913,  6921,  6929,  6937,  6945,  6953,  6965,
    6966,  6970,  6971,  6976,  6977,  6987,  7000,  7010,  7022,  7023,
    7026,  7027,  7037,  7047,  7048,  7052,  7056,  7060,  7071,  7084,
    7098,  7115,  7116,  7117,  7118,  7119,  7131,  7157,  7186,  7187,
    7191,  7192,  7196,  7197,  7201,  7202,  7205,  7206,  7214,  7225,
    7236,  7249,  7250,  7253,  7254,  7257,  7258,  7259,  7262,  7263,
    7264,  7280,  7292,  7305,  7320,  7321,  7324,  7325,  7329,  7330,
    7334,  7335,  7340,  7352,  7359,  7366,  7381,  7382,  7386,  7387,
    7402,  7411,  7420,  7429,  7438,  7450,  7451,  7452,  7453,  7454,
    7460,  7464,  7479,  7480,  7486,  7496,  7500,  7505,  7513,  7554,
    7558,  7562,  7566,  7574,  7575,  7579,  7589,  7590,  7596,  7597,
    7604,  7608,  7612,  7616,  7620,  7624,  7628,  7632,  7636,  7640,
    7644,  7648,  7652,  7656,  7660,  7665,  7672,  7676,  7680,  7684,
    7688,  7694,  7695,  7702,  7703,  7707,  7708,  7711,  7723,  7727,
    7742,  7753,  7754,  7759,  7760,  7775,  7785,  7798,  7808,  7821,
    7831,  7844,  7852,  7854,  7856,  7861,  7863,  7868,  7869,  7874,
    7892,  7901,  7902,  7906,  7910,  7922,  7933,  7944,  7957,  7958,
    7959,  7963,  7975,  7976,  7986,  7998,  8002,  8006,  8010,  8017,
    8037,  8046,  8055,  8064,  8075,  8076,  8079,  8080,  8081,  8084,
    8085,  8088,  8098,  8107,  8124,  8133,  8142,  8151,  8160,  8169,
    8178,  8187,  8196,  8205,  8214,  8223,  8232,  8242,  8252,  8261,
    8270,  8279,  8288,  8298,  8308,  8318,  8328,  8338,  8348,  8358,
    8368,  8378,  8388,  8398,  8408,  8419,  8430,  8441,  8452,  8462,
    8472,  8483,  8494,  8504,  8514,  8522,  8531,  8540,  8549,  8558,
    8567,  8576,  8585,  8594,  8603,  8617,  8618,  8621,  8622,  8632,
    8640,  8649,  8657,  8674,  8683,  8692,  8701,  8710,  8719,  8728,
    8737,  8746,  8755,  8764,  8773,  8782,  8791,  8800,  8809,  8818,
    8827,  8836,  8845,  8854,  8863,  8872,  8881,  8890,  8908,  8917,
    8918,  8921,  8923,  8929,  8930,  8931,  8932,  8933,  8942,  8950,
    8958,  8966,  8974,  8982,  8990,  8998,  9006,  9014,  9022,  9030,
    9038,  9046,  9054,  9062,  9070,  9078,  9086,  9094,  9102,  9110,
    9128,  9147,  9148,  9152,  9156,  9176,  9183,  9191,  9199,  9216,
    9229,  9233,  9240,  9249,  9258,  9267,  9276,  9286,  9296,  9314,
    9322,  9338,  9355,  9356,  9357,  9362,  9368,  9377,  9378,  9379,
    9380,  9381,  9385,  9386,  9389,  9390,  9391,  9392,  9396,  9397,
    9398,  9410,  9420,  9421,  9424,  9433,  9439,  9458,  9465,  9472,
    9479,  9486,  9493,  9500,  9508,  9516,  9524,  9532,  9540,  9547,
    9554,  9563,  9564,  9565,  9569,  9572,  9575,  9578,  9581,  9588,
    9590,  9592,  9597,  9599,  9611,  9624,  9637,  9655,  9676,  9677,
    9678,  9679,  9689,  9705,  9715,  9716,  9720,  9721,  9725,  9729,
    9733,  9751,  9752,  9753,  9754,  9755,  9756,  9757,  9764,  9765,
    9776,  9783,  9790,  9801,  9818,  9825,  9841,  9858,  9864,  9880,
    9893,  9902,  9910,  9918,  9927,  9938,  9949,  9959,  9960,  9971,
    9981,  9992, 10003, 10014, 10025, 10034, 10046, 10047, 10061, 10084,
   10092, 10101, 10112, 10113, 10125, 10139, 10153, 10165, 10173, 10186,
   10187, 10191, 10192, 10193, 10194, 10195, 10208, 10218, 10231, 10232,
   10236, 10237, 10240, 10241, 10244, 10245, 10249, 10250, 10263, 10270,
   10280, 10287, 10297, 10298, 10299, 10300, 10301, 10302, 10303, 10304,
   10305, 10309, 10313, 10320, 10327, 10328, 10332, 10333, 10334, 10344,
   10354, 10355, 10359, 10360, 10361, 10362, 10372, 10379, 10396, 10415,
   10416, 10426, 10432, 10438, 10444, 10460, 10478, 10482, 10490, 10496,
   10503, 10509, 10516, 10525, 10526, 10530, 10532, 10537, 10548, 10558,
   10568, 10574, 10583, 10592, 10598, 10599, 10610, 10624, 10625, 10636,
   10647, 10648, 10651, 10652, 10653, 10654, 10655, 10656, 10657, 10658,
   10661, 10662, 10666, 10667, 10668, 10679, 10697, 10698, 10702, 10707,
   10731, 10742, 10743, 10753, 10764, 10767, 10768, 10769, 10770, 10771,
   10774, 10775, 10776, 10824, 10825, 10829, 10830, 10845, 10846, 10853,
   10861, 10869, 10877, 10885, 10893, 10904, 10905, 10932, 10946, 10961,
   10962, 10981, 10985, 10989, 11006, 11013, 11020, 11030, 11031, 11034,
   11046, 11047, 11051, 11063, 11071, 11076, 11081, 11086, 11091, 11099,
   11107, 11112, 11117, 11124, 11125, 11129, 11130, 11131, 11138, 11139,
   11143, 11144, 11148, 11149, 11153, 11157, 11158, 11161, 11170, 11183,
   11184, 11185, 11186, 11190, 11191, 11195, 11197, 11213, 11215, 11220,
   11223, 11228, 11229, 11237, 11257, 11258, 11260, 11265, 11266, 11270,
   11271, 11274, 11275, 11300, 11301, 11305, 11306, 11310, 11311, 11312,
   11313, 11314, 11318, 11331, 11338, 11345, 11352, 11353, 11357, 11358,
   11362, 11363, 11367, 11368, 11372, 11383, 11384, 11385, 11386, 11390,
   11391, 11401, 11407, 11425, 11426, 11430, 11431, 11437, 11442, 11450,
   11457, 11465, 11471, 11478, 11513, 11538, 11542, 11568, 11572, 11584,
   11597, 11611, 11622, 11637, 11643, 11648, 11654, 11661, 11662, 11670,
   11674, 11678, 11684, 11691, 11696, 11697, 11698, 11699, 11703, 11704,
   11716, 11717, 11722, 11729, 11736, 11743, 11754, 11755, 11768, 11772,
   11779, 11792, 11805, 11806, 11821, 11831, 11843, 11848, 11849, 11852,
   11853, 11856, 11857, 11862, 11863, 11868, 11869, 11877, 11882, 11883,
   11887, 11891, 11897, 11921, 11931, 11944, 11945, 11949, 11963, 12020,
   12034, 12036, 12041, 12043, 12045, 12047, 12052, 12054, 12059, 12067,
   12087, 12092, 12099, 12104, 12110, 12115, 12124, 12126, 12129, 12133,
   12134, 12135, 12136, 12137, 12138, 12143, 12163, 12164, 12165, 12166,
   12177, 12183, 12191, 12192, 12198, 12203, 12208, 12213, 12218, 12223,
   12228, 12233, 12239, 12245, 12251, 12258, 12280, 12289, 12293, 12301,
   12305, 12313, 12325, 12346, 12350, 12356, 12360, 12373, 12381, 12391,
   12393, 12395, 12397, 12399, 12401, 12406, 12407, 12414, 12423, 12431,
   12440, 12451, 12459, 12460, 12461, 12465, 12467, 12469, 12471, 12473,
   12475, 12477, 12482, 12487, 12493, 12501, 12506, 12513, 12520, 12524,
   12528, 12564, 12565, 12567, 12575, 12590, 12592, 12594, 12596, 12598,
   12600, 12602, 12604, 12606, 12608, 12610, 12612, 12614, 12616, 12619,
   12621, 12623, 12626, 12628, 12630, 12632, 12635, 12640, 12648, 12653,
   12661, 12666, 12674, 12679, 12688, 12696, 12704, 12712, 12730, 12738,
   12746, 12754, 12762, 12778, 12786, 12794, 12802, 12810, 12818, 12826,
   12830, 12834, 12838, 12842, 12850, 12858, 12866, 12874, 12894, 12916,
   12927, 12934, 12950, 12955, 12961, 12986, 12988, 12990, 12992, 12994,
   12996, 12998, 13000, 13002, 13004, 13006, 13008, 13010, 13012, 13014,
   13016, 13018, 13020, 13022, 13024, 13028, 13032, 13036, 13040, 13045,
   13061, 13062, 13063, 13078, 13112, 13114, 13116, 13127, 13151, 13162,
   13173, 13180, 13190, 13200, 13209, 13213, 13219, 13226, 13233, 13243,
   13250, 13278, 13313, 13324, 13325, 13332, 13338, 13342, 13346, 13350,
   13354, 13358, 13362, 13366, 13370, 13374, 13378, 13382, 13386, 13390,
   13394, 13398, 13400, 13404, 13413, 13418, 13425, 13440, 13447, 13451,
   13455, 13459, 13463, 13470, 13478, 13486, 13490, 13494, 13498, 13502,
   13506, 13512, 13516, 13525, 13529, 13533, 13538, 13552, 13554, 13558,
   13560, 13562, 13565, 13568, 13571, 13572, 13575, 13583, 13593, 13594,
   13597, 13598, 13599, 13604, 13608, 13612, 13616, 13627, 13628, 13632,
   13633, 13641, 13642, 13646, 13647, 13652, 13660, 13662, 13676, 13679,
   13706, 13707, 13710, 13711, 13722, 13740, 13747, 13756, 13773, 13818,
   13826, 13834, 13842, 13850, 13871, 13872, 13873, 13876, 13877, 13880,
   13883, 13884, 13885, 13888, 13889, 13892, 13893, 13894, 13895, 13896,
   13897, 13898, 13899, 13900, 13901, 13902, 13903, 13906, 13908, 13913,
   13915, 13920, 13922, 13924, 13926, 13928, 13930, 13942, 13946, 13953,
   13957, 13963, 13967, 13976, 13987, 13988, 13991, 13995, 13999, 14005,
   14006, 14011, 14015, 14022, 14023, 14024, 14025, 14026, 14027, 14028,
   14029, 14039, 14043, 14050, 14057, 14058, 14074, 14078, 14083, 14087,
   14102, 14107, 14111, 14114, 14117, 14118, 14119, 14122, 14129, 14139,
   14153, 14154, 14158, 14169, 14170, 14173, 14174, 14177, 14181, 14188,
   14192, 14196, 14204, 14215, 14216, 14220, 14221, 14225, 14226, 14229,
   14230, 14240, 14241, 14245, 14246, 14249, 14265, 14273, 14281, 14303,
   14304, 14315, 14319, 14346, 14348, 14353, 14356, 14359, 14361, 14363,
   14365, 14375, 14377, 14388, 14392, 14396, 14400, 14404, 14413, 14420,
   14452, 14456, 14462, 14469, 14473, 14477, 14483, 14484, 14486, 14487,
   14488, 14492, 14522, 14549, 14553, 14559, 14561, 14578, 14579, 14580,
   14585, 14586, 14587, 14592, 14593, 14594, 14595, 14601, 14602, 14603,
   14604, 14605, 14625, 14626, 14627, 14628, 14629, 14630, 14631, 14632,
   14633, 14634, 14635, 14636, 14637, 14638, 14639, 14640, 14641, 14642,
   14643, 14644, 14645, 14646, 14647, 14648, 14649, 14650, 14651, 14652,
   14653, 14654, 14655, 14656, 14657, 14658, 14659, 14660, 14661, 14662,
   14663, 14664, 14665, 14666, 14667, 14668, 14669, 14670, 14671, 14672,
   14673, 14674, 14675, 14676, 14677, 14678, 14679, 14680, 14681, 14682,
   14683, 14684, 14685, 14686, 14687, 14688, 14689, 14690, 14691, 14692,
   14693, 14694, 14695, 14696, 14697, 14698, 14699, 14700, 14701, 14702,
   14703, 14704, 14705, 14706, 14707, 14708, 14709, 14710, 14711, 14712,
   14713, 14714, 14715, 14716, 14717, 14718, 14719, 14720, 14721, 14722,
   14723, 14724, 14725, 14726, 14727, 14728, 14729, 14730, 14731, 14732,
   14733, 14734, 14735, 14736, 14737, 14738, 14739, 14740, 14741, 14742,
   14743, 14744, 14745, 14746, 14747, 14748, 14749, 14750, 14751, 14752,
   14753, 14754, 14755, 14756, 14757, 14758, 14759, 14760, 14761, 14762,
   14763, 14764, 14765, 14766, 14767, 14768, 14769, 14770, 14771, 14772,
   14773, 14774, 14775, 14776, 14777, 14778, 14779, 14780, 14781, 14782,
   14783, 14784, 14785, 14786, 14787, 14788, 14789, 14790, 14791, 14792,
   14793, 14794, 14795, 14796, 14797, 14798, 14799, 14800, 14801, 14802,
   14803, 14804, 14805, 14806, 14807, 14808, 14809, 14810, 14811, 14812,
   14813, 14814, 14815, 14816, 14817, 14818, 14819, 14820, 14821, 14822,
   14823, 14824, 14825, 14826, 14827, 14828, 14829, 14830, 14831, 14832,
   14833, 14834, 14835, 14836, 14837, 14838, 14839, 14840, 14841, 14842,
   14843, 14844, 14845, 14846, 14847, 14848, 14849, 14850, 14851, 14852,
   14853, 14854, 14855, 14856, 14857, 14858, 14859, 14860, 14861, 14862,
   14863, 14864, 14865, 14866, 14867, 14868, 14869, 14870, 14871, 14872,
   14873, 14874, 14875, 14876, 14877, 14878, 14879, 14880, 14881, 14882,
   14883, 14884, 14885, 14886, 14887, 14888, 14889, 14890, 14891, 14892,
   14893, 14894, 14895, 14896, 14897, 14898, 14899, 14900, 14901, 14902,
   14903, 14904, 14905, 14906, 14920, 14921, 14922, 14923, 14924, 14925,
   14926, 14927, 14928, 14929, 14930, 14931, 14932, 14933, 14934, 14935,
   14936, 14937, 14938, 14939, 14940, 14941, 14942, 14943, 14944, 14945,
   14946, 14947, 14948, 14949, 14950, 14951, 14952, 14953, 14954, 14955,
   14956, 14957, 14958, 14959, 14960, 14961, 14962, 14963, 14964, 14965,
   14966, 14967, 14968, 14969, 14983, 14984, 14985, 14986, 14987, 14988,
   14989, 14990, 14991, 14992, 14993, 14994, 14995, 14996, 14997, 14998,
   14999, 15000, 15001, 15002, 15003, 15004, 15005, 15015, 15016, 15017,
   15018, 15019, 15020, 15021, 15022, 15023, 15024, 15025, 15026, 15027,
   15028, 15029, 15030, 15031, 15032, 15033, 15034, 15035, 15036, 15037,
   15038, 15039, 15040, 15041, 15042, 15043, 15044, 15045, 15046, 15047,
   15048, 15049, 15050, 15051, 15052, 15053, 15054, 15055, 15056, 15057,
   15058, 15059, 15060, 15061, 15062, 15063, 15064, 15065, 15066, 15067,
   15068, 15069, 15070, 15071, 15072, 15073, 15074, 15075, 15076, 15077,
   15078, 15079, 15080, 15081, 15082, 15083, 15084, 15085, 15086, 15087,
   15088, 15089, 15090, 15091
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENT", "FCONST",
  "SCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTACH", "ATTRIBUTE",
  "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT",
  "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE",
  "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION",
  "CONFLICT", "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P",
  "CONTINUE_P", "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV",
  "CUBE", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE",
  "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DESC",
  "DETACH", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO",
  "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT",
  "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN",
  "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH",
  "FILTER", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN",
  "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "GROUPING", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IMPORT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX", "INDEXES",
  "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT",
  "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER",
  "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION",
  "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P",
  "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT",
  "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP", "LOCATION",
  "LOCK_P", "LOCKED", "LOGGED", "MAPPING", "MATCH", "MATERIALIZED",
  "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE",
  "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NO",
  "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR",
  "ORDER", "ORDINALITY", "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY",
  "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POLICY",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM",
  "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF_P", "REFERENCES", "REFERENCING", "REFRESH", "REINDEX",
  "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA",
  "RESET", "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE",
  "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P",
  "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER",
  "SESSION", "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW",
  "SIMILAR", "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SQL_P",
  "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN",
  "STDOUT", "STORAGE", "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING",
  "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESAMPLE",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIME",
  "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TRANSFORM", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING", "VACUUM",
  "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR",
  "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VIEWS",
  "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH", "WITHIN",
  "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES",
  "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST", "XMLNAMESPACES",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "XMLTABLE", "YEAR_P",
  "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA", "'<'", "'>'", "'='",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept", "stmtblock",
  "stmtmulti", "stmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "DropRoleStmt", "CreateGroupStmt", "AlterGroupStmt", "add_drop",
  "CreateSchemaStmt", "OptSchemaName", "OptSchemaEltList", "schema_stmt",
  "VariableSetStmt", "set_rest", "generic_set", "set_rest_more",
  "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "partition_cmd", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "ForValues", "partbound_datum",
  "partbound_datum_list", "range_datum_list", "PartitionRangeDatum",
  "AlterCompositeTypeStmt", "alter_type_cmds", "alter_type_cmd",
  "ClosePortalStmt", "CopyStmt", "copy_from", "opt_program",
  "copy_file_name", "copy_options", "copy_opt_list", "copy_opt_item",
  "opt_binary", "opt_oids", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem",
  "ExclusionWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_strategy", "part_params", "part_elem", "OptWith", "OnCommitOption",
  "OptTableSpace", "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "AlterForeignTableStmt",
  "ImportForeignSchemaStmt", "import_qualification_type",
  "import_qualification", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreatePolicyStmt",
  "AlterPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultPermissive",
  "RowSecurityDefaultForCmd", "row_security_cmd", "CreateAmStmt",
  "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerReferencing", "TriggerTransitions",
  "TriggerTransition", "TransitionOldOrNew", "TransitionRowOrTable",
  "TransitionRelName", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertStmt", "DropAssertStmt", "DefineStmt", "definition",
  "def_list", "def_elem", "def_arg", "old_aggr_definition",
  "old_aggr_list", "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "AlterEnumStmt", "opt_if_not_exists", "CreateOpClassStmt",
  "opclass_item_list", "opclass_item", "opt_default", "opt_opfamily",
  "opclass_purpose", "opt_recheck", "CreateOpFamilyStmt",
  "AlterOpFamilyStmt", "opclass_drop_list", "opclass_drop",
  "DropOpClassStmt", "DropOpFamilyStmt", "DropOwnedStmt",
  "ReassignOwnedStmt", "DropStmt", "drop_type_any_name", "drop_type_name",
  "drop_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_type_any_name", "comment_type_name", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type_any_name",
  "security_label_type_name", "security_label", "FetchStmt", "fetch_args",
  "from_in", "opt_from_in", "GrantStmt", "RevokeStmt", "privileges",
  "privilege_list", "privilege", "privilege_target", "grantee_list",
  "grantee", "opt_grant_grant_option", "GrantRoleStmt", "RevokeRoleStmt",
  "opt_grant_admin_option", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique", "opt_concurrently",
  "opt_index_name", "access_method_clause", "index_params", "index_elem",
  "opt_collate", "opt_class", "opt_asc_desc", "opt_nulls_order",
  "CreateFunctionStmt", "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "operator_with_argtypes_list",
  "operator_with_argtypes", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "CreateTransformStmt", "transform_element_list", "DropTransformStmt",
  "ReindexStmt", "reindex_target_type", "reindex_target_multitable",
  "reindex_option_list", "reindex_option_elem", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterOwnerStmt",
  "CreatePublicationStmt", "opt_publication_for_tables",
  "publication_for_tables", "AlterPublicationStmt",
  "CreateSubscriptionStmt", "publication_name_list",
  "publication_name_item", "AlterSubscriptionStmt", "DropSubscriptionStmt",
  "RuleStmt", "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "opt_transaction", "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "AlterCollationStmt", "AlterSystemStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "any_with", "CreateConversionStmt",
  "ClusterStmt", "cluster_index_specification", "VacuumStmt",
  "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_target",
  "insert_rest", "override_kind", "insert_column_list",
  "insert_column_item", "opt_on_conflict", "opt_conf_expr",
  "returning_clause", "DeleteStmt", "using_clause", "LockStmt", "opt_lock",
  "lock_type", "opt_nowait", "opt_nowait_or_skip", "UpdateStmt",
  "set_clause_list", "set_clause", "set_target", "set_target_list",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "all_or_distinct", "distinct_clause", "opt_all_clause",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value", "select_fetch_first_value",
  "I_or_F_const", "row_or_rows", "first_or_next", "group_clause",
  "group_by_list", "group_by_item", "empty_grouping_set", "rollup_clause",
  "cube_clause", "grouping_sets_clause", "having_clause",
  "for_locking_clause", "opt_for_locking_clause", "for_locking_items",
  "for_locking_item", "for_locking_strength", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "opt_alias_clause", "func_alias_clause", "join_type",
  "join_outer", "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "explicit_row", "implicit_row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,    60,    62,    61,   708,    43,    45,    42,
      47,    37,    94,   709,    91,    93,    40,    41,    46,    59,
      44,    58
};
#endif

#define YYPACT_NINF (-4754)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-2570)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    5606,    39, 11587, -4754, -4754,    39, -4754, 68896,   585,   156,
      54,   162, 12336, 69343, 76048,   599,   308, 12932,    39, 76048,
    1403, 53698, 65767,   871, 76048,  1106,   847, 53698, 76048, 76495,
    1040,  1354,   161, 76942, 69790, 64426,   974, 76048,  1603,   355,
   77389, 70237,  1491, 70684,   847, 50150,   140,  1460, 77836, 76048,
    1881,  1965,  1537, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754,   585, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,  1902, -4754,
    1080,  2011,  1412,   208,  1525, -4754, -4754, -4754, 62191, 76048,
   76048, 76048,  1795, 76048,  1737, 76048,   242, 62191, 58168, 71131,
    1875,  1739, 46568, 78283, -4754, 76048, 56380, 76048, 76048, 78730,
   76048, 76048, 76048,  1108, 67108, 76048,  1808, 76048, 76048, 56827,
   79177,  1974,  1213, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, 76048,  5826,  1106, -4754, -4754,  1881, 76048,
    1964, 62191, 76048,  1762, 79624,  1845, 76048, -4754, 76048,  1851,
   80071,   460,  1728, 58168,  1856, 47016,  1983, 76048, 76048, 58168,
   80518, 80965, 81412, 76048, 76048, -4754, -4754,  1912, 76048, 76048,
   -4754,  2081, 58615,  1427,  2085,  2240,  2155,  1239, -4754, 71578,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, 61297,   308,
   -4754, -4754,  2128, 62638, 76048,  2200, -4754, -4754, 81859, 96987,
    1993, -4754,   783, 63085, 59062,  2296,  1975, 47464,  2351, -4754,
   -4754, 59509, -4754, -4754, -4754, -4754, -4754, 82306, -4754, 82753,
    2088,  2200, -4754, 97420, 59956, -4754,  2223, 83200, 83647, 84094,
   -4754,  1990,  1243,  1531, 42512, -4754, -4754, -4754,   585, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754,   210,  1659,   231,
     212,   261, -4754, -4754,   213,   215,   218,   210,  2435,  2435,
   -4754, 76048, -4754, -4754,  1659,   676,  1997,  1997,  1997,  2208,
     853, -4754,  1997,  2157, -4754, -4754, -4754, -4754, 70684, -4754,
    2034,  1106,  2059,  2455,  2130, -4754, -4754, -4754, -4754, -4754,
    2139, 76048, 76048, 76048, -4754, -4754,  2553,  2160,  2403,  2162,
   -4754, -4754, -4754,  2349,  2356,  2365,   124,  1106,  2245, -4754,
    2489, -4754,  2384, 29681, 29681,  1106, 72025, 84541,   203, 61297,
    1106, 72472,  2209,  1136,  2390, -4754, -4754, -4754,   111, -4754,
    2621,  2229,  2458,  2162,  1213, 43861, -4754,  2226,  1539, 70684,
   -4754, -4754, -4754,   381,  2529, 31537, 76048,  2224, -4754,  2233,
    2224,  2228,  2236,  1412, -4754,  5606, 76048,  1282,  1282,  2651,
    1282,  1800,  1919, -4754,  2110, -4754,  2546,  2511, 70684,  2261,
     236, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754,  1580,  2262,  1539, -4754,   250, -4754,
    1433,  2252,  1690,   818, -4754, -4754,   911, 76048,   207,  2304,
   72919,  9238,  2263,  1539,  2275, -4754, -4754, -4754,  2424,   369,
   -4754, -4754, -4754, -4754,  2568,  2627,  7348,   317, 73366, -4754,
   -4754, -4754, -4754, 76048, 76048, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754,  2307,   710, -4754, -4754,  2313,  2649,
    2535,  1100,  2618,  2496,  1259,  2551,   151,  2678,  8595,  1422,
    1723,  1182, 73813, 76048,  2643,  2685,  7608,  1834,   955,  2566,
    1033,  2618,  2680,  2525,  1259,  2699, 11139, 76048, -4754,  2625,
    2736,   776, -4754,   241, -4754,  2441,  2589,   866,  2624, 62191,
    2400, -4754, -4754, 76048, -4754, -4754, 97853,  2488, -4754,   830,
   62191, -4754,  2607,  2461, 47912, 76048, -4754, -4754, 76048, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754,  2545,  2729, 76048, 97853,
   -4754,  2681, 76048, 76048, -4754,  2423, -4754, -4754, -4754, -4754,
    1997, 76048,  2426,  2830, 97853,  2645,   135, 76048,  1529,  2862,
   76048,  2650,  1529,  2470, 84988, -4754, -4754,  1529, -4754, -4754,
   -4754, 76048, 76048,  2439,  1347,  2644,  2755,  1529,  2663,  2873,
    2875,  2671,  2527,  2674,  2233,  2844,  2646,   980,  1400,   188,
    1559,  1529,  2507, 85435, 85882, 76048,  2509, 76048,  2853, 62191,
   76048,  2776, -4754,  2634, -4754, -4754,   266, -4754, -4754, -4754,
   -4754, -4754,  2790, -4754,   177,   251,  2791,  2472,  2794, -4754,
   -4754, -4754,  2521, -4754,  2521,  2521,  2478,  2478,  2653,  2481,
    2805, -4754, -4754, -4754,  1206,  2521,  2478, -4754, 98719, -4754,
     -11,  1398, -4754,   206, -4754,  2918, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754,  2487, -4754,  1014,  1738, -4754, -4754,
    2524, -4754,  2816,   239, -4754,  2820, -4754,  2493, 86329, -4754,
   86776, 87223,  2821,   354, -4754, 58168,  2822,  2493,  2823,   251,
    2825, -4754,  1028,  2814,  2827,   206,  2829,  1567,  2493, 61744,
    2832,   433, -4754,  2837,   453, -4754,  2838,  2710, 31537, -4754,
    2611, -4754,  1460, -4754,   909, -4754, 52804, -4754,  1531,  1659,
   -4754, 76048,  1659, 76048,  1659, 76048,  1659, 76048,  1659, 76048,
   76048, 76048,  1659, -4754, -4754, -4754, 76048,  2523, 76048, 76048,
   -4754, -4754, -4754, 66214, 58168, 66661, -4754, 76048, -4754,   144,
    1106, -4754, -4754, 97853,  2955, 58168,  2853, -4754,  1599, -4754,
   -4754, -4754, -4754, -4754, -4754,  2773, 76048,  2842,  2845, 66214,
   58168, -4754, 87670, 61297,  2738,  2541, -4754, -4754, -4754, -4754,
   -4754,  1778,  2990,   220,  3003, 31537,  2543,   220,   220,  2548,
    2855, -4754, -4754, -4754,   275,  2552,  2560, -4754,   227,   227,
   -4754,  2561,  2564, -4754,   247,  2567,  2569,  3012,  3014,   260,
    2575,  2576,  2577,  1206,   220, 31537, -4754,  2578,   227,  2579,
    2580,  2581,  3024,  2582, -4754,  3029,  2583,   211,   339,  2584,
    2590, -4754,  2561, -4754,   287,  2593,  2594,  2598,  2603,  2604,
    2608,  2609,  2610, 31537, 31537, 31537, -4754, 28289,  1539,  1106,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,   288,  5411,
   -4754,  2647, -4754, -4754,  2796, -4754, -4754, 31537, -4754, -4754,
     634, -4754,   289, -4754, -4754, -4754,  1539,  2874,  2613, -4754,
   -4754,   883,  2617, -4754,  1889, -4754, -4754, -4754, -4754, -4754,
   -4754, 60403,  3044, -4754,   314,  1106,   241,   297,  2987, 51910,
   52357, -4754, -4754,  2871, -4754, 76048, -4754, -4754, 31537, 49703,
   -4754,  1539,   153, -4754, -4754, -4754, -4754,  1610, -4754, -4754,
   -4754,   585, 11798,  1626,  2224, 76048, 76048,  3059, -4754, -4754,
   -4754,  2233, -4754, -4754,  1412,  1412, 31537,  1412,   235,  1237,
   30145, 32001,  2943,  2840,  1424,  1503,  2944, -4754,  2847,  1800,
    1919, 70684, 76048, 88117,  2757, 31537,  2722,  2723,  2778, 51044,
   -4754,  1539,  2725,  2695,  2730,  2782, 54592,  2652,  2735,  2737,
    2792, -4754,  2904, -4754, -4754,  2743,  2744, 88564, -4754, -4754,
     265, -4754, -4754, -4754,   265, -4754,  2677,  1465,   757,   255,
    2746,   424,  1038,  3051, -4754,  1148, -4754, -4754,  2800, -4754,
    6814, 76048,  2993, 11274,  2877,   317,  2879,  2806, -4754, -4754,
    2929,  2762, 76048,  2765,  2899,   317,   272, 89011, -4754, -4754,
   -4754, -4754, -4754, -4754,  5555, 27422, -4754,  1705,  2769,  2748,
    2779, 76048, 63532,   361,  2895,  2897,  1524,  1302,   192,  2834,
   76048,  1732,  2903, 76048,  2701,  2781,  2783,  2996,  2712,  1609,
    3093,  2709, -4754, -4754, -4754,  2042,  2043,  2902, -4754,  2995,
    3039, 11004,  2777,  2785, 95688, -4754,  2799,   925, 48360, 76048,
   76048,  2824,  2826,  2810,  2811,    18,  3087,  1185,  2812, -4754,
   -4754, -4754,  1185, 76048,  2819,  2828, 76048, 98719,   317, -4754,
    3148,   317,   317,  1959,  3150,  2833,   321,  2965,  2150,  1529,
    2709,  1932, -4754,  2835,  2836,   841, -4754,  2938,  2839,  2841,
    2876,  1106, -4754, -4754,  2849,  2906,  2851,   872, -4754, -4754,
    1253,  2846, 70684,  2925,  2926,   268,  2161,  2709, -4754,  2852,
    2854,  2712,  2712, 76048, 76048, 76048, 76048, 76048,   233,  3172,
    3174,  2859,   209,  2881,  2749, -4754,  1185, 57274,  2861, -4754,
    1185, 76048,  2863,  2169,  2709,  1660,   112, -4754, -4754, -4754,
    1213, -4754, 76048, -4754, 76048, -4754,  3015, 97853,  2952,  3018,
   -4754,  2798, -4754,  3021,   317, -4754, 76048, 76048,  3023,  2966,
    2968,  1094, 97853,  2974,  3036, -4754,  3043,  3045,  2865,  2843,
    2856, 51477, -4754,  2439,  2788,  3220,  3115, 76048, 54592, -4754,
    3245,   265, -4754, 97853,  3004,  3126, -4754, 76048,  3022,    55,
   -4754,  3163,  2872, -4754, -4754,    60, 76048,   257,  2878, -4754,
   -4754,  3138, 58168,   300,  3149,  1106,  2882,  3159,  3040,  1106,
   58168,  3077, 76048, 76048, 76048, 76048, -4754, -4754,  3047,   923,
     122, -4754, 57274,  3058, -4754, 76048,  3060,  1932,  3062,  3275,
     722,  1997, 89458,  3158, -4754, 89905,  2850,  3287, 97853,  3113,
   -4754,  1837, -4754,  2986, -4754, 62191, -4754, -4754, 62191, -4754,
   -4754, -4754, 97853, 76048, -4754,  2860, -4754, -4754, 31537, -4754,
   -4754, -4754,  2435, -4754, 97853,  2521,  2521, -4754, -4754,  3296,
    2946,  2947,  2435, -4754,  2435, -4754, 97853, -4754,  2870,  2884,
    2435,  2948,  2959,  2960, -4754,  2885,  2962,  2435, -4754, -4754,
    1821, -4754, -4754, 62191, 62191, -4754, 58168, 58168,  3194,   433,
    3205,  2945,  3209,  2950, 48360, 48360, -4754,   456, 58168, 76048,
   -4754, 76048, -4754, -4754, -4754, -4754, 97853, 97853, -4754, 58168,
   57274,  3211,  3212,   251, 76048, 76048, -4754, 76048, 76048, -4754,
   76048, 76048,  1747, 90352,  1531, 60850, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, 76048, -4754, 76048, -4754, 76048, -4754,
   76048, -4754, 76048, -4754, -4754, -4754, 76048, -4754, 76048,  1806,
   -4754, -4754,  1824,  1079, 76048, 76048,   767, 62191, 76048,  3098,
   76048, 76048, 76048, 76048, 76048,  2975,  2617,  1140, -4754,   801,
     278, 70684,  3106, -4754, -4754,  1831,  1881,  1130, 76048,   898,
    2139, -4754, -4754, 66661, 65767,  3201,   142, 76048, -4754, -4754,
    5028, 31537,  1539, 29217, -4754, -4754, 11798,  2939, 31537, 31537,
    2900,  2435,  2435, -4754,   368, 31537, 31537, 31537,  2435,  2435,
    3312, 31537, 48360, 31537, 36641, 25592, 31537, 31537, 28753, -4754,
   31537,  3125, 38021, 31537,   297,  3127, 31537,   297,  3312,  3357,
    3357,  1862,  5777,  2901,  1539, -4754,  2435,  1018, -4754,   425,
   97853, 31537, 31537, 31537, 31537, 54592,  2985,   240, 76048, 31537,
    2907,  1855, -4754, 31537, -4754,  2908, 31537,  2988,   846, 31537,
   31537, 31537, 31537, 31537, 31537, 31537, 31537, 31537, -4754, 39368,
     507,  3207,  3219,   819,   402, 74260, 29681,  3214, 24662, -4754,
     237,  3214, -4754, -4754, -4754, 76048,  3044, -4754, -4754,  2991,
   -4754, -4754, -4754, -4754, -4754,   294, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754,  2909, -4754, -4754, -4754, -4754,  2909, -4754,
    2915,  9262,  2913, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,  3210,
    3213,   251, 76048,   381, 67555, -4754, 31537, -4754,  1844,  2919,
   -4754,  3185, -4754,  2920, -4754,  9581,  3185, -4754, -4754, 37099,
    3037,  3182,  3128, -4754, -4754, -4754,  2923, 11798, 32465, 32465,
   -4754,  1717, 11798,  1888, -4754, -4754, -4754, -4754, -4754, -4754,
    1084, -4754, 76048,   677,  2943,  1503,  2984,  1195,  3362, 76048,
   -4754, 44310,  1846, 58168, 76048, 76048,  3131, -4754,  3353, -4754,
   98719, -4754,  2953, -4754, 98286, 94375, -4754, -4754,  1256, -4754,
     546, 58168, -4754, 76048, 76048, -4754, 54592, 58168, 76048, 76048,
   -4754, 58168, 76048, 76048, -4754, -4754, -4754, -4754, -4754, 53251,
      66, 65767,  3081, 64873, -4754, -4754,  2961, 76048,  3008,  3215,
    3216,  1208, -4754, -4754, 90799, -4754,  3173, 58168, 76048, 76048,
   31537,  3175, 76048, 76048, -4754,   547,  3032,  3046, -4754, 76048,
    3049,  3202, 62191,  2964, 76048, 76048, 97853,  3048,   836, 62191,
    3017, 48808, 76048, 76048, 76048, 76048,  3103,  3280, 97853, 76048,
    3232,  1410, 70684,   389,  2183,  2709,  3189, -4754,  3300,  1222,
   -4754, 58168, -4754, 76048,  3183, -4754, -4754, -4754, 74707,  3405,
    3095, -4754, -4754, 91246, -4754, -4754, -4754,  1858, -4754, 58168,
   58168, 76048, 12156, 91693,  1276,  3203, -4754, -4754, 97853, -4754,
   76048, 76048, 76048,  3308,  3237, 76048, 68002, 92140, 92587,  1030,
    1478,  3238, 76048, 68449,  3239, -4754,  3129, 76048, -4754, -4754,
   55039, 58168, 76048,   835, 54592, -4754, -4754, 76048, -4754,  3196,
     967, -4754, 76048,  9178, -4754, -4754,  3075,  3086, 76048,  3200,
     406,  2421,  2709, 76048, 76048,  2998,  1864, 58168, 76048, 54592,
   -4754,  3204,  1032, 70684, 70684, 58168, 76048, 70684, -4754, 76048,
   84541, -4754, 58168,   516, -4754,  3151, 58168, 76048, 10462, -4754,
   -4754, -4754,   317, -4754, -4754, -4754, -4754, -4754, 76048, 76048,
     317, 76048, 76048,   317,  1471, -4754, 58168, 76048, -4754, -4754,
   -4754, 58168, 76048, 76048, -4754, 58168,  2878, 76048, 54592, -4754,
   76048,  9736, 76048, 76048, 76048, 76048, 76048, 76048, 58168, 76048,
   -4754, -4754,  1191,  1320,  1557,  1597,   259, 76048,  3292, 76048,
   93034, 58168, 76048, 76048,  1106, 76048,   364, -4754, -4754,  3132,
   -4754, 58168,   516, -4754, 12429, 76048, 76048,  3085,  3088,   191,
    3167, -4754, -4754, -4754, -4754, -4754, -4754,   867,  3439, 93481,
     867, -4754,   867,  3274,  3071,  3072,   867, 76048, 76048, -4754,
   -4754, -4754, -4754,  3271, 76048,   867,   867,   867,  3186,  3221,
     765,  3299,  3034,  1868, -4754, -4754, 31537, 97853, 76048, -4754,
    1869, -4754,  3035,   923, -4754, -4754, 54592, 76048,   198,   804,
    3339,  3230, 63979,  3112,  3336, 76048,  3073, 76048,  3459,  3119,
   70684,  2439, -4754,  3112, 76048, -4754,  1796, 65767, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, 76048, -4754, -4754,  3340, 76048,
   31537,  3195, -4754,  1106,  2439,  2439,  2439,  2439, -4754, -4754,
   -4754, -4754,  3240,  1871, -4754,  3057,  2439, 76048,  3154,  3361,
    3112,  3064,  3370, -4754,  1932,  3371,   851, 76048,  3241, 63979,
    1922,  3097,  3277,  3496,  1997,  1106,  3281,  3268, -4754, 27855,
    7463,  3272,  3325, 61297,  3364,  3366,  3389, -4754,   177, -4754,
    3512, -4754, 31537,  1870,  3082,   206, -4754, -4754,  3084,  2884,
    3102,  3104,  3089,  3090, -4754,  2435,   194,  3091,  1176,  1015,
    3223,  2435,  3315,  3092, -4754,   239, -4754,  2493, -4754, 76048,
   -4754, 76048, 76048, 76048, 76048,   354, -4754, -4754,  2493,   251,
   -4754,  3348,   206,  2493,  3206,  3408, 61297, -4754,   433, -4754,
     453, -4754,  3301,   251, -4754,  3318,  1997, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754,  1887, -4754, 76048, -4754,  3385,
    3386,  3387,  3105,  3107,  3140, 76048,  3108,  3105,   317,  3105,
    2617,  2617,  3105,  3107, 57721,  3558,  3413, -4754,  3198,  3117,
    3424,   199, -4754,   200,   630,  3350, -4754, -4754, -4754, -4754,
   97853, -4754, 58168,  3161, 76048, 76048, -4754,   356,  3321,  3121,
   57721,  3541,   251, -4754, 62191, -4754, -4754, 97853,  3208,  3222,
   62191,  3337,  3177, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   97853, -4754,  3390, 76048, 76048,  1896, -4754, -4754,  1692, -4754,
    1710, 31537,   149, -4754, 10051,  1901, 31537,  3134,  3136, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754,  3137,  3443, -4754,  1916,
    1923,  1929,  3139,  3143,  2831,  3144, 10313,  3145,  3141, 36641,
   36641, 28289,  2084, -4754, 36641,  3146,  3338,  1931,  9722,  3147,
    3152, 10649, 30609, 31537, 30609, 30609, 10910,  3147,  3153,  1935,
   54592,  3328, 11172,  1939, -4754, 31537, 54592,  2883, 31537, -4754,
   31537,  3155, -4754, -4754,  4509,  4509,  4509,  3312, -4754,  3178,
   -4754, 36641, 36641, -4754,  1299, 28289, -4754, -4754,  3462, -4754,
   -4754,  1884, -4754,  3164, -4754, -4754,  2309, 48360,  6250, 31537,
     283, 31537,  2907, 31537,  3234,  4509,  4509,  4509,   393,   393,
     245,   245,   245,  1754,   402, -4754, -4754, -4754,  3166,  3168,
    3169,  3360,  3171, 31537, -4754,  2154,  2196, 76048,  3539,  4820,
    5385, -4754, -4754, -4754, 40267,  3218, 31537, 31537, 31537,  3181,
   -4754,  2267, 11798,   728, -4754,   299,  3218, -4754,  1213,  2435,
    1018, 52804, -4754, -4754, 31537, -4754, -4754, -4754,  2233, -4754,
   -4754, -4754, 11798, -4754,  1881, 31537, -4754, -4754,   939,  3187,
     632,  3373,  2189,  2189,  1717,  3375, -4754, -4754,  3225, -4754,
   31537,  2089, -4754,  2232, -4754, -4754, -4754, -4754,  2617, -4754,
    3415, -4754, -4754, -4754, 40267,  3226,  3233,  1518, 43411,  3388,
   -4754, 76048, -4754, 76048,   386, -4754,  3235, -4754, -4754, -4754,
   -4754, -4754, -4754, 94375,  1738, -4754, 98286, -4754, 98286, -4754,
    1738,  3598, -4754, 94375,  1682, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, 58168, 58168,
    3391, 76048,  3384,  3392, 31537,   779, 76048,  3197,  3227,  1380,
    3467, 76048, -4754,  3515,   251, -4754, -4754,  3286, -4754, 11798,
   -4754, -4754, -4754, -4754, -4754, 58168, 76048, -4754, 61297, -4754,
   76048, -4754, 97853, -4754, -4754, -4754, 76048,  3228, 76048, -4754,
   76048, 76048, 76048, -4754, -4754, -4754, -4754, -4754,  1137, 97853,
   -4754, -4754, 76048, 76048,   147,  3288,  3290, 76048, -4754,  1118,
    2938, 12590, 76048, 76048, 76048,  3468, 76048, -4754, -4754, -4754,
   -4754,  3422, -4754, -4754, 94375, -4754,  2493,  1346,  3313,  2709,
    3448, -4754,  3560,  3436, -4754,  1034, -4754, 76048,  3367, -4754,
   -4754, -4754, -4754,  3564,   251,  3566,   251, 76048, 76048, 76048,
   76048,  3374, -4754, -4754, -4754, -4754,  3376,  3492, -4754, 54592,
   54592, 54592,  1945, -4754, -4754,  1106, -4754, -4754, -4754, -4754,
   -4754, -4754,  3526, -4754,  1949, -4754,  1442, -4754, -4754, -4754,
   -4754, -4754, -4754, 58168, 76048, 12765,  3571, 76048, 76048, 76048,
    1840, -4754,  1186, 97853, -4754, 96121, -4754, -4754,  1976, -4754,
    3264, 76048,  3334, 58168,  3314,  3252,  3252, -4754, -4754,  3252,
   -4754, -4754, -4754,  3501,  3438, -4754,   890,  3440, 58168,  3322,
   -4754,  3341, -4754, -4754,  3344,  2475,  2709,  1932, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754,  1278, -4754, -4754,  1364,   455,  2482,  2709,
   -4754,  3576, -4754,  3347, -4754,  3349, -4754, -4754, -4754,  3503,
    3507,  3508,  3355,  3356,  3410,  3363,  3365,  3411, -4754,  3368,
    3412,  3369,  3417,  3478,  3372,   251, 97853,  3506,  1106,  3409,
    3609,   251, -4754,  3377, -4754,  3393, -4754,  3718, -4754, 76048,
   -4754,  3394,  2549,  2709, -4754, -4754, 58168, 76048, -4754, -4754,
   -4754, -4754, -4754, -4754, 97853, 76048,  3557, -4754, -4754,   867,
   76048, 76048, -4754,  3569,  3572, 76048,  3573, -4754, -4754, -4754,
   -4754,   447, -4754, -4754, -4754,  3186,  3604, 45660, -4754,  3779,
    6071,  3316,   392, -4754, 54592, 45660,  1961,  1776,   343,  1529,
   -4754, 61297, 76048, 61297, -4754,   804,  3436, 76048, 76048, 76048,
    3317,  3320, -4754, -4754, -4754, -4754, 58168,   196, 58168,  2435,
   -4754, -4754,  3399, -4754, 76048,  1997,  3782,  3631, -4754,  3252,
   -4754,  3756,  2875,   300,  3480,  1440,  2527,  3699,  2233,   397,
   54592,  3097, -4754, -4754, -4754, -4754, 76048, 76048,   923,  1106,
   -4754,  3345,  3351, -4754, 76048,  3647, 76048, 76048, 76048, 76048,
    3161,  3342, 76048,  3359, 97853,    75,  3543,  3551,  2712,  3783,
    3675,  1881,  3097,  3437,  3678, 76048, -4754,  1978,   127, -4754,
    1106, 61297, 95255,  3670, -4754,  3649, -4754, -4754,   820, 76048,
    3655, -4754, -4754,  1881, -4754, 97853,  1984, -4754, -4754, -4754,
    2435, -4754, -4754,  1629,  1629,  3380, -4754,  3381, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754,  3382, -4754, -4754, -4754,   433,
    3419,   251,  3420,   251, -4754, -4754, 76048, -4754, 76048, 57274,
     251, -4754, -4754, 76048, -4754,  3687, -4754, -4754,  3497,  3498,
    3499, 76048,  3105, -4754,  3378, 58168,  1352, -4754, -4754,  3568,
   -4754, -4754, 70684,  3493, -4754, -4754, -4754, -4754,  3697,  3698,
   -4754, -4754, -4754,   817, -4754, -4754, -4754, 58168, 66214,   475,
   58168, -4754,  3636,  3641, -4754, -4754,  3644,   317, -4754,  3656,
   -4754,  3657,  3659, -4754, -4754, -4754,  3403, 11295, 31537, -4754,
    3735, 97853, -4754,  6392, -4754, -4754, -4754, 31537, -4754, -4754,
   -4754, -4754, -4754, 31537, -4754, 31537,  3710, -4754, 26057,  3862,
    3862,  3404, 97853, 36641, 36641, 36641, 36641,  1540,  2579, 36641,
   36641, 36641, 36641, 36641, 36641, 36641, 36641, 36641, 37563,   448,
   -4754,  3600, 31537, 31537,  3721,  3710, -4754, 97853,  3431,  3147,
    3432,  3434, 31537, -4754, -4754,  1998, 38470,  3441, 54592, -4754,
   31537,  9757,  1999,  3454, 11673,  1539,  6565,  1106, 31537,  2214,
    2804, 31537,  2003, 31537,  3717, -4754, -4754, -4754,  3414, -4754,
   -4754, 97853, 31537,  3442,  2347, 36641, 36641,  2818, -4754,  3993,
   31537, 28289, -4754,  3610,  3460, 44759, -4754, 26522,  3421,   847,
     847,   847,   847, -4754, 76048, 76048, 76048, 40716,  3725,  3444,
   39817, 75154,  3446,  1996, -4754, 75154, 75601, 75154, -4754,  3450,
   -4754,  3447,  1539, 31537,  3733,   755,   755,  3610, -4754, 31537,
   31537, 31073,  3445, -4754,  3733,   241,  3451, -4754, -4754, 11798,
    3449, -4754,  3452, -4754,  3455, -4754,  3187,  1134, -4754, -4754,
   -4754,  3639, -4754, -4754, -4754, -4754,  3446, 32929,  3592, -4754,
   -4754, -4754,  3505,  2008, -4754, -4754,  3842,  3592, -4754, -4754,
    2009, 44310,  3226, 31537,  1539,  2013,  1816, -4754, -4754, 94375,
   -4754,  3527,  2493,  2493,  1071,  3105,  3769,  1071,  6611, -4754,
   -4754, 41165, 76048, 76048, -4754, 76048,  2014,  1526, 76048, -4754,
   76048, -4754, -4754, -4754, -4754,  3893, -4754, 76048, -4754, -4754,
    3519,  3524, 76048, 76048, 76048, 76048,  3723, -4754, -4754,  2252,
   -4754, -4754, 58168, 76048, -4754, -4754, -4754,   422,  2622,  2709,
   -4754,  3549, -4754, -4754, -4754,  3741, -4754,  3885,  3561, 76048,
    3794, 76048,  3477, -4754,  1526,  3781,  1327,  2712,   321,  5203,
   -4754,  1247, -4754, -4754,  3547, -4754, -4754, 76048, -4754, 76048,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754,  3607, -4754, -4754,
   -4754, -4754, 55039, -4754, -4754, 76048, -4754, 54592, 45660, 54592,
   -4754,  1414,   430,  2626,  2709, 76048, -4754,  3562, -4754,  3563,
    3565,  3615,  1178,   726,  3570,  3574,  3617,  3495,  3509,  3510,
   -4754, 54592, 46120,  3627, 76048,  2493,  3504,  3530,   210,  1106,
   -4754, -4754,  1106,  2493,  1106, 76048, 76048, 76048, 54592, -4754,
    3910,  3585, 76048, 76048, 76048, 76048,  3556, -4754, 76048, 76048,
    3816,  1105,  1720, 58168, 76048, 76048, 58168, 76048, 76048, 76048,
   76048, 76048, 76048,  3827, 76048, -4754,  3907,  3834,  2083,  3876,
    3584, 76048, -4754, 76048,  1106,  2938, 76048, 76048, -4754, -4754,
    3516,  3780,   867, -4754,  3786,  3788,   867,   867,  3789,   867,
   -4754, -4754,  1529, -4754,   447, 76048, -4754,  3455,  2042,  2043,
   -4754, -4754, -4754, -4754, -4754, -4754,  3034, -4754, -4754,  1960,
   76048, -4754, -4754, -4754, 76048,  3521, 76048, 76048, 36641, -4754,
    1553,  1214,   248, -4754,  3775, 76048,  2878, -4754, -4754, -4754,
    3688, 76048, -4754, -4754, -4754, -4754, -4754,    63,  3342, -4754,
    3797, 63979,  2493, 58168, 58168,  2493, -4754, 97853,  3531,  3097,
   -4754,   786,  3612, 58168,   300,  1548, 93928,  2882,  3567,  3730,
   40267,  1278, -4754,  3532,  3692, -4754,  3542,  3544, -4754, -4754,
   76048,  3436, 57274,  2020,  1932,  3977,   773,  1990, -4754, 65320,
    3728,  3342,  3797, -4754, -4754, -4754,  3939,  3640, -4754,  1881,
   76048,  3161,  3640,  1106, 76048,  3008, -4754, 94375, 31537, 31537,
   -4754,  3552, -4754,  3555,  8499, -4754,  3628,  3575, -4754, -4754,
   -4754, -4754, -4754, -4754,  3648,  3577, 76048, -4754,  3559, -4754,
    3582, -4754, -4754, -4754, -4754, -4754, -4754, 76048, -4754, 76048,
   -4754,   251, -4754,  3681, -4754,   251, 76048, 76048, 76048, 76048,
    3105,   317, -4754,  3860, 57721, -4754, -4754,  2021, 76048, -4754,
   -4754, -4754,  3930,   142,  3874, -4754, -4754,   910,   910,   910,
    3831,   910,   910,   910, -4754, 31537, 11798, -4754,  3581, -4754,
   11798,  6989, 11798,  3721, -4754,  2025, 31537, -4754,  2415,  2415,
    2415,  3050,  3880, -4754,   810,  3583,  2415,  2415,  2415,   415,
     415,   217,   217,   217,  3862,   448, 11798, 11798, -4754, -4754,
    3586, -4754, -4754, -4754,  3147, -4754, 33393,  3727,  3997, -4754,
   -4754, -4754,  3624,  3625,  3589, -4754, 31537, 33857,  3588, 98719,
    3790, -4754,   961, 31537, 31537,  2563, -4754,  7073, 31537, 97853,
    2031,  2563,   524, 31537,  3435,  3654, 31537, 31537,  4140,  7251,
    3593, 31537, 94808, -4754, -4754, -4754,  2032, 31537, 76048, 76048,
   76048, 76048, -4754, -4754, -4754, 75154, 75601, 75154,  3599, 38919,
   26972,  1996,  3601, 76048, -4754, -4754,  3603, 40267,  3857,  3795,
   -4754, 40267,  3795,  1725,  3795,  3863,  3693, 45208, -4754, -4754,
    3608, -4754,  3802, -4754, 24662,  1705, 11798,  4026,  3909, 31537,
    3614,  3618,  3619, 11798, 11798, 31537, -4754,  1106,  3909,  1106,
   -4754, -4754, 48360, -4754, -4754, -4754, -4754,  3823, 11798, 29681,
   -4754,  1881,  2358, 76048,  1539,    69, -4754,  3632, 76048, -4754,
    3592, 11798, -4754,  3694,  2033, -4754, -4754, -4754, -4754, -4754,
   -4754,  3705, 65767,  3931, -4754, 31537,  2046, -4754,  3666,  4027,
     263,  2048,  2050,  1526, -4754,  2878, -4754,  1481,  3911,   171,
   -4754,   251, -4754, 97853, -4754, 76048, 76048, -4754, -4754, -4754,
   -4754, 76048,  2652, -4754, -4754, 76048, 76048, 76048, 76048, -4754,
   58168, 76048, -4754, 76048, -4754, 54592,  1776,  1553,  3918,  3843,
   -4754,   317, -4754,  1553,  3844,   210, 76048, -4754, -4754,  1633,
   -4754, 97853,   251,   251, -4754, -4754, -4754, -4754, -4754,  3650,
    4050,  3731, 76048, 76048, 76048, -4754, 76048, 58168, 76048, 76048,
    2435,  2435, 97853,  3634, -4754,  2435,  2435,  3651, -4754, 58168,
   76048, 76048, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, -4754, -4754,  3719, -4754, 31537,  4053, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, 58168, 76048,  3732, -4754,
    3737, -4754,  1839, -4754, -4754, 76048, 76048, 76048, 76048,  3980,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   76048, -4754, 76048, -4754, -4754,  1106,  1106, 97853,   251,   251,
   -4754, -4754, -4754, -4754,  3916,   867, -4754,   867,   867, -4754,
   -4754,   867, -4754,  3660,   482, -4754,  1526,  1798,  3963, -4754,
    3966, 31537, -4754,  1161,  3050, -4754,  4018,  4095, -4754, -4754,
   -4754, -4754,  2878,  1997,  3729, 62191,   344, -4754,  3952,   198,
    3877, 63979,  3576,   905,  3674,  3796, -4754,  2493,  2493,  3734,
   76048,  4106, -4754, -4754, -4754, -4754, -4754, -4754, 58168,  3314,
   -4754,  3892,   811,  3986, 76048, 31537,  3446, -4754,   182,  3989,
   -4754,  1106, -4754, -4754,  3801,  3097, -4754,  1168, 76048,  3889,
   63979,  3161,  2054, -4754, -4754, -4754,  3736,  4099,  1922, -4754,
    3576,  3728,  1298, 76048, -4754,  3738,  4122, -4754, -4754,  3996,
    3894,  3695, -4754, 11798, 11798,  1106, 99152,  3649, 97853,  4002,
   76048,   798,  3969,   251, -4754,   251,   251, -4754, 76048, -4754,
    3105,  3105,  3105, -4754,  3895, -4754, -4754,  3959, -4754,   251,
   57721, -4754, -4754, -4754, -4754, -4754,   910, -4754, -4754, -4754,
   11798, -4754, -4754, -4754, -4754,  7413, 36641,  4006, -4754,  3706,
   97853, -4754,  3708,  2056,  2090, 38021,  3864, -4754, -4754, -4754,
    7453,  3761, 11798,  3809,  3716,  3722,  2563,  2563,  7073,  2091,
   -4754,  2563, 31537, 31537,  2563,  2563, 31537, -4754, -4754,  7747,
    3901, -4754, -4754,  8057, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754, 55486,  3711,  3328, 75154,  3724, 76048,  1996, 40267, -4754,
   -4754,  1608, -4754, 40267,  3979, -4754, 40267, 62191, -4754, 76048,
    3726, 76048, -4754,   728, 34321, 31537,  3763, -4754, -4754, -4754,
    3610, -4754,  3763, -4754,  3739, 76048,  2613, -4754,  1518, -4754,
   -4754,  4110, 41165,  4071, 31537, -4754, -4754, -4754, -4754, 57721,
    3933, 57721,  1526,  8123,  2878, 41165, 49256, 76048, 76048, 76048,
    3888,  2878,  3729, -4754, -4754, -4754, -4754, -4754, -4754,  3740,
   -4754, -4754, -4754, -4754,  3814, -4754, -4754,   582,  3106, -4754,
    2096, -4754,  4167,  4058, -4754, -4754, -4754, -4754, -4754, -4754,
    3907, -4754, -4754, 45660, 58168, 76048, -4754,  3817, -4754, -4754,
   -4754, -4754, -4754, 42962, 48360, -4754,  1178,  3742,  3743,   726,
   -4754, -4754, -4754, 76048,  8151,  3744,   970,  3106, 76048, 76048,
    3746,  3747,  1509,  1260,  1581,  3105,  4048, -4754, -4754, -4754,
   -4754,  3907, -4754, -4754,   867, -4754, -4754, -4754, -4754, 54592,
   -4754,  2250, -4754,  1529,  4097, 62191,  4181,  4181, 76048, -4754,
    8353,  3961, -4754, -4754,  4041,  3729,  3987,  4033, -4754,  3757,
   76048,  3921,  3758, 76048,  3759,  3879,   994,   994, 76048, 76048,
   76048,  2102,  1881,  2493,  3530,   300,  4082, 63979,  4125,  3436,
     400, -4754, -4754,   182, -4754,  1107,  4103,  3805, -4754, 76048,
    4206, 76048,  3161,  3342, 76048,  3776, -4754, -4754, 65320,  3976,
    1776, 24047,  3551,  3728,  1922,  3914, -4754,  3915, -4754,   271,
   -4754,  1881, 76048, 76048, 41165, -4754, 98286, -4754,  2103, -4754,
   -4754, -4754,  3852,  3218,  3897,  3903,  3787, 76048,   997, -4754,
   -4754, -4754, -4754, -4754, 76048, -4754,   475, -4754, -4754,  4046,
   36641, 97853,  2121, 31537, -4754, 31537, -4754,  4200, -4754, -4754,
   -4754,   795, -4754, -4754, -4754,  2563,  2563,  2563, -4754,  4211,
    3610, -4754, -4754,  2127,  4231, 35713,  4193, -4754, 76048,  2134,
   -4754, 31537,  3806, -4754, -4754, 40267,  1608,  3810,  2138, 76048,
    2153, 97853,  3804,  3811,   903,  3818, 25127,  3798, -4754, -4754,
   -4754, -4754, -4754, 11798, 11798, 76048, -4754,  3808, -4754, -4754,
   -4754,  3867, 76048,  2159, -4754,   103, 11798,  1352,  1071,   475,
    4027,  3729, -4754,  3822, -4754, -4754, -4754,   949,   949, 76048,
    3729, -4754, -4754, 76048,  3904, -4754, -4754, 54592,  4111, -4754,
    3884, -4754,  1055,  3106, 76048, 97853, -4754,   133,  4139, -4754,
   97853, 97853, -4754, -4754, -4754, 31537,  3919, -4754, -4754, -4754,
     267,   617, -4754, -4754, 76048, 76048, 76048, 76048, 76048,   251,
   -4754,  2171, -4754, 42063, -4754, -4754,  2862,  1106,  2862,   163,
   -4754, -4754,  2862, -4754,  2862, -4754,  3660,  1106,  4181,   307,
   -4754, -4754, -4754,  1674,  4051,  3835, -4754,   823,  4039,  3928,
    3846, -4754, 62191,  4304,  3342,  3797, 76048, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754,  2172,  3436,  4160,
    3097,  3738, -4754, 76048,  3882, -4754, 40267, -4754, -4754, -4754,
    2862, -4754,    76,  3850,  4174,  3436,  1881,  1990, -4754,  3728,
    3342,  3797, -4754, -4754, -4754,  3853, -4754,  3640,  1922,  3551,
   -4754, -4754,  4256,  4054,  4257,  3161, -4754,  3008,  2173, -4754,
    8499, 99152, 97853,  4198,  3898,  3900, -4754, -4754,  3912, 76048,
   -4754, -4754,  3436, -4754,  4046,  2177, -4754,  2178,  2190,  4020,
    3917, -4754, 31537,  1644,  3450, 55486,  3868, -4754, 36641,  2212,
   -4754,  3778, 76048,  2217, -4754, 11798, 76048, -4754, -4754, 31537,
   -4754,  2219, -4754, -4754, 31537,  3870, 31537, -4754, 34321,  3869,
   -4754,  4298, -4754,  1881, -4754,  3218, 41165, -4754,  3988, -4754,
    4176, -4754, 76048,  3920, 48360,  3187,  3187,  1997, -4754,  1526,
   -4754, 76048, -4754,  3835, 31537, -4754,  3962, -4754, -4754,  2242,
    1495,  4031,  4031,  2247,  2249,  8677, 76048, -4754, -4754, -4754,
   -4754, -4754, -4754,  2254, -4754, -4754, -4754, -4754,  2255,  3107,
    1581,  3107, -4754,  3105, -4754, -4754, 54592, -4754, 55933, -4754,
   -4754, -4754,  1106, -4754,  1106,  4086, 76048, 50597,  1106,  1106,
   -4754, -4754, -4754, -4754, -4754,  4212,  4155, -4754,  1932, -4754,
   -4754, -4754, -4754,   719, -4754,  4085,  4087, 76048, -4754,  3886,
   -4754,  2268,  3576,  4008,  3436, -4754, -4754, 76048,  4313,  4320,
   -4754,   920, 76048,  3446, 76048, -4754, -4754, -4754, 31537,  4055,
   -4754,  3738,  3161,  1922,  3576,  3728,  1776, 41614, -4754,  3551,
    3640,  4088, -4754,  4089, -4754,  3899,  3097,  3649, -4754, -4754,
     858,  4195,  4203, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754,  3147, 34785, 34785,  3902, -4754, -4754, 76048,  3050,  3905,
   35713, 54592,  2280, -4754, 96554, -4754,  2284,  2295, -4754,  2315,
   34321,  2316, -4754, 76048,  3906, -4754, -4754, -4754, 44310, 57721,
     949,  3908, -4754,  3913, -4754, -4754,  3987,  1526,  3106, -4754,
   11798, 76048, 62191,  4311, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754,  3106,  3983,   267, -4754,   617, 76048, -4754, -4754,  2321,
   -4754, -4754, -4754, 76048,  3532, -4754,  3532, -4754, -4754,  4044,
   -4754,   986,  1092,  1092,  4255, -4754,  3965, -4754, -4754,  3922,
   -4754,  4372,  4032, 76048, -4754, -4754,  1178,  1881, 63979,  3436,
   -4754, -4754,  8715, 62191, -4754, -4754,  3551,  3728,  1922, 31537,
    2322, -4754,  4027,   263,  3640, -4754, -4754, -4754, 41165,  3640,
   -4754, -4754, -4754,  2655, 62191, 62191, 36177,  4047,   958,  9933,
   -4754, -4754, -4754, -4754,  2323, 38021, -4754, -4754, -4754, 76048,
    4108,  1234, -4754,  4066, -4754,  2328, -4754, -4754, -4754,  1172,
     475,  3187, 31537,  1526, -4754,  4039, -4754,  3106, -4754, 76048,
   -4754,  3924, -4754, -4754, -4754, -4754, 55933,  3532,  3805, -4754,
   -4754,  4365, -4754,   258, -4754, -4754, -4754, -4754, 76048,  3436,
    3634,  3738, -4754, -4754,  3926,  3640,  1922,  3551,  8755, -4754,
   41614, 76048, 76048, -4754,  2332,  3218, -4754,  2294, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754,  3925,  3927,  4355, -4754, -4754,
   -4754, -4754, -4754, -4754,  3328, -4754, -4754, 36641, 36641,  4132,
   -4754,  1234, -4754,  3932, -4754, -4754, -4754, -4754, -4754,  9017,
   -4754, -4754, -4754,   267, -4754,  4252, -4754, -4754, -4754,  3436,
   -4754, -4754, 54145, -4754,  3551,  3640,  4027, -4754, -4754, -4754,
    3097, -4754,  1967, -4754, -4754,  2113,  2236,  4012,  4238, 35249,
    4327,  3050,  3050, -4754, -4754, 31537, -4754,  1526,  2346,  4102,
   -4754, -4754,  2355, -4754, -4754, -4754, -4754,  3640, -4754, 76048,
    3640, -4754,  2294,  4045,  4049, -4754, 76048,  9051, -4754, 62191,
   -4754, 54145, -4754, -4754,  3218, -4754,  3975,  3981,  2389, -4754,
    3945, -4754, -4754,  4248,  4249, -4754, 54145, 62191, 62191,  2412,
   -4754, -4754, -4754
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
    1621,  1403,   620,  1489,  1488,  1403,   253,     0,  1491,     0,
    1403,   416,  1095,     0,     0,     0,     0,   620,  1403,     0,
    1621,     0,     0,     0,     0,     0,  1634,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1403,     0,     0,  1641,
       0,     0,     0,     0,  1634,     0,  1493,     0,     0,     0,
       0,     0,     2,     4,    71,    72,    31,    30,    91,    54,
      18,    62,   125,   124,   126,    41,    37,    79,    26,    28,
      38,    42,    64,    66,    44,    55,   103,    63,    24,    61,
      86,    67,    89,    49,    12,    13,    50,    14,    51,    15,
      52,    16,    99,    73,    92,    35,    60,    23,    43,    69,
      70,     5,    45,    81,    77,    11,    56,    57,    59,    83,
      84,    85,   108,    87,   120,    40,   117,    96,    97,   114,
      98,   115,     9,   100,    53,    17,   111,   110,   112,    80,
      46,    82,    68,    90,   109,    27,   113,    19,    20,    22,
      21,    58,    29,    65,    32,    88,   116,   106,   102,   121,
     119,   127,   104,    74,     7,     8,    93,     6,    25,    48,
      10,    34,    33,    47,    39,   123,    36,  1491,    95,   107,
      94,    75,   101,    78,   105,   122,    76,   118,  1594,  1593,
    1643,  1597,  1620,     0,  1609,  1402,  1401,  1387,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   619,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1413,  2217,  2232,  2233,  2234,  2235,  2236,  2237,
    2238,  2239,   387,  2240,  2241,  2242,  2243,  2244,  2245,  2246,
    2247,  2248,  2249,  2250,  2514,  2515,  2516,  2517,  2251,  2252,
    2253,  2254,  2255,  2256,  2257,  2518,  2519,  2258,  2259,  2260,
    2261,  2262,  2520,  2263,  2264,  2265,  2266,  2267,  2268,  2269,
    2270,  2271,  2272,  2273,  2274,  2275,  2276,  2277,  2278,  2279,
    2280,  2281,  2282,  2283,  2284,  2285,  2521,  2522,  2286,  2287,
    2288,  2289,  2290,  2291,  2292,  2293,  2294,  2295,  2296,  2297,
    2298,  2299,  2300,  2301,  2302,  2303,  2304,  2305,  2306,  2307,
    2308,  2309,  2310,  2311,  2312,  2523,  2313,  2314,  2315,  2524,
    2316,  2317,  2318,  2525,  2319,  2320,  2321,  2322,  2323,  2324,
    2325,  2326,  2526,  2527,  2327,  2328,  2329,  2330,  2331,  2332,
    2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,
    2343,  2528,  2344,  2345,  2346,  2347,  2529,  2530,  2531,  2348,
    2349,  2350,  2351,  2352,  2353,  2354,  2355,  2532,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,  2366,  2367,
    2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,  2533,  2534,
    2376,  2377,  2378,  2535,  2379,  2380,  2381,  2536,  2382,  2537,
    2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,  2391,  2538,
    2392,  2539,  2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,
    2401,  2402,  2403,  2540,  2404,  2541,  2407,  2405,  2406,  2408,
    2409,  2410,  2411,  2412,  2413,  2414,  2415,  2416,  2542,  2417,
    2418,  2419,  2420,  2421,  2422,  2423,  2424,  2425,  2426,  2427,
    2428,  2429,  2430,  2431,  2432,  2433,  2434,  2435,  2436,  2437,
    2543,  2438,  2439,  2440,  2441,  2442,  2443,  2444,  2445,  2446,
    2447,  2448,  2449,  2450,  2451,  2452,  2453,  2544,  2454,  2455,
    2456,  2457,  2545,  2458,  2459,  2460,  2461,  2462,  2463,  2464,
    2465,  2466,  2467,  2468,  2469,  2470,  2546,  2471,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2547,  2548,  2479,  2480,  2549,
    2481,  2550,  2482,  2483,  2484,  2485,  2486,  2487,  2488,  2489,
    2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,  2551,
    2552,  2499,  2500,  2501,  2502,  2503,  2504,  2505,  2506,  2507,
    2508,  2509,  2510,  2553,  2554,  2555,  2556,  2557,  2558,  2559,
    2560,  2561,  2562,  2563,  2511,  2512,  2513,   386,  1584,  2185,
    2218,  2219,  1490,  1470,   620,     0,  1390,   415,  1621,     0,
       0,     0,     0,     0,     0,     0,     0,   848,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     176,     0,     0,     0,     0,   441,   440,     0,     0,     0,
    1068,   446,     0,     0,     0,     0,     0,   608,  1533,  2405,
    1531,  1585,   254,   257,   258,   255,   256,  2207,     0,  1190,
    1191,  1193,     0,     0,     0,  1203,   888,   889,     0,     0,
       0,   897,     0,     0,     0,   886,     0,     0,     0,   902,
     899,     0,   903,   900,   883,   901,   890,     0,   882,     0,
       0,  1203,   904,     0,     0,   884,     0,     0,     0,     0,
    1391,  1530,   447,  1621,     0,  1507,  1508,  1509,  1491,  1498,
    1510,  1503,  1505,  1504,  1506,  1502,  2206,  2233,  1008,  1008,
    1008,  1008,  1005,  1006,  1008,  1008,  1008,  2424,     0,     0,
     987,     0,   989,  2208,  1008,  1013,   508,   508,   508,     0,
    1012,  1017,   508,     0,  1384,  1422,  2190,  1633,     0,   988,
    1383,  2479,  1521,     0,     0,  1218,  1214,  1216,  1217,  1215,
       0,     0,     0,  2440,  1395,   238,  2451,  2547,  2479,   237,
     232,   233,   206,  2237,     0,     0,  1012,     0,  1392,  1393,
     970,  1640,  1638,     0,  2172,  2256,  2271,  2359,   229,  2435,
    2441,  2451,  2547,  2479,  2510,   185,   195,   190,     0,   247,
    2451,  2547,  2479,   243,  1413,     0,  1610,  1742,  2181,     0,
    1386,  1385,  1492,     0,  1495,     0,  2419,  1614,  1617,  1497,
    1615,  1606,     0,     0,     1,  1621,  1486,  1637,  1637,     0,
    1637,     0,  1598,  1606,  1601,  1605,     0,     0,     0,     0,
    2217,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,
    2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,
    2583,  2584,  2585,  2586,     0,     0,     0,  2191,  2218,  2222,
       0,   907,     0,  1425,  2186,  1054,     0,     0,     0,     0,
       0,     0,     0,  1104,  1103,  2223,  2213,  2214,     0,  2211,
    2212,  2224,  2225,  2226,     0,  2332,     0,     0,     0,  2083,
    2094,  2095,  2096,  2260,  2316,  2091,  2092,  2093,  2085,  2086,
    2087,  2088,  2089,  2090,     0,     0,  1185,  2084,     0,  2332,
       0,     0,   155,     0,   132,     0,     0,  2332,     0,     0,
       0,     0,     0,     0,     0,  2332,     0,     0,     0,     0,
       0,   155,  2364,     0,   132,  2332,     0,     0,  1407,     0,
       0,     0,  1409,  1412,  1388,  1473,     0,  2181,     0,     0,
       0,   941,   934,     0,   942,   949,     0,     0,   951,     0,
       0,   935,     0,     0,     0,     0,   954,   955,     0,   956,
     936,   957,   937,   958,   938,   959,     0,     0,     0,     0,
     939,     0,     0,     0,  1399,     0,  1523,  1525,  1524,  1522,
     508,     0,     0,     0,     0,  2332,     0,     0,   132,  1458,
       0,  2332,   132,     0,     0,   445,   444,   132,  2211,   443,
     442,  2260,  2316,     0,  1094,     0,  1342,   132,  2332,     0,
     178,  2332,   692,  2332,  1497,     0,   623,     0,     0,   803,
    2364,   132,     0,     0,     0,     0,     0,     0,  1071,     0,
       0,     0,   607,   620,  1534,  1532,     0,  1194,   231,   230,
    1192,   895,  2332,  1136,   341,   341,     0,     0,  2332,  1444,
    2220,  1817,  1846,  1824,  1846,  1846,  1813,  1813,  2300,  1826,
    2332,  1814,  1815,  1851,     0,  1846,  1813,  1818,     0,  1816,
    1854,  1854,  1841,   341,   911,  1798,  1799,  1800,  1801,  1827,
    1828,  1802,  1833,  1834,  1838,  1803,  1868,  1813,  2221,   896,
       0,   887,  2332,   341,  1100,  2332,  2215,   165,     0,   885,
    2260,  2316,  2332,   341,  1187,     0,  2332,   161,  2332,   341,
    2332,   624,     0,     0,  2332,   341,  2332,  2364,   163,     0,
    2332,   341,   905,  2332,   341,  2183,  2332,     0,     0,  1526,
       0,  1500,  2551,  1515,     0,  1511,  1518,  1514,  1621,  1008,
    1007,     0,  1008,     0,  1008,     0,  1008,     0,  1008,     0,
       0,     0,  1008,  2209,  2210,   990,     0,  1014,     0,     0,
    1021,  1020,  1019,     0,     0,     0,  1022,     0,  1746,  1561,
       0,  1381,  1398,     0,     0,     0,  1071,  1221,     0,  1219,
    1210,  1211,  1394,   236,   234,     0,     0,     0,     0,     0,
       0,  1400,     0,     0,     0,     0,  2194,  2196,  2197,  2097,
    2167,     0,  2515,  2516,  2517,  2156,     0,  2518,  2519,  2520,
    2566,  1999,  1986,  1995,  2000,  1987,  1989,  1996,  2521,  2522,
    1934,  2523,  2524,  2204,  2525,  2526,  2527,  2529,  2530,  2531,
    2532,  1991,  1993,  2533,  2534,     0,  2205,  2536,  2537,  2388,
    2539,  2540,  2542,  2543,  1997,  2545,  2546,  2547,  2548,  2549,
    2550,  2203,     0,  1998,  2552,  2554,  2555,  2556,  2557,  2559,
    2560,  2561,  2562,     0,     0,     0,  2178,     0,  1966,     0,
    1806,  1807,  1829,  1830,  1808,  1835,  1836,  1809,     0,  2177,
    1871,  2048,  1965,  1982,     0,  1971,  1972,     0,  1964,  1960,
    1623,  2173,     0,  1961,  2193,  2195,  2157,  1623,  2171,   198,
     249,     0,   250,  2179,  2451,   186,   228,   200,   227,   201,
     199,     0,  2258,   187,     0,     0,   188,     0,     0,     0,
       0,   246,   244,     0,  1389,     0,  1744,  1743,  2164,     0,
    2165,  2182,   916,  1485,  1483,  1484,  1482,     0,  1479,  1481,
    1494,  1491,  2107,     0,  1616,     0,     0,     0,  1596,  1595,
       3,  1497,  1635,  1636,     0,     0,     0,     0,     0,     0,
       0,     0,  1691,  1651,  1652,  1654,  1688,  1692,  1700,     0,
    1602,     0,     0,  1748,     0,     0,     0,     0,     0,     0,
    1135,  2192,     0,     0,     0,     0,     0,   908,     0,     0,
       0,  1431,     0,  1433,  1434,  1435,     0,     0,  1436,  1437,
    1425,   240,  1443,  1441,  1424,  1426,  1439,     0,     0,     0,
       0,     0,     0,     0,  1450,     0,   169,   170,     0,   636,
     620,     0,  2332,     0,     0,     0,     0,     0,  1143,  1150,
       0,     0,     0,     0,     0,     0,     0,     0,  1144,  1142,
    1145,   242,  1154,  1171,  1174,     0,  1102,  1105,     0,     0,
       0,     0,     0,  1276,     0,     0,     0,  1276,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   265,   277,   336,   599,     0,     0,     0,   602,     0,
    2332,     0,     0,     0,     0,  1189,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   130,
     131,   136,     0,     0,     0,     0,     0,     0,     0,   585,
     598,     0,     0,     0,     0,     0,   595,     0,     0,   132,
     269,   575,   581,     0,     0,     0,   699,   698,     0,     0,
       0,     0,  1358,  1357,     0,     0,     0,     0,  1448,  1447,
       0,     0,     0,     0,     0,  1276,     0,   259,   261,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   379,   380,     0,     0,     0,   136,
       0,     0,     0,     0,   271,     0,     0,  1408,  1405,  1406,
       0,  1411,     0,  1469,     0,   948,     0,     0,     0,     0,
     950,     0,   943,     0,     0,   940,  2260,  2316,     0,     0,
       0,     0,     0,     0,     0,   953,     0,     0,     0,   418,
       0,     0,   800,     0,     0,     0,     0,     0,     0,   811,
       0,  1425,  1457,     0,     0,     0,   629,     0,  2332,     0,
     134,   849,     0,   801,   446,     0,     0,     0,  1166,  1341,
     134,     0,     0,   172,     0,     0,   696,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   741,   740,     0,     0,
       0,   802,     0,     0,   134,     0,  2332,   578,  2332,     0,
     508,   508,     0,     0,  1070,  1073,     0,     0,     0,     0,
    1588,  1590,  1589,     0,  1587,     0,   339,   340,     0,  1177,
     798,  1202,     0,     0,  1845,  1832,  1840,  1839,     0,  1822,
    1821,  1820,     0,  1819,     0,  1846,  1846,  1844,  1823,  1798,
       0,     0,     0,  1850,     0,  1848,     0,   878,  1794,  1790,
       0,  1857,  1858,  1859,  1856,  1869,  1855,     0,  1804,  1860,
    1813,  1810,   898,     0,     0,  1175,     0,     0,  2332,   341,
    2332,     0,  2332,     0,     0,     0,  1179,   341,     0,     0,
    1359,     0,   894,   892,   891,   893,     0,     0,   876,     0,
       0,     0,  2332,   341,     0,     0,   871,     0,     0,   873,
       0,     0,     0,     0,  1621,     0,   217,   218,   216,  1516,
     219,  1517,  1513,  1499,     0,   998,     0,  1002,     0,   993,
       0,   999,     0,   994,   991,   992,     0,   997,     0,     0,
     509,   511,     0,     0,  2283,  2299,     0,  2322,  2352,  2353,
    2441,  2447,     0,  2474,  2484,     0,  1023,  1049,  1018,   710,
       0,     0,  1571,  1382,  2114,     0,  1621,     0,     0,     0,
       0,   235,   207,     0,     0,     0,  1051,  2440,  1397,   969,
     620,     0,  1962,     0,  1969,  1970,  2155,     0,     0,     0,
       0,     0,     0,  1968,  2122,     0,     0,     0,     0,     0,
    1894,     0,     0,     0,  2135,     0,  2141,     0,     0,  1931,
       0,     0,     0,     0,     0,     0,     0,     0,  1895,  1875,
    1876,  1966,  2107,     0,  1967,  2200,     0,  1868,  2176,  2097,
       0,  2094,  2095,  2096,     0,     0,     0,  2170,     0,  2105,
       0,     0,  1909,  2103,  1911,     0,     0,     0,     0,  2091,
    2092,  2093,  2085,  2086,  2087,  2088,  2089,  2090,  2101,  1891,
       0,     0,  2050,     0,  1890,     0,     0,  1704,     0,  2198,
    2158,  1704,   251,   252,   248,     0,     0,   203,   202,     0,
     221,   225,   226,   197,   224,     0,   220,   205,  2039,  2038,
     204,   196,   193,   191,   208,   210,   211,   194,   192,   245,
       0,  2163,     0,  2227,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,  2595,  2596,  2597,  2598,  2599,  2600,  2601,  2602,
    2603,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,
    2613,  2614,  2615,  2616,  2617,  2618,  2619,  2620,  2621,  2622,
    2623,  2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2632,
    2633,  2634,  2635,  2636,  2637,  2638,  2639,  2640,  2641,  2642,
    2643,  2644,  2645,  2646,  2647,  2648,  2649,  2650,  2651,  2652,
    2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,  2661,  2662,
    2663,  2160,  2159,  2188,  2228,  2229,  2230,  2231,  2166,     0,
       0,   341,  1477,     0,  1474,  1701,     0,  1618,     0,     0,
    1487,  1613,  1612,  1644,  1645,  1087,  1611,  1671,  1672,     0,
       0,     0,     0,  1697,  1695,  1662,  1655,  1661,     0,     0,
    1659,     0,  1663,  1871,  1690,  1600,  1649,  1650,  1653,  1599,
       0,  1693,     0,  1574,  1691,  1654,  1558,     0,  1536,     0,
    1749,     0,     0,     0,     0,     0,  1115,  1117,     0,  1116,
       0,  1119,     0,  1128,     0,     0,  1114,  1133,     0,  1122,
    1120,     0,  1446,     0,     0,   909,     0,     0,     0,     0,
    1432,     0,     0,  2474,   239,  1435,  1440,  1427,  1438,     0,
       0,     0,     0,     0,  1053,  1052,     0,     0,  1075,     0,
       0,     0,  1453,   497,     0,   338,     0,     0,     0,     0,
       0,     0,     0,     0,   796,   793,     0,     0,   792,     0,
     634,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   672,     0,  1276,     0,   704,     0,  1152,     0,     0,
    1151,     0,  1155,     0,     0,  1153,  1148,  1149,  2441,  2451,
    2479,   241,  1173,     0,  1172,  1170,  1097,     0,  1098,     0,
       0,     0,     0,     0,  2309,  2332,   281,   300,     0,  1275,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   323,     0,     0,   326,   325,
       0,     0,     0,     0,     0,   330,   309,     0,   310,     0,
       0,   329,     0,     0,   600,   601,     0,     0,     0,     0,
    1276,     0,   273,     0,     0,     0,     0,     0,     0,     0,
    1186,     0,   727,     0,     0,     0,     0,     0,  1345,     0,
       0,   158,     0,   153,   157,     0,     0,     0,     0,   583,
     584,   597,     0,   588,   589,   586,   590,   591,     0,     0,
       0,     0,     0,     0,     0,   582,     0,     0,   694,   693,
     697,     0,     0,     0,  1354,     0,  1166,     0,     0,  1353,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1223,  1222,     0,     0,     0,     0,     0,     0,   839,     0,
       0,     0,     0,     0,     0,     0,     0,   160,   714,     0,
     713,     0,   154,   159,     0,     0,     0,     0,     0,     0,
       0,   215,  1404,  1410,  1472,  2189,  1471,     0,     0,     0,
       0,   952,     0,     0,     0,     0,     0,     0,     0,   944,
     945,   946,   947,     0,     0,     0,     0,     0,   393,     0,
       0,     0,  2220,     0,   827,   799,     0,     0,     0,   813,
       0,   816,   819,     0,  1423,   465,     0,     0,   626,   672,
       0,     0,   449,   167,     0,     0,     0,     0,   729,     0,
       0,     0,  1340,   129,   176,   178,   447,     0,   177,   179,
     181,   182,   183,   180,   184,     0,   691,   695,     0,     0,
       0,     0,   622,     0,     0,     0,     0,     0,   742,   746,
     745,   749,   747,     0,   743,     0,     0,  1769,     0,     0,
     152,     0,     0,   573,   577,     0,     0,     0,     0,   449,
     549,   352,  2332,     0,   508,     0,  2332,     0,  1072,     0,
       0,     0,     0,     0,     0,     0,     0,  1586,   341,  1137,
       0,  1445,     0,     0,     0,   341,  1843,  1842,  1795,  1791,
       0,     0,     0,     0,   912,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1811,   341,  1101,   166,  2216,     0,
     880,     0,     0,     0,     0,   341,  1188,   868,   162,   341,
     625,     0,   341,   164,     0,     0,     0,   617,   341,   906,
     341,  2184,     0,   341,  1529,  2332,   508,  1501,  1512,   995,
    1004,  1003,  1001,  1000,   996,     0,  1015,     0,   507,     0,
       0,     0,  1029,  1030,     0,     0,  1028,  1031,     0,  1033,
    1025,  1024,  1034,  1035,     0,     0,  1051,   708,     0,     0,
       0,     0,  1568,     0,  1566,     0,  1747,  1570,  1559,  1520,
       0,  1519,     0,   566,     0,     0,  1220,     0,     0,  1012,
       0,     0,   341,  1396,     0,   971,   977,     0,     0,     0,
       0,     0,     0,   980,   981,   982,   973,   983,   974,   984,
       0,   975,     0,     0,     0,     0,  2168,  2118,     0,  2119,
       0,     0,  2154,  2150,     0,     0,     0,     0,     0,  2123,
    2126,  2127,  2128,  2125,  2129,  2124,     0,     0,  2130,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2543,     0,
       0,     0,     0,  1935,     0,     0,  2078,     0,  2107,  2140,
       0,     0,     0,     0,     0,     0,  2107,  2146,     0,     0,
       0,     0,  2037,     0,  2034,     0,     0,     0,     0,  2167,
       0,     0,  2201,  1872,  1886,  1887,  1888,  1892,  2175,     0,
    2169,     0,     0,  1873,  1900,     0,  2147,  1927,     0,  1932,
    1915,     0,  1908,     0,  1913,  1917,  1896,     0,  1893,     0,
    2170,  2106,     0,  2104,     0,  1883,  1884,  1885,  1877,  1878,
    1879,  1880,  1881,  1882,  1889,  2082,  2080,  2081,     0,     0,
       0,  2058,     0,     0,  1912,  2325,  2359,     0,  1634,  1634,
    1634,  1622,  1632,  2174,     0,  1764,     0,     0,     0,     0,
    1974,     0,  2111,  1643,  2109,  1120,  1764,  2180,     0,     0,
    1868,     0,  1745,  2161,  2164,   914,   915,   913,  1497,  1480,
    1476,  1475,  2108,  1496,  1621,     0,  1085,  1086,     0,  1090,
    2543,  2438,     0,     0,     0,     0,  1664,  1698,     0,  1689,
       0,  2194,  1665,  2193,  1666,  1669,  1670,  1660,  1699,  1572,
       0,  1694,  1604,  1603,     0,  1767,     0,     0,     0,  1550,
    1538,     0,  1750,     0,  1704,  1576,     0,  2167,  1702,  1318,
    1224,  1283,  1118,     0,  1813,  1129,     0,  1113,     0,  1112,
    1813,     0,  1130,     0,  1813,  1319,  1225,  1284,   910,  1320,
    1226,  1285,  1321,  1227,  1442,  1430,  1429,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   777,  2332,   341,  1451,  1322,     0,  1228,   337,
    1452,  1286,  1456,   795,   794,     0,     0,  1287,     0,   635,
       0,   639,     0,   641,   642,   643,     0,     0,     0,   644,
       0,  2260,  2316,   646,   649,   656,   661,   651,     0,     0,
     663,   657,     0,     0,     0,     0,     0,     0,   669,   674,
       0,     0,     0,     0,     0,     0,     0,  1146,  1147,  1323,
    1231,     0,  1288,  1096,     0,  1232,   168,     0,     0,   266,
    2332,   283,     0,   676,   777,  1278,   307,     0,     0,   322,
     317,   318,   316,  2332,   341,  2332,   341,     0,     0,     0,
       0,     0,   319,   314,   315,   311,     0,     0,   324,  2236,
    2301,  2452,     0,   680,   682,     0,   687,   327,  1250,   348,
     347,   346,     0,   331,     0,   353,   356,   328,   305,   308,
     306,   302,   278,     0,     0,     0,     0,     0,     0,     0,
       0,  2187,     0,     0,  1181,     0,  1326,  1289,     0,  1309,
       0,     0,     0,     0,   721,  1346,  1348,  1338,  1238,  1347,
     156,  1265,   145,     0,     0,   141,     0,     0,     0,     0,
     135,     0,  1329,  1239,     0,     0,   270,   576,   587,   592,
    1244,   596,   593,  1299,   594,  1336,  1240,  1332,  1268,  1294,
    1339,  1355,  1241,  1166,  1350,  1352,     0,  1276,     0,   260,
     262,     0,   280,     0,  1242,     0,  1292,  1331,  1267,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1459,     0,
       0,     0,     0,     0,     0,   341,     0,     0,     0,  1278,
    2332,   341,  1330,     0,  1273,     0,  1307,     0,   381,     0,
    1266,     0,     0,   272,  1246,  1301,     0,     0,   213,   212,
     214,   961,   921,   960,     0,  2299,     0,   920,   922,     0,
       0,     0,   923,     0,     0,     0,     0,   919,   917,   918,
     392,     0,   417,   390,   391,   393,     0,     0,   826,     0,
       0,     0,     0,   815,     0,     0,     0,  1449,     0,   132,
     633,     0,     0,     0,   628,   671,   676,     0,     0,     0,
       0,   448,   452,   456,   457,   458,     0,     0,     0,     0,
     146,   133,     0,   857,     0,   508,     0,   731,  1344,  1343,
    1165,     0,   178,   171,     0,     0,   692,     0,  1497,     0,
       0,   352,   810,   808,   807,   809,     0,     0,     0,   831,
     806,     0,  1768,  1770,     0,     0,     0,     0,     0,     0,
     566,   451,     0,     0,   511,     0,     0,   553,     0,     0,
       0,     0,   352,     0,     0,     0,  1107,     0,  1125,  1108,
       0,     0,     0,     0,  1159,  1166,  1160,  1138,     0,     0,
     605,  1591,  1592,     0,  1178,     0,     0,  1812,  1825,   879,
       0,  1853,  1852,  1854,  1854,     0,  1796,     0,  1837,  1862,
    1863,  1864,  1865,  1866,  1867,     0,  1861,  1805,  1176,   341,
       0,   341,     0,   341,  1180,  1360,     0,   877,     0,     0,
     341,   870,   872,     0,   874,     0,  1016,   510,     0,     0,
       0,     0,  1027,   603,  1032,     0,  1044,  1039,  1041,     0,
    1045,   707,     0,     0,  1569,  1562,  1564,  1563,     0,     0,
    1560,  2115,   869,     0,   572,  1212,  1213,     0,     0,   341,
       0,  1046,     0,     0,   978,   972,     0,     0,   976,     0,
     979,     0,     0,  1639,  2116,  2117,     0,     0,     0,  2151,
       0,     0,  2012,     0,  1988,  1990,  2002,     0,  2013,  1973,
    2014,  1992,  1994,     0,  2098,     0,     0,  2003,     0,  1937,
    1938,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1953,  1952,
    2004,  2077,     0,     0,  2138,  2139,  2005,     0,     0,  2145,
       0,     0,     0,  2010,  2015,     0,     0,     0,     0,  2021,
       0,  2042,     0,     0,     0,  1963,  2108,     0,     0,     0,
       0,     0,     0,     0,     0,  1933,  1916,  1910,     0,  1914,
    1918,     0,     0,     0,  1904,     0,     0,  1902,  1928,  1898,
       0,     0,  1929,     0,     0,     0,  1981,     0,     0,  1634,
    1634,  1634,  1634,  1631,     0,     0,     0,     0,  2438,  2563,
       0,  1728,  1703,  1705,  1715,  1728,  1733,  1728,  1983,  1762,
    1984,     0,  2181,     0,  1674,  1643,  1643,  1643,  1980,     0,
       0,     0,     0,  1642,  1674,   189,     0,   222,   209,  2163,
       0,  1478,     0,  1646,     0,  2099,  1090,     0,  1648,  1668,
    1667,     0,  1658,  1696,  1656,  1573,  1557,     0,  1555,  1542,
    1544,  1543,     0,     0,  1545,  2167,     0,  1555,  1537,  1581,
       0,     0,  1767,     0,  1580,     0,  1813,  1110,  1111,     0,
    1134,     0,  1056,  1057,     0,  1055,     0,     0,     0,   496,
    1074,     0,     0,     0,   777,     0,     0,   500,     0,  1454,
       0,  1337,  1264,   637,   638,     0,   650,     0,   659,   658,
       0,     0,     0,     0,     0,     0,     0,   645,   665,   609,
     666,   668,     0,     0,   667,   670,   673,  1276,     0,   705,
    1252,     0,  1305,  1140,  1279,     0,  1099,     0,     0,     0,
       0,     0,     0,   465,   301,     0,     0,     0,   361,     0,
     285,   293,   359,   299,     0,  1282,   333,     0,   304,     0,
     297,   320,   312,   321,   313,   332,   334,     0,   684,   685,
     683,   679,     0,   686,   688,     0,   350,     0,     0,     0,
    1325,     0,  1276,     0,   274,     0,  1248,     0,  1303,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1308,     0,     0,     0,     0,   726,     0,   723,     0,     0,
     138,   137,     0,   144,     0,     0,     0,     0,     0,  1356,
       0,     0,     0,     0,     0,     0,     0,   279,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   382,   343,     0,   834,     0,
       0,     0,   384,     0,     0,     0,     0,     0,  1324,  1233,
       0,     0,     0,   932,     0,     0,     0,     0,     0,     0,
     395,   396,   132,   394,     0,     0,   825,  2388,  2085,  2086,
     823,   829,   820,   822,   824,   821,     0,   828,   777,     0,
       0,   812,   817,   818,     0,     0,     0,     0,     0,   480,
       0,     0,     0,   471,     0,     0,  1166,   464,   467,   468,
       0,     0,   629,   632,   630,   631,   664,     0,   451,   487,
     535,     0,   148,     0,     0,   149,   147,     0,     0,   352,
     728,     0,   725,     0,   174,   447,     0,   696,     0,     0,
       0,  1166,   621,   748,   751,   744,     0,   830,   832,   804,
       0,   676,     0,     0,   578,     0,   508,  1530,   561,     0,
     537,   451,   535,   547,   546,   548,     0,   555,   351,     0,
       0,   566,   555,     0,     0,  1075,  1106,     0,     0,     0,
    1156,  1161,  1157,     0,     0,  1121,     0,  1158,  1139,  1093,
    1376,  1377,  1374,  1375,     0,     0,     0,  1583,     0,  1831,
       0,  1849,  1847,  1792,  1797,  1870,   881,     0,   864,     0,
     866,   341,   715,     0,   618,   341,     0,     0,     0,     0,
    1026,     0,  1042,     0,     0,  1009,  1048,     0,     0,  1567,
    1565,   564,     0,  1051,     0,  1010,  1050,     0,     0,     0,
       0,     0,     0,     0,  2120,     0,  2153,  2149,     0,  1985,
    2121,     0,  2133,  2132,  2078,     0,     0,  1936,  1948,  1949,
    1950,  2134,     0,  1958,     0,     0,  1945,  1946,  1947,  1939,
    1940,  1941,  1942,  1943,  1944,  1951,  2143,  2142,  2136,  2137,
       0,  2007,  2008,  2009,  2144,  2016,     0,  2251,  2043,  2020,
    2036,  2035,     0,     0,     0,  2023,     0,     0,  2032,     0,
    2079,  2202,  1874,     0,     0,  1901,  2148,  1919,     0,     0,
       0,  1897,  2098,     0,     0,     0,     0,     0,  1906,     0,
       0,     0,  2061,  2056,  2057,  2075,     0,     0,     0,     0,
       0,     0,  1625,  1624,  1630,  1728,  1733,  1728,     0,     0,
    1606,     0,  1715,     0,  1727,  1713,  1726,     0,     0,  1739,
    1737,     0,  1739,     0,  1739,     0,  1707,     0,  1729,  1709,
    1726,  1711,     0,  1754,     0,  2182,  1763,     0,  1687,     0,
       0,     0,     0,  2112,  2113,     0,  2110,  1975,  1687,     0,
    2162,  1619,     0,  1647,  1088,  1089,  1657,  2279,  1765,     0,
    1556,     0,     0,     0,  1547,  1553,  1535,     0,     0,  1577,
    1555,  1578,  1131,     0,     0,  1123,  1062,  1065,  1063,  1061,
    1064,     0,     0,     0,   777,     0,     0,   516,     0,  1082,
    1082,     0,     0,   502,   558,  1166,   780,     0,     0,     0,
     778,   341,  1229,     0,   660,     0,     0,   655,   653,   652,
     654,     0,   610,  1335,  1230,     0,     0,     0,     0,  1141,
       0,     0,  1251,     0,   282,     0,   461,     0,   294,     0,
     290,     0,  1277,     0,     0,     0,     0,   289,   363,     0,
     360,     0,   341,   341,   335,   681,   349,   354,   355,   358,
       0,     0,     0,     0,     0,  1281,     0,     0,     0,     0,
       0,     0,     0,   858,   841,     0,     0,   859,   860,     0,
       0,     0,  1183,  1184,  1182,  1310,  1311,  1316,  1313,  1312,
    1315,  1317,  1314,     0,  1236,     0,     0,   719,   142,   139,
     140,   143,  1262,  1245,  1300,  1351,     0,     0,     0,  1243,
       0,  1293,     0,  1258,  1254,     0,     0,     0,     0,     0,
    1334,  1272,  1298,  1333,  1270,  1296,  1269,  1295,  1271,  1297,
       0,  1263,     0,  1772,   838,     0,     0,     0,   341,   341,
     837,   717,  1247,  1302,     0,     0,   924,     0,     0,   926,
     927,     0,   929,   400,   420,   737,   797,     0,     0,   814,
     776,     0,   469,     0,   475,   478,     0,     0,   482,   483,
     481,   470,  1166,   508,   557,     0,     0,   787,     0,   627,
       0,   449,     0,   484,     0,     0,   453,   151,   150,     0,
       0,     0,   732,   736,   734,   733,   735,   730,     0,   721,
     178,  2332,     0,     0,     0,     0,   559,  1349,     0,   761,
     805,     0,  1771,   711,     0,   352,   574,     0,     0,     0,
     449,   566,     0,   454,   459,   460,   465,     0,   549,   536,
       0,   537,     0,     0,   563,  1421,     0,   567,   569,     0,
       0,     0,  1109,  1126,  1127,     0,     0,  1166,     0,     0,
       0,     0,   612,   341,  1793,   341,   341,  1209,     0,   875,
    1038,  1037,  1036,   604,     0,  1040,   709,     0,   565,   341,
       0,   986,   966,   985,   965,   967,     0,   964,   962,   963,
    2152,  2001,  2011,  2131,  2077,  2108,     0,     0,  1959,     0,
       0,  2006,  2553,     0,     0,     0,     0,  2040,  2041,  2022,
       0,  2378,  2027,     0,     0,     0,  1925,  1923,  1920,     0,
    1921,  1905,     0,     0,  1903,  1899,     0,  1930,  2047,     0,
    2063,  2060,  2074,  2108,  1629,  1628,  1627,  1626,  1714,  1710,
    1712,     0,  2558,     0,  1717,  1724,     0,  1706,     0,  1738,
    1734,     0,  1735,     0,     0,  1736,     0,     0,  1708,     0,
    1724,     0,  1761,  1643,     0,     0,  2052,  1978,  1979,  1976,
    1643,  2199,  2052,   223,     0,     0,  1554,  1539,     0,  1540,
    1546,     0,     0,     0,     0,  1582,  1575,  1124,  1132,     0,
       0,     0,   498,     0,  1166,     0,     0,     0,  1084,  1084,
       0,  1166,   557,   782,   781,   784,   779,   783,  1455,     0,
     647,   648,   662,  1253,     0,  1306,  1260,     0,  1571,   284,
       0,   677,     0,     0,   286,   362,   364,   287,   288,   291,
     343,   303,   296,     0,     0,     0,  1249,     0,  1304,  1256,
    1327,  1234,  1290,     0,     0,   847,     0,     0,     0,     0,
    1328,  1235,  1291,     0,     0,     0,     0,  1571,     0,     0,
       0,     0,     0,     0,     0,  1464,     0,  1280,   342,   836,
     835,   343,   383,  1274,     0,   925,   930,   931,   928,     0,
     389,   397,   421,   132,     0,     0,  1200,  1200,     0,   777,
       0,     0,   466,   479,     0,   557,   515,     0,   472,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   724,   723,   173,     0,   449,     0,   676,
       0,   755,   756,   750,   752,     0,   763,   767,   833,     0,
       0,     0,   566,   451,     0,     0,  1527,   450,     0,     0,
     462,     0,   553,   537,   549,     0,   550,     0,   554,     0,
    1414,     0,     0,     0,     0,  1162,     0,  1168,     0,  1120,
    1091,  1163,     0,  1764,     0,     0,     0,     0,   616,  1201,
     865,   867,   716,  1043,     0,  1047,   341,   968,  2079,  1954,
       0,     0,     0,     0,  2017,     0,  2018,  2045,  2044,  2024,
    2028,     0,  2025,  2026,  1922,  1926,  1924,  1907,  2049,     0,
    1643,  2076,  1757,     0,  1760,     0,     0,  1716,     0,     0,
    1718,     0,     0,  1720,  1722,     0,     0,     0,     0,     0,
       0,  2185,     0,  2278,  2527,  2437,     0,  1673,  1675,  1678,
    1680,  1679,  1681,  1677,  1686,     0,  1608,     0,  1607,  2100,
    1766,     0,     0,     0,  1076,     0,  1579,  1044,     0,   341,
    1082,   557,   517,  2388,   518,  1081,  1083,  1087,  1087,     0,
     557,   777,   640,     0,     0,   267,   675,     0,     0,   295,
     345,   357,     0,  1571,     0,     0,   845,   854,   854,   842,
       0,     0,   861,  1237,   720,     0,     0,   263,  1259,  1255,
       0,     0,  1466,  1467,     0,     0,     0,     0,     0,   341,
     933,     0,   423,   430,   401,   406,  1458,     0,  1458,     0,
     403,   407,  1458,   402,  1458,   399,   400,     0,  1200,     0,
    1197,  1196,   775,     0,   506,   580,   473,     0,   526,     0,
       0,   788,     0,     0,   451,   535,     0,   495,   488,   489,
     490,   491,   492,   493,   494,   486,   485,     0,   676,   851,
     352,  1421,   718,     0,     0,   689,     0,   753,   758,   757,
    1458,   762,     0,     0,     0,   676,     0,  1530,   562,   537,
     451,   535,   455,   465,   539,     0,   540,   555,   549,   553,
     551,   552,     0,     0,     0,   566,  1468,  1075,     0,  1167,
       0,     0,     0,     0,     0,     0,  1204,   611,     0,     0,
     615,   606,   676,  1011,  1955,     0,  1956,     0,     0,     0,
    2030,  2029,     0,  2066,  1762,     0,     0,  1756,     0,     0,
    1786,     0,     0,     0,  1725,  1741,     0,  1721,  1719,     0,
    1730,     0,  1732,  1975,     0,     0,     0,  1682,     0,  2051,
    2053,     0,  1977,     0,  1552,  1764,     0,  1549,     0,  1058,
       0,  1059,  1084,   521,     0,  1090,  1090,   508,   777,   499,
    1261,     0,   678,   580,     0,   298,     0,   275,  1257,     0,
       0,   856,   856,     0,     0,     0,     0,   370,   377,   376,
     371,   369,   378,     0,   374,   368,   367,   372,     0,  1460,
       0,  1461,  1462,  1465,   385,   398,     0,   428,     0,   426,
     425,   427,     0,   414,     0,     0,     0,     0,     0,     0,
     388,   419,  1195,  1199,  1198,     0,     0,   474,     0,   476,
     512,   513,   514,     0,   477,   522,   523,     0,   785,     0,
     790,     0,     0,     0,   676,   534,   700,     0,     0,     0,
    1415,     0,     0,   560,     0,   764,   765,   760,     0,     0,
     712,  1421,   566,   549,     0,   537,   463,     0,   436,   553,
     555,     0,  1418,     0,   568,     0,   352,  1166,  1169,  1164,
    1380,     0,     0,   614,   613,   706,  1957,  2033,  2019,  2046,
    2031,  2062,     0,     0,     0,  1755,  1758,     0,  1789,     0,
       0,     0,     0,  1775,     0,  1723,     0,     0,  1731,     0,
       0,     0,  1676,     0,     0,  1541,  1551,  1077,     0,     0,
    1087,     0,   777,     0,  1079,  1078,   515,   501,  1571,   292,
     344,     0,     0,     0,   852,   855,   843,   844,   863,   862,
     722,  1571,     0,     0,   365,     0,     0,   424,   433,     0,
     431,   404,   409,     0,   413,   411,   410,   405,   408,     0,
     505,     0,     0,     0,     0,   524,     0,   525,   556,     0,
     789,     0,     0,     0,   702,   850,     0,     0,   449,   676,
     754,   759,     0,     0,  1416,  1528,   553,   537,   549,     0,
       0,   541,  1082,  1082,   555,   434,  1419,  1420,     0,   555,
    1092,  1379,  1378,  1621,     0,     0,  2514,  2279,  2486,     0,
    2064,  2067,  2065,  2059,     0,     0,  1787,  1788,  1773,     0,
       0,  1777,  1740,  1753,  1684,     0,  1683,  2054,  2055,  1764,
     341,  1090,     0,   503,   519,   526,   268,  1571,   846,     0,
     264,     0,   375,   373,  1463,   429,     0,   412,   767,   579,
     531,     0,   530,     0,   528,   527,   786,   791,     0,   676,
     840,  1421,   690,   766,     0,   555,   549,   553,     0,   538,
       0,  1084,  1084,   438,     0,  1764,  1362,  1621,  1361,  1363,
    1371,  1368,  1370,  1369,  1367,  1207,  1208,     0,  2071,  2070,
    2069,  2073,  2072,  1759,     0,  1776,  1779,     0,     0,     0,
    1785,  1778,  1780,     0,  1751,  1685,  1548,  1060,  1080,     0,
     777,   276,   853,     0,   432,     0,   529,   533,   532,   676,
     701,  1417,   770,   437,   553,   555,  1082,   542,   544,   543,
     352,  1066,     0,  1372,  1366,  1606,  1593,     0,     0,     0,
       0,  1782,  1783,  1784,  1781,     0,   520,   504,     0,     0,
     703,   772,     0,   768,   771,   773,   774,   555,   435,  1084,
     555,  1364,  1621,     0,     0,  2068,     0,     0,   366,     0,
     738,     0,   439,   545,  1764,  1365,     0,     0,     0,  1752,
       0,   769,  1067,     0,     0,  1774,   770,     0,     0,     0,
    1205,  1206,   739
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4754, -4754, -4754,  3629, -4754,  -867,   346,  2866,  -509, -4754,
   -4754, -4754,  1116, -4754, -4754, -4754, -4754,  3578, -4754,  2002,
   -2315, -4754, -4754,   150,  3525, -1244,   136,  3120,  1656, -4754,
   -1100, -4754, -4754,  -556,   154, -4754,  3533,   409, -4754, -4754,
   -4754, -4754, -4754, -4754, -4754, -4754,  -751,  2111,  2181,  1493,
   -1007, -2635, -4754, -4754, -1369, -3094, -4754,   822, -4754,   845,
   -4050, -4478, -4754,  -813,  -642, -4754, -4754,  2097, -4754, -4754,
   -4754,  1307,   731,  -320, -4754, -4754, -4754, -4754, -4754, -4754,
   -4754,  -498, -4754, -4754,  -737,   157,    36, -2359, -3595, -4754,
   -4754,   689,  -137, -1387, -4754, -3445, -4754,   229, -3648, -4754,
   -4754, -4754,  -103, -1348,  1590, -4754,  -669, -1063,  1899,  -609,
   -4754,    13, -4754,  -707,  -517,  -506,  -637, -3657, -4113, -4754,
   -4754, -4754,  -740, -4128, -4365, -3627, -3443,  1604, -4754,   165,
   -3001, -3084,   166,   662, -4754,   172,   174, -4754,   680,  -438,
    -876, -1466, -4754,  -663, -4754, -4754, -4754, -2811, -4754, -4754,
   -4754, -4754,    81, -4754, -4754, -4754, -4754,   724, -4754, -4754,
   -4754, -4754, -4754, -4754, -2577,  2068,  2069, -4754, -3053, -4754,
    -845, -4754,   868, -2844,  1512, -4754, -4754,  1293,  3587,   707,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -1571, -4754, -4754,
   -4754, -4754,   226,   -77, -4754, -4754, -4754, -4754, -4754, -4754,
     176, -4754,  2086,  1290, -4754, -4754,   -83, -4754, -4754, -4754,
   -4754, -4754, -4754,  -697,  -834,  -818, -4754, -2875, -4754, -4754,
   -4754,   -51, -4754, -4754, -4754, -4754, -4754, -4754,  -832, -4754,
    1356, -3023, -4754, -4754,  1362, -4754, -4754, -4754, -4754, -4754,
    -614,     7,  2886, -4754,  -223,  -416, -4754, -4754, -4754,    20,
   -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -1047,  6819,
    -793,  -523, -4754, -4754, -4754, -4754, -4754, -2140, -4754, -4754,
   -4754, -4754, -3563, -4754,  4483,  2016,  -322,   178, -4754,    -1,
      68,  3395, -1092, -2527,   657,  -175, -4754, -4754, -4754, -2458,
   -4754, -4754, -4754, -4754, -3391,   179, -4754,  3358, -4754, -3672,
   -4385, -3410, -3921, -4283, -4397, -3357, -4754, -4754, -4754, -4754,
   -1306,  -190, -4754, -4754, -1374,  2427, -1867, -4754, -2045,   709,
    1685,  3579, -2631,  -127,  2858, -3674,  -639, -3156, -4754, -4754,
   -2249,  -312, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
    -577,  2797,  -189, -4754, -4754,  3923, -4754, -4200, -4754,  3878,
   -4754, -4754, -4754, -4754,  2721,  2724, -4754,  2726, -4754, -4754,
   -1354,  1452, -4754, -4754, -4754, -4754,   904, -4754, -4754, -4754,
   -4754, -4754, -4754, -4754,  1357,   886, -4754, -4754, -4754, -4754,
   -4754,  -595,  -753, -4754, -4754,   180, -4754, -4754, -4754, -4754,
    2235,  -866,  -672,  3791,   183, -4531, -4754, -4754,  -496, -4754,
    3160, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -2376, -4754, -4754, -4226, -4754, -4754, -4754, -4754, -4754,  2510,
    2512,    50,   -28, -4754, -4754,  -930, -4754,  -532, -4754,  2795,
   -4754, -4754, -4754, -4754, -1662,   185, -3649, -4754,     3, -4754,
   -4754,   129, -4754,   522, -4754, -4754, -3291,     4, -4754, -4754,
   -4754, -4754, -4263, -4754,     5,  -497,  1051, -2688, -4754,   189,
       8, -4754, -4754,     2,   385,   -44,   -39,   -35,     1,   137,
    3236, -4754,  3276, -4754,    -8,  1829, -4754, -4754,  -764,  -156,
   -4754,  1782,  -593,  2483,  3229,  3217, -4754,  1769,  2513, -1871,
   -1870, -4754,  1099,  -476,  -313, -4754, -4754, -4754, -4754,   558,
    -587,  2495, -4754,  3224, -4754, -4754, -4754, -1769, -2705, -3308,
    1131, -3300, -3201,   606,   591, -1398,   -81,    29,  -709,  3231,
   -4754, -4754,  1139,  -278, -4754, -4754,  -276, -2698,  1077, -4754,
   -4194, -2218,  1144,  -708,  -562, -4754,  -640, -4754,  -441,  -371,
    2905, -1009, -4754, -4754,  -951, 16134, -4754, -4754, -4754, 16555,
   16942, -4754, -4754, 17794, 18122, -4754,  -835, 18602,  7483,  -983,
   -1718, -2062, 14422, -1683,    48, -2691, -4754, -3385, -2448, -4754,
   -4754, -4754,   -31,  1205,   696, -4754, -4231, -4754, -4754,   193,
   -4754,  -439, -4754,  -437, -4754, -4754, -4754,  -415, -4753,  2706,
   -4754, -4754, -4754,  -176, -4754, 19404, -2630, -4754,  -720, -2623,
   -2627, -3289, -1719, -4754, -4754, -4754, -4754, -4754, -4754, -4754,
   -1607, -3160,  -357,  1898, -4754, -4754,  1989, -4754, -4754, -4754,
   -1269,  1848,  -716, -2515,  1903, -4754,  -719,  2708,  -729,  9699,
    -604,  7353,  -469, -2181, -1182, -1495, -4754,  -123, -4754,   160,
     -16,    -7,  -117,  -187,  -563,  2951, 14803,  -608, -1286, 10495,
   14399, 13761, -3021
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    51,    52,    53,    54,  1481,  2403,  2273,  3160,  3161,
      55,    56,  1477,    57,    58,    59,    60,  1400,    61,   989,
    1623,  2418,    62,  2114,   756,   757,   758,  1933,  1934,  2352,
    1935,  1923,  1287,  1760,  1421,   730,   731,  1382,  1422,    64,
      65,  1281,  1914,    66,    67,    68,  1451,  1528,  1452,  1394,
    1669,  4183,  4905,  2973,  2241,  3209,  2974,  2975,  3581,  3582,
    3657,  4922,  4928,  4923,  4924,    69,  1544,  1545,    70,    71,
    3125,  3121,  3702,  4520,  4521,  4755,   569,  2380,  4523,  4524,
    4741,  4742,  4940,  5079,  5080,  2419,  1615,  3203,  3790,  3151,
    4272,  3152,  4273,  3153,  4274,  3137,  3737,  3738,  4217,  3739,
    3154,  4233,  4785,  3155,  2133,  4957,  2460,  1782,  1780,  4768,
    4046,  4047,  5052,  4964,  4965,  4966,  5184,  4235,  4278,  4279,
    4815,  5120,  5121,  3207,  3797,  4284,  4538,  2862,    73,   665,
    1649,  3304,   666,  2463,   604,   667,  2420,    78,  2453,  4959,
    2454,  1502,  2282,  4925,  3284,    79,  1013,  3548,  4608,  4840,
    4841,    80,   221,    81,  1631,    82,    83,  2398,  3144,    84,
    2150,  2879,    85,    86,  2908,  2909,  2910,    87,  3573,  4460,
    1453,  2962,  2963,  2964,  2965,  3603,    88,  1626,  2427,  2428,
      89,    90,    91,    92,  2569,  2570,    93,  2339,    94,    95,
      96,    97,  3637,  4147,  4249,  3004,  3167,  3762,  4247,    98,
    2421,  1639,  2443,  2444,  4259,  4563,  4564,  4565,  4800,  5110,
    4567,  4802,  4987,  4804,  5282,  5283,  4529,  3527,  4060,   100,
    4226,  4227,  4971,   101,  2148,   102,   103,   104,  1599,  2390,
    2391,  3711,  1592,  2383,  2384,  3776,  3777,   105,  3078,   106,
    4123,  4124,   605,  4978,  4911,  5066,   107,   108,  4127,  4128,
     109,   110,   111,   112,   113,   657,   658,   659,  1101,  1102,
    2834,  1053,   114,  2031,   115,   952,   953,  3102,   116,  1174,
    2613,  2614,  4322,   117,   690,  1120,  1121,  2422,   119,   699,
    2589,   701,  1795,  3286,  3287,  3855,   120,   121,  2566,  2592,
     122,  1387,  2124,  2125,  4041,  2423,   606,  1655,  2467,  2857,
    4683,  4684,  4438,  4697,  2779,  3478,   124,   607,  1426,  2197,
    1073,  1074,  2470,  3217,  2093,  2094,  2095,  3814,  2096,  3219,
    2097,  1360,  2098,  1023,  1024,  3225,  3226,  3227,  3810,  3817,
    2412,  4597,  4598,   125,  1424,  2195,   126,   127,   128,  1465,
     874,  1083,  1084,   129,   619,   620,   130,  4760,   131,  1027,
     132,  4606,   133,   134,   721,   722,  1158,  1159,   135,   136,
    2211,  3584,   137,   138,   139,  2998,  2999,  4139,   140,   141,
    1618,  1619,   142,   143,  3043,  3044,   144,   145,   146,  5208,
    5262,  5263,  5264,  3824,  5133,  5210,  1151,   148,   149,   150,
     187,   912,   913,   914,  2424,  4590,   152,   153,  1383,  1384,
    1385,  1386,  2119,   154,   155,   156,   157,   158,   159,   160,
    1603,   161,   162,  4734,   163,   164,  1563,   165,  1317,  1318,
     166,   167,   563,   774,  1321,  1327,   168,   669,  1114,  1115,
    1116,  1762,   169,  1154,   955,   670,  1109,   171,   671,  2077,
    2809,  3492,  3493,  3494,  3497,  4423,  4020,   672,  2805,   174,
    1802,  2575,  2578,  2801,   673,  2814,  2815,  2816,  3500,   674,
     692,  1016,  2476,   675,  1248,   179,   180,   181,   783,   777,
     778,   183,  1907,  2741,   708,  1334,   743,   744,   791,  3463,
    2043,  2044,  2068,  2069,  1343,  1344,  2056,  2060,  2061,  2792,
    2785,  2049,  3998,  4667,  4668,  4669,  4670,  4671,  4672,  4406,
    2064,  2065,  1346,  1347,  1348,  2073,   184,  2745,  3442,  3443,
    3444,  3974,  3975,  3989,  3985,  4390,  4653,  3445,  1149,  1354,
    4398,  5234,  3446,  4642,  4643,  4857,  3993,  3454,  3488,  3191,
    3192,  3193,  3447,  5032,  5033,  5231,  5232,  4859,  4860,  2099,
    1699,  1055,  1249,  1056,  1711,  1250,  1683,  1058,  1251,  1252,
    1253,  1061,  1254,  1255,  1256,  1064,  1675,  1257,  1258,  1693,
    1708,  1709,  1322,  4861,  1260,  1261,  1262,  3449,  1263,  3928,
    4354,  4343,  2673,  2674,  1930,  3924,  3387,  1902,  2731,  4676,
    4879,  4880,  3426,  3953,  4370,  4640,  5024,  5140,  5141,  1264,
    1265,  1266,  2728,  1898,   877,  1267,  3713,  1900,  2667,  2753,
    2754,  1805,  1825,  2620,  2636,  2637,  2647,  3346,  2655,  2660,
    3374,  3375,  2668,  2697,  1268,  2622,  2623,  3330,  1827,  1269,
    1310,  1942,  1361,  1822,  2692,  1277,  1270,  1271,  1796,   767,
    4649,  1105,   833,  2990,  2022,   916,   705,  1272,  1273,  1274,
    1275,  1458,   848,  1076,  1077,   559,   827,   850,  2966,   560,
     561,   829,  2027
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     621,   182,   177,   172,   173,   175,   782,   841,   983,   706,
    1019,   849,  1501,   875,   694,   557,  1759,  1282,  1670,   884,
     694,   182,   611,  2023,   792,  1278,   876,  1140,  1141,  1142,
    1349,  1719,   904,  1146,   735,  2295,   769,  1549,  1367,  1689,
    2132,  2751,  2028,  3150,  1506,  2206,  1697,  1561,   603,  2827,
    2829,  2198,  1311,  3448,  1104,  1323,  1117,  3041,  3464,  3574,
    1312,   824,  1017,  3309,  1628,   825,  1715,  2354,  1695,  3818,
     668,  2448,   766,  2992,   842,  1779,  1726,  1815,  1087,  2235,
    2023,  1296,  1730,  2218,  2207,  1679,  1680,  3772,  1738,   883,
     700,  1098,  2028,  3746,  1746,  1688,  3554,  1749,   656,  3486,
    3173,  1601,   903,   736,  2619,  1606,  3715,   968,  3290,  3075,
    1610,  4048,  3723,  3448,  3715,  3598,  3788,  3600,  3802,  4013,
    1620,  3457,  3940,  3455,  3456,  3499,  4043,  1427,  4086,  4439,
    1095,  1111,  3971,  4291,  1644,  4281,  4049,  1500,  4271,   786,
    4297,  1019,  2756,   794,  2581,  1527,  3988,   795,  3476,  2682,
    4582,  1613,  4646,  4232,    63,  1554,  4698,    72,  2028,  1029,
    2468,  2652,  2320,  2321,  3395,    74,    75,  1641,  4584,  2524,
     729,  2316,    76,  2191,    77,  4288,    99,   763,   118,   123,
     147,   693,  4545,   151,  2105,   170,   780,   693,  2794,   176,
     755,  2797,  3505,  1289,  1457,  4705,  4280,  3785,  1342,  1676,
    1677,  1311,  1423,   676,  1345,  4658,  4026,  4660,   617,  4828,
    1687,   567, -2318, -2354,  3908, -2377, -1854,  4817, -2408,   676,
    3107,  2219,  3108,  1640,  3163, -1846,  3112,  2826,  3352,  1396,
    4583, -2248, -1813,  1666,  4727,  3117,  3118,  3119,  3808,  2029,
     676, -2220, -2192,   896,  3986,  1695,  3991,  1679,  1680, -2220,
   -2220,  2332, -1826,  4927,  3140, -2221,  1870,  1122,  1054,  2445,
    4980, -2321,  1666, -2221, -2221, -1851,   715,  1688,  1371,  3098,
     676,  1454,   617,  1298,  1710,  2327,   676,  4736,  4737,  2690,
   -2569,  3328,  1054,  2409,  4446,  1876,  1170,  1126, -2569, -2569,
    4910,  1589, -1841,   617,   617,  1666,  3450,  1597,  2571,   617,
    4895,  4896,  3504,   772, -2191,  4324,  4325,  1666,  4327,  4328,
    4329,  2591,  2392,   617,  1286,  1660,  1878,  1920,  1454,   617,
    3550,  1454,  2690,   676,   796,  -132,   676,  4761,  4822,  1800,
    -132,  3261,  3555,  3263,  4437,  4421,  4823,  1397,  2134,  3793,
    2401,  2209,  3294,  3296, -1854,  4953,   839,  1372,  4230,   716,
     565,  2314,  1676,  1677,   908,  4887,  3450,  1123,  1125,  1127,
    3141,  4220,  1129,  1130,  1131, -2375,  2135,  3753,  1661,  5247,
    2406,  2629,  1136,   617,   682,   682,  4540,   682,  3073,  1687,
     682,   741,  1928,  5217,  1313,   178,  3087,  2186,  1752,  2047,
    2416,  1396,  1539,   682,  2267,  2848,   978,   683,   683,  1373,
     683,  2040,   978,   683,  1870,   178,   797,  2505,  4985,   876,
    1666,     3,     4,  1870,  4945,   978,   683,  4917,  2349,  4946,
    1690,  2572,   564,   682,  1929,  1921,  3352,  2446,   185,  4561,
    1561,  2350,  1484,  1876,  2209,   781,  3251,  3253,  3254,  4462,
    4986,  1691,  1876,   185,  2210,  4466,   683,  4562,   962,   909,
    4907, -2083,   617,  1761,  5000,  1692,  4819,  2351, -2083,  3352,
    5114,   876,  2209,  1662,  1878,  4871,   977,  4947,  2417,  1485,
    4818,   186,   987,  1878,  2630,  2849,  2030,  2187,  2279,  2209,
     742,  2556,  2407,  2048,  1598,  1001,   186,  3740,  4541,  1666,
    4954,  1019,   910,  1374,  1540,  2209,  4824,   717,  1299,  1397,
     825,  1667,  4918,  2209,  4221,  4919,  2136,  2138,  1019,  1666,
     842,  4888,  1666,  2220,  5248,  1663,  5295,  1043,  3307,  3012,
     618,  2402,  1727,  4920,  2221,  3754,  2222,  1863,  2209,  4231,
    1667,  1666,  1864,  2725,  3142,  4422,   718,   719,  3652,  1922,
    2726,  2234,  1314,  1743,  1315,  2631,  2115,   911,  2744,   954,
   -2102,  3295,  3297,  2616,  3720,  1569,  1398, -2102,  4952,  3770,
    1910,  3551,  4796,  1667,   973,  1019,  1300,   793,  3555,   182,
     959,   956,   957,   958,  2621,  1667,  2873,  3074,  1584,  1166,
   -1813,  1797,  3809,  4447,  2223,  4108,  1763,  3715,  2447,  2688,
   -2375,  3099,  1807,  1595,  1145,  2028,  2333,  5173,  3013,  1464,
    -422,  1598,  1018,   621,  1664,  2632,   773,  1816,  2633,  5050,
    2573,  4142,  1717,  2691,  1801,  1399,   798,  1819,   840,  3143,
     782,  1454,   617,  1801,  2334,   612,   676,   720,   568,  2290,
    2574,  1924,  2293,  2410,  5124,  2082,  1936,  1936,  1350,  1674,
    1118,  2028,  1690,  2268,  1378,   951,  1379,  1668,  2328,  4053,
    4359,  3014,  2175,  5161,  1598,  2315,  3415, -1813, -2375,  3246,
    5251,  4921,  2300,  1691,   182,  4241,  3988,   688,   689,  4387,
    1119, -2375,  1124,  4391,  1128,  3520,  1696,  1692,  1667,  3367,
    1132, -2318, -2354,  1019, -2377,  2309, -1846, -2408,   688,   689,
    4999,  1019,  1019,  1678,  2353,  1152,  4993,  2528,  1110,  1135,
   -2248,  1308, -2220, -2192,  5076,  1309,  3015,  1897,  2634,  1714,
    2252,  1560,  2510,  1682,  1113,  2545, -2221,  4287,   688,   689,
    2517,  1171,  2038,  4333,  1455,  1456, -1851,  1308,  4263,  1279,
   -2321,  1309,  1288,  1018,  1290,  1918,  2527,  1148,  2553,  4426,
    1573, -2569,  2177,  5204,   794,  1578,  3448,  2563,   795,  3448,
    1479,  5195,  2185, -1841,  1866,  1908,  2074,  1667,   876,  2504,
    2759,  2385,  2075,  4617,  4378, -2191,  4380,  4917,  3741,  4892,
    1690,  1455,  1456,  1480,  1455,  1456,  2912,  1667,  -132,  -132,
    1667,  3507,  1804,  3508, -2083,  2194,   182,   177,   172,   173,
     175,  1691,  1566,  2987,  3649,  5166,   825,  1764,  1148,  1667,
    1766,  1316,  1768,  3016,  1770,  1694,  1772,   842,  5170,  4075,
    1776,  2139,  4242,  3700,  3701,  2635,  2931,  4112, -1813,  2913,
    2023,  1371,  2126,  1319,  1725,  2280,  1145,  1353,  2283,  2284,
    3448,  4580,  5255,  5144,  4006,  5092,   974,   693,  1905,   693,
    2127,   693,  3653,  4206,  2126,  3785,   617,   693,  1133,  1134,
    2486,  2487,  1894,  1895,  1896,  1897,  3501,  3764,  1598,  1892,
    1893,  1894,  1895,  1896,  1897,  5116,  2727,  2036,  2874,  1403,
    2036,  2554,   617,  4920,  3364,  3365,  3366,  3367,  4034,  2751,
    2751,  2751,  5118, -2102,  2116,  5131,  1656,  1070,   613,  5287,
    4125,  2260,  4522,  2710,  4205,   617,  2988,  1285,  2128, -1669,
    1372,  1293,  4243,  1745,  5241,  3362,  3363,  3364,  3365,  3366,
    3367,  2363,  2794,  1324,  3481,   617,  2129,  3017,  5258,  5259,
    2128,  3861,  5102,  1748,  2838,  3018,  1717,  3123,  3019,  3694,
    3695,  4704,  2799,  1388,  1571,  4337,  3820,  4338,  2129,    63,
    2887,  2567,    72,   614,  5117,  3854,  2969,   859,  2976,  2191,
      74,    75,  1373,   178,   860,   861,   862,    76,  2483,    77,
    4604,    99,  3298,   118,   123,   147,  3349,  3350,   151,  3693,
     170,  3369,  1870,  3000,   176,  1137,  3819,  2903,  4809,   615,
    4024,   616,  2461,  2457,  4244,  2776,  4960,  1381,  2295,  3450,
    5197,  1466,  3450,  5270,  4126,  3199,  4644,  1912,  2970,  4701,
     789, -1813,  4140,   715,  5196,   562,  5303,  2458,  3399,  3400,
   -1813,  4921,  1678, -1813,  1366,  4302, -1813,   693,  3821,  2846,
    4777,  1487,  3045,  2568,  2767,  4048,  2711,   789,   729,  1520,
     703,  2712,  1878,  2800,  4268,  1533,  2979,  4049,  3299,  2439,
    1488,  1389,  3467,  1558,  4850,  3502,  1374,  4546,   178,   781,
    4049,  4622,  1717,  2904,  2130,  1538,  3575,  5132,  4269,  1467,
    1632,  1539,  2560,  2561,  1913,  4256,  3862,  2713,  5254,  2777,
    4778,  4339,  2457,  3450,  1455,  1456,  2130,  1534,  4779,  3448,
    4650,  1689,  3712,  1018,  4647,  4654,   716,  2971,  4656,  1489,
    3712,  4547,  4766,  2256,  1659,  3218,  2458,  2298,  3348,  1375,
    1018,  2615,  1633,  2618,  1906,  2394,  4780,  4961,  1732,  2625,
    3138,   617,  3472,  2555,  5219,  2639,  2640,  2641,  4973,   182,
    1701,  2440,  1471,  3101,  1701,  2657,  2659,  5093,  4245,  1765,
    2669,  1767, -2189,  1769,  1803,  1771,  1376,  1773,  1774,  1775,
      34,  3818,  1138,  2530,  1777,  1864,  3640,  1117,  5180,  2140,
    1733,  2732,  3124,  2507,  4995,  5005,  5007,  1018,  4992,  1071,
    2131,  2485,  3822,  1540,  3576,  2518,  4321,  1377,   793,  4432,
     178,  4570,  4781,  1490,  2369,  2308,  2523,  3815,  4962,  4972,
    2552,  4268,  2131,  4782,  2557,  4605,  2559,  4576,  2459,  2562,
    4998,  1702,  1390,    39,  4246,  1702,  2358,  1378,  3461,  1379,
    2714,  5201,  5202,   782,  2481,  4269,  1572,  3474,  3622,  4049,
    1559,  2373,  2888,  3059,  2522,  4994,  2370,  3542,  2907,  3060,
     787,  1491,  2537,   707,  1492,  3999,  3725,    43,  3823,  1391,
    1472,  2980,  2395,  1865,   717,  2294,  4036,  5227,  1535,  4270,
    1144,  4461,  1867,  4851,  2549,  2972,  4838,  1380,  4893,   908,
    5220,  1703,  3252,  4875,  1704,  1703,  1909,  4898,  1704,  3543,
    1392,  2258,  4166,  1634,  1511,  2645,  1494,    47,  1685,  1686,
     737,  2144,  3728,   718,   719,  1018,   693,  4557,  1926,  1927,
      48,  2145,   788,  1018,  1018,  2733,  3448,  2472,  4014,  2141,
    3448,  2903,   876,  2034,  2050,  2041,  2042,  4890,  2046,   795,
     795,  2480,   795,    49,  1444,  1512,  2806,  1869,  1332,  1496,
    1870,  1734,  4571,  1054,  1541,  1513,  3623,    50,  2441,  4726,
     713,  3061,  3450,  1145,  1393,  2494,   908,  3730,  4218,  1497,
    1308,  2442,  4845,  2051,  1309,  5289,  1536,  2917,  1598,  1876,
    4425,  5181,  4120,  2798,   909,  5228, -2570,  4867,  4015,  1499,
    3002,  1542,   789,  3249,  1705,  1705,  3577,  3578,  1705,  4783,
    2340,  1635,  4784,   185,  2947,  2521,  1054,  2904,  4996,  1836,
    1878,  4403,  4006,  5125,  2142,  2209,  1754,  2371,  4410,  1755,
    1353,  1473,  1543,  3579,  3385,  2217,  5108,   910,  -671,  2063,
    3392,  2259,   865,   866,   867,  4219,   868,   869,   870,   871,
     872,   873,  3027,  1009,  4906,  4319,   186,  1333,  4037,  1735,
     582,  4839,  4531,  3250,  4585,  4038,  5182,  3733,  1474,  3003,
    3544,   909,  2948,  2550,  1636,  4167,  4909,  2918,  4586,  2146,
     892,  4913,  4914,     3,     4,  2415,  2053,  3401,  2135,  4798,
    1717,  5183,   911,  2432,  1476,  1637,  4121,  2050,  4039,  1475,
    4711,  2929,  3715,  5179,   693,  2340,  2551,   893,  3734,   693,
     693,  1706,  3259,  1514,   910,  1706,  2147,  3624,   584,  4040,
    4644,  3234,  3062,  3735,  2807,  2372,  5047,  -571,  3239, -2570,
    1707,  2170,   790,  4799, -2570,  5229,  2051,  4224,  4808,  2299,
    5230,  3068,  2054,   662,  1295,  2304,  1515,  5203,  3258,  2683,
    1516,  4049,  5205,   178,  3625,  4088,  4795,    34,  3264,  3063,
      39,  1019,  3265,    14,   582,  3267,  1705,  2582,  3545,   911,
   -2570,  3271,  4257,  3272,  2506,  1717,  3274,  3026,  2831,  3450,
    2508,  1517,  2907,  3450,  2270,  3626,  2516,    39,  5054,  5055,
    3064,  2479,   825,  2052,    43,   825,  4122,    19,   876,   876,
    3566,  2311,  4196,  2340,  3005,  3006,  4199,  4200,  3009,  4202,
    3049,  2295,  4262,  3712,  3736,   693,  1824,  1885,  5253,  2565,
    3578,    43,   584,  1010,  2285,   693,  1338, -2211,  4089,  3170,
    4735,  -155,  4215,  2903,    47,  3311,  1833,  4138,   714,  2053,
     842,   842,  4587,  3093,  2751,  4443,  4099,    48,  3453,  1638,
    1717,  3065,  3182,  3183,  3184,  3185,  4216,  3874,  -155,  2426,
    1717,    47,  5122,  2431,  3190,  1133,  1134,  1849,  2860,  3028,
      49,   662,  2120,   595,    48,   596,  3567,  3031,  5288,  1011,
    3034,  1381,  1861,  2121,    50,  1012,  1381,  2926,  3066,  4056,
    1299,    14,  3501,  2843,  3650,  2054,  1340,    49,   693,   601,
    2122,   693,   693, -2570,  4763,  1338,  4305,  -447,  4306,  2904,
    5302,  2808,  4444,  5304,   842,  3892,   876,  3893,  1487,  3067,
    3888,  3889,  3890,  3891,  2861,    19,  3896,  3897,  3898,  3899,
    3900,  3901,  3902,  3903,  3904,  3905,  2856,  1488,  1479,  4732,
    3448,  2905,  1444,  3654,  4110,  3568,  4979,  3448,  3843,  3978,
    1381,  3169,  3448,  1503,  1381,  3448,  2286,  2411,  1300,  2287,
    3179,  1480,  4733,  3651,  1362,   582,  1642,    31,  4057,   793,
     793,  1166,   793,  2832,  1740,  1340,  2833,   595,  2906,   596,
    1748,  3448,  3944,  3945,   693,  4976,  1489,  1002,  1643,  3883,
    1504,  5004, -1075,  4049,  3448,    39,  1741,  1363,  3648, -2570,
    1002,  1364,  4990,  1614,    39,   182,  1892,  1893,  1894,  1895,
    1896,  1897,  3236,  4111,  3020,  1870,  1341,  5063,  3909,  -447,
    1003,  3979,  2539,   584,  2540,  4058,  2541,  4059,  2542,    43,
    2543,  3853,  1365,  1003,  2544,  2885,  1598,  4056,    43,  5015,
    2860,  3894,  2123,  4616,  1876,  3212,  4837,  2900,  3526,  4093,
    3010,  3895,  3980,  1004,  5238,  1113,  4442,   182,   959,   956,
     957,   958,  2949,  2588,   740,  5122,  3766,  3981,  2638,    47,
    1490,   682,  3854,   663,  2907,  1878,  4899,  3982,    47,  1690,
    2576,  4955,    48,  3020,  5064,  4710,  3794,  2933,  3471,  3798,
    2236,  3725,  2484,  1505,   683,    31,  3523,  3726,  2392,  1005,
    1691,  3818,  2492,  3983,  2493,    49,  2214,  3529,  2215,  3727,
    2497,  1356,  1005,  4902,  1694,  1019,  4057,  2503,  1491,   664,
    2950,  1492,  4544,    39,  4651,  3069,  4739,  4168,    50,   575,
     764,  2587,  2294,  2504,  4450,  4451,  2271,  3728,  3979,  3729,
    2226,  2274,  2653,  3490,  3045,  3283,  2819,  3608,  1357,  4169,
    2671,  2612,  4687,  3448,  4689,  4833,  3070,    43,  5115,  2760,
    3609,  4575,  5129,  1494,  2835,  3071,  2216,  3230,  1019,  3980,
    2839,  5104,  2227,  4058,  2842,  4059,   775,  3491,   595,  1358,
     596,  3351,  1291,  3450,  4393,  4555,  3984,  3588,  4732,  3590,
    3450,  2347,  3730,  3379,  3982,  3450,  3072,    47,  3450,  5022,
    2866,  3282,  1338,  1916,  1614,  2337,  1496,  1339,  1479,  2343,
      48,  4733,  4525,   582,  3448,   784,  2413,  1487,  3731,  2889,
    3270,  1368,  2893,  4535,  3450,  3402,  1497,  5023,  2348,  1748,
    2698,  1480,  2699,    49, -1069,   876,  1488,  3450,  2237,  3462,
    2450,  2627,  2628,  4526,  2919,   799,  1499,    50,  2642,  2643,
    1482,  4500, -1606,  1308,  1508,  2700,   785,  1309,  1369,  3404,
    4732,  3405,   978,  3428, -1606,  2238,  3131,  1546,  4652, -1606,
    1550,   584,  1340,  5057,  4501,  2881,  2681,  3732,  5014,   825,
    4054,  3506,  3733,  4733,  3406,  1489,   842,   691,  2239,  1370,
    2240,  1509, -1606,   691,  2967,  4214,  2244,  2245,  4600,  2795,
    2796,   676,   676,  3984, -1606,  4515,  5192,  4516,  4517, -1606,
    1690,  4518,  2285,  1341, -1606,  3556,  1809,  3174,  3675,  1810,
    2996, -1642,  1510,  3734,  3682,  2234, -1642,  2032,  3007,  2810,
    2033,  1691,  2925,  1319, -1606,   978,  3465,  3978,  3735,  3022,
    3583,  4983,  1179,  2035,   835,  3352,  2036,  2786,  1936,  3353,
    3354,  3355,  3920,  1018, -1606,  3448,  2701,  4185,   975,  3035,
     976,  2702,  2847,  4098,  3037,  1529,  2703,  2226,  3040,  1490,
    2850,  3619,  2853,  3773, -1606, -1606,  2616,  2751,  4186,   837,
    3413,  3057,  2751,  3783, -1606,   857,  5250,  3187,  2751,   178,
    3407, -1642,  3188,  3511,  3082,  3408,  3450,   898,  1678,  2227,
    2106, -1605,  1530,  1019,   978,  3011,  1531,  3324,  3620,  3979,
    3559,   858,  2036, -1605,  3448, -1606,  5290,  1491, -1605,  1308,
    1492, -2192,  1290,  1309, -1606,  3325,   595,  5163,   596,  3736,
    3326,  2294, -1642,  1532,  4084,  4691,   907,  5046,   598,  3621,
    3980,   178,  4700,  3479,  2286,  3448,  5280,  2287,   676,   600,
     961,  2911,  1614,  4076,  1678,  3981,  1366,  3450,  4090,  3301,
    4097,  4264,  1494, -1605,  2534,  3982,  3864,  2036,  2793,  2793,
   -1664, -1664,  1179,    39,  3090,  3352,  3313,  3724,   964,  3353,
    3354,  3355,  3188, -1605,  3614,  2616,   979,   967,   980,  3319,
     222,  3983,  1823,   970,    50,   566,  3933,  3515,  3769,  2704,
     787,   997,  3836,   660,  3838,  1496,  3840,    43,  4113,  2705,
    3831,  3832, -1643,  3844, -1606,  2696,  2474, -1643,  2475,  3356,
    1019,   738,  3742,  2546, -1605,  1497,  2547,  4033,  3409,   693,
    3459,  3460,  1678, -1605,  2106,  3512,  3513,  1678,  3410,  2106,
    3357,  2548,  1148,  1148,  2547,  1499,  1148,    47,  2579,  4744,
    3721,  2580,  3865,   984, -1606,  3378,  3448,  3380,  3381,  4290,
      48,  2773,   788,  2818,  1748,  -570,  2036,  1869,  3085,  1006,
    1870,  2976,  3533,  4109,  3984,  2923,  1308,  1007,  2924,  1328,
    1309,  2994, -1643,    49,  2995,  3128,  3133,  3237,  3129,  3134,
    2036,  3103,  4745,  1008,  3103,  3000,  3103,    50,  3450,  1876,
    3103,  3205,  3358,  3206,  3276,  1869, -2570,  2547,  1870,  3103,
    3103,  3103,  3045,  3323,  1021,  5277,  2036,  4746,  3332,  4789,
    4942,  2036,  4944, -1643,  4740,  1078,  4948,  3288,  4949,  1026,
    1878,  2236,   789,  3338,  4747,  1069,  2036,  1876,  4748,  4207,
    3339,  4208,  2236,  2036, -2570,  3302,  3340,  1079,  3371,  2036,
    2236,  2036,  3384,  3288,  1085,  2036,  3389,  3450,  4749,  3390,
    3316,  4750,  3601, -1605,  2236,  3602,  3606,  3181,  1878,  3607,
    3357, -1668, -1668,  1179,  4984,  4751,  3352,  1092,  3712,  4596,
   -2570, -2570, -2570,  3218,  5291,  1099,  5292,  3448,  3450,  1148,
    3635,  4275,   693,  3630,   676,  3806,  3631,  3412,  3807,  3213,
     693,  3829,  3175,   693,  2036,  3643,  1108,  1018,  3200,  4051,
    4052,  5236,   178,  1139,  3710,  3915,  3925,  3312,  3916,  3926,
    3936,   825,  3710,  2036,  1143,  4022,  4027,   842,  4023,  4028,
    4032,  4055,  3358,  2833,  2547,  3943,  2292,  4265,  4316, -2570,
    2547,  1801,  4334,  1147, -2570,  2036,  3759,  2317,  4360,  4372,
    4428,  2580,  2036,  2833,  1150,  2346,  4752,  5261,  1155,  3448,
    1018,  3535,   790,  4434,  4753,  4440,  4435,  4441,  2547,  2914,
    2547,  4577,  5160,  4624,  4578,  1153,  4625, -2570,  3546,  2237,
   -2570,   876, -2570,  1019,  3429,  1019,  3430,  3359,  3360,  3361,
    2237,  3362,  3363,  3364,  3365,  3366,  3367,    28,  2237,  3450,
    2675,  4829,  1156,  2678,  4754,  2504,  2238,  4626,  4634,  1157,
    2036,  2580,  2237,  4706, -1667, -1667,  4707,  2238, -2570,  4790,
    4830,  1869,  2547,  4831,  1870,  2238,  3431,  1885,  3432,  2239,
    1328,  2240, -1594,  3857,  4392,  3743,  4395,  3745,  4846,  2238,
    2239,  2580,  2240,  3752,  4854,  3755,  1163,  4855,  2239,  1561,
    2240,  4864,  3475,  1876,  1748,  4870,  5312,   782,  3780,  1164,
   -2570,  1165,  2239,  1019,  2240,  1885,  2234,  1335,  1167,  1337,
    4872,  3451,  3627,  3780,  3629,  1168,  4885,  2234,  3885,  4886,
    1166,  1169,  1172,  4098,  1878,  2234,    39,  4418,  4935,  4975,
    5006,  4936,  1915,  4886,  5016,  5017,  1173,  2580,  3390,  2234,
    1175,   782,  2236,  4619,  3870,  3245,  3247,  5018,  1294,  1297,
    2036,  3255,  3914, -2570,  1301,  3812,  1303,  3359,  3360,  3361,
      43,  3362,  3363,  3364,  3365,  3366,  3367,  3850,  1302,  5029,
    3450,  3451,  5030,  3358,  5035,  1307,  5038,  1748,  3531,  3780,
    1320,  4000,  4001,  4002,  1325,  1328,  4459,  2653,  2653,  1326,
      39, -2570,  2653,  1329,  1336,  3676,  2236,  3956,  1351,  5062,
      47,  4091,  2580,  2236,  5068,  1352,  5069,  2580,   693,  2580,
    1366,  5072,  5074,    48,  5073,  5075,  2028,  1355,  1359,  1425,
    3434,  3435,  3436,  3690,    43,  5100,  3995,  1401,  5101,  2653,
    2653, -2222,  1428, -2570,  3863,  1018,    49,  5148, -2570,  4575,
    5149,  5152,  3450,  1430,  1748,  2616,  4072,  2989,  5130, -2570,
      50, -1373,  5153, -1373,   782,  2036,  1892,  1893,  1894,  1895,
    1896,  1897,  1431,  1464,    47,   182,   959,   956,   957,   958,
    2236,  1468,  5154,  5156, -2570,  2036,  2036,    48,  5175,  5199,
    5223,  5176,  5200,  3780,  1469,  5235,  3610, -2570,  4878,  5260,
    2237,  1470,  4886,  1476,  1892,  1893,  1894,  1895,  1896,  1897,
      49,  3647,  1179,  5298,  1478,  3352,  5073,  1483,  3655,  3353,
    3354,  3355,  5300,  1486,    50,  5301,  1869,  2238,  1521,  1870,
    1522,  1885,  1537,  2933,  4307,  4203,  3934,  1547,  4309,  1869,
    4191,   178,  1870,  1548,  1551,  1556,  1871,  1872,  1873,  1557,
    2239,  1562,  2240,  2236,  2237,  1564,  5315,  2236,  1876,  5149,
    1565,  2237,  1018,  1874,  3828, -2570,  1567,  1574, -2570, -2570,
   -2570,  1876,  3362,  3363,  3364,  3365,  3366,  3367,  1877,  5322,
    1570,  2238,  5301,  1575,  1581,  3687,  1582,  2234,  2238,  1878,
    1588,  1869,  1591,  1585,  1870,  1594,  1596,  1602,  1871,  1872,
    1873,  1605,  1878,  1607,  2239,  1598,  2240,  5206,    28,  3688,
    1616,  2239,  1617,  2240,  1621,  1874,  1622, -2570,  -175,  3466,
    4355,   693,  1624,  1876,  1625,  1627,  1629,  1630,  2237,  1645,
    1877,  1652,  1654,  1658,   204,  1665,  1671,  4844,  1672,  1673,
    1674,  2234,  3480,  3480,  1678,  3710,  1681,  1682,  2234,  3604,
    1684,  3475,  1698,  1700,  1878,  2238,  3946,  1712,  4077,  3475,
    3878,  1713,  4114,  1717,  4596,  1716,  1724,  1728,  1729,  4137,
    1731,  1736,  1737,   702,  1739,   704,  1751,  1744,  2239,   710,
    2240,  3887,  1747,  1750,   724,   732,   702,  1753,   739,  1778,
    1806,   732,   732,  1811,   768, -1817,   771,    39, -2570,  1813,
    3641,  2237,  1814, -2570,  1820,  2237,  3910,  1821, -1824,  1828,
    3357,  1879,  1830, -2570,  1829,  2234,  1880, -1814,  1831, -1815,
    1892,  1893,  1894,  1895,  1896,  1897,  1832,    50,  2238, -1818,
    1834,    43,  2238,  1835, -1816,  1836,  1861,  1881,  1882, -2570,
    1804,  1837,  1838,  1839,  1841,  1842,  1843,  1844,  1845,  1846,
    1847,  2239,  1883,  2240,  4448,  2239,  1848,  2240,  1179,  1850,
    1851,  3352,  3678,  1879,  1852,  3353,  3354,  3355,  1880,  1853,
    1854,    47,  3358,  1903,  1855,  1856,  1857,  1901,  1905,  1919,
    1861,  1931,  2340,  1906,    48,  1884,  1885,  1915,  2234,  1881,
    1882,  1939,  2234,  3103,  2039,  4471,  4472,  2696,  3852,  1885,
    1339,  2070,  1886,  1341,  1883,  3703,  2081,    49,  2072,  2083,
    2084,  3714,  2101,  3422,  2085,  3012,  2102,  2103,  2104,  3714,
    2106,  5207,  2107,  3866,  2108,  1018,  2110,  1018,  2109,  3441,
    2111,  2112,  2118,  2137,  2143,  3156,  2149,  1884,  2172,   826,
     831,   831,   834,  2176,   831,  2178,  2180,  2179,   843,  2181,
     768,  1885,  2183,   878,  1886,  2184,  2199,  2200,  2201,   178,
     768,  2212,   831,  2213,  2228,   768,  2224,  2230,  2231,   831,
    2232,   768, -2570,  3778,  2233,  5028,  2242,  4551,  2234,  2243,
    2247,  4512,  4513,  2246,  2248,  1887,  2257,  2253,  4313,  3441,
    4237,  4238,  2269,   781,  3013,  2254,  4344,  2265,  2266,  2272,
    2263,  2281,  2264,  2288,  3811,  1018,  2276,  2291,  1444,  2306,
    2312,  2313,  2303,  3801,  2329,  2277,  2330,  2335,  2359,  2336,
    2289,  2357,  2296,  2297,  2360,  2310,  2301,  2362,  2302,  2366,
    4275,  2361,  2367,  4743,  2368,  3827,  2305,  1887,  2307,  2318,
    2374,  2319,  2375,  4310,  4311,  4312,  2331,  3014,  2341,  2376,
    2345,  2377,  2378,  2381,  2386,  2387,  3357,  3359,  3360,  3361,
    2388,  3362,  3363,  3364,  3365,  3366,  3367,  3950, -2570,  2393,
    2396,  2397,  2379,  2400,   577,  1892,  1893,  1894,  1895,  1896,
    1897,  1888,  2405,  2414,  1889,  1890,  1891,   693,  1892,  1893,
    1894,  1895,  1896,  1897,  2425,   693,  4609,  3157,  4610,  4611,
    4416,  3343,  3015,  1505,  2429,  2433,  2430,  2411,  2438,  2449,
    2456,  2452,  4615,  2455,  3451,  2465,  2469,  3451,  3358,  3756,
    1869,  1148,  2471,  1870,  2477,  2473,  2482,  1871,  1872,  1873,
    2488,  2490,  2491,  1888,  2495,  2498,  1889,  1890,  1891,  2509,
    1892,  1893,  1894,  1895,  1896,  1897,  2499,  2500,  2496,  2502,
    2511,  2501,  1876,  3393,  2513,  2512,  2525,  2526,  2558,  1877,
    2514,  2577,  2564,  2590,  2621,  4073,  2626,  2670,  1870,  2676,
    2689,  2680,  2730,  2695,  2707,  2709,  2744,   782,  2729,  2761,
    2758,  3931,  2762,  1878,  2764,  2774,  4239,   788,  2765,  2787,
    2775,  2766,  2788,  2790,  2804,  2789,   782,  2811,  3451,  3016,
    3830,  2653,  2653,  2653,  2653,  2822,  2823,  2653,  2653,  2653,
    2653,  2653,  2653,  2653,  2653,  2653,  2653,  2851,  2856,  2875,
    2825,  3958,  3959,  3960,  3961,  2858,  2859,  2854,  4465,  2865,
    2882,  2870,  3475,  2876,  3918,  4414,  2878,  2899,  2880,  2890,
    2886,  3158,  2898,  1179,  2902,  2915,  3352,  2916,  1291,  2921,
    3353,  3354,  3355,  1295,  2932,  2937,  3475,  2938,  2951,  2956,
    2978,  2957,  2983,  2653,  2653,  2984,  2986,  4362,  2993,  3021,
    3001,  3077,  3096,  3100,  3104,  3097,  4170,   693,  3089,  4173,
    3109,  3110,  3111,  3115,  3147,  3122,  3159,  3126,  3120,  3127,
    3135,  3148,  1879,  3162,  3166,  3164,  3168,  1880,  3180,  3177,
    3194,  3186,  3202,  3359,  3360,  3361,  3195,  3362,  3363,  3364,
    3365,  3366,  3367,  3017,   917,  3197,  3198,  4457,  1881,  1882,
     768,  3018,   826,  3189,  3019,   831,  3208,   834,  3210,   831,
    3196,  3211,  3214,  1883,  3215,  4560,   878,  3229,  3228, -2475,
    3231,   990,  3232,   831,  5271,  5272,  3233,  3235,  3240,  3238,
     831,  3241,  3268,  3242,  4536,  3256,  3243,  3244,  3248,  3257,
    3266,  4502,  4503,  1705,  4505,  3269,  1884,  3273,  1804,  3275,
    3278,  3279,  3280,  3281,   826,  1748,  4250,  1745,  1714,   834,
    1885,  3289,  2591,  3292,   843,  3291,  3293,  3308,   878,  3300,
    3303,  1145,  3714,  4496,  3310,  2340,   178,  3317,  3315,  3318,
    3314,  3334,  3320,  3335,  3336,  3337,  3341,  3348,   831,  4843,
    3342,  3344,  3347,  3370,  3386, -2075,  4141,  2036,   178,  3376,
    3383,  3420,  3397,  4149,  3403,  2295,  4150,  3398,  4151, -2475,
    3411,  4148,  3421,  3483,  3423,  3424,  3425,  3427,  3477,  4662,
   -1670,  3357,  3482,  4939,  3453,  3485,  4677,  3451,  3458,  3489,
    4743,  3509,  3487,  3516,  3496,  3525,  4756,  3514,  3517,   768,
    3528,  3537,  1179,  3521,  3563,  3352,  1887,  3288,  4190,  3353,
    3354,  3355,   768,  3530,  1162,  3552,  3103,  3553,  3565, -2475,
    3103,  3103,  4891,  3103,  3220,  4553,  4363,  4929,  3703,  4931,
    3503, -2475,  4449,  3522,  1276,  1276, -2475,   768,   732,  3570,
    3569, -2475,   732,  3358,  1404,  3571,  3572, -2475,  3586,  3587,
   -2475,  3589,  3597, -2475,  3605,  3595,   768,  3596,  3615,  3632,
     768,  3634,  1801,  3638,  3636,  3639,  1276,  3642,  3645,  3644,
    4470,  3646,  4934,  3656,  3658,  3660,  3659,   768,  1405,  3661,
    3662, -2475,  3663,  3664,  3673,  5147,  3665,  3668,  3670,   768,
    3666,  4485,  3667,  3672,  3681,  3669,  3671,  3677,  3679,  3674,
    2327, -2475,  1888,  3692,  3683,  1889,  1890,  1891,   693,  1892,
    1893,  1894,  1895,  1896,  1897,  3696,  2653,  3705,  3697,  3699,
    3684,  3686,  3716,  3719,  3750,  3760,  1179,  4289,  3761,  3352,
    3751,   768,   693,  3353,  3354,  3355,  3757,  1407,   693,  3763,
    3765,  4285, -2475,  3768,  3782, -2475,  1861,  3795,  3789,   768,
    3710, -2475,  3779,  5031,   831,   831,  4511,  3796,  3799,  4787,
    3800,  3780,  3965,  3804,  3803,  3970,  3792,  3816,  3826,  3837,
    3839,  1408,  3846,  3847,  3848,  3849,   876,  3856,  5078,  3858,
    3859,  3860,  3867,   732,   732,  3833,  3834,  3868,  3851,  3835,
    3869,  4323,  4323,  4323,  3451,  4323,  4323,  4323,  3451,  4694,
    3357,  3221,  3871,  3872, -2475,  3873,  1409,  1823,  1133,  1134,
     826,  3877,  3373,  3352,  3886,  3927,  4853, -2074,  3372,  3938,
    3939,   843,   789,  5084,  5086,   878,  3951,  3968,  3359,  3360,
    3361,  3957,  3362,  3363,  3364,  3365,  3366,  3367,  3911,  3912,
    1410,  3913,  3992,   831,  3997,  4848,  4016,  4717,  3919,  3942,
    3969,  4712,  4007,  3994,  4010,   707,  3977,  4019,  4009,  4011,
    4021,  4012,  3358,  4025,  4035,   768,  4042,  4601,  4063,  4065,
    4480,  1412,   831,   831,  4066,  4071,  4078,  4079,  4080,  4083,
    4081, -2475,  4490,  4085,  4101,  4143,  1863,  4087,  4104,  4116,
    4117,  4119,  4118,  4131,   768,   768,   768,  4129,   831,  4146,
     826,  4130,  4132,  4156,  4157, -2475,  5286, -2475, -2475,  1804,
    4145,    34,  4162,  4165,  4180,  1414,  4133,  4134,  4182,  4184,
    4092,  4187,  1415,  4194,  3357,  4222,  4195,  4211,  4234,  4225,
    1416,  4411,  4197,  4413,  4198,  4201,  4255,  4240,  2193,  4248,
    4254,  1869,  2547, -2475,  1870,  4258, -2475, -2475, -2475,  4260,
    1418,   693,  4267,  4277,  4261,  5286,  4282,  4383,  1419,  4283,
    5177,  4296,  4295,  4417,  4419,  4298,  4303,  4308,  4314,   831,
    5286,   831,   831,  1876,  4318,  4300,  4320,  4326,  4345,  3223,
   -2570,  4430,  4336,  4301,  4863,  4299,  3358,  4304,  4331,  4340,
    4346,  4347,  4348,  4341,  1179,  4863,  4349,  3352,  4353,  1276,
    4368,  3353,  3354,  3355,  1878,  4381,  4388, -2076,  4384,  4386,
    4389,  4397,  4396,  1420,  4401,  4402,  5078,  3224,  2411,  4404,
    4941,  4407,  5091,  4405,  4415,  4408,  4409,  4424,  4468,  1781,
    1781,  4427,  4429,  4431,   768,  4436,   702,  4463,  4437,  4464,
    4467,  4445,  4539,  4474,  4486,  4473,  4493,  3359,  3360,  3361,
    4475,  3362,  3363,  3364,  3365,  3366,  3367,  1812,  4495,  4498,
     768,  4489,  4514,  1818,  4499,  4506,  4519,  4527,  4528,  4533,
    4534,  3947,  5021,  3288,  4933,  1019,  1276,  4542,  4543,  4537,
    4548,  4552,  4549,  4556,  4550,  4558,  4566,  4569,  1869,  5037,
    4574,  1870,  4581,  5237,  5039,  3441,  5041,  4591,  4592,  4602,
    4593,  4594,  4607,  4614,  4613,  4579,  1276,  4589,  4620,  4509,
    4510,  4631,  4621, -2570,  4623,  4628,  4630,  4645, -2570,  3103,
    1876,  3103,  3103,  4632,   178,  3103,  4639, -2570,  4655,  4633,
    4648,  4675,  4659,  4682,  1276,  1276,  1276,  4685,  1276,  4688,
    4699,  4703,  4708,  4709,  4714,  4738,  4679,  4702,  4720,  4721,
    4725,  1878,  4730,  4731, -2570,  4757,  4759,  4221,  1276,  4765,
    4767,  4769,  4772,  4770,  4773,  4776,  4775,  4793,  5056,  4794,
    4803,  3359,  3360,  3361,  4801,  3362,  3363,  3364,  3365,  3366,
    3367,  4806,  3288,  4811,  3288,  4568,  4813,  4820,  4821,  4832,
    1804,   693, -2570,  4849,  4836,   693,   768,  4834,  3451,  1276,
     876,  1885,  5036,  4835,  4852,  3451,  4856,  4862,  4878,  4572,
    3451,  4873,  4866,  3451,  4657,  4882,  4869,  4874,  4366,  4595,
    4483,  4484,  4883,  4901,  4876,  4487,  4488,  1276,  4894,  4903,
    3676,  1276,  1276,  4716,  4904,  4718,  4910,  3475,  4916,  3451,
    4956,  4958,   768,   768,  2080,  4963,  1276,  4967,   876,  4970,
    4323,  4977,  3451,  4968,  3358,  4982,  4988,  5053,  4989,  4997,
   -2570,  5001,  5003,  5002,  5010, -2570,  5013,  5011,   732,  5012,
    1019,  5019,  5020,  5044,  5027,  4758,  5040,  5048,  5049,  5043,
    5065,  5061,  5083,  5089,  1804,  5090,  5051, -2570,  5106,  1804,
    1804,  5094,  5099,  5096,  5103,  5107,  5113,  5126,  5127,  5134,
     842, -2570,  3441,  2182,  5169,  5128,  3441,  5135,   732,  5143,
    5171,  5092,  3952,  5093,  5162,  5145,  5178,  5187,  5188,  5218,
    5164,  5226,   768,  2208,  2653,  5233,  5246,  5269,  5273,  5186,
    5243,   768,  5252,  4627,   831,  5267,  5279,  5268,  5275,  5293,
    5294,  5296,   842,  5299,  5313,  5306,   178,   178,  1885,  5307,
    5314,  5316,  5317,  5318,  1330,  2342,  3171,  3468,  1519,   878,
    1938,   768,  3050,  4680,  2982,  1518,  4100,  1429,  3580,  4107,
    5278,  5172,  3704,  3088,   768,  4204,  4950,   768,  5077,  5244,
    4236,  4812,  4532, -2570,  4786,  3519,  3277,  5165,  4692,  5097,
    1892,  1893,  1894,  1895,  1896,  1897,  5185,  3714,  5240,  5095,
    5257,  5009,  4286,  3524,  4266,  5059,  4229,  3145,  3146,  3767,
    4105,  3451,  3599,   768,  4253,  4554,  1507,  4792,  3775,  3136,
    4797,  5245,  5319,  5311,   831,   831,   831,   831,   768,  4771,
    3722,  3717,  5190,  4719, -2570,  4912,  5067,  2404,  3103,  3359,
    3360,  3361,   768,  3362,  3363,  3364,  3365,  3366,  3367,  4722,
     709,  4315,  4889,  2355,  1808,   768,  4292,  1869,  3510,  5008,
    1870,  2515,  2828,  2478, -2570, -2570, -2570,   831,   831,  1093,
    2584,  3680,  3451,  2585,  4155,  4135,  2586,  3771,  5209,  5305,
    1798,  1593,  1020,  2769,  2117,  4420,  2770,  4681,   831,  1876,
    2538,  5159,  4029,  1911,  4791,  1304,  1877,  3473,  2803,  3484,
    2066,  2037,  2784,  4008,  5155,  5042,  4412,   768,  1019,  2802,
    2071,  3972,  4379,  2067,  4394,  4868,  3966,  5026,  5025,  4030,
    1878,  3967,  2076,   831,   831,   831,   831,  5225,  5308,  5146,
   -2570,  5274,  4847,  4825,  2489,  3921,   768,  1892,  1893,  1894,
    1895,  1896,  1897,   768,  5157,  4678,  2355,  5158,  5142,  2734,
    3418,  3329,  3470,  3416,  2743,     0,   826,     0,     0,   826,
       0,     0,   782,     0,   834,     0,     0,     0,     0,  1276,
       0,     0,     0,   693,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4969,
       0,     0,   178,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5151,   843,   843,     0,     0,  2653,     0,
       0,     0,     0,  3451,     0,   878,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1879,
       0,     0,     0,  2653,  1880,   831,   831,     0,     0,     0,
       0,     0,   831,     0,   768,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4926,  4926,     0,     0,   876,     0,
       0,     0,     0,     0,     0,     0,     0,  1018,     0,  1781,
    1883,  4943,  3451,     0,     0,     0,   831,     0,   843,     0,
       0,  4951,   768,   768,     0,   831,     0,     0,     0,     0,
       0,     0,   768,     0,     0,     0,     0,     0,     0,   768,
       0,     0,     0,  3451,   702,   702,     0,     0,  2593,     0,
       0,     0,  1276,  3441,  1276,     0,     0,  1885,  3441,  1276,
    1276,  3441,     0,     0,     0,     0,  1276,  1276,  1276,     0,
       0,     0,  1276,   878,  1276,  1276,  1276,  1276,  1276,  1276,
       0,  1276,     0,  1276,  1276,     0,     0,  1276,  4991,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2477,     0,  1276,  1276,  1276,  1276,     0,     0,     0,   831,
    1276,     0,     0,     0,  1276,     0,     0,  1276,     0,     0,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,     0,
    1276,     0,     0,     0,     0,     0,   768,  1276,     0,  1276,
       0,     0,  3288,  1887,     0,     0,   768,     0,     0,     0,
       0,     0,  5168,     0,  3451,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5045,     0,     0,     0,     0,
     693,   693,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   693,     0,     0,  2653,     0,     0,     0,
   -2477,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1018,     0,     0,     0,  5081,     0,  5082,     0,
       0,     0,  5087,  5088,     0,     0,     0,   178,     0,   842,
       0,     0,     0,     0,  5215,  5216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1888,
   -2477,     0, -2570, -2570, -2570,     0,  1892,  1893,  1894,  1895,
    1896,  1897, -2477,     0,     0,     0,   178, -2477,     0,     0,
       0,     0, -2477,   768,     0,   768,     0,  1276, -2477,     0,
    5194, -2477,     0,     0, -2477,     0,     0,     0,     0,     0,
    1276,     0,     0,     0,     0,  3451,     0,     0,     0,  1276,
    1276,   842,   842,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2477,   768,     0,     0,     0,     0,     0,     0,
    2812,     0,  2817,     0,     0,     0,     0,     0,     0,     0,
    3441,     0, -2477,     0,     0,     0,     0,     0,     0,     0,
       0,  1861,     0,  2594,     0,     0,     0,  4926,     0,  4926,
       0,     0,     0,   834,     0,     0,     0,     0,     0,     0,
       0,     0,   702,     0,   702,     0,     0,  3451,  2653,     0,
       0,     0,     0, -2477,     0,     0, -2477,     0,     0,     0,
       0,  1276, -2477,     0,     0,     0,     0,     0,     0,     0,
       0,  2595,     0,   826,     0,   831,   831,     0,     0,  5191,
     843,     0,   878,     0,   831,     0,   831,     0,     0,     0,
     831,     0,     0,   768,     0,     0,     0,  5320,  5321,     0,
       0,     0,     0,  2596,   182,  5214,  5211,  5212,  5213,     0,
       0,     0,     0,     0,   732, -2477,     0,     0,     0,     0,
       0,     0,     0,     0,  2208,     0,  2597,     0,     0,     0,
    1018,     0,  2935,  5266,     0,     0,     0,  2598,     0,  2946,
       0,     0,     0,     0,     0,     0,  5310,     0,   768,     0,
       0,  3441,     0,     0,     0,     0,     0,  2599,     0,     0,
       0,   178,  2600,  5224,   842,   842,   707,     0,     0,   768,
       0,     0,     0,     0,  2991,  2991,     0,     0,   182,  5214,
    5211,  5212,  5213,     0,   768,   768,     0,     0,   768,     0,
     834,   732, -2477,     0,     0,     0,     0,  4926,     0,     0,
       0,     0,     0,   693,     0,   693,  5285,     0,  1487,   831,
       0,  2601,   831,     0,     0,     0, -2477,     0, -2477, -2477,
       0,     0,     0,     0,     0,     0,     0,  1488,     0,     0,
       0,     0,  2602,   768,   768,     0,     0,     0,   178,     0,
       0,     0,     0,     0,     0,  2653,  2653,     0,  3076,     0,
    3079,  3081,     0,     0, -2477,  5285,     0, -2477, -2477, -2477,
       0,     0,     0,   182,  5214,  5211,  5212,  5213,     0,     0,
    5285,     0,     0,     0,     0,     0,  1489,  4092,     0,     0,
     831,     0,     0,     0,  2140,     0,     0,     0,   831,   831,
       0,     0,     0,     0,     0,   831,     0,     0,   204,     0,
       0,  2603,     0,     0,     0,     0,     0,  1276,     0,   831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2208,     0,     0,  2991,  2604,   768,     0,
       0,   768,     0,     0,  2605,  3172,     0,     0,   702,  4093,
       0,  2606,     0,     0,     0,     0,     0,     0,     0,     0,
     831,  1276,     0,     0,     0, -2491,     0,     0,     0,     0,
    1490,     0,     0,     0,     0,     0,     0,     0,  3076,  2607,
       0,     0,     0,   693,  2608,     0,     0,  2609,   831,     0,
    3204,     0,  5284,     0,  1868,     0,     0,     0,     0,  1869,
       0,     0,  1870,     0,     0,  2610,  1871,  1872,  1873,     0,
       0,     0,     0,  1276,     0,     0,     0,     0,  1491,     0,
       0,  1492,     0,  1874,     0,     0,  1875,     0,     0,     0,
    2611,  1876,  2294,     0,  4094,     0,     0,     0,  1877,     0,
     831,  5284,   831,  2991,   831,  2991,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -2491,  5284,     0,     0,     0,
       0,     0,  1878,  1494,     0,     0,     0,     0,     0,     0,
       0,     0,   178,     0,     0,     0,     0,     0,  1781,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   178,     0,
       0,     0,     0,     0,     0, -2491,  1496,     0,     0,     0,
       0,     0,     0,     0,     0,   768,     0, -2491,     0,     0,
       0,     0, -2491,     0,     0,   826,  1497, -2491,     0,     0,
       0,   843,     0, -2491,     0,     0, -2491,     0,     0, -2491,
       0,     0,     0,     0,   831,     0,  1499,     0,  4095,     0,
       0,  4096,  1276,     0,     0,     0,     0,  1276,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2491,     0,     0,
       0,  1879,  5265,     0,     0,     0,  1880,     0,     0,     0,
    1276,  1276,  1276,     0,     0,  1276,  -128, -2491,     0,     0,
    1404,     0,     0,  1276,  1276,  1276,  1276,  1881,  1882,     0,
       0,     0,     0,     0,     1,     0,  1276,     0,     0,  1276,
       0,  1276,  1883,     0,     2,     0,     3,     4,     0,     0,
       0,     0,  1276,  1276,  1405,     0,  1276,     0, -2491,     0,
       0, -2491,     5,     0,     0,     0,     0, -2491,   878,     0,
    1276,     0,  1276,     0,  1276,  1884,     0,     0,     0,  2234,
       0,     0,     6,     0,     7,     8,     0,   178,     0,  1885,
       0,     9,  1886,    10,  1276,     0,     0,     0,   768,     0,
       0,     0,     0,     0,    11,  3452,    12,  1276,  1276,  1276,
       0,     0,     0,  1407,     0,     0,     0,     0,     0,     0,
   -2491,     0,     0,    13,     0,  1276,    14,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1276,     0,     0,     0,
      15,     0,    16,     0,     0,     0,    17,  1408,     0,     0,
       0,  1276,    18,     0,     0,     0,     0,     0,     0,     0,
      19,     0,    20,     0,     0,  3452,     0,     0,    21,  3495,
       0,   707,  3498,     0,  2817,  1887,     0,     0,     0,     0,
       0,     0,  1409,     0,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1869,     0, -2491,  1870,     0,
      23,     0,  1871,  1872,  1873,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1276,  1410,  2991,     0,  1874,
       0, -2491,  1781, -2491, -2491,     0,     0,  1876,     0,     0,
       0,     0,     0,     0,  1877,     0,     0,     0,     0,    24,
      25,     0,     0,     0,     0,    26,     0,  1412,     0,   831,
       0,   831,   831,   831,     0,     0,   918,    27,  1878, -2491,
       0,   919, -2491, -2491, -2491,     0,     0,     0,     0,    28,
       0,  1888,     0,     0,  1889,  1890,  1891,     0,  1892,  1893,
    1894,  1895,  1896,  1897,     0,     0,     0,    34,     0,  2192,
       0,  1414,     0,     0,     0,   920,     0,     0,  1415,     0,
       0,     0,     0,     0,     0,     0,  1416,     0,   921,   922,
       0,    29,     0,     0,  2193,     0,     0,     0,     0,   923,
       0,     0,     0,   924,    30,     0,  1418,     0,     0,     0,
      31,    32,     0,    33,  1419,     0,     0,     0,    34,     0,
       0,   925,     0,    35,     0,     0,    36,     0,     0,     0,
       0,    37,     0,     0,     0,     0,     0,    38,    39,     0,
       0,     0,   768,     0,   926,    40,     0,  1879,     0,    41,
       0,     0,  1880,     0,     0,   927,     0,     0,     0,    42,
       0,     0,     0,   928,     0,     0,     0,     0,     0,  1420,
       0,     0,    43,  1881,  1882,   929,     0,     0,     0,     0,
     930,     0,     0,     0,     0,     0,     0,     0,  1883,     0,
       0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,     0,     0,   931,     0,     0,    46,     0,     0,
       0,     0,    47,     0,     0,     0,     0,     0,     0,     0,
       0,  1884,     0,     0,     0,    48,     0,     0,     0,   932,
       0,     0,     0,     0,     0,  1885,     0,     0,  1886,     0,
       0,     0,     0,     0,     0,     0,   831,     0,    49,     0,
     933,  2991,  2991,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    50,     0,     0,  -128,     0,     0,     0,  1869,
       0,     0,  1870,     0,     0,     0,  1871,  1872,  1873,     0,
       0,     0,     0,     0,   934,     0,     0,     0,   768,   768,
     768,     0,     0,  1874,     0,     0,     0,     0,     0,     0,
       0,  1876,     0,     0,     0,   768,   935,     0,  1877,     0,
       0,     0,     0,     0,     0,     0,   204,     0,     0,   936,
       0,  1887,     0,     0,     0,     0,     0,  1781,   768,     0,
       0,     0,  1878,     0,     0,     0,     0,  1781,   768,   768,
       0,     0,     0,   768,     0,   937,     0,     0,     0,     0,
     938,     0,   939,     0,     0,     0,   768,     0,     0,   940,
       0,     0,   941,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   942,     0,     0,     0,     0,     0,   943,     0,     0,
       0,     0,   944,     0,     0,   945,     0,     0,     0,   946,
       0,     0,     0,     0,     0,     0,   947,     0,   948,     0,
       0,     0,     0,   949,   831,     0,     0,  1888,     0,     0,
    1889,  1890,  1891,     0,  1892,  1893,  1894,  1895,  1896,  1897,
       0,     0,     0,   768,  2679,     0,     0,     0,   950,     0,
       0,  1879,     0,     0,     0,     0,  1880,     0,  1869,   768,
       0,  1870,     0,     0,     0,  1871,  1872,  1873,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1881,  1882,  1276,
       0,     0,  1874,     0,     0,     0,     0,     0,  1276,     0,
    1876,     0,  1883,     0,  1276,     0,  1276,  1877,     0,  1276,
       0,     0,     0,     0,  1276,  1276,  1276,  1276,     0,     0,
    1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,  1276,
       0,  1878,     0,  1276,  1276,  1884,     0,     0,     0,     0,
       0,     0,     0,  1276,     0,     0,     0,  1276,     0,  1885,
       0,  1276,  1886,     0,     0,     0,     0,     0,     0,  1276,
       0,     0,  1276,     0,  1276,     0,     0,     0,     0,     0,
       0,     0,     0,  1276,     0,     0,  1276,  1276,     0,     0,
       0,  1276,  1276,     0,     0,     0,  3954,     0,  1276,     0,
       0,     0,     0,     0,     0,   768,   768,   768,   826,     0,
       0,  3452,  3976,     0,     0,     0,  3976,  3990,  3976,     0,
    1869,     0,     0,  1870,  1276,     0,     0,  1871,  1872,  1873,
    1276,  1276,  1276,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1874,  1887,     0,     0,     0,     0,
    1879,     0,  1876,     0,     0,  1880,     0,     0,  1276,  1877,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2817,     0,  1276,     0,  1881,  1882,     0,     0,
       0,     0,     0,  1878,     0,     0,     0,     0,     0,     0,
       0,  1883,  4050,  1781,  1781,     0,  2355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   831,   831,   831,   831,     0,     0,     0,
       0,     0,     0,     0,  1884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1885,     0,
       0,  1888,  2208,     0,  1889,  1890,  1891,     0,  1892,  1893,
    1894,  1895,  1896,  1897,     0,     0,     0,     0,  3718,     0,
    4103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1879,  1869,     0,     0,  1870,  1880,     0,     0,
    1871,  1872,  1873,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1874,  1881,  1882,
       0,     0,     0,     0,  1887,  1876,     0,     0,     0,     0,
       0,     0,  1877,  1883,     0,     0,     0,     0,     0,  1869,
       0,     0,  1870,     0,     0,     0,  1871,  1872,  1873,     0,
       0,     0,  4188,     0,     0,     0,  1878,     0,     0,     0,
       0,     0,     0,  1874,     0,     0,  1884,     0,     0,     0,
       0,  1876,     0,     0,     0,     0,     0,     0,  1877,     0,
    1885,     0,     0,  1886,     0,     0,     0,     0,     0,     0,
       0,   831,     0,     0,     0,   768,     0,   831,     0,  1276,
       0,     0,  1878,     0,     0,     0,   768,     0,     0,     0,
       0,     0,  4228,     0,     0,     0,     0,     0,     0,     0,
    1888,     0,  2208,  1889,  1890,  1891,     0,  1892,  1893,  1894,
    1895,  1896,  1897,     0,     0,     0,     0,   768,     0,     0,
       0,  3452,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3076,     0,     0,     0,     0,     0,     0,     0,     0,
    4276,     0,     0,     0,     0,  1879,  1887,     0,     0,     0,
    1880,   768,     0,     0,     0,  2355,     0,     0,     0,  1276,
    1276,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1881,  1882,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1883,     0,  2991,     0,
    2991,  1879,     0,     0,     0,     0,  1880,   768,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1881,  1882,  1884,
       0,     0,     0,     0,     0,     0,  1276,     0,     0,     0,
       0,     0,  1883,  1885,  2151,     0,  1886,  1276,     0,  2152,
       0,     0,  1888,     0,     0,  1889,  1890,  1891,     0,  1892,
    1893,  1894,  1895,  1896,  1897,     0,     0,     0,     0,  3879,
       0,     0,     0,     0,     0,  1884,     0,  1276,     0,     0,
       0,     0,     0,  2153,     0,     0,     0,  1276,  1276,  1885,
       0,     0,  1886,     0,  1276,  1276,  2154,     0,     0,  1276,
       0,     0,     0,     0,  1276,     0,     0,  1276,  1276,     0,
       0,  2155,  1276,  4371,     0,     0,     0,     0,  1276,   768,
     768,   768,   768,     0,     0,     0,  3976,  3990,  3976,  1887,
    1276,  3976,     0,     0,  4385,     0,     0,     0,  3452,     0,
       0,     0,  3452,     0,     0,     0,     0,     0,  4400,     0,
       0,     0,  2156,     0,     0,  1276,     0,     0,     0,     0,
    1276,     0,     0,  2157,     0,     0,  1276,     0,     0,     0,
       0,     0,     0,   878,     0,  1887,     0,     0,     0,     0,
    1276,     0,     0,  2158,  3495,     0,     0,     0,  2159,  2817,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   702,     0,     0,  1276,  1869,     0,     0,
    1870,     0,     0,     0,  1871,  1872,  1873,     0,   830,   832,
       0,     0,   836,     0,     0,  1888,  2991,  2991,  1889,  1890,
    1891,  1874,  1892,  1893,  1894,  1895,  1896,  1897,     0,  1876,
     890,     0,  3930,     0,  2208,     0,  1877,   900,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4469,  2160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1878,  1888,     0,     0,  1889,  1890,  1891,     0,  1892,  1893,
    1894,  1895,  1896,  1897,     0,     0,     0,     0,  4044,     0,
       0,  1869,  2161,     0,  1870,     0,     0,     0,  1871,  1872,
    1873,     0,     0,     0,     0,     0,  1276,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1876,   204,     0,     0,     0,   831,     0,
    1877,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1878,     0,     0,     0,     0,     0,
    2162,     0,     0,     0,     0,     0,     0,  2163,     0,     0,
    2164,     0,  1276,     0,     0,     0,     0,     0,     0,  1879,
       0,     0,     0,     0,  1880,     0,   826,     0,     0,     0,
       0,     0,  2208,     0,     0,     0,     0,     0,     0,     0,
    2165,  1781,     0,     0,     0,  1881,  1882,  2166,     0,     0,
       0,     0,     0,     0,  2167,     0,  1276,     0,     0,     0,
    1883,  2168,     0,     0,     0,     0,     0,     0,     0,   831,
       0,  3204,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2169,     0,     0,     0,
       0,     0,     0,  1884,     0,     0,     0,     0,     0,     0,
       0,   768,     0,  1879,     0,     0,     0,  1885,  1880,  1869,
    1886,     0,  1870,     0,     0,     0,  1871,  1872,  1873,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2570,
   -2570,     0,     0,  1874,     0,     0,     0,  1276,     0,     0,
       0,  1876,     0,     0,  1883,     0,  1276,     0,  1877,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1276,  1276,     0,     0,  1276,     0,     0,
       0,     0,  1878,     0,     0,     0,     0, -2570,     0,     0,
       0,     0,   826,     0,     0,  3976,     0,     0,     0,  3452,
       0,  1885,     0,  1887,  3452,     0,     0,  3452,   826,     0,
    3076,     0,  4661,     0,     0,  1276,  1276,     0,     0,     0,
     558,     0,     0,     0,     0,     0,   610,   558,     0,     0,
    1432,     0,   661,  4050,   558,  1276,  1433,     0,     0,     0,
     558,     0,   712,     0,     0,     0,  4050,   878,   831,   831,
     831,     0,     0,   966,     0,     0,     0,   969,     0,     0,
       0,   779,   779,     0,     0,     0,     0,     0,     0,     0,
       0,   994,     0,     0,     0,     0,     0,  1434,   999,     0,
       0,  1869,     0,     0,  1870,     0,     0,  1887,  1871,  1872,
    1873,  1879,     0,     0,   843,   878,  1880,     0,     0,  1888,
       0,     0,  1889,  1890,  1891,  1874,  1892,  1893,  1894,  1895,
    1896,  1897,     0,  1876,     0,     0,  4332,  1881,  1882,     0,
    1877,  1869,     0,     0,  1870,     0,     0,  1435,  1871,  1872,
    1873,  1436,  1883,     0,     0,     0,   843,     0,  1437,   768,
       0,  1438,     0,     0,  1878,  1874,     0,     0,     0,     0,
       0,  4228,     0,  1876,   768,     0,     0,     0,  3220,   768,
    1877,  2991,     0,     0,     0,  1884,  1439,     0,  2208,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1404,  1885,
       0,     0,  1886,  1888,  1878,   768,  1889,  1890,  1891,  4276,
    1892,  1893,  1894,  1895,  1896,  1897,     0,     0,  1440,     0,
       0,     0,     0,   831,   768,  4050,     0,     0,   838,     0,
       0,     0,  1405,     0,     0,     0,   880,     0,   881,     0,
     885,   886,     0,   889,     0,   891,     0,     0,   897,     0,
     899,  1276,     0,     0,  1276,     0,  1276,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1879,     0,     0,  1276,  1441,  1880,  1442,
       0,     0,  1276,     0,     0,  1887,  3452,     0,     0,  1443,
    4661,  1407,     0,     0,     0,     0,     0,  1276,  1444,  1881,
    1882,     0,     0,     0,     0,     0,  4881,     0,     0,  1445,
    1432,     0,     0,  1879,  1883,     0,  1433,     0,  1880,     0,
       0,     0,     0,     0,     0,  1408,     0,     0,     0,  1523,
     768,     0,     0,     0,     0,     0,     0,     0,     0,  1881,
    1882,     0,     0,     0,     0,     0,  1446,  1884,     0,  1447,
    1448,     0,     0,     0,  1883,  3221,  1276,  1434,     0,     0,
    1409,  1885,  1462,  1463,  1886,   831,   831,   831,   831,     0,
       0,     0,     0,     0,     0,     0,     0,  1449,     0,     0,
       0,  1888,     0,     0,  1889,  1890,  1891,  1884,  1892,  1893,
    1894,  1895,  1896,  1897,  1410,     0,     0,     0,  4367,     0,
       0,  1885,     0,   826,  1886,     0,     0,     0,     0,  1524,
       0,  1436,     0,     0,     0,     0,     0,     0,  1437,     0,
       0,  1438,     0,     0,   768,  1412,     0,  3452,     0,     0,
       0,     0,     0,     0,     0,  1869,     0,     0,  1870,     0,
       0,  1450,  1871,  1872,  1873,     0,  1439,  1887,     0,     0,
       0,  1586,     0,     0,     0,     0,     0,     0,     0,  1874,
       0,     0,     0,     0,     0,    34,     0,  1876,     0,  3222,
       0,     0,     0,     0,  1877,     0,  1415,     0,  1440,     0,
    1611,  1612,     0,  1276,  1416,     0,   826,  1887,     0,  1276,
       0,     0,  2193,  5034,     0,     0,     0,     0,  1878,     0,
    1276,     0,     0,     0,  1418,  1276,  1653,  1276,     0,  1276,
       0,     0,  1419,     0,     0,     0,     0,  4050,     0,     0,
       0,     0,     0,   831,     0,   878,     0,     0,     0,     0,
       0,     0,     0,  3223,     0,  1276,     0,  1441,     0,  1442,
       0,     0,     0,  1888,     0,     0,  1889,  1890,  1891,  1443,
    1892,  1893,  1894,  1895,  1896,  1897,     0,     0,  1444,     0,
    4618,     0,     0,     0,     0,     0,     0,  1420,     0,  1445,
       0,  3224,     0,     0,     0,     0,     0,  1781,  1781,  1721,
    1723,     0,     0,  1888,     0,     0,  1889,  1890,  1891,     0,
    1892,  1893,  1894,  1895,  1896,  1897,     0,     0,     0,     0,
    4629,     0,     0,     0,     0,   963,  1525,  1879,   831,  1447,
    1448,     0,  1880,   972,     0,  5111,     0,     0,     0,  1276,
     985,   986,     0,     0,   992,     0,   995,   996,  5123,     0,
       0,   998,     0,  1881,  1882,     0,     0,  1526,     0,     0,
       0,     0,  1015,     0,     0,     0,     0,     0,  1883,     0,
       0,     0,     0,  1276,  1276,     0,     0,  1025,  3076,     0,
       0,  1276,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1276,     0,     0,  4881,     0,     0,     0,     0,  2817,
    1089,  1884,  1091,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1107,   843,     0,  1885,     0,     0,  1886,     0,
       0,  1450,     0,     0,     0,     0,     0,   831,     0,     0,
       0,     0,     0,     0,  1781,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   558,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2208,
       0,     0,     0,     0,   826,  1869,     0,     0,  1870,     0,
    1276,     0,  1871,  1872,  1873,  1161,     0,     0,     0,  4050,
       0,     0,     0,     0,     0,   843,   843,  1276,     0,  1874,
       0,     0,     0,     0,     0,     0,  1276,  1876,     0,     0,
    5034,  1887,     0,     0,  1877,     0,     0,     0,     0,     0,
       0,     0,  1066,  1276,     0,     0,     0,     0,     0,     0,
     831,     0,     0,     0,     0,     0,     0,     0,  1878,   779,
       0,  1869,     0,     0,  1870,     0,  1066,     0,  1871,  1872,
    1873,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5123,   831,   831,     0,  1874,     0,     0,     0,  1869,
       0,     0,  1870,  1876,     0,     0,  1871,  1872,  1873,     0,
    1877,     0,     0,     0,     0,     0,     0,     0,  1276,  1276,
       0,     0,     0,  1874,     0,     0,     0,     0,     0,     0,
    1395,  1876,     0,     0,  1878,     0,     0,  1888,  1877,     0,
    1889,  1890,  1891,     0,  1892,  1893,  1894,  1895,  1896,  1897,
       0,     0,     0,     0,  4638,     0,     0,     0,     0,     0,
    1276,     0,  1878,     0,     0,     0,  1276,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1879,     0,     0,
     831,     0,  1880,     0,     0,     0,     0,  5034,     0,     0,
     826,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1555,     0,  2229,  1881,  1882,     0,     0,     0,   843,   843,
       0,     0,     0,     0,     0,     0,  1568,     0,  1883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1579,     0,
       0,  1580,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1583,     0,  1879,     0,     0,  1587,     0,  1880,     0,
       0,  1884,     0,     0,  1590,     0,     0,     0,     0,     0,
    1600,     0,     0,  1604,     0,  1885,     0,     0,  1886,  1881,
    1882,  1879,     0,     0,     0,     0,  1880,     0,     0,     0,
       0,     0,     0,     0,  1883,     0,     0,     0,     0,     0,
       0,     0,  2322,  2323,  2324,  2325,     0,  1881,  1882,     0,
       0,  1869,     0,  1657,  1870,     0,     0,     0,  1871,  1872,
    1873,     0,  1883,     0,     0,     0,     0,  1884,     0,     0,
       0,     0,     0,     0,     0,  1874,     0,     0,     0,     0,
       0,  1885,     0,  1876,  1886,  2364,  2365,     0,     0,     0,
    1877,     0,     0,     0,     0,  1884,     0,     0,     0,  1066,
       0,  1887,     0,     0,     0,     0,  2389,     0,     0,  1885,
       0,     0,  1886,     0,  1878,     0,     0,     0,     0,     0,
       0,     0,  1066,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1066,     0,     0,
       0,  2434,  2435,  2436,  2437,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   558,     0,   558,  1887,   558,     0,
     558,     0,   558,   558,   558,     0,     0,     0,     0,   558,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1799,     0,     0,     0,     0,  1887,     0,  1888,     0,     0,
    1889,  1890,  1891,     0,  1892,  1893,  1894,  1895,  1896,  1897,
       0,     0,     0,     0,  4641,     0,     0,     0,     0,     0,
       0,  1066,     0,  1879,  3220,     0,     0,     0,  1880,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1404,     0,     0,     0,     0,  1881,
    1882,     0,     0,     0,  2529,     0,     0,     0,     0,     0,
    2533,     0,     0,  1888,  1883,     0,  1889,  1890,  1891,     0,
    1892,  1893,  1894,  1895,  1896,  1897,     0,     0,  1405,     0,
    4690,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1888,     0,     0,  1889,  1890,  1891,  1884,  1892,  1893,
    1894,  1895,  1896,  1897,     0,     0,     0,  1432,  4724,     0,
       0,  1885,     0,  1433,  1886,     0,     0,     0,     0,     0,
    1487,     0,     0,     0,     0,     0,  1066,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1407,     0,  1488,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1434,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   779,     0,
       0,  1408,     0,     0,     0,  1869,     0,     0,  1870,     0,
       0,     0,  1871,  1872,  1873,     0,     0,  2693,  1489,     0,
       0,     0,     0,     0,     0,     0,     0,  1887,     0,  1874,
       0,  3221,     0,     0,     0,     0,  1409,  1876,  1436,     0,
       0,     0,     0,  1869,  1877,  1437,  1870,     0,  1438,     0,
    1871,  1872,  1873,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1874,  1878,     0,
    1410,     0,     0,  1439,  2171,  1876,     0,     0,     0,     0,
       0,     0,  1877,  1869,     0,     0,  1870,     0,     0,     0,
    1871,  1872,  1873,     0,     0,     0,     0,  1925,     0,     0,
       0,  1412,  1490,     0,     0,  1440,  1878,  1874,     0,     0,
       0,     0,     0,     0,     0,  1876,     0,     0,     0,     0,
       0,     0,  1877,  1888,     0,     0,  1889,  1890,  1891,     0,
    1892,  1893,  1894,  1895,  1896,  1897,     0,     0,     0,     0,
    4764,    34,  2261,     0,     0,  1414,  1878,     0,     0,     0,
    1491,     0,  1415,  1492,     0,     0,     0,     0,     0,     0,
    1416,     0,  1066,     0,  1493,     0,  1442,     0,  2193,     0,
       0,     0,     0,     0,     0,     0,  1443,  1879,     0,     0,
    1418,     0,  1880,     0,     0,  1444,     0,     0,  1419,     0,
       0,     0,     0,     0,     0,  1494,  1445,     0,     0,     0,
       0,     0,     0,  1881,  1882,     0,     0,     0,     0,  3223,
       0,     0,     0,     0,     0,  1879,     0,     0,  1883,     0,
    1880,     0,     0,     0,     0,     0,     0,     0,  1066,     0,
       0,     0,     0,  1495,     0,     0,  1447,  1448,  1496,     0,
       0,  1881,  1882,  1420,     0,     0,     0,  3224,     0,     0,
       0,  1884,     0,     0,     0,  1879,  1883,     0,  1497,     0,
    1880,     0,     0,     0,  1498,  1885,     0,  1066,  1886,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1499,     0,
    2399,  1881,  1882,     0,     0,     0,     0,     0,     0,  1884,
    1066,     0,     0,  2883,  2884,     0,  1883,     0,     0,     0,
       0,     0,  2895,  1885,  2897,     0,  1886,     0,  2901,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1450,  1884,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1885,     0,  1869,  1886,     0,  1870,     0,
       0,  1887,  1871,  1872,  1873,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1874,
    1066,     0,     0,     0,     0,     0,     0,  1876,     0,  1869,
       0,     0,  1870,     0,  1877,  1066,  1871,  1872,  1873,  1887,
       0,     0,     0,     0,  1066,     0,     0,     0,     0,     0,
       0,     0,  2519,  1874,  2520,     0,  1066,     0,  1878,     0,
       0,  1876,     0,     0,     0,     0,     0,     0,  1877,     0,
       0,  2531,     0,  2532,     0,     0,     0,  3029,     0,  1887,
    3032,     0,     0,     0,     0,     0,     0,   558,     0,   558,
       0,   558,  1878,   558,     0,   558,     0,  1888,     0,   558,
    1889,  1890,  1891,     0,  1892,  1893,  1894,  1895,  1896,  1897,
       0,  1066,     0,     0,  5070,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1066,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1888,     0,  1066,  1889,  1890,
    1891,     0,  1892,  1893,  1894,  1895,  1896,  1897,  3106,  1066,
       0,     0,  5193,     0,     0,     0,  3113,  3114,     0,     0,
       0,     0,     0,  3116,     0,     0,     0,  1879,     0,     0,
    1432,     0,  1880,     0,     0,  1888,  1433,  3132,  1889,  1890,
    1891,     0,  1892,  1893,  1894,  1895,  1896,  1897,     0,  1066,
    1066,     0,  5256,  1881,  1882,     0,     0,     0,     0,     0,
       0,  1879,     0,     0,     0,     0,  1880,     0,  1883,     0,
       0,     0,     0,     0,     0,     0,     0,  1434,  3178,     0,
       0,     0,     0,     0,     0,     0,     0,  1881,  1882,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1869,  1884,  1883,  1870,     0,     0,  3201,  1871,  1872,  1873,
       0,     0,     0,     0,     0,  1885,     0,     0,  1886,     0,
       0,     0,     0,  1404,  1874,     0,     0,     0,     0,     0,
       0,  1436,  1876,     0,     0,  1884,     0,     0,  1437,  1877,
       0,  1438,     0,     0,     0,     0,     0,     0,     0,  1885,
       0,     0,  1886,     0,     0,     0,     0,  1405,     0,     0,
    3260,     0,  3262,  1878,     0,     0,  1439,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1066,     0,     0,     0,  1406,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1440,     0,
       0,  1887,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1407,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1887,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1408,     0,     0,     0,     0,     0,     0,  1441,     0,  1442,
       0,     0,  3321,     0,     0,     0,     0,  2820,  2821,  1443,
       0,     0,  1879,     0,     0,     0,     0,  1880,  1444,     0,
       0,     0,     0,     0,     0,  1409,  2836,  2837,     0,  1445,
       0,  2840,  2841,     0,     0,     0,  2844,  1888,  1881,  1882,
    1889,  1890,  1891,     0,  1892,  1893,  1894,  1895,  1896,  1897,
    2855,     0,     0,  1883,  5276,     0,     0,  2864,     0,  1410,
       0,  2867,  2868,     0,     0,  2871,  2872,     0,     0,  1447,
    1448,  1888,  2877,     0,  1889,  1890,  1891,     0,  1892,  1893,
    1894,  1895,  1896,  1897,     0,  2894,  1884,  2896,  5309,  1411,
    1412,     0,     0,     0,     0,     0,     0,  1449,     0,     0,
    1885,     0,     0,  1886,     0,     0,  2920,     0,     0,     0,
       0,  2922,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2927,     0,  1413,     0,     0,     0,
      34,     0,     0,  2934,  1414,  2936,     0,     0,  2939,  2942,
    2944,  1415,     0,  1066,     0,  2952,  2955,  1066,  1066,  1416,
       0,     0,     0,     0,     0,  2968,     0,  1417,     0,  1869,
    2977,  1450,  1870,     0,     0,  2981,  1871,  1872,  1873,  1418,
       0,     0,     0,     0,     0,     0,     0,  1419,     0,     0,
       0,  2997,     0,  1874,     0,     0,  1887,  2776,     0,  3008,
       0,  1876,     0,     0,     0,     0,     0,     0,  1877,     0,
    3023,     0,     0,     0,     0,     0,     0,     0,     0,  1066,
       0,     0,  3030,     0,     0,  3033,     0,     0,     0,     0,
    3036,  1066,  1878,     0,     0,  3038,  3039,     0,     0,     0,
    3042,     0,  1420,  3046,     0,     0,     0,  3053,  3054,  3055,
    3056,     0,  3058,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3083,  3084,     0,  3086,     0,
       0,  1066,     0,     0,     0,     0,     0,     0,  3094,  3095,
       0,  2777,     0,     0,     0,     0,     0,  3538,     0,  3539,
    3540,  3541,  1888,     0,     0,  1889,  1890,  1891,     0,  1892,
    1893,  1894,  1895,  1896,  1897,     0,     0,  2763,     0,     0,
    1869,     0,     0,  1870,     0,     0,     0,  1871,  1872,  1873,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3139,     0,     0,     0,  1874,     0,     0,     0,  1432,     0,
       0,  1879,  1876,     0,  1433,  1869,  1880,     0,  1870,  1877,
       0,     0,  1871,  1872,  1873,     0,     0,  1523,  3176,     0,
       0,     0,     0,     0,     0,     0,     0,  1881,  1882,  1874,
       0,     0,     0,  1878,     0,     0,     0,  1876,     0,     0,
       0,     0,  1883,     0,  1877,  1434,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1878,     0,
       0,     0,     0,     0,     0,  1884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1885,
       0,     0,  1886,     0,     0,     0,     0,  1524,     0,  1436,
       0,     0,     0,     0,     0,     0,  1437,     0,     0,  1438,
    1066,     0,     0,     0,     0,     0,     0,     0,     0,  3372,
       0,     0,     0,     0,  3373,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1439,     0,     0,     0,   856,     0,
       0,     0,  1879,     0,     0,     0,     0,  1880,   888,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   906,
       0,     0,     0,     0,  3691,     0,  1440,     0,  1881,  1882,
       0,     0,     0,     0,     0,  1887,     0,  1879,  3306,     0,
       0,  1869,  1880,  1883,  1870,     0,     0,     0,  1871,  1872,
    1873,     0,  1066,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1881,  1882,  1874,     0,  3322,     0,     0,
       0,     0,     0,  1876,     0,     0,  1884,     0,  1883,     0,
    1877,     0,     0,     0,     0,  1441,     0,  1442,     0,     0,
    1885,  2778,     0,  1886,     0,     0,     0,  1443,     0,     0,
       0,     0,     0,     0,  1878,     0,  1444,     0,     0,     0,
       0,  1884,     0,     0,     0,     0,     0,  1445,     0,     0,
       0,     0,     0,     0,     0,  1885,     0,     0,  1886,     0,
       0,  1888,     0,     0,  1889,  1890,  1891,     0,  1892,  1893,
    1894,  1895,  1896,  1897,     0,     0,     0,     0,     0,     0,
       0,  3922,     0,     0,  3047,     0,     0,  1447,  1448,  1869,
       0,     0,  1870,  1066,     0,     0,  1871,  1872,  1873,     0,
       0,     0,     0,     0,     0,     0,  1887,     0,     0,     0,
    1066,     0,     0,  1874,     0,  3048,  3331,     0,     0,  5221,
       0,  1876,  3845,  1066,     0,     0,     0,     0,  1877,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1887,     0,  1879,     0,     0,     0,     0,  1880,     0,
       0,     0,  1878,     0,     0,     0,     0,  3923,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1881,
    1882,     0,     0,     0,     0,     0,     0,     0,     0,  1450,
       0,     0,     0,     0,  1883,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1888,     0,     0,  1889,  1890,  1891,     0,  1892,
    1893,  1894,  1895,  1896,  1897,     0,     0,  1884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1885,     0,     0,  1886,     0,     0,  1888,     0,     0,
    1889,  1890,  1891,     0,  1892,  1893,  1894,  1895,  1896,  1897,
       0,     0,     0,     0,     0,  5222,     0,     0,     0,  3532,
       0,  1879,     0,  3534,     0,     0,  1880,     0,     0,  3536,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3547,  3549,  1881,  1882,     0,
    3549,     0,   915,     0,     0,  3560,  3561,  3562,   960,  3564,
       0,     0,  1883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1887,     0,     0,
    3585,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3591,  3592,  3593,  3594,     0,  1884,  1066,     0,     0,  1066,
       0,  1066,     0,     0,     0,     0,  1066,     0,     0,  1885,
       0,  1869,  1886,     0,  1870,     0,     0,     0,  1871,  1872,
    1873,     0,     0,     0,     0,     0,     0,  3611,     0,     0,
    3616,  3617,  3618,     0,     0,  1874,     0,     0,     0,     0,
       0,     0,     0,  1876,     0,     0,     0,     0,     0,     0,
    1877,  4067,  4068,  4069,  4070,  1066,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1066,  1888,  1878,     0,  1889,  1890,  1891,     0,
    1892,  1893,  1894,  1895,  1896,  1897,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1887,     0,  1066,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1160,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3685,     0,     0,  1283,     0,     0,     0,     0,
    3689,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1306,     0,     0,     0,  3698,     0,
       0,     0,     0,     0,     0,     0,  1066,     0,  1066,     0,
       0,     0,     0,     0,  1432,  1331,     0,     0,     0,     0,
    1433,     0,     0,  1879,     0,  3744,     0,  1487,  1880,     0,
       0,  1888,     0,     0,  1889,  1890,  1891,     0,  1892,  1893,
    1894,  1895,  1896,  1897,     0,     0,  1488,     0,     0,  1881,
    1882,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1434,     0,     0,  1883,     0,     0,     0,     0,  4209,
       0,     0,     0,     0,     0,  4212,     0,  3781,     0,     0,
       0,     0,  3787,     0,     0,     0,     0,  1461,     0,  1066,
       0,     0,     0,     0,     0,  1489,     0,  1884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1885,  3825,     0,  1886,  1436,     0,  1066,     0,     0,
       0,     0,  1437,     0,     0,  1438,     0,     0,     0,     0,
       0,  3345,     0,     0,     0,     0,     0,     0,     0,     0,
    1066,     0,     0,     0,     0,     0,     0,     0,  1066,  3841,
    1439,  3842,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1490,
       0,     0,  1440,     0,     0,     0,     0,  1869,     0,     0,
    1870,     0,     0,     0,  1871,  1872,  1873,  1887,     0,     0,
       0,     0,     0,  1609,     0,     0,     0,     0,     0,     0,
       0,  1874,     0,   828,  3377,     0,     0,  1066,     0,  1876,
       0,     0,   828,   851,     0,     0,  1877,  1491,     0,     0,
    1492,   851,  1647,  1650,  1651,  1066,     0,     0,     0,     0,
       0,  1493,     0,  1442,   851,     0,     0,     0,  1066,     0,
    1878,     0,     0,  1443,     0,     0,     0,     0,     0,     0,
       0,     0,  1444,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1494,  1445,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1888,     0,     0,  1889,  1890,  1891,     0,
    1892,  1893,  1894,  1895,  1896,  1897,     0,     0,     0,     0,
    3024,     0,     0,  1447,  1448,  1496,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1497,     0,     0,     0,     0,
       0,  3025,     0,     0,  1066,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1499,     0,     0,     0,  1879,
       0,     0,     0,     0,  1880,  1066,     0,     0,     0,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1881,  1882,     0,     0,     0,
    1066,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
    1883,     0,     0,     0,     0,  1450,     0,     0,     0,     0,
       0,  4061,     0,  4062,     0,     0,     0,     0,     0,     0,
    4064,     0,     0,     0,  1066,     0,     0,     0,     0,     0,
       0,     0,     0,  1884,     0,     0,  4074,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1885,  1869,     0,
    1886,  1870,  4082,     0,     0,  1871,  1872,  1873,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4102,     0,  1874,     0,     0,     0,     0,     0,     0,     0,
    1876,     0,     0,     0,     0,     0,     0,  1877,  4106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4115,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1878,     0,     0,     0,     0,  4504,  4144,     0,     0,
       0,     0,  1066,     0,     0,     0,     0,     0,  4152,  4153,
    4154,  4508,     0,  1887,  1940,  4158,  4159,  4160,  4161,     0,
       0,  4163,  4164,     0,     0,     0,     0,  4171,  4172,     0,
    4174,  4175,  4176,  4177,  4178,  4179,  1432,  4181,     0,     0,
       0,     0,  1433,     0,     0,     0,  4189,     0,     0,  4192,
    4193,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2078,     0,     0,     0,     0,     0,     0,  3549,     0,
       0,     0,     0,     0,     0,     0,   828,     0,     0,     0,
       0,     0,  3382,  1434,     0,     0,     0,     0,   851,     0,
    4213,     0,     0,     0,   851,     0,     0,  4573,     0,     0,
    1879,  1066,     0,     0,     0,  1880,     0,   851,     0,  1888,
       0,     0,  1889,  1890,  1891,     0,  1892,  1893,  1894,  1895,
    1896,  1897,     0,   851,     0,  1066,  1881,  1882,   828,     0,
       0,     0,     0,  2249,  1068,     0,     0,  1436,   828,   851,
    2202,  1883,     0,     0,  1437,     0,   851,  1438,     0,  2225,
       0,     0,     0,     0,     0,     0,     0,     0,  1068,   851,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   851,
       0,  1432,  1439,     0,  1884,     0,     0,  1433,     0,  2262,
       0,     0,     0,     0,     0,     0,     0,     0,  1885,  3549,
    1869,  1886,  2275,  1870,     0,  2278,     0,  1871,  1872,  1873,
       0,     0,     0,     0,  1440,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1874,     0,     0,  3388,  1434,     0,
       0,  4317,  1876,     0,     0,     0,     0,     0,     0,  1877,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2326,     0,   828,   828,
    1066,     0,     0,  1878,   851,     0,     0,     0,     0,     0,
    2344,     0,     0,  1441,     0,  1442,  4695,  4696,  4696,     0,
       0,     0,  1436,  2356,  1887,  1443,     0,     0,     0,  1437,
     828,     0,  1438,     0,  1444,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1445,     0,     0,     0,     0,
    1066,     0,     0,     0,     0,     0,  1432,  1439,     0,     0,
       0,     0,  1433,  1869,     0,     0,  1870,     0,     0,     0,
    1871,  1872,  1873,     0,     0,  2408,     0,     0,     0,     0,
       0,     0,  2250,     0,     0,  1447,  1448,  1874,     0,  1440,
       0,     0,     0,     0,     0,  1876,     0,     0,     0,     0,
       0,     0,  1877,  1434,  2451,     0,     0,     0,     0,     0,
       0,  2464,  1879,  2251,     0,     0,     0,  1880,     0,     0,
    1888,     0,     0,  1889,  1890,  1891,  1878,  1892,  1893,  1894,
    1895,  1896,  1897,     0,     0,     0,     0,     0,  1881,  1882,
       0,     0,     0,     0,     0,     0,     0,     0,  1441,     0,
    1442,     0,     0,  1883,     0,     0,     0,  1436,     0,     0,
    1443,     0,     0,     0,  1437,     0,     0,  1438,     0,  1444,
       0,  4826,  1066,     0,   828,     0,     0,  1450,     0,     0,
    1445,  1068,  1066,     0,  4452,   828,  1884,     0,  4453,  4454,
    4455,  4456,  1439,     0,  4458,     0,     0,     0,     0,     0,
    1885,     0,     0,  1886,  1068,     0,     0,     0,     0,     0,
       0,     0,  2536,     0,     0,     0,     0,  1552,     0,  1068,
    1447,  1448,     0,     0,  1440,  4476,  4477,  4478,     0,  4479,
       0,  4481,  4482,     0,     0,  1879,     0,     0,     0,     0,
    1880,     0,     0,  4491,  4492,     0,     0,     0,  1553,     0,
    1283,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1881,  1882,     0,   828,     0,     0,  2583,     0,     0,
    4497,     0,     0,     0,     0,     0,  1883,     0,     0,     0,
       0,     0,     0,  1441,     0,  1442,  1887,     0,     0,     0,
       0,     0,     0,  4507,     0,  1443,     0,     0,     0,     0,
       0,     0,     0,  1068,  1444,     0,  1066,     0,     0,  1884,
       0,     0,  1450,     0,  4930,  1445,  4932,     0,     0,     0,
       0,     0,     0,  1885,     0,     0,  1886,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     851,     0,     0,     0,  1066,     0,     0,     0,     0,     0,
       0,     0,  2173,     0,   851,  1447,  1448,     0,     0,     0,
       0,     0,     0,   828,  2742,  1066,     0,  4559,     0,     0,
       0,   851,   188,     0,  2757,     0,     0,     0,     0,     0,
       0,     0,  1888,  2174,     0,  1889,  1890,  1891,     0,  1892,
    1893,  1894,  1895,  1896,  1897,     0,  4588,     0,     0,   851,
       0,     0,     0,     0,     0,     0,     0,     0,  1068,  1887,
     851,     0,     0,     0,     0,     0,     0,     0,     0,   189,
       0,  4612,     0,     0,     0,   851,     0,     0,   851,     0,
    1066,     0,     0,     0,   190,     0,     0,     0,     0,  3875,
     828,  1869,     0,     0,  1870,     0,     0,  1450,  1871,  1872,
    1873,     0,   191,     0,     0,     0,     0,     0,   192,     0,
       0,     0,     0,     0,     0,  1874,     0,     0,  3929,     0,
     828,  4696,     0,  1876,     0,   193,     0,     0,     0,     0,
    1877,     0,     0,     0,     0,     0,   194,     0,     0,     0,
       0,  2768,     0,  2771,   195,     0,     0,     0,   828,   828,
     828,     0,   828,     0,  1878,  1888,   196,     0,  1889,  1890,
    1891,   197,  1892,  1893,  1894,  1895,  1896,  1897,   198,     0,
       0,     0,   828,     0,     0,     0,     0,     0,   558,     0,
       0,  1283,     0,     0,     0,   199,     0,     0,     0,     0,
       0,  1066,     0,     0,     0,     0,   851,     0,     0,     0,
       0,     0,     0,     0,   851,   851,  5105,     0,     0,     0,
     200,     0,     0,   828,  2024,     0,  1869,     0,     0,  1870,
       0,     0,     0,  1871,  1872,  1873,     0,     0,     0,     0,
       0,   201,     0,  1066,     0,     0,     0,     0,  4713,     0,
    1874,   828,     0,     0,     0,   828,   828,     0,  1876,     0,
       0,     0,     0,     0,     0,  1877,  4723,     0,     0,     0,
     828,  4728,  4729,  1879,  1068,   202,     0,     0,  1880,     0,
       0,  2024,     0,     0,     0,     0,     0,     0,     0,  1878,
       0,     0,     0,     0,     0,     0,     0,   203,     0,  1881,
    1882,     0,     0,     0,     0,     0,     0,   204,     0,     0,
     205,     0,     0,     0,  1883,  5174,     0,     0,     0,     0,
       0,     0,  4788,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   206,     0,     0,     0,
    1068,   207,  4805,   208,  4807,     0,  2958,  1884,     0,     0,
     209,     0,     0,   210,     0,     0,     0,     0,     0,     0,
       0,  1885,     0,     0,  1886,     0,     0,  2985,     0,     0,
       0,     0,   211,     0,     0,     0,  1066,     0,   212,  1068,
    3549,     0,   213,   214,     0,     0,   215,  4842,     0,     0,
     216,     0,     0,     0,     0,     0,     0,     0,  1879,   217,
       0,     0,  1068,  1880,   218,     0,     0,     0,  5242,     0,
       0,     0,     0,     0,     0,     0,   219,     0,     0,     0,
       0,     0,     0,     0,  1881,  1882,     0,     0,     0,   220,
       0,  3051,  3052,     0,     0,     0,     0,     0,     0,  1883,
    4696,  4696,     0,     0,     0,     0,     0,  1887,     0,     0,
       0,     0,     0,     0,     0,  4884,     0,     0,     0,     0,
       0,     0,   851,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1884,     0,     0,     0,  4900,     0,     0,     0,
       0,     0,  1068,     0,     0,     0,  1885,  4908,     0,  1886,
       0,     0,     0,     0,     0,     0,     0,  1068,     0,  1066,
       0,     0,     0,     0,     0,     0,  1068,     0,     0,     0,
       0,     0,     0,  2024,     0,     0,     0,     0,  1068,     0,
       0,     0,     0,     0,  1066,     0,  3165,     0,  4696,     0,
       0,     0,     0,     0,     0,     0,     0,   851,     0,     0,
       0,     0,     0,  1888,     0,   851,  1889,  1890,  1891,  4974,
    1892,  1893,  1894,  1895,  1896,  1897,     0,   851,     0,     0,
       0,     0,     0,     0,  1066,     0,     0,     0,     0,     0,
       0,     0,  1887,  1068,     0,     0,     0,     0,     0,     0,
     828,     0,     0,   828,     0,     0,     0,  1068,     0,     0,
       0,     0,     0,   828,     0,     0,     0,     0,  1432,  1068,
       0,     0,     0,     0,  1433,     0,     0,     0,     0,     0,
       0,  1068,  3549,     0,     0,     0,     0,     0,  1066,     0,
       0,     0,     0,  1066,  1066,     0,     0,     0,   828,   828,
       0,   851,   851,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   851,     0,  1434,     0,     0,     0,     0,
       0,  1068,  1068,     0,   851,   851,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1888,     0,
     851,  1889,  1890,  1891,  5058,  1892,  1893,  1894,  1895,  1896,
    1897,     0,     0,     0,     0,     0,     0,     0,     0,  5071,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1436,
       0,     0,   828,  3305,     0,     0,  1437,     0,     0,  1438,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1439,  1066,   828,     0,   828,     0,
    5098,     0,     0,   828,   828,     0,     0,     0,     0,     0,
     828,   828,   828,     0,     0,  5109,   828,     0,   828,   828,
     828,   828,   828,   828,     0,   828,  1440,   828,   828,     0,
       0,   828,     0,     0,     0,     0,   570,     0,     0,     0,
       0,   571,     0,     0,     0,  1068,   828,   828,   828,   828,
    2024,     0,     0,   572,   828,     0,     0,     0,   828,     0,
       0,   828,     0,     0,   828,   828,   828,   828,   828,   828,
     828,   828,   828,     0,   828,   573,     0,     0,     0,     0,
       0,   828,     0,   828,     0,  1441,     0,  1442,   574,     0,
       0,     0,     0,     0,  5167,     0,     0,  1443,     0,   575,
       0,     0,     0,  -849,     0,     0,  1444,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3433,  1445,     0,     0,
       0,   576,     0,     0,     0,     0,     0,   577,     0,     0,
       0,  1432,     0,     0,     0,     0,  5189,  1433,     0,     0,
       0,     0,     0,     0,   578,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2928,   579,     0,  1447,  1448,     0,
       0,     0,     0,   580,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   581,     0,     0,  1434,     0,
       0,     0,     0,   582,     0,  1449,     0,   583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1066,     0,     0,
       0,     0,     0,     0, -1069,     0,     0,     0,     0,     0,
       0,   828,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5249,     0,     0,   828,     0,     0,     0,     0,     0,
       0,     0,  1436,   828,   828,     0,     0,     0,     0,  1437,
       0,   584,  1438,     0,     0,     0,     0,     0,     0,  1450,
    -571,     0,     0,     0,     0,     0,     0,     0,   851,     0,
       0,     0,     0,     0,     0,  1068,     0,  1439,     0,  1068,
    1068,     0,     0,     0,     0,     0,   851,     0,     0,     0,
       0,  2024,   851,     0,   585,     0,   851,   586,     0,     0,
       0,     0,  1432,     0,   851,     0,     0,     0,  1433,  1440,
       0,     0,     0,     0,     0,     0,   587,     0,     0,     0,
       0,     0,   851,     0,     0,   828,     0,     0,     0,   588,
       0,     0,     0,     0,     0,     0,  -447,   828,     0,     0,
       0,  1068,     0,     0,   828,     0,     0,     0,     0,  1434,
       0,     0,     0,  1068,     0,   589,     0,     0,     0,     0,
       0,     0,   590,     0,     0,     0,   851,     0,  1441,  -447,
    1442,     0,   591,     0,     0,     0,     0,     0,     0,     0,
    1443,     0,     0,     0,   851,   851,     0,     0,     0,  1444,
    3633,   592,     0,  1068,     0,     0,     0,   593,     0,     0,
    1445,     0,  -447,  1436,     0,   594,   595,     0,   596,   597,
    1437,     0,     0,  1438,     0,  2024,   851,     0,   598,  2024,
       0,     0,     0,   599,     0,     0,     0,     0,     0,   600,
       0,     0,   601,     0,     0,   602,     0,  3091,  1439,     0,
    1447,  1448,   851,     0,  2024,     0,     0,     0,  -447,     0,
     851,     0,     0,     0,     0,     0,     0,   851,     0,     0,
       0,   851,     0,     0,     0,     0,     0,     0,  3092,     0,
    1440,     0,     0,     0,     0,     0,     0,  1432,     0,     0,
       0,   851,     0,  1433,     0,     0,   851,     0,     0,     0,
     851,     0,     0,  2024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   851,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   851,     0,     0,     0,
       0,     0,     0,     0,  1434,     0,   851,     0,     0,  1441,
       0,  1442,  1450,     0,     0,     0,  3747,  3748,  3749,     0,
       0,  1443,     0,     0,     0,     0,     0,     0,     0,     0,
    1444,     0,     0,  3758,     0,     0,     0,     0,     0,     0,
       0,  1445,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   828,  1068,     0,     0,     0,  3774,     0,  1436,     0,
       0,  2024,     0,     0,     0,  1437,  3784,  3786,  1438,     0,
       0,  3791,     0,     0,     0,     0,     0,     0,  3557,     0,
       0,  1447,  1448,     0,  3805,     0,     0,     0,     0,     0,
       0,     0,     0,  1439,     0,   828,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3558,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   622,     0,     0,  1440,     0,   623,     0,     0,
       0,     0,     0,     0,  1068,     0,     0,     0,   851,   624,
       0,     0,     0,     0,     0,     0,     0,   828,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   625,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1450,   626,     0,     0,  1283,     0,     0,
       0,     0,     0,     0,  1441,     0,  1442,     0,     0,   627,
       0,   851,     0,     0,     0,     0,  1443,     0,     0,     0,
       0,     0,     0,     0,     0,  1444,     0,   628,     0,     0,
       0,     0,     0,     0,     0,     0,  1445,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   851,
     629,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   630,     0,     0,     0,  1068,     0,   851,     0,   631,
       0,     0,     0,  3612,     0,   851,  1447,  1448,     0,   828,
       0,   632,  1068,     0,     0,   828,   633,     0,     0,     0,
       0,     0,     0,   634,     0,  1068,     0,     0,     0,     0,
       0,     0,     0,     0,  3613,     0,   828,     0,     0,     0,
     635,   828,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3962,  3963,  3964,     0,     0,     0,     0,
       0,     0,     0,     0,   828,   828,   828,     0,     0,   828,
       0,     0,     0,     0,     0,     0,     0,   828,   828,   828,
     828,     0,     0,     0,     0,  2024,   636,     0,     0,     0,
     828,  2024,     0,   828,     0,   828,     0,     0,  1450,     0,
       0,     0,     0,     0,     0,     0,   828,   828,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     637,     0,     0,     0,   828,     0,   828,     0,   828,     0,
       0,     0,   638,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   639,     0,     0,     0,     0,     0,   828,     0,
       0,     0,   204,     0,     0,   640,     0,     0,     0,   828,
       0,   828,   828,   828,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   851,     0,     0,   828,
       0,   641,     0,     0,     0,     0,   642,     0,   643,     0,
     828,     0,     0,     0,     0,   644,     0,     0,   645,     0,
       0,     0,     0,     0,     0,   828,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   646,     0,   828,
       0,     0,     0,   647,     0,     0,     0,     0,   648,     0,
       0,   649,     0,     0,     0,   650,     0,     0,  1068,     0,
       0,  1068,   651,  1068,   652,     0,     0,     0,  1068,   653,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   654,     0,   851,   851,     0,     0,     0,     0,   828,
       0,     0,     0,     0,   655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     851,     0,     0,   851,     0,     0,     0,  1068,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1068,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1068,
       0,     0,     0,  4210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2024,  2024,  2024,     0,     0,     0,
       0,     0,     0,     0,     0,  4252,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   851,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1068,     0,
    1068,     0,     0,     0,     0,     0,     0,     0,   851,  2464,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   851,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2536,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1068,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   851,     0,     0,     0,     0,     0,     0,     0,  1068,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1068,     0,     0,     0,     0,     0,     0,  2024,
    1068,     0,     0,     0,     0,     0,   851,     0,   851,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   851,     0,   851,     0,     0,     0,  4374,  4375,  4376,
    4377,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2024,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1068,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   851,  1068,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1068,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   851,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     851,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   851,     0,     0,   851,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   828,     0,     0,  1068,     0,     0,     0,
       0,     0,   828,     0,     0,     0,     0,     0,   828,     0,
     828,     0,     0,   828,     0,     0,     0,  1068,   828,   828,
     828,   828,     0,     0,   828,   828,   828,   828,   828,   828,
     828,   828,   828,   828,     0,     0,     0,   828,   828,     0,
       0,     0,  1068,     0,     0,     0,     0,   828,     0,     0,
       0,   828,     0,  2024,     0,   828,     0,     0,     0,     0,
       0,     0,     0,   828,     0,     0,   828,     0,   828,     0,
       0,     0,     0,     0,     0,     0,  1068,   828,     0,     0,
     828,   828,     0,     0,     0,   828,   828,     0,     0,     0,
       0,     0,   828,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   828,     0,     0,   828,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   828,     0,
       0,     0,     0,     0,   828,   828,   828,     0,   844,   853,
       0,     0,     0,     0,     0,     0,     0,   853,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     853,     0,   828,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   828,  4603,
       0,     0,     0,     0,  1068,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   828,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   851,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2024,     0,     0,
       0,     0,  2024,  1068,  2024,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2024,  1068,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   851,     0,
       0,   851,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   828,     0,     0,     0,  4762,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4774,     0,     0,     0,     0,  1283,   851,   851,
       0,     0,  1068,     0,     0,     0,     0,     0,   851,     0,
       0,     0,     0,     0,     0,   828,     0,     0,     0,     0,
       0,     0,     0,  4810,     0,     0,     0,   851,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4827,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1068,   828,   828,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   853,     0,     0,     0,     0,   851,
     853,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   853,     0,     0,     0,     0,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,   853,
       0,   828,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   844,   853,     0,     0,  4897,     0,
       0,     0,   853,     0,     0,     0,     0,     0,     0,     0,
       0,   828,     0,     0,     0,   853,     0,     0,     0,     0,
       0,   828,   828,     0,  1068,   853,     0,     0,   828,   828,
       0,     0,     0,   828,  1068,     0,     0,     0,   828,     0,
       0,   828,   828,     0,     0,     0,   828,     0,     0,     0,
       0,     0,   828,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   828,     0,     0,     0,     0,     0,
       0,     0,   828,     0,     0,     0,   828,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   828,
       0,     0,  4981,     0,   828,     0,     0,     0,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     853,     0,     0,     0,   828,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1068,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   851,     0,     0,     0,     0,
    2024,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1068,   852,     0,     0,
       0,     0,     0,     0,     0,   852,     0,     0,     0,     0,
       0,     0,   851,     0,     0,     0,     0,  1068,   852,     0,
       0,     0,     0,     0,   851,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   851,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1068,     0,     0,     0,     0,     0,     0,     0,
       0,   844,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   828,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   851,     0,     0,     0,     0,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1068,     0,  1068,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   851,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   828,     0,     0,     0,  1068,     0,     0,     0,     0,
     828,     0,     0,     0,     0,     0,   853,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   828,   828,     0,
     853,   828,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   828,   853,     0,     0,
       0,     0,     0,   828,     0,     0,     0,     0,   828,     0,
       0,   828,   828,     0,     0,     0,     0,     0,     0,   828,
     828,     0,     0,     0,     0,   853,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   853,   828,     0,   828,
       0,     0,     0,     0,   851,     0,   851,     0,     0,     0,
     828,   853,     0,     0,   853,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1068,   851,
       0,     0,     0,     0,     0,     0,     0,     0,   828,     0,
       0,     0,   852,     0,     0,     0,     0,     0,   852,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   852,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2024,     0,     0,   852,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   852,     0,     0,     0,     0,     0,     0,
     852,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   853,   852,     0,     0,     0,     0,     0,     0,
     853,   853,     0,   852,     0,     0,     0,     0,     0,     0,
    2026,     0,     0,     0,     0,     0,  4816,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   828,
       0,  1068,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   828,  1068,     0,   828,     0,
     828,     0,     0,     0,     0,     0,     0,  2026,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     828,     0,     0,     0,     0,     0,   828,     0,   852,     0,
     828,     0,     0,     0,     0,     0,  1068,     0,     0,     0,
       0,   828,     0,     0,     0,  1259,  1259,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2024,     0,     0,     0,     0,     0,     0,     0,
    1068,     0,     0,     0,     0,  1068,  1068,     0,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   851,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   828,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   828,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   853,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1068,  1068,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   828,     0,     0,
     828,     0,     0,   828,     0,     0,     0,     0,     0,  2026,
       0,     0,     0,     0,   828,     0,     0,     0,     0,   828,
       0,   828,     0,   828,     0,     0,     0,     0,     0,     0,
       0,   828,     0,   853,     0,     0,     0,     0,     0,     0,
       0,   853,     0,     0,     0,     0,     0,     0,     0,   828,
       0,     0,     0,   853,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2024,  1067,   851,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1067,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   844,   844,     0,   853,   853,     0,
       0,     0,     0,   828,   852,     0,     0,     0,     0,   853,
       0,     0,   828,     0,     0,     0,     0,     0,   852,     0,
     853,   853,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   852,   853,   828,   828,     0,
       0,     0,     0,     0,     0,   828,  2024,     0,     0,  1068,
       0,     0,     0,     0,     0,   828,     0,     0,     0,     0,
       0,     0,     0,   852,   851,     0,     0,     0,   844,     0,
       0,     0,     0,     0,   852,     0,     0,   828,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   852,
       0,     0,   852,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1826,   828,     0,
       0,     0,     0,     0,   828,     0,     0,     0,     0,     0,
       0,     0,     0,   828,     0,     0,     0,     0,     0,   828,
     828,   828,     0,     0,     0,     0,  2026,  1840,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   828,     0,     0,
       0,     0,     0,     0,     0,  1858,  1859,  1860,     0,  1862,
       0,   851,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1904,
     852,     0,     0,     0,     0,   828,     0,     0,   852,   852,
       0,     0,     0,     0,     0,     0,     0,     0,  2025,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   828,   828,     0,     0,     0,     0,     0,  1067,
    1941,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2024,     0,     0,
       0,     0,  1067,     0,     0,     0,     0,     0,  2045,     0,
       0,     0,  2057,  2062,   828,  2025,     0,  1067,     0,     0,
     828,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   828,     0,  2024,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2024,   828,   828,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   853,     0,     0,     0,     0,     0,
       0,  1067,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   853,     0,     0,     0,     0,  2026,   853,     0,
       0,     0,   853,     0,     0,     0,     0,     0,     0,     0,
     853,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   853,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     844,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   853,     0,     0,     0,   852,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1067,     0,     0,     0,
     853,   853,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2026,   853,     0,     0,  2026,     0,  2025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   853,     0,
    2026,   852,     0,     0,     0,     0,   853,     0,     0,   852,
       0,     0,     0,   853,     0,     0,     0,   853,     0,     0,
       0,   852,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   853,     0,     0,
       0,     0,   853,     0,     0,     0,   853,     0,     0,  2026,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   853,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   853,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   853,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   852,   852,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   852,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   852,   852,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   852,     0,     0,  2026,     0,     0,
       0,     0,  2100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2100,     0,
       0,     0,     0,     0,   853,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2624,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2644,     0,  2646,     0,  1067,  2658,  2661,
    2666,     0,     0,     0,  2025,  2672,     0,     0,  2677,     0,
       0,     0,     0,     0,     0,     0,     0,   853,     0,     0,
    1067,     0,     0,  2684,  2685,  2686,  2687,     0,     0,     0,
       0,  2694,     0,     0,     0,  2706,     0,     0,  2708,     0,
       0,  2715,  2716,  2717,  2718,  2719,  2720,  2721,  2722,  2723,
       0,  2724,     0,     0,     0,   853,     0,     0,  1259,     0,
    2752,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   853,     0,     0,     0,     0,     0,     0,
       0,   853,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   844,     0,     0,     0,     0,     0,     0,     0,     0,
    1067,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1067,     0,     0,     0,     0,
       0,     0,     0,     0,  2100,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1067,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2026,     0,     0,     0,     0,     0,  2026,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2772,     0,
       0,  1067,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1067,     0,     0,     0,     0,
    1859,  1860,   852,     0,     0,     0,     0,  1067,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1067,
     852,     0,     0,     0,     0,  2025,   852,     0,     0,     0,
     852,     0,     0,     0,     0,     0,     0,     0,   852,     0,
       0,     0,   853,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   852,     0,     0,  1067,
    1067,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2869,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     852,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   852,   852,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   853,
     853,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2025,
     852,     0,     0,  2025,     0,     0,   853,     0,     0,   853,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   852,     0,  2025,     0,
       0,     0,     0,     0,   852,     0,     0,     0,     0,     0,
       0,   852,     0,  1067,     0,   852,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   852,     0,     0,     0,     0,
     852,     0,     0,     0,   852,     0,     0,  2025,     0,     0,
       0,  2755,     0,     0,     0,     0,     0,   852,     0,     0,
    2026,  2026,  2026,     0,     0,     0,     0,     0,     0,     0,
     852,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     852,     0,     0,     0,   853,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1057,   853,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   853,
       0,     0,     0,     0,     0,     0,     0,  1057,     0,     0,
       0,     0,     0,     0,     0,  2025,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3130,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   853,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   852,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2824,     0,  2026,     0,  2100,  2830,     0,
       0,     0,   853,     0,   853,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   853,     0,   853,
       0,     0,     0,     0,     0,   852,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2026,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1067,
       0,     0,     0,   852,     0,     0,     0,     0,     0,     0,
       0,  1067,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   852,   853,     0,     0,     0,     0,     0,     0,   852,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1067,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     853,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3327,     0,     0,   853,     0,  3333,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1057,     0,     0,     0,     0,     0,     0,     0,   853,  2025,
       0,   853,     0,  1862,     0,  2025,     0,     0,     0,     0,
       0,     0,     0,  1057,  2666,     0,  2666,  2666,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3391,  1057,     0,
    3394,     0,  3396,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3414,     0,  3417,     0,  3419,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2026,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     852,     0,     0,     0,     0,     0,     0,     0,  2752,  2752,
    2752,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1057,     0,  1059,     0,  3469,     0,     0,     0,
    1067,     0,     0,     0,     0,     0,     0,  2045,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1059,     0,
       0,     0,  2062,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   852,   852,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2100,     0,   852,     0,  3518,   852,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1057,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   853,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2025,  2025,
    2025,     0,     0,  2026,     0,     0,     0,     0,  2026,     0,
    2026,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   852,  1067,     0,     0,     0,     0,     0,     0,
       0,     0,  2026,     0,     0,     0,     0,     0,     0,     0,
    1067,     0,   852,     0,     0,     0,     0,     0,     0,  2026,
       0,     0,     0,  1067,     0,     0,     0,   852,     0,     0,
       0,     0,     0,     0,   853,     0,     0,   853,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1059,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1057,     0,   852,     0,     0,     0,     0,
       0,     0,     0,     0,  1059,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   853,   853,     0,     0,     0,  1059,
       0,     0,     0,     0,   853,     0,     0,     0,     0,     0,
       0,     0,     0,  2025,     0,     0,     0,     0,     0,     0,
     852,     0,   852,   853,     0,     0,     0,     0,     0,  2755,
    2755,  2755,     0,     0,     0,   852,     0,   852,     0,  1057,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1060,     0,     0,     0,     0,     0,     0,     0,  2025,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1060,     0,     0,  1057,     0,
       0,     0,     0,  1059,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   853,     0,     0,     0,     0,
     852,  1057,     0,     0,     0,     0,  2100,     0,     0,  2830,
       0,  2830,     0,     0,     0,     0,  2100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   852,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   852,  1067,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1057,  1067,     0,     0,     0,   852,     0,  1059,   852,
       0,     0,     0,     0,     0,     0,  1057,     0,     0,     0,
       0,     0,     0,     0,     0,  1057,     0,  2100,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1057,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3876,     0,     0,     0,     0,     0,     0,     0,     0,  3880,
       0,     0,     0,     0,     0,  3881,     0,  3882,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2025,     0,     0,
       0,     0,  1057,     0,  3906,  3907,  1067,     0,  1067,     0,
       0,     0,     0,     0,     0,     0,  1057,     0,     0,     0,
       0,     0,  2672,     0,     0,     0,     0,     0,  1057,     0,
    3932,     0,     0,  3935,     0,  3937,     0,     0,     0,     0,
    1057,     0,     0,     0,  3941,     0,     0,     0,     0,     0,
       0,   853,  3948,  3949,     0,     0,  2026,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1060,     0,
    1057,  1057,     0,     0,     0,  3996,     0,     0,   853,  1067,
       0,  4003,  4004,  2752,     0,     0,     0,     0,     0,     0,
     853,  1060,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1060,  1067,     0,  4018,
       0,     0,     0,     0,  1059,     0,     0,   853,     0,     0,
       0,     0,     0,     0,     0,  4031,     0,     0,     0,     0,
    2830,     0,     0,     0,     0,     0,     0,     0,  2830,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   852,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1059,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1060,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2025,     0,     0,  1057,     0,  2025,  1067,  2025,   853,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1059,
       0,     0,     0,     0,     0,  2830,     0,     0,     0,     0,
    2025,     0,     0,     0,     0,     0,     0,     0,  1067,     0,
       0,     0,  1059,     0,     0,     0,     0,  2025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   852,     0,     0,   852,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   853,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1060,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1059,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1067,     0,     0,  1059,     0,     0,
       0,     0,     0,     0,     0,     0,  1059,     0,     0,     0,
       0,     0,   852,   852,     0,  1067,     0,     0,  1059,     0,
       0,     0,   852,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1067,   852,     0,     0,     0,     0,     0,     0,     0,     0,
     853,     0,   853,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1059,  1067,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1057,     0,     0,  1059,  1057,  1057,
    4293,  4294,     0,     0,     0,   853,     0,     0,     0,  1059,
       0,     0,     0,     0,   844,     0,     0,     0,     0,     0,
       0,  1059,     0,   852,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2755,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2026,     0,     0,     0,     0,     0,   844,     0,     0,     0,
    1057,  1059,  1059,     0,     0,     0,     0,  4330,     0,     0,
       0,  1060,  1057,     0,     0,     0,     0,     0,  4335,     0,
       0,     0,  2100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1057,     0,     0,     0,     0,     0,  4350,  4352,
       0,     0,     0,     0,     0,  4356,  4357,     0,     0,     0,
    4358,     0,     0,     0,     0,  4361,     0,  1060,  4364,  4365,
       0,     0,     0,  4369,     0,     0,     0,     0,     0,  4373,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1060,     0,     0,     0,
       0,  2830,     0,     0,     0,     0,  2752,     0,     0,     0,
       0,  2752,     0,  1062,     0,  1059,     0,  2752,     0,  1060,
       0,     0,     0,     0,     0,  2830,     0,     0,     0,     0,
       0,  1259,     0,     0,     0,     0,     0,  1062,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4433,  2026,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   852,
       0,     0,     0,     0,  2025,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   853,     0,     0,     0,     0,  1060,
       0,     0,     0,     0,     0,     0,   852,     0,     0,     0,
       0,  1057,     0,     0,  1060,     0,     0,     0,   852,     0,
       0,     0,     0,  1060,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1060,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   852,     0,     0,     0,     0,
    1067,     0,     0,     0,     0,     0,     0,  4494,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1060,     0,     0,  1057,     0,     0,     0,     0,     0,     0,
    2100,     0,     0,     0,  1060,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1060,     0,     0,     0,
       0,     0,     0,  4530,     0,     0,     0,     0,  1060,     0,
       0,     0,     0,     0,     0,  1059,     0,   852,     0,  1059,
    1059,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1060,  1060,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2026,     0,   853,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1059,     0,     0,  1057,     0,     0,     0,     0,   852,
    1062,     0,     0,  1059,     0,     0,     0,     0,     0,     0,
       0,  1057,  1067,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1067,  1062,  1057,     0,     0,     0,     0,     0,
       0,  1063,     0,     0,     0,     0,     0,     0,  1062,     0,
       0,     0,     0,  1059,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,     0,     0,     0,
       0,     0,     0,     0,  4635,  4636,     0,     0,  4637,     0,
       0,     0,  2026,     0,     0,     0,     0,  2755,     0,     0,
       0,     0,  2755,     0,     0,     0,     0,     0,  2755,     0,
     853,     0,  1060,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   844,     0,     0,  4673,  4674,   852,     0,
     852,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1062,     0,     0,     0,  4686,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1067,     0,     0,     0,
       0,     0,     0,   852,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   844,   844,     0,     0,     0,
       0,     0,     0,     0,  1067,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2025,     0,
       0,     0,     0,     0,     0,  1067,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   853,     0,     0,
       0,     0,  1059,     0,     0,     0,     0,  1062,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1057,     0,     0,
    1057,     0,  1057,     0,     0,     0,     0,  1057,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1067,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2026,     0,     0,  1057,     0,     0,     0,
       0,     0,     0,     0,  1059,     0,     0,     0,     0,     0,
       0,     0,  1060,  1057,     0,     0,  1060,  1060,     0,     0,
       0,     0,     0,     0,     0,  2672,     0,     0,  1063,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1057,     0,
       0,     0,  2026,     0,     0,     0,     0,     0,     0,     0,
       0,  1063,     0,  4865,     0,     0,     0,  2026,   844,   844,
       0,     0,     0,     0,     0,     0,  1063,     0,  1862,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1060,  4599,
       0,  1067,     0,     0,     0,     0,  2025,     0,     0,     0,
    1060,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1057,     0,  1057,
       0,     0,     0,     0,     0,  1059,     0,     0,     0,     0,
       0,     0,   852,  1067,     0,     0,     0,  4915,     0,     0,
    1060,     0,  1059,  1062,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1059,     0,     0,     0,     0,
    1063,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1057,     0,     0,     0,     0,     0,     0,     0,     0,  1062,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1065,     0,     0,     0,     0,     0,     0,  1057,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,     0,     0,  1062,     0,
       0,  1057,     0,     0,     0,     0,     0,     0,     0,  1057,
       0,     0,     0,     0,     0,  1063,  2830,     0,     0,     0,
       0,  1062,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4673,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5060,     0,     0,  1060,
       0,     0,     0,     0,     0,  2025,     0,   852,  1057,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1057,     0,     0,     0,
       0,  1062,     0,     0,     0,     0,     0,     0,     0,  1057,
       0,     0,     0,     0,     0,     0,  1062,     0,  1059,     0,
       0,  1059,     0,  1059,     0,  1062,     0,     0,  1059,     0,
       0,     0,     0,     0,     0,     0,     0,  1062,     0,  2830,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5112,  1060,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1067,     0,     0,     0,     0,     0,
    2025,     0,     0,     0,     0,     0,     0,  1059,     0,     0,
       0,     0,     0,     0,  5139,  5139,     0,     0,   852,     0,
       0,     0,  1062,     0,  1059,     0,     0,     0,     0,     0,
       0,     0,  4673,     0,  1067,  1057,  1062,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1062,  1059,
       0,  1063,     0,     0,     0,     0,  1057,     0,     0,     0,
    1062,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1057,     0,     0,     0,     0,     0,     0,  1067,     0,
       0,     0,  1060,  1067,  1067,     0,     0,     0,  1065,     0,
    1062,  1062,     0,     0,     0,     0,     0,     0,     0,  1060,
       0,  5198,     0,     0,     0,  1057,     0,  1063,  1059,     0,
    1059,  1065,  1060,     0,     0,     0,     0,     0,  5139,     0,
       0,     0,     0,     0,     0,     0,  1065,     0,     0,     0,
       0,     0,     0,     0,     0,   852,     0,     0,     0,     0,
       0,     0,     0,     0,  5239,     0,  1063,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1063,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1059,     0,     0,  4599,  1067,     0,     0,     0,     0,
       0,     0,     0,  1057,     0,     0,     0,     0,     0,     0,
    1065,  2025,     0,     0,     0,     0,     0,     0,     0,  1059,
       0,     0,     0,     0,  1062,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1059,     0,     0,     0,     0,     0,     0,  1063,
    1059,  5139,     0,     0,     0,     0,     0,  5297,     0,     0,
    2025,     0,     0,     0,  1063,     0,     0,     0,     0,     0,
       0,     0,     0,  1063,     0,  2025,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1057,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,     0,     0,     0,  1059,
       0,     0,     0,     0,     0,  1060,  1057,     0,  1060,     0,
    1060,     0,     0,     0,     0,  1060,     0,  1059,     0,     0,
    1063,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1059,     0,     0,     0,  1063,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1063,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1063,     0,
       0,     0,     0,     0,  1060,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1067,     0,     0,
       0,  1060,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1063,  1063,
       0,     0,     0,     0,     0,     0,  1060,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1062,     0,  1059,     0,  1062,  1062,
       0,  1057,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1059,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1059,     0,     0,  1060,     0,  1060,     0,     0,
       0,  1057,     0,     0,     0,     0,     0,     0,     0,     0,
    1062,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1065,  1062,     0,     0,     0,  1059,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1062,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1060,     0,
       0,     0,     0,     0,     0,     0,     0,  1065,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1060,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1057,  1059,     0,  1065,     0,     0,  1060,
       0,     0,     0,  1057,     0,     0,     0,  1060,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1060,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1059,  1060,     0,     0,     0,     0,  1065,
       0,     0,     0,     0,     0,     0,     0,  1060,     0,     0,
       0,  1062,     0,     0,  1065,     0,     0,  1059,     0,     0,
       0,     0,     0,  1065,     0,     0,     0,  1057,     0,     0,
       0,     0,     0,     0,     0,  1065,     0,     0,     0,     0,
       0,     0,  1063,     0,     0,     0,  1063,  1063,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1057,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1057,     0,     0,     0,
    1065,     0,     0,  1062,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1060,  1065,     0,     0,     0,  1063,     0,
       0,     0,     0,     0,     0,     0,  1065,     0,     0,     0,
    1063,     0,     0,     0,  1060,     0,     0,     0,  1065,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1059,     0,     0,     0,     0,     0,     0,  1060,
       0,  1057,     0,     0,     0,     0,     0,     0,     0,     0,
    1063,     0,     0,     0,     0,     0,     0,     0,  1065,  1065,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1060,     0,     0,     0,     0,     0,     0,
       0,     0,  1059,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1062,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1062,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1062,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1057,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1060,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,     0,  1057,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1059,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1059,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1063,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1060,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1060,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1063,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1057,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1062,  1059,     0,
    1062,     0,  1062,     0,     0,     0,     0,  1062,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1059,     0,     0,     0,
       0,     0,     0,  1899,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1062,  1059,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,  1062,     0,     0,  1065,  1065,     0,  1060,
       0,     0,  1063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1062,  1063,
       0,     0,     0,     0,     0,     0,  1899,     0,     0,     0,
    1057,     0,  1063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1059,     0,     0,     0,     0,     0,     0,  1060,
       0,     0,     0,     0,     0,  1057,     0,     0,  1065,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1062,     0,  1062,
       0,     0,     0,     0,     0,  1057,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1057,
       0,     0,     0,  1059,  1057,  1057,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1062,  1060,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1060,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1059,     0,     0,  1062,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1062,     0,     0,     0,     0,     0,     0,     0,  1062,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,     0,  1063,     0,
    1063,     0,     0,     0,     0,  1063,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1057,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
       0,     0,     0,     0,     0,     0,     0,     0,  1062,     0,
       0,     0,     0,     0,  1063,  1060,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1062,     0,     0,     0,
       0,  1063,     0,     0,     0,     0,     0,     0,  1059,  1062,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1060,     0,     0,  1063,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1060,     0,     0,     0,     0,     0,
       0,  1065,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,  1063,     0,     0,
       0,     0,     0,     0,     0,  1062,     0,     0,     0,  1060,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1062,     0,     0,     0,
       0,  1059,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1057,     0,
       0,  1062,     0,     0,     0,     0,  1059,     0,     0,     0,
       0,     0,  1065,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1063,  1065,
       0,     0,     0,     0,     0,  1062,     0,     0,     0,     0,
       0,     0,  1065,     0,     0,     0,  1059,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1063,     0,     0,     0,
    1899,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1060,     0,     0,     0,  1899,     0,     0,     0,  2654,  1063,
       0,     0,     0,     0,     0,     0,     0,  1063,     0,     0,
       0,     0,  1899,  1899,  1899,     0,  1899,     0,     0,     0,
    1059,     0,     0,     0,     0,  1059,  1059,     0,     0,     0,
       0,     0,  1060,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1062,     0,     0,     0,     0,  1899,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1063,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1063,  1899,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1063,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1059,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1062,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1060,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,  1062,     0,  1065,     0,
    1065,     0,     0,     0,     0,  1065,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1899,
       0,     0,     0,  1063,     0,     0,     0,     0,     0,     0,
       0,  1899,     0,     0,     0,     0,  1899,     0,     0,     0,
       0,     0,     0,     0,  1063,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1063,
       0,  1065,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,     0,     0,     0,
       0,     0,     0,  1063,     0,     0,     0,     0,  1060,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1062,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1060,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1059,
       0,     0,     0,     0,     0,  1065,     0,  1065,     0,     0,
       0,  1062,     0,  1060,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1063,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1060,     0,     0,
       0,     0,  1060,  1060,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1065,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1062,     0,     0,     0,     0,     0,  1065,
    1063,     0,     0,  1062,     0,     0,     0,  1065,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1063,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1060,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1065,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1062,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1063,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1062,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1062,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1063,
       0,     0,     0,  1065,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1060,     0,     0,  1065,
       0,  1062,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1899,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1899,     0,
    1899,  1063,     0,  2654,  2654,     0,  3368,     0,  2654,     0,
       0,  1063,  1899,     0,     0,  1899,     0,     0,     0,     0,
    1899,     0,     0,     0,     0,     0,  1899,     0,     0,     0,
       0,  1899,     0,     0,     0,     0,     0,     0,  1899,  1899,
    1899,  1899,  1062,     0,     0,  2654,  2654,     0,  1899,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1899,  1065,  1899,     0,     0,     0,     0,     0,     0,  1899,
    1899,  1899,  1899,  1899,  1899,  1899,  1899,  1899,  1899,     0,
       0,     0,     0,     0,  1062,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1899,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1899,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1063,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1063,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1062,     0,     0,
       0,     0,     0,  1899,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1063,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1062,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
       0,     0,     0,     0,     0,  1062,     0,     0,     0,     0,
    1063,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1062,     0,     0,     0,     0,
       0,     0,  1063,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1062,
       0,     0,     0,     0,  1062,  1062,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1065,     0,     0,  1899,     0,     0,     0,     0,     0,
       0,  1065,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1063,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1062,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1063,     0,
       0,     0,     0,     0,  1065,     0,     0,     0,     0,     0,
       0,  1899,     0,     0,     0,     0,     0,  1899,     0,     0,
       0,     0,     0,  1063,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3368,  3368,     0,     0,  2654,  2654,  2654,
    2654,     0,     0,  2654,  2654,  2654,  2654,  2654,  2654,  2654,
    2654,  2654,  2654,  3368,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1063,     0,     0,     0,     0,     0,  1065,
       0,     0,     0,     0,     0,  1899,     0,     0,  1899,     0,
    1899,     0,     0,  3368,  3368,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1899,  2654,
    2654,  1899,     0,  1899,     0,     0,     0,     0,  1062,     0,
       0,     0,     0,     0,     0,     0,     0,  1063,     0,     0,
       0,     0,  1063,  1063,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1899,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1899,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1063,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2654,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1063,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1065,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1899,     0,     0,     0,  1899,  1899,  1899,     0,     0,     0,
       0,     0,  3368,  3368,  3368,  3368,     0,     0,     0,     0,
    3368,  3368,  3368,  3368,  3368,  3368,  3368,  3368,  3368,  3368,
    1899,  1899,     0,     0,     0,     0,     0,  1065,     0,     0,
       0,     0,  1065,  1065,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1899,     0,     0,  1899,
       0,  1899,     0,     0,     0,  1899,     0,     0,  3368,  3368,
       0,     0,  1899,  1899,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1899,     0,     0,     0,     0,     0,     0,  1899,  1899,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1899,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,  1899,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3368,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1899,  1899,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1899,     0,     0,     0,     0,  1899,
    2654,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1899,     0,  1899,     0,     0,     0,
    1899,  1899,  1899,     0,     0,  1899,     0,     0,  1899,  1899,
       0,     0,     0,  1899,     0,     0,     0,  1899,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1899,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1899,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1899,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3368,  2654,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1899,
    1899,  1899,     0,     0,     0,     0,     0,     0,     0,  2654,
    4814,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,  1899,  1899,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
    1899,   241,   242,   243,     0,     0,     0,     0,     0,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,     0,
       0,   257,     0,   258,   259,   260,   261,     0,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,     0,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,     0,   316,   317,   318,     0,     0,   320,     0,
     321,   322,     0,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,     0,     0,     0,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,     0,   352,   353,   354,   355,     0,  3368,     0,
       0,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,  2654,     0,   366,  3368,     0,   368,     0,  1899,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,     0,     0,   390,   391,   392,     0,     0,   394,
     395,     0,   396,     0,     0,   398,     0,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,  1899,
     408,     0,     0,   410,     0,     0,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,     0,   424,
       0,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,     0,   478,
     479,     0,   480,   481,     0,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,  3368,     0,  2654,     0,   507,   508,     0,   510,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,     0,  1899,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   554,   555,   556,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1899,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1899,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1899,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2654,  2654,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1899,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   800,  1176,   617,  1177,  1178,
    1179,   676,  1180,     0,     0,  3368,  3368,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,  2746,   233,
     234,   235,     0,     0,     0,     0,  1181,     0,     0,   236,
     237,  1899,   238,   239,   240,   801,   241,   242,   243,   244,
    1182,   802,  1183,  1184,     0,   248,   249,   250,   251,   252,
    1185,  1186,   253,   254,  1187,  1188,   257,     0,   258,   259,
     260,   261,  1189,     0,  1190,     0,   263,   264,   265,   266,
     267,   804,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,   805,   277,   278,   279,  1191,  1192,  1193,
    1194,  1195,  1196,  1197,   280,   281,   282,   283,   284,   285,
    1198,  1199,   288,  1200,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,  2747,     0,   300,
     301,  1038,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,  1201,   316,   317,
     318,  1202,  1203,   320,     0,   321,   322,  1204,   324,     0,
     325,     0,   326,   807,     0,   808,   327,   328,   329,   330,
       0,   331,  1205,     0,  1206,   334,     0,   335,   336,   337,
     338,   339,   809,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,   810,   351,   352,   353,
     354,   355,  1207,  1208,     0,  1209,     0,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,     0,     0,   366,
    1210,   814,   368,   815,     0,   369,   370,   371,  1211,  1212,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,  1213,   816,  1214,   390,
     391,   392,   393,  1215,   394,   395,   817,   396,  1216,  1217,
     398,  1218,   400,   401,   402,     0,   403,   404,     0,     0,
    1219,   406,   407,     0,     0,   408,   409,   818,   410,   819,
    1220,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,  1221,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,  1222,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
     820,   457,   458,   459,  1223,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
    1224,   475,   476,   477,   478,   479,   821,   480,   481,  1225,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,  1226,     0,   497,   498,     0,   499,
     822,   500,   501,   502,   503,   504,     0,  1227,  1228,     0,
       0,   507,   508,  1229,   510,  1230,  1231,   512,   513,   514,
     515,   516,   517,   518,     0,  1232,   519,   520,   521,   522,
     523,  1233,     0,   524,   525,   526,   527,   528,   529,  1234,
    2748,   531,   823,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,  1235,
    1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,   553,   554,
     555,   556,  1243,     0,     0,     0,     0,     0,     0,  1244,
    1245,  2749,     0,     0,     0,     0,     0,     0,  1247,  2750,
     800,  1176,   617,  1177,  1178,  1179,   676,  1180,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,  1181,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,  1182,   802,  1183,  1184,     0,
     248,   249,   250,   251,   252,  1185,  1186,   253,   254,  1187,
    1188,   257,     0,   258,   259,   260,   261,  1189,     0,  1190,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,
     281,   282,   283,   284,   285,  1198,  1199,   288,  1200,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,  1038,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,  1201,   316,   317,   318,  1202,  1203,   320,     0,
     321,   322,  1204,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,  1205,     0,  1206,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,  1207,  1208,     0,
    1209,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,  1210,   814,   368,   815,     0,
     369,   370,   371,  1211,  1212,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  1213,   816,  1214,   390,   391,   392,   393,  1215,   394,
     395,   817,   396,  1216,  1217,   398,  1218,   400,   401,   402,
       0,   403,   404,     0,     0,  1219,   406,   407,     0,     0,
     408,   409,   818,   410,   819,  1220,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,  1221,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1222,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,  1223,
     461,   462,   463,   464,   465,   466,   467,   468,   469,    39,
     470,   471,   472,   473,   474,  1224,   475,   476,   477,   478,
     479,   821,   480,   481,  1225,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,  1226,
       0,   497,   498,    43,   499,   822,   500,   501,   502,   503,
     504,     0,  1227,  1228,     0,     0,   507,   508,  1229,   510,
    1230,  1231,   512,   513,   514,   515,   516,   517,   518,     0,
    1232,   519,   520,   521,   522,   523,  1233,     0,   524,   525,
     526,   527,   528,  1112,  1234,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,    48,   537,   538,   539,
     540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,
    1240,  1241,  1242,   553,   554,   555,   556,  1243,     0,    49,
       0,     0,     0,     0,  1244,  1245,     0,     0,     0,     0,
       0,     0,     0,  1247,  4877,   800,  1176,   617,  1177,  1178,
    1179,   676,  1180,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,  1181,     0,     0,   236,
     237,     0,   238,   239,   240,   801,   241,   242,   243,   244,
    1182,   802,  1183,  1184,     0,   248,   249,   250,   251,   252,
    1185,  1186,   253,   254,  1187,  1188,   257,     0,   258,   259,
     260,   261,  1189,     0,  1190,     0,   263,   264,   265,   266,
     267,   804,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,   805,   277,   278,   279,  1191,  1192,  1193,
    1194,  1195,  1196,  1197,   280,   281,   282,   283,   284,   285,
    1198,  1199,   288,  1200,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,  1038,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,  1201,   316,   317,
     318,  1202,  1203,   320,     0,   321,   322,  1204,   324,     0,
     325,     0,   326,   807,     0,   808,   327,   328,   329,   330,
       0,   331,  1205,     0,  1206,   334,     0,   335,   336,   337,
     338,   339,   809,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,   810,   351,   352,   353,
     354,   355,  1207,  1208,     0,  1209,     0,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,     0,     0,   366,
    1210,   814,   368,   815,     0,   369,   370,   371,  1211,  1212,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,  1213,   816,  1214,   390,
     391,   392,   393,  1215,   394,   395,   817,   396,  1216,  1217,
     398,  1218,   400,   401,   402,     0,   403,   404,     0,     0,
    1219,   406,   407,     0,     0,   408,   409,   818,   410,   819,
    1220,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,  1221,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,  1222,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
     820,   457,   458,   459,  1223,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
    1224,   475,   476,   477,   478,   479,   821,   480,   481,  1225,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,  1226,     0,   497,   498,     0,   499,
     822,   500,   501,   502,   503,   504,     0,  1227,  1228,     0,
       0,   507,   508,  1229,   510,  1230,  1231,   512,   513,   514,
     515,   516,   517,   518,     0,  1232,   519,   520,   521,   522,
     523,  1233,     0,   524,   525,   526,   527,   528,   529,  1234,
       0,   531,   823,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,  1235,
    1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,   553,   554,
     555,   556,  1243,     0,     0,     0,     0,     0,     0,  1244,
    1245,     0,     0,     0,     0,     0,     0,     0,  1247,  2656,
     800,  1176,   617,  1177,  1178,  1179,   676,  1180,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,  1181,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,  1182,   802,  1183,  1184,     0,
     248,   249,   250,   251,   252,  1185,  1186,   253,   254,  1187,
    1188,   257,     0,   258,   259,   260,   261,  1189,     0,  1190,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,
     281,   282,   283,   284,   285,  1198,  1199,   288,  1200,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,  1038,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,  1201,   316,   317,   318,  1202,  1203,   320,     0,
     321,   322,  1204,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,  1205,     0,  1206,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,  1207,  1208,     0,
    1209,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,  1210,   814,   368,   815,     0,
     369,   370,   371,  1211,  1212,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  1213,   816,  1214,   390,   391,   392,   393,  1215,   394,
     395,   817,   396,  1216,  1217,   398,  1218,   400,   401,   402,
       0,   403,   404,     0,     0,  1219,   406,   407,     0,     0,
     408,   409,   818,   410,   819,  1220,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,  1221,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1222,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,  1223,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,  1224,   475,   476,   477,   478,
     479,   821,   480,   481,  1225,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,  1226,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,  1227,  1228,     0,     0,   507,   508,  1229,   510,
    1230,  1231,   512,   513,   514,   515,   516,   517,   518,     0,
    1232,   519,   520,   521,   522,   523,  1233,     0,   524,   525,
     526,   527,   528,   529,  1234,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,
    1240,  1241,  1242,   553,   554,   555,   556,  1243,     0,     0,
       0,     0,     0,     0,  1244,  1245,     0,     0,     0,     0,
       0,     0,     0,  1247,  3884,   800,  1176,   617,  1177,  1178,
    1179,   676,  1180,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,  1181,     0,     0,   236,
     237,     0,   238,   239,   240,   801,   241,   242,   243,   244,
    1182,   802,  1183,  1184,     0,   248,   249,   250,   251,   252,
    1185,  1186,   253,   254,  1187,  1188,   257,     0,   258,   259,
     260,   261,  1189,     0,  1190,     0,   263,   264,   265,   266,
     267,   804,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,   805,   277,   278,   279,  1191,  1192,  1193,
    1194,  1195,  1196,  1197,   280,   281,   282,   283,   284,   285,
    1198,  1199,   288,  1200,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,  1038,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,  1201,   316,   317,
     318,  1202,  1203,   320,     0,   321,   322,  1204,   324,     0,
     325,     0,   326,   807,     0,   808,   327,   328,   329,   330,
       0,   331,  1205,     0,  1206,   334,     0,   335,   336,   337,
     338,   339,   809,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,   810,   351,   352,   353,
     354,   355,  1207,  1208,     0,  1209,     0,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,     0,     0,   366,
    1210,   814,   368,   815,     0,   369,   370,   371,  1211,  1212,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,  1213,   816,  1214,   390,
     391,   392,   393,  1215,   394,   395,   817,   396,  1216,  1217,
     398,  1218,   400,   401,   402,     0,   403,   404,     0,     0,
    1219,   406,   407,     0,     0,   408,   409,   818,   410,   819,
    1220,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,  1221,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,  1222,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
     820,   457,   458,   459,  1223,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
    1224,   475,   476,   477,   478,   479,   821,   480,   481,  1225,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,  1226,     0,   497,   498,     0,   499,
     822,   500,   501,   502,   503,   504,     0,  1227,  1228,     0,
       0,   507,   508,  1229,   510,  1230,  1231,   512,   513,   514,
     515,   516,   517,   518,     0,  1232,   519,   520,   521,   522,
     523,  1233,     0,   524,   525,   526,   527,   528,   529,  1234,
       0,   531,   823,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,  1235,
    1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,   553,   554,
     555,   556,  1243,     0,     0,   223,     0,     0,     0,  1244,
    1245,     0,     0,     0,     0,     0,     0,     0,  1247,  3955,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,  3973,     0,   236,
     237,     0,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0, -1728,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,     0,     0, -1728,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350, -1728,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360, -1728,   361,   362,   363,   364,   365,     0,     0,   366,
     367, -1728,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388, -1728,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
   -1728,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,     0,     0,     0,  1030,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1328,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,   801,   241,   242,   243,     0,
    1031,   802,  1032,  1033,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,  1034,  1035,   257,     0,   258,   259,
     260,   261,     0,     0,   803,     0,   263,   264,   265,   266,
     267,   804,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,   805,   277,   278,   279,     0,     0,     0,
     806,     0,     0,     0,   280,   281,   282,   283,   284,   285,
    1036,  1037,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,  1038,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,     0,   316,   317,
     318,     0,     0,   320,     0,   321,   322,  1039,   324,     0,
     325,     0,   326,   807,     0,   808,   327,   328,   329,   330,
       0,   331,     0,     0,     0,   334,     0,   335,   336,   337,
     338,   339,   809,   340,   341,   342,   343,  2086,   344,   345,
     346,   347,   348,   349,     0,   350,   810,  2087,   352,   353,
     354,   355,  1041,  1042,     0,  1043,     0,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,     0,     0,   366,
       0,   814,   368,   815,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,  1044,   816,  1045,   390,
     391,   392,     0,     0,   394,   395,   817,   396,     0,     0,
     398,  1046,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,  2089,   818,   410,   819,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,     0,   424,     0,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,  1047,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
     820,   457,   458,   459,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,  2090,   478,   479,   821,   480,   481,  1049,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,     0,   497,   498,     0,   499,
     822,   500,   501,   502,   503,   504,     0,  1050,  1051,     0,
       0,   507,   508,     0,   510,     0,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,     0,  1052,
    2091,   531,   823,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,  1030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   554,
     555,   556,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,  2196,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,     0,  1031,   802,  1032,  1033,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,  1034,  1035,   257,
       0,   258,   259,   260,   261,     0,     0,   803,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,   279,
       0,     0,     0,   806,     0,     0,     0,   280,   281,   282,
     283,   284,   285,  1036,  1037,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,  1038,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
       0,   316,   317,   318,     0,     0,   320,     0,   321,   322,
    1039,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,     0,     0,     0,   334,     0,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
    2086,   344,   345,   346,   347,   348,   349,     0,   350,   810,
    2087,   352,   353,   354,   355,  1041,  1042,     0,  1043,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,     0,   814,   368,   815,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1044,
     816,  1045,   390,   391,   392,     0,     0,   394,   395,   817,
     396,     0,     0,   398,  1046,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,  2089,
     818,   410,   819,     0,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,     0,   424,     0,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,  1047,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,  2090,   478,   479,   821,
     480,   481,  1049,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,     0,   497,
     498,     0,   499,   822,   500,   501,   502,   503,   504,     0,
    1050,  1051,     0,     0,   507,   508,     0,   510,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,     0,  1052,  2091,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,     0,   800,  1176,   617,  1177,  1178,  1179,   676,  1180,
       0,     0,   554,   555,   556,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,  3216,  1181,     0,     0,   236,   237,     0,   238,
     239,   240,   801,   241,   242,   243,   244,  1182,   802,  1183,
    1184,     0,   248,   249,   250,   251,   252,  1185,  1186,   253,
     254,  1187,  1188,   257,     0,   258,   259,   260,   261,  1189,
       0,  1190,     0,   263,   264,   265,   266,   267,   804,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
     805,   277,   278,   279,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,   280,   281,   282,   283,   284,   285,  1198,  1199,   288,
    1200,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,  1038,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,  1201,   316,   317,   318,  1202,  1203,
     320,     0,   321,   322,  1204,   324,     0,   325,     0,   326,
     807,     0,   808,   327,   328,   329,   330,     0,   331,  1205,
       0,  1206,   334,     0,   335,   336,   337,   338,   339,   809,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,   810,   351,   352,   353,   354,   355,  1207,
    1208,     0,  1209,     0,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,     0,     0,   366,  1210,   814,   368,
     815,     0,   369,   370,   371,  1211,  1212,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1213,   816,  1214,   390,   391,   392,   393,
    1215,   394,   395,   817,   396,  1216,  1217,   398,  1218,   400,
     401,   402,     0,   403,   404,     0,     0,  1219,   406,   407,
       0,     0,   408,   409,   818,   410,   819,  1220,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
    1221,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1222,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,   820,   457,   458,
     459,  1223,   461,   462,   463,   464,   465,   466,   467,   468,
     469,    39,   470,   471,   472,   473,   474,  1224,   475,   476,
     477,   478,   479,   821,   480,   481,  1225,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,  1226,     0,   497,   498,    43,   499,   822,   500,   501,
     502,   503,   504,     0,  1227,  1228,     0,     0,   507,   508,
    1229,   510,  1230,  1231,   512,   513,   514,   515,   516,   517,
     518,     0,  1232,   519,   520,   521,   522,   523,  1233,     0,
     524,   525,   526,   527,   528,  1112,  1234,     0,   531,   823,
     532,   533,   534,   535,     0,     0,   536,     0,    48,   537,
     538,   539,   540,   541,   542,   543,  1235,  1236,  1237,  1238,
     548,  1239,  1240,  1241,  1242,   553,   554,   555,   556,  1243,
       0,    49,     0,     0,     0,     0,  1244,  1245,     0,     0,
       0,     0,     0,     0,     0,  1247,   800,  1176,   617,  1177,
    1178,  1179,   676,  1180,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,  1181,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
     244,  1182,   802,  1183,  1184,  2662,   248,   249,   250,   251,
     252,  1185,  1186,   253,   254,  1187,  1188,   257,     0,   258,
     259,   260,   261,  1189,     0,  1190,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,   280,   281,   282,   283,   284,
     285,  1198,  1199,   288,  1200,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,  1038,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,  1201,   316,
     317,   318,  1202,  1203,   320,     0,   321,   322,  1204,   324,
       0,   325,     0,   326,   807,  2663,   808,   327,   328,   329,
     330,     0,   331,  1205,     0,  1206,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,   351,   352,
     353,   354,   355,  1207,  1208,     0,  1209,     0,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,     0,  2664,
     366,  1210,   814,   368,   815,     0,   369,   370,   371,  1211,
    1212,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,  1213,   816,  1214,
     390,   391,   392,   393,  1215,   394,   395,   817,   396,  1216,
    1217,   398,  1218,   400,   401,   402,     0,   403,   404,     0,
       0,  1219,   406,   407,     0,     0,   408,   409,   818,   410,
     819,  1220,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,  1221,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
    1222,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,  1223,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,  1224,   475,   476,   477,   478,   479,   821,   480,   481,
    1225,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,  1226,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,  1227,  1228,
       0,  2665,   507,   508,  1229,   510,  1230,  1231,   512,   513,
     514,   515,   516,   517,   518,     0,  1232,   519,   520,   521,
     522,   523,  1233,     0,   524,   525,   526,   527,   528,   529,
    1234,     0,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
    1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,   553,
     554,   555,   556,  1243,     0,     0,     0,     0,     0,     0,
    1244,  1245,     0,     0,     0,     0,     0,     0,     0,  1247,
     800,  1176,   617,  1177,  1178,  1179,   676,  1180,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,  1181,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,  1182,   802,  1183,  1184,     0,
     248,   249,   250,   251,   252,  1185,  1186,   253,   254,  1187,
    1188,   257,     0,   258,   259,   260,   261,  1189,     0,  1190,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,
     281,   282,   283,   284,   285,  1198,  1199,   288,  1200,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,  1038,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,  1201,   316,   317,   318,  1202,  1203,   320,     0,
     321,   322,  1204,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,  1205,     0,  1206,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,  1207,  1208,     0,
    1209,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,  1210,   814,   368,   815,     0,
     369,   370,   371,  1211,  1212,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  1213,   816,  1214,   390,   391,   392,   393,  1215,   394,
     395,   817,   396,  1216,  1217,   398,  1218,   400,   401,   402,
       0,   403,   404,     0,     0,  1219,   406,   407,     0,     0,
     408,   409,   818,   410,   819,  1220,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,  1221,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1222,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,  1223,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,  1224,   475,   476,   477,   478,
     479,   821,   480,   481,  1225,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,  1226,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,  1227,  1228,     0,     0,   507,   508,  1229,   510,
    1230,  1231,   512,   513,   514,   515,   516,   517,   518,     0,
    1232,   519,   520,   521,   522,   523,  1233,     0,   524,   525,
     526,   527,   528,   529,  1234,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,
    1240,  1241,  1242,   553,   554,   555,   556,  1243,     0,     0,
       0,     0,     0,     0,  1244,  1245,     0,     0,     0,     0,
       0,  1823,  2617,  1247,   800,  1176,   617,  1177,  1178,  1179,
     676,  1180,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,  1181,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,   244,  1182,
     802,  1183,  1184,     0,   248,   249,   250,   251,   252,  1185,
    1186,   253,   254,  1187,  1188,   257,     0,   258,   259,   260,
     261,  1189,     0,  1190,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,   278,   279,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,   280,   281,   282,   283,   284,   285,  1198,
    1199,   288,  1200,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
    1038,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,  1201,   316,   317,   318,
    1202,  1203,   320,     0,   321,   322,  1204,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,  1205,     0,  1206,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,   351,   352,   353,   354,
     355,  1207,  1208,     0,  1209,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,  1210,
     814,   368,   815,     0,   369,   370,   371,  1211,  1212,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,  1213,   816,  1214,   390,   391,
     392,   393,  1215,   394,   395,   817,   396,  1216,  1217,   398,
    1218,   400,   401,   402,     0,   403,   404,     0,     0,  1219,
     406,   407,     0,     0,   408,   409,   818,   410,   819,  1220,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,  1221,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,  1222,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,   459,  1223,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,  1224,
     475,   476,   477,   478,   479,   821,   480,   481,  1225,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,  1226,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,  1227,  1228,     0,     0,
     507,   508,  1229,   510,  1230,  1231,   512,   513,   514,   515,
     516,   517,   518,     0,  1232,   519,   520,   521,   522,   523,
    1233,     0,   524,   525,   526,   527,   528,   529,  1234,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,  1235,  1236,
    1237,  1238,   548,  1239,  1240,  1241,  1242,   553,   554,   555,
     556,  1243,     0,     0,     0,     0,     0,     0,  1244,  1245,
    1246,     0,     0,     0,     0,     0,     0,  1247,   800,  1176,
     617,  1177,  1178,  1179,   676,  1180,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,  2055,   233,   234,   235,     0,     0,     0,     0,  1181,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,   244,  1182,   802,  1183,  1184,     0,   248,   249,
     250,   251,   252,  1185,  1186,   253,   254,  1187,  1188,   257,
       0,   258,   259,   260,   261,  1189,     0,  1190,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,   279,
    1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,   281,   282,
     283,   284,   285,  1198,  1199,   288,  1200,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,  1038,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
    1201,   316,   317,   318,  1202,  1203,   320,     0,   321,   322,
    1204,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,  1205,     0,  1206,   334,     0,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,   810,
     351,   352,   353,   354,   355,  1207,  1208,     0,  1209,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,  1210,   814,   368,   815,     0,   369,   370,
     371,  1211,  1212,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1213,
     816,  1214,   390,   391,   392,   393,  1215,   394,   395,   817,
     396,  1216,  1217,   398,  1218,   400,   401,   402,     0,   403,
     404,     0,     0,  1219,   406,   407,     0,     0,   408,   409,
     818,   410,   819,  1220,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,  1221,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,  1222,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,  1223,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,  1224,   475,   476,   477,   478,   479,   821,
     480,   481,  1225,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,  1226,     0,   497,
     498,     0,   499,   822,   500,   501,   502,   503,   504,     0,
    1227,  1228,     0,     0,   507,   508,  1229,   510,  1230,  1231,
     512,   513,   514,   515,   516,   517,   518,     0,  1232,   519,
     520,   521,   522,   523,  1233,     0,   524,   525,   526,   527,
     528,   529,  1234,     0,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,  1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,
    1242,   553,   554,   555,   556,  1243,     0,     0,     0,     0,
       0,     0,  1244,  1245,     0,     0,     0,     0,     0,     0,
       0,  1247,   800,  1176,   617,  1177,  1178,  1179,   676,  1180,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,  1181,     0,     0,   236,   237,     0,   238,
     239,   240,   801,   241,   242,   243,   244,  1182,   802,  1183,
    1184,     0,   248,   249,   250,   251,   252,  1185,  1186,   253,
     254,  1187,  1188,   257,     0,   258,   259,   260,   261,  1189,
       0,  1190,     0,   263,   264,   265,   266,   267,   804,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
     805,   277,   278,   279,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,   280,   281,   282,   283,   284,   285,  1198,  1199,   288,
    1200,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,  1038,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,  1201,   316,   317,   318,  1202,  1203,
     320,     0,   321,   322,  1204,   324,     0,   325,     0,   326,
     807,  2663,   808,   327,   328,   329,   330,     0,   331,  1205,
       0,  1206,   334,     0,   335,   336,   337,   338,   339,   809,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,   810,   351,   352,   353,   354,   355,  1207,
    1208,     0,  1209,     0,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,     0,     0,   366,  1210,   814,   368,
     815,     0,   369,   370,   371,  1211,  1212,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1213,   816,  1214,   390,   391,   392,   393,
    1215,   394,   395,   817,   396,  1216,  1217,   398,  1218,   400,
     401,   402,     0,   403,   404,     0,     0,  1219,   406,   407,
       0,     0,   408,   409,   818,   410,   819,  1220,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
    1221,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1222,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,   820,   457,   458,
     459,  1223,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,  1224,   475,   476,
     477,   478,   479,   821,   480,   481,  1225,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,  1226,     0,   497,   498,     0,   499,   822,   500,   501,
     502,   503,   504,     0,  1227,  1228,     0,     0,   507,   508,
    1229,   510,  1230,  1231,   512,   513,   514,   515,   516,   517,
     518,     0,  1232,   519,   520,   521,   522,   523,  1233,     0,
     524,   525,   526,   527,   528,   529,  1234,     0,   531,   823,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,  1235,  1236,  1237,  1238,
     548,  1239,  1240,  1241,  1242,   553,   554,   555,   556,  1243,
       0,     0,     0,     0,     0,     0,  1244,  1245,     0,     0,
       0,     0,     0,     0,     0,  1247,   800,  1176,   617,  1177,
    1178,  1179,   676,  1180,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,  1181,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
     244,  1182,   802,  1183,  1184,     0,   248,   249,   250,   251,
     252,  1185,  1186,   253,   254,  1187,  1188,   257,     0,   258,
     259,   260,   261,  1189,     0,  1190,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,   280,   281,   282,   283,   284,
     285,  1198,  1199,   288,  1200,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,  1038,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,  1201,   316,
     317,   318,  1202,  1203,   320,     0,   321,   322,  1204,   324,
       0,   325,     0,   326,   807,     0,   808,   327,   328,   329,
     330,     0,   331,  1205,     0,  1206,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,   351,   352,
     353,   354,   355,  1207,  1208,     0,  1209,     0,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,     0,     0,
     366,  1210,   814,   368,   815,     0,   369,   370,   371,  1211,
    1212,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,  1213,   816,  1214,
     390,   391,   392,   393,  1215,   394,   395,   817,   396,  1216,
    1217,   398,  1218,   400,   401,   402,     0,   403,   404,     0,
       0,  1219,   406,   407,     0,     0,   408,   409,   818,   410,
     819,  1220,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,  1221,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
    1222,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,  1223,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,  1224,   475,   476,   477,   478,   479,   821,   480,   481,
    1225,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,  1226,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,  1227,  1228,
       0,     0,   507,   508,  1229,   510,  1230,  1231,   512,   513,
     514,   515,   516,   517,   518,     0,  1232,   519,   520,   521,
     522,   523,  1233,     0,   524,   525,   526,   527,   528,   529,
    1234,  4005,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
    1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,   553,
     554,   555,   556,  1243,     0,     0,     0,     0,     0,     0,
    1244,  1245,     0,     0,     0,     0,     0,     0,     0,  1247,
     800,  1176,   617,  1177,  1178,  1179,   676,  1180,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,  1181,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,  1182,   802,  1183,  1184,     0,
     248,   249,   250,   251,   252,  1185,  1186,   253,   254,  1187,
    1188,   257,     0,   258,   259,   260,   261,  1189,     0,  1190,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,
     281,   282,   283,   284,   285,  1198,  1199,   288,  1200,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,  1038,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,  1201,   316,   317,   318,  1202,  1203,   320,     0,
     321,   322,  1204,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,  1205,     0,  1206,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,  1207,  1208,     0,
    1209,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,  1210,   814,   368,   815,     0,
     369,   370,   371,  1211,  1212,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  1213,   816,  1214,   390,   391,   392,   393,  1215,   394,
     395,   817,   396,  1216,  1217,   398,  1218,   400,   401,   402,
       0,   403,   404,     0,     0,  1219,   406,   407,     0,     0,
     408,   409,   818,   410,   819,  1220,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,  1221,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1222,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,  1223,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,  1224,   475,   476,   477,   478,
     479,   821,   480,   481,  1225,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,  1226,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,  1227,  1228,     0,     0,   507,   508,  1229,   510,
    1230,  1231,   512,   513,   514,   515,   516,   517,   518,     0,
    1232,   519,   520,   521,   522,   523,  1233,     0,   524,   525,
     526,   527,   528,   529,  1234,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,
    1240,  1241,  1242,   553,   554,   555,   556,  1243,     0,     0,
       0,     0,     0,     0,  1244,  1245,     0,     0,     0,     0,
       0,     0,     0,  1247,   800,  1176,   617,  1177,  1178,  1179,
     676,  1180,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,  1181,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,   244,  1182,
     802,  1183,  1184,     0,   248,   249,   250,   251,   252,  1185,
    1186,   253,   254,  1187,  1188,   257,     0,   258,   259,   260,
     261,  1189,     0,  1190,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,   278,   279,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,   280,   281,   282,   283,   284,   285,  1198,
    1199,   288,  1200,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
    1038,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,  1201,   316,   317,   318,
    1202,  1203,   320,     0,   321,   322,  1204,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,  1205,     0,  1206,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,   351,   352,   353,   354,
     355,  1207,  1208,     0,  1209,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,  1210,
     814,   368,   815,     0,   369,   370,   371,  1211,  1212,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,  1213,   816,  1214,   390,   391,
     392,   393,  1215,   394,   395,   817,   396,  1216,  1217,   398,
    1218,   400,   401,   402,     0,   403,   404,     0,     0,  1219,
     406,   407,     0,     0,   408,   409,   818,   410,   819,  1220,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,  1221,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,  1222,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,   459,  1223,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,  1224,
     475,   476,   477,   478,   479,   821,   480,   481,  1225,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,  1226,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,  1227,  1228,     0,     0,
     507,   508,  1229,   510,  1230,  1231,   512,   513,   514,   515,
     516,   517,   518,     0,  1232,   519,   520,   521,   522,   523,
    1233,     0,   524,   525,   526,   527,   528,   529,  1234,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,  1235,  1236,
    1237,  1238,   548,  1239,  1240,  1241,  1242,   553,   554,   555,
     556,  1243,     0,     0,     0,     0,     0,     0,  2058,  2059,
       0,     0,     0,     0,     0,     0,     0,  1247,   800,  2791,
     617,  1177,  1178,  1179,   676,  1180,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,  1181,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,   244,  1182,   802,  1183,  1184,     0,   248,   249,
     250,   251,   252,  1185,  1186,   253,   254,  1187,  1188,   257,
       0,   258,   259,   260,   261,  1189,     0,  1190,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,   279,
    1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,   281,   282,
     283,   284,   285,  1198,  1199,   288,  1200,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,  1038,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
    1201,   316,   317,   318,  1202,  1203,   320,     0,   321,   322,
    1204,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,  1205,     0,  1206,   334,     0,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,   810,
     351,   352,   353,   354,   355,  1207,  1208,     0,  1209,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,  1210,   814,   368,   815,     0,   369,   370,
     371,  1211,  1212,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1213,
     816,  1214,   390,   391,   392,   393,  1215,   394,   395,   817,
     396,  1216,  1217,   398,  1218,   400,   401,   402,     0,   403,
     404,     0,     0,  1219,   406,   407,     0,     0,   408,   409,
     818,   410,   819,  1220,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,  1221,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,  1222,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,  1223,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,  1224,   475,   476,   477,   478,   479,   821,
     480,   481,  1225,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,  1226,     0,   497,
     498,     0,   499,   822,   500,   501,   502,   503,   504,     0,
    1227,  1228,     0,     0,   507,   508,  1229,   510,  1230,  1231,
     512,   513,   514,   515,   516,   517,   518,     0,  1232,   519,
     520,   521,   522,   523,  1233,     0,   524,   525,   526,   527,
     528,   529,  1234,     0,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,  1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,
    1242,   553,   554,   555,   556,  1243,     0,     0,     0,     0,
       0,     0,  1244,  1245,     0,     0,     0,     0,     0,     0,
       0,  1247,   800,  1176,   617,  1177,  1178,  1179,   676,  1180,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,  1181,     0,     0,   236,   237,     0,   238,
     239,   240,   801,   241,   242,   243,   244,  1182,   802,  1183,
    1184,     0,   248,   249,   250,   251,   252,  1185,  1186,   253,
     254,  1187,  1188,   257,     0,   258,   259,   260,   261,  1189,
       0,  1190,     0,   263,   264,   265,   266,   267,   804,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
     805,   277,   278,  4017,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,   280,   281,   282,   283,   284,   285,  1198,  1199,   288,
    1200,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,  1038,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,  1201,   316,   317,   318,  1202,  1203,
     320,     0,   321,   322,  1204,   324,     0,   325,     0,   326,
     807,     0,   808,   327,   328,   329,   330,     0,   331,  1205,
       0,  1206,   334,     0,   335,   336,   337,   338,   339,   809,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,   810,   351,   352,   353,   354,   355,  1207,
    1208,     0,  1209,     0,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,     0,     0,   366,  1210,   814,   368,
     815,     0,   369,   370,   371,  1211,  1212,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1213,   816,  1214,   390,   391,   392,   393,
    1215,   394,   395,   817,   396,  1216,  1217,   398,  1218,   400,
     401,   402,     0,   403,   404,     0,     0,  1219,   406,   407,
       0,     0,   408,   409,   818,   410,   819,  1220,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
    1221,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1222,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,   820,   457,   458,
     459,  1223,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,  1224,   475,   476,
     477,   478,   479,   821,   480,   481,  1225,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,  1226,     0,   497,   498,     0,   499,   822,   500,   501,
     502,   503,   504,     0,  1227,  1228,     0,     0,   507,   508,
    1229,   510,  1230,  1231,   512,   513,   514,   515,   516,   517,
     518,     0,  1232,   519,   520,   521,   522,   523,  1233,     0,
     524,   525,   526,   527,   528,   529,  1234,     0,   531,   823,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,  1235,  1236,  1237,  1238,
     548,  1239,  1240,  1241,  1242,   553,   554,   555,   556,  1243,
       0,     0,     0,     0,     0,     0,  1244,  1245,     0,     0,
       0,     0,     0,     0,     0,  1247,   800,  1176,   617,  1177,
    1178,  1179,   676,  1180,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,  1181,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
     244,  1182,   802,  1183,  1184,     0,   248,   249,   250,   251,
     252,  1185,  1186,   253,   254,  1187,  1188,   257,     0,   258,
     259,   260,   261,  1189,     0,  1190,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,   280,   281,   282,   283,   284,
     285,  1198,  1199,   288,  1200,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,  1038,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,  1201,   316,
     317,   318,  1202,  1203,   320,     0,   321,   322,  1204,   324,
       0,   325,     0,   326,   807,     0,   808,   327,   328,   329,
     330,     0,   331,  1205,     0,  1206,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,   351,   352,
     353,   354,   355,  1207,  1208,     0,  1209,     0,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,     0,     0,
     366,  1210,   814,   368,   815,     0,   369,   370,   371,  1211,
    1212,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,  1213,   816,  1214,
     390,   391,   392,   393,  1215,   394,   395,   817,   396,  1216,
    1217,   398,  1218,   400,   401,   402,     0,   403,   404,     0,
       0,  1219,   406,   407,     0,     0,   408,   409,   818,   410,
     819,  1220,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,  1221,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
    1222,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,  1223,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,  1224,   475,   476,   477,   478,   479,   821,   480,   481,
    1225,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,  1226,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,  1227,  1228,
       0,     0,   507,   508,  1229,   510,  1230,  1231,   512,   513,
     514,   515,   516,   517,   518,     0,  1232,   519,   520,   521,
     522,   523,  1233,     0,   524,   525,   526,   527,   528,   529,
    1234,     0,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,  4342,
    1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,   553,
     554,   555,   556,  1243,     0,     0,     0,     0,     0,     0,
    1244,  1245,     0,     0,     0,     0,     0,     0,     0,  1247,
     800,  1176,   617,  1177,  1178,  1179,   676,  1180,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,  1181,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,  1182,   802,  1183,  1184,     0,
     248,   249,   250,   251,   252,  1185,  1186,   253,   254,  1187,
    1188,   257,     0,   258,   259,   260,   261,  1189,     0,  1190,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,
     281,   282,   283,   284,   285,  1198,  1199,   288,  1200,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,  1038,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,  1201,   316,   317,   318,  1202,  1203,   320,     0,
     321,   322,  1204,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,  1205,     0,  1206,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,  1207,  1208,     0,
    1209,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,  1210,   814,   368,   815,     0,
     369,   370,   371,  1211,  1212,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  1213,   816,  1214,   390,   391,  4351,   393,  1215,   394,
     395,   817,   396,  1216,  1217,   398,  1218,   400,   401,   402,
       0,   403,   404,     0,     0,  1219,   406,   407,     0,     0,
     408,   409,   818,   410,   819,  1220,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,  1221,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1222,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,  1223,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,  1224,   475,   476,   477,   478,
     479,   821,   480,   481,  1225,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,  1226,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,  1227,  1228,     0,     0,   507,   508,  1229,   510,
    1230,  1231,   512,   513,   514,   515,   516,   517,   518,     0,
    1232,   519,   520,   521,   522,   523,  1233,     0,   524,   525,
     526,   527,   528,   529,  1234,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,
    1240,  1241,  1242,   553,   554,   555,   556,  1243,     0,     0,
       0,     0,     0,     0,  1244,  1245,     0,     0,     0,     0,
       0,     0,     0,  1247,   800,  1176,   617,  1177,  1178,  1179,
     676,  1180,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,  1181,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,   244,  1182,
     802,  1183,  1184,     0,   248,   249,   250,   251,   252,  1185,
    1186,   253,   254,  1187,  1188,   257,     0,   258,   259,   260,
     261,  1189,     0,  1190,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,  4663,   279,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,   280,   281,   282,   283,   284,   285,  1198,
    1199,   288,  1200,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
    1038,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,  1201,   316,   317,   318,
    1202,  1203,   320,     0,   321,   322,  1204,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,  1205,     0,  4664,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,   351,   352,   353,   354,
     355,  1207,  1208,     0,  1209,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,  1210,
     814,   368,   815,     0,   369,   370,   371,  1211,  1212,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,  1213,   816,  1214,   390,   391,
     392,   393,  1215,   394,   395,   817,   396,  1216,  1217,   398,
    1218,   400,   401,   402,     0,   403,   404,     0,     0,  1219,
     406,   407,     0,     0,   408,   409,   818,   410,   819,  1220,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,  1221,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,  1222,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,  4665,  1223,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,  1224,
     475,   476,   477,   478,   479,   821,   480,   481,  1225,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,  1226,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,  1227,  1228,     0,     0,
     507,   508,  1229,   510,  1230,  1231,   512,   513,   514,   515,
     516,   517,   518,     0,  1232,   519,   520,   521,   522,   523,
    1233,     0,   524,   525,   526,   527,   528,   529,  1234,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,  1235,  1236,
    1237,  1238,   548,  1239,  1240,  1241,  1242,   553,   554,   555,
     556,  1243,     0,     0,     0,     0,     0,     0,  1244,  1245,
       0,     0,     0,     0,     0,     0,     0,  4666,   800,  1176,
     617,  1177,  1178,  1179,   676,  1180,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,  1181,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,  5136,  1182,   802,  1183,  1184,     0,   248,   249,
     250,   251,   252,  1185,  1186,   253,   254,  1187,  1188,   257,
       0,   258,   259,   260,   261,  1189,     0,  1190,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,  5137,
    1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,   281,   282,
     283,   284,   285,  1198,  1199,   288,  1200,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,  1038,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
    1201,   316,   317,   318,  1202,  1203,   320,     0,   321,   322,
    1204,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,  1205,     0,  1206,   334,     0,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,   810,
     351,   352,   353,   354,   355,  1207,  1208,     0,  1209,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,  1210,   814,   368,   815,     0,   369,   370,
     371,  1211,  1212,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1213,
     816,  1214,   390,   391,   392,   393,  1215,   394,   395,   817,
     396,  1216,  1217,   398,  1218,   400,   401,   402,     0,   403,
     404,     0,     0,  1219,   406,   407,     0,     0,   408,   409,
     818,   410,   819,  1220,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,  1221,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,  1222,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,  1223,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,  1224,   475,   476,   477,   478,   479,   821,
     480,   481,  1225,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,  1226,     0,   497,
     498,     0,   499,   822,   500,   501,   502,   503,   504,     0,
    1227,  1228,     0,     0,   507,   508,  1229,   510,  1230,  1231,
     512,   513,   514,   515,  5138,   517,   518,     0,  1232,   519,
     520,   521,   522,   523,  1233,     0,   524,   525,   526,   527,
     528,   529,  1234,     0,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,  1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,
    1242,   553,   554,   555,   556,  1243,     0,     0,     0,     0,
       0,     0,  1244,  1245,     0,     0,     0,     0,     0,     0,
       0,  1247,   800,  1176,   617,  1177,  1178,  1179,   676,  1180,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,  1181,     0,     0,   236,   237,     0,   238,
     239,   240,   801,   241,   242,   243,   244,  1182,   802,  1183,
    1184,     0,   248,   249,   250,   251,   252,  1185,  1186,   253,
     254,  1187,  1188,   257,     0,   258,   259,   260,   261,  1189,
       0,  1190,     0,   263,   264,   265,   266,   267,   804,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
     805,   277,   278,  5137,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,   280,   281,   282,   283,   284,   285,  1198,  1199,   288,
    1200,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,  1038,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,  1201,   316,   317,   318,  1202,  1203,
     320,     0,   321,   322,  1204,   324,     0,   325,     0,   326,
     807,     0,   808,   327,   328,   329,   330,     0,   331,  1205,
       0,  1206,   334,     0,   335,   336,   337,   338,   339,   809,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,   810,   351,   352,   353,   354,   355,  1207,
    1208,     0,  1209,     0,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,     0,     0,   366,  1210,   814,   368,
     815,     0,   369,   370,   371,  1211,  1212,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1213,   816,  1214,   390,   391,   392,   393,
    1215,   394,   395,   817,   396,  1216,  1217,   398,  1218,   400,
     401,   402,     0,   403,   404,     0,     0,  1219,   406,   407,
       0,     0,   408,   409,   818,   410,   819,  1220,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
    1221,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1222,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,   820,   457,   458,
     459,  1223,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,  1224,   475,   476,
     477,   478,   479,   821,   480,   481,  1225,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,  1226,     0,   497,   498,     0,   499,   822,   500,   501,
     502,   503,   504,     0,  1227,  1228,     0,     0,   507,   508,
    1229,   510,  1230,  1231,   512,   513,   514,   515,  5138,   517,
     518,     0,  1232,   519,   520,   521,   522,   523,  1233,     0,
     524,   525,   526,   527,   528,   529,  1234,     0,   531,   823,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,  1235,  1236,  1237,  1238,
     548,  1239,  1240,  1241,  1242,   553,   554,   555,   556,  1243,
       0,     0,     0,     0,     0,     0,  1244,  1245,     0,     0,
       0,     0,     0,     0,     0,  1247,   800,  1176,   617,  1177,
    1178,  1179,   676,  1180,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,  1181,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
     244,  1182,   802,  1183,  1184,     0,   248,   249,   250,   251,
     252,  1185,  1186,   253,   254,  1187,  1188,   257,     0,   258,
     259,   260,   261,  1189,     0,  1190,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,   280,   281,   282,   283,   284,
     285,  1198,  1199,   288,  4858,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,  1038,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,  1201,   316,
     317,   318,  1202,  1203,   320,     0,   321,   322,  1204,   324,
       0,   325,     0,   326,   807,     0,   808,   327,   328,   329,
     330,     0,   331,  1205,     0,  1206,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,   351,   352,
     353,   354,   355,  1207,  1208,     0,  1209,     0,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,     0,     0,
     366,  1210,   814,   368,   815,     0,   369,   370,   371,  1211,
    1212,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,  1213,   816,  1214,
     390,   391,   392,   393,     0,   394,   395,   817,   396,  1216,
    1217,   398,  1218,   400,   401,   402,     0,   403,   404,     0,
       0,  1219,   406,   407,     0,     0,   408,   409,   818,   410,
     819,  1220,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,  1221,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
    1222,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,  2648,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,  1224,   475,   476,   477,   478,   479,   821,   480,   481,
    1225,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,  1226,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,  1227,  1228,
       0,     0,   507,   508,  1229,   510,  1230,  1231,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,  1233,     0,   524,   525,   526,   527,   528,   529,
    1234,     0,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
    1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,   553,
     554,   555,   556,     0,     0,     0,     0,     0,     0,     0,
    2649,  2650,     0,     0,     0,     0,     0,     0,     0,  2651,
     800,  1176,   617,  1177,  1178,  1179,   676,  1180,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,  1181,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243, -2570,  1182,   802,  1183,  1184,     0,
     248,   249,   250,   251,   252,  1185,  1186,   253,   254,  1187,
    1188,   257,     0,   258,   259,   260,   261,  1189,     0,  1190,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,  5137,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,
     281,   282,   283,   284,   285,  1198,  1199,   288,  1200,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,  1038,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,  1201,   316,   317,   318,  1202,  1203,   320,     0,
     321,   322,  1204,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,  1205,     0,  1206,
     334,     0,   335,   336,   337,   338,   339, -2570,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,  1207,  1208,     0,
    1209,     0,   359,     0,     0,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,  1210,   814,   368, -2570,     0,
     369,   370,   371,  1211,  1212,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  1213,   816,  1214,   390,   391,   392,   393,  1215,   394,
     395,     0,   396,  1216,  1217,   398,  1218,   400,   401,   402,
       0,   403,   404,     0,     0,  1219,   406,   407,     0,     0,
     408,   409,   818,   410,   819,  1220,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,  1221,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1222,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,  1223,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,  1224,   475,   476,   477,   478,
     479, -2570,   480,   481,  1225,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,  1226,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,  1227,  1228,     0,     0,   507,   508,  1229,   510,
    1230,  1231,   512,   513,   514,   515,  5138,   517,   518,     0,
    1232,   519,   520,   521,   522,   523,  1233,     0,   524,   525,
     526,   527,   528,   529,  1234,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,
    1240,  1241,  1242,   553,   554,   555,   556, -2570,     0,     0,
       0,     0,     0,     0,  1244,  1245,     0,     0,     0,     0,
       0,     0,     0,  1247,   800,  1176,   617,  1177,  1178,  1179,
     676,  1180,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,  1181,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,   244,  1182,
     802,  1183,  1184,     0,   248,   249,   250,   251,   252,  1185,
    1186,   253,   254,  1187,  1188,   257,     0,   258,   259,   260,
     261,  1189,     0,  1190,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,   278,   279,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,   280,   281,   282,   283,   284,   285,  1198,
    1199,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
    1038,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,  1201,   316,   317,   318,
    1202,  1203,   320,     0,   321,   322,  1204,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,  1205,     0,  1206,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,   351,   352,   353,   354,
     355,  1207,  1208,     0,  1209,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,  1210,
     814,   368,   815,     0,   369,   370,   371,  1211,  1212,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,  1213,   816,  1214,   390,   391,
     392,   393,     0,   394,   395,   817,   396,  1216,  1217,   398,
    1218,   400,   401,   402,     0,   403,   404,     0,     0,  1219,
     406,   407,     0,     0,   408,   409,   818,   410,   819,  1220,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,  1221,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,  1222,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,   459,  2648,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,  1224,
     475,   476,   477,   478,   479,   821,   480,   481,  1225,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,  1226,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,  1227,  1228,     0,     0,
     507,   508,  1229,   510,  1230,  1231,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
    1233,     0,   524,   525,   526,   527,   528,   529,  1234,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,  1235,  1236,
    1237,  1238,   548,  1239,  1240,  1241,  1242,   553,   554,   555,
     556,     0,     0,     0,     0,     0,     0,     0,  2649,  2650,
       0,     0,   800,  1176,   617,  1177,  1178,  2651,   676,  1180,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,  1181,     0,     0,   236,   237,     0,   238,
     239,   240,   801,   241,   242,   243,   244,  1182,   802,  1183,
    1184,     0,   248,   249,   250,   251,   252,  1185,  1186,   253,
     254,  1187,  1188,   257,     0,   258,   259,   260,   261,  1189,
       0,  1190,     0,   263,   264,   265,   266,   267,   804,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
     805,   277,   278,   279,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,   280,   281,   282,   283,   284,   285,  1198,  1199,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,  1038,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,  1201,   316,   317,   318,  1202,  1203,
     320,     0,   321,   322,  1204,   324,     0,   325,     0,   326,
     807,     0,   808,   327,   328,   329,   330,     0,   331,  1205,
       0,  1206,   334,     0,   335,   336,   337,   338,   339,   809,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,   810,   351,   352,   353,   354,   355,  1207,
    1208,     0,  1209,     0,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,     0,     0,   366,  1210,   814,   368,
     815,     0,   369,   370,   371,  1211,  1212,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1213,   816,  1214,   390,   391,   392,   393,
       0,   394,   395,   817,   396,  1216,  1217,   398,  1218,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   818,   410,   819,  1220,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
    1221,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1222,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,   820,   457,   458,
     459,  2780,  2781,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,  1224,   475,   476,
     477,   478,   479,   821,   480,   481,  1225,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,  1226,     0,   497,   498,     0,   499,   822,   500,   501,
     502,   503,   504,     0,  1227,  1228,     0,     0,   507,   508,
    1229,   510,  1230,  1231,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,  1233,     0,
     524,   525,   526,   527,   528,   529,  1234,     0,   531,   823,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,  1235,  1236,  1237,  1238,
     548,  1239,  1240,  1241,  1242,   553,   554,   555,   556,     0,
       0,     0,     0,     0,     0,     0,  2782,  2783,     0,     0,
       0,     0,     0,     0,     0,  2651,   800,  1176,   617,  1177,
    1178,  1179,   676,  1180,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,  1181,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
     244,  1182,   802,  1183,  1184,     0,   248,   249,   250,   251,
     252,  1185,  1186,   253,   254,  1187,  1188,   257,     0,   258,
     259,   260,   261,  1189,     0,  1190,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,   280,   281,   282,   283,   284,
     285,  1198,  1199,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,  1038,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,  1201,   316,
     317,   318,  1202,  1203,   320,     0,   321,   322,  1204,   324,
       0,   325,     0,   326,   807,     0,   808,   327,   328,   329,
     330,     0,   331,  1205,     0,  1206,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,   351,   352,
     353,   354,   355,  1207,  1208,     0,  1209,     0,   359,     0,
     812,   360,   813,   361,   362,   363,   364,   365,     0,     0,
     366,  1210,   814,   368,   815,     0,   369,   370,   371,  1211,
    1212,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,  1213,   816,  1214,
     390,   391,   392,   393,     0,   394,   395,   817,   396,  1216,
    1217,   398,  1218,   400,   401,   402,     0,   403,   404,     0,
       0,  1219,   406,   407,     0,     0,   408,   409,   818,   410,
     819,  1220,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,  1221,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
    1222,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,  2648,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,  1224,   475,   476,   477,   478,   479,   821,   480,   481,
    1225,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,  1226,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,  1227,  1228,
       0,     0,   507,   508,  1229,   510,  1230,  1231,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,  1233,     0,   524,   525,   526,   527,   528,   529,
    1234,     0,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
    1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,   553,
     554,   555,   556,     0,     0,     0,     0,     0,     0,     0,
    2649,  2650,     0,     0,   800,  1176,   617,  1177,  1178,  2651,
     676,  1180,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,  1181,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,   244,  1182,
     802,  1183,  1184,     0,   248,   249,   250,   251,   252,  1185,
    1186,   253,   254,  1187,  1188,   257,     0,   258,   259,   260,
     261,  1189,     0,  1190,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,   278,   279,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,   280,   281,   282,   283,   284,   285,  1198,
    1199,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
    1038,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,  1201,   316,   317,   318,
    1202,  1203,   320,     0,   321,   322,  1204,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,  1205,     0,  1206,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,   351,   352,   353,   354,
     355,  1207,  1208,     0,  1209,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,  1210,
     814,   368,   815,     0,   369,   370,   371,  1211,  1212,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,  1213,   816,  1214,   390,   391,
     392,   393,     0,   394,   395,   817,   396,  1216,  1217,   398,
    1218,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   818,   410,   819,  1220,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,  1221,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,  1222,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,   459,  2648,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,  1224,
     475,   476,   477,   478,   479,   821,   480,   481,  1225,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,  1226,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,  1227,  1228,     0,     0,
     507,   508,  1229,   510,  1230,  1231,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
    1233,     0,   524,   525,   526,   527,   528,   529,  1234,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,  1235,  1236,
    1237,  1238,   548,  1239,  1240,  1241,  1242,   553,   554,   555,
     556,     0,     0,   800,  1176,   617,  1177,  1178,     0,   676,
    1180,     0,     0,     0,     0,     0,     0,  2651,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,  1181,     0,     0,   236,   237,     0,
     238,   239,   240,   801,   241,   242,   243,   244,  1182,   802,
    1183,  1184,     0,  3917,   249,   250,   251,   252,  1185,  1186,
     253,   254,  1187,  1188,   257,     0,   258,   259,   260,   261,
    1189,     0,  1190,     0,   263,   264,   265,   266,   267,   804,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,   805,   277,   278,   279,  1191,  1192,  1193,  1194,  1195,
    1196,  1197,   280,   281,   282,   283,   284,   285,  1198,  1199,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,  1038,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,  1201,   316,   317,   318,  1202,
    1203,   320,     0,   321,   322,  1204,   324,     0,   325,     0,
     326,   807,     0,   808,   327,   328,   329,   330,     0,   331,
    1205,     0,  1206,   334,     0,   335,   336,   337,   338,   339,
     809,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,   810,   351,   352,   353,   354,   355,
    1207,  1208,     0,  1209,     0,   359,   811,   812,   360,   813,
     361,   362,   363,   364,   365,     0,     0,   366,  1210,   814,
     368,   815,     0,   369,   370,   371,  1211,  1212,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,  1213,   816,  1214,   390,   391,   392,
     393,     0,   394,   395,   817,   396,  1216,  1217,   398,  1218,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,   818,   410,   819,  1220,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,  1221,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,  1222,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,   820,   457,
     458,   459,  2648,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,  1224,   475,
     476,   477,   478,   479,   821,   480,   481,  1225,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,  1226,     0,   497,   498,     0,   499,   822,   500,
     501,   502,   503,   504,     0,  1227,  1228,     0,     0,   507,
     508,  1229,   510,  1230,  1231,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,  1233,
       0,   524,   525,   526,   527,   528,   529,  1234,     0,   531,
     823,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,  1235,  1236,  1237,
    1238,   548,  1239,  1240,  1241,  1242,   553,   554,   555,   556,
       0,     0,   800,  1176,   617,  1177,  1178,     0,   676,  1180,
       0,     0,     0,     0,     0,     0,  2651,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,  1181,     0,     0,   236,   237,     0,   238,
     239,   240,   801,   241,   242,   243,   244,  1182,   802,  1183,
    1184,     0,   248,   249,   250,   251,   252,  1185,  1186,   253,
     254,  1187,  1188,   257,     0,   258,   259,   260,   261,  1189,
       0,  1190,     0,   263,   264,   265,   266,   267,   804,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
     805,   277,   278,   279,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,   280,   281,   282,   283,   284,   285,  1198,  1199,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,  1038,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,  1201,   316,   317,   318,  1202,  1203,
     320,     0,   321,   322,  1204,   324,     0,   325,     0,   326,
     807,     0,   808,   327,   328,   329,   330,     0,   331,  1205,
       0,  1206,   334,     0,   335,   336,   337,   338,   339,   809,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,   810,   351,   352,   353,   354,   355,  1207,
    1208,     0,  1209,     0,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,     0,     0,   366,  1210,   814,   368,
     815,     0,   369,   370,   371,  1211,  1212,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1213,   816,  1214,   390,   391,   392,   393,
       0,   394,   395,   817,   396,  1216,  1217,   398,  1218,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   818,   410,   819,  1220,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
    1221,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1222,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,   820,   457,   458,
     459,  2648,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,  1224,   475,   476,
     477,   478,   479,   821,   480,   481,  1225,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,  1226,     0,   497,   498,     0,   499,   822,   500,   501,
     502,   503,   504,     0,  1227,  1228,     0,     0,   507,   508,
    1229,   510,  1230,  1231,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,  1233,     0,
     524,   525,   526,   527,   528,   529,  1234,     0,   531,   823,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,  1235,  1236,  1237,  1238,
    4382,  1239,  1240,  1241,  1242,   553,   554,   555,   556,     0,
       0,   800,  1176,   617,  1177,  1178,  1179,   676,  1180,     0,
       0,     0,     0,     0,     0,  2651,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,  1181,     0,     0,   236,   237,     0,   238,   239,
     240,   801,   241,   242,   243,     0,  1182,   802,  1183,  1184,
       0,   248,   249,   250,   251,   252,  1185,  1186,   253,   254,
    1187,  1188,   257,     0,   258,   259,   260,   261,  1189,     0,
    1190,     0,   263,   264,   265,   266,   267,   804,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,   805,
     277,   278,   279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,
     280,   281,   282,   283,   284,   285,  1198,  1199,   288,  1200,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,  1038,   303,   304,
       0,   305,   306,   307,     0,   308,     0,   310,     0,   311,
     312,   313,   314,  1201,   316,   317,   318,  1202,  1203,   320,
       0,   321,   322,  1204,   324,     0,   325,     0,   326,   807,
       0,   808,   327,   328,   329,   330,     0,   331,  1205,     0,
    1206,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,   810,   351,   352,   353,   354,   355,  1207,  1208,
       0,  1209,     0,   359,     0,     0,   360,   813,   361,   362,
     363,   364,   365,     0,     0,   366,  1210,   814,   368,     0,
       0,   369,   370,   371,  1211,  1212,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,  1213,   816,  1214,   390,   391,   392,   393,  1215,
     394,   395,     0,   396,  1216,  1217,   398,  1218,   400,   401,
     402,     0,   403,   404,     0,     0,  1219,   406,   407,     0,
       0,   408,   409,   818,   410,   819,  1220,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,  1221,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,  1222,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,   820,   457,   458,   459,
    1223,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,  1224,   475,   476,   477,
     478,   479,     0,   480,   481,  1225,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
    1226,     0,   497,   498,     0,   499,   822,   500,   501,   502,
     503,   504,     0,  1227,  1228,     0,     0,   507,   508,  1229,
     510,  1230,  1231,   512,   513,   514,   515,   516,   517,   518,
       0,  1232,   519,   520,   521,   522,   523,  1233,     0,   524,
     525,   526,   527,   528,   529,  1234,     0,   531,   823,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,
    1239,  1240,  1241,  1242,   553,   554,   555,   556,     0,     0,
     800,     0,     0,     0,     0,  1244,  1245,     0,     0,     0,
       0,     0,     0,     0,  1247,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,   245,   802,   246,   247,     0,
     248,   249,   250,   251,   252,     0,  1186,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,  1189,     0,  1190,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,  1202,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,  1205,     0,   333,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,  3437,     0,   366,  1210,   814,   368,   815,     0,
     369,   370,   371,  1211,  1212,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   816,   389,   390,   391,   392,   393,     0,   394,
     395,   817,   396,     0,  1217,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   765,   405,   406,   407,     0,     0,
     408,   409,   818,   410,   819,  1220,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,  1221,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,   460,
    3438,   462,   463,   464,   465,   466,   467,   468,   469,    39,
     470,   471,   472,   473,   474,  1224,   475,   476,   477,   478,
     479,   821,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,  1226,
       0,   497,   498,    43,   499,   822,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,  1229,   510,
    1230,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,  1233,     0,   524,   525,
     526,   527,   528,  1112,   530,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,    48,   537,   538,   539,
     540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,
    1240,  1241,  1242,  3439,   554,   555,   556,     0,     0,    49,
     800,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3440,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,   245,   802,   246,   247,     0,
     248,   249,   250,   251,   252,     0,  1186,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,  1189,     0,  1190,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,  1202,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,  1205,     0,   333,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,  3437,     0,   366,  1210,   814,   368,   815,     0,
     369,   370,   371,  1211,  1212,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   816,   389,   390,   391,   392,   393,     0,   394,
     395,   817,   396,     0,  1217,   398,   399,   400,   401,   402,
       0,   403,   404,     0,   765,   405,   406,   407,     0,     0,
     408,   409,   818,   410,   819,  1220,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,  1221,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,   460,
    3438,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,  1224,   475,   476,   477,   478,
     479,   821,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,  1226,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,  1229,   510,
    1230,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,  1233,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,
    1240,  1241,  1242,  3439,   554,   555,   556,     0,     0,   800,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3440,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,   801,
     241,   242,   243,   244,   245,   802,   246,   247,     0,   248,
     249,   250,   251,   252,     0,  1186,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,  1189,     0,  1190,     0,
     263,   264,   265,   266,   267,   804,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,   805,   277,   278,
     279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,  1202,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,   807,     0,   808,
     327,   328,   329,   330,     0,   331,  1205,     0,   333,   334,
       0,   335,   336,   337,   338,   339,   809,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
     810,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,   811,   812,   360,   813,   361,   362,   363,   364,
     365,     0,     0,   366,  1210,   814,   368,   815,     0,   369,
     370,   371,  1211,  1212,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   816,   389,   390,   391,   392,   393,     0,   394,   395,
     817,   396,     0,  1217,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,   818,   410,   819,  1220,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,  1221,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,   820,   457,   458,   459,   460,  3438,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,  1224,   475,   476,   477,   478,   479,
     821,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,  1226,     0,
     497,   498,     0,   499,   822,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,  1229,   510,  1230,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,  1233,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,   823,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,  1240,
    1241,  1242,  3439,   554,   555,   556,     0,     0,   800,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    50,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,   244,   245,   802,   246,   247,     0,   248,   249,
     250,   251,   252,     0,  1186,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,  1189,     0,  1190,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,   279,
    1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,  1202,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,  1205,     0,   333,   334,     0,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,   810,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,  1210,   814,   368,   815,     0,   369,   370,
     371,  1211,  1212,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     816,   389,   390,   391,   392,   393,     0,   394,   395,   817,
     396,     0,  1217,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     818,   410,   819,  1220,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,  1221,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,  1224,   475,   476,   477,   478,   479,   821,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,  1226,     0,   497,
     498,     0,   499,   822,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   507,   508,  1229,   510,  1230,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,  1233,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,  1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,
    1242,   553,   554,   555,   556,     0,     0,   800,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4045,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,   801,   241,   242,
     243,   244,   245,   802,   246,   247,     0,   248,   249,   250,
     251,   252,     0,  1186,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,  1189,     0,  1190,     0,   263,   264,
     265,   266,   267,   804,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,   805,   277,   278,   279,  1191,
    1192,  1193,  1194,  1195,  1196,  1197,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,  1202,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,   807,     0,   808,   327,   328,
     329,   330,     0,   331,  1205,     0,   333,   334,     0,   335,
     336,   337,   338,   339,   809,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,   810,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
     811,   812,   360,   813,   361,   362,   363,   364,   365,     0,
       0,   366,  1210,   814,   368,   815,     0,   369,   370,   371,
    1211,  1212,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   816,
     389,   390,   391,   392,   393,     0,   394,   395,   817,   396,
       0,  1217,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,   818,
     410,   819,  1220,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,  1221,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,   820,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,  1224,   475,   476,   477,   478,   479,   821,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,  1226,     0,   497,   498,
       0,   499,   822,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,  1229,   510,  1230,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,  1233,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,   823,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,  1235,  1236,  1237,  1238,   548,  1239,  1240,  1241,  1242,
     553,   554,   555,   556,     0,     0,   845,  1454,   617,     0,
       0,     0,   676,     0,     0,     0,     0,     0,     0,     0,
    5119,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
     244,   245,   802,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,   803,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,     0,     0,
       0,   806,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,  1756,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,   807,     0,   808,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,     0,     0,
     366,   367,   814,   368,   815,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   816,   389,
     390,   391,   392,   393,     0,   394,   395,   817,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,  1757,
       0,   405,   406,   407,     0,     0,   408,   409,   818,   410,
     819,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   821,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,  1758,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,     0,     0,   845,     0,     0,     0,     0,
    1455,  1456,  4937,     0,     0,     0,     0,     0,     0,  4938,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     3,     4,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,   801,   241,   242,   243,   244,
     245,   802,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,   803,     0,   263,   264,   265,   266,
     267,   804,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,   805,   277,   278,   279,     0,     0,     0,
     806,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,   807,     0,   808,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,   339,   809,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,   810,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,     0,     0,   366,
     367,   814,   368,   815,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   816,   389,   390,
     391,   392,   393,     0,   394,   395,   817,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   818,   410,   819,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
     820,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,    39,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   821,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,    43,   499,
     822,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,  1112,   530,
       0,   531,   823,   532,   533,   534,   535,     0,     0,   536,
       0,    48,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,     0,     0,    49,   800,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,   801,   241,   242,   243,   244,
     245,   802,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,   803,     0,   263,   264,   265,   266,
     267,   804,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,   805,   277,   278,   279,     0,     0,     0,
     806,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,   807,     0,   808,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,   339,   809,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,   810,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,     0,     0,   366,
     367,   814,   368,   815,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   816,   389,   390,
     391,   392,   393,     0,   394,   395,   817,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   818,   410,   819,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
     820,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   821,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
     822,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,   823,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,     0,     0,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4715,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,    39,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,    43,   499,     0,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,  1112,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
      48,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,     0,     0,    49,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,     0,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,     0,     0,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1305,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
       0,     0,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2813,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,   255,   256,   257,     0,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
       0,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,     0,   326,
       0,     0,     0,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,   339,     0,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,     0,     0,   360,     0,   361,
     362,   363,   364,   365,     0,     0,   366,   367,     0,   368,
       0,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,   390,   391,   392,   393,
       0,   394,   395,     0,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,     0,   410,     0,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,     0,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,     0,   500,   501,
     502,   503,   504,     0,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,     0,
       0,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3952,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,     0,     0,
       0,     0,     0,  1030,  1454,   617,     0,     0,   859,   676,
       0,     0,     0,     0,  4399,   860,   861,   862,   224,   225,
     226,   227,   228,   229,   230,   231,  1944,   233,   234,   235,
    1945,  1946,  1947,  1948,  1949,  1950,  1951,   236,   237,  1952,
     238,   239,   240,   801,   241,   242,   243,     0,  1031,   802,
    1032,  1033,  1953,   248,   249,   250,   251,   252,  1954,  1955,
     253,   254,  1034,  1035,   257,  1956,   258,   259,   260,   261,
       0,  1957,   803,  1958,   263,   264,   265,   266,   267,   804,
     268,   269,   270,  1959,   271,   272,   273,   274,   275,   276,
    1960,   805,   277,   278,   279,  1961,  1962,  1963,   806,  1964,
    1965,  1966,   280,   281,   282,   283,   284,   285,  1036,  1037,
     288,  1967,   289,  1968,   290,   291,   292,   293,   294,   295,
    1969,   296,   297,   298,   299,  1970,  1971,   300,   301,  1038,
     303,   304,  1972,   305,   306,   307,  1973,   308,   309,   310,
    1974,   311,   312,   313,   314,     0,   316,   317,   318,     0,
    1975,   320,  1976,   321,   322,  1039,   324,  1977,   325,  1978,
     326,   807,  1979,   808,   327,   328,   329,   330,  1980,   331,
       0,  1981,     0,   334,  1982,   335,   336,   337,   338,   339,
     809,   340,   341,   342,   343,  1983,   344,   345,   346,   347,
     348,   349,  1984,   350,   810,     0,   352,   353,   354,   355,
    1041,  1042,  1985,  1043,  1986,   359,   811,   812,   360,   813,
     361,   362,   363,   364,   365,  1987,  1988,   366,     0,   814,
     368,   815,  1989,   369,   370,   371,  1990,  1991,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,  1044,   816,  1045,   390,   391,   392,
    3706,  1992,   394,   395,   817,   396,  1993,     0,   398,  1046,
     400,   401,   402,  1994,   403,   404,  1995,  1996,  3707,   406,
     407,  1997,  1998,   408,     0,   818,   410,   819,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,  1999,   421,
     422,     0,   424,     0,   426,   427,   428,  2000,   429,   430,
     431,   432,   433,   434,   435,   436,   437,  1047,   439,   440,
     441,   442,  2001,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,  2002,   455,   456,   820,   457,
     458,   459,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,  2003,   470,   471,   472,   473,   474,  2004,   475,
     476,  2090,   478,   479,   821,   480,   481,  1049,   483,  2005,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,  2006,   497,   498,  2007,   499,   822,   500,
     501,   502,   503,   504,  2008,  1050,  1051,  2009,  2010,   507,
     508,     0,   510,     0,  2011,   512,   513,   514,   515,   516,
     517,   518,  2012,  2013,   519,   520,   521,   522,   523,  2014,
    2015,   524,   525,   526,   527,   528,     0,  1052,  2016,   531,
     823,   532,   533,   534,   535,  2017,  2018,   536,  2019,  2020,
     537,   538,   539,   540,   541,   542,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   554,   555,   556,
       0,     0,     0,   865,   866,   867,     0,  3708,  3709,   870,
     871,   872,   873,  1030,  1454,   617,     0,     0,   859,   676,
       0,     0,     0,     0,     0,   860,   861,   862,   224,   225,
     226,   227,   228,   229,   230,   231,  1944,   233,   234,   235,
    1945,  1946,  1947,  1948,  1949,  1950,  1951,   236,   237,  1952,
     238,   239,   240,   801,   241,   242,   243,     0,  1031,   802,
    1032,  1033,  1953,   248,   249,   250,   251,   252,  1954,  1955,
     253,   254,  1034,  1035,   257,  1956,   258,   259,   260,   261,
       0,  1957,   803,  1958,   263,   264,   265,   266,   267,   804,
     268,   269,   270,  1959,   271,   272,   273,   274,   275,   276,
    1960,   805,   277,   278,   279,  1961,  1962,  1963,   806,  1964,
    1965,  1966,   280,   281,   282,   283,   284,   285,  1036,  1037,
     288,  1967,   289,  1968,   290,   291,   292,   293,   294,   295,
    1969,   296,   297,   298,   299,  1970,  1971,   300,   301,  1038,
     303,   304,  1972,   305,   306,   307,  1973,   308,   309,   310,
    1974,   311,   312,   313,   314,     0,   316,   317,   318,     0,
    1975,   320,  1976,   321,   322,  1039,   324,  1977,   325,  1978,
     326,   807,  1979,   808,   327,   328,   329,   330,  1980,   331,
       0,  1981,     0,   334,  1982,   335,   336,   337,   338,   339,
     809,   340,   341,   342,   343,  1983,   344,   345,   346,   347,
     348,   349,  1984,   350,   810,     0,   352,   353,   354,   355,
    1041,  1042,  1985,  1043,  1986,   359,   811,   812,   360,   813,
     361,   362,   363,   364,   365,  1987,  1988,   366,     0,   814,
     368,   815,  1989,   369,   370,   371,  1990,  1991,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,  1044,   816,  1045,   390,   391,   392,
    4136,  1992,   394,   395,   817,   396,  1993,     0,   398,  1046,
     400,   401,   402,  1994,   403,   404,  1995,  1996,  3707,   406,
     407,  1997,  1998,   408,     0,   818,   410,   819,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,  1999,   421,
     422,     0,   424,     0,   426,   427,   428,  2000,   429,   430,
     431,   432,   433,   434,   435,   436,   437,  1047,   439,   440,
     441,   442,  2001,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,  2002,   455,   456,   820,   457,
     458,   459,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,  2003,   470,   471,   472,   473,   474,  2004,   475,
     476,  2090,   478,   479,   821,   480,   481,  1049,   483,  2005,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,  2006,   497,   498,  2007,   499,   822,   500,
     501,   502,   503,   504,  2008,  1050,  1051,  2009,  2010,   507,
     508,     0,   510,     0,  2011,   512,   513,   514,   515,   516,
     517,   518,  2012,  2013,   519,   520,   521,   522,   523,  2014,
    2015,   524,   525,   526,   527,   528,     0,  1052,  2016,   531,
     823,   532,   533,   534,   535,  2017,  2018,   536,  2019,  2020,
     537,   538,   539,   540,   541,   542,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   554,   555,   556,
       0,   223,     0,   865,   866,   867,   859,  3708,  3709,   870,
     871,   872,   873,   860,   861,   862,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   863,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   864,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,     0,   223,
       0,   865,   866,   867,   859,   868,   869,   870,   871,   872,
     873,   860,   861,   862,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   981,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   982,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,     0,   223,     0,   865,
     866,   867,   859,   868,   869,   870,   871,   872,   873,   860,
     861,   862,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,  1080,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,     0,   277,   278,   279,     0,
       0,     0,     0,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,  1081,     0,   321,   322,   323,
     324,     0,   325,     0,   326,     0,     0,     0,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,  1082,     0,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
       0,     0,   360,     0,   361,   362,   363,   364,   365,     0,
       0,   366,   367,     0,   368,     0,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,     0,
     389,   390,   391,   392,   393,     0,   394,   395,     0,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,     0,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,     0,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,     0,   223,     0,   865,   866,   867,
     859,   868,   869,   870,   871,   872,   873,   860,   861,   862,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,  1576,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,     0,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,  1577,     0,   321,   322,   323,   324,     0,
     325,     0,   326,     0,     0,     0,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360,     0,   361,   362,   363,   364,   365,     0,     0,   366,
     367,     0,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,     0,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,     0,   223,     0,   865,   866,   867,   859,   868,
     869,   870,   871,   872,   873,   860,   861,   862,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
       0,   223,     0,   865,   866,   867,   859,   868,   869,   870,
     871,   872,   873,   860,   861,   862,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,  2891,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,  2892,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,     0,   223,
       0,   865,   866,   867,   859,   868,   869,   870,   871,   872,
     873,   860,   861,   862,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,  4693,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,  1943,     0,     0,   865,
     866,   867,     0,   868,   869,   870,   871,   872,   873,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,  1944,
     233,   234,   235,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
     236,   237,  1952,   238,   239,   240,   801,   241,   242,   243,
     244,   245,   802,   246,   247,  1953,   248,   249,   250,   251,
     252,  1954,  1955,   253,   254,   255,   256,   257,  1956,   258,
     259,   260,   261,   262,  1957,   803,  1958,   263,   264,   265,
     266,   267,   804,   268,   269,   270,  1959,   271,   272,   273,
     274,   275,   276,  1960,   805,   277,   278,   279,  1961,  1962,
    1963,   806,  1964,  1965,  1966,   280,   281,   282,   283,   284,
     285,   286,   287,   288,  1967,   289,  1968,   290,   291,   292,
     293,   294,   295,  1969,   296,   297,   298,   299,  1970,  1971,
     300,   301,   302,   303,   304,  1972,   305,   306,   307,  1973,
     308,   309,   310,  1974,   311,   312,   313,   314,   315,   316,
     317,   318,   319,  1975,   320,  1976,   321,   322,   323,   324,
    1977,   325,  1978,   326,   807,  1979,   808,   327,   328,   329,
     330,  1980,   331,   332,  1981,   333,   334,  1982,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,  1983,   344,
     345,   346,   347,   348,   349,  1984,   350,   810,   351,   352,
     353,   354,   355,   356,   357,  1985,   358,  1986,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,  1987,  1988,
     366,   367,   814,   368,   815,  1989,   369,   370,   371,  1990,
    1991,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   816,   389,
     390,   391,   392,   393,  1992,   394,   395,   817,   396,  1993,
     397,   398,   399,   400,   401,   402,  1994,   403,   404,  1995,
    1996,   405,   406,   407,  1997,  1998,   408,   409,   818,   410,
     819,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,  1999,   421,   422,   423,   424,   425,   426,   427,   428,
    2000,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,  2001,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,  2002,   455,
     456,   820,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,  2003,   470,   471,   472,   473,
     474,  2004,   475,   476,   477,   478,   479,   821,   480,   481,
     482,   483,  2005,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,  2006,   497,   498,  2007,
     499,   822,   500,   501,   502,   503,   504,  2008,   505,   506,
    2009,  2010,   507,   508,   509,   510,   511,  2011,   512,   513,
     514,   515,   516,   517,   518,  2012,  2013,   519,   520,   521,
     522,   523,  2014,  2015,   524,   525,   526,   527,   528,   529,
     530,  2016,   531,   823,   532,   533,   534,   535,  2017,  2018,
     536,  2019,  2020,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   223,     0,     0,     0,     0,     0,     0,
       0,     0,  2021,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     223,     0,     0,     0,     0,     0,     0,     0,     0,   770,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,     0,     0,   366,   367,     0,   368,     0,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,   390,   391,   392,   393,     0,   394,
     395,     0,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,     0,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,  1030,     0,     0,
       0,     0,     0,     0,     0,     0,  5085,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,   801,   241,   242,
     243,     0,  1031,   802,  1032,  1033,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,  1034,  1035,   257,     0,
     258,   259,   260,   261,     0,     0,   803,     0,   263,   264,
     265,   266,   267,   804,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,   805,   277,   278,   279,     0,
       0,     0,   806,     0,     0,     0,   280,   281,   282,   283,
     284,   285,  1036,  1037,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,  1038,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,     0,
     316,   317,   318,     0,     0,   320,     0,   321,   322,  1039,
     324,     0,   325,     0,   326,   807,     0,   808,   327,   328,
     329,   330,     0,   331,     0,     0,     0,   334,     0,   335,
     336,   337,   338,   339,   809,   340,   341,   342,   343,  2086,
     344,   345,   346,   347,   348,   349,     0,   350,   810,  2087,
     352,   353,   354,   355,  1041,  1042,     0,  1043,     0,   359,
     811,   812,   360,   813,   361,   362,   363,   364,   365,     0,
       0,   366,     0,   814,   368,   815,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,  1044,   816,
    1045,   390,   391,   392,     0,     0,   394,   395,   817,   396,
       0,     0,   398,  1046,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,  2088,   408,  2089,   818,
     410,   819,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,     0,   424,     0,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,  1047,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,   820,   457,   458,   459,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,  2090,   478,   479,   821,   480,
     481,  1049,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,     0,   497,   498,
       0,   499,   822,   500,   501,   502,   503,   504,     0,  1050,
    1051,     0,     0,   507,   508,     0,   510,     0,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
       0,  1052,  2091,   531,   823,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
    2382,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   554,   555,   556,     0,   224,   225,   226,   227,   228,
     229,   230,   231,  2092,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,     0,  1031,   802,  1032,  1033,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,  1034,
    1035,   257,     0,   258,   259,   260,   261,     0,     0,   803,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,     0,     0,     0,   806,     0,     0,     0,   280,
     281,   282,   283,   284,   285,  1036,  1037,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,  1038,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,     0,   316,   317,   318,     0,     0,   320,     0,
     321,   322,  1039,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,     0,     0,     0,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,  2086,   344,   345,   346,   347,   348,   349,     0,
     350,   810,  2087,   352,   353,   354,   355,  1041,  1042,     0,
    1043,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,     0,   814,   368,   815,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  1044,   816,  1045,   390,   391,   392,     0,     0,   394,
     395,   817,   396,     0,     0,   398,  1046,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,  2088,
     408,  2089,   818,   410,   819,     0,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,     0,   424,
       0,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1047,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,  2090,   478,
     479,   821,   480,   481,  1049,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,  1050,  1051,     0,     0,   507,   508,     0,   510,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,     0,  1052,  2091,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   845,  1454,   617,     0,     0,     0,   676,
       0,     0,     0,     0,   554,   555,   556,     0,   224,   225,
     226,   227,   228,   229,   230,   231,  2092,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,   801,   241,   242,   243,   244,   245,   802,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,   803,     0,   263,   264,   265,   266,   267,   804,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,   805,   277,   278,   279,     0,     0,     0,   806,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,  1932,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
    1756,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,   807,     0,   808,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
     809,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,   810,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,   811,   812,   360,   813,
     361,   362,   363,   364,   365,     0,     0,   366,   367,   814,
     368,   815,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   816,   389,   390,   391,   392,
     393,     0,   394,   395,   817,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,  1757,     0,   405,   406,
     407,     0,     0,   408,   409,   818,   410,   819,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,   820,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   821,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,   822,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,  1758,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
     823,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     845,  1454,   617,     0,     0,     0,   676,  1455,  1456,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,   245,   802,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,   803,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,     0,     0,     0,   806,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,  1937,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,  1756,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,   367,   814,   368,   815,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   816,   389,   390,   391,   392,   393,     0,   394,
     395,   817,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,  1757,     0,   405,   406,   407,     0,     0,
     408,   409,   818,   410,   819,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   821,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,  1758,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   845,  1454,   617,
       0,     0,     0,   676,  1455,  1456,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,   801,   241,   242,
     243,   244,   245,   802,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,   803,     0,   263,   264,
     265,   266,   267,   804,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,   805,   277,   278,   279,     0,
       0,     0,   806,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,  1756,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,   807,     0,   808,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,   339,   809,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,   810,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
     811,   812,   360,   813,   361,   362,   363,   364,   365,     0,
       0,   366,   367,   814,   368,   815,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   816,
     389,   390,   391,   392,   393,     0,   394,   395,   817,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
    1757,     0,   405,   406,   407,     0,     0,   408,   409,   818,
     410,   819,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,   820,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   821,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,   822,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,  1758,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,   823,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   845,     0,   617,     0,     0,     0,
     676,  1455,  1456,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,   244,   245,
     802,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,   803,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,   278,   279,     0,     0,     0,   806,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,  2845,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,  1756,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,   367,
     814,   368,   815,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   816,   389,   390,   391,
     392,   393,     0,   394,   395,   817,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,  1757,     0,   405,
     406,   407,     0,     0,   408,   409,   818,   410,   819,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   821,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,  1758,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   223,     0,     0,     0,     0,     0,   676,   688,   689,
       0,     0,     0,     0,     0,     0,   224,   677,   226,   227,
     228,   229,   230,   231,   678,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   679,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   680,   323,   324,     0,   325,     0,   681,     0,
     682,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,   342,   343,   683,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   684,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   685,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   686,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   687,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,  1943,  5281,
     617,     0,     0,     0,   676,   688,   689,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,  1944,   233,   234,   235,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,   236,   237,  1952,   238,   239,   240,   801,   241,
     242,   243,   244,   245,   802,   246,   247,  1953,   248,   249,
     250,   251,   252,  1954,  1955,   253,   254,   255,   256,   257,
    1956,   258,   259,   260,   261,   262,  1957,   803,  1958,   263,
     264,   265,   266,   267,   804,   268,   269,   270,  1959,   271,
     272,   273,   274,   275,   276,  1960,   805,   277,   278,   279,
    1961,  1962,  1963,   806,  1964,  1965,  1966,   280,   281,   282,
     283,   284,   285,   286,   287,   288,  1967,   289,  1968,   290,
     291,   292,   293,   294,   295,  1969,   296,   297,   298,   299,
    1970,  1971,   300,   301,   302,   303,   304,  1972,   305,   306,
     307,  1973,   308,   309,   310,  1974,   311,   312,   313,   314,
     315,   316,   317,   318,   319,  1975,   320,  1976,   321,   322,
     323,   324,  1977,   325,  1978,   326,   807,  1979,   808,   327,
     328,   329,   330,  1980,   331,   332,  1981,   333,   334,  1982,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
    1983,   344,   345,   346,   347,   348,   349,  1984,   350,   810,
     351,   352,   353,   354,   355,   356,   357,  1985,   358,  1986,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
    1987,  1988,   366,   367,   814,   368,   815,  1989,   369,   370,
     371,  1990,  1991,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     816,   389,   390,   391,   392,   393,  1992,   394,   395,   817,
     396,  1993,   397,   398,   399,   400,   401,   402,  1994,   403,
     404,  1995,  1996,   405,   406,   407,  1997,  1998,   408,   409,
     818,   410,   819,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,  1999,   421,   422,   423,   424,   425,   426,
     427,   428,  2000,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,  2001,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
    2002,   455,   456,   820,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,  2003,   470,   471,
     472,   473,   474,  2004,   475,   476,   477,   478,   479,   821,
     480,   481,   482,   483,  2005,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,  2006,   497,
     498,  2007,   499,   822,   500,   501,   502,   503,   504,  2008,
     505,   506,  2009,  2010,   507,   508,   509,   510,   511,  2011,
     512,   513,   514,   515,   516,   517,   518,  2012,  2013,   519,
     520,   521,   522,   523,  2014,  2015,   524,   525,   526,   527,
     528,   529,   530,  2016,   531,   823,   532,   533,   534,   535,
    2017,  2018,   536,  2019,  2020,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,  1943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,  1944,   233,
     234,   235,  1945,  1946,  1947,  1948,  1949,  1950,  1951,   236,
     237,  1952,   238,   239,   240,   801,   241,   242,   243,   244,
     245,   802,   246,   247,  1953,   248,   249,   250,   251,   252,
    1954,  1955,   253,   254,   255,   256,   257,  1956,   258,   259,
     260,   261,   262,  1957,   803,  1958,   263,   264,   265,   266,
     267,   804,   268,   269,   270,  1959,   271,   272,   273,   274,
     275,   276,  1960,   805,   277,   278,   279,  1961,  1962,  1963,
     806,  1964,  1965,  1966,   280,   281,   282,   283,   284,   285,
     286,   287,   288,  1967,   289,  1968,   290,   291,   292,   293,
     294,   295,  1969,   296,   297,   298,   299,  1970,  1971,   300,
     301,   302,   303,   304,  1972,   305,   306,   307,  1973,   308,
     309,   310,  1974,   311,   312,   313,   314,   315,   316,   317,
     318,   319,  1975,   320,  1976,   321,   322,   323,   324,  1977,
     325,  1978,   326,   807,  1979,   808,   327,   328,   329,   330,
    1980,   331,   332,  1981,   333,   334,  1982,   335,   336,   337,
     338,   339,   809,   340,   341,   342,   343,  1983,   344,   345,
     346,   347,   348,   349,  1984,   350,   810,   351,   352,   353,
     354,   355,   356,   357,  1985,   358,  1986,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,  1987,  1988,   366,
     367,   814,   368,   815,  1989,   369,   370,   371,  1990,  1991,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   816,   389,   390,
     391,   392,   393,  1992,   394,   395,   817,   396,  1993,   397,
     398,   399,   400,   401,   402,  1994,   403,   404,  1995,  1996,
     405,   406,   407,  1997,  1998,   408,   409,   818,   410,   819,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
    1999,   421,   422,   423,   424,   425,   426,   427,   428,  2000,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,  2001,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,  2002,   455,   456,
     820,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,  2003,   470,   471,   472,   473,   474,
    2004,   475,   476,   477,   478,   479,   821,   480,   481,   482,
     483,  2005,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,  2006,   497,   498,  2007,   499,
     822,   500,   501,   502,   503,   504,  2008,   505,   506,  2009,
    2010,   507,   508,   509,   510,   511,  2011,   512,   513,   514,
     515,   516,   517,   518,  2012,  2013,   519,   520,   521,   522,
     523,  2014,  2015,   524,   525,   526,   527,   528,   529,   530,
    2016,   531,   823,   532,   533,   534,   535,  2017,  2018,   536,
    2019,  2020,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,  1943,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,  2959,   229,   230,   231,  1944,   233,   234,   235,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,   236,   237,  1952,   238,
     239,   240,   801,   241,   242,   243,   244,   245,   802,   246,
     247,  1953,   248,   249,   250,   251,   252,  1954,  1955,   253,
     254,   255,   256,   257,  1956,   258,   259,   260,   261,   262,
    1957,   803,  1958,   263,   264,   265,   266,   267,   804,   268,
     269,   270,  1959,   271,   272,   273,   274,   275,   276,  1960,
     805,   277,   278,   279,  1961,  1962,  1963,   806,  1964,  1965,
    1966,   280,   281,   282,   283,   284,   285,   286,   287,   288,
    1967,   289,  1968,   290,   291,   292,   293,   294,   295,  1969,
     296,   297,   298,   299,  1970,  1971,   300,   301,   302,  2960,
     304,  1972,   305,   306,   307,  1973,   308,   309,   310,  1974,
     311,   312,   313,   314,   315,   316,   317,   318,   319,  1975,
     320,  1976,   321,   322,   323,   324,  1977,   325,  1978,   326,
     807,  1979,   808,   327,   328,   329,   330,  1980,   331,   332,
    1981,   333,   334,  1982,   335,   336,   337,   338,   339,   809,
     340,   341,   342,   343,  1983,   344,   345,   346,   347,   348,
     349,  1984,   350,   810,   351,   352,   353,   354,   355,   356,
     357,  1985,   358,  1986,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,  1987,  1988,   366,   367,   814,   368,
     815,  1989,   369,   370,   371,  1990,  1991,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   816,   389,   390,   391,   392,   393,
    1992,   394,   395,   817,   396,  1993,   397,   398,   399,   400,
     401,   402,  1994,   403,   404,  1995,  1996,   405,   406,   407,
    1997,  1998,   408,   409,   818,   410,   819,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,  1999,   421,   422,
     423,   424,   425,   426,   427,   428,  2000,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  2001,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,  2002,   455,   456,   820,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,  2003,   470,   471,   472,   473,   474,  2004,  2961,   476,
     477,   478,   479,   821,   480,   481,   482,   483,  2005,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,  2006,   497,   498,  2007,   499,   822,   500,   501,
     502,   503,   504,  2008,   505,   506,  2009,  2010,   507,   508,
     509,   510,   511,  2011,   512,   513,   514,   515,   516,   517,
     518,  2012,  2013,   519,   520,   521,   522,   523,  2014,  2015,
     524,   525,   526,   527,   528,   529,   530,  2016,   531,   823,
     532,   533,   534,   535,  2017,  2018,   536,  2019,  2020,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   800,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,   801,
     241,   242,   243,   244,   245,   802,   246,   247,     0,   248,
     249,   250,   251,   252,     0,  1186,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,  1189,     0,  1190,     0,
     263,   264,   265,   266,   267,   804,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,   805,   277,   278,
     279,  1191,  1192,  1193,  1194,  1195,  1196,  1197,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,  1202,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,   807,     0,   808,
     327,   328,   329,   330,     0,   331,  1205,     0,   333,   334,
       0,   335,   336,   337,   338,   339,   809,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
     810,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,   811,   812,   360,   813,   361,   362,   363,   364,
     365,     0,     0,   366,  1210,   814,   368,   815,     0,   369,
     370,   371,  1211,  1212,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   816,   389,   390,   391,   392,   393,     0,   394,   395,
     817,   396,     0,  1217,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,   818,   410,   819,  1220,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,  1221,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,   820,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,  1224,   475,   476,   477,   478,   479,
     821,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,  1226,     0,
     497,   498,     0,   499,   822,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,  1229,   510,  1230,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,  1233,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,   823,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,  1235,  1236,  1237,  1238,   548,  1239,  1240,
    1241,  1242,   553,   554,   555,   556,   845,     0,   617,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
     244,   245,   802,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,   803,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,     0,     0,
       0,   806,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,  1756,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,   807,     0,   808,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,     0,     0,
     366,   367,   814,   368,   815,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   816,   389,
     390,   391,   392,   393,     0,   394,   395,   817,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,  1757,
       0,   405,   406,   407,     0,     0,   408,   409,   818,   410,
     819,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   821,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,  1758,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   845,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,   882,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,   801,   241,   242,   243,   244,   245,   802,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,   803,     0,   263,   264,   265,   266,   267,   804,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,   805,   277,   278,   279,     0,     0,     0,   806,     0,
       0,   846,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,   807,     0,   808,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
     809,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,   810,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,   811,   812,   360,   813,
     361,   362,   363,   364,   365,     0,     0,   366,   367,   814,
     368,   815,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   816,   389,   390,   391,   392,
     393,     0,   394,   395,   817,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,   818,   410,   819,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,   820,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,   847,   475,
     476,   477,   478,   479,   821,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,   822,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
     823,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     845,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   901,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,   245,   802,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,   803,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,     0,     0,     0,   806,     0,     0,   846,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,   367,   814,   368,   815,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   902,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   816,   389,   390,   391,   392,   393,     0,   394,
     395,   817,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   818,   410,   819,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,   847,   475,   476,   477,   478,
     479,   821,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   845,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,   801,   241,   242,
     243,   244,   245,   802,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,   803,     0,   263,   264,
     265,   266,   267,   804,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,   805,   277,   278,   279,     0,
       0,     0,   806,     0,     0,   846,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,   807,     0,   808,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,   339,   809,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,   810,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
     811,   812,   360,   813,   361,   362,   363,   364,   365,     0,
       0,   366,   367,   814,   368,   815,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   816,
     389,   390,   391,   392,   393,     0,   394,   395,   817,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,   818,
     410,   819,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,   820,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,   847,   475,   476,   477,   478,   479,   821,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,   822,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,  2338,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,   823,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   845,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,   244,   245,
     802,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,   803,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,   278,   279,     0,     0,     0,   806,
       0,     0,   846,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,   332,  3285,   333,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,   367,
     814,   368,   815,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   816,   389,   390,   391,
     392,   393,     0,   394,   395,   817,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   818,   410,   819,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,   847,
     475,   476,   477,   478,   479,   821,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   845,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,   801,   241,   242,   243,   244,   245,   802,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
     803,     0,   263,   264,   265,   266,   267,   804,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,   805,
     277,   278,   279,     0,     0,     0,   806,     0,     0,   846,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,   807,
       0,   808,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   339,   809,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,   810,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,   811,   812,   360,   813,   361,   362,
     363,   364,   365,     0,     0,   366,   367,   814,   368,   815,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   816,   389,   390,   391,   392,   393,     0,
     394,   395,   817,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,   818,   410,   819,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,   820,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,   847,   475,   476,   477,
     478,   479,   821,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,   822,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,   823,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   845,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,   244,   245,   802,   246,   247,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,   262,     0,   803,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,   279,
       0,     0,     0,   806,     0,     0,   846,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,   319,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,   332,     0,   333,   334,     0,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,   810,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,   367,   814,   368,   815,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,  1000,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     816,   389,   390,   391,   392,   393,     0,   394,   395,   817,
     396,     0,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     818,   410,   819,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,   847,   475,   476,   477,   478,   479,   821,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,     0,   497,
     498,     0,   499,   822,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   845,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,   801,   241,   242,   243,   244,
     245,   802,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,   803,     0,   263,   264,   265,   266,
     267,   804,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,   805,   277,   278,   279,     0,     0,     0,
     806,     0,     0,   846,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,   807,     0,   808,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,  1075,   809,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,   810,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,     0,     0,   366,
     367,   814,   368,   815,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   816,   389,   390,
     391,   392,   393,     0,   394,   395,   817,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   818,   410,   819,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
     820,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
     847,   475,   476,   477,   478,   479,   821,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
     822,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,   823,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   845,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,   801,   241,   242,   243,   244,   245,   802,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,   255,   256,   257,     0,   258,   259,   260,   261,   262,
       0,   803,     0,   263,   264,   265,   266,   267,   804,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
     805,   277,   278,   279,     0,     0,     0,   806,     0,     0,
     846,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,     0,   326,
     807,     0,   808,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,  1086,   809,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,   810,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,     0,     0,   366,   367,   814,   368,
     815,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   816,   389,   390,   391,   392,   393,
       0,   394,   395,   817,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   818,   410,   819,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,   820,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,   847,   475,   476,
     477,   478,   479,   821,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,   822,   500,   501,
     502,   503,   504,     0,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,   823,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   845,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,   801,
     241,   242,   243,   244,   245,   802,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,   803,     0,
     263,   264,   265,   266,   267,   804,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,   805,   277,   278,
     279,     0,     0,     0,   806,     0,     0,   846,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,   807,     0,   808,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,  1096,   809,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
     810,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,   811,   812,   360,   813,   361,   362,   363,   364,
     365,     0,     0,   366,   367,   814,   368,   815,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,  1097,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   816,   389,   390,   391,   392,   393,     0,   394,   395,
     817,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,   818,   410,   819,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,   820,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,   847,   475,   476,   477,   478,   479,
     821,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,   822,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,   823,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   845,     0,   617,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
     244,   245,   802,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,   803,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,     0,     0,
       0,   806,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,  1917,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,     0,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,   807,     0,   808,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,     0,     0,
     366,   367,   814,   368,   815,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   816,   389,
     390,   391,   392,   393,     0,   394,   395,   817,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   818,   410,
     819,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   821,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   845,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       3,     4,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,   801,   241,   242,   243,   244,   245,   802,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,   803,     0,   263,   264,   265,   266,   267,   804,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,   805,   277,   278,   279,     0,     0,     0,   806,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,   807,     0,   808,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
     809,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,   810,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,   811,   812,   360,   813,
     361,   362,   363,   364,   365,     0,     0,   366,   367,   814,
     368,   815,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   816,   389,   390,   391,   392,
     393,     0,   394,   395,   817,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,   818,   410,   819,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,   820,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   821,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,   822,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
     823,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     845,     0,   617,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,   244,   245,   802,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,   803,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,     0,     0,     0,   806,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   339,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,   367,   814,   368,   815,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   816,   389,   390,   391,   392,   393,     0,   394,
     395,   817,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   818,   410,   819,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   821,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   845,     0,   617,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,   801,   241,   242,
     243,   244,   245,   802,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,   803,     0,   263,   264,
     265,   266,   267,   804,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,   805,   277,   278,   279,     0,
       0,     0,   806,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,   807,     0,   808,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,  1742,   809,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,   810,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
     811,   812,   360,   813,   361,   362,   363,   364,   365,     0,
       0,   366,   367,   814,   368,   815,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   816,
     389,   390,   391,   392,   393,     0,   394,   395,   817,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,   818,
     410,   819,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,   820,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   821,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,   822,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,   823,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   800,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,   244,   245,
     802,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,   803,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,   278,   279,     0,     0,     0,   806,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,   367,
     814,   368,   815,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   816,   389,   390,   391,
     392,   393,     0,   394,   395,   817,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   818,   410,   819,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   821,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   800,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,   801,   241,   242,   243,   244,   245,   802,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
     803,     0,   263,   264,   265,   266,   267,   804,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,   805,
     277,   278,   279,     0,     0,     0,   806,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,   807,
       0,   808,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,  1022,   809,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,   810,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,   811,   812,   360,   813,   361,   362,
     363,   364,   365,     0,     0,   366,   367,   814,   368,   815,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   816,   389,   390,   391,   392,   393,     0,
     394,   395,   817,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,   818,   410,   819,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,   820,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   821,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,   822,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,   823,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   800,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,   244,   245,   802,   246,   247,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,   262,     0,   803,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,   279,
       0,     0,     0,   806,     0,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,   319,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,   332,     0,   333,   334,     0,
     335,   336,   337,   338,  1072,   809,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,   810,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,   367,   814,   368,   815,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     816,   389,   390,   391,   392,   393,     0,   394,   395,   817,
     396,     0,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     818,   410,   819,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   821,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,     0,   497,
     498,     0,   499,   822,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,  2126,   258,   259,
     260,   261,   262,     0,     0,  2203,   263,   264,   265,   266,
     267,     0,   268,   269,   270,  2127,   271,   272,   273,   274,
     275,   276,     0,     0,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,  2204,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,  2129,   326,     0,     0,     0,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,  2205,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360,     0,   361,   362,   363,   364,   365,     0,     0,   366,
     367,     0,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,     0,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,  2130,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,  2131,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,   255,   256,   257,  2126,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,  2127,   271,   272,   273,   274,   275,   276,     0,
       0,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
    2204,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,  2129,   326,
       0,     0,     0,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,   339,     0,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,     0,     0,   360,     0,   361,
     362,   363,   364,   365,     0,     0,   366,   367,     0,   368,
    3149,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,   390,   391,   392,   393,
       0,   394,   395,     0,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,     0,   410,     0,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,  2130,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,     0,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,     0,   500,   501,
     502,   503,   504,     0,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,  2131,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   733,
     230,   231,   695,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,   696,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,   734,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   697,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   698,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   695,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,   696,     0,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,     0,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,     0,     0,     0,   327,   328,   329,
     330,  2852,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,   339,     0,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,     0,
       0,   360,     0,   361,   362,   363,   364,   365,     0,     0,
     366,   367,     0,   368,     0,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
     390,   391,   392,   393,     0,   394,   395,     0,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,   409,     0,   410,
       0,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   697,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   698,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,     0,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,     0,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,  2126,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,  2127,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,  2204,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,  2129,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,  2130,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,  2131,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   695,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,   696,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,     0,     0,   366,   367,     0,   368,     0,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,   390,   391,   392,   393,     0,   394,
     395,     0,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   697,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   698,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,     0,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
    1783,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,     0,   277,   278,   279,     0,
       0,     0,     0,     0,     0,     0,   280,   281,   282,  1784,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,  1785,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,  1786,   326,     0,     0,     0,  1787,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
       0,     0,   360,     0,   361,   362,  1788,  1789,   365,     0,
       0,   366,   367,     0,   368,     0,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,     0,
     389,   390,   391,   392,   393,     0,   394,   395,     0,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
    1790,   465,   466,   467,   468,   469,     0,  1791,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,     0,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
    1792,   499,     0,  1793,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,  1794,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,   696,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   697,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   698,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,     0,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,   894,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   895,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,   765,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   223,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     3,     4,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,   246,   247,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,     0,   277,   278,   279,
       0,     0,     0,     0,     0,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,   319,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,     0,     0,     0,   327,
     328,   329,   330,     0,   331,   332,     0,   333,   334,     0,
     335,   336,   337,   338,   339,     0,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,     0,     0,   360,     0,   361,   362,   363,   364,   365,
       0,     0,   366,   367,     0,   368,     0,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,   390,   391,   392,   393,     0,   394,   395,     0,
     396,     0,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,     0,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,     0,   497,
     498,     0,   499,     0,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,  2940,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,     0,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,     0,     0,     0,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360,     0,   361,   362,   363,   364,   365,     0,     0,   366,
     367,     0,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,     0,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,  2941,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,  2953,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,   255,   256,   257,     0,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
       0,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,     0,   326,
       0,     0,     0,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,   339,     0,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,     0,     0,   360,     0,   361,
     362,   363,   364,   365,     0,     0,   366,   367,     0,   368,
       0,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,   390,   391,   392,   393,
       0,   394,   395,     0,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,     0,   410,     0,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,     0,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,     0,   500,   501,
     502,   503,   504,     0,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,  2954,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   608,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,     0,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,     0,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,     0,     0,     0,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,   339,     0,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,     0,
       0,   360,     0,   361,   362,   363,   364,   365,     0,     0,
     366,   367,     0,   368,     0,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
     390,   391,   392,   393,     0,   394,   395,     0,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,   409,     0,   410,
       0,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   609,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,     0,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,     0,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,   725,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   726,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   727,   506,     0,     0,   728,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   759,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,     0,     0,   366,   367,     0,   368,     0,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,   390,   391,   392,   393,     0,   394,
     395,     0,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   760,     0,   475,   476,   477,   478,
     479,     0,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,   761,   506,     0,     0,   762,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,     0,   277,   278,   279,     0,
       0,     0,     0,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,     0,     0,     0,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
       0,     0,   360,     0,   361,   362,   363,   364,   365,     0,
       0,   366,   367,     0,   368,     0,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,     0,
     389,   390,   391,   392,   393,     0,   394,   395,     0,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,   765,   405,   406,   407,     0,     0,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,     0,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,     0,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,   854,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     855,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,     0,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,  1014,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   223,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,  1280,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,   246,   247,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,     0,   277,   278,   279,
       0,     0,     0,     0,     0,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,   319,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,     0,     0,     0,   327,
     328,   329,   330,     0,   331,   332,     0,   333,   334,     0,
     335,   336,   337,   338,   339,     0,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,     0,     0,   360,     0,   361,   362,   363,   364,   365,
       0,     0,   366,   367,     0,   368,     0,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,   390,   391,   392,   393,     0,   394,   395,     0,
     396,     0,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,     0,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,     0,   497,
     498,     0,   499,     0,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,  1291,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   745,   254,   255,   256,  1292,     0,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,     0,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,     0,     0,     0,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360,     0,   361,   362,   363,   364,   365,     0,     0,   366,
     367,     0,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   748,   388,     0,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   749,   458,   459,   460,   461,   462,   463,   750,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,  1284,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   752,   506,     0,
       0,   753,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   754,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,   255,   256,   257,     0,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
       0,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,     0,   326,
       0,     0,     0,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,  1402,     0,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,     0,     0,   360,     0,   361,
     362,   363,   364,   365,     0,     0,   366,   367,     0,   368,
       0,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,   390,   391,   392,   393,
       0,   394,   395,     0,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,   765,   405,   406,   407,
       0,     0,   408,   409,     0,   410,     0,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,     0,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,     0,   500,   501,
     502,   503,   504,     0,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,  1459,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,  1460,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   725,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,     0,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,     0,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,     0,     0,     0,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,   339,     0,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,     0,
       0,   360,     0,   361,   362,   363,   364,   365,     0,     0,
     366,   367,     0,   368,     0,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
     390,   391,   392,   393,     0,   394,   395,     0,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,   409,     0,   410,
       0,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,     0,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,     0,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,  2735,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,  2736,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,  2737,   499,     0,   500,
    2738,   502,  2739,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,  2740,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     223,     0,   617,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,     0,     0,   366,   367,     0,   368,     0,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,   390,   391,   392,   393,     0,   394,
     395,     0,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,     0,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,  3973,
       0,   236,   237,     0,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,     0,   277,   278,   279,     0,
       0,     0,     0,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,     0,     0,     0,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
       0,     0,   360,     0,   361,   362,   363,   364,   365,     0,
       0,   366,   367,     0,   368,     0,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,     0,
     389,   390,   391,   392,   393,     0,   394,   395,     0,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,     0,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,     0,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,  3987,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,     0,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   223,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,   246,   247,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,     0,   277,   278,   279,
       0,     0,     0,     0,     0,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,   319,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,     0,     0,     0,   327,
     328,   329,   330,     0,   331,   332,     0,   333,   334,     0,
     335,   336,   337,   338,   339,     0,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,     0,     0,   360,     0,   361,   362,   363,   364,   365,
       0,     0,   366,   367,     0,   368,     0,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,   390,   391,   392,   393,     0,   394,   395,     0,
     396,     0,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,     0,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,     0,   497,
     498,     0,   499,     0,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   711,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,     0,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,     0,     0,     0,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360,     0,   361,   362,   363,   364,   365,     0,     0,   366,
     367,     0,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,     0,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   723,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   745,
     254,   255,   256,   257,     0,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   746,   272,   273,   274,   275,   276,     0,
       0,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,     0,   326,
       0,     0,     0,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,   339,     0,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,     0,     0,   360,     0,   361,
     362,   363,   364,   365,     0,     0,   366,   367,     0,   368,
       0,     0,   369,   370,   747,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   748,   388,     0,   389,   390,   391,   392,   393,
       0,   394,   395,     0,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,     0,   410,     0,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   749,   458,
     459,   460,   461,   462,   463,   750,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   751,     0,   475,   476,
     477,   478,   479,     0,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,     0,   500,   501,
     502,   503,   504,     0,   752,   506,     0,     0,   753,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   754,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   776,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,     0,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,     0,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,     0,     0,     0,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,   879,     0,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,     0,
       0,   360,     0,   361,   362,   363,   364,   365,     0,     0,
     366,   367,     0,   368,     0,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
     390,   391,   392,   393,     0,   394,   395,     0,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,   409,     0,   410,
       0,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,     0,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,     0,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   887,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   905,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,     0,     0,   366,   367,     0,   368,     0,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,   390,   391,   392,   393,     0,   394,
     395,     0,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,     0,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,     0,   277,   278,   279,     0,
       0,     0,     0,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,     0,     0,     0,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,   965,     0,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
       0,     0,   360,     0,   361,   362,   363,   364,   365,     0,
       0,   366,   367,     0,   368,     0,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,     0,
     389,   390,   391,   392,   393,     0,   394,   395,     0,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,     0,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,     0,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     971,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,     0,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   988,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   223,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,   246,   247,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,     0,   277,   278,   279,
       0,     0,     0,     0,     0,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,   319,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,     0,     0,     0,   327,
     328,   329,   330,     0,   331,   332,     0,   333,   334,     0,
     335,   336,   337,   338,   991,     0,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,     0,     0,   360,     0,   361,   362,   363,   364,   365,
       0,     0,   366,   367,     0,   368,     0,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,   390,   391,   392,   393,     0,   394,   395,     0,
     396,     0,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,     0,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,     0,   497,
     498,     0,   499,     0,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,     0,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,     0,     0,     0,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,   993,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360,     0,   361,   362,   363,   364,   365,     0,     0,   366,
     367,     0,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,     0,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,   255,   256,   257,     0,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
       0,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,     0,   326,
       0,     0,     0,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,  1028,     0,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,     0,     0,   360,     0,   361,
     362,   363,   364,   365,     0,     0,   366,   367,     0,   368,
       0,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,   390,   391,   392,   393,
       0,   394,   395,     0,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,     0,   410,     0,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,     0,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,     0,   500,   501,
     502,   503,   504,     0,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,  1088,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,     0,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,     0,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,     0,     0,     0,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,  1090,     0,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,     0,
       0,   360,     0,   361,   362,   363,   364,   365,     0,     0,
     366,   367,     0,   368,     0,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
     390,   391,   392,   393,     0,   394,   395,     0,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,   409,     0,   410,
       0,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,     0,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,     0,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,  1100,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,  1103,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,     0,     0,   366,   367,     0,   368,     0,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,   390,   391,   392,   393,     0,   394,
     395,     0,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,     0,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,     0,   277,   278,   279,     0,
       0,     0,     0,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,     0,     0,     0,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,  1106,     0,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
       0,     0,   360,     0,   361,   362,   363,   364,   365,     0,
       0,   366,   367,     0,   368,     0,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,     0,
     389,   390,   391,   392,   393,     0,   394,   395,     0,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,     0,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,     0,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   745,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   748,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     749,   458,   459,   460,   461,   462,   463,   750,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,  1284,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,     0,
     500,   501,   502,   503,   504,     0,   752,   506,     0,     0,
     753,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   754,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,  1608,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   223,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,   246,   247,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,     0,   277,   278,   279,
       0,     0,     0,     0,     0,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,   319,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,     0,     0,     0,   327,
     328,   329,   330,     0,   331,   332,     0,   333,   334,     0,
     335,   336,   337,   338,  1646,     0,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,     0,     0,   360,     0,   361,   362,   363,   364,   365,
       0,     0,   366,   367,     0,   368,     0,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,   390,   391,   392,   393,     0,   394,   395,     0,
     396,     0,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,     0,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,     0,   497,
     498,     0,   499,     0,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,     0,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,     0,     0,     0,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,  1648,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360,     0,   361,   362,   363,   364,   365,     0,     0,   366,
     367,     0,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,     0,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,   255,   256,   257,     0,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
       0,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,     0,   326,
       0,     0,     0,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,  1718,     0,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,     0,     0,   360,     0,   361,
     362,   363,   364,   365,     0,     0,   366,   367,     0,   368,
       0,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,   390,   391,   392,   393,
       0,   394,   395,     0,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,     0,   410,     0,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,     0,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,     0,   500,   501,
     502,   503,   504,     0,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,  1720,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   505,   506,     0,     0,   507,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,     0,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,     0,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,     0,     0,     0,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,  1722,     0,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,     0,
       0,   360,     0,   361,   362,   363,   364,   365,     0,     0,
     366,   367,     0,   368,     0,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
     390,   391,   392,   393,     0,   394,   395,     0,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,   409,     0,   410,
       0,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,     0,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,     0,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,  1817,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,  2079,     0,   236,   237,     0,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,     0,     0,   366,   367,     0,   368,     0,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,   390,   391,   392,   393,     0,   394,
     395,     0,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,     0,   476,   477,   478,
     479,     0,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   745,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,     0,   277,   278,   279,     0,
       0,     0,     0,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,     0,     0,     0,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
       0,     0,   360,     0,   361,   362,   363,   364,   365,     0,
       0,   366,   367,     0,   368,     0,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   748,   388,     0,
     389,   390,   391,   392,   393,     0,   394,   395,     0,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   749,   458,   459,   460,   461,   462,   463,
     750,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,  1284,     0,   475,   476,   477,   478,   479,     0,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,     0,  2113,   501,   502,   503,   504,     0,   752,
     506,     0,     0,   753,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   754,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   745,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   748,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     749,   458,   459,   460,   461,   462,   463,  2188,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,  2189,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,     0,
     500,   501,   502,   503,   504,     0,   752,   506,     0,     0,
    2190,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   754,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,  2462,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   223,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,   246,   247,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,   255,   256,   257,
       0,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,     0,   277,   278,   279,
       0,     0,     0,     0,     0,     0,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,   302,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
     315,   316,   317,   318,   319,     0,   320,     0,   321,   322,
     323,   324,     0,   325,     0,   326,     0,     0,     0,   327,
     328,   329,   330,     0,   331,   332,     0,   333,   334,     0,
     335,   336,   337,   338,  2466,     0,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,   354,   355,   356,   357,     0,   358,     0,
     359,     0,     0,   360,     0,   361,   362,   363,   364,   365,
       0,     0,   366,   367,     0,   368,     0,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,   390,   391,   392,   393,     0,   394,   395,     0,
     396,     0,   397,   398,   399,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,   409,
       0,   410,     0,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,     0,
     480,   481,   482,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,     0,   497,
     498,     0,   499,     0,   500,   501,   502,   503,   504,     0,
     505,   506,     0,     0,   507,   508,   509,   510,   511,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   223,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   246,   247,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,   255,   256,   257,     0,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,     0,   277,   278,   279,     0,     0,     0,
       0,     0,     0,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,   315,   316,   317,
     318,   319,     0,   320,     0,   321,   322,   323,   324,     0,
     325,     0,   326,     0,     0,     0,   327,   328,   329,   330,
       0,   331,   332,     0,   333,   334,     0,   335,   336,   337,
     338,  2535,     0,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
     354,   355,   356,   357,     0,   358,     0,   359,     0,     0,
     360,     0,   361,   362,   363,   364,   365,     0,     0,   366,
     367,     0,   368,     0,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,     0,   389,   390,
     391,   392,   393,     0,   394,   395,     0,   396,     0,   397,
     398,   399,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,   409,     0,   410,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,     0,   480,   481,   482,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,     0,   497,   498,     0,   499,
       0,   500,   501,   502,   503,   504,     0,   505,   506,     0,
       0,   507,   508,   509,   510,   511,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   246,
     247,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,   255,   256,   257,     0,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
       0,   277,   278,   279,     0,     0,     0,     0,     0,     0,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,   302,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,   315,   316,   317,   318,   319,     0,
     320,     0,   321,   322,   323,   324,     0,   325,     0,   326,
       0,     0,     0,   327,   328,   329,   330,     0,   331,   332,
       0,   333,   334,     0,   335,   336,   337,   338,  2863,     0,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,   353,   354,   355,   356,
     357,     0,   358,     0,   359,     0,     0,   360,     0,   361,
     362,   363,   364,   365,     0,     0,   366,   367,     0,   368,
       0,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,   390,   391,   392,   393,
       0,   394,   395,     0,   396,     0,   397,   398,   399,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,   409,     0,   410,     0,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,     0,   480,   481,   482,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,     0,   497,   498,     0,   499,     0,   500,   501,
     502,   503,   504,     0,   505,   506,     0,     0,   507,   508,
     509,   510,   511,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   223,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   246,   247,     0,   248,
     249,   250,   251,   252,     0,     0,   745,   254,   255,   256,
     257,     0,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,     0,   277,   278,
     279,     0,     0,     0,     0,     0,     0,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,   302,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,   315,   316,   317,   318,   319,     0,   320,     0,   321,
     322,   323,   324,     0,   325,     0,   326,     0,     0,     0,
     327,   328,   329,   330,     0,   331,   332,     0,   333,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,   354,   355,   356,   357,     0,   358,
       0,   359,     0,     0,   360,     0,   361,   362,   363,   364,
     365,     0,     0,   366,   367,     0,   368,     0,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   748,
     388,     0,   389,   390,   391,   392,   393,     0,   394,   395,
       0,   396,     0,   397,   398,   399,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
     409,     0,   410,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   749,   458,   459,   460,   461,
     462,   463,   750,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,  2189,     0,   475,   476,   477,   478,   479,
       0,   480,   481,   482,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     497,   498,     0,   499,     0,   500,   501,   502,   503,   504,
       0,   752,   506,     0,     0,  2190,   508,   509,   510,   511,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   754,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   246,   247,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,   255,   256,   257,     0,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,     0,   277,   278,   279,     0,     0,
       0,     0,     0,     0,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,   302,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,   315,   316,
     317,   318,   319,     0,   320,     0,   321,   322,   323,   324,
       0,   325,     0,   326,     0,     0,     0,   327,   328,   329,
     330,     0,   331,   332,     0,   333,   334,     0,   335,   336,
     337,   338,  2930,     0,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
     353,   354,   355,   356,   357,     0,   358,     0,   359,     0,
       0,   360,     0,   361,   362,   363,   364,   365,     0,     0,
     366,   367,     0,   368,     0,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
     390,   391,   392,   393,     0,   394,   395,     0,   396,     0,
     397,   398,   399,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,   409,     0,   410,
       0,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,     0,   480,   481,
     482,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,     0,   497,   498,     0,
     499,     0,   500,   501,   502,   503,   504,     0,   505,   506,
       0,     0,   507,   508,   509,   510,   511,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     246,   247,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,   255,   256,   257,     0,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,     0,   277,   278,   279,     0,     0,     0,     0,     0,
       0,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,   302,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,   315,   316,   317,   318,   319,
       0,   320,     0,   321,   322,   323,   324,     0,   325,     0,
     326,     0,     0,     0,   327,   328,   329,   330,     0,   331,
     332,     0,   333,   334,     0,   335,   336,   337,   338,  2943,
       0,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,   354,   355,
     356,   357,     0,   358,     0,   359,     0,     0,   360,     0,
     361,   362,   363,   364,   365,     0,     0,   366,   367,     0,
     368,     0,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,   389,   390,   391,   392,
     393,     0,   394,   395,     0,   396,     0,   397,   398,   399,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,   409,     0,   410,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,     0,   480,   481,   482,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,     0,   497,   498,     0,   499,     0,   500,
     501,   502,   503,   504,     0,   505,   506,     0,     0,   507,
     508,   509,   510,   511,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,   246,   247,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,   255,
     256,   257,     0,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,     0,   277,
     278,   279,     0,     0,     0,     0,     0,     0,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,   302,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,   315,   316,   317,   318,   319,     0,   320,     0,
     321,   322,   323,   324,     0,   325,     0,   326,     0,     0,
       0,   327,   328,   329,   330,     0,   331,   332,     0,   333,
     334,     0,   335,   336,   337,   338,  2945,     0,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,   353,   354,   355,   356,   357,     0,
     358,     0,   359,     0,     0,   360,     0,   361,   362,   363,
     364,   365,     0,     0,   366,   367,     0,   368,     0,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,   390,   391,   392,   393,     0,   394,
     395,     0,   396,     0,   397,   398,   399,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,   409,     0,   410,     0,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,     0,   480,   481,   482,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
       0,   497,   498,     0,   499,     0,   500,   501,   502,   503,
     504,     0,   505,   506,     0,     0,   507,   508,   509,   510,
     511,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   246,   247,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,   255,   256,   257,     0,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,     0,   277,   278,   279,     0,
       0,     0,     0,     0,     0,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,   302,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,   315,
     316,   317,   318,   319,     0,   320,     0,   321,   322,   323,
     324,     0,   325,     0,   326,     0,     0,     0,   327,   328,
     329,   330,     0,   331,   332,     0,   333,   334,     0,   335,
     336,   337,   338,  3080,     0,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,   354,   355,   356,   357,     0,   358,     0,   359,
       0,     0,   360,     0,   361,   362,   363,   364,   365,     0,
       0,   366,   367,     0,   368,     0,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,     0,
     389,   390,   391,   392,   393,     0,   394,   395,     0,   396,
       0,   397,   398,   399,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,   409,     0,
     410,     0,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,     0,   480,
     481,   482,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,     0,   497,   498,
       0,   499,     0,   500,   501,   502,   503,   504,     0,   505,
     506,     0,     0,   507,   508,   509,   510,   511,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   246,   247,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,   255,   256,   257,     0,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,     0,   277,   278,   279,     0,     0,     0,     0,
       0,     0,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,  3105,
     302,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,   315,   316,   317,   318,
     319,     0,   320,     0,   321,   322,   323,   324,     0,   325,
       0,   326,     0,     0,     0,   327,   328,   329,   330,     0,
     331,   332,     0,   333,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,   353,   354,
     355,   356,   357,     0,   358,     0,   359,     0,     0,   360,
       0,   361,   362,   363,   364,   365,     0,     0,   366,   367,
       0,   368,     0,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,   390,   391,
     392,   393,     0,   394,   395,     0,   396,     0,   397,   398,
     399,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,   409,     0,   410,     0,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,     0,   480,   481,   482,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,     0,   497,   498,     0,   499,     0,
     500,   501,   502,   503,   504,     0,   505,   506,     0,     0,
     507,   508,   509,   510,   511,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,  4251,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,  1030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,     0,  1031,   802,  1032,  1033,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,  1034,  1035,   257,
       0,   258,   259,   260,   261,     0,     0,   803,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,   279,
       0,     0,     0,   806,     0,     0,     0,   280,   281,   282,
     283,   284,   285,  1036,  1037,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,  1038,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
       0,   316,   317,   318,     0,     0,   320,     0,   321,   322,
    1039,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,     0,     0,     0,   334,     0,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
    2086,   344,   345,   346,   347,   348,   349,     0,   350,   810,
    2087,   352,   353,   354,   355,  1041,  1042,     0,  1043,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,     0,   814,   368,   815,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1044,
     816,  1045,   390,   391,   392,     0,     0,   394,   395,   817,
     396,     0,     0,   398,  1046,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,  2089,
     818,   410,   819,     0,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,     0,   424,     0,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,  1047,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,  2090,   478,   479,   821,
     480,   481,  1049,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,     0,   497,
     498,     0,   499,   822,   500,   501,   502,   503,   504,     0,
    1050,  1051,     0,     0,   507,   508,     0,   510,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,     0,  1052,  2091,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,   223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   554,   555,   556,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   246,   247,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
     255,   256,   257,     0,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,     0,
     277,   278,   279,     0,     0,     0,     0,     0,     0,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,   302,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,   315,   316,   317,   318,   319,     0,   320,
       0,   321,   322,   323,   324,     0,   325,     0,   326,     0,
       0,     0,   327,   328,   329,   330,     0,   331,   332,     0,
     333,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,   354,   355,   356,   357,
       0,   358,     0,   359,     0,     0,   360,     0,   361,   362,
     363,   364,   365,     0,     0,   366,   367,     0,   368,     0,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,     0,   389,   390,   391,   392,   393,     0,
     394,   395,     0,   396,     0,   397,   398,   399,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,   409,     0,   410,     0,   411,   412,   413,   414,
     415,   416,   417,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,     0,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,     0,   480,   481,   482,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,     0,   497,   498,     0,   499,     0,   500,   501,   502,
     503,   504,     0,   505,   506,     0,     0,   507,   508,   509,
     510,   511,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,  1030,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,     0,   233,   234,   235,     0,     0,     0,     0,     0,
       0,     0,   236,   237,     0,   238,   239,   240,   801,   241,
     242,   243,     0,  1031,   802,  1032,  1033,     0,   248,   249,
     250,   251,   252,     0,     0,   253,   254,  1034,  1035,   257,
       0,   258,   259,   260,   261,     0,     0,   803,     0,   263,
     264,   265,   266,   267,   804,   268,   269,   270,     0,   271,
     272,   273,   274,   275,   276,     0,   805,   277,   278,   279,
       0,     0,     0,   806,     0,     0,     0,   280,   281,   282,
     283,   284,   285,  1036,  1037,   288,     0,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,   300,   301,  1038,   303,   304,     0,   305,   306,
     307,     0,   308,   309,   310,     0,   311,   312,   313,   314,
       0,   316,   317,   318,     0,     0,   320,     0,   321,   322,
    1039,   324,     0,   325,     0,   326,   807,     0,   808,   327,
     328,   329,   330,     0,   331,     0,     0,     0,   334,     0,
     335,   336,   337,   338,   339,   809,   340,   341,   342,   343,
       0,   344,   345,   346,   347,   348,   349,     0,   350,   810,
       0,   352,   353,   354,   355,  1041,  1042,     0,  1043,     0,
     359,   811,   812,   360,   813,   361,   362,   363,   364,   365,
       0,     0,   366,     0,   814,   368,   815,     0,   369,   370,
     371,     0,     0,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1044,
     816,  1045,   390,   391,   392,     0,     0,   394,   395,   817,
     396,  2184,     0,   398,  1046,   400,   401,   402,     0,   403,
     404,     0,     0,   405,   406,   407,     0,     0,   408,     0,
     818,   410,   819,     0,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,     0,   424,     0,   426,
     427,   428,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   437,  1047,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,   820,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,   473,   474,     0,   475,   476,  2090,   478,   479,   821,
     480,   481,  1049,   483,     0,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,     0,     0,   497,
     498,  3813,   499,   822,   500,   501,   502,   503,   504,     0,
    1050,  1051,     0,     0,   507,   508,     0,   510,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,   519,
     520,   521,   522,   523,     0,     0,   524,   525,   526,   527,
     528,     0,  1052,     0,   531,   823,   532,   533,   534,   535,
       0,     0,   536,     0,     0,   537,   538,   539,   540,   541,
     542,  1030,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   554,   555,   556,     0,   224,   225,   226,   227,
     228,   229,   230,   231,     0,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,   236,   237,     0,   238,   239,
     240,   801,   241,   242,   243,     0,  1031,   802,  1032,  1033,
       0,   248,   249,   250,   251,   252,     0,     0,   253,   254,
    1034,  1035,   257,     0,   258,   259,   260,   261,     0,     0,
     803,     0,   263,   264,   265,   266,   267,   804,   268,   269,
     270,     0,   271,   272,   273,   274,   275,   276,     0,   805,
     277,   278,   279,     0,     0,     0,   806,     0,     0,     0,
     280,   281,   282,   283,   284,   285,  1036,  1037,   288,     0,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,   300,   301,  1038,   303,   304,
       0,   305,   306,   307,     0,   308,   309,   310,     0,   311,
     312,   313,   314,     0,   316,   317,   318,     0,     0,   320,
       0,   321,   322,  1039,   324,     0,   325,     0,   326,   807,
       0,   808,   327,   328,   329,   330,     0,   331,     0,     0,
       0,   334,     0,   335,   336,   337,   338,   339,   809,   340,
     341,   342,   343,     0,   344,   345,   346,   347,   348,   349,
       0,   350,   810,     0,   352,   353,   354,   355,  1041,  1042,
       0,  1043,     0,   359,   811,   812,   360,   813,   361,   362,
     363,   364,   365,     0,     0,   366,     0,   814,   368,   815,
       0,   369,   370,   371,     0,     0,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,  1044,   816,  1045,   390,   391,   392,  2255,     0,
     394,   395,   817,   396,     0,     0,   398,  1046,   400,   401,
     402,     0,   403,   404,     0,     0,   405,   406,   407,     0,
       0,   408,     0,   818,   410,   819,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,     0,
     424,     0,   426,   427,   428,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   437,  1047,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,   820,   457,   458,   459,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,   473,   474,     0,   475,   476,  1048,
     478,   479,   821,   480,   481,  1049,   483,     0,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,     0,   497,   498,     0,   499,   822,   500,   501,   502,
     503,   504,     0,  1050,  1051,     0,     0,   507,   508,     0,
     510,     0,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,   519,   520,   521,   522,   523,     0,     0,   524,
     525,   526,   527,   528,     0,  1052,     0,   531,   823,   532,
     533,   534,   535,     0,     0,   536,     0,     0,   537,   538,
     539,   540,   541,   542,  1030,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   554,   555,   556,     0,   224,
     225,   226,   227,   228,   229,   230,   231,     0,   233,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   236,   237,
       0,   238,   239,   240,   801,   241,   242,   243,     0,  1031,
     802,  1032,  1033,     0,   248,   249,   250,   251,   252,     0,
       0,   253,   254,  1034,  1035,   257,     0,   258,   259,   260,
     261,     0,     0,   803,     0,   263,   264,   265,   266,   267,
     804,   268,   269,   270,     0,   271,   272,   273,   274,   275,
     276,     0,   805,   277,   278,   279,     0,     0,     0,   806,
       0,     0,     0,   280,   281,   282,   283,   284,   285,  1036,
    1037,   288,     0,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   300,   301,
    1038,   303,   304,     0,   305,   306,   307,     0,   308,   309,
     310,     0,   311,   312,   313,   314,     0,   316,   317,   318,
       0,     0,   320,     0,   321,   322,  1039,   324,     0,   325,
       0,   326,   807,     0,   808,   327,   328,   329,   330,     0,
     331,     0,     0,     0,   334,     0,   335,   336,   337,   338,
     339,   809,   340,   341,   342,   343,     0,   344,   345,   346,
     347,   348,   349,     0,   350,   810,     0,   352,   353,   354,
     355,  1041,  1042,     0,  1043,     0,   359,   811,   812,   360,
     813,   361,   362,   363,   364,   365,     0,     0,   366,     0,
     814,   368,   815,     0,   369,   370,   371,     0,     0,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,  1044,   816,  1045,   390,   391,
     392,  3628,     0,   394,   395,   817,   396,     0,     0,   398,
    1046,   400,   401,   402,     0,   403,   404,     0,     0,   405,
     406,   407,     0,     0,   408,     0,   818,   410,   819,     0,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,     0,   424,     0,   426,   427,   428,     0,   429,
     430,   431,   432,   433,   434,   435,   436,   437,  1047,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,   820,
     457,   458,   459,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,   473,   474,     0,
     475,   476,  1048,   478,   479,   821,   480,   481,  1049,   483,
       0,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,     0,   497,   498,     0,   499,   822,
     500,   501,   502,   503,   504,     0,  1050,  1051,     0,     0,
     507,   508,     0,   510,     0,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,   519,   520,   521,   522,   523,
       0,     0,   524,   525,   526,   527,   528,     0,  1052,     0,
     531,   823,   532,   533,   534,   535,     0,     0,   536,     0,
       0,   537,   538,   539,   540,   541,   542,  1030,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   554,   555,
     556,     0,   224,   225,   226,   227,   228,   229,   230,   231,
       0,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   237,     0,   238,   239,   240,   801,   241,   242,
     243,     0,  1031,   802,  1032,  1033,     0,   248,   249,   250,
     251,   252,     0,     0,   253,   254,  1034,  1035,   257,     0,
     258,   259,   260,   261,     0,     0,   803,     0,   263,   264,
     265,   266,   267,   804,   268,   269,   270,     0,   271,   272,
     273,   274,   275,   276,     0,   805,   277,   278,   279,     0,
       0,     0,   806,     0,     0,     0,   280,   281,   282,   283,
     284,   285,  1036,  1037,   288,     0,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,   300,   301,  1038,   303,   304,     0,   305,   306,   307,
       0,   308,   309,   310,     0,   311,   312,   313,   314,     0,
     316,   317,   318,     0,     0,   320,     0,   321,   322,  1039,
     324,  5150,   325,     0,   326,   807,     0,   808,   327,   328,
     329,   330,     0,   331,     0,     0,     0,   334,     0,   335,
     336,   337,   338,   339,   809,   340,   341,   342,   343,     0,
     344,   345,   346,   347,   348,   349,     0,   350,   810,     0,
     352,   353,   354,   355,  1041,  1042,     0,  1043,     0,   359,
     811,   812,   360,   813,   361,   362,   363,   364,   365,     0,
       0,   366,     0,   814,   368,   815,     0,   369,   370,   371,
       0,     0,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,  1044,   816,
    1045,   390,   391,   392,     0,     0,   394,   395,   817,   396,
       0,     0,   398,  1046,   400,   401,   402,     0,   403,   404,
       0,     0,   405,   406,   407,     0,     0,   408,     0,   818,
     410,   819,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,     0,   424,     0,   426,   427,
     428,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     437,  1047,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,   820,   457,   458,   459,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
     473,   474,     0,   475,   476,  1048,   478,   479,   821,   480,
     481,  1049,   483,     0,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,     0,   497,   498,
       0,   499,   822,   500,   501,   502,   503,   504,     0,  1050,
    1051,     0,     0,   507,   508,     0,   510,     0,     0,   512,
     513,   514,   515,   516,   517,   518,     0,     0,   519,   520,
     521,   522,   523,     0,     0,   524,   525,   526,   527,   528,
       0,  1052,     0,   531,   823,   532,   533,   534,   535,     0,
       0,   536,     0,     0,   537,   538,   539,   540,   541,   542,
    1030,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   554,   555,   556,     0,   224,   225,   226,   227,   228,
     229,   230,   231,     0,   233,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   236,   237,     0,   238,   239,   240,
     801,   241,   242,   243,     0,  1031,   802,  1032,  1033,     0,
     248,   249,   250,   251,   252,     0,     0,   253,   254,  1034,
    1035,   257,     0,   258,   259,   260,   261,     0,     0,   803,
       0,   263,   264,   265,   266,   267,   804,   268,   269,   270,
       0,   271,   272,   273,   274,   275,   276,     0,   805,   277,
     278,   279,     0,     0,     0,   806,     0,     0,     0,   280,
     281,   282,   283,   284,   285,  1036,  1037,   288,     0,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   300,   301,  1038,   303,   304,     0,
     305,   306,   307,     0,   308,   309,   310,     0,   311,   312,
     313,   314,     0,   316,   317,   318,     0,     0,   320,     0,
     321,   322,  1039,   324,     0,   325,     0,   326,   807,     0,
     808,   327,   328,   329,   330,     0,   331,     0,     0,     0,
     334,     0,   335,   336,   337,   338,  1040,   809,   340,   341,
     342,   343,     0,   344,   345,   346,   347,   348,   349,     0,
     350,   810,     0,   352,   353,   354,   355,  1041,  1042,     0,
    1043,     0,   359,   811,   812,   360,   813,   361,   362,   363,
     364,   365,     0,     0,   366,     0,   814,   368,   815,     0,
     369,   370,   371,     0,     0,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,  1044,   816,  1045,   390,   391,   392,     0,     0,   394,
     395,   817,   396,     0,     0,   398,  1046,   400,   401,   402,
       0,   403,   404,     0,     0,   405,   406,   407,     0,     0,
     408,     0,   818,   410,   819,     0,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,     0,   424,
       0,   426,   427,   428,     0,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1047,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,   820,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,   473,   474,     0,   475,   476,  1048,   478,
     479,   821,   480,   481,  1049,   483,     0,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
       0,   497,   498,     0,   499,   822,   500,   501,   502,   503,
     504,     0,  1050,  1051,     0,     0,   507,   508,     0,   510,
       0,     0,   512,   513,   514,   515,   516,   517,   518,     0,
       0,   519,   520,   521,   522,   523,     0,     0,   524,   525,
     526,   527,   528,     0,  1052,     0,   531,   823,   532,   533,
     534,   535,     0,     0,   536,     0,     0,   537,   538,   539,
     540,   541,   542,  1030,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   554,   555,   556,     0,   224,   225,
     226,   227,   228,   229,   230,   231,     0,   233,   234,   235,
       0,     0,     0,     0,     0,     0,     0,   236,   237,     0,
     238,   239,   240,   801,   241,   242,   243,     0,  1031,   802,
    1032,  1033,     0,   248,   249,   250,   251,   252,     0,     0,
     253,   254,  1034,  1035,   257,     0,   258,   259,   260,   261,
       0,     0,   803,     0,   263,   264,   265,   266,   267,   804,
     268,   269,   270,     0,   271,   272,   273,   274,   275,   276,
       0,   805,   277,   278,   279,     0,     0,     0,   806,     0,
       0,     0,   280,   281,   282,   283,   284,   285,  1036,  1037,
     288,     0,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,   300,   301,  1038,
     303,   304,     0,   305,   306,   307,     0,   308,   309,   310,
       0,   311,   312,   313,   314,     0,   316,   317,   318,     0,
       0,   320,     0,   321,   322,  1039,   324,     0,   325,     0,
     326,   807,     0,   808,   327,   328,   329,   330,     0,   331,
       0,     0,     0,   334,     0,   335,   336,   337,   338,  1094,
     809,   340,   341,   342,   343,     0,   344,   345,   346,   347,
     348,   349,     0,   350,   810,     0,   352,   353,   354,   355,
    1041,  1042,     0,  1043,     0,   359,   811,   812,   360,   813,
     361,   362,   363,   364,   365,     0,     0,   366,     0,   814,
     368,   815,     0,   369,   370,   371,     0,     0,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,  1044,   816,  1045,   390,   391,   392,
       0,     0,   394,   395,   817,   396,     0,     0,   398,  1046,
     400,   401,   402,     0,   403,   404,     0,     0,   405,   406,
     407,     0,     0,   408,     0,   818,   410,   819,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,     0,   424,     0,   426,   427,   428,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   437,  1047,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,   820,   457,
     458,   459,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,   473,   474,     0,   475,
     476,  1048,   478,   479,   821,   480,   481,  1049,   483,     0,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,     0,   497,   498,     0,   499,   822,   500,
     501,   502,   503,   504,     0,  1050,  1051,     0,     0,   507,
     508,     0,   510,     0,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,   519,   520,   521,   522,   523,     0,
       0,   524,   525,   526,   527,   528,     0,  1052,     0,   531,
     823,   532,   533,   534,   535,     0,     0,   536,     0,     0,
     537,   538,   539,   540,   541,   542,  1030,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   554,   555,   556,
       0,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   237,     0,   238,   239,   240,   801,   241,   242,   243,
       0,  1031,   802,  1032,  1033,     0,   248,   249,   250,   251,
     252,     0,     0,   253,   254,  1034,  1035,   257,     0,   258,
     259,   260,   261,     0,     0,   803,     0,   263,   264,   265,
     266,   267,   804,   268,   269,   270,     0,   271,   272,   273,
     274,   275,   276,     0,   805,   277,   278,   279,     0,     0,
       0,   806,     0,     0,     0,   280,   281,   282,   283,   284,
     285,  1036,  1037,   288,     0,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
     300,   301,  1038,   303,   304,     0,   305,   306,   307,     0,
     308,   309,   310,     0,   311,   312,   313,   314,     0,   316,
     317,   318,     0,     0,   320,     0,   321,   322,  1039,   324,
       0,   325,     0,   326,   807,     0,   808,   327,   328,   329,
     330,     0,   331,     0,     0,     0,   334,     0,   335,   336,
     337,   338,   339,   809,   340,   341,   342,   343,     0,   344,
     345,   346,   347,   348,   349,     0,   350,   810,     0,   352,
     353,   354,   355,  1041,  1042,     0,  1043,     0,   359,   811,
     812,   360,   813,   361,   362,   363,   364,   365,     0,     0,
     366,     0,   814,   368,   815,     0,   369,   370,   371,     0,
       0,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,  1044,   816,  1045,
     390,   391,   392,     0,     0,   394,   395,   817,   396,     0,
       0,   398,  1046,   400,   401,   402,     0,   403,   404,     0,
       0,   405,   406,   407,     0,     0,   408,     0,   818,   410,
     819,     0,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,     0,   424,     0,   426,   427,   428,
       0,   429,   430,   431,   432,   433,   434,   435,   436,   437,
    1047,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,   820,   457,   458,   459,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,   473,
     474,     0,   475,   476,  1048,   478,   479,   821,   480,   481,
    1049,   483,     0,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,     0,   497,   498,     0,
     499,   822,   500,   501,   502,   503,   504,     0,  1050,  1051,
       0,     0,   507,   508,     0,   510,     0,     0,   512,   513,
     514,   515,   516,   517,   518,     0,     0,   519,   520,   521,
     522,   523,     0,     0,   524,   525,   526,   527,   528,     0,
    1052,     0,   531,   823,   532,   533,   534,   535,     0,     0,
     536,     0,     0,   537,   538,   539,   540,   541,   542,  1030,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     554,   555,   556,     0,   224,   225,   226,   227,   228,   229,
     230,   231,     0,   233,   234,   235,     0,     0,     0,     0,
       0,     0,     0,   236,   237,     0,   238,   239,   240,   801,
     241,   242,   243,     0,  1031,   802,  1032,  1033,     0,   248,
     249,   250,   251,   252,     0,     0,   253,   254,  1034,  1035,
     257,     0,   258,   259,   260,   261,     0,     0,   803,     0,
     263,   264,   265,   266,   267,   804,   268,   269,   270,     0,
     271,   272,   273,   274,   275,   276,     0,   805,   277,   278,
     279,     0,     0,     0,   806,     0,     0,     0,   280,   281,
     282,   283,   284,   285,  1036,  1037,   288,     0,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   300,   301,  1038,   303,   304,     0,   305,
     306,   307,     0,   308,   309,   310,     0,   311,   312,   313,
     314,     0,   316,   317,   318,     0,     0,   320,     0,   321,
     322,  1039,   324,     0,   325,     0,   326,   807,     0,   808,
     327,   328,   329,   330,     0,   331,     0,     0,     0,   334,
       0,   335,   336,   337,   338,   339,   809,   340,   341,   342,
     343,     0,   344,   345,   346,   347,   348,   349,     0,   350,
     810,     0,   352,   353,   354,   355,  1041,  1042,     0,  1043,
       0,   359,   811,   812,   360,   813,   361,   362,   363,   364,
     365,     0,     0,   366,     0,   814,   368,   815,     0,   369,
     370,   371,     0,     0,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
    1044,   816,  1045,   390,   391,   392,     0,     0,   394,   395,
     817,   396,     0,     0,   398,  1046,   400,   401,   402,     0,
     403,   404,     0,     0,   405,   406,   407,     0,     0,   408,
       0,   818,   410,   819,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,     0,   424,     0,
     426,   427,   428,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   437,  1047,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,   820,   457,   458,   459,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,   473,   474,     0,   475,   476,  2090,   478,   479,
     821,   480,   481,  1049,   483,     0,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,     0,
     497,   498,     0,   499,   822,   500,   501,   502,   503,   504,
       0,  1050,  1051,     0,     0,   507,   508,     0,   510,     0,
       0,   512,   513,   514,   515,   516,   517,   518,     0,     0,
     519,   520,   521,   522,   523,     0,     0,   524,   525,   526,
     527,   528,     0,  1052,     0,   531,   823,   532,   533,   534,
     535,     0,     0,   536,     0,     0,   537,   538,   539,   540,
     541,   542,  1030,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   554,   555,   556,     0,   224,   225,   226,
     227,   228,   229,   230,   231,     0,   233,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   236,   237,     0,   238,
     239,   240,   801,   241,   242,   243,     0,  1031,   802,  1032,
    1033,     0,   248,   249,   250,   251,   252,     0,     0,   253,
     254,  1034,  1035,   257,     0,   258,   259,   260,   261,     0,
       0,   803,     0,   263,   264,   265,   266,   267,   804,   268,
     269,   270,     0,   271,   272,   273,   274,   275,   276,     0,
     805,   277,   278,   279,     0,     0,     0,   806,     0,     0,
       0,   280,   281,   282,   283,   284,   285,  1036,  1037,   288,
       0,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,   300,   301,  1038,   303,
     304,     0,   305,   306,   307,     0,   308,   309,   310,     0,
     311,   312,   313,   314,     0,   316,   317,   318,     0,     0,
     320,     0,   321,   322,  1039,   324,     0,   325,     0,   326,
     807,     0,   808,   327,   328,   329,   330,     0,   331,     0,
       0,     0,   334,     0,   335,   336,   337,   338,   339,   809,
     340,   341,   342,   343,     0,   344,   345,   346,   347,   348,
     349,     0,   350,   810,     0,   352,   353,   354,   355,  1041,
    1042,     0,  1043,     0,   359,   811,   812,   360,   813,   361,
     362,   363,   364,   365,     0,     0,   366,     0,   814,   368,
     815,     0,   369,   370,   371,     0,     0,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1044,   816,  1045,   390,   391,   392,     0,
       0,   394,   395,   817,   396,     0,     0,   398,  1046,   400,
     401,   402,     0,   403,   404,     0,     0,   405,   406,   407,
       0,     0,   408,     0,   818,   410,   819,     0,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
       0,   424,     0,   426,   427,   428,     0,   429,   430,   431,
     432,   433,   434,   435,   436,   437,  1047,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,   820,   457,   458,
     459,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,   473,   474,     0,   475,   476,
       0,   478,   479,   821,   480,   481,  1049,   483,     0,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,   497,   498,     0,   499,   822,   500,   501,
     502,   503,   504,     0,  1050,  1051,     0,     0,   507,   508,
       0,   510,     0,     0,   512,   513,   514,   515,   516,   517,
     518,     0,     0,   519,   520,   521,   522,   523,     0,     0,
     524,   525,   526,   527,   528,     0,  1052,     0,   531,   823,
     532,   533,   534,   535,     0,     0,   536,     0,     0,   537,
     538,   539,   540,   541,   542,  1030,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   554,   555,   556,     0,
     224,   225,   226,   227,   228,   229,   230,   231,     0,   233,
     234,   235,     0,     0,     0,     0,     0,     0,     0,   236,
     237,     0,   238,   239,   240,   801,   241,   242,   243,     0,
       0,   802,     0,     0,     0,   248,   249,   250,   251,   252,
       0,     0,   253,   254,     0,     0,   257,     0,   258,   259,
     260,   261,     0,     0,   803,     0,   263,   264,   265,   266,
     267,   804,   268,   269,   270,     0,   271,   272,   273,   274,
     275,   276,     0,   805,   277,   278,   279,     0,     0,     0,
     806,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,     0,   288,     0,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   300,
     301,   302,   303,   304,     0,   305,   306,   307,     0,   308,
     309,   310,     0,   311,   312,   313,   314,     0,   316,   317,
     318,     0,     0,   320,     0,   321,   322,     0,   324,     0,
     325,     0,   326,   807,     0,   808,   327,   328,   329,   330,
       0,   331,     0,     0,     0,   334,     0,   335,   336,   337,
     338,   339,   809,   340,   341,   342,   343,     0,   344,   345,
     346,   347,   348,   349,     0,   350,   810,     0,   352,   353,
     354,   355,     0,     0,     0,     0,     0,   359,   811,   812,
     360,   813,   361,   362,   363,   364,   365,     0,     0,   366,
       0,   814,   368,   815,     0,   369,   370,   371,     0,     0,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,   816,     0,   390,
     391,   392,     0,     0,   394,   395,   817,   396,     0,     0,
     398,     0,   400,   401,   402,     0,   403,   404,     0,     0,
     405,   406,   407,     0,     0,   408,     0,   818,   410,   819,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,     0,   424,     0,   426,   427,   428,     0,
     429,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
     820,   457,   458,   459,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,   473,   474,
       0,   475,   476,     0,   478,   479,   821,   480,   481,     0,
     483,     0,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,     0,     0,   497,   498,     0,   499,
     822,   500,   501,   502,   503,   504,     0,     0,     0,     0,
       0,   507,   508,     0,   510,     0,     0,   512,   513,   514,
     515,   516,   517,   518,     0,     0,   519,   520,   521,   522,
     523,     0,     0,   524,   525,   526,   527,   528,     0,     0,
       0,   531,   823,   532,   533,   534,   535,     0,     0,   536,
       0,     0,   537,   538,   539,   540,   541,   542,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   554,
     555,   556
};

static const yytype_int16 yycheck[] =
{
      16,     0,     0,     0,     0,     0,    50,   197,   585,    25,
     618,   198,   888,   202,    21,     7,  1116,   746,  1025,   206,
      27,    20,    14,  1309,   180,   744,   202,   696,   697,   698,
     794,  1078,   219,   702,    35,  1501,    44,   904,   831,  1048,
    1388,  1908,  1311,  2402,   889,  1432,  1053,   913,    12,  2094,
    2095,  1425,   768,  2744,   658,   775,   664,  2306,  2756,  2934,
     769,   188,   618,  2590,   994,   188,  1073,  1562,  1051,  3225,
      20,  1642,    43,  2254,   197,  1138,  1083,  1169,   641,  1448,
    1366,   753,  1089,  1437,  1432,  1036,  1037,  3181,  1095,   206,
      22,   654,  1361,  3146,  1101,  1046,  2907,  1104,    17,  2804,
    2415,   968,   219,    35,  1823,   972,  3127,   576,  2566,  2327,
     977,  3521,  3135,  2804,  3135,  2959,  3200,  2961,  3212,  3476,
     987,  2748,  3411,  2746,  2747,  2813,  3517,   843,  3573,  4050,
     653,   663,  3440,  3805,  1001,  3792,  3521,   888,  3787,   167,
    3814,   749,  1911,   182,  1806,   896,  3446,   182,  2778,  1867,
    4278,   983,  4383,  3748,     0,   906,  4439,     0,  1427,   628,
    1655,  1844,  1531,  1532,  2679,     0,     0,   999,  4281,  1740,
      34,  1525,     0,  1417,     0,  3802,     0,    41,     0,     0,
       0,    21,  4232,     0,  1366,     0,    49,    27,  2059,     0,
      40,  2061,  2823,   749,   857,  4458,  3791,  3198,   791,  1034,
    1035,   917,   841,     9,   791,  4399,  3497,  4401,     5,  4594,
    1045,    49,     0,     0,  3374,     0,     5,  4582,     0,     9,
    2360,    29,  2362,    35,  2405,     5,  2366,  2094,    11,    22,
    4280,     0,     5,    56,  4497,  2375,  2376,  2377,   111,    86,
       9,     5,     5,   214,  3445,  1228,  3447,  1198,  1199,    13,
      14,    42,     5,  4731,    56,     5,    11,    26,   629,   137,
    4791,     0,    56,    13,    14,     5,   105,  1218,     3,    78,
       9,     4,     5,   162,  1067,    42,     9,  4503,  4504,    39,
       5,   132,   653,    26,   113,    40,   162,    26,    13,    14,
     157,   960,     5,     5,     5,    56,  2744,   162,    20,     5,
    4697,  4698,  2817,   163,     5,  3868,  3869,    56,  3871,  3872,
    3873,   169,  1598,     5,   111,    49,    71,     3,     4,     5,
     173,     4,    39,     9,   116,     4,     9,  4527,    57,   185,
       9,  2512,  2909,  2514,    71,   266,    65,   130,    83,   264,
     285,    73,   143,   143,     5,    38,   104,    82,   285,   188,
     296,    83,  1187,  1188,   113,   252,  2804,   679,   680,   681,
     162,   113,   684,   685,   686,   162,   111,   171,   102,   111,
     310,     3,   694,     5,   162,   162,    32,   162,   119,  1214,
     162,    26,    85,  5136,     3,     0,    22,   115,  1108,   154,
      90,    22,    28,   162,   376,   329,   583,   185,   185,   134,
     185,  1331,   589,   185,    11,    20,   198,  1713,   332,   585,
      56,    30,    31,    11,   251,   602,   185,   150,   306,   256,
     431,   143,   266,   162,   127,   111,    11,   305,   389,   247,
    1296,   319,   281,    40,    73,    50,  2498,  2499,  2500,  4087,
     364,   452,    40,   389,    83,  4093,   185,   265,   571,   208,
    4713,    26,     5,  1116,  4819,   466,  4584,   345,    33,    11,
    4991,   637,    73,   197,    71,  4659,   583,   304,   168,   318,
    4583,   432,   589,    71,   106,   409,   323,   205,  1487,    73,
     125,  1787,   422,   248,   466,   602,   432,   144,   144,    56,
     183,  1099,   251,   228,   130,    73,   225,   336,   387,   130,
     623,   324,   235,    73,   256,   238,   251,    83,  1116,    56,
     633,   408,    56,   321,   256,   249,  5269,   203,   162,     3,
     212,   466,  1085,   256,   332,   329,   334,  1247,    73,   466,
     324,    56,  1248,    26,   336,   466,   375,   376,    83,   225,
      33,   466,   161,  1099,   163,   177,   281,   306,   162,   565,
      26,   352,   352,  1822,   162,   926,   349,    33,  4758,   162,
    1276,   414,   162,   324,   104,  1173,   455,   182,  3145,   568,
     568,   568,   568,   568,   425,   324,    29,   318,   949,   468,
      34,  1144,   455,   412,   392,  3608,  1118,  3608,   466,  1875,
     387,   400,  1155,   964,   470,  1864,   387,  5075,    82,   466,
     118,   466,   618,   619,   338,   237,   466,  1170,   240,  4892,
     332,  3632,   470,   373,   470,   408,   408,  1173,   376,   421,
     664,     4,     5,   470,   415,    26,     9,   466,   466,  1496,
     352,  1294,  1499,   376,  4999,  1355,  1299,  1300,   794,   419,
     668,  1910,   431,  1475,   379,   564,   381,   470,   415,  3524,
    3939,   135,  1403,  5050,   466,   387,   373,   111,   455,   465,
    5191,   394,  1507,   452,   663,  3759,  3966,   457,   458,  3977,
     677,   468,   679,  3981,   681,  2856,   470,   466,   324,   462,
     687,   469,   469,  1291,   469,  1517,   466,   469,   457,   458,
    4818,  1299,  1300,   466,  1560,   711,  4809,  1744,   662,   691,
     469,   464,   466,   466,  4930,   468,   190,   462,   340,   470,
    1461,   470,  1719,   466,   664,  1778,   466,  3801,   457,   458,
    1727,   737,  1326,  3883,   457,   458,   466,   464,  3781,   745,
     469,   468,   748,   749,   750,  1291,  1743,   708,  1785,  4030,
     930,   466,  1405,  5128,   783,   934,  3437,  1794,   783,  3440,
     429,  5116,  1415,   466,   466,   466,  1349,   324,   934,  1710,
     466,  1593,  1349,  4326,  3965,   466,  3967,   150,   425,  4690,
     431,   457,   458,   452,   457,   458,   387,   324,   457,   458,
     324,  2826,  1153,  2828,   359,  1424,   785,   785,   785,   785,
     785,   452,   919,   387,  3043,  5058,   919,  1119,   769,   324,
    1122,   420,  1124,   287,  1126,   466,  1128,   930,  5071,   387,
    1132,   387,    26,   366,   367,   447,  2203,   387,   272,  2173,
    2106,     3,    65,   773,   470,  1488,   470,   798,  1491,  1492,
    3521,  4276,  5197,  5027,  3461,   116,   376,   677,   204,   679,
      83,   681,   387,  3718,    65,  3846,     5,   687,   688,   689,
    1685,  1686,   459,   460,   461,   462,   470,  3172,   466,   457,
     458,   459,   460,   461,   462,  4993,   359,   470,   321,   840,
     470,   104,     5,   256,   459,   460,   461,   462,  3509,  2746,
    2747,  2748,  4995,   359,  1380,    27,  1009,   104,   289,  5254,
     164,  1468,   410,    47,  3705,     5,  2250,   747,   141,   267,
      82,   751,   116,   470,  5167,   457,   458,   459,   460,   461,
     462,  1574,  2783,   776,  2784,     5,   159,   401,  5201,  5202,
     141,   104,  4972,   470,  2106,   409,   470,   162,   412,  3110,
    3111,   349,   255,    22,   104,   125,   116,   127,   159,   785,
     104,   140,   785,   344,  4994,   470,   111,     8,  2234,  2193,
     785,   785,   134,   568,    15,    16,    17,   785,  1678,   785,
     162,   785,   332,   785,   785,   785,  2649,  2650,   785,  3109,
     785,  2654,    11,  2259,   785,   299,  3225,   173,  4573,   380,
    3495,   382,  1651,   261,   198,    36,   163,   833,  2454,  3437,
    5118,   281,  3440,  5224,   268,   144,  4381,   114,   163,  4442,
     272,   455,  3632,   105,  5117,   420,  5289,   285,  2691,  2692,
     464,   394,   466,   467,   468,  3826,   470,   857,   198,  2119,
      26,    35,  2308,   222,  2031,  4435,   180,   272,   892,   893,
     159,   185,    71,   356,   261,    80,    69,  4422,   408,   116,
      54,   130,  2760,   267,   249,  2814,   228,   142,   663,   664,
    4435,  4340,   470,   249,   297,    22,    22,   199,   285,   349,
      80,    28,  1791,  1792,   181,  3770,   249,   221,  5196,   120,
      76,   261,   261,  3521,   457,   458,   297,   122,    84,  3770,
    4388,  2090,  3127,  1099,  4384,  4393,   188,   252,  4396,   103,
    3135,   186,  4535,  1464,  1013,  2469,   285,   256,   466,   281,
    1116,  1821,   122,  1823,   470,  1601,   112,   284,    80,  1829,
    2396,     5,  2774,   346,   156,  1835,  1836,  1837,  4775,  1118,
     106,   198,    22,   256,   106,  1845,  1846,   408,   342,  1121,
    1850,  1123,   266,  1125,  1150,  1127,   318,  1129,  1130,  1131,
     322,  4297,   466,  1747,  1136,  1861,   256,  1755,    56,   111,
     122,   332,   387,  1716,  4811,  4827,  4830,  1173,  4807,   376,
     403,  1684,   342,   130,   130,  1728,   256,   349,   783,  4044,
     785,  4265,   178,   187,    80,   303,  1739,  3222,   355,  4774,
    1784,   261,   403,   189,  1788,   387,  1790,  4271,   466,  1793,
    4817,   177,   281,   342,   408,   177,  1567,   379,   470,   381,
     354,  5122,  5123,  1247,  1673,   285,   376,   268,    22,  4594,
     434,  1582,   376,    22,  1737,  4810,   122,    80,   414,    28,
     140,   235,  1754,   376,   238,   470,    65,   376,   408,   318,
     130,   264,  1603,  1249,   336,   249,   165,     3,   283,   466,
     387,  4085,  1258,   448,   165,   410,   249,   429,  4691,   113,
     292,   237,   237,   350,   240,   237,  1272,  4700,   240,   122,
     349,   336,   157,   283,    82,  1842,   280,   416,    62,    63,
     296,   123,   111,   375,   376,  1291,  1116,   466,  1294,  1295,
     429,   133,   202,  1299,  1300,   466,  3977,  1658,   154,   251,
    3981,   173,  1468,  1321,   210,  1334,  1335,  4688,  1337,  1334,
    1335,  1672,  1337,   452,   270,   123,   111,     8,    26,   323,
      11,   283,   144,  1684,   281,   133,   130,   466,   395,   349,
     280,   130,  3770,   470,   413,  1696,   113,   166,   114,   343,
     464,   408,  4621,   249,   468,  5256,   381,   115,   466,    40,
    4028,   249,   164,  2072,   208,   111,    47,  4655,   214,   363,
     318,   318,   272,   177,   340,   340,   322,   323,   340,   365,
    1547,   381,   368,   389,   334,  1736,  1737,   249,  4813,   466,
      71,  3994,  3999,  5000,   336,    73,   467,   283,  4005,   470,
    1351,   281,   349,   349,  2670,    83,   466,   251,   270,  1341,
    2676,   466,   453,   454,   455,   181,   457,   458,   459,   460,
     461,   462,  2278,   164,   349,  3863,   432,   125,   337,   381,
     167,   414,   251,   237,   116,   344,   324,   256,   318,   387,
     283,   208,   392,   344,    24,   320,  4715,   205,   130,   281,
     322,  4720,  4721,    30,    31,  1622,   352,   138,   111,   332,
     470,   349,   306,  1630,   185,    45,   268,   210,   377,   349,
    4473,  2202,  4473,   467,  1294,  1642,   377,   349,   297,  1299,
    1300,   447,  2509,   281,   251,   447,   318,   281,   225,   398,
    4855,  2478,   281,   312,   279,   381,  4886,   234,  2485,   180,
     466,  1400,   402,   376,   185,   251,   249,  3736,  4572,  1505,
     256,  2323,   408,    90,   358,  1511,   314,  5124,  2505,  1870,
     318,  4886,  5129,  1118,   318,   178,  4559,   322,  2515,   318,
     342,  2119,  2519,   110,   167,  2522,   340,   387,   381,   306,
     221,  2528,  3771,  2530,  1714,   470,  2533,  2278,   272,  3977,
    1717,   349,   414,  3981,   349,   349,  1725,   342,  4895,  4896,
     349,  1668,  1665,   306,   376,  1668,   368,   144,  1724,  1725,
    2924,  1522,  3692,  1740,  2263,  2264,  3696,  3697,  2267,  3699,
    2311,  3027,  3780,  3608,   403,  1405,  1181,   268,  5195,   429,
     323,   376,   225,   334,   103,  1415,   152,   318,   251,  2411,
     320,   322,    29,   173,   416,  2592,  1201,  3632,   234,   352,
    1713,  1714,   294,  2344,  3461,   114,   349,   429,   426,   199,
     470,   281,  2434,  2435,  2436,  2437,    53,  3326,   349,  1625,
     470,   416,  4997,  1629,  2446,  1455,  1456,  1232,   410,  2282,
     452,    90,   157,   380,   429,   382,   280,  2290,  5255,   390,
    2293,  1477,  1247,   168,   466,   396,  1482,  2200,   318,   113,
     387,   110,   470,  2112,   280,   408,   222,   452,  1488,   406,
     185,  1491,  1492,   354,  4529,   152,  3837,   310,  3839,   249,
    5287,   466,   181,  5290,  1787,   125,  1842,   127,    35,   349,
    3353,  3354,  3355,  3356,   466,   144,  3359,  3360,  3361,  3362,
    3363,  3364,  3365,  3366,  3367,  3368,   410,    54,   429,   429,
    4381,   281,   270,  3047,   280,   349,  4790,  4388,  3269,    91,
    1546,  2410,  4393,   281,  1550,  4396,   235,   429,   455,   238,
    2430,   452,   452,   349,   281,   167,   157,   314,   192,  1334,
    1335,   468,  1337,   467,   157,   222,   470,   380,   318,   382,
     470,  4422,  3415,  3416,  1574,  4788,   103,   310,   179,  3346,
     318,  4825,   466,  5128,  4435,   342,   179,   314,   470,   450,
     310,   318,  4805,   406,   342,  1754,   457,   458,   459,   460,
     461,   462,  2482,   349,  2273,    11,   263,   272,  3375,   422,
     343,   163,  1764,   225,  1766,   249,  1768,   251,  1770,   376,
    1772,   429,   349,   343,  1776,  2156,   466,   113,   376,  4842,
     410,   251,   327,  4320,    40,  2464,  4607,  2168,  2861,   166,
    2269,   261,   194,   376,  5161,  1755,  4055,  1806,  1806,  1806,
    1806,  1806,   334,  1814,   211,  5200,   376,   209,  1834,   416,
     187,   162,   470,   420,   414,    71,  4701,   219,   416,   431,
    1801,   157,   429,  2342,   339,  4470,  3205,  2208,  2768,  3208,
     231,    65,  1682,   421,   185,   314,   466,    71,  3134,   422,
     452,  5007,  1692,   245,  1694,   452,   332,  2864,   334,    83,
    1700,   281,   422,  4707,   466,  2473,   192,  1707,   235,   466,
     392,   238,  4231,   342,   266,   318,  4511,   157,   466,    83,
     389,  1813,   249,  2834,  4065,  4066,  1477,   111,   163,   113,
     158,  1482,  1844,   375,  3180,  2558,  2083,   455,   318,   179,
    1852,  1820,  4429,  4594,  4431,  4603,   349,   376,  4992,  1925,
     468,  4270,  5006,   280,  2101,   318,   392,  2473,  2526,   194,
    2107,  4974,   190,   249,  2111,   251,   466,   409,   380,   349,
     382,  2651,    43,  4381,   209,  4250,   328,  2944,   429,  2946,
    4388,   281,   166,  2663,   219,  4393,   349,   416,  4396,   305,
    2137,  2555,   152,    64,   406,  1546,   323,   157,   429,  1550,
     429,   452,   164,   167,  4655,     0,  1620,    35,   192,  2159,
    2526,   281,  2161,  4222,  4422,  2695,   343,   333,   318,   470,
     125,   452,   127,   452,   188,  2161,    54,  4435,   379,  2753,
    1644,  1831,  1832,   195,  2181,   470,   363,   466,  1838,  1839,
     884,   162,   140,   464,   281,   150,   469,   468,   318,   125,
     429,   127,  2199,  2733,   152,   406,  2387,   901,   410,   157,
     904,   225,   222,  4898,   185,  2152,  1866,   251,  4839,  2152,
    3525,  2824,   256,   452,   150,   103,  2159,    21,   429,   349,
     431,   318,   140,    27,  2231,  3728,     4,     4,  4297,   332,
     333,     9,     9,   328,   152,  4195,  5109,  4197,  4198,   157,
     431,  4201,   103,   263,   202,  2910,   467,   271,  3075,   470,
    2257,   152,   349,   297,  3081,   466,   157,   467,  2265,  2077,
     470,   452,  2199,  2033,   222,  2272,  2758,    91,   312,  2276,
    2935,  4796,     8,   467,   299,    11,   470,  2049,  2761,    15,
      16,    17,  3388,  2119,   202,  4796,   251,    24,   380,  2296,
     382,   256,  2119,  3579,  2301,   281,   261,   158,  2305,   187,
    2121,   281,  2123,  3186,   222,   263,  3395,  3994,    45,   392,
    2707,  2318,  3999,  3196,   272,   260,  5189,   266,  4005,  1754,
     256,   222,   271,   461,  2331,   261,  4594,   339,   466,   190,
     468,   140,   318,  2761,  2341,  2272,   322,   465,   318,   163,
    2911,   422,   470,   152,  4855,   263,  5260,   235,   157,   464,
     238,   466,  2188,   468,   272,   465,   380,  5052,   382,   403,
     470,   249,   263,   349,  3571,  4434,   212,  4885,   392,   349,
     194,  1806,  4441,     4,   235,  4886,  5249,   238,     9,   403,
     236,  2172,   406,  3557,   466,   209,   468,  4655,  3577,  2580,
    3579,  3782,   280,   202,   467,   219,  3308,   470,  2058,  2059,
     332,   333,     8,   342,  2341,    11,  2597,   266,   466,    15,
      16,    17,   271,   222,  2985,  3504,   380,   392,   382,  2610,
       5,   245,   464,   392,   466,    10,    32,  2851,  3178,   394,
     140,   339,  3259,    18,  3261,   323,  3263,   376,  3612,   404,
    3243,  3244,   152,  3270,   402,  1880,   429,   157,   431,   185,
    2878,    36,  3139,   467,   263,   343,   470,   461,   394,  2119,
      13,    14,   466,   272,   468,  2848,  2849,   466,   404,   468,
     206,   467,  2263,  2264,   470,   363,  2267,   416,   467,    49,
    3132,   470,  3309,   320,   402,  2662,  4997,  2664,  2665,  3804,
     429,   467,   202,   467,   470,   234,   470,     8,  2334,   234,
      11,  3607,  2878,  3609,   328,   467,   464,    87,   470,   467,
     468,   467,   222,   452,   470,   467,   467,   467,   470,   470,
     470,  2357,    92,   188,  2360,  3631,  2362,   466,  4796,    40,
    2366,   429,   268,   431,   467,     8,    47,   470,    11,  2375,
    2376,  2377,  3648,   467,   236,  5240,   470,   117,   467,  4550,
    4746,   470,  4748,   263,  4514,    79,  4752,  2564,  4754,   179,
      71,   231,   272,   467,   134,   392,   470,    40,   138,   429,
     467,   431,   231,   470,    47,  2582,   467,   422,   467,   470,
     231,   470,   467,  2590,    53,   470,   467,  4855,   158,   470,
    2600,   161,   467,   402,   231,   470,   467,  2433,    71,   470,
     206,   332,   333,     8,  4800,   175,    11,   339,  4473,  4296,
      15,    16,    17,  3807,   467,   212,   469,  5128,  4886,  2410,
    3003,  3789,  2282,   467,     9,   467,   470,   138,   470,  2465,
    2290,   467,  2416,  2293,   470,  3018,   466,  2473,  2456,  3522,
    3523,  5159,  2077,   466,  3127,   467,   467,  2594,   470,   470,
     467,  2594,  3135,   470,   266,   467,   467,  2600,   470,   470,
     467,   467,   268,   470,   470,   138,   336,   467,   467,   180,
     470,   470,   467,   336,   185,   470,  3165,   336,   467,   467,
     467,   470,   470,   470,   470,   336,   256,  5205,    53,  5200,
    2526,  2882,   402,   467,   264,   467,   470,   467,   470,   336,
     470,   467,  5049,   467,   470,   466,   470,   180,  2899,   379,
     221,  2707,   185,  3141,   380,  3143,   382,   453,   454,   455,
     379,   457,   458,   459,   460,   461,   462,   253,   379,  4997,
    1854,  4596,   422,  1857,   304,  3506,   406,   467,   467,   420,
     470,   470,   379,   467,   332,   333,   470,   406,   221,   467,
     467,     8,   470,   470,    11,   406,   380,   268,   382,   429,
     467,   431,   469,  3292,  3982,  3141,  3984,  3143,   467,   406,
     429,   470,   431,  3156,   467,  3158,    43,   470,   429,  3465,
     431,   467,  2778,    40,   470,   467,  5304,  2651,   470,   449,
      47,   208,   429,  3221,   431,   268,   466,   788,   269,   790,
     467,  2744,  2993,   470,  2995,   269,   467,   466,  3348,   470,
     468,   266,   387,  4099,    71,   466,   342,   279,   467,   467,
     467,   470,   470,   470,   467,   467,   157,   470,   470,   466,
     266,  2695,   231,  4336,  3317,  2495,  2496,   467,   449,   269,
     470,  2501,  3382,   354,    43,  3221,   208,   453,   454,   455,
     376,   457,   458,   459,   460,   461,   462,  3281,   449,   467,
    5128,  2804,   470,   268,   467,   459,   467,   470,  2875,   470,
     161,  3455,  3456,  3457,   470,   467,  4083,  2649,  2650,   466,
     342,   354,  2654,   467,    53,  3076,   231,  3427,   162,   467,
     416,  3578,   470,   231,   467,   204,   467,   470,  2558,   470,
     468,   467,   467,   429,   470,   470,  3995,   466,   466,   466,
    2738,  2739,  2740,  3104,   376,   467,  3452,   433,   470,  2691,
    2692,   466,   318,   180,  3307,  2761,   452,   467,   185,  5108,
     470,   467,  5200,   185,   470,  4024,  3549,   336,  5007,   450,
     466,   467,   467,   469,  2808,   470,   457,   458,   459,   460,
     461,   462,   145,   466,   416,  2774,  2774,  2774,  2774,  2774,
     231,   468,   467,   467,   221,   470,   470,   429,   467,   467,
     467,   470,   470,   470,   145,   467,  2983,   450,   470,   467,
     379,   266,   470,   185,   457,   458,   459,   460,   461,   462,
     452,   336,     8,   467,   318,    11,   470,   266,   336,    15,
      16,    17,   467,   145,   466,   470,     8,   406,   185,    11,
     145,   268,   266,  3204,  3841,  3702,    32,   157,  3845,     8,
    3685,  2456,    11,   318,   145,   220,    15,    16,    17,   113,
     429,   410,   431,   231,   379,   266,   467,   231,    40,   470,
     236,   379,  2878,    32,  3235,    47,   466,   260,   453,   454,
     455,    40,   457,   458,   459,   460,   461,   462,    47,   467,
     392,   406,   470,   422,   339,   336,   157,   466,   406,    71,
     467,     8,   466,   212,    11,    65,   251,    35,    15,    16,
      17,   251,    71,   433,   429,   466,   431,   252,   253,  3096,
     266,   429,   157,   431,   251,    32,    43,   354,    43,  2759,
    3929,  2761,   251,    40,   397,   251,    82,   281,   379,   422,
      47,   422,    79,   157,   300,   145,   145,  4620,   466,   145,
     419,   466,  2782,  2783,   466,  3608,   293,   466,   466,  2965,
     145,  3127,    34,   466,    71,   406,   138,   433,   336,  3135,
    3331,   145,   336,   470,  4831,   145,   145,   145,   145,  3632,
     145,   157,   145,    22,   145,    24,   266,   145,   429,    28,
     431,  3352,   145,   145,    33,    34,    35,   376,    37,   466,
      35,    40,    41,   220,    43,     5,    45,   342,   180,   157,
    3016,   379,   157,   185,   266,   379,  3377,   466,     5,   466,
     206,   180,   157,   450,   466,   466,   185,     5,   466,     5,
     457,   458,   459,   460,   461,   462,   466,   466,   406,     5,
     466,   376,   406,   466,     5,   466,  2651,   206,   207,   221,
    3411,   466,   466,   466,   466,   466,   466,   466,   466,   466,
     466,   429,   221,   431,  4061,   429,   466,   431,     8,   466,
     466,    11,  3078,   180,   466,    15,    16,    17,   185,   466,
     466,   416,   268,   277,   466,   466,   466,   430,   204,    35,
    2695,    94,  3269,   470,   429,   254,   268,   470,   466,   206,
     207,   220,   466,  3109,    35,  4102,  4103,  2712,  3285,   268,
     157,   157,   271,   263,   221,  3121,   349,   452,   261,   387,
     387,  3127,   387,  2728,   336,     3,   421,   387,   336,  3135,
     468,   466,   387,  3310,   387,  3141,   222,  3143,   336,  2744,
     387,   387,   455,   387,    83,    23,   336,   254,   145,   188,
     189,   190,   191,   266,   193,   266,   217,   341,   197,   387,
     199,   268,   387,   202,   271,   256,   387,   409,   379,  2774,
     209,   266,   211,   266,   261,   214,   332,   466,   387,   218,
     387,   220,   354,  3189,   178,  4858,    83,  4240,   466,   470,
     185,  4188,  4189,   281,   145,   354,   387,   410,  3851,  2804,
    3753,  3754,   105,  2808,    82,   410,  3916,   387,   387,   387,
     376,    53,   376,    53,  3220,  3221,   387,   242,   270,   303,
     285,   285,   336,  3211,    42,   387,    42,   336,   266,   470,
     387,   206,   387,   387,   206,   379,   387,   206,   387,   206,
    4578,   433,   266,  4519,   266,  3233,   387,   354,   387,   387,
     266,   387,   206,  3847,  3848,  3849,   387,   135,   387,   206,
     387,   206,   387,   397,   466,    35,   206,   453,   454,   455,
     145,   457,   458,   459,   460,   461,   462,  3423,   450,    24,
     266,   145,   429,   251,   111,   457,   458,   459,   460,   461,
     462,   450,   410,   145,   453,   454,   455,  3127,   457,   458,
     459,   460,   461,   462,   145,  3135,  4303,   185,  4305,  4306,
    4019,   470,   190,   421,   145,   228,   266,   429,   261,   251,
      35,   251,  4319,   251,  3437,   157,   466,  3440,   268,  3159,
       8,  3292,    35,    11,   338,   212,   466,    15,    16,    17,
      34,   385,   385,   450,   464,   387,   453,   454,   455,   145,
     457,   458,   459,   460,   461,   462,   387,   387,   464,   387,
     145,   466,    40,   470,   145,   410,   145,   145,   260,    47,
     410,   255,   387,   162,   425,  3552,   466,   242,    11,   242,
     385,   470,   153,   466,   466,   387,   162,  3421,   171,   470,
     389,  3397,   467,    71,   471,   466,  3757,   202,   178,   352,
     470,   178,   210,   470,   410,   267,  3440,    35,  3521,   287,
    3240,  3353,  3354,  3355,  3356,   274,    53,  3359,  3360,  3361,
    3362,  3363,  3364,  3365,  3366,  3367,  3368,   336,   410,   387,
     467,  3429,  3430,  3431,  3432,   210,   210,   466,  4091,   256,
     466,   256,  3608,   387,  3386,  4012,   387,   157,   236,   422,
     392,   329,   339,     8,   212,   256,    11,   147,    43,   266,
      15,    16,    17,   358,   251,   147,  3632,   220,   220,   220,
     264,   332,   387,  3415,  3416,   379,   266,    32,   470,   318,
     266,   179,   387,   306,    35,   387,  3663,  3317,   346,  3666,
     206,   410,   410,   212,   145,   264,   374,   188,   302,   455,
     455,   261,   180,   157,    35,   422,   377,   185,   303,   159,
     346,   261,   261,   453,   454,   455,   145,   457,   458,   459,
     460,   461,   462,   401,   563,   145,   145,  4080,   206,   207,
     569,   409,   571,   466,   412,   574,   429,   576,   251,   578,
     466,    35,   251,   221,   266,  4255,   585,   212,   266,     0,
     176,   590,   176,   592,  5227,  5228,   157,    35,   464,   467,
     599,   449,   346,   449,  4223,   240,   467,   467,   467,   467,
     212,  4165,  4166,   340,  4168,   157,   254,   266,  3939,   251,
     185,   185,   185,   433,   623,   470,  3763,   470,   470,   628,
     268,    23,   169,   466,   633,   387,   162,   266,   637,   239,
     429,   470,  3608,  4156,    53,  3782,  3211,   260,   376,   422,
     392,   467,   212,   467,   467,   162,   467,   466,   657,  4616,
     467,   467,   467,   467,   286,   277,  3632,   470,  3233,   467,
     467,   387,   467,  3639,   162,  5091,  3642,   449,  3644,    90,
     466,  3638,   466,   408,   466,   466,   276,   466,   451,  4403,
     267,   206,   267,  4743,   426,   230,  4410,  3770,   467,   416,
    4936,    53,   426,   269,   266,   188,  4523,   266,   266,   708,
     145,   433,     8,   466,   196,    11,   354,  3854,  3684,    15,
      16,    17,   721,   387,   723,   387,  3692,   387,   256,   140,
    3696,  3697,  4689,  3699,    35,  4248,    32,  4734,  3704,  4736,
     455,   152,  4063,   466,   743,   744,   157,   746,   747,   251,
     387,   162,   751,   268,    55,   145,   270,   168,   341,   145,
     171,   145,   220,   174,   188,   341,   765,   341,   147,   455,
     769,   387,   470,   222,   410,   287,   775,   287,   387,   407,
    4101,   387,  4739,   157,   387,   232,   387,   786,    89,   232,
     232,   202,   387,   387,   266,  5031,   336,   336,   336,   798,
     387,  4122,   387,   336,   145,   387,   387,   251,   349,   387,
      42,   222,   450,   206,   387,   453,   454,   455,  3608,   457,
     458,   459,   460,   461,   462,   206,  3728,   173,   206,   206,
     387,   387,     3,   467,   467,     3,     8,  3803,   157,    11,
     470,   840,  3632,    15,    16,    17,   397,   148,  3638,    43,
     320,  3799,   263,   104,   157,   266,  3421,   264,   466,   858,
    4473,   272,   467,    35,   863,   864,  4187,   266,    35,  4548,
     145,   470,  3437,   145,   387,  3440,   467,   157,   173,   410,
     410,   182,   145,   336,   336,   336,  4012,   269,  4938,   346,
     143,   143,   206,   892,   893,   465,   465,   206,   470,   467,
     206,  3867,  3868,  3869,  3977,  3871,  3872,  3873,  3981,  4436,
     206,   212,   206,   206,   325,   206,   217,   464,  3708,  3709,
     919,   136,   162,    11,   470,   421,  4640,   277,   157,   162,
     466,   930,   272,  4946,  4947,   934,   426,   162,   453,   454,
     455,   470,   457,   458,   459,   460,   461,   462,   467,   467,
     251,   467,   452,   952,   171,  4625,   267,  4484,   467,   467,
     466,  4474,   467,   466,   465,   376,   470,   325,   467,   467,
     415,   466,   268,    81,   397,   974,   157,  4298,    35,   410,
    4117,   282,   981,   982,   410,   212,   387,   196,    53,   145,
     379,   402,  4129,   466,   397,   318,  4666,   166,   341,   387,
     387,   336,   387,   336,  1003,  1004,  1005,   387,  1007,   429,
    1009,   387,   467,    53,   379,   426,  5252,   428,   429,  4340,
     466,   322,   416,   157,   147,   326,   467,   467,    71,   145,
     104,   397,   333,   467,   206,   210,   206,   466,   191,   301,
     341,  4007,   206,  4009,   206,   206,   266,   466,   349,   387,
     433,     8,   470,   464,    11,   313,   467,   468,   469,   467,
     361,  3851,    35,   285,   470,  5301,    77,  3969,   369,   379,
    5083,   466,   470,  4021,  4022,   397,   467,   346,   168,  1078,
    5316,  1080,  1081,    40,   104,   387,   162,   206,   311,   390,
      47,  4042,   162,   466,  4648,   470,   268,   465,   467,   466,
      53,   427,   427,   467,     8,  4659,   467,    11,   470,  1108,
     467,    15,    16,    17,    71,   466,   209,   277,   467,   466,
     275,   378,   209,   424,   466,   273,  5176,   428,   429,    53,
    4743,   467,  4958,   174,   261,   467,   467,   455,  4095,  1138,
    1139,   397,   387,   162,  1143,   429,  1145,   179,    71,   256,
     256,   190,  4225,    53,   470,   455,   387,   453,   454,   455,
     379,   457,   458,   459,   460,   461,   462,  1166,    65,   387,
    1169,   470,   206,  1172,   387,   145,   466,   164,   162,   111,
      35,   138,  4852,  4320,  4738,  4743,  1185,   185,   261,   410,
     466,    35,   346,   251,   410,   159,   157,   346,     8,  4869,
     261,    11,    53,  5160,  4874,  3770,  4876,    35,   162,   157,
     266,   466,   193,   204,   269,   429,  1215,   429,   162,  4185,
    4186,   362,   466,   180,   466,   311,   415,   466,   185,  4195,
      40,  4197,  4198,   467,  3799,  4201,   285,    47,   209,   467,
     466,   428,   466,    83,  1243,  1244,  1245,   126,  1247,   266,
     312,   387,    35,   145,   387,   157,   467,   467,   466,   466,
     466,    71,   466,   466,   221,   118,    35,   256,  1267,   178,
     233,   188,   301,   466,   466,   346,   467,   145,  4897,   104,
     425,   453,   454,   455,   131,   457,   458,   459,   460,   461,
     462,    35,  4429,   467,  4431,  4261,   270,   333,   333,   397,
    4621,  4091,   206,    53,   467,  4095,  1305,   360,  4381,  1308,
    4436,   268,  4866,   360,    53,  4388,    35,    74,   470,  4267,
    4393,   467,   466,  4396,  4397,   467,   466,   466,   138,  4295,
    4120,  4121,   415,   379,   466,  4125,  4126,  1336,   466,   178,
    4661,  1340,  1341,  4483,   410,  4484,   157,  4473,   379,  4422,
     249,   466,  1351,  1352,  1353,   266,  1355,   379,  4484,     5,
    4326,   151,  4435,   467,   268,   433,   466,  4894,   144,   466,
     180,    65,    65,   269,   126,   185,   414,   429,  1377,   429,
    4938,   311,   415,    35,   466,  4525,   466,   349,   162,   470,
     309,   379,   256,   131,  4715,   190,   426,   354,    35,  4720,
    4721,   266,   466,   266,   346,    35,   301,   269,   269,   164,
    4483,   221,  3977,  1412,    53,   466,  3981,   164,  1417,   467,
     387,   116,   466,   408,   466,   470,   332,     5,   346,   332,
     467,   273,  1431,  1432,  4336,   319,    21,    32,   256,   467,
     466,  1440,   466,  4345,  1443,   470,   144,   470,   466,   387,
     162,    74,  4525,   301,   429,   360,  4021,  4022,   268,   360,
     429,   466,   164,   164,   785,  1549,  2414,  2761,   893,  1468,
    1300,  1470,  2311,  4415,  2243,   892,  3581,   849,  2935,  3607,
    5243,  5073,  3125,  2336,  1483,  3704,  4756,  1486,  4936,  5176,
    3751,  4578,  4213,   450,  4547,  2855,  2547,  5056,  4435,  4966,
     457,   458,   459,   460,   461,   462,  5093,  4473,  5165,  4965,
    5200,  4832,  3800,  2859,  3784,  4903,  3742,  2399,  2399,  3176,
    3602,  4594,  2960,  1522,  3767,  4249,   889,  4554,  3188,  2393,
    4563,  5178,  5316,  5301,  1533,  1534,  1535,  1536,  1537,  4540,
    3134,  3129,  5106,  4486,   354,  4718,  4912,  1611,  4514,   453,
     454,   455,  1551,   457,   458,   459,   460,   461,   462,  4489,
      27,  3854,  4687,  1562,  1156,  1564,  3807,     8,  2833,  4831,
      11,  1724,  2095,  1665,    15,    16,    17,  1576,  1577,   651,
    1809,  3079,  4655,  1809,  3648,  3631,  1810,  3180,  5133,  5292,
    1145,   962,   619,  2033,  1384,  4023,  2034,  4418,  1597,    40,
    1755,  5048,  3501,  1277,  4552,   764,    47,  2775,  2075,  2790,
    1343,  1325,  2049,  3464,  5040,  4878,  4008,  1616,  5176,  2074,
    1346,  3440,  3966,  1344,  3983,  4656,  3437,  4855,  4854,  3502,
      71,  3437,  1351,  1632,  1633,  1634,  1635,  5149,  5296,  5030,
     450,  5231,  4623,  4591,  1689,  3390,  1645,   457,   458,   459,
     460,   461,   462,  1652,  5043,  4412,  1655,  5044,  5023,  1903,
    2712,  2622,  2764,  2710,  1906,    -1,  1665,    -1,    -1,  1668,
      -1,    -1,  4666,    -1,  1673,    -1,    -1,    -1,    -1,  1678,
      -1,    -1,    -1,  4473,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4772,
      -1,    -1,  4267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5034,  1713,  1714,    -1,    -1,  4620,    -1,
      -1,    -1,    -1,  4796,    -1,  1724,  1725,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,
      -1,    -1,    -1,  4645,   185,  1744,  1745,    -1,    -1,    -1,
      -1,    -1,  1751,    -1,  1753,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4730,  4731,    -1,    -1,  4894,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4743,    -1,  1778,
     221,  4747,  4855,    -1,    -1,    -1,  1785,    -1,  1787,    -1,
      -1,  4757,  1791,  1792,    -1,  1794,    -1,    -1,    -1,    -1,
      -1,    -1,  1801,    -1,    -1,    -1,    -1,    -1,    -1,  1808,
      -1,    -1,    -1,  4886,  1813,  1814,    -1,    -1,  1817,    -1,
      -1,    -1,  1821,  4388,  1823,    -1,    -1,   268,  4393,  1828,
    1829,  4396,    -1,    -1,    -1,    -1,  1835,  1836,  1837,    -1,
      -1,    -1,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,
      -1,  1850,    -1,  1852,  1853,    -1,    -1,  1856,  4806,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       0,    -1,  1871,  1872,  1873,  1874,    -1,    -1,    -1,  1878,
    1879,    -1,    -1,    -1,  1883,    -1,    -1,  1886,    -1,    -1,
    1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,    -1,
    1899,    -1,    -1,    -1,    -1,    -1,  1905,  1906,    -1,  1908,
      -1,    -1,  5049,   354,    -1,    -1,  1915,    -1,    -1,    -1,
      -1,    -1,  5062,    -1,  4997,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4883,    -1,    -1,    -1,    -1,
    4730,  4731,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4743,    -1,    -1,  4858,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4938,    -1,    -1,    -1,  4942,    -1,  4944,    -1,
      -1,    -1,  4948,  4949,    -1,    -1,    -1,  4552,    -1,  5062,
      -1,    -1,    -1,    -1,  5134,  5135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,
     140,    -1,   453,   454,   455,    -1,   457,   458,   459,   460,
     461,   462,   152,    -1,    -1,    -1,  4591,   157,    -1,    -1,
      -1,    -1,   162,  2032,    -1,  2034,    -1,  2036,   168,    -1,
    5113,   171,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
    2049,    -1,    -1,    -1,    -1,  5128,    -1,    -1,    -1,  2058,
    2059,  5134,  5135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   202,  2072,    -1,    -1,    -1,    -1,    -1,    -1,
    2079,    -1,  2081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4655,    -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4666,    -1,    25,    -1,    -1,    -1,  5073,    -1,  5075,
      -1,    -1,    -1,  2112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2121,    -1,  2123,    -1,    -1,  5200,  5030,    -1,
      -1,    -1,    -1,   263,    -1,    -1,   266,    -1,    -1,    -1,
      -1,  2140,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,  2152,    -1,  2154,  2155,    -1,    -1,  5107,
    2159,    -1,  2161,    -1,  2163,    -1,  2165,    -1,    -1,    -1,
    2169,    -1,    -1,  2172,    -1,    -1,    -1,  5317,  5318,    -1,
      -1,    -1,    -1,   105,  5133,  5133,  5133,  5133,  5133,    -1,
      -1,    -1,    -1,    -1,  2193,   325,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2203,    -1,   128,    -1,    -1,    -1,
    5176,    -1,  2211,  5207,    -1,    -1,    -1,   139,    -1,  2218,
      -1,    -1,    -1,    -1,    -1,    -1,  5299,    -1,  2227,    -1,
      -1,  4796,    -1,    -1,    -1,    -1,    -1,   159,    -1,    -1,
      -1,  4806,   164,  5145,  5317,  5318,   376,    -1,    -1,  2248,
      -1,    -1,    -1,    -1,  2253,  2254,    -1,    -1,  5207,  5207,
    5207,  5207,  5207,    -1,  2263,  2264,    -1,    -1,  2267,    -1,
    2269,  2270,   402,    -1,    -1,    -1,    -1,  5243,    -1,    -1,
      -1,    -1,    -1,  5073,    -1,  5075,  5252,    -1,    35,  2288,
      -1,   213,  2291,    -1,    -1,    -1,   426,    -1,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,   234,  2312,  2313,    -1,    -1,    -1,  4883,    -1,
      -1,    -1,    -1,    -1,    -1,  5227,  5228,    -1,  2327,    -1,
    2329,  2330,    -1,    -1,   464,  5301,    -1,   467,   468,   469,
      -1,    -1,    -1,  5292,  5292,  5292,  5292,  5292,    -1,    -1,
    5316,    -1,    -1,    -1,    -1,    -1,   103,   104,    -1,    -1,
    2359,    -1,    -1,    -1,   111,    -1,    -1,    -1,  2367,  2368,
      -1,    -1,    -1,    -1,    -1,  2374,    -1,    -1,   300,    -1,
      -1,   303,    -1,    -1,    -1,    -1,    -1,  2386,    -1,  2388,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2402,    -1,    -1,  2405,   329,  2407,    -1,
      -1,  2410,    -1,    -1,   336,  2414,    -1,    -1,  2417,   166,
      -1,   343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2429,  2430,    -1,    -1,    -1,     0,    -1,    -1,    -1,    -1,
     187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2447,   371,
      -1,    -1,    -1,  5243,   376,    -1,    -1,   379,  2457,    -1,
    2459,    -1,  5252,    -1,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,   397,    15,    16,    17,    -1,
      -1,    -1,    -1,  2482,    -1,    -1,    -1,    -1,   235,    -1,
      -1,   238,    -1,    32,    -1,    -1,    35,    -1,    -1,    -1,
     422,    40,   249,    -1,   251,    -1,    -1,    -1,    47,    -1,
    2509,  5301,  2511,  2512,  2513,  2514,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,  5316,    -1,    -1,    -1,
      -1,    -1,    71,   280,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5107,    -1,    -1,    -1,    -1,    -1,  2547,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5133,    -1,
      -1,    -1,    -1,    -1,    -1,   140,   323,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2584,    -1,   152,    -1,    -1,
      -1,    -1,   157,    -1,    -1,  2594,   343,   162,    -1,    -1,
      -1,  2600,    -1,   168,    -1,    -1,   171,    -1,    -1,   174,
      -1,    -1,    -1,    -1,  2613,    -1,   363,    -1,   365,    -1,
      -1,   368,  2621,    -1,    -1,    -1,    -1,  2626,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,    -1,    -1,
      -1,   180,  5207,    -1,    -1,    -1,   185,    -1,    -1,    -1,
    2649,  2650,  2651,    -1,    -1,  2654,     0,   222,    -1,    -1,
      55,    -1,    -1,  2662,  2663,  2664,  2665,   206,   207,    -1,
      -1,    -1,    -1,    -1,    18,    -1,  2675,    -1,    -1,  2678,
      -1,  2680,   221,    -1,    28,    -1,    30,    31,    -1,    -1,
      -1,    -1,  2691,  2692,    89,    -1,  2695,    -1,   263,    -1,
      -1,   266,    46,    -1,    -1,    -1,    -1,   272,  2707,    -1,
    2709,    -1,  2711,    -1,  2713,   254,    -1,    -1,    -1,   466,
      -1,    -1,    66,    -1,    68,    69,    -1,  5292,    -1,   268,
      -1,    75,   271,    77,  2733,    -1,    -1,    -1,  2737,    -1,
      -1,    -1,    -1,    -1,    88,  2744,    90,  2746,  2747,  2748,
      -1,    -1,    -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,
     325,    -1,    -1,   107,    -1,  2764,   110,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2775,    -1,    -1,    -1,
     124,    -1,   126,    -1,    -1,    -1,   130,   182,    -1,    -1,
      -1,  2790,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     144,    -1,   146,    -1,    -1,  2804,    -1,    -1,   152,  2808,
      -1,   376,  2811,    -1,  2813,   354,    -1,    -1,    -1,    -1,
      -1,    -1,   217,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,   402,    11,    -1,
     184,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2854,   251,  2856,    -1,    32,
      -1,   426,  2861,   428,   429,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,   223,
     224,    -1,    -1,    -1,    -1,   229,    -1,   282,    -1,  2888,
      -1,  2890,  2891,  2892,    -1,    -1,    20,   241,    71,   464,
      -1,    25,   467,   468,   469,    -1,    -1,    -1,    -1,   253,
      -1,   450,    -1,    -1,   453,   454,   455,    -1,   457,   458,
     459,   460,   461,   462,    -1,    -1,    -1,   322,    -1,   324,
      -1,   326,    -1,    -1,    -1,    59,    -1,    -1,   333,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   341,    -1,    72,    73,
      -1,   295,    -1,    -1,   349,    -1,    -1,    -1,    -1,    83,
      -1,    -1,    -1,    87,   308,    -1,   361,    -1,    -1,    -1,
     314,   315,    -1,   317,   369,    -1,    -1,    -1,   322,    -1,
      -1,   105,    -1,   327,    -1,    -1,   330,    -1,    -1,    -1,
      -1,   335,    -1,    -1,    -1,    -1,    -1,   341,   342,    -1,
      -1,    -1,  3001,    -1,   128,   349,    -1,   180,    -1,   353,
      -1,    -1,   185,    -1,    -1,   139,    -1,    -1,    -1,   363,
      -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,   424,
      -1,    -1,   376,   206,   207,   159,    -1,    -1,    -1,    -1,
     164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,
      -1,   395,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   405,    -1,    -1,   188,    -1,    -1,   411,    -1,    -1,
      -1,    -1,   416,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   254,    -1,    -1,    -1,   429,    -1,    -1,    -1,   213,
      -1,    -1,    -1,    -1,    -1,   268,    -1,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3105,    -1,   452,    -1,
     234,  3110,  3111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   466,    -1,    -1,   469,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,   268,    -1,    -1,    -1,  3147,  3148,
    3149,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,  3164,   290,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   300,    -1,    -1,   303,
      -1,   354,    -1,    -1,    -1,    -1,    -1,  3186,  3187,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,  3196,  3197,  3198,
      -1,    -1,    -1,  3202,    -1,   329,    -1,    -1,    -1,    -1,
     334,    -1,   336,    -1,    -1,    -1,  3215,    -1,    -1,   343,
      -1,    -1,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   365,    -1,    -1,    -1,    -1,    -1,   371,    -1,    -1,
      -1,    -1,   376,    -1,    -1,   379,    -1,    -1,    -1,   383,
      -1,    -1,    -1,    -1,    -1,    -1,   390,    -1,   392,    -1,
      -1,    -1,    -1,   397,  3273,    -1,    -1,   450,    -1,    -1,
     453,   454,   455,    -1,   457,   458,   459,   460,   461,   462,
      -1,    -1,    -1,  3292,   467,    -1,    -1,    -1,   422,    -1,
      -1,   180,    -1,    -1,    -1,    -1,   185,    -1,     8,  3308,
      -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,   207,  3328,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,  3337,    -1,
      40,    -1,   221,    -1,  3343,    -1,  3345,    47,    -1,  3348,
      -1,    -1,    -1,    -1,  3353,  3354,  3355,  3356,    -1,    -1,
    3359,  3360,  3361,  3362,  3363,  3364,  3365,  3366,  3367,  3368,
      -1,    71,    -1,  3372,  3373,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3382,    -1,    -1,    -1,  3386,    -1,   268,
      -1,  3390,   271,    -1,    -1,    -1,    -1,    -1,    -1,  3398,
      -1,    -1,  3401,    -1,  3403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3412,    -1,    -1,  3415,  3416,    -1,    -1,
      -1,  3420,  3421,    -1,    -1,    -1,  3425,    -1,  3427,    -1,
      -1,    -1,    -1,    -1,    -1,  3434,  3435,  3436,  3437,    -1,
      -1,  3440,  3441,    -1,    -1,    -1,  3445,  3446,  3447,    -1,
       8,    -1,    -1,    11,  3453,    -1,    -1,    15,    16,    17,
    3459,  3460,  3461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,   354,    -1,    -1,    -1,    -1,
     180,    -1,    40,    -1,    -1,   185,    -1,    -1,  3487,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3501,    -1,  3503,    -1,   206,   207,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   221,  3521,  3522,  3523,    -1,  3525,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3542,  3543,  3544,  3545,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,    -1,
      -1,   450,  3571,    -1,   453,   454,   455,    -1,   457,   458,
     459,   460,   461,   462,    -1,    -1,    -1,    -1,   467,    -1,
    3589,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   180,     8,    -1,    -1,    11,   185,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,   206,   207,
      -1,    -1,    -1,    -1,   354,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    47,   221,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,  3681,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    -1,   254,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,
     268,    -1,    -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3720,    -1,    -1,    -1,  3724,    -1,  3726,    -1,  3728,
      -1,    -1,    71,    -1,    -1,    -1,  3735,    -1,    -1,    -1,
      -1,    -1,  3741,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     450,    -1,  3751,   453,   454,   455,    -1,   457,   458,   459,
     460,   461,   462,    -1,    -1,    -1,    -1,  3766,    -1,    -1,
      -1,  3770,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3789,    -1,    -1,    -1,    -1,   180,   354,    -1,    -1,    -1,
     185,  3800,    -1,    -1,    -1,  3804,    -1,    -1,    -1,  3808,
    3809,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   206,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,  3837,    -1,
    3839,   180,    -1,    -1,    -1,    -1,   185,  3846,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,   207,   254,
      -1,    -1,    -1,    -1,    -1,    -1,  3875,    -1,    -1,    -1,
      -1,    -1,   221,   268,    20,    -1,   271,  3886,    -1,    25,
      -1,    -1,   450,    -1,    -1,   453,   454,   455,    -1,   457,
     458,   459,   460,   461,   462,    -1,    -1,    -1,    -1,   467,
      -1,    -1,    -1,    -1,    -1,   254,    -1,  3916,    -1,    -1,
      -1,    -1,    -1,    59,    -1,    -1,    -1,  3926,  3927,   268,
      -1,    -1,   271,    -1,  3933,  3934,    72,    -1,    -1,  3938,
      -1,    -1,    -1,    -1,  3943,    -1,    -1,  3946,  3947,    -1,
      -1,    87,  3951,  3952,    -1,    -1,    -1,    -1,  3957,  3958,
    3959,  3960,  3961,    -1,    -1,    -1,  3965,  3966,  3967,   354,
    3969,  3970,    -1,    -1,  3973,    -1,    -1,    -1,  3977,    -1,
      -1,    -1,  3981,    -1,    -1,    -1,    -1,    -1,  3987,    -1,
      -1,    -1,   128,    -1,    -1,  3994,    -1,    -1,    -1,    -1,
    3999,    -1,    -1,   139,    -1,    -1,  4005,    -1,    -1,    -1,
      -1,    -1,    -1,  4012,    -1,   354,    -1,    -1,    -1,    -1,
    4019,    -1,    -1,   159,  4023,    -1,    -1,    -1,   164,  4028,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4042,    -1,    -1,  4045,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,    -1,   189,   190,
      -1,    -1,   193,    -1,    -1,   450,  4065,  4066,   453,   454,
     455,    32,   457,   458,   459,   460,   461,   462,    -1,    40,
     211,    -1,   467,    -1,  4083,    -1,    47,   218,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4096,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      71,   450,    -1,    -1,   453,   454,   455,    -1,   457,   458,
     459,   460,   461,   462,    -1,    -1,    -1,    -1,   467,    -1,
      -1,     8,   268,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,  4145,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,   300,    -1,    -1,    -1,  4167,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4182,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
     336,    -1,    -1,    -1,    -1,    -1,    -1,   343,    -1,    -1,
     346,    -1,  4211,    -1,    -1,    -1,    -1,    -1,    -1,   180,
      -1,    -1,    -1,    -1,   185,    -1,  4225,    -1,    -1,    -1,
      -1,    -1,  4231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     376,  4240,    -1,    -1,    -1,   206,   207,   383,    -1,    -1,
      -1,    -1,    -1,    -1,   390,    -1,  4255,    -1,    -1,    -1,
     221,   397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4268,
      -1,  4270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4300,    -1,   180,    -1,    -1,    -1,   268,   185,     8,
     271,    -1,    11,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
     207,    -1,    -1,    32,    -1,    -1,    -1,  4336,    -1,    -1,
      -1,    40,    -1,    -1,   221,    -1,  4345,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4362,  4363,    -1,    -1,  4366,    -1,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,   254,    -1,    -1,
      -1,    -1,  4381,    -1,    -1,  4384,    -1,    -1,    -1,  4388,
      -1,   268,    -1,   354,  4393,    -1,    -1,  4396,  4397,    -1,
    4399,    -1,  4401,    -1,    -1,  4404,  4405,    -1,    -1,    -1,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    -1,    -1,
      22,    -1,    19,  4422,    21,  4424,    28,    -1,    -1,    -1,
      27,    -1,    29,    -1,    -1,    -1,  4435,  4436,  4437,  4438,
    4439,    -1,    -1,   574,    -1,    -1,    -1,   578,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   592,    -1,    -1,    -1,    -1,    -1,    69,   599,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,   354,    15,    16,
      17,   180,    -1,    -1,  4483,  4484,   185,    -1,    -1,   450,
      -1,    -1,   453,   454,   455,    32,   457,   458,   459,   460,
     461,   462,    -1,    40,    -1,    -1,   467,   206,   207,    -1,
      47,     8,    -1,    -1,    11,    -1,    -1,   119,    15,    16,
      17,   123,   221,    -1,    -1,    -1,  4525,    -1,   130,  4528,
      -1,   133,    -1,    -1,    71,    32,    -1,    -1,    -1,    -1,
      -1,  4540,    -1,    40,  4543,    -1,    -1,    -1,    35,  4548,
      47,  4550,    -1,    -1,    -1,   254,   158,    -1,  4557,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,   268,
      -1,    -1,   271,   450,    71,  4574,   453,   454,   455,  4578,
     457,   458,   459,   460,   461,   462,    -1,    -1,   190,    -1,
      -1,    -1,    -1,  4592,  4593,  4594,    -1,    -1,   195,    -1,
      -1,    -1,    89,    -1,    -1,    -1,   203,    -1,   205,    -1,
     207,   208,    -1,   210,    -1,   212,    -1,    -1,   215,    -1,
     217,  4620,    -1,    -1,  4623,    -1,  4625,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   180,    -1,    -1,  4645,   249,   185,   251,
      -1,    -1,  4651,    -1,    -1,   354,  4655,    -1,    -1,   261,
    4659,   148,    -1,    -1,    -1,    -1,    -1,  4666,   270,   206,
     207,    -1,    -1,    -1,    -1,    -1,  4675,    -1,    -1,   281,
      22,    -1,    -1,   180,   221,    -1,    28,    -1,   185,    -1,
      -1,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,    41,
    4699,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,   318,   254,    -1,   321,
     322,    -1,    -1,    -1,   221,   212,  4725,    69,    -1,    -1,
     217,   268,   863,   864,   271,  4734,  4735,  4736,  4737,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   349,    -1,    -1,
      -1,   450,    -1,    -1,   453,   454,   455,   254,   457,   458,
     459,   460,   461,   462,   251,    -1,    -1,    -1,   467,    -1,
      -1,   268,    -1,  4772,   271,    -1,    -1,    -1,    -1,   121,
      -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,
      -1,   133,    -1,    -1,  4793,   282,    -1,  4796,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,   413,    15,    16,    17,    -1,   158,   354,    -1,    -1,
      -1,   952,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    40,    -1,   326,
      -1,    -1,    -1,    -1,    47,    -1,   333,    -1,   190,    -1,
     981,   982,    -1,  4852,   341,    -1,  4855,   354,    -1,  4858,
      -1,    -1,   349,  4862,    -1,    -1,    -1,    -1,    71,    -1,
    4869,    -1,    -1,    -1,   361,  4874,  1007,  4876,    -1,  4878,
      -1,    -1,   369,    -1,    -1,    -1,    -1,  4886,    -1,    -1,
      -1,    -1,    -1,  4892,    -1,  4894,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   390,    -1,  4904,    -1,   249,    -1,   251,
      -1,    -1,    -1,   450,    -1,    -1,   453,   454,   455,   261,
     457,   458,   459,   460,   461,   462,    -1,    -1,   270,    -1,
     467,    -1,    -1,    -1,    -1,    -1,    -1,   424,    -1,   281,
      -1,   428,    -1,    -1,    -1,    -1,    -1,  4946,  4947,  1080,
    1081,    -1,    -1,   450,    -1,    -1,   453,   454,   455,    -1,
     457,   458,   459,   460,   461,   462,    -1,    -1,    -1,    -1,
     467,    -1,    -1,    -1,    -1,   572,   318,   180,  4977,   321,
     322,    -1,   185,   580,    -1,  4984,    -1,    -1,    -1,  4988,
     587,   588,    -1,    -1,   591,    -1,   593,   594,  4997,    -1,
      -1,   598,    -1,   206,   207,    -1,    -1,   349,    -1,    -1,
      -1,    -1,   609,    -1,    -1,    -1,    -1,    -1,   221,    -1,
      -1,    -1,    -1,  5022,  5023,    -1,    -1,   624,  5027,    -1,
      -1,  5030,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5040,    -1,    -1,  5043,    -1,    -1,    -1,    -1,  5048,
     647,   254,   649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   659,  5062,    -1,   268,    -1,    -1,   271,    -1,
      -1,   413,    -1,    -1,    -1,    -1,    -1,  5076,    -1,    -1,
      -1,    -1,    -1,    -1,  5083,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   691,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5108,
      -1,    -1,    -1,    -1,  5113,     8,    -1,    -1,    11,    -1,
    5119,    -1,    15,    16,    17,   722,    -1,    -1,    -1,  5128,
      -1,    -1,    -1,    -1,    -1,  5134,  5135,  5136,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,  5145,    40,    -1,    -1,
    5149,   354,    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   629,  5162,    -1,    -1,    -1,    -1,    -1,    -1,
    5169,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,   776,
      -1,     8,    -1,    -1,    11,    -1,   653,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5200,  5201,  5202,    -1,    32,    -1,    -1,    -1,     8,
      -1,    -1,    11,    40,    -1,    -1,    15,    16,    17,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5227,  5228,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,
     837,    40,    -1,    -1,    71,    -1,    -1,   450,    47,    -1,
     453,   454,   455,    -1,   457,   458,   459,   460,   461,   462,
      -1,    -1,    -1,    -1,   467,    -1,    -1,    -1,    -1,    -1,
    5269,    -1,    71,    -1,    -1,    -1,  5275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,    -1,    -1,
    5289,    -1,   185,    -1,    -1,    -1,    -1,  5296,    -1,    -1,
    5299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     907,    -1,  1443,   206,   207,    -1,    -1,    -1,  5317,  5318,
      -1,    -1,    -1,    -1,    -1,    -1,   923,    -1,   221,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   935,    -1,
      -1,   938,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   948,    -1,   180,    -1,    -1,   953,    -1,   185,    -1,
      -1,   254,    -1,    -1,   961,    -1,    -1,    -1,    -1,    -1,
     967,    -1,    -1,   970,    -1,   268,    -1,    -1,   271,   206,
     207,   180,    -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1533,  1534,  1535,  1536,    -1,   206,   207,    -1,
      -1,     8,    -1,  1010,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,   221,    -1,    -1,    -1,    -1,   254,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,   268,    -1,    40,   271,  1576,  1577,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,   926,
      -1,   354,    -1,    -1,    -1,    -1,  1597,    -1,    -1,   268,
      -1,    -1,   271,    -1,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   964,    -1,    -1,
      -1,  1632,  1633,  1634,  1635,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1121,    -1,  1123,   354,  1125,    -1,
    1127,    -1,  1129,  1130,  1131,    -1,    -1,    -1,    -1,  1136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1147,    -1,    -1,    -1,    -1,   354,    -1,   450,    -1,    -1,
     453,   454,   455,    -1,   457,   458,   459,   460,   461,   462,
      -1,    -1,    -1,    -1,   467,    -1,    -1,    -1,    -1,    -1,
      -1,  1048,    -1,   180,    35,    -1,    -1,    -1,   185,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,   206,
     207,    -1,    -1,    -1,  1745,    -1,    -1,    -1,    -1,    -1,
    1751,    -1,    -1,   450,   221,    -1,   453,   454,   455,    -1,
     457,   458,   459,   460,   461,   462,    -1,    -1,    89,    -1,
     467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   450,    -1,    -1,   453,   454,   455,   254,   457,   458,
     459,   460,   461,   462,    -1,    -1,    -1,    22,   467,    -1,
      -1,   268,    -1,    28,   271,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,    -1,  1153,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1325,    -1,
      -1,   182,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,  1878,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    32,
      -1,   212,    -1,    -1,    -1,    -1,   217,    40,   123,    -1,
      -1,    -1,    -1,     8,    47,   130,    11,    -1,   133,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    71,    -1,
     251,    -1,    -1,   158,  1401,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    47,     8,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,  1294,    -1,    -1,
      -1,   282,   187,    -1,    -1,   190,    71,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    47,   450,    -1,    -1,   453,   454,   455,    -1,
     457,   458,   459,   460,   461,   462,    -1,    -1,    -1,    -1,
     467,   322,  1469,    -1,    -1,   326,    71,    -1,    -1,    -1,
     235,    -1,   333,   238,    -1,    -1,    -1,    -1,    -1,    -1,
     341,    -1,  1359,    -1,   249,    -1,   251,    -1,   349,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   261,   180,    -1,    -1,
     361,    -1,   185,    -1,    -1,   270,    -1,    -1,   369,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,   206,   207,    -1,    -1,    -1,    -1,   390,
      -1,    -1,    -1,    -1,    -1,   180,    -1,    -1,   221,    -1,
     185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1425,    -1,
      -1,    -1,    -1,   318,    -1,    -1,   321,   322,   323,    -1,
      -1,   206,   207,   424,    -1,    -1,    -1,   428,    -1,    -1,
      -1,   254,    -1,    -1,    -1,   180,   221,    -1,   343,    -1,
     185,    -1,    -1,    -1,   349,   268,    -1,  1464,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,
    1607,   206,   207,    -1,    -1,    -1,    -1,    -1,    -1,   254,
    1487,    -1,    -1,  2154,  2155,    -1,   221,    -1,    -1,    -1,
      -1,    -1,  2163,   268,  2165,    -1,   271,    -1,  2169,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,   254,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   268,    -1,     8,   271,    -1,    11,    -1,
      -1,   354,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
    1567,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,     8,
      -1,    -1,    11,    -1,    47,  1582,    15,    16,    17,   354,
      -1,    -1,    -1,    -1,  1591,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1729,    32,  1731,    -1,  1603,    -1,    71,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,
      -1,  1748,    -1,  1750,    -1,    -1,    -1,  2288,    -1,   354,
    2291,    -1,    -1,    -1,    -1,    -1,    -1,  1764,    -1,  1766,
      -1,  1768,    71,  1770,    -1,  1772,    -1,   450,    -1,  1776,
     453,   454,   455,    -1,   457,   458,   459,   460,   461,   462,
      -1,  1658,    -1,    -1,   467,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1672,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,    -1,  1684,   453,   454,
     455,    -1,   457,   458,   459,   460,   461,   462,  2359,  1696,
      -1,    -1,   467,    -1,    -1,    -1,  2367,  2368,    -1,    -1,
      -1,    -1,    -1,  2374,    -1,    -1,    -1,   180,    -1,    -1,
      22,    -1,   185,    -1,    -1,   450,    28,  2388,   453,   454,
     455,    -1,   457,   458,   459,   460,   461,   462,    -1,  1736,
    1737,    -1,   467,   206,   207,    -1,    -1,    -1,    -1,    -1,
      -1,   180,    -1,    -1,    -1,    -1,   185,    -1,   221,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,  2429,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,   207,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,   254,   221,    11,    -1,    -1,  2457,    15,    16,    17,
      -1,    -1,    -1,    -1,    -1,   268,    -1,    -1,   271,    -1,
      -1,    -1,    -1,    55,    32,    -1,    -1,    -1,    -1,    -1,
      -1,   123,    40,    -1,    -1,   254,    -1,    -1,   130,    47,
      -1,   133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,
      -1,    -1,   271,    -1,    -1,    -1,    -1,    89,    -1,    -1,
    2511,    -1,  2513,    71,    -1,    -1,   158,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1870,    -1,    -1,    -1,   119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   190,    -1,
      -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,   251,
      -1,    -1,  2613,    -1,    -1,    -1,    -1,  2084,  2085,   261,
      -1,    -1,   180,    -1,    -1,    -1,    -1,   185,   270,    -1,
      -1,    -1,    -1,    -1,    -1,   217,  2103,  2104,    -1,   281,
      -1,  2108,  2109,    -1,    -1,    -1,  2113,   450,   206,   207,
     453,   454,   455,    -1,   457,   458,   459,   460,   461,   462,
    2127,    -1,    -1,   221,   467,    -1,    -1,  2134,    -1,   251,
      -1,  2138,  2139,    -1,    -1,  2142,  2143,    -1,    -1,   321,
     322,   450,  2149,    -1,   453,   454,   455,    -1,   457,   458,
     459,   460,   461,   462,    -1,  2162,   254,  2164,   467,   281,
     282,    -1,    -1,    -1,    -1,    -1,    -1,   349,    -1,    -1,
     268,    -1,    -1,   271,    -1,    -1,  2183,    -1,    -1,    -1,
      -1,  2188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2201,    -1,   318,    -1,    -1,    -1,
     322,    -1,    -1,  2210,   326,  2212,    -1,    -1,  2215,  2216,
    2217,   333,    -1,  2090,    -1,  2222,  2223,  2094,  2095,   341,
      -1,    -1,    -1,    -1,    -1,  2232,    -1,   349,    -1,     8,
    2237,   413,    11,    -1,    -1,  2242,    15,    16,    17,   361,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   369,    -1,    -1,
      -1,  2258,    -1,    32,    -1,    -1,   354,    36,    -1,  2266,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,
    2277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2156,
      -1,    -1,  2289,    -1,    -1,  2292,    -1,    -1,    -1,    -1,
    2297,  2168,    71,    -1,    -1,  2302,  2303,    -1,    -1,    -1,
    2307,    -1,   424,  2310,    -1,    -1,    -1,  2314,  2315,  2316,
    2317,    -1,  2319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2332,  2333,    -1,  2335,    -1,
      -1,  2208,    -1,    -1,    -1,    -1,    -1,    -1,  2345,  2346,
      -1,   120,    -1,    -1,    -1,    -1,    -1,  2888,    -1,  2890,
    2891,  2892,   450,    -1,    -1,   453,   454,   455,    -1,   457,
     458,   459,   460,   461,   462,    -1,    -1,   465,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2397,    -1,    -1,    -1,    32,    -1,    -1,    -1,    22,    -1,
      -1,   180,    40,    -1,    28,     8,   185,    -1,    11,    47,
      -1,    -1,    15,    16,    17,    -1,    -1,    41,  2425,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,   207,    32,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,   221,    -1,    47,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,
      -1,    -1,   271,    -1,    -1,    -1,    -1,   121,    -1,   123,
      -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,   133,
    2387,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   158,    -1,    -1,    -1,   199,    -1,
      -1,    -1,   180,    -1,    -1,    -1,    -1,   185,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,  3105,    -1,   190,    -1,   206,   207,
      -1,    -1,    -1,    -1,    -1,   354,    -1,   180,  2585,    -1,
      -1,     8,   185,   221,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,  2469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   206,   207,    32,    -1,  2614,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,   254,    -1,   221,    -1,
      47,    -1,    -1,    -1,    -1,   249,    -1,   251,    -1,    -1,
     268,   410,    -1,   271,    -1,    -1,    -1,   261,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,   270,    -1,    -1,    -1,
      -1,   254,    -1,    -1,    -1,    -1,    -1,   281,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   268,    -1,    -1,   271,    -1,
      -1,   450,    -1,    -1,   453,   454,   455,    -1,   457,   458,
     459,   460,   461,   462,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   294,    -1,    -1,   318,    -1,    -1,   321,   322,     8,
      -1,    -1,    11,  2580,    -1,    -1,    15,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,
    2597,    -1,    -1,    32,    -1,   349,    35,    -1,    -1,   156,
      -1,    40,  3273,  2610,    -1,    -1,    -1,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,   180,    -1,    -1,    -1,    -1,   185,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,   370,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,
      -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   450,    -1,    -1,   453,   454,   455,    -1,   457,
     458,   459,   460,   461,   462,    -1,    -1,   254,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   268,    -1,    -1,   271,    -1,    -1,   450,    -1,    -1,
     453,   454,   455,    -1,   457,   458,   459,   460,   461,   462,
      -1,    -1,    -1,    -1,    -1,   292,    -1,    -1,    -1,  2876,
      -1,   180,    -1,  2880,    -1,    -1,   185,    -1,    -1,  2886,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2902,  2903,   206,   207,    -1,
    2907,    -1,   563,    -1,    -1,  2912,  2913,  2914,   569,  2916,
      -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,
    2937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2947,  2948,  2949,  2950,    -1,   254,  2823,    -1,    -1,  2826,
      -1,  2828,    -1,    -1,    -1,    -1,  2833,    -1,    -1,   268,
      -1,     8,   271,    -1,    11,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,  2984,    -1,    -1,
    2987,  2988,  2989,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      47,  3542,  3543,  3544,  3545,  2882,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2899,   450,    71,    -1,   453,   454,   455,    -1,
     457,   458,   459,   460,   461,   462,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,  2924,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     721,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3089,    -1,    -1,   746,    -1,    -1,    -1,    -1,
    3097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   765,    -1,    -1,    -1,  3115,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2993,    -1,  2995,    -1,
      -1,    -1,    -1,    -1,    22,   786,    -1,    -1,    -1,    -1,
      28,    -1,    -1,   180,    -1,  3142,    -1,    35,   185,    -1,
      -1,   450,    -1,    -1,   453,   454,   455,    -1,   457,   458,
     459,   460,   461,   462,    -1,    -1,    54,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    -1,   221,    -1,    -1,    -1,    -1,  3720,
      -1,    -1,    -1,    -1,    -1,  3726,    -1,  3194,    -1,    -1,
      -1,    -1,  3199,    -1,    -1,    -1,    -1,   858,    -1,  3076,
      -1,    -1,    -1,    -1,    -1,   103,    -1,   254,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   268,  3229,    -1,   271,   123,    -1,  3104,    -1,    -1,
      -1,    -1,   130,    -1,    -1,   133,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3135,  3266,
     158,  3268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,
      -1,    -1,   190,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    15,    16,    17,   354,    -1,    -1,
      -1,    -1,    -1,   974,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,    -1,   188,    35,    -1,    -1,  3204,    -1,    40,
      -1,    -1,   197,   198,    -1,    -1,    47,   235,    -1,    -1,
     238,   206,  1003,  1004,  1005,  3222,    -1,    -1,    -1,    -1,
      -1,   249,    -1,   251,   219,    -1,    -1,    -1,  3235,    -1,
      71,    -1,    -1,   261,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   280,   281,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   450,    -1,    -1,   453,   454,   455,    -1,
     457,   458,   459,   460,   461,   462,    -1,    -1,    -1,    -1,
     318,    -1,    -1,   321,   322,   323,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   343,    -1,    -1,    -1,    -1,
      -1,   349,    -1,    -1,  3331,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   363,    -1,    -1,    -1,   180,
      -1,    -1,    -1,    -1,   185,  3352,    -1,    -1,    -1,    -1,
      -1,    -1,  1143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   206,   207,    -1,    -1,    -1,
    3377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1169,    -1,
     221,    -1,    -1,    -1,    -1,   413,    -1,    -1,    -1,    -1,
      -1,  3528,    -1,  3530,    -1,    -1,    -1,    -1,    -1,    -1,
    3537,    -1,    -1,    -1,  3411,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   254,    -1,    -1,  3553,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,     8,    -1,
     271,    11,  3569,    -1,    -1,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3587,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    -1,    -1,    -1,    -1,    -1,    -1,    47,  3605,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3615,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    -1,    -1,    -1,  4167,  3634,    -1,    -1,
      -1,    -1,  3509,    -1,    -1,    -1,    -1,    -1,  3645,  3646,
    3647,  4182,    -1,   354,  1305,  3652,  3653,  3654,  3655,    -1,
      -1,  3658,  3659,    -1,    -1,    -1,    -1,  3664,  3665,    -1,
    3667,  3668,  3669,  3670,  3671,  3672,    22,  3674,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,  3683,    -1,    -1,  3686,
    3687,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1352,    -1,    -1,    -1,    -1,    -1,    -1,  3705,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   571,    -1,    -1,    -1,
      -1,    -1,   162,    69,    -1,    -1,    -1,    -1,   583,    -1,
    3727,    -1,    -1,    -1,   589,    -1,    -1,  4268,    -1,    -1,
     180,  3608,    -1,    -1,    -1,   185,    -1,   602,    -1,   450,
      -1,    -1,   453,   454,   455,    -1,   457,   458,   459,   460,
     461,   462,    -1,   618,    -1,  3632,   206,   207,   623,    -1,
      -1,    -1,    -1,   119,   629,    -1,    -1,   123,   633,   634,
    1431,   221,    -1,    -1,   130,    -1,   641,   133,    -1,  1440,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   653,   654,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   664,
      -1,    22,   158,    -1,   254,    -1,    -1,    28,    -1,  1470,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,  3826,
       8,   271,  1483,    11,    -1,  1486,    -1,    15,    16,    17,
      -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    35,    69,    -1,
      -1,  3858,    40,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1537,    -1,   743,   744,
    3757,    -1,    -1,    71,   749,    -1,    -1,    -1,    -1,    -1,
    1551,    -1,    -1,   249,    -1,   251,  4437,  4438,  4439,    -1,
      -1,    -1,   123,  1564,   354,   261,    -1,    -1,    -1,   130,
     775,    -1,   133,    -1,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   281,    -1,    -1,    -1,    -1,
    3807,    -1,    -1,    -1,    -1,    -1,    22,   158,    -1,    -1,
      -1,    -1,    28,     8,    -1,    -1,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,  1616,    -1,    -1,    -1,    -1,
      -1,    -1,   318,    -1,    -1,   321,   322,    32,    -1,   190,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    69,  1645,    -1,    -1,    -1,    -1,    -1,
      -1,  1652,   180,   349,    -1,    -1,    -1,   185,    -1,    -1,
     450,    -1,    -1,   453,   454,   455,    71,   457,   458,   459,
     460,   461,   462,    -1,    -1,    -1,    -1,    -1,   206,   207,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,
     251,    -1,    -1,   221,    -1,    -1,    -1,   123,    -1,    -1,
     261,    -1,    -1,    -1,   130,    -1,    -1,   133,    -1,   270,
      -1,  4592,  3929,    -1,   919,    -1,    -1,   413,    -1,    -1,
     281,   926,  3939,    -1,  4071,   930,   254,    -1,  4075,  4076,
    4077,  4078,   158,    -1,  4081,    -1,    -1,    -1,    -1,    -1,
     268,    -1,    -1,   271,   949,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1753,    -1,    -1,    -1,    -1,   318,    -1,   964,
     321,   322,    -1,    -1,   190,  4112,  4113,  4114,    -1,  4116,
      -1,  4118,  4119,    -1,    -1,   180,    -1,    -1,    -1,    -1,
     185,    -1,    -1,  4130,  4131,    -1,    -1,    -1,   349,    -1,
    1791,  1792,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   206,   207,    -1,  1009,    -1,    -1,  1808,    -1,    -1,
    4157,    -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,
      -1,    -1,    -1,   249,    -1,   251,   354,    -1,    -1,    -1,
      -1,    -1,    -1,  4180,    -1,   261,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1048,   270,    -1,  4063,    -1,    -1,   254,
      -1,    -1,   413,    -1,  4735,   281,  4737,    -1,    -1,    -1,
      -1,    -1,    -1,   268,    -1,    -1,   271,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1085,    -1,    -1,    -1,  4101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   318,    -1,  1099,   321,   322,    -1,    -1,    -1,
      -1,    -1,    -1,  1108,  1905,  4122,    -1,  4254,    -1,    -1,
      -1,  1116,    25,    -1,  1915,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   450,   349,    -1,   453,   454,   455,    -1,   457,
     458,   459,   460,   461,   462,    -1,  4283,    -1,    -1,  1144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1153,   354,
    1155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,
      -1,  4308,    -1,    -1,    -1,  1170,    -1,    -1,  1173,    -1,
    4187,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,   384,
    1185,     8,    -1,    -1,    11,    -1,    -1,   413,    15,    16,
      17,    -1,   105,    -1,    -1,    -1,    -1,    -1,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    35,    -1,
    1215,  4892,    -1,    40,    -1,   128,    -1,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,
      -1,  2032,    -1,  2034,   147,    -1,    -1,    -1,  1243,  1244,
    1245,    -1,  1247,    -1,    71,   450,   159,    -1,   453,   454,
     455,   164,   457,   458,   459,   460,   461,   462,   171,    -1,
      -1,    -1,  1267,    -1,    -1,    -1,    -1,    -1,  4415,    -1,
      -1,  2072,    -1,    -1,    -1,   188,    -1,    -1,    -1,    -1,
      -1,  4298,    -1,    -1,    -1,    -1,  1291,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1299,  1300,  4977,    -1,    -1,    -1,
     213,    -1,    -1,  1308,  1309,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    -1,    -1,
      -1,   234,    -1,  4340,    -1,    -1,    -1,    -1,  4475,    -1,
      32,  1336,    -1,    -1,    -1,  1340,  1341,    -1,    40,    -1,
      -1,    -1,    -1,    -1,    -1,    47,  4493,    -1,    -1,    -1,
    1355,  4498,  4499,   180,  1359,   268,    -1,    -1,   185,    -1,
      -1,  1366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,   300,    -1,    -1,
     303,    -1,    -1,    -1,   221,  5076,    -1,    -1,    -1,    -1,
      -1,    -1,  4549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   329,    -1,    -1,    -1,
    1425,   334,  4569,   336,  4571,    -1,  2227,   254,    -1,    -1,
     343,    -1,    -1,   346,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   268,    -1,    -1,   271,    -1,    -1,  2248,    -1,    -1,
      -1,    -1,   365,    -1,    -1,    -1,  4473,    -1,   371,  1464,
    4607,    -1,   375,   376,    -1,    -1,   379,  4614,    -1,    -1,
     383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,   392,
      -1,    -1,  1487,   185,   397,    -1,    -1,    -1,  5169,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   206,   207,    -1,    -1,    -1,   422,
      -1,  2312,  2313,    -1,    -1,    -1,    -1,    -1,    -1,   221,
    5201,  5202,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4682,    -1,    -1,    -1,    -1,
      -1,    -1,  1547,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   254,    -1,    -1,    -1,  4703,    -1,    -1,    -1,
      -1,    -1,  1567,    -1,    -1,    -1,   268,  4714,    -1,   271,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1582,    -1,  4596,
      -1,    -1,    -1,    -1,    -1,    -1,  1591,    -1,    -1,    -1,
      -1,    -1,    -1,  1598,    -1,    -1,    -1,    -1,  1603,    -1,
      -1,    -1,    -1,    -1,  4621,    -1,  2407,    -1,  5289,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1622,    -1,    -1,
      -1,    -1,    -1,   450,    -1,  1630,   453,   454,   455,  4776,
     457,   458,   459,   460,   461,   462,    -1,  1642,    -1,    -1,
      -1,    -1,    -1,    -1,  4661,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   354,  1658,    -1,    -1,    -1,    -1,    -1,    -1,
    1665,    -1,    -1,  1668,    -1,    -1,    -1,  1672,    -1,    -1,
      -1,    -1,    -1,  1678,    -1,    -1,    -1,    -1,    22,  1684,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,
      -1,  1696,  4839,    -1,    -1,    -1,    -1,    -1,  4715,    -1,
      -1,    -1,    -1,  4720,  4721,    -1,    -1,    -1,  1713,  1714,
      -1,  1716,  1717,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1728,    -1,    69,    -1,    -1,    -1,    -1,
      -1,  1736,  1737,    -1,  1739,  1740,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,    -1,
    1755,   453,   454,   455,  4901,   457,   458,   459,   460,   461,
     462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4916,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   123,
      -1,    -1,  1787,  2584,    -1,    -1,   130,    -1,    -1,   133,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   158,  4832,  1821,    -1,  1823,    -1,
    4967,    -1,    -1,  1828,  1829,    -1,    -1,    -1,    -1,    -1,
    1835,  1836,  1837,    -1,    -1,  4982,  1841,    -1,  1843,  1844,
    1845,  1846,  1847,  1848,    -1,  1850,   190,  1852,  1853,    -1,
      -1,  1856,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,  1870,  1871,  1872,  1873,  1874,
    1875,    -1,    -1,    37,  1879,    -1,    -1,    -1,  1883,    -1,
      -1,  1886,    -1,    -1,  1889,  1890,  1891,  1892,  1893,  1894,
    1895,  1896,  1897,    -1,  1899,    59,    -1,    -1,    -1,    -1,
      -1,  1906,    -1,  1908,    -1,   249,    -1,   251,    72,    -1,
      -1,    -1,    -1,    -1,  5061,    -1,    -1,   261,    -1,    83,
      -1,    -1,    -1,    87,    -1,    -1,   270,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2737,   281,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,    -1,   111,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,  5103,    28,    -1,    -1,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   318,   139,    -1,   321,   322,    -1,
      -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   159,    -1,    -1,    69,    -1,
      -1,    -1,    -1,   167,    -1,   349,    -1,   171,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5034,    -1,    -1,
      -1,    -1,    -1,    -1,   188,    -1,    -1,    -1,    -1,    -1,
      -1,  2036,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5188,    -1,    -1,  2049,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   123,  2058,  2059,    -1,    -1,    -1,    -1,   130,
      -1,   225,   133,    -1,    -1,    -1,    -1,    -1,    -1,   413,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2083,    -1,
      -1,    -1,    -1,    -1,    -1,  2090,    -1,   158,    -1,  2094,
    2095,    -1,    -1,    -1,    -1,    -1,  2101,    -1,    -1,    -1,
      -1,  2106,  2107,    -1,   268,    -1,  2111,   271,    -1,    -1,
      -1,    -1,    22,    -1,  2119,    -1,    -1,    -1,    28,   190,
      -1,    -1,    -1,    -1,    -1,    -1,   290,    -1,    -1,    -1,
      -1,    -1,  2137,    -1,    -1,  2140,    -1,    -1,    -1,   303,
      -1,    -1,    -1,    -1,    -1,    -1,   310,  2152,    -1,    -1,
      -1,  2156,    -1,    -1,  2159,    -1,    -1,    -1,    -1,    69,
      -1,    -1,    -1,  2168,    -1,   329,    -1,    -1,    -1,    -1,
      -1,    -1,   336,    -1,    -1,    -1,  2181,    -1,   249,   343,
     251,    -1,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     261,    -1,    -1,    -1,  2199,  2200,    -1,    -1,    -1,   270,
    3001,   365,    -1,  2208,    -1,    -1,    -1,   371,    -1,    -1,
     281,    -1,   376,   123,    -1,   379,   380,    -1,   382,   383,
     130,    -1,    -1,   133,    -1,  2230,  2231,    -1,   392,  2234,
      -1,    -1,    -1,   397,    -1,    -1,    -1,    -1,    -1,   403,
      -1,    -1,   406,    -1,    -1,   409,    -1,   318,   158,    -1,
     321,   322,  2257,    -1,  2259,    -1,    -1,    -1,   422,    -1,
    2265,    -1,    -1,    -1,    -1,    -1,    -1,  2272,    -1,    -1,
      -1,  2276,    -1,    -1,    -1,    -1,    -1,    -1,   349,    -1,
     190,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,
      -1,  2296,    -1,    28,    -1,    -1,  2301,    -1,    -1,    -1,
    2305,    -1,    -1,  2308,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2331,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,  2341,    -1,    -1,   249,
      -1,   251,   413,    -1,    -1,    -1,  3147,  3148,  3149,    -1,
      -1,   261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     270,    -1,    -1,  3164,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2386,  2387,    -1,    -1,    -1,  3187,    -1,   123,    -1,
      -1,  2396,    -1,    -1,    -1,   130,  3197,  3198,   133,    -1,
      -1,  3202,    -1,    -1,    -1,    -1,    -1,    -1,   318,    -1,
      -1,   321,   322,    -1,  3215,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   158,    -1,  2430,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   349,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    -1,    -1,   190,    -1,    25,    -1,    -1,
      -1,    -1,    -1,    -1,  2469,    -1,    -1,    -1,  2473,    37,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2482,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   413,    72,    -1,    -1,  3308,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,   251,    -1,    -1,    87,
      -1,  2526,    -1,    -1,    -1,    -1,   261,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   270,    -1,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2564,
     128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   139,    -1,    -1,    -1,  2580,    -1,  2582,    -1,   147,
      -1,    -1,    -1,   318,    -1,  2590,   321,   322,    -1,  2594,
      -1,   159,  2597,    -1,    -1,  2600,   164,    -1,    -1,    -1,
      -1,    -1,    -1,   171,    -1,  2610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   349,    -1,  2621,    -1,    -1,    -1,
     188,  2626,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3434,  3435,  3436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2649,  2650,  2651,    -1,    -1,  2654,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2662,  2663,  2664,
    2665,    -1,    -1,    -1,    -1,  2670,   234,    -1,    -1,    -1,
    2675,  2676,    -1,  2678,    -1,  2680,    -1,    -1,   413,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2691,  2692,    -1,    -1,
    2695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     268,    -1,    -1,    -1,  2709,    -1,  2711,    -1,  2713,    -1,
      -1,    -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,  2733,    -1,
      -1,    -1,   300,    -1,    -1,   303,    -1,    -1,    -1,  2744,
      -1,  2746,  2747,  2748,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2761,    -1,    -1,  2764,
      -1,   329,    -1,    -1,    -1,    -1,   334,    -1,   336,    -1,
    2775,    -1,    -1,    -1,    -1,   343,    -1,    -1,   346,    -1,
      -1,    -1,    -1,    -1,    -1,  2790,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   365,    -1,  2804,
      -1,    -1,    -1,   371,    -1,    -1,    -1,    -1,   376,    -1,
      -1,   379,    -1,    -1,    -1,   383,    -1,    -1,  2823,    -1,
      -1,  2826,   390,  2828,   392,    -1,    -1,    -1,  2833,   397,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   409,    -1,  2848,  2849,    -1,    -1,    -1,    -1,  2854,
      -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2875,    -1,    -1,  2878,    -1,    -1,    -1,  2882,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2899,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2924,
      -1,    -1,    -1,  3724,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3735,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2959,  2960,  2961,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3766,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2983,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2993,    -1,
    2995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3003,  3800,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3018,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3846,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3096,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3127,    -1,    -1,    -1,    -1,    -1,    -1,  3134,
    3135,    -1,    -1,    -1,    -1,    -1,  3141,    -1,  3143,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3156,    -1,  3158,    -1,    -1,    -1,  3958,  3959,  3960,
    3961,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3180,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3221,  3222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3269,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3307,    -1,    -1,  3310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3328,    -1,    -1,  3331,    -1,    -1,    -1,
      -1,    -1,  3337,    -1,    -1,    -1,    -1,    -1,  3343,    -1,
    3345,    -1,    -1,  3348,    -1,    -1,    -1,  3352,  3353,  3354,
    3355,  3356,    -1,    -1,  3359,  3360,  3361,  3362,  3363,  3364,
    3365,  3366,  3367,  3368,    -1,    -1,    -1,  3372,  3373,    -1,
      -1,    -1,  3377,    -1,    -1,    -1,    -1,  3382,    -1,    -1,
      -1,  3386,    -1,  3388,    -1,  3390,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3398,    -1,    -1,  3401,    -1,  3403,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3411,  3412,    -1,    -1,
    3415,  3416,    -1,    -1,    -1,  3420,  3421,    -1,    -1,    -1,
      -1,    -1,  3427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3437,    -1,    -1,  3440,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3453,    -1,
      -1,    -1,    -1,    -1,  3459,  3460,  3461,    -1,   197,   198,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     219,    -1,  3487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3503,  4300,
      -1,    -1,    -1,    -1,  3509,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3521,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3552,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3602,    -1,    -1,
      -1,    -1,  3607,  3608,  3609,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3631,  3632,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3648,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3663,    -1,
      -1,  3666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3728,    -1,    -1,    -1,  4528,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4543,    -1,    -1,    -1,    -1,  4548,  3753,  3754,
      -1,    -1,  3757,    -1,    -1,    -1,    -1,    -1,  3763,    -1,
      -1,    -1,    -1,    -1,    -1,  3770,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4574,    -1,    -1,    -1,  3782,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3807,  3808,  3809,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   583,    -1,    -1,    -1,    -1,  3854,
     589,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   602,    -1,    -1,    -1,    -1,    -1,    -1,
    3875,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   618,
      -1,  3886,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   633,   634,    -1,    -1,  4699,    -1,
      -1,    -1,   641,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3916,    -1,    -1,    -1,   654,    -1,    -1,    -1,    -1,
      -1,  3926,  3927,    -1,  3929,   664,    -1,    -1,  3933,  3934,
      -1,    -1,    -1,  3938,  3939,    -1,    -1,    -1,  3943,    -1,
      -1,  3946,  3947,    -1,    -1,    -1,  3951,    -1,    -1,    -1,
      -1,    -1,  3957,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3969,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3977,    -1,    -1,    -1,  3981,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3994,
      -1,    -1,  4793,    -1,  3999,    -1,    -1,    -1,    -1,    -1,
    4005,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     749,    -1,    -1,    -1,  4019,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4063,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4080,    -1,    -1,    -1,    -1,
    4085,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4101,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,  4117,    -1,    -1,    -1,    -1,  4122,   219,    -1,
      -1,    -1,    -1,    -1,  4129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4211,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4248,    -1,    -1,    -1,    -1,    -1,    -1,
    4255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4296,    -1,  4298,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4320,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4336,    -1,    -1,    -1,  4340,    -1,    -1,    -1,    -1,
    4345,    -1,    -1,    -1,    -1,    -1,  1085,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4362,  4363,    -1,
    1099,  4366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4381,  1116,    -1,    -1,
      -1,    -1,    -1,  4388,    -1,    -1,    -1,    -1,  4393,    -1,
      -1,  4396,  4397,    -1,    -1,    -1,    -1,    -1,    -1,  4404,
    4405,    -1,    -1,    -1,    -1,  1144,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1155,  4422,    -1,  4424,
      -1,    -1,    -1,    -1,  4429,    -1,  4431,    -1,    -1,    -1,
    4435,  1170,    -1,    -1,  1173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4473,  4474,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4483,    -1,
      -1,    -1,   583,    -1,    -1,    -1,    -1,    -1,   589,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   602,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4519,    -1,    -1,   618,    -1,    -1,
    4525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   634,    -1,    -1,    -1,    -1,    -1,    -1,
     641,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1291,   654,    -1,    -1,    -1,    -1,    -1,    -1,
    1299,  1300,    -1,   664,    -1,    -1,    -1,    -1,    -1,    -1,
    1309,    -1,    -1,    -1,    -1,    -1,  4581,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4594,
      -1,  4596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4620,  4621,    -1,  4623,    -1,
    4625,    -1,    -1,    -1,    -1,    -1,    -1,  1366,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4645,    -1,    -1,    -1,    -1,    -1,  4651,    -1,   749,    -1,
    4655,    -1,    -1,    -1,    -1,    -1,  4661,    -1,    -1,    -1,
      -1,  4666,    -1,    -1,    -1,   743,   744,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4715,    -1,    -1,    -1,    -1,  4720,  4721,    -1,    -1,    -1,
    4725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4743,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4772,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4796,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1547,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4831,  4832,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4852,    -1,    -1,
    4855,    -1,    -1,  4858,    -1,    -1,    -1,    -1,    -1,  1598,
      -1,    -1,    -1,    -1,  4869,    -1,    -1,    -1,    -1,  4874,
      -1,  4876,    -1,  4878,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4886,    -1,  1622,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1630,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4904,
      -1,    -1,    -1,  1642,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4936,   629,  4938,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   653,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1713,  1714,    -1,  1716,  1717,    -1,
      -1,    -1,    -1,  4988,  1085,    -1,    -1,    -1,    -1,  1728,
      -1,    -1,  4997,    -1,    -1,    -1,    -1,    -1,  1099,    -1,
    1739,  1740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1116,  1755,  5022,  5023,    -1,
      -1,    -1,    -1,    -1,    -1,  5030,  5031,    -1,    -1,  5034,
      -1,    -1,    -1,    -1,    -1,  5040,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1144,  5049,    -1,    -1,    -1,  1787,    -1,
      -1,    -1,    -1,    -1,  1155,    -1,    -1,  5062,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1170,
      -1,    -1,  1173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1185,  5113,    -1,
      -1,    -1,    -1,    -1,  5119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5128,    -1,    -1,    -1,    -1,    -1,  5134,
    5135,  5136,    -1,    -1,    -1,    -1,  1875,  1215,    -1,    -1,
    5145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5162,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1243,  1244,  1245,    -1,  1247,
      -1,  5176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1267,
    1291,    -1,    -1,    -1,    -1,  5200,    -1,    -1,  1299,  1300,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1309,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5227,  5228,    -1,    -1,    -1,    -1,    -1,   926,
    1308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5252,    -1,    -1,
      -1,    -1,   949,    -1,    -1,    -1,    -1,    -1,  1336,    -1,
      -1,    -1,  1340,  1341,  5269,  1366,    -1,   964,    -1,    -1,
    5275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5299,    -1,  5301,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5316,  5317,  5318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2083,    -1,    -1,    -1,    -1,    -1,
      -1,  1048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2101,    -1,    -1,    -1,    -1,  2106,  2107,    -1,
      -1,    -1,  2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2137,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2181,    -1,    -1,    -1,  1547,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1153,    -1,    -1,    -1,
    2199,  2200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2230,  2231,    -1,    -1,  2234,    -1,  1598,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2257,    -1,
    2259,  1622,    -1,    -1,    -1,    -1,  2265,    -1,    -1,  1630,
      -1,    -1,    -1,  2272,    -1,    -1,    -1,  2276,    -1,    -1,
      -1,  1642,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2296,    -1,    -1,
      -1,    -1,  2301,    -1,    -1,    -1,  2305,    -1,    -1,  2308,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2341,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1716,  1717,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1728,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1739,  1740,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1755,    -1,    -1,  2396,    -1,    -1,
      -1,    -1,  1359,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1425,    -1,
      -1,    -1,    -1,    -1,  2473,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1828,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1841,    -1,  1843,    -1,  1464,  1846,  1847,
    1848,    -1,    -1,    -1,  1875,  1853,    -1,    -1,  1856,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2526,    -1,    -1,
    1487,    -1,    -1,  1871,  1872,  1873,  1874,    -1,    -1,    -1,
      -1,  1879,    -1,    -1,    -1,  1883,    -1,    -1,  1886,    -1,
      -1,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
      -1,  1899,    -1,    -1,    -1,  2564,    -1,    -1,  1906,    -1,
    1908,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2582,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2590,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2600,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1582,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1591,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1603,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2670,    -1,    -1,    -1,    -1,    -1,  2676,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2036,    -1,
      -1,  1658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1672,    -1,    -1,    -1,    -1,
    2058,  2059,  2083,    -1,    -1,    -1,    -1,  1684,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1696,
    2101,    -1,    -1,    -1,    -1,  2106,  2107,    -1,    -1,    -1,
    2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2119,    -1,
      -1,    -1,  2761,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2137,    -1,    -1,  1736,
    1737,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2199,  2200,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2848,
    2849,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2230,
    2231,    -1,    -1,  2234,    -1,    -1,  2875,    -1,    -1,  2878,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2257,    -1,  2259,    -1,
      -1,    -1,    -1,    -1,  2265,    -1,    -1,    -1,    -1,    -1,
      -1,  2272,    -1,  1870,    -1,  2276,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2296,    -1,    -1,    -1,    -1,
    2301,    -1,    -1,    -1,  2305,    -1,    -1,  2308,    -1,    -1,
      -1,  1908,    -1,    -1,    -1,    -1,    -1,  2318,    -1,    -1,
    2959,  2960,  2961,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2341,    -1,    -1,    -1,  2983,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   629,  3003,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3018,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   653,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2396,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2386,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3096,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2090,    -1,  3134,    -1,  2094,  2095,    -1,
      -1,    -1,  3141,    -1,  3143,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3156,    -1,  3158,
      -1,    -1,    -1,    -1,    -1,  2526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2156,
      -1,    -1,    -1,  2564,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2582,  3221,    -1,    -1,    -1,    -1,    -1,    -1,  2590,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2621,    -1,    -1,  3285,    -1,  2626,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3307,  2670,
      -1,  3310,    -1,  2651,    -1,  2676,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   949,  2662,    -1,  2664,  2665,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2675,   964,    -1,
    2678,    -1,  2680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2709,    -1,  2711,    -1,  2713,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3388,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2761,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2746,  2747,
    2748,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1048,    -1,   629,    -1,  2764,    -1,    -1,    -1,
    2387,    -1,    -1,    -1,    -1,    -1,    -1,  2775,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   653,    -1,
      -1,    -1,  2790,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2848,  2849,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2469,    -1,  2875,    -1,  2854,  2878,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1153,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2959,  2960,
    2961,    -1,    -1,  3602,    -1,    -1,    -1,    -1,  3607,    -1,
    3609,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2983,  2580,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3631,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2597,    -1,  3003,    -1,    -1,    -1,    -1,    -1,    -1,  3648,
      -1,    -1,    -1,  2610,    -1,    -1,    -1,  3018,    -1,    -1,
      -1,    -1,    -1,    -1,  3663,    -1,    -1,  3666,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1359,    -1,  3096,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   949,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3753,  3754,    -1,    -1,    -1,   964,
      -1,    -1,    -1,    -1,  3763,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3134,    -1,    -1,    -1,    -1,    -1,    -1,
    3141,    -1,  3143,  3782,    -1,    -1,    -1,    -1,    -1,  2746,
    2747,  2748,    -1,    -1,    -1,  3156,    -1,  3158,    -1,  1425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   629,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3180,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   653,    -1,    -1,  1464,    -1,
      -1,    -1,    -1,  1048,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3854,    -1,    -1,    -1,    -1,
    3221,  1487,    -1,    -1,    -1,    -1,  2823,    -1,    -1,  2826,
      -1,  2828,    -1,    -1,    -1,    -1,  2833,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3269,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3285,  2882,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1567,  2899,    -1,    -1,    -1,  3307,    -1,  1153,  3310,
      -1,    -1,    -1,    -1,    -1,    -1,  1582,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1591,    -1,  2924,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1603,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3337,
      -1,    -1,    -1,    -1,    -1,  3343,    -1,  3345,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3388,    -1,    -1,
      -1,    -1,  1658,    -1,  3372,  3373,  2993,    -1,  2995,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1672,    -1,    -1,    -1,
      -1,    -1,  3390,    -1,    -1,    -1,    -1,    -1,  1684,    -1,
    3398,    -1,    -1,  3401,    -1,  3403,    -1,    -1,    -1,    -1,
    1696,    -1,    -1,    -1,  3412,    -1,    -1,    -1,    -1,    -1,
      -1,  4080,  3420,  3421,    -1,    -1,  4085,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   926,    -1,
    1736,  1737,    -1,    -1,    -1,  3453,    -1,    -1,  4117,  3076,
      -1,  3459,  3460,  3461,    -1,    -1,    -1,    -1,    -1,    -1,
    4129,   949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   964,  3104,    -1,  3487,
      -1,    -1,    -1,    -1,  1359,    -1,    -1,  4156,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3503,    -1,    -1,    -1,    -1,
    3127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3602,    -1,    -1,  1870,    -1,  3607,  3204,  3609,  4248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1464,
      -1,    -1,    -1,    -1,    -1,  3222,    -1,    -1,    -1,    -1,
    3631,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3235,    -1,
      -1,    -1,  1487,    -1,    -1,    -1,    -1,  3648,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3663,    -1,    -1,  3666,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1153,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3331,    -1,    -1,  1582,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1591,    -1,    -1,    -1,
      -1,    -1,  3753,  3754,    -1,  3352,    -1,    -1,  1603,    -1,
      -1,    -1,  3763,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3377,  3782,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4429,    -1,  4431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1658,  3411,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2090,    -1,    -1,  1672,  2094,  2095,
    3808,  3809,    -1,    -1,    -1,  4474,    -1,    -1,    -1,  1684,
      -1,    -1,    -1,    -1,  4483,    -1,    -1,    -1,    -1,    -1,
      -1,  1696,    -1,  3854,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3461,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4519,    -1,    -1,    -1,    -1,    -1,  4525,    -1,    -1,    -1,
    2156,  1736,  1737,    -1,    -1,    -1,    -1,  3875,    -1,    -1,
      -1,  1359,  2168,    -1,    -1,    -1,    -1,    -1,  3886,    -1,
      -1,    -1,  3509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2208,    -1,    -1,    -1,    -1,    -1,  3926,  3927,
      -1,    -1,    -1,    -1,    -1,  3933,  3934,    -1,    -1,    -1,
    3938,    -1,    -1,    -1,    -1,  3943,    -1,  1425,  3946,  3947,
      -1,    -1,    -1,  3951,    -1,    -1,    -1,    -1,    -1,  3957,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1464,    -1,    -1,    -1,
      -1,  3608,    -1,    -1,    -1,    -1,  3994,    -1,    -1,    -1,
      -1,  3999,    -1,   629,    -1,  1870,    -1,  4005,    -1,  1487,
      -1,    -1,    -1,    -1,    -1,  3632,    -1,    -1,    -1,    -1,
      -1,  4019,    -1,    -1,    -1,    -1,    -1,   653,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4045,  4707,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4080,
      -1,    -1,    -1,    -1,  4085,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4743,    -1,    -1,    -1,    -1,  1567,
      -1,    -1,    -1,    -1,    -1,    -1,  4117,    -1,    -1,    -1,
      -1,  2387,    -1,    -1,  1582,    -1,    -1,    -1,  4129,    -1,
      -1,    -1,    -1,  1591,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1603,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4156,    -1,    -1,    -1,    -1,
    3757,    -1,    -1,    -1,    -1,    -1,    -1,  4145,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1658,    -1,    -1,  2469,    -1,    -1,    -1,    -1,    -1,    -1,
    3807,    -1,    -1,    -1,  1672,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1684,    -1,    -1,    -1,
      -1,    -1,    -1,  4211,    -1,    -1,    -1,    -1,  1696,    -1,
      -1,    -1,    -1,    -1,    -1,  2090,    -1,  4248,    -1,  2094,
    2095,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1736,  1737,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4936,    -1,  4938,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2156,    -1,    -1,  2580,    -1,    -1,    -1,    -1,  4320,
     926,    -1,    -1,  2168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2597,  3929,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3939,   949,  2610,    -1,    -1,    -1,    -1,    -1,
      -1,   629,    -1,    -1,    -1,    -1,    -1,    -1,   964,    -1,
      -1,    -1,    -1,  2208,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   653,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4362,  4363,    -1,    -1,  4366,    -1,
      -1,    -1,  5031,    -1,    -1,    -1,    -1,  3994,    -1,    -1,
      -1,    -1,  3999,    -1,    -1,    -1,    -1,    -1,  4005,    -1,
    5049,    -1,  1870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5062,    -1,    -1,  4404,  4405,  4429,    -1,
    4431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1048,    -1,    -1,    -1,  4424,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4063,    -1,    -1,    -1,
      -1,    -1,    -1,  4474,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5134,  5135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4519,    -1,
      -1,    -1,    -1,    -1,    -1,  4122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5176,    -1,    -1,
      -1,    -1,  2387,    -1,    -1,    -1,    -1,  1153,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2823,    -1,    -1,
    2826,    -1,  2828,    -1,    -1,    -1,    -1,  2833,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5252,    -1,    -1,  2882,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2469,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2090,  2899,    -1,    -1,  2094,  2095,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4623,    -1,    -1,   926,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2924,    -1,
      -1,    -1,  5301,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   949,    -1,  4651,    -1,    -1,    -1,  5316,  5317,  5318,
      -1,    -1,    -1,    -1,    -1,    -1,   964,    -1,  4666,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2156,  4296,
      -1,  4298,    -1,    -1,    -1,    -1,  4707,    -1,    -1,    -1,
    2168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2993,    -1,  2995,
      -1,    -1,    -1,    -1,    -1,  2580,    -1,    -1,    -1,    -1,
      -1,    -1,  4743,  4340,    -1,    -1,    -1,  4725,    -1,    -1,
    2208,    -1,  2597,  1359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2610,    -1,    -1,    -1,    -1,
    1048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   629,    -1,    -1,    -1,    -1,    -1,    -1,  3104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   653,    -1,    -1,  1464,    -1,
      -1,  3127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3135,
      -1,    -1,    -1,    -1,    -1,  1153,  4473,    -1,    -1,    -1,
      -1,  1487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4878,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4904,    -1,    -1,  2387,
      -1,    -1,    -1,    -1,    -1,  4936,    -1,  4938,  3204,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3222,    -1,    -1,    -1,
      -1,  1567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3235,
      -1,    -1,    -1,    -1,    -1,    -1,  1582,    -1,  2823,    -1,
      -1,  2826,    -1,  2828,    -1,  1591,    -1,    -1,  2833,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1603,    -1,  4596,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4988,  2469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4621,    -1,    -1,    -1,    -1,    -1,
    5031,    -1,    -1,    -1,    -1,    -1,    -1,  2882,    -1,    -1,
      -1,    -1,    -1,    -1,  5022,  5023,    -1,    -1,  5049,    -1,
      -1,    -1,  1658,    -1,  2899,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5040,    -1,  4661,  3331,  1672,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1684,  2924,
      -1,  1359,    -1,    -1,    -1,    -1,  3352,    -1,    -1,    -1,
    1696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3377,    -1,    -1,    -1,    -1,    -1,    -1,  4715,    -1,
      -1,    -1,  2580,  4720,  4721,    -1,    -1,    -1,   926,    -1,
    1736,  1737,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2597,
      -1,  5119,    -1,    -1,    -1,  3411,    -1,  1425,  2993,    -1,
    2995,   949,  2610,    -1,    -1,    -1,    -1,    -1,  5136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   964,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5176,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5162,    -1,  1464,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1487,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3076,    -1,    -1,  4831,  4832,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3509,    -1,    -1,    -1,    -1,    -1,    -1,
    1048,  5252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3104,
      -1,    -1,    -1,    -1,  1870,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3127,    -1,    -1,    -1,    -1,    -1,    -1,  1567,
    3135,  5269,    -1,    -1,    -1,    -1,    -1,  5275,    -1,    -1,
    5301,    -1,    -1,    -1,  1582,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1591,    -1,  5316,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1603,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1153,    -1,    -1,    -1,  3204,
      -1,    -1,    -1,    -1,    -1,  2823,  3632,    -1,  2826,    -1,
    2828,    -1,    -1,    -1,    -1,  2833,    -1,  3222,    -1,    -1,
    1658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3235,    -1,    -1,    -1,  1672,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1684,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1696,    -1,
      -1,    -1,    -1,    -1,  2882,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5034,    -1,    -1,
      -1,  2899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1736,  1737,
      -1,    -1,    -1,    -1,    -1,    -1,  2924,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2090,    -1,  3331,    -1,  2094,  2095,
      -1,  3757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3352,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3377,    -1,    -1,  2993,    -1,  2995,    -1,    -1,
      -1,  3807,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1359,  2168,    -1,    -1,    -1,  3411,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3076,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1425,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3929,  3509,    -1,  1464,    -1,    -1,  3127,
      -1,    -1,    -1,  3939,    -1,    -1,    -1,  3135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1487,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3608,  3222,    -1,    -1,    -1,    -1,  1567,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3235,    -1,    -1,
      -1,  2387,    -1,    -1,  1582,    -1,    -1,  3632,    -1,    -1,
      -1,    -1,    -1,  1591,    -1,    -1,    -1,  4063,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1603,    -1,    -1,    -1,    -1,
      -1,    -1,  2090,    -1,    -1,    -1,  2094,  2095,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4122,    -1,    -1,    -1,
    1658,    -1,    -1,  2469,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3331,  1672,    -1,    -1,    -1,  2156,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1684,    -1,    -1,    -1,
    2168,    -1,    -1,    -1,  3352,    -1,    -1,    -1,  1696,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3757,    -1,    -1,    -1,    -1,    -1,    -1,  3377,
      -1,  4187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1736,  1737,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3411,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3807,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2580,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2610,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1870,    -1,  4340,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3929,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3939,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2387,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3632,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4473,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2823,  4063,    -1,
    2826,    -1,  2828,    -1,    -1,    -1,    -1,  2833,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4101,    -1,    -1,    -1,
      -1,    -1,    -1,  1259,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2882,  4122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2090,  2899,    -1,    -1,  2094,  2095,    -1,  3757,
      -1,    -1,  2580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2924,  2597,
      -1,    -1,    -1,    -1,    -1,    -1,  1322,    -1,    -1,    -1,
    4596,    -1,  2610,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4187,    -1,    -1,    -1,    -1,    -1,    -1,  3807,
      -1,    -1,    -1,    -1,    -1,  4621,    -1,    -1,  2156,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2993,    -1,  2995,
      -1,    -1,    -1,    -1,    -1,  4661,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4715,
      -1,    -1,    -1,  4298,  4720,  4721,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3076,  3929,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4340,    -1,    -1,  3104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2823,    -1,    -1,  2826,    -1,
    2828,    -1,    -1,    -1,    -1,  2833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4832,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2387,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3204,    -1,
      -1,    -1,    -1,    -1,  2882,  4063,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3222,    -1,    -1,    -1,
      -1,  2899,    -1,    -1,    -1,    -1,    -1,    -1,  4473,  3235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4101,    -1,    -1,  2924,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4122,    -1,    -1,    -1,    -1,    -1,
      -1,  2469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2993,    -1,  2995,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3331,    -1,    -1,    -1,  4187,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3352,    -1,    -1,    -1,
      -1,  4596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5034,    -1,
      -1,  3377,    -1,    -1,    -1,    -1,  4621,    -1,    -1,    -1,
      -1,    -1,  2580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3076,  2597,
      -1,    -1,    -1,    -1,    -1,  3411,    -1,    -1,    -1,    -1,
      -1,    -1,  2610,    -1,    -1,    -1,  4661,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3104,    -1,    -1,    -1,
    1826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4298,    -1,    -1,    -1,  1840,    -1,    -1,    -1,  1844,  3127,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3135,    -1,    -1,
      -1,    -1,  1858,  1859,  1860,    -1,  1862,    -1,    -1,    -1,
    4715,    -1,    -1,    -1,    -1,  4720,  4721,    -1,    -1,    -1,
      -1,    -1,  4340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3509,    -1,    -1,    -1,    -1,  1904,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3222,  1941,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4832,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4473,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2823,  3632,    -1,  2826,    -1,
    2828,    -1,    -1,    -1,    -1,  2833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2045,
      -1,    -1,    -1,  3331,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2057,    -1,    -1,    -1,    -1,  2062,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2882,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3377,
      -1,  2899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2924,    -1,    -1,    -1,
      -1,    -1,    -1,  3411,    -1,    -1,    -1,    -1,  4596,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4621,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5034,
      -1,    -1,    -1,    -1,    -1,  2993,    -1,  2995,    -1,    -1,
      -1,  3807,    -1,  4661,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4715,    -1,    -1,
      -1,    -1,  4720,  4721,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3076,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3929,    -1,    -1,    -1,    -1,    -1,  3127,
    3608,    -1,    -1,  3939,    -1,    -1,    -1,  3135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3632,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4832,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4063,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3757,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3807,
      -1,    -1,    -1,  3331,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5034,    -1,    -1,  3377,
      -1,  4187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3411,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2624,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2644,    -1,
    2646,  3929,    -1,  2649,  2650,    -1,  2652,    -1,  2654,    -1,
      -1,  3939,  2658,    -1,    -1,  2661,    -1,    -1,    -1,    -1,
    2666,    -1,    -1,    -1,    -1,    -1,  2672,    -1,    -1,    -1,
      -1,  2677,    -1,    -1,    -1,    -1,    -1,    -1,  2684,  2685,
    2686,  2687,  4298,    -1,    -1,  2691,  2692,    -1,  2694,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2706,  3509,  2708,    -1,    -1,    -1,    -1,    -1,    -1,  2715,
    2716,  2717,  2718,  2719,  2720,  2721,  2722,  2723,  2724,    -1,
      -1,    -1,    -1,    -1,  4340,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2752,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2772,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4063,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3632,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4473,    -1,    -1,
      -1,    -1,    -1,  2869,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4187,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3757,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3807,
      -1,    -1,    -1,    -1,    -1,  4621,    -1,    -1,    -1,    -1,
    4298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4661,    -1,    -1,    -1,    -1,
      -1,    -1,  4340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4715,
      -1,    -1,    -1,    -1,  4720,  4721,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3929,    -1,    -1,  3130,    -1,    -1,    -1,    -1,    -1,
      -1,  3939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4473,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4832,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4063,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4596,    -1,
      -1,    -1,    -1,    -1,  4122,    -1,    -1,    -1,    -1,    -1,
      -1,  3327,    -1,    -1,    -1,    -1,    -1,  3333,    -1,    -1,
      -1,    -1,    -1,  4621,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3349,  3350,    -1,    -1,  3353,  3354,  3355,
    3356,    -1,    -1,  3359,  3360,  3361,  3362,  3363,  3364,  3365,
    3366,  3367,  3368,  3369,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4661,    -1,    -1,    -1,    -1,    -1,  4187,
      -1,    -1,    -1,    -1,    -1,  3391,    -1,    -1,  3394,    -1,
    3396,    -1,    -1,  3399,  3400,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3414,  3415,
    3416,  3417,    -1,  3419,    -1,    -1,    -1,    -1,  5034,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4715,    -1,    -1,
      -1,    -1,  4720,  4721,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3469,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3518,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4832,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4473,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3728,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5034,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4596,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4621,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4661,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3876,    -1,    -1,    -1,  3880,  3881,  3882,    -1,    -1,    -1,
      -1,    -1,  3888,  3889,  3890,  3891,    -1,    -1,    -1,    -1,
    3896,  3897,  3898,  3899,  3900,  3901,  3902,  3903,  3904,  3905,
    3906,  3907,    -1,    -1,    -1,    -1,    -1,  4715,    -1,    -1,
      -1,    -1,  4720,  4721,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3932,    -1,    -1,  3935,
      -1,  3937,    -1,    -1,    -1,  3941,    -1,    -1,  3944,  3945,
      -1,    -1,  3948,  3949,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3996,    -1,    -1,    -1,    -1,    -1,    -1,  4003,  4004,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4018,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4832,  4031,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5034,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4293,  4294,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4330,    -1,    -1,    -1,    -1,  4335,
    4336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4350,    -1,  4352,    -1,    -1,    -1,
    4356,  4357,  4358,    -1,    -1,  4361,    -1,    -1,  4364,  4365,
      -1,    -1,    -1,  4369,    -1,    -1,    -1,  4373,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4530,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4619,  4620,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4635,
    4636,  4637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4645,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,  4673,  4674,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
    4686,    44,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    -1,
      -1,    64,    -1,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,    -1,    -1,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,    -1,   151,    -1,
     153,   154,    -1,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,    -1,    -1,    -1,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,    -1,   196,   197,   198,   199,    -1,  4844,    -1,
      -1,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,  4858,    -1,   217,  4861,    -1,   220,    -1,  4865,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
     253,    -1,   255,    -1,    -1,   258,    -1,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,  4915,
     273,    -1,    -1,   276,    -1,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,    -1,   292,
      -1,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,    -1,   352,
     353,    -1,   355,   356,    -1,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,  5028,    -1,  5030,    -1,   389,   390,    -1,   392,
      -1,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,    -1,  5060,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   447,   448,   449,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5227,  5228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5239,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,  5271,  5272,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,  5297,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,    -1,    -1,    -1,    -1,    -1,   457,
     458,   459,    -1,    -1,    -1,    -1,    -1,    -1,   466,   467,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,    -1,    -1,    -1,   457,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   466,   467,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,    -1,    -1,    -1,    -1,    -1,   457,
     458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,   467,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,    -1,
      -1,    -1,    -1,    -1,   457,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   466,   467,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,    -1,     3,    -1,    -1,    -1,   457,
     458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,   467,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    35,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   467,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    -1,    -1,    72,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,
      98,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,    -1,   146,   147,
     148,    -1,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,    -1,    -1,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
      -1,   219,   220,   221,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,    -1,    -1,   252,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,    -1,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,    -1,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,    -1,   392,    -1,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,
     448,   449,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,   467,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    -1,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      -1,    -1,    -1,    98,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,    -1,    -1,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,    -1,   219,   220,   221,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,    -1,   252,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,    -1,   292,    -1,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,    -1,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,    -1,   392,    -1,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,   447,   448,   449,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,   467,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,   420,
     421,   422,   423,   424,    -1,    -1,   427,    -1,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,    -1,    -1,    -1,   457,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   466,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,   162,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,    -1,    -1,    -1,    -1,    -1,
     457,   458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,    -1,
      -1,    -1,    -1,    -1,   457,   458,    -1,    -1,    -1,    -1,
      -1,   464,   465,   466,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,    -1,    -1,    -1,    -1,    -1,   457,   458,
     459,    -1,    -1,    -1,    -1,    -1,    -1,   466,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,    -1,    -1,    -1,
      -1,    -1,   457,   458,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   466,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,   162,   163,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,   420,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,    -1,    -1,    -1,    -1,    -1,   457,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   466,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,    -1,    -1,    -1,    -1,    -1,
     457,   458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,    -1,
      -1,    -1,    -1,    -1,   457,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   466,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,    -1,    -1,    -1,    -1,    -1,   457,   458,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,    -1,    -1,    -1,
      -1,    -1,   457,   458,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   466,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,   420,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,    -1,    -1,    -1,    -1,    -1,   457,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   466,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,    -1,    -1,    -1,    -1,    -1,
     457,   458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,    -1,
      -1,    -1,    -1,    -1,   457,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   466,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,    -1,    -1,    -1,    -1,    -1,   457,   458,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,    -1,    -1,    -1,
      -1,    -1,   457,   458,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   466,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,   420,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,    -1,    -1,    -1,    -1,    -1,   457,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   466,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     457,   458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,    -1,
      -1,    -1,    -1,    -1,   457,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   466,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   457,   458,
      -1,    -1,     3,     4,     5,     6,     7,   466,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,   420,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   457,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   466,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     457,   458,    -1,    -1,     3,     4,     5,     6,     7,   466,
       9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,    -1,    -1,     3,     4,     5,     6,     7,    -1,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,   466,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    72,    -1,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
     420,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
      -1,    -1,     3,     4,     5,     6,     7,    -1,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,   466,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,   420,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,   466,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      72,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,    -1,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,   219,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,    -1,
       3,    -1,    -1,    -1,    -1,   457,   458,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   466,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,    -1,    -1,   452,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   466,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,   267,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   466,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   466,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    59,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   466,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    72,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,   420,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,    -1,     3,     4,     5,    -1,
      -1,    -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     466,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    -1,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,    -1,    -1,     3,    -1,    -1,    -1,    -1,
     457,   458,   459,    -1,    -1,    -1,    -1,    -1,    -1,   466,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,
      98,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,    -1,    -1,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,    -1,   452,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,
      98,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,    -1,    -1,   452,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   466,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    -1,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,    -1,   220,
      -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
      -1,   252,   253,    -1,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,    -1,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   466,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      -1,    -1,    -1,    -1,   466,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,    -1,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,   392,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   448,   449,
      -1,    -1,    -1,   453,   454,   455,    -1,   457,   458,   459,
     460,   461,   462,     3,     4,     5,    -1,    -1,     8,     9,
      -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,    -1,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,    -1,   392,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   448,   449,
      -1,     3,    -1,   453,   454,   455,     8,   457,   458,   459,
     460,   461,   462,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,     3,
      -1,   453,   454,   455,     8,   457,   458,   459,   460,   461,
     462,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,    -1,     3,    -1,   453,
     454,   455,     8,   457,   458,   459,   460,   461,   462,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    -1,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    -1,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,    -1,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,    -1,   252,   253,    -1,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,    -1,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,    -1,     3,    -1,   453,   454,   455,
       8,   457,   458,   459,   460,   461,   462,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,     3,    -1,   453,   454,   455,     8,   457,
     458,   459,   460,   461,   462,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
      -1,     3,    -1,   453,   454,   455,     8,   457,   458,   459,
     460,   461,   462,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,    -1,     3,
      -1,   453,   454,   455,     8,   457,   458,   459,   460,   461,
     462,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,    -1,   453,
     454,   455,    -1,   457,   458,   459,   460,   461,   462,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   459,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   459,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,    -1,   252,
     253,    -1,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,    -1,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   459,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    -1,    -1,    72,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,    -1,
     146,   147,   148,    -1,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,    -1,    -1,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,   217,    -1,   219,   220,   221,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,    -1,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,    -1,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,    -1,   392,    -1,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   447,   448,   449,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,   459,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    -1,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,    -1,    -1,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,    -1,   219,   220,   221,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,    -1,   292,
      -1,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,    -1,   392,
      -1,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,     3,     4,     5,    -1,    -1,    -1,     9,
      -1,    -1,    -1,    -1,   447,   448,   449,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,   459,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    72,    -1,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    -1,    -1,    -1,    98,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,   266,    -1,   268,   269,
     270,    -1,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
     420,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,     4,     5,    -1,    -1,    -1,     9,   457,   458,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,     4,     5,
      -1,    -1,    -1,     9,   457,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    72,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,    -1,   268,   269,   270,    -1,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,   420,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,     5,    -1,    -1,    -1,
       9,   457,   458,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,    -1,   268,
     269,   270,    -1,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,     9,   457,   458,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
     162,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,     4,
       5,    -1,    -1,    -1,     9,   457,   458,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    -1,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
      -1,   268,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    72,    -1,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    -1,    -1,    -1,    98,    -1,
      -1,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
     420,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    -1,    -1,    -1,    98,    -1,    -1,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    72,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    -1,
      -1,    -1,    98,    -1,    -1,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,   420,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,    98,
      -1,    -1,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      72,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    -1,    -1,    -1,    98,    -1,    -1,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      -1,    -1,    -1,    98,    -1,    -1,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    72,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,
      98,    -1,    -1,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,   219,   220,   221,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,    -1,   252,   253,   254,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    -1,    -1,    -1,    98,    -1,    -1,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,   219,   220,
     221,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,   420,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    -1,    -1,    -1,    98,    -1,    -1,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,   219,   220,   221,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,    -1,   252,   253,
     254,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    -1,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,   219,   220,   221,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,    -1,   252,   253,   254,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    72,    -1,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    -1,    -1,    -1,    98,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,   219,
     220,   221,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,    -1,   252,   253,   254,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
     420,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,   219,   220,   221,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,    -1,   252,
     253,   254,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    72,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,   219,   220,   221,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,    -1,   252,   253,   254,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,   420,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
     219,   220,   221,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      72,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    -1,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,   219,   220,   221,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      -1,    -1,    -1,    98,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,   219,   220,   221,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,   254,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    73,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,   159,   160,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    -1,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,    -1,   220,
     221,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
      -1,   252,   253,    -1,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,    -1,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    -1,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    -1,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,    -1,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,    -1,   252,   253,    -1,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,   159,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,    -1,   252,
     253,    -1,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,    -1,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    -1,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    -1,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,    -1,    -1,    -1,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,    -1,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,    -1,   252,   253,    -1,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,    -1,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,   267,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    -1,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    -1,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    -1,    92,    93,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,    -1,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
      -1,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,    -1,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    -1,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,    -1,   220,
      -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
      -1,   252,   253,    -1,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,    -1,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    -1,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    -1,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,    -1,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,    -1,   252,   253,    -1,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,    -1,   252,
     253,    -1,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,    -1,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    -1,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    -1,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,    -1,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,    -1,   252,   253,    -1,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,   267,   268,   269,   270,    -1,    -1,   273,   274,    -1,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,    -1,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    -1,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    -1,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    -1,    92,    93,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,    -1,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
      -1,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,    -1,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    -1,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,    -1,   220,
      -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
      -1,   252,   253,    -1,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,   267,   268,   269,   270,
      -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,    -1,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    -1,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    -1,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,    -1,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,    -1,   252,   253,    -1,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,    -1,   252,
     253,    -1,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,    -1,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    -1,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    -1,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,    -1,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,    -1,   252,   253,    -1,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,    -1,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    35,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    -1,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    -1,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    -1,    92,    93,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,    -1,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
      -1,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,    -1,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    -1,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,    -1,   220,
      -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
      -1,   252,   253,    -1,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,    -1,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    -1,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    -1,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,    -1,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,    -1,   252,   253,    -1,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,    -1,   252,
     253,    -1,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,    -1,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    -1,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    -1,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,    -1,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,    -1,   252,   253,    -1,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,    -1,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    -1,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    -1,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    -1,    92,    93,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,    -1,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
      -1,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,    -1,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    -1,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,    -1,   220,
      -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
      -1,   252,   253,    -1,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,    -1,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    -1,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    -1,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,    -1,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,    -1,   252,   253,    -1,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,    -1,   252,
     253,    -1,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,    -1,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    -1,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    -1,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,    -1,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,    -1,   252,   253,    -1,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,    -1,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    -1,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    -1,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    -1,    92,    93,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,    -1,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
      -1,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,    -1,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    -1,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,    -1,   220,
      -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
      -1,   252,   253,    -1,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,    -1,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    -1,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    -1,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,    -1,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,    -1,   252,   253,    -1,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,    -1,   252,
     253,    -1,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,    -1,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,    -1,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    -1,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    -1,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,    -1,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,    -1,   252,   253,    -1,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,    -1,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    -1,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    -1,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    -1,    92,    93,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,   146,   147,   148,   149,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,
     165,   166,   167,    -1,   169,   170,    -1,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,    -1,   210,   211,   212,   213,   214,
      -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
      -1,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,    -1,   377,    -1,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,   391,   392,   393,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,    -1,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    -1,    50,    51,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,   151,    -1,   153,   154,   155,   156,    -1,
     158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,
      -1,   169,   170,    -1,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,    -1,   210,   211,   212,   213,   214,    -1,    -1,   217,
     218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,   252,   253,    -1,   255,    -1,   257,
     258,   259,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,    -1,   377,
      -1,   379,   380,   381,   382,   383,    -1,   385,   386,    -1,
      -1,   389,   390,   391,   392,   393,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    -1,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,   170,
      -1,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,
     211,   212,   213,   214,    -1,    -1,   217,   218,    -1,   220,
      -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
      -1,   252,   253,    -1,   255,    -1,   257,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,    -1,   377,    -1,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
     391,   392,   393,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,    -1,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    -1,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    75,    76,    77,    78,    -1,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,    -1,
     164,   165,   166,   167,    -1,   169,   170,    -1,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,   213,
     214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,    -1,   252,   253,
      -1,   255,    -1,   257,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
     274,    -1,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,    -1,   377,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,   391,   392,   393,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    -1,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    74,    75,    76,
      77,    78,    -1,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,   166,
     167,    -1,   169,   170,    -1,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,    -1,   210,   211,   212,   213,   214,    -1,    -1,
     217,   218,    -1,   220,    -1,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,    -1,   252,   253,    -1,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,    -1,
     377,    -1,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,   391,   392,   393,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,    -1,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    -1,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    75,    76,    77,    78,    -1,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,   169,
     170,    -1,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,    -1,
     210,   211,   212,   213,   214,    -1,    -1,   217,   218,    -1,
     220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,    -1,   252,   253,    -1,   255,    -1,   257,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,    -1,   377,    -1,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,   391,   392,   393,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,   416,   417,    -1,   419,
      -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    -1,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    -1,    92,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,   146,   147,   148,   149,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,    -1,    -1,
      -1,   164,   165,   166,   167,    -1,   169,   170,    -1,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,   212,
     213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,    -1,   252,
     253,    -1,   255,    -1,   257,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,   274,    -1,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,    -1,   377,    -1,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,   391,   392,
     393,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    -1,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    -1,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    -1,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,   151,    -1,   153,   154,   155,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,   164,   165,
     166,   167,    -1,   169,   170,    -1,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,    -1,   210,   211,   212,   213,   214,    -1,
      -1,   217,   218,    -1,   220,    -1,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,    -1,   252,   253,    -1,   255,
      -1,   257,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,    -1,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
      -1,   377,    -1,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,   391,   392,   393,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,    -1,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      -1,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    -1,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,   146,   147,   148,
     149,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,    -1,    -1,    -1,   164,   165,   166,   167,    -1,
     169,   170,    -1,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
      -1,   210,   211,   212,   213,   214,    -1,    -1,   217,   218,
      -1,   220,    -1,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,    -1,   252,   253,    -1,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,   274,    -1,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,    -1,   377,    -1,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,   391,   392,   393,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,    -1,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    -1,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      -1,    -1,    -1,    98,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,    -1,    -1,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,    -1,   219,   220,   221,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,    -1,   252,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,    -1,   292,    -1,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,    -1,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,    -1,   392,    -1,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   447,   448,   449,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    -1,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    -1,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    -1,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,   146,   147,   148,   149,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,    -1,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,    -1,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,    -1,   210,   211,
     212,   213,   214,    -1,    -1,   217,   218,    -1,   220,    -1,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,    -1,
     252,   253,    -1,   255,    -1,   257,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,   274,    -1,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,    -1,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,    -1,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,   391,
     392,   393,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    -1,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      -1,    -1,    -1,    98,    -1,    -1,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
      -1,    -1,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,   141,   142,   143,   144,
      -1,   146,   147,   148,    -1,    -1,   151,    -1,   153,   154,
     155,   156,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,    -1,    -1,   173,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,    -1,   193,   194,
      -1,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
      -1,    -1,   217,    -1,   219,   220,   221,    -1,   223,   224,
     225,    -1,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,    -1,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,    -1,   264,
     265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,    -1,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    -1,   289,   290,    -1,   292,    -1,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,    -1,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,    -1,    -1,   389,   390,    -1,   392,    -1,    -1,
     395,   396,   397,   398,   399,   400,   401,    -1,    -1,   404,
     405,   406,   407,   408,    -1,    -1,   411,   412,   413,   414,
     415,    -1,   417,    -1,   419,   420,   421,   422,   423,   424,
      -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   447,   448,   449,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    -1,    -1,
      72,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    -1,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,    -1,    -1,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,   141,
     142,   143,   144,    -1,   146,   147,   148,    -1,    -1,   151,
      -1,   153,   154,   155,   156,    -1,   158,    -1,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,    -1,
      -1,   173,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
      -1,   193,   194,    -1,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,    -1,   217,    -1,   219,   220,   221,
      -1,   223,   224,   225,    -1,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,    -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,
      -1,   273,    -1,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,    -1,   289,   290,    -1,
     292,    -1,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,    -1,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,   383,    -1,   385,   386,    -1,    -1,   389,   390,    -1,
     392,    -1,    -1,   395,   396,   397,   398,   399,   400,   401,
      -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,   411,
     412,   413,   414,   415,    -1,   417,    -1,   419,   420,   421,
     422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   447,   448,   449,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    -1,    -1,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    -1,   112,    -1,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,    -1,    -1,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,   141,   142,   143,   144,    -1,   146,   147,   148,
      -1,    -1,   151,    -1,   153,   154,   155,   156,    -1,   158,
      -1,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,    -1,    -1,   173,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,    -1,   193,   194,    -1,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,    -1,   217,    -1,
     219,   220,   221,    -1,   223,   224,   225,    -1,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,    -1,   264,   265,    -1,    -1,   268,
     269,   270,    -1,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,    -1,   292,    -1,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,    -1,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,    -1,    -1,
     389,   390,    -1,   392,    -1,    -1,   395,   396,   397,   398,
     399,   400,   401,    -1,    -1,   404,   405,   406,   407,   408,
      -1,    -1,   411,   412,   413,   414,   415,    -1,   417,    -1,
     419,   420,   421,   422,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   448,
     449,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    -1,    -1,    72,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,    -1,
      -1,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,    -1,
     146,   147,   148,    -1,    -1,   151,    -1,   153,   154,   155,
     156,   157,   158,    -1,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,    -1,    -1,   173,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,    -1,   193,   194,    -1,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
      -1,   217,    -1,   219,   220,   221,    -1,   223,   224,   225,
      -1,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,    -1,   264,   265,
      -1,    -1,   268,   269,   270,    -1,    -1,   273,    -1,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,    -1,   289,   290,    -1,   292,    -1,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,    -1,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,    -1,    -1,   389,   390,    -1,   392,    -1,    -1,   395,
     396,   397,   398,   399,   400,   401,    -1,    -1,   404,   405,
     406,   407,   408,    -1,    -1,   411,   412,   413,   414,   415,
      -1,   417,    -1,   419,   420,   421,   422,   423,   424,    -1,
      -1,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   447,   448,   449,    -1,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    -1,    -1,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,    -1,    -1,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,   141,   142,
     143,   144,    -1,   146,   147,   148,    -1,    -1,   151,    -1,
     153,   154,   155,   156,    -1,   158,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,    -1,    -1,
     173,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,    -1,
     193,   194,    -1,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,    -1,   217,    -1,   219,   220,   221,    -1,
     223,   224,   225,    -1,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
      -1,   264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,    -1,   292,
      -1,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
      -1,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,    -1,    -1,   389,   390,    -1,   392,
      -1,    -1,   395,   396,   397,   398,   399,   400,   401,    -1,
      -1,   404,   405,   406,   407,   408,    -1,    -1,   411,   412,
     413,   414,   415,    -1,   417,    -1,   419,   420,   421,   422,
     423,   424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   447,   448,   449,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      -1,    -1,    72,    -1,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    -1,    -1,    -1,    98,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,    -1,    -1,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,    -1,   137,   138,   139,
      -1,   141,   142,   143,   144,    -1,   146,   147,   148,    -1,
      -1,   151,    -1,   153,   154,   155,   156,    -1,   158,    -1,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,    -1,    -1,   173,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,    -1,   193,   194,    -1,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,    -1,   217,    -1,   219,
     220,   221,    -1,   223,   224,   225,    -1,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,    -1,   252,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,    -1,   264,   265,    -1,    -1,   268,   269,
     270,    -1,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,    -1,   289,
     290,    -1,   292,    -1,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,    -1,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,    -1,   385,   386,    -1,    -1,   389,
     390,    -1,   392,    -1,    -1,   395,   396,   397,   398,   399,
     400,   401,    -1,    -1,   404,   405,   406,   407,   408,    -1,
      -1,   411,   412,   413,   414,   415,    -1,   417,    -1,   419,
     420,   421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   448,   449,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    -1,    -1,    72,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    -1,    -1,
      -1,    98,    -1,    -1,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,    -1,   112,    -1,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,    -1,    -1,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,   141,   142,   143,   144,    -1,   146,
     147,   148,    -1,    -1,   151,    -1,   153,   154,   155,   156,
      -1,   158,    -1,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,    -1,    -1,   173,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,    -1,   193,   194,    -1,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,    -1,
     217,    -1,   219,   220,   221,    -1,   223,   224,   225,    -1,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,    -1,   264,   265,    -1,
      -1,   268,   269,   270,    -1,    -1,   273,    -1,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,    -1,   292,    -1,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,    -1,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
      -1,    -1,   389,   390,    -1,   392,    -1,    -1,   395,   396,
     397,   398,   399,   400,   401,    -1,    -1,   404,   405,   406,
     407,   408,    -1,    -1,   411,   412,   413,   414,   415,    -1,
     417,    -1,   419,   420,   421,   422,   423,   424,    -1,    -1,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     447,   448,   449,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    -1,    -1,    72,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,    -1,    -1,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,    -1,   146,   147,   148,    -1,    -1,   151,    -1,   153,
     154,   155,   156,    -1,   158,    -1,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,    -1,    -1,   173,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,    -1,   193,
     194,    -1,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,    -1,    -1,   217,    -1,   219,   220,   221,    -1,   223,
     224,   225,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,    -1,   252,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,    -1,   268,   269,   270,    -1,    -1,   273,
      -1,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,    -1,   292,    -1,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,    -1,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
      -1,   385,   386,    -1,    -1,   389,   390,    -1,   392,    -1,
      -1,   395,   396,   397,   398,   399,   400,   401,    -1,    -1,
     404,   405,   406,   407,   408,    -1,    -1,   411,   412,   413,
     414,   415,    -1,   417,    -1,   419,   420,   421,   422,   423,
     424,    -1,    -1,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   447,   448,   449,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    27,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    -1,
      -1,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    -1,    -1,    -1,    98,    -1,    -1,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,    -1,    -1,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
     141,   142,   143,   144,    -1,   146,   147,   148,    -1,    -1,
     151,    -1,   153,   154,   155,   156,    -1,   158,    -1,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
      -1,    -1,   173,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,    -1,   193,   194,    -1,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,    -1,   217,    -1,   219,   220,
     221,    -1,   223,   224,   225,    -1,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
      -1,   252,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,    -1,   264,   265,    -1,    -1,   268,   269,   270,
      -1,    -1,   273,    -1,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,    -1,   289,   290,
      -1,   292,    -1,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
      -1,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,    -1,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,    -1,    -1,   389,   390,
      -1,   392,    -1,    -1,   395,   396,   397,   398,   399,   400,
     401,    -1,    -1,   404,   405,   406,   407,   408,    -1,    -1,
     411,   412,   413,   414,   415,    -1,   417,    -1,   419,   420,
     421,   422,   423,   424,    -1,    -1,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   447,   448,   449,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    45,    46,    -1,
      -1,    49,    -1,    -1,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    -1,    -1,    64,    -1,    66,    67,
      68,    69,    -1,    -1,    72,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    -1,    -1,    -1,
      98,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
      -1,    -1,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,    -1,    -1,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,    -1,   146,   147,
     148,    -1,    -1,   151,    -1,   153,   154,    -1,   156,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,    -1,    -1,   173,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,    -1,   196,   197,
     198,   199,    -1,    -1,    -1,    -1,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,    -1,   217,
      -1,   219,   220,   221,    -1,   223,   224,   225,    -1,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,    -1,   245,    -1,   247,
     248,   249,    -1,    -1,   252,   253,   254,   255,    -1,    -1,
     258,    -1,   260,   261,   262,    -1,   264,   265,    -1,    -1,
     268,   269,   270,    -1,    -1,   273,    -1,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,    -1,   292,    -1,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,   354,   355,   356,    -1,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,    -1,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,    -1,    -1,    -1,    -1,
      -1,   389,   390,    -1,   392,    -1,    -1,   395,   396,   397,
     398,   399,   400,   401,    -1,    -1,   404,   405,   406,   407,
     408,    -1,    -1,   411,   412,   413,   414,   415,    -1,    -1,
      -1,   419,   420,   421,   422,   423,   424,    -1,    -1,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,
     448,   449
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    18,    28,    30,    31,    46,    66,    68,    69,    75,
      77,    88,    90,   107,   110,   124,   126,   130,   136,   144,
     146,   152,   168,   184,   223,   224,   229,   241,   253,   295,
     308,   314,   315,   317,   322,   327,   330,   335,   341,   342,
     349,   353,   363,   376,   395,   405,   411,   416,   429,   452,
     466,   473,   474,   475,   476,   482,   483,   485,   486,   487,
     488,   490,   494,   506,   511,   512,   515,   516,   517,   537,
     540,   541,   557,   600,   601,   604,   607,   608,   609,   617,
     623,   625,   627,   628,   631,   634,   635,   639,   648,   652,
     653,   654,   655,   658,   660,   661,   662,   663,   671,   672,
     691,   695,   697,   698,   699,   709,   711,   718,   719,   722,
     723,   724,   725,   726,   734,   736,   740,   745,   749,   750,
     758,   759,   762,   767,   778,   805,   808,   809,   810,   815,
     818,   820,   822,   824,   825,   830,   831,   834,   835,   836,
     840,   841,   844,   845,   848,   849,   850,   857,   859,   860,
     861,   866,   868,   869,   875,   876,   877,   878,   879,   880,
     881,   883,   884,   886,   887,   889,   892,   893,   898,   904,
     907,   909,   910,   919,   921,   926,   931,   935,   936,   937,
     938,   939,   940,   943,   978,   389,   432,   862,    25,    72,
      87,   105,   111,   128,   139,   147,   159,   164,   171,   188,
     213,   234,   268,   290,   300,   303,   329,   334,   336,   343,
     346,   365,   371,   375,   376,   379,   383,   392,   397,   409,
     422,   624,   862,     3,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    37,    38,    40,    41,
      42,    44,    45,    46,    47,    48,    50,    51,    53,    54,
      55,    56,    57,    60,    61,    62,    63,    64,    66,    67,
      68,    69,    70,    74,    75,    76,    77,    78,    80,    81,
      82,    84,    85,    86,    87,    88,    89,    92,    93,    94,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   112,
     114,   115,   116,   117,   118,   119,   121,   122,   123,   124,
     127,   128,   129,   130,   131,   133,   134,   135,   137,   138,
     139,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     151,   153,   154,   155,   156,   158,   160,   164,   165,   166,
     167,   169,   170,   172,   173,   175,   176,   177,   178,   179,
     181,   182,   183,   184,   186,   187,   188,   189,   190,   191,
     193,   195,   196,   197,   198,   199,   200,   201,   203,   205,
     208,   210,   211,   212,   213,   214,   217,   218,   220,   223,
     224,   225,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   246,
     247,   248,   249,   250,   252,   253,   255,   257,   258,   259,
     260,   261,   262,   264,   265,   268,   269,   270,   273,   274,
     276,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   289,   290,   291,   292,   293,   294,   295,   296,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   326,   327,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     343,   344,   345,   346,   347,   349,   350,   351,   352,   353,
     355,   356,   357,   358,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   374,   375,   377,
     379,   380,   381,   382,   383,   385,   386,   389,   390,   391,
     392,   393,   395,   396,   397,   398,   399,   400,   401,   404,
     405,   406,   407,   408,   411,   412,   413,   414,   415,   416,
     417,   419,   421,   422,   423,   424,   427,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   932,  1103,  1117,
    1121,  1122,   420,   894,   266,   296,   862,    49,   466,   548,
      20,    25,    37,    59,    72,    83,   105,   111,   128,   139,
     147,   159,   167,   171,   225,   268,   271,   290,   303,   329,
     336,   346,   365,   371,   379,   380,   382,   383,   392,   397,
     403,   406,   409,   558,   606,   714,   768,   779,    26,   295,
    1103,   932,    26,   289,   344,   380,   382,     5,   212,   816,
     817,  1112,    20,    25,    37,    59,    72,    87,   105,   128,
     139,   147,   159,   164,   171,   188,   234,   268,   280,   290,
     303,   329,   334,   336,   343,   346,   365,   371,   376,   379,
     383,   390,   392,   397,   409,   422,   624,   727,   728,   729,
     862,  1103,    90,   420,   466,   601,   604,   607,   893,   899,
     907,   910,   919,   926,   931,   935,     9,    19,    26,    44,
     154,   160,   162,   185,   214,   248,   298,   316,   457,   458,
     746,   747,   932,  1111,  1113,    26,    90,   312,   342,   751,
     752,   753,  1117,   159,  1117,  1108,  1112,   376,   946,   746,
    1117,   389,  1103,   280,   234,   105,   188,   336,   375,   376,
     466,   826,   827,   335,  1117,    26,   347,   385,   389,   498,
     507,   508,  1117,    23,   168,   751,   752,   296,   862,  1117,
     211,    26,   125,   948,   949,    60,    84,   225,   243,   329,
     336,   347,   385,   389,   435,   495,   496,   497,   498,    26,
     347,   385,   389,   498,   389,   267,   989,  1101,  1117,   946,
     459,  1117,   163,   466,   895,   466,   310,   941,   942,  1103,
     941,   936,   937,   940,     0,   469,   894,   140,   202,   272,
     402,   950,   951,   936,   938,   939,   116,   198,   408,   470,
       3,    43,    49,    72,    79,    91,    98,   161,   163,   180,
     194,   206,   207,   209,   219,   221,   245,   254,   275,   277,
     328,   354,   378,   420,   795,  1109,  1117,  1118,  1121,  1123,
     731,  1117,   731,  1104,  1117,   299,   731,   392,  1103,   104,
     376,   783,  1109,  1117,  1123,     3,   101,   348,  1114,  1115,
    1119,  1121,  1122,  1123,    26,   179,  1101,   260,   422,     8,
      15,    16,    17,    67,   151,   453,   454,   455,   457,   458,
     459,   460,   461,   462,   812,   814,  1065,  1066,  1117,   179,
    1103,  1103,    26,  1114,  1115,  1103,  1103,   179,  1101,  1103,
     731,  1103,   322,   349,    26,   179,   989,  1103,   339,  1103,
     731,    26,   232,  1114,  1115,   179,  1101,   212,   113,   208,
     251,   306,   863,   864,   865,  1101,  1107,  1117,    20,    25,
      59,    72,    73,    83,    87,   105,   128,   139,   147,   159,
     164,   188,   213,   234,   268,   290,   303,   329,   334,   336,
     343,   346,   365,   371,   376,   379,   383,   390,   392,   397,
     422,   624,   737,   738,  1112,   906,   910,   919,   926,   935,
    1101,   236,  1109,  1103,   466,   179,   731,   392,  1104,   731,
     392,   179,  1103,   104,   376,   380,   382,  1114,  1115,   380,
     382,    67,   151,   812,   320,  1103,  1103,  1114,   179,   491,
    1117,   179,  1103,   179,   731,  1103,  1103,   339,  1103,   731,
     232,  1114,   310,   343,   376,   422,   234,    87,   188,   164,
     334,   390,   396,   618,    26,  1103,   933,   505,  1112,  1119,
     817,   236,   179,   795,   796,  1103,   179,   821,   179,  1104,
       3,    48,    50,    51,    62,    63,   108,   109,   129,   155,
     179,   200,   201,   203,   244,   246,   259,   307,   351,   357,
     385,   386,   417,   733,  1011,  1013,  1015,  1017,  1019,  1021,
    1022,  1023,  1025,  1026,  1027,  1029,  1030,  1118,  1121,   392,
     104,   376,   179,   782,   783,   179,  1115,  1116,    79,   422,
      67,   151,   179,   813,   814,    53,   179,  1116,   179,  1103,
     179,  1103,   339,   821,   179,   733,   179,   232,  1116,   212,
     179,   730,   731,   179,  1102,  1103,   179,  1103,   466,   908,
     558,   899,   416,   893,   900,   901,   902,  1119,   894,  1113,
     747,   748,    26,   748,  1113,   748,    26,   748,  1113,   748,
     748,   748,  1113,  1111,  1111,   932,   748,   299,   466,   466,
     578,   578,   578,   266,   387,   470,   578,   336,   989,   990,
     470,   858,  1112,   466,   905,    53,   422,   420,   828,   829,
    1101,  1103,  1117,    43,   449,   208,   468,   269,   269,   266,
     162,  1112,   387,   157,   741,   266,     4,     6,     7,     8,
      10,    34,    48,    50,    51,    58,    59,    62,    63,    70,
      72,    95,    96,    97,    98,    99,   100,   101,   108,   109,
     111,   145,   149,   150,   155,   170,   172,   200,   201,   203,
     218,   226,   227,   244,   246,   251,   256,   257,   259,   268,
     278,   291,   307,   332,   348,   357,   372,   385,   386,   391,
     393,   394,   403,   409,   417,   437,   438,   439,   440,   442,
     443,   444,   445,   450,   457,   458,   459,   466,   936,  1014,
    1017,  1020,  1021,  1022,  1024,  1025,  1026,  1029,  1030,  1034,
    1036,  1037,  1038,  1040,  1061,  1062,  1063,  1067,  1086,  1091,
    1098,  1099,  1109,  1110,  1111,  1112,  1117,  1097,  1098,  1112,
      26,   513,  1100,  1101,   347,   495,   111,   504,  1112,   505,
    1112,    43,    64,   495,   449,   358,   864,   269,   162,   387,
     455,    43,   449,   208,   865,   466,  1101,   459,   464,   468,
    1092,  1094,   990,     3,   161,   163,   420,   890,   891,   893,
     161,   896,  1034,  1070,   941,   470,   466,   897,   467,   467,
     475,  1101,    26,   125,   947,   947,    53,   947,   152,   157,
     222,   263,   954,   956,   957,   972,   974,   975,   976,   950,
     951,   162,   204,   989,   991,   466,   281,   318,   349,   466,
     793,  1094,   281,   314,   318,   349,   468,   732,   281,   318,
     349,     3,    82,   134,   228,   281,   318,   349,   379,   381,
     429,   506,   509,   870,   871,   872,   873,   763,    22,   130,
     281,   318,   349,   413,   521,  1103,    22,   130,   349,   408,
     489,   433,   179,   989,    55,    89,   119,   148,   182,   217,
     251,   281,   282,   318,   326,   333,   341,   349,   361,   369,
     424,   506,   510,   798,   806,   466,   780,  1094,   318,   489,
     185,   145,    22,    28,    69,   119,   123,   130,   133,   158,
     190,   249,   251,   261,   270,   281,   318,   321,   322,   349,
     413,   518,   520,   642,     4,   457,   458,   615,  1113,    26,
     179,  1101,   731,   731,   466,   811,   281,   349,   468,   145,
     266,    22,   130,   281,   318,   349,   185,   484,   318,   429,
     452,   477,   484,   266,   281,   318,   145,    35,    54,   103,
     187,   235,   238,   249,   280,   318,   323,   343,   349,   363,
     518,   612,   613,   281,   318,   421,   642,   650,   281,   318,
     349,    82,   123,   133,   281,   314,   318,   349,   508,   496,
     498,   185,   145,    41,   121,   318,   349,   518,   519,   281,
     318,   322,   349,    80,   122,   283,   381,   266,    22,    28,
     130,   281,   318,   349,   538,   539,   484,   157,   318,   477,
     484,   145,   318,   349,   518,  1103,   220,   113,   267,   434,
     470,   863,   410,   888,   266,   236,   795,   466,  1103,  1011,
     392,   104,   376,   783,   260,   422,    67,   151,   814,  1103,
    1103,   339,   157,  1103,  1011,   212,   731,  1103,   467,   578,
    1103,   466,   704,   793,    65,  1011,   251,   162,   466,   700,
    1103,   477,    35,   882,  1103,   251,   477,   433,   179,  1101,
     477,   731,   731,   700,   406,   558,   266,   157,   842,   843,
     477,   251,    43,   492,   251,   397,   649,   251,   897,    82,
     281,   626,    80,   122,   283,   381,    24,    45,   199,   673,
      35,   700,   157,   179,   477,   422,   179,  1101,   179,   602,
    1101,  1101,   422,   731,    79,   769,  1109,  1103,   157,   624,
      49,   102,   197,   249,   338,   145,    56,   324,   470,   522,
     522,   145,   466,   145,   419,  1028,  1028,  1028,   466,  1016,
    1016,   293,   466,  1018,   145,    62,    63,  1028,  1016,  1013,
     431,   452,   466,  1031,   466,  1031,   470,   522,    34,  1012,
     466,   106,   177,   237,   240,   340,   447,   466,  1032,  1033,
     732,  1016,   433,   145,   470,   522,   145,   470,   179,   730,
     179,   731,   179,   731,   145,   470,   522,  1116,   145,   145,
     522,   145,    80,   122,   283,   381,   157,   145,   522,   145,
     157,   179,   179,   505,   145,   470,   522,   145,   470,   522,
     145,   266,  1070,   376,   467,   470,   150,   266,   394,   502,
     505,   615,   903,   899,   748,   932,   748,   932,   748,   932,
     748,   932,   748,   932,   932,   932,   748,   932,   466,   579,
     580,  1117,   579,    26,   105,   128,   159,   164,   212,   213,
     336,   343,   376,   379,   397,   754,  1100,  1116,   753,  1103,
     185,   470,   922,  1112,  1011,  1073,    35,  1116,   769,   467,
     470,   220,  1117,   157,   157,   754,  1116,   335,  1117,   505,
     266,   466,  1095,   464,   936,  1074,  1034,  1090,   466,   466,
     157,   466,   466,   936,   466,   466,   466,   466,   466,   466,
    1034,   466,   466,   466,   466,   466,   466,   466,   466,   936,
     466,   466,   466,   466,   466,   466,   466,   466,  1034,  1034,
    1034,   936,  1034,  1070,  1094,  1112,   466,  1112,     3,     8,
      11,    15,    16,    17,    32,    35,    40,    47,    71,   180,
     185,   206,   207,   221,   254,   268,   271,   354,   450,   453,
     454,   455,   457,   458,   459,   460,   461,   462,  1065,  1067,
    1069,   430,  1049,   277,  1034,   204,   470,   944,   466,  1112,
    1094,   944,   114,   181,   514,   470,    64,   111,   505,    35,
       3,   111,   225,   503,   615,  1030,  1112,  1112,    85,   127,
    1046,    94,   111,   499,   500,   502,   615,   111,   499,   220,
    1101,  1034,  1093,     3,    26,    30,    31,    32,    33,    34,
      35,    36,    39,    52,    58,    59,    65,    71,    73,    83,
      90,    95,    96,    97,    99,   100,   101,   111,   113,   120,
     125,   126,   132,   136,   140,   150,   152,   157,   159,   162,
     168,   171,   174,   185,   192,   202,   204,   215,   216,   222,
     226,   227,   251,   256,   263,   266,   267,   271,   272,   288,
     297,   312,   325,   342,   348,   359,   373,   376,   384,   387,
     388,   394,   402,   403,   409,   410,   418,   425,   426,   428,
     429,   459,  1106,  1120,  1121,  1122,  1123,  1124,  1092,    86,
     323,   735,   467,   470,   894,   467,   470,   942,  1102,    35,
     897,   938,   938,   952,   953,  1034,   938,   154,   248,   963,
     210,   249,   306,   352,   408,    26,   958,  1034,   457,   458,
     959,   960,  1034,  1036,   972,   973,   957,   956,   954,   955,
     157,   975,   261,   977,   954,   972,   991,   911,  1101,    35,
    1117,   349,  1070,   387,   387,   336,   185,   195,   272,   274,
     351,   418,   459,   786,   787,   788,   790,   792,   794,  1011,
    1118,   387,   421,   387,   336,  1106,   468,   387,   387,   336,
     222,   387,   387,   379,   495,   281,   870,   872,   455,   874,
     157,   168,   185,   327,   764,   765,    65,    83,   141,   159,
     297,   403,   575,   576,    83,   111,   251,   387,    83,   387,
     111,   251,   336,    83,   123,   133,   281,   318,   696,   336,
     632,    20,    25,    59,    72,    87,   128,   139,   159,   164,
     234,   268,   336,   343,   346,   376,   383,   390,   397,   422,
     624,  1103,   145,   318,   349,   518,   266,   615,   266,   341,
     217,   387,  1117,   387,   256,   615,   115,   205,   336,   347,
     389,   497,   324,   349,   798,   807,   467,   781,   786,   387,
     409,   379,  1101,    73,   141,   179,   565,   575,  1117,    73,
      83,   832,   266,   266,   332,   334,   392,    83,   832,    29,
     321,   332,   334,   392,   332,  1101,   158,   190,   261,   731,
     466,   387,   387,   178,   466,   526,   231,   379,   406,   429,
     431,   526,    83,   470,     4,     4,   281,   185,   145,   119,
     318,   349,   518,   410,   410,   250,  1011,   387,   336,   466,
     812,  1103,  1101,   376,   376,   387,   387,   376,   700,   105,
     349,   509,   387,   479,   509,  1101,   387,   387,  1101,  1013,
     615,    53,   614,   615,   615,   103,   235,   238,    53,   387,
     477,   242,   336,   477,   249,   613,   387,   387,   256,  1112,
     642,   387,   387,   336,  1112,   387,   303,   387,   303,   700,
     379,   989,   285,   285,    83,   387,   832,   336,   387,   387,
     526,   526,   731,   731,   731,   731,  1101,    42,   415,    42,
      42,   387,    42,   387,   415,   336,   470,   509,   409,   659,
    1115,   387,   479,   509,  1101,   387,   336,   281,   318,   306,
     319,   345,   501,   863,  1107,  1117,  1101,   206,  1011,   266,
     206,   433,   206,   615,   731,   731,   206,   266,   266,    80,
     122,   283,   381,  1011,   266,   206,   206,   206,   387,   429,
     549,   397,     3,   705,   706,   700,   466,    35,   145,   731,
     701,   702,  1120,    24,   870,  1011,   266,   145,   629,  1103,
     251,   285,   466,   478,   714,   410,   310,   422,  1101,    26,
     376,   429,   802,   478,   145,  1115,    90,   168,   493,   557,
     608,   672,   749,   767,   866,   145,  1112,   650,   651,   145,
     266,  1112,  1115,   228,   731,   731,   731,   731,   261,   116,
     198,   395,   408,   674,   675,   137,   305,   466,   659,   251,
     478,  1101,   251,   610,   612,   251,    35,   261,   285,   466,
     578,   578,   179,   605,  1101,   157,   179,   770,  1107,   466,
     784,    35,  1011,   212,   429,   431,   934,   338,   796,   795,
    1011,  1104,   466,  1070,  1111,   733,  1028,  1028,    34,  1012,
     385,   385,  1111,  1111,  1011,   464,   464,  1111,   387,   387,
     387,   466,   387,  1111,  1016,   782,   783,  1116,  1115,   145,
     522,   145,   410,   145,   410,   813,   814,   522,  1116,  1103,
    1103,  1011,   733,  1116,   659,   145,   145,   522,   730,   731,
    1102,  1103,  1103,   731,   467,   179,  1101,   899,   901,   932,
     932,   932,   932,   932,   932,   579,   467,   470,   467,   165,
     344,   377,  1102,   730,   104,   346,   782,  1102,   260,  1102,
    1100,  1100,  1102,   730,   387,   429,   760,   140,   222,   656,
     657,    20,   143,   332,   352,   923,   989,   255,   924,   467,
     470,   906,   387,  1101,   826,   827,   829,   752,   751,   752,
     162,   169,   761,  1117,    25,    73,   105,   128,   139,   159,
     164,   213,   234,   303,   329,   336,   343,   371,   376,   379,
     397,   422,   624,   742,   743,  1070,  1092,   465,  1070,  1074,
    1075,   425,  1087,  1088,  1034,  1070,   466,  1111,  1111,     3,
     106,   177,   237,   240,   340,   447,  1076,  1077,  1112,  1070,
    1070,  1070,  1111,  1111,  1034,   812,  1034,  1078,   332,   457,
     458,   466,  1035,  1036,  1067,  1080,   467,  1070,  1034,  1070,
    1081,  1034,    52,   162,   216,   388,  1034,  1070,  1084,  1070,
     242,  1036,  1034,  1044,  1045,  1046,   242,  1034,  1046,   467,
     470,  1111,  1032,  1011,  1034,  1034,  1034,  1034,  1120,   385,
      39,   373,  1096,   731,  1034,   466,   936,  1085,   125,   127,
     150,   251,   256,   261,   394,   404,  1034,   466,  1034,   387,
      47,   180,   185,   221,   354,  1034,  1034,  1034,  1034,  1034,
    1034,  1034,  1034,  1034,  1034,    26,    33,   359,  1064,   171,
     153,  1050,   332,   466,  1061,   167,   225,   376,   380,   382,
     406,   945,  1101,  1099,   162,   979,    26,   125,   418,   459,
     467,   788,  1034,  1071,  1072,  1118,   979,  1101,   389,   466,
    1112,   470,   467,   465,   471,   178,   178,   522,  1101,   891,
     892,  1101,  1034,   467,   466,   470,    36,   120,   410,   776,
     332,   333,   457,   458,   960,   962,  1036,   352,   210,   267,
     470,     4,   961,  1111,   961,   332,   333,   962,  1100,   255,
     356,   925,   973,   955,   410,   920,   111,   279,   466,   912,
     935,    35,  1117,   466,   927,   928,   929,  1117,   467,  1115,
    1103,  1103,   274,    53,  1118,   467,   788,   790,   787,   790,
    1118,   272,   467,   470,   732,  1115,  1103,  1103,  1106,  1115,
    1103,  1103,  1115,  1104,  1103,   111,   502,  1113,   329,   409,
     751,   336,   168,   751,   466,  1103,   410,   771,   210,   210,
     410,   466,   599,   179,  1103,   256,  1115,  1103,  1103,  1034,
     256,  1103,  1103,    29,   321,   387,   387,  1103,   387,   633,
     236,   795,   466,   731,   731,  1011,   392,   104,   376,   783,
     422,    67,   151,   814,  1103,   731,  1103,   731,   339,   157,
    1011,   731,   212,   173,   249,   281,   318,   414,   636,   637,
     638,   989,   387,   832,   336,   256,   147,   115,   205,  1115,
    1103,   266,  1103,   467,   470,  1114,  1116,  1103,   318,   518,
     179,   565,   251,  1011,  1103,  1117,  1103,   147,   220,  1103,
      26,   409,  1103,   179,  1103,   179,  1117,   334,   392,   334,
     392,   220,  1103,    26,   409,  1103,   220,   332,  1101,    22,
     130,   349,   643,   644,   645,   646,  1120,  1115,  1103,   111,
     163,   252,   410,   525,   528,   529,  1120,  1103,   264,    69,
     264,  1103,   520,   387,   379,  1101,   266,   387,   832,   336,
    1105,  1117,  1105,   470,   467,   470,  1115,  1103,   837,   838,
    1120,   266,   318,   387,   667,   990,   990,  1115,  1103,   990,
    1104,  1114,     3,    82,   135,   190,   287,   401,   409,   412,
     480,   318,  1115,  1103,   318,   349,   518,   612,   615,   731,
    1103,   615,   731,  1103,   615,  1115,  1103,  1115,  1103,  1103,
    1115,   802,  1103,   846,   847,  1120,  1103,   318,   349,   518,
     519,  1101,  1101,  1103,  1103,  1103,  1103,  1115,  1103,    22,
      28,   130,   281,   318,   349,   281,   318,   349,   700,   318,
     349,   318,   349,   119,   318,  1003,  1117,   179,   710,  1117,
     179,  1117,  1115,  1103,  1103,  1112,  1103,    22,   539,   346,
    1114,   318,   349,   518,  1103,  1103,   387,   387,    78,   400,
     306,   256,   739,  1112,    35,   128,   731,   739,   739,   206,
     410,   410,   739,   731,   731,   212,   731,   739,   739,   739,
     302,   543,   264,   162,   387,   542,   188,   455,   467,   470,
    1034,  1011,   731,   467,   470,   455,   674,   567,  1120,  1103,
      56,   162,   336,   421,   630,   637,   638,   145,   261,   221,
     559,   561,   563,   565,   572,   575,    23,   185,   329,   374,
     480,   481,   157,  1105,   422,  1101,    35,   668,   377,   990,
     700,   491,  1117,   492,   271,   558,  1103,   159,   731,  1070,
     303,  1112,   700,   700,   700,   700,   261,   266,   271,   466,
     700,  1001,  1002,  1003,   346,   145,   466,   145,   145,   144,
     935,   731,   261,   559,  1117,   429,   431,   595,   429,   527,
     251,    35,   578,  1112,   251,   266,   467,   785,   786,   791,
      35,   212,   326,   390,   428,   797,   798,   799,   266,   212,
     505,   176,   176,   157,   522,    35,  1070,   467,   467,   522,
     464,   449,   449,   467,   467,  1111,   465,  1111,   467,   177,
     237,  1033,   237,  1033,  1033,  1111,   240,   467,   522,   730,
     731,  1105,   731,  1105,   522,   522,   212,   522,   346,   157,
     505,   522,   522,   266,   522,   251,   467,   580,   185,   185,
     185,   433,  1102,   615,   616,   171,   755,   756,  1115,    23,
     761,   387,   466,   162,   143,   352,   143,   352,   332,   408,
     239,  1011,  1115,   429,   603,  1101,  1103,   162,   266,   755,
      53,   522,   795,  1011,   392,   376,   783,   260,   422,  1011,
     212,   731,  1103,   467,   465,   465,   470,  1034,   132,  1088,
    1089,    35,   467,  1034,   467,   467,   467,   162,   467,   467,
     467,   467,   467,   470,   467,   288,  1079,   467,   466,  1035,
    1035,  1070,    11,    15,    16,    17,   185,   206,   268,   453,
     454,   455,   457,   458,   459,   460,   461,   462,  1067,  1035,
     467,   467,   157,   162,  1082,  1083,   467,    35,  1084,  1070,
    1084,  1084,   162,   467,   467,  1120,   286,  1048,    35,   467,
     470,  1034,  1120,   470,  1034,  1095,  1034,   467,   449,  1035,
    1035,   138,  1070,   162,   125,   127,   150,   256,   261,   394,
     404,   466,   138,   812,  1034,   373,  1096,  1034,  1085,  1034,
     387,   466,   936,   466,   466,   276,  1054,   466,  1070,   380,
     382,   380,   382,  1101,   946,   946,   946,   215,   333,   446,
     466,   936,   980,   981,   982,   989,   994,  1004,  1037,  1039,
    1040,  1109,  1117,   426,   999,  1071,  1071,  1072,   467,    13,
      14,   470,   950,   951,   999,   864,  1111,  1032,   500,  1034,
    1093,   897,   906,   953,   268,  1065,  1068,   451,   777,     4,
    1111,   962,   267,   408,   959,   230,   980,   426,  1000,   416,
     375,   409,   913,   914,   915,  1117,   266,   916,  1117,   929,
     930,   470,   979,   455,  1095,   794,   732,   790,   790,    53,
     792,   461,  1116,  1116,   266,  1102,   269,   266,  1034,   576,
    1105,   466,   466,   466,   599,   188,   579,   689,   145,   522,
     387,  1115,  1103,   505,  1103,  1011,  1103,   433,   731,   731,
     731,   731,    80,   122,   283,   381,  1011,  1103,   619,  1103,
     173,   414,   387,   387,   619,   636,   642,   318,   349,   518,
    1103,  1103,  1103,   196,  1103,   256,   786,   280,   349,   387,
     251,   145,   270,   640,   689,    22,   130,   322,   323,   349,
     521,   530,   531,   642,   833,  1103,   341,   145,   522,   145,
     522,  1103,  1103,  1103,  1103,   341,   341,   220,   645,   646,
     645,   467,   470,   647,  1112,   188,   467,   470,   455,   468,
    1115,  1103,   318,   349,   518,   147,  1103,  1103,  1103,   281,
     318,   349,    22,   130,   281,   318,   349,  1011,   250,  1011,
     467,   470,   455,  1101,   387,  1116,   410,   664,   222,   287,
     256,  1112,   287,  1116,   407,   387,   387,   336,   470,   802,
     280,   349,    83,   387,   832,   336,   157,   532,   387,   387,
     232,   232,   232,   387,   387,   336,   387,   387,   336,   387,
     336,   387,   336,   266,   387,   522,  1011,   251,  1112,   349,
     833,   145,   522,   387,   387,  1103,   387,   336,  1115,  1103,
    1011,   731,   206,   739,  1105,  1105,   206,   206,  1103,   206,
     366,   367,   544,  1112,   543,   173,   250,   268,   457,   458,
     615,   703,   790,  1068,  1112,  1124,     3,   706,   467,   467,
     162,   700,   702,   703,   266,    65,    71,    83,   111,   113,
     166,   192,   251,   256,   297,   312,   403,   568,   569,   571,
     144,   425,   477,   505,  1103,   505,   640,  1101,  1101,  1101,
     467,   470,  1116,   171,   329,  1116,  1111,   397,  1101,   578,
       3,   157,   669,    43,   492,   320,   376,   649,   104,   897,
     162,   846,   527,   579,  1101,   675,   707,   708,  1112,   467,
     470,  1103,   157,   579,  1101,   602,  1101,  1103,   603,   466,
     560,  1101,   467,   264,   526,   264,   266,   596,   526,    35,
     145,   935,   527,   387,   145,  1101,   467,   470,   111,   455,
     800,  1112,   505,   376,   789,   790,   157,   801,   799,   802,
     116,   198,   342,   408,   855,  1103,   173,   935,  1011,   467,
    1111,  1031,  1031,   465,   465,   467,   522,   410,   522,   410,
     522,  1103,  1103,   659,   522,   731,   145,   336,   336,   336,
    1102,   470,  1115,   429,   470,   757,   269,   990,   346,   143,
     143,   104,   249,  1116,   754,   522,  1115,   206,   206,   206,
     615,   206,   206,   206,  1074,   384,  1034,   136,  1011,   467,
    1034,  1034,  1034,  1082,   467,  1070,   470,  1011,  1035,  1035,
    1035,  1035,   125,   127,   251,   261,  1035,  1035,  1035,  1035,
    1035,  1035,  1035,  1035,  1035,  1035,  1034,  1034,  1083,  1082,
    1011,   467,   467,   467,  1070,   467,   470,    53,  1036,   467,
    1120,  1045,   294,   370,  1047,   467,   470,   421,  1041,    35,
     467,  1112,  1034,    32,    32,  1034,   467,  1034,   162,   466,
    1073,  1034,   467,   138,  1035,  1035,   138,   138,  1034,  1034,
     951,   426,   466,  1055,  1117,   467,  1070,   470,   946,   946,
     946,   946,  1101,  1101,  1101,   936,   994,  1004,   162,   466,
     936,   981,   982,    35,   983,   984,  1117,   470,    91,   163,
     194,   209,   219,   245,   328,   986,   984,    35,   983,   985,
    1117,   984,   452,   998,   466,  1094,  1034,   171,   964,   470,
     950,   950,   950,  1034,  1034,   418,  1072,   467,   964,   467,
     465,   467,   466,   777,   154,   214,   267,    94,  1034,   325,
     918,   415,   467,   470,  1095,    81,   918,   467,   470,   928,
    1000,  1034,   467,   461,   794,   397,   165,   337,   344,   377,
     398,   766,   157,   766,   467,   466,   582,   583,   773,  1039,
    1117,   579,   579,   689,  1107,   467,   113,   192,   249,   251,
     690,  1103,  1103,    35,  1103,   410,   410,   731,   731,   731,
     731,   212,   732,  1115,  1103,   387,   832,   336,   387,   196,
      53,   379,  1103,   145,   565,   466,   567,   166,   178,   251,
     526,   477,   104,   166,   251,   365,   368,   526,   613,   349,
     531,   397,  1103,  1117,   341,   644,  1103,   529,   703,  1120,
     280,   349,   387,   832,   336,  1103,   387,   387,   387,   336,
     164,   268,   368,   712,   713,   164,   268,   720,   721,   387,
     387,   336,   467,   467,   467,   838,   250,   615,   790,   839,
    1068,  1112,  1124,   318,  1103,   466,   429,   665,  1113,  1112,
    1112,  1112,  1103,  1103,  1103,   847,    53,   379,  1103,  1103,
    1103,  1103,   416,  1103,  1103,   157,   157,   320,   157,   179,
    1115,  1103,  1103,  1115,  1103,  1103,  1103,  1103,  1103,  1103,
     147,  1103,    71,   523,   145,    24,    45,   397,  1117,  1103,
    1112,   642,  1103,  1103,   467,   206,   739,   206,   206,   739,
     739,   206,   739,   477,   544,   619,   689,   429,   431,   731,
    1101,   466,   731,  1103,  1035,    29,    53,   570,   114,   181,
     113,   256,   210,  1101,   802,   301,   692,   693,  1117,   629,
     285,   466,   560,   573,   191,   589,   563,  1116,  1116,  1011,
     466,   527,    26,   116,   198,   342,   408,   670,   387,   666,
    1115,   179,  1101,   651,   433,   266,   980,   802,   313,   676,
     467,   470,  1003,   640,   659,   467,   610,    35,   261,   285,
     466,   908,   562,   564,   566,   575,  1117,   285,   590,   591,
     560,   589,    77,   379,   597,   935,   605,   603,   597,  1112,
    1107,   771,   791,  1034,  1034,   470,   466,   797,   397,   470,
     387,   466,   619,   467,   465,  1105,  1105,   522,   346,   522,
    1102,  1102,  1102,   615,   168,   756,   467,  1103,   104,   761,
     162,   256,   744,  1112,   744,   744,   206,   744,   744,   744,
    1034,   467,   467,  1083,   467,  1034,   162,   125,   127,   261,
     466,   467,   436,  1043,  1070,   311,    53,   427,   427,   467,
    1034,   249,  1034,   470,  1042,  1013,  1034,  1034,  1034,  1073,
     467,  1034,    32,    32,  1034,  1034,   138,   467,   467,  1034,
    1056,  1117,   467,  1034,  1101,  1101,  1101,  1101,   984,   985,
     984,   466,   441,  1036,   467,  1117,   466,   981,   209,   275,
     987,   981,   987,   209,   986,   987,   209,   378,   992,   466,
    1117,   466,   273,  1071,    53,   174,   971,   467,   467,   467,
    1072,  1112,   971,  1112,   812,   261,  1098,   935,   279,   935,
     915,   266,   466,   917,   455,   929,   918,   397,   467,   387,
     751,   162,   689,  1034,   467,   470,   429,    71,   774,   774,
     467,   467,   802,   114,   181,   190,   113,   412,   522,  1011,
    1105,  1105,  1103,  1103,  1103,  1103,  1103,  1116,  1103,   565,
     641,   645,   570,   179,   256,   615,   570,   256,  1113,  1117,
    1011,   522,   522,   455,    53,   379,  1103,  1103,  1103,  1103,
    1115,  1103,  1103,  1111,  1111,  1011,   470,  1111,  1111,   470,
    1115,  1103,  1103,   387,  1034,    65,  1116,  1103,   387,   387,
     162,   185,  1102,  1102,   731,  1102,   145,  1103,   731,  1112,
    1112,  1011,   522,   522,   206,   739,   739,   739,   739,   466,
     545,   546,   410,   550,   551,   164,   195,   164,   162,   688,
    1034,   251,   569,   111,    35,   802,   578,   410,   598,  1109,
      32,   144,   185,   261,   559,   532,   142,   186,   466,   346,
     410,   579,    35,  1116,   664,   492,   251,   466,   159,  1103,
    1070,   247,   265,   677,   678,   679,   157,   682,  1112,   346,
     527,   144,   935,   731,   261,   559,   603,   467,   470,   429,
     567,    53,   595,   532,   590,   116,   130,   294,  1103,   429,
     867,    35,   162,   266,   466,  1112,   788,   803,   804,  1118,
     802,  1011,   157,  1101,   162,   387,   823,   193,   620,   522,
     522,   522,  1103,   269,   204,   522,   755,   744,   467,  1035,
     162,   466,  1073,   466,   467,   470,   467,  1036,   311,   467,
     415,   362,   467,   467,   467,  1034,  1034,  1034,   467,   285,
    1057,   467,   995,   996,  1039,   466,  1048,   983,   466,  1102,
     981,   266,   410,   988,   981,   209,   981,  1109,  1002,   466,
    1002,  1117,   950,    93,   172,   331,   466,   965,   966,   967,
     968,   969,   970,  1034,  1034,   428,  1051,   950,  1051,   467,
     932,   913,    83,   772,   773,   126,  1034,   755,   266,   755,
     467,   802,   583,   268,   812,   731,   731,   775,   775,   312,
     802,   598,   467,   387,   349,   924,   467,   470,    35,   145,
     523,   703,  1116,  1103,   387,   466,   783,   812,   814,   713,
     466,   466,   721,  1103,   467,   466,   349,   924,  1103,  1103,
     466,   466,   429,   452,   885,   320,   885,   885,   157,   523,
     739,   552,   553,  1120,    49,    92,   117,   134,   138,   158,
     161,   175,   256,   264,   304,   547,   477,   118,   783,    35,
     819,   819,  1101,   689,   467,   178,   598,   233,   581,   188,
     466,   693,   301,   466,  1101,   467,   346,    26,    76,    84,
     112,   178,   189,   365,   368,   574,   574,  1100,  1103,  1105,
     467,   935,   665,   145,   104,   640,   162,   678,   332,   376,
     680,   131,   683,   425,   685,  1103,    35,  1103,   603,   560,
    1101,   467,   564,   270,     3,   592,  1121,   596,   590,   595,
     333,   333,    57,    65,   225,   935,   731,  1101,   772,   790,
     467,   470,   397,   999,   360,   360,   467,   619,   249,   414,
     621,   622,  1103,   522,  1035,  1073,   467,  1044,  1070,    53,
     249,   448,    53,   950,   467,   470,    35,   997,   111,  1009,
    1010,  1035,    74,  1102,   467,  1034,   466,   981,   988,   466,
     467,  1002,   467,   467,   466,   350,   466,   467,   470,  1052,
    1053,  1117,   467,   415,  1103,   467,   470,   252,   408,   757,
     766,   522,   774,   598,   466,   776,   776,  1101,   598,   689,
    1103,   379,   645,   178,   410,   524,   349,   924,  1103,  1073,
     157,   716,   716,  1073,  1073,  1034,   379,   150,   235,   238,
     256,   394,   533,   535,   536,   615,  1112,   533,   534,   730,
     731,   730,   731,  1102,   522,   467,   470,   459,   466,   502,
     554,   615,   882,  1112,   882,   251,   256,   304,   882,   882,
     545,  1112,   819,    38,   183,   157,   249,   577,   466,   611,
     163,   284,   355,   266,   585,   586,   587,   379,   467,  1109,
       5,   694,   560,   589,  1103,   467,   640,   151,   715,   527,
     867,  1101,   433,   980,   882,   332,   364,   684,   466,   144,
     640,   935,   908,   590,   560,   589,   567,   466,   597,   595,
     596,    65,   269,    65,   603,   771,   467,   797,   803,  1011,
     126,   429,   429,   414,   619,   640,   467,   467,   467,   311,
     415,  1070,   305,   333,  1058,   998,   995,   466,  1035,   467,
     470,    35,  1005,  1006,  1117,   467,  1102,  1070,   467,  1070,
     466,  1070,   966,   470,    35,   935,   999,   773,   349,   162,
     775,   426,   584,   812,   777,   777,   578,   689,  1103,   611,
    1034,   379,   467,   272,   339,   309,   717,   717,   467,   467,
     467,  1103,   467,   470,   467,   470,   885,   553,   502,   555,
     556,  1112,  1112,   256,   579,   459,   579,  1112,  1112,   131,
     190,   612,   116,   408,   266,   587,   266,   586,  1103,   466,
     467,   470,   532,   346,   640,   731,    35,    35,   466,  1103,
     681,  1117,  1034,   301,   867,   603,   595,   532,   590,   466,
     593,   594,  1039,  1117,   596,   597,   269,   269,   466,   527,
     802,    27,   199,   856,   164,   164,    47,    94,   399,  1034,
    1059,  1060,  1059,   467,  1002,   470,  1010,  1120,   467,   470,
     157,  1011,   467,   467,   467,   965,   467,  1053,  1055,   927,
     755,   776,   466,   689,   467,   581,   924,  1103,   783,    53,
     924,   387,   536,   533,   731,   467,   470,   579,   332,   467,
      56,   249,   324,   349,   588,   588,   467,     5,   346,  1103,
     712,   935,   640,   467,  1109,   596,   590,   595,  1034,   467,
     470,   774,   774,   597,   772,   597,   252,   466,   851,   853,
     857,   910,   919,   926,   935,   783,   783,  1060,   332,   156,
     292,   156,   292,   467,  1036,  1006,   273,     3,   111,   251,
     256,  1007,  1008,   319,   993,   467,   999,   522,   777,  1034,
     585,   924,   731,   466,   556,   685,    21,   111,   256,  1103,
     640,   867,   466,   597,   595,   596,   467,   594,   775,   775,
     467,   999,   852,   853,   854,   936,   937,   470,   470,    32,
    1048,  1035,  1035,   256,  1008,   466,   467,   689,   535,   144,
     640,     4,   686,   687,  1111,  1112,  1120,   596,   597,   774,
     527,   467,   469,   387,   162,  1060,    74,  1034,   467,   301,
     467,   470,   597,   775,   597,   854,   360,   360,  1005,   467,
    1109,   687,   999,   429,   429,   467,   466,   164,   164,   686,
     783,   783,   467
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   472,   473,   474,   474,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   476,
     477,   477,   477,   478,   478,   479,   479,   480,   480,   480,
     480,   480,   480,   480,   480,   480,   481,   481,   481,   481,
     481,   481,   482,   483,   483,   484,   484,   485,   485,   485,
     485,   486,   486,   486,   486,   486,   486,   487,   488,   489,
     489,   490,   490,   490,   490,   491,   491,   492,   492,   493,
     493,   493,   493,   493,   493,   494,   494,   494,   495,   495,
     495,   496,   496,   496,   496,   497,   497,   497,   497,   497,
     497,   497,   497,   497,   497,   497,   498,   498,   499,   499,
     500,   500,   501,   501,   501,   501,   502,   502,   502,   502,
     503,   503,   503,   503,   503,   503,   503,   504,   504,   504,
     505,   505,   506,   507,   507,   507,   507,   508,   508,   509,
     509,   510,   510,   511,   511,   511,   511,   511,   512,   513,
     513,   514,   514,   515,   516,   516,   516,   516,   516,   517,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   517,
     517,   517,   517,   517,   517,   517,   517,   518,   518,   519,
     519,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   521,   521,   522,
     522,   522,   523,   523,   524,   524,   525,   525,   525,   525,
     526,   527,   527,   528,   528,   529,   529,   529,   529,   530,
     530,   531,   531,   531,   531,   532,   532,   533,   533,   533,
     533,   533,   534,   534,   535,   535,   536,   536,   536,   537,
     538,   538,   539,   539,   539,   539,   540,   540,   541,   541,
     542,   542,   543,   543,   544,   544,   544,   545,   545,   546,
     546,   547,   547,   547,   547,   547,   547,   547,   547,   547,
     547,   547,   547,   547,   547,   548,   548,   549,   549,   550,
     550,   551,   551,   552,   552,   553,   554,   554,   554,   554,
     554,   555,   555,   556,   557,   557,   557,   557,   557,   557,
     558,   558,   558,   558,   558,   558,   558,   558,   559,   559,
     560,   560,   561,   561,   562,   562,   563,   563,   563,   564,
     564,   565,   566,   566,   567,   567,   568,   568,   568,   568,
     569,   569,   569,   569,   569,   569,   569,   569,   570,   570,
     571,   571,   571,   571,   572,   573,   573,   573,   574,   574,
     574,   574,   574,   574,   574,   574,   575,   575,   576,   576,
     576,   576,   576,   576,   576,   577,   577,   578,   578,   579,
     579,   580,   581,   581,   581,   581,   582,   582,   583,   583,
     584,   584,   585,   585,   585,   585,   585,   586,   587,   588,
     588,   588,   588,   588,   589,   589,   590,   590,   591,   592,
     592,   593,   593,   594,   594,   594,   595,   595,   595,   595,
     596,   596,   596,   596,   597,   597,   598,   598,   599,   600,
     600,   601,   601,   602,   603,   603,   603,   604,   604,   605,
     606,   606,   607,   608,   608,   609,   609,   610,   610,   611,
     611,   612,   612,   613,   613,   613,   613,   613,   613,   613,
     613,   613,   613,   613,   613,   613,   613,   614,   614,   615,
     615,   615,   615,   616,   616,   617,   617,   618,   618,   619,
     619,   620,   620,   621,   621,   622,   622,   623,   623,   624,
     624,   625,   626,   626,   627,   627,   628,   628,   629,   629,
     630,   630,   630,   630,   631,   632,   632,   633,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   635,   636,   636,   636,   636,   637,
     637,   638,   638,   639,   639,   640,   640,   641,   641,   642,
     643,   643,   644,   644,   644,   644,   645,   646,   647,   648,
     648,   649,   649,   650,   650,   651,   651,   652,   652,   652,
     653,   653,   653,   653,   654,   654,   655,   656,   656,   657,
     657,   658,   658,   659,   659,   660,   660,   661,   662,   663,
     664,   664,   665,   665,   666,   666,   667,   667,   668,   668,
     669,   669,   670,   670,   670,   670,   670,   671,   672,   672,
     673,   673,   673,   674,   674,   675,   675,   675,   675,   675,
     676,   676,   677,   677,   678,   679,   679,   680,   680,   681,
     682,   682,   683,   683,   684,   684,   685,   685,   686,   686,
     686,   687,   687,   687,   687,   688,   688,   689,   689,   690,
     690,   690,   690,   690,   690,   691,   691,   692,   692,   693,
     694,   694,   695,   696,   696,   696,   696,   697,   698,   699,
     699,   699,   699,   699,   699,   699,   699,   699,   699,   699,
     699,   699,   699,   699,   699,   700,   701,   701,   702,   702,
     703,   703,   703,   703,   703,   703,   704,   705,   705,   706,
     707,   707,   708,   708,   709,   709,   709,   709,   710,   710,
     711,   712,   712,   713,   713,   713,   713,   713,   714,   714,
     715,   715,   716,   716,   716,   717,   717,   718,   719,   719,
     720,   720,   721,   721,   722,   722,   723,   723,   724,   725,
     726,   726,   726,   726,   726,   726,   726,   726,   726,   726,
     726,   726,   727,   727,   727,   727,   727,   727,   727,   727,
     727,   727,   727,   727,   727,   728,   728,   728,   728,   728,
     728,   728,   729,   729,   729,   730,   730,   731,   731,   732,
     732,   733,   733,   734,   735,   735,   735,   736,   736,   736,
     736,   736,   736,   736,   736,   736,   736,   736,   736,   736,
     736,   736,   736,   736,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   737,   737,   737,   737,   738,   738,
     738,   738,   738,   738,   738,   738,   738,   738,   738,   738,
     739,   739,   740,   740,   740,   740,   740,   740,   740,   741,
     741,   742,   742,   742,   742,   742,   742,   743,   743,   743,
     743,   743,   743,   743,   743,   744,   744,   745,   745,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   747,   747,   748,   748,   749,
     750,   750,   751,   751,   751,   751,   751,   752,   752,   753,
     753,   753,   753,   754,   754,   754,   754,   754,   754,   754,
     754,   754,   754,   754,   754,   754,   754,   754,   754,   755,
     755,   756,   756,   757,   757,   758,   759,   759,   760,   760,
     761,   761,   762,   763,   763,   764,   764,   764,   765,   765,
     765,   766,   766,   766,   766,   766,   767,   767,   768,   768,
     769,   769,   770,   770,   771,   771,   772,   772,   773,   773,
     773,   774,   774,   775,   775,   776,   776,   776,   777,   777,
     777,   778,   778,   778,   779,   779,   780,   780,   781,   781,
     782,   782,   783,   783,   783,   783,   784,   784,   785,   785,
     786,   786,   786,   786,   786,   787,   787,   787,   787,   787,
     788,   789,   790,   790,   790,   791,   791,   791,   792,   793,
     793,   793,   793,   794,   794,   795,   796,   796,   797,   797,
     798,   798,   798,   798,   798,   798,   798,   798,   798,   798,
     798,   798,   798,   798,   798,   798,   799,   799,   799,   799,
     799,   800,   800,   801,   801,   802,   802,   803,   804,   804,
     805,   806,   806,   807,   807,   808,   808,   809,   809,   810,
     810,   811,   811,   811,   811,   812,   812,   813,   813,   814,
     815,   816,   816,   817,   817,   818,   818,   818,   819,   819,
     819,   820,   821,   821,   822,   823,   823,   823,   823,   824,
     825,   825,   825,   825,   826,   826,   827,   827,   827,   828,
     828,   829,   830,   830,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   832,   832,   833,   833,   834,
     834,   834,   834,   835,   835,   835,   835,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   835,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   835,   835,   836,   837,
     837,   838,   838,   839,   839,   839,   839,   839,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   840,
     841,   842,   842,   843,   843,   844,   844,   844,   844,   845,
     846,   846,   847,   848,   848,   848,   848,   848,   848,   849,
     849,   850,   851,   851,   851,   852,   852,   853,   853,   853,
     853,   853,   854,   854,   855,   855,   855,   855,   856,   856,
     856,   857,   858,   858,   859,   860,   860,   861,   861,   861,
     861,   861,   861,   861,   861,   861,   861,   861,   861,   861,
     861,   862,   862,   862,   863,   863,   863,   863,   863,   864,
     864,   864,   865,   865,   866,   866,   866,   866,   867,   867,
     867,   867,   868,   869,   870,   870,   871,   871,   872,   872,
     872,   873,   873,   873,   873,   873,   873,   873,   874,   874,
     875,   875,   875,   876,   877,   877,   878,   879,   879,   880,
     881,   881,   881,   881,   881,   881,   881,   882,   882,   883,
     884,   884,   884,   884,   884,   884,   885,   885,   886,   887,
     887,   887,   888,   888,   889,   889,   889,   889,   889,   890,
     890,   891,   891,   891,   891,   891,   892,   892,   893,   893,
     894,   894,   895,   895,   896,   896,   897,   897,   898,   898,
     898,   898,   899,   899,   899,   899,   899,   899,   899,   899,
     899,   900,   900,   901,   902,   902,   903,   903,   903,   904,
     905,   905,   906,   906,   906,   906,   907,   907,   907,   908,
     908,   909,   909,   909,   909,   910,   911,   911,   912,   912,
     912,   912,   912,   913,   913,   914,   914,   915,   916,   916,
     916,   917,   917,   917,   918,   918,   919,   920,   920,   921,
     922,   922,   923,   923,   923,   923,   923,   923,   923,   923,
     924,   924,   925,   925,   925,   926,   927,   927,   928,   928,
     929,   930,   930,   931,   932,   933,   933,   933,   933,   933,
     934,   934,   934,   935,   935,   936,   936,   937,   937,   937,
     937,   937,   937,   937,   937,   938,   938,   939,   939,   939,
     939,   939,   939,   939,   940,   940,   940,   941,   941,   942,
     943,   943,   944,   944,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   946,   946,   947,   947,   947,   948,   948,
     949,   949,   950,   950,   951,   952,   952,   953,   953,   954,
     954,   954,   954,   955,   955,   956,   956,   956,   956,   957,
     957,   958,   958,   959,   960,   960,   960,   961,   961,   962,
     962,   963,   963,   964,   964,   965,   965,   966,   966,   966,
     966,   966,   967,   968,   969,   970,   971,   971,   972,   972,
     973,   973,   974,   974,   975,   976,   976,   976,   976,   977,
     977,   978,   978,   979,   979,   980,   980,   981,   981,   981,
     981,   981,   981,   981,   981,   981,   981,   982,   982,   982,
     982,   982,   982,   983,   983,   983,   983,   984,   984,   985,
     985,   985,   985,   985,   986,   986,   986,   986,   987,   987,
     988,   988,   989,   989,   989,   989,   990,   990,   991,   991,
     991,   992,   993,   993,   994,   994,   995,   996,   996,   997,
     997,   998,   998,   999,   999,  1000,  1000,  1000,  1001,  1001,
    1002,  1002,  1003,  1004,  1004,  1005,  1005,  1006,  1006,  1006,
    1007,  1007,  1008,  1008,  1008,  1008,  1009,  1009,  1010,  1010,
    1011,  1011,  1011,  1011,  1011,  1011,  1012,  1012,  1012,  1013,
    1013,  1013,  1013,  1013,  1013,  1013,  1014,  1014,  1014,  1014,
    1015,  1015,  1016,  1016,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1018,  1018,  1019,  1019,  1020,
    1020,  1021,  1022,  1023,  1023,  1024,  1024,  1025,  1026,  1027,
    1027,  1027,  1027,  1027,  1027,  1028,  1028,  1029,  1029,  1029,
    1029,  1030,  1031,  1031,  1031,  1032,  1032,  1032,  1032,  1032,
    1032,  1032,  1032,  1032,  1032,  1032,  1032,  1032,  1032,  1033,
    1033,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,
    1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,
    1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,
    1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,
    1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,
    1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,  1034,
    1034,  1034,  1034,  1034,  1034,  1035,  1035,  1035,  1035,  1035,
    1035,  1035,  1035,  1035,  1035,  1035,  1035,  1035,  1035,  1035,
    1035,  1035,  1035,  1035,  1035,  1035,  1035,  1035,  1035,  1035,
    1036,  1036,  1036,  1036,  1036,  1036,  1036,  1036,  1036,  1036,
    1036,  1036,  1036,  1036,  1037,  1037,  1037,  1037,  1037,  1037,
    1037,  1038,  1038,  1039,  1039,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1041,  1041,  1042,
    1042,  1042,  1042,  1043,  1044,  1044,  1045,  1045,  1046,  1046,
    1047,  1047,  1047,  1048,  1048,  1048,  1048,  1049,  1049,  1050,
    1050,  1051,  1051,  1052,  1052,  1053,  1054,  1054,  1054,  1055,
    1056,  1056,  1057,  1057,  1058,  1058,  1058,  1059,  1059,  1060,
    1060,  1060,  1060,  1060,  1061,  1061,  1061,  1062,  1062,  1063,
    1064,  1064,  1064,  1065,  1065,  1066,  1066,  1066,  1066,  1066,
    1066,  1066,  1066,  1066,  1066,  1066,  1066,  1067,  1067,  1068,
    1068,  1069,  1069,  1069,  1069,  1069,  1069,  1070,  1070,  1071,
    1071,  1072,  1072,  1072,  1073,  1073,  1074,  1074,  1074,  1075,
    1075,  1076,  1076,  1077,  1077,  1077,  1077,  1077,  1077,  1077,
    1077,  1078,  1078,  1079,  1080,  1080,  1081,  1081,  1081,  1081,
    1081,  1081,  1082,  1083,  1084,  1084,  1084,  1085,  1085,  1086,
    1087,  1087,  1088,  1089,  1089,  1090,  1090,  1091,  1091,  1092,
    1092,  1092,  1092,  1093,  1093,  1094,  1094,  1095,  1095,  1096,
    1096,  1097,  1097,  1098,  1098,  1099,  1099,  1099,  1099,  1100,
    1100,  1101,  1101,  1102,  1102,  1103,  1104,  1105,  1106,  1107,
    1108,  1109,  1109,  1110,  1110,  1110,  1110,  1110,  1110,  1110,
    1110,  1110,  1110,  1110,  1110,  1110,  1111,  1112,  1113,  1113,
    1113,  1114,  1115,  1115,  1115,  1116,  1116,  1117,  1117,  1117,
    1118,  1118,  1118,  1119,  1119,  1119,  1119,  1120,  1120,  1120,
    1120,  1120,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1123,  1123,  1123,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     5,
       1,     1,     0,     2,     0,     2,     0,     2,     2,     3,
       3,     1,     3,     3,     2,     1,     1,     2,     2,     2,
       3,     3,     5,     5,     5,     0,     3,     5,     5,     5,
       5,     3,     5,     3,     5,     3,     5,     5,     6,     1,
       1,     6,     4,     9,     7,     1,     0,     2,     0,     1,
       1,     1,     1,     1,     1,     2,     3,     3,     2,     5,
       1,     3,     3,     3,     3,     1,     3,     3,     2,     2,
       2,     2,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     5,     1,     1,     1,     1,     1,     0,
       1,     1,     2,     1,     2,     3,     2,     1,     1,     2,
       1,     2,     1,     2,     3,     4,     3,     2,     4,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     4,
       6,     4,     6,    10,    13,     4,     6,    10,    13,     4,
       6,     4,     6,     5,     7,    11,    14,     1,     3,     4,
       3,     2,     5,     3,     6,     4,     6,     6,     6,     5,
       5,     6,     9,     4,     5,     7,     6,     4,     8,     4,
       2,     4,     3,     6,     4,     3,     3,     3,     3,     2,
       2,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     4,     3,     2,     3,     2,     2,     3,     3,     2,
       2,     3,     4,     4,     4,     5,     1,     3,     2,     1,
       1,     0,     2,     0,     2,     0,     1,     1,     1,     3,
       3,     2,     0,     1,     3,     3,     1,     5,     3,     1,
       2,     1,     3,     2,     3,     6,    10,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     1,     4,
       1,     3,     4,     6,     4,     8,     2,     2,    11,     9,
       1,     1,     1,     0,     1,     1,     1,     1,     3,     2,
       0,     1,     1,     1,     3,     3,     1,     1,     3,     3,
       3,     3,     4,     3,     2,     1,     0,     2,     0,     3,
       0,     1,     0,     1,     3,     2,     1,     1,     1,     3,
       0,     1,     3,     1,    12,    15,    11,    14,    13,    16,
       1,     1,     2,     2,     2,     2,     1,     0,     1,     0,
       3,     0,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     4,     2,     4,     2,     0,     3,     1,     1,     2,
       2,     1,     3,     4,     5,     2,     5,     5,     1,     2,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     5,     7,
       3,     8,     4,     9,    11,     2,     0,     3,     0,     1,
       3,     1,     2,     2,     2,     0,     1,     3,     3,     6,
       4,     0,     1,     1,     2,     2,     0,     3,     3,     2,
       1,     1,     2,     2,     4,     0,     1,     0,     6,     1,
       1,     1,     3,     3,     3,     5,     2,     2,     2,     0,
       3,     4,     4,     0,     2,     0,     4,     0,     3,     8,
      11,     7,    10,     5,     2,     3,     0,     8,    11,     4,
       1,     0,     6,     5,     8,     4,     6,     1,     0,     3,
       0,     1,     2,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     3,     1,     3,     1,     0,     1,
       2,     2,     1,     1,     3,     6,    10,     1,     0,     1,
       2,     2,     0,     2,     2,     1,     0,     5,     7,     1,
       0,     7,     2,     0,     3,     5,     5,     8,     2,     0,
       2,     2,     2,     1,     5,     2,     0,     2,     7,     6,
      10,     6,     6,     6,     6,     7,     6,     9,     9,     6,
       7,     6,     8,     8,     8,     8,     6,     6,     7,     7,
       8,     6,     9,     6,     7,     2,     2,     2,     2,     1,
       2,     1,     0,     7,     6,     4,     0,     1,     3,     4,
       1,     3,     1,     2,     2,     2,     2,     1,     1,    10,
      13,     2,     0,     2,     2,     1,     0,     5,     4,     4,
      11,    14,    12,    15,     5,     7,    11,     2,     1,     4,
       0,     8,    11,     1,     1,     7,     9,     8,    10,     8,
       4,     0,     5,     0,     2,     0,     2,     0,     2,     0,
       2,     0,     1,     1,     1,     1,     1,     8,    16,    20,
       1,     1,     2,     1,     3,     1,     1,     1,     3,     1,
       2,     0,     1,     2,     4,     1,     1,     1,     1,     1,
       3,     0,     1,     0,     1,     1,     4,     0,     1,     3,
       0,     1,     1,     1,     1,     2,     0,     0,     2,     2,
       1,     2,     2,     2,     2,    11,    13,     1,     3,     5,
       1,     3,     5,     1,     2,     2,     1,     8,     4,     5,
       4,     4,     4,     3,     7,     8,     6,     6,     6,     6,
       6,     4,     7,     5,     8,     3,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     3,     3,
       1,     0,     1,     3,     7,     9,     9,     8,     3,     0,
      13,     1,     3,     5,     5,     3,     6,     2,     1,     0,
       2,     0,     2,     4,     0,     1,     0,     6,     8,     8,
       1,     3,     5,     5,     7,     9,     7,     9,     5,     6,
       6,     4,     6,     4,     6,     8,     4,     6,     4,     6,
       5,     7,     1,     1,     1,     2,     1,     2,     1,     1,
       1,     3,     3,     3,     3,     2,     2,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     2,
       3,     1,     3,     5,     2,     2,     0,     6,     6,     6,
       6,     6,     6,     6,     8,     9,     8,     8,     9,     8,
       9,     9,     7,    10,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     2,     3,     3,     3,     3,     2,     1,
       2,     1,     3,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     8,     8,     8,     8,     8,     8,     9,     2,
       0,     1,     2,     1,     1,     1,     2,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     3,     3,     3,     3,     4,     4,     3,     3,     3,
       4,     4,     3,     4,     4,     1,     1,     1,     0,     7,
       7,    10,     1,     1,     2,     4,     5,     1,     3,     2,
       2,     2,     2,     1,     2,     2,     4,     3,     2,     2,
       2,     2,     3,     2,     2,     2,     5,     5,     5,     1,
       3,     1,     2,     3,     0,     6,     6,     9,     3,     0,
       3,     0,     5,     2,     0,     3,     3,     3,     7,     7,
      10,     1,     1,     1,     1,     1,    14,    17,     1,     0,
       1,     0,     1,     0,     2,     0,     1,     3,     5,     5,
       7,     2,     0,     1,     0,     1,     1,     0,     2,     2,
       0,     9,    12,     7,     2,     0,     3,     2,     1,     3,
       1,     3,     2,     1,     1,     2,     3,     2,     1,     3,
       3,     3,     2,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     4,     5,     1,     3,     3,     1,     3,
       3,     5,     6,     1,     3,     2,     1,     3,     1,     2,
       4,     5,     1,     1,     1,     1,     3,     3,     2,     2,
       1,     2,     2,     2,     1,     2,     2,     2,     2,     1,
       1,     1,     3,     3,     5,     2,     0,     2,     1,     3,
       5,     1,     2,     1,     0,     4,     6,     4,     6,     4,
       6,     3,     5,     5,     5,     1,     3,     1,     3,     2,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,    10,    11,    11,     5,     5,     8,
       3,     3,     6,     6,     1,     1,     1,     1,     1,     1,
       3,     1,     5,     5,     6,     6,     6,     6,     6,     8,
       8,     6,     6,     7,     9,     9,     8,    10,     6,     6,
       6,     6,     6,     8,     6,     8,     6,     8,     7,     9,
       6,     8,     7,     9,     8,    10,     9,    11,     8,    10,
       9,    11,     8,     8,     7,     6,     6,     6,     6,     8,
       8,     8,     8,     6,     9,     1,     0,     2,     0,     7,
       9,     8,     7,     6,     6,     6,     6,     6,     6,     6,
       9,     9,     6,     8,     6,     8,     8,     8,     8,     6,
       8,     6,     8,     7,     9,     7,     9,     6,     7,     1,
       3,     3,     3,     1,     1,     1,     1,     1,     6,     6,
       6,     6,     6,     6,     7,     7,     6,     9,     9,     6,
       6,     6,     6,     8,     8,     8,     6,     7,     6,     6,
       5,     1,     0,     3,     3,     5,     6,     6,     6,     8,
       1,     3,     1,     5,     5,     6,     7,     4,     4,     4,
       6,    13,     1,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       0,     3,     2,     0,     2,     2,     2,     2,     3,     3,
       2,     2,     2,     2,     3,     2,     5,     4,     3,     3,
       3,     1,     1,     0,     3,     2,     2,     1,     2,     1,
       3,     2,     1,     0,     9,    11,    12,    14,     3,     4,
       4,     0,     2,     5,     1,     0,     1,     2,     3,     3,
       3,     1,     2,     1,     1,     1,     1,     1,     1,     0,
       5,     4,     6,     4,     3,     5,     5,     4,     4,     6,
       4,     6,     6,     5,     7,     9,     6,     1,     0,     6,
      11,    11,    11,    13,     9,    11,     1,     1,    10,     4,
       2,     5,     2,     0,     4,     5,     5,     4,     6,     1,
       3,     1,     1,     1,     1,     1,     2,     4,     1,     1,
       1,     0,     1,     0,     1,     0,     3,     0,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     1,     0,     5,
       3,     0,     1,     1,     1,     1,     3,     9,    12,     3,
       0,     2,     3,     2,     3,     7,     1,     3,     1,     4,
       4,     7,     2,     1,     1,     1,     3,     2,     8,     5,
       0,     4,     3,     0,     2,     0,     7,     2,     0,     5,
       3,     0,     2,     2,     2,     3,     1,     3,     1,     2,
       1,     0,     1,     2,     0,     8,     1,     3,     3,     5,
       2,     1,     3,     7,     1,     0,     3,     2,     2,     2,
       0,     2,     2,     1,     1,     3,     3,     1,     2,     4,
       4,     2,     3,     5,     5,     1,     1,     9,     9,     1,
       2,     4,     4,     4,     2,     2,     3,     1,     3,     6,
       1,     0,     2,     0,     3,     3,     4,     4,     4,     4,
       3,     2,     1,     1,     0,     1,     1,     0,     1,     5,
       1,     0,     1,     0,     3,     1,     3,     4,     3,     2,
       2,     1,     1,     1,     0,     2,     4,     5,     4,     2,
       3,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     3,     0,     1,     3,     1,     1,     1,
       1,     1,     2,     4,     4,     5,     2,     0,     1,     3,
       1,     0,     1,     2,     3,     2,     4,     2,     3,     2,
       0,     4,     5,     2,     0,     1,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     1,     4,     3,     4,     5,
       4,     5,     4,     5,     2,     4,     1,     1,     0,     1,
       4,     5,     4,     0,     2,     2,     2,     1,     1,     0,
       4,     2,     1,     2,     2,     4,     1,     3,     1,     2,
       3,     6,     4,     0,     2,     6,     2,     1,     3,     4,
       0,     2,     0,     2,     0,     2,     4,     0,     1,     0,
       1,     3,     3,     7,    12,     1,     3,     2,     3,     3,
       1,     2,     2,     2,     2,     1,     1,     3,     3,     2,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     4,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     4,     1,     2,
       2,     1,     3,     3,     2,     1,     0,     5,     2,     5,
       2,     1,     3,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     0,     1,
       4,     1,     3,     3,     5,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     3,     3,     2,     2,     3,     5,     4,     6,
       3,     5,     4,     6,     4,     6,     5,     7,     3,     2,
       4,     2,     3,     3,     4,     3,     4,     3,     4,     5,
       6,     6,     7,     6,     7,     6,     7,     3,     4,     4,
       6,     2,     3,     4,     1,     1,     3,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     5,     6,     6,     7,     3,     4,
       1,     1,     2,     4,     1,     1,     1,     2,     2,     2,
       2,     1,     1,     4,     3,     5,     6,     8,     6,     6,
       4,     4,     1,     1,     1,     5,     1,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     1,     1,     1,     1,
       1,     6,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       5,     4,     6,     5,     7,     7,     7,     2,     3,     3,
       3,     4,     0,     4,     1,     3,     3,     1,     1,     1,
       2,     2,     0,     2,     4,     4,     6,     5,     0,     5,
       0,     2,     0,     1,     3,     3,     2,     2,     0,     6,
       1,     0,     3,     0,     2,     2,     0,     1,     4,     2,
       2,     2,     2,     2,     4,     3,     5,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       4,     1,     4,     1,     2,     1,     2,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     2,     1,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     3,     2,     3,     0,     3,     3,     2,     2,
       1,     0,     2,     2,     3,     2,     1,     1,     3,     5,
       1,     2,     4,     2,     0,     1,     0,     1,     2,     2,
       2,     3,     5,     1,     0,     1,     2,     0,     2,     1,
       0,     1,     0,     1,     3,     3,     2,     1,     1,     1,
       3,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     6,
       2,     3,     5,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  YY_USE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, core_yyscan_t yyscanner)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  YY_USE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* stmtblock: stmtmulti  */
#line 776 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
				(void) yynerrs;		/* suppress compiler warning */
			}
#line 25280 "gram.c"
    break;

  case 3: /* stmtmulti: stmtmulti ';' stmt  */
#line 793 "gram.y"
                                {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 25296 "gram.c"
    break;

  case 4: /* stmtmulti: stmt  */
#line 805 "gram.y"
                                {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 25307 "gram.c"
    break;

  case 128: /* stmt: %empty  */
#line 938 "gram.y"
                                { (yyval.node) = NULL; }
#line 25313 "gram.c"
    break;

  case 129: /* CreateRoleStmt: CREATE ROLE RoleId opt_with OptRoleList  */
#line 949 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25325 "gram.c"
    break;

  case 130: /* opt_with: WITH  */
#line 959 "gram.y"
                                                                                        {}
#line 25331 "gram.c"
    break;

  case 131: /* opt_with: WITH_LA  */
#line 960 "gram.y"
                                                                                                {}
#line 25337 "gram.c"
    break;

  case 132: /* opt_with: %empty  */
#line 961 "gram.y"
                                                                                                {}
#line 25343 "gram.c"
    break;

  case 133: /* OptRoleList: OptRoleList CreateOptRoleElem  */
#line 970 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 25349 "gram.c"
    break;

  case 134: /* OptRoleList: %empty  */
#line 971 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 25355 "gram.c"
    break;

  case 135: /* AlterOptRoleList: AlterOptRoleList AlterOptRoleElem  */
#line 975 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 25361 "gram.c"
    break;

  case 136: /* AlterOptRoleList: %empty  */
#line 976 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 25367 "gram.c"
    break;

  case 137: /* AlterOptRoleElem: PASSWORD Sconst  */
#line 981 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 25376 "gram.c"
    break;

  case 138: /* AlterOptRoleElem: PASSWORD NULL_P  */
#line 986 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 25384 "gram.c"
    break;

  case 139: /* AlterOptRoleElem: ENCRYPTED PASSWORD Sconst  */
#line 990 "gram.y"
                                {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 25398 "gram.c"
    break;

  case 140: /* AlterOptRoleElem: UNENCRYPTED PASSWORD Sconst  */
#line 1000 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 25410 "gram.c"
    break;

  case 141: /* AlterOptRoleElem: INHERIT  */
#line 1008 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 25418 "gram.c"
    break;

  case 142: /* AlterOptRoleElem: CONNECTION LIMIT SignedIconst  */
#line 1012 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 25426 "gram.c"
    break;

  case 143: /* AlterOptRoleElem: VALID UNTIL Sconst  */
#line 1016 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 25434 "gram.c"
    break;

  case 144: /* AlterOptRoleElem: USER role_list  */
#line 1021 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 25442 "gram.c"
    break;

  case 145: /* AlterOptRoleElem: IDENT  */
#line 1025 "gram.y"
                                {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(TRUE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(FALSE), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 25491 "gram.c"
    break;

  case 146: /* CreateOptRoleElem: AlterOptRoleElem  */
#line 1072 "gram.y"
                                                                { (yyval.defelt) = (yyvsp[0].defelt); }
#line 25497 "gram.c"
    break;

  case 147: /* CreateOptRoleElem: SYSID Iconst  */
#line 1075 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 25505 "gram.c"
    break;

  case 148: /* CreateOptRoleElem: ADMIN role_list  */
#line 1079 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 25513 "gram.c"
    break;

  case 149: /* CreateOptRoleElem: ROLE role_list  */
#line 1083 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 25521 "gram.c"
    break;

  case 150: /* CreateOptRoleElem: IN_P ROLE role_list  */
#line 1087 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 25529 "gram.c"
    break;

  case 151: /* CreateOptRoleElem: IN_P GROUP_P role_list  */
#line 1091 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 25537 "gram.c"
    break;

  case 152: /* CreateUserStmt: CREATE USER RoleId opt_with OptRoleList  */
#line 1105 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25549 "gram.c"
    break;

  case 153: /* AlterRoleStmt: ALTER ROLE RoleSpec opt_with AlterOptRoleList  */
#line 1123 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 25561 "gram.c"
    break;

  case 154: /* AlterRoleStmt: ALTER USER RoleSpec opt_with AlterOptRoleList  */
#line 1131 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 25573 "gram.c"
    break;

  case 155: /* opt_in_database: %empty  */
#line 1141 "gram.y"
                                                                        { (yyval.str) = NULL; }
#line 25579 "gram.c"
    break;

  case 156: /* opt_in_database: IN_P DATABASE database_name  */
#line 1142 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 25585 "gram.c"
    break;

  case 157: /* AlterRoleSetStmt: ALTER ROLE RoleSpec opt_in_database SetResetClause  */
#line 1147 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 25597 "gram.c"
    break;

  case 158: /* AlterRoleSetStmt: ALTER ROLE ALL opt_in_database SetResetClause  */
#line 1155 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 25609 "gram.c"
    break;

  case 159: /* AlterRoleSetStmt: ALTER USER RoleSpec opt_in_database SetResetClause  */
#line 1163 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 25621 "gram.c"
    break;

  case 160: /* AlterRoleSetStmt: ALTER USER ALL opt_in_database SetResetClause  */
#line 1171 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 25633 "gram.c"
    break;

  case 161: /* DropRoleStmt: DROP ROLE role_list  */
#line 1192 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25644 "gram.c"
    break;

  case 162: /* DropRoleStmt: DROP ROLE IF_P EXISTS role_list  */
#line 1199 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25655 "gram.c"
    break;

  case 163: /* DropRoleStmt: DROP USER role_list  */
#line 1206 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25666 "gram.c"
    break;

  case 164: /* DropRoleStmt: DROP USER IF_P EXISTS role_list  */
#line 1213 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 25677 "gram.c"
    break;

  case 165: /* DropRoleStmt: DROP GROUP_P role_list  */
#line 1220 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25688 "gram.c"
    break;

  case 166: /* DropRoleStmt: DROP GROUP_P IF_P EXISTS role_list  */
#line 1227 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25699 "gram.c"
    break;

  case 167: /* CreateGroupStmt: CREATE GROUP_P RoleId opt_with OptRoleList  */
#line 1244 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25711 "gram.c"
    break;

  case 168: /* AlterGroupStmt: ALTER GROUP_P RoleSpec add_drop USER role_list  */
#line 1262 "gram.y"
                                {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 25724 "gram.c"
    break;

  case 169: /* add_drop: ADD_P  */
#line 1272 "gram.y"
                                                                                        { (yyval.ival) = +1; }
#line 25730 "gram.c"
    break;

  case 170: /* add_drop: DROP  */
#line 1273 "gram.y"
                                                                                                { (yyval.ival) = -1; }
#line 25736 "gram.c"
    break;

  case 171: /* CreateSchemaStmt: CREATE SCHEMA OptSchemaName AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 1285 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 25750 "gram.c"
    break;

  case 172: /* CreateSchemaStmt: CREATE SCHEMA ColId OptSchemaEltList  */
#line 1295 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 25764 "gram.c"
    break;

  case 173: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS OptSchemaName AUTHORIZATION RoleSpec OptSchemaEltList  */
#line 1305 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 25783 "gram.c"
    break;

  case 174: /* CreateSchemaStmt: CREATE SCHEMA IF_P NOT EXISTS ColId OptSchemaEltList  */
#line 1320 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 25802 "gram.c"
    break;

  case 175: /* OptSchemaName: ColId  */
#line 1337 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 25808 "gram.c"
    break;

  case 176: /* OptSchemaName: %empty  */
#line 1338 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 25814 "gram.c"
    break;

  case 177: /* OptSchemaEltList: OptSchemaEltList schema_stmt  */
#line 1343 "gram.y"
                                {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 25824 "gram.c"
    break;

  case 178: /* OptSchemaEltList: %empty  */
#line 1349 "gram.y"
                                { (yyval.list) = NIL; }
#line 25830 "gram.c"
    break;

  case 185: /* VariableSetStmt: SET set_rest  */
#line 1377 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 25840 "gram.c"
    break;

  case 186: /* VariableSetStmt: SET LOCAL set_rest  */
#line 1383 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 25850 "gram.c"
    break;

  case 187: /* VariableSetStmt: SET SESSION set_rest  */
#line 1389 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 25860 "gram.c"
    break;

  case 188: /* set_rest: TRANSACTION transaction_mode_list  */
#line 1398 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 25872 "gram.c"
    break;

  case 189: /* set_rest: SESSION CHARACTERISTICS AS TRANSACTION transaction_mode_list  */
#line 1406 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 25884 "gram.c"
    break;

  case 191: /* generic_set: var_name TO var_list  */
#line 1418 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 25896 "gram.c"
    break;

  case 192: /* generic_set: var_name '=' var_list  */
#line 1426 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 25908 "gram.c"
    break;

  case 193: /* generic_set: var_name TO DEFAULT  */
#line 1434 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 25919 "gram.c"
    break;

  case 194: /* generic_set: var_name '=' DEFAULT  */
#line 1441 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 25930 "gram.c"
    break;

  case 195: /* set_rest_more: generic_set  */
#line 1450 "gram.y"
                                                                                {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 25936 "gram.c"
    break;

  case 196: /* set_rest_more: var_name FROM CURRENT_P  */
#line 1452 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 25947 "gram.c"
    break;

  case 197: /* set_rest_more: TIME ZONE zone_value  */
#line 1460 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 25962 "gram.c"
    break;

  case 198: /* set_rest_more: CATALOG_P Sconst  */
#line 1471 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 25974 "gram.c"
    break;

  case 199: /* set_rest_more: SCHEMA Sconst  */
#line 1479 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 25986 "gram.c"
    break;

  case 200: /* set_rest_more: NAMES opt_encoding  */
#line 1487 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 26001 "gram.c"
    break;

  case 201: /* set_rest_more: ROLE NonReservedWord_or_Sconst  */
#line 1498 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 26013 "gram.c"
    break;

  case 202: /* set_rest_more: SESSION AUTHORIZATION NonReservedWord_or_Sconst  */
#line 1506 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 26025 "gram.c"
    break;

  case 203: /* set_rest_more: SESSION AUTHORIZATION DEFAULT  */
#line 1514 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 26036 "gram.c"
    break;

  case 204: /* set_rest_more: XML_P OPTION document_or_content  */
#line 1521 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 26048 "gram.c"
    break;

  case 205: /* set_rest_more: TRANSACTION SNAPSHOT Sconst  */
#line 1530 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 26060 "gram.c"
    break;

  case 206: /* var_name: ColId  */
#line 1539 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 26066 "gram.c"
    break;

  case 207: /* var_name: var_name '.' ColId  */
#line 1541 "gram.y"
                                { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 26072 "gram.c"
    break;

  case 208: /* var_list: var_value  */
#line 1544 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26078 "gram.c"
    break;

  case 209: /* var_list: var_list ',' var_value  */
#line 1545 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26084 "gram.c"
    break;

  case 210: /* var_value: opt_boolean_or_string  */
#line 1549 "gram.y"
                                { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 26090 "gram.c"
    break;

  case 211: /* var_value: NumericOnly  */
#line 1551 "gram.y"
                                { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 26096 "gram.c"
    break;

  case 212: /* iso_level: READ UNCOMMITTED  */
#line 1554 "gram.y"
                                                                                { (yyval.str) = "read uncommitted"; }
#line 26102 "gram.c"
    break;

  case 213: /* iso_level: READ COMMITTED  */
#line 1555 "gram.y"
                                                                                        { (yyval.str) = "read committed"; }
#line 26108 "gram.c"
    break;

  case 214: /* iso_level: REPEATABLE READ  */
#line 1556 "gram.y"
                                                                                        { (yyval.str) = "repeatable read"; }
#line 26114 "gram.c"
    break;

  case 215: /* iso_level: SERIALIZABLE  */
#line 1557 "gram.y"
                                                                                        { (yyval.str) = "serializable"; }
#line 26120 "gram.c"
    break;

  case 216: /* opt_boolean_or_string: TRUE_P  */
#line 1561 "gram.y"
                                                                                                { (yyval.str) = "true"; }
#line 26126 "gram.c"
    break;

  case 217: /* opt_boolean_or_string: FALSE_P  */
#line 1562 "gram.y"
                                                                                                { (yyval.str) = "false"; }
#line 26132 "gram.c"
    break;

  case 218: /* opt_boolean_or_string: ON  */
#line 1563 "gram.y"
                                                                                                { (yyval.str) = "on"; }
#line 26138 "gram.c"
    break;

  case 219: /* opt_boolean_or_string: NonReservedWord_or_Sconst  */
#line 1569 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 26144 "gram.c"
    break;

  case 220: /* zone_value: Sconst  */
#line 1582 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 26152 "gram.c"
    break;

  case 221: /* zone_value: IDENT  */
#line 1586 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 26160 "gram.c"
    break;

  case 222: /* zone_value: ConstInterval Sconst opt_interval  */
#line 1590 "gram.y"
                                {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 26179 "gram.c"
    break;

  case 223: /* zone_value: ConstInterval '(' Iconst ')' Sconst  */
#line 1605 "gram.y"
                                {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 26190 "gram.c"
    break;

  case 224: /* zone_value: NumericOnly  */
#line 1611 "gram.y"
                                                                                        { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 26196 "gram.c"
    break;

  case 225: /* zone_value: DEFAULT  */
#line 1612 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 26202 "gram.c"
    break;

  case 226: /* zone_value: LOCAL  */
#line 1613 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 26208 "gram.c"
    break;

  case 227: /* opt_encoding: Sconst  */
#line 1617 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 26214 "gram.c"
    break;

  case 228: /* opt_encoding: DEFAULT  */
#line 1618 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 26220 "gram.c"
    break;

  case 229: /* opt_encoding: %empty  */
#line 1619 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 26226 "gram.c"
    break;

  case 230: /* NonReservedWord_or_Sconst: NonReservedWord  */
#line 1623 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 26232 "gram.c"
    break;

  case 231: /* NonReservedWord_or_Sconst: Sconst  */
#line 1624 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 26238 "gram.c"
    break;

  case 232: /* VariableResetStmt: RESET reset_rest  */
#line 1628 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 26244 "gram.c"
    break;

  case 233: /* reset_rest: generic_reset  */
#line 1632 "gram.y"
                                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 26250 "gram.c"
    break;

  case 234: /* reset_rest: TIME ZONE  */
#line 1634 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 26261 "gram.c"
    break;

  case 235: /* reset_rest: TRANSACTION ISOLATION LEVEL  */
#line 1641 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 26272 "gram.c"
    break;

  case 236: /* reset_rest: SESSION AUTHORIZATION  */
#line 1648 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 26283 "gram.c"
    break;

  case 237: /* generic_reset: var_name  */
#line 1658 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 26294 "gram.c"
    break;

  case 238: /* generic_reset: ALL  */
#line 1665 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 26304 "gram.c"
    break;

  case 239: /* SetResetClause: SET set_rest  */
#line 1674 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 26310 "gram.c"
    break;

  case 240: /* SetResetClause: VariableResetStmt  */
#line 1675 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 26316 "gram.c"
    break;

  case 241: /* FunctionSetResetClause: SET set_rest_more  */
#line 1680 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 26322 "gram.c"
    break;

  case 242: /* FunctionSetResetClause: VariableResetStmt  */
#line 1681 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 26328 "gram.c"
    break;

  case 243: /* VariableShowStmt: SHOW var_name  */
#line 1687 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26338 "gram.c"
    break;

  case 244: /* VariableShowStmt: SHOW TIME ZONE  */
#line 1693 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 26348 "gram.c"
    break;

  case 245: /* VariableShowStmt: SHOW TRANSACTION ISOLATION LEVEL  */
#line 1699 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 26358 "gram.c"
    break;

  case 246: /* VariableShowStmt: SHOW SESSION AUTHORIZATION  */
#line 1705 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 26368 "gram.c"
    break;

  case 247: /* VariableShowStmt: SHOW ALL  */
#line 1711 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 26378 "gram.c"
    break;

  case 248: /* ConstraintsSetStmt: SET CONSTRAINTS constraints_set_list constraints_set_mode  */
#line 1721 "gram.y"
                                {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 26389 "gram.c"
    break;

  case 249: /* constraints_set_list: ALL  */
#line 1730 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 26395 "gram.c"
    break;

  case 250: /* constraints_set_list: qualified_name_list  */
#line 1731 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 26401 "gram.c"
    break;

  case 251: /* constraints_set_mode: DEFERRED  */
#line 1735 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 26407 "gram.c"
    break;

  case 252: /* constraints_set_mode: IMMEDIATE  */
#line 1736 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 26413 "gram.c"
    break;

  case 253: /* CheckPointStmt: CHECKPOINT  */
#line 1745 "gram.y"
                                {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 26422 "gram.c"
    break;

  case 254: /* DiscardStmt: DISCARD ALL  */
#line 1760 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 26432 "gram.c"
    break;

  case 255: /* DiscardStmt: DISCARD TEMP  */
#line 1766 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 26442 "gram.c"
    break;

  case 256: /* DiscardStmt: DISCARD TEMPORARY  */
#line 1772 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 26452 "gram.c"
    break;

  case 257: /* DiscardStmt: DISCARD PLANS  */
#line 1778 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 26462 "gram.c"
    break;

  case 258: /* DiscardStmt: DISCARD SEQUENCES  */
#line 1784 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 26472 "gram.c"
    break;

  case 259: /* AlterTableStmt: ALTER TABLE relation_expr alter_table_cmds  */
#line 1803 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26485 "gram.c"
    break;

  case 260: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 1812 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26498 "gram.c"
    break;

  case 261: /* AlterTableStmt: ALTER TABLE relation_expr partition_cmd  */
#line 1821 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26511 "gram.c"
    break;

  case 262: /* AlterTableStmt: ALTER TABLE IF_P EXISTS relation_expr partition_cmd  */
#line 1830 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26524 "gram.c"
    break;

  case 263: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 1839 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 26539 "gram.c"
    break;

  case 264: /* AlterTableStmt: ALTER TABLE ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 1850 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 26554 "gram.c"
    break;

  case 265: /* AlterTableStmt: ALTER INDEX qualified_name alter_table_cmds  */
#line 1861 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26567 "gram.c"
    break;

  case 266: /* AlterTableStmt: ALTER INDEX IF_P EXISTS qualified_name alter_table_cmds  */
#line 1870 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26580 "gram.c"
    break;

  case 267: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 1879 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 26595 "gram.c"
    break;

  case 268: /* AlterTableStmt: ALTER INDEX ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 1890 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 26610 "gram.c"
    break;

  case 269: /* AlterTableStmt: ALTER SEQUENCE qualified_name alter_table_cmds  */
#line 1901 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26623 "gram.c"
    break;

  case 270: /* AlterTableStmt: ALTER SEQUENCE IF_P EXISTS qualified_name alter_table_cmds  */
#line 1910 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26636 "gram.c"
    break;

  case 271: /* AlterTableStmt: ALTER VIEW qualified_name alter_table_cmds  */
#line 1919 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26649 "gram.c"
    break;

  case 272: /* AlterTableStmt: ALTER VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 1928 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26662 "gram.c"
    break;

  case 273: /* AlterTableStmt: ALTER MATERIALIZED VIEW qualified_name alter_table_cmds  */
#line 1937 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26675 "gram.c"
    break;

  case 274: /* AlterTableStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name alter_table_cmds  */
#line 1946 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26688 "gram.c"
    break;

  case 275: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name SET TABLESPACE name opt_nowait  */
#line 1955 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 26703 "gram.c"
    break;

  case 276: /* AlterTableStmt: ALTER MATERIALIZED VIEW ALL IN_P TABLESPACE name OWNED BY role_list SET TABLESPACE name opt_nowait  */
#line 1966 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 26718 "gram.c"
    break;

  case 277: /* alter_table_cmds: alter_table_cmd  */
#line 1979 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26724 "gram.c"
    break;

  case 278: /* alter_table_cmds: alter_table_cmds ',' alter_table_cmd  */
#line 1980 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26730 "gram.c"
    break;

  case 279: /* partition_cmd: ATTACH PARTITION qualified_name ForValues  */
#line 1986 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 26746 "gram.c"
    break;

  case 280: /* partition_cmd: DETACH PARTITION qualified_name  */
#line 1999 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 26762 "gram.c"
    break;

  case 281: /* alter_table_cmd: ADD_P columnDef  */
#line 2015 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26774 "gram.c"
    break;

  case 282: /* alter_table_cmd: ADD_P IF_P NOT EXISTS columnDef  */
#line 2024 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26786 "gram.c"
    break;

  case 283: /* alter_table_cmd: ADD_P COLUMN columnDef  */
#line 2033 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26798 "gram.c"
    break;

  case 284: /* alter_table_cmd: ADD_P COLUMN IF_P NOT EXISTS columnDef  */
#line 2042 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26810 "gram.c"
    break;

  case 285: /* alter_table_cmd: ALTER opt_column ColId alter_column_default  */
#line 2051 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 26822 "gram.c"
    break;

  case 286: /* alter_table_cmd: ALTER opt_column ColId DROP NOT NULL_P  */
#line 2060 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 26833 "gram.c"
    break;

  case 287: /* alter_table_cmd: ALTER opt_column ColId SET NOT NULL_P  */
#line 2068 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 26844 "gram.c"
    break;

  case 288: /* alter_table_cmd: ALTER opt_column ColId SET STATISTICS SignedIconst  */
#line 2076 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 26856 "gram.c"
    break;

  case 289: /* alter_table_cmd: ALTER opt_column ColId SET reloptions  */
#line 2085 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26868 "gram.c"
    break;

  case 290: /* alter_table_cmd: ALTER opt_column ColId RESET reloptions  */
#line 2094 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26880 "gram.c"
    break;

  case 291: /* alter_table_cmd: ALTER opt_column ColId SET STORAGE ColId  */
#line 2103 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 26892 "gram.c"
    break;

  case 292: /* alter_table_cmd: ALTER opt_column ColId ADD_P GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 2112 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *)n;
				}
#line 26912 "gram.c"
    break;

  case 293: /* alter_table_cmd: ALTER opt_column ColId alter_identity_column_option_list  */
#line 2129 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26924 "gram.c"
    break;

  case 294: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P  */
#line 2138 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 26936 "gram.c"
    break;

  case 295: /* alter_table_cmd: ALTER opt_column ColId DROP IDENTITY_P IF_P EXISTS  */
#line 2147 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 26948 "gram.c"
    break;

  case 296: /* alter_table_cmd: DROP opt_column IF_P EXISTS ColId opt_drop_behavior  */
#line 2156 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 26961 "gram.c"
    break;

  case 297: /* alter_table_cmd: DROP opt_column ColId opt_drop_behavior  */
#line 2166 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 26974 "gram.c"
    break;

  case 298: /* alter_table_cmd: ALTER opt_column ColId opt_set_data TYPE_P Typename opt_collate_clause alter_using  */
#line 2179 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 26992 "gram.c"
    break;

  case 299: /* alter_table_cmd: ALTER opt_column ColId alter_generic_options  */
#line 2194 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27004 "gram.c"
    break;

  case 300: /* alter_table_cmd: ADD_P TableConstraint  */
#line 2203 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 27015 "gram.c"
    break;

  case 301: /* alter_table_cmd: ALTER CONSTRAINT name ConstraintAttributeSpec  */
#line 2211 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 27033 "gram.c"
    break;

  case 302: /* alter_table_cmd: VALIDATE CONSTRAINT name  */
#line 2226 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27044 "gram.c"
    break;

  case 303: /* alter_table_cmd: DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 2234 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 27057 "gram.c"
    break;

  case 304: /* alter_table_cmd: DROP CONSTRAINT name opt_drop_behavior  */
#line 2244 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 27070 "gram.c"
    break;

  case 305: /* alter_table_cmd: SET WITH OIDS  */
#line 2254 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 27080 "gram.c"
    break;

  case 306: /* alter_table_cmd: SET WITHOUT OIDS  */
#line 2261 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 27090 "gram.c"
    break;

  case 307: /* alter_table_cmd: CLUSTER ON name  */
#line 2268 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27101 "gram.c"
    break;

  case 308: /* alter_table_cmd: SET WITHOUT CLUSTER  */
#line 2276 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 27112 "gram.c"
    break;

  case 309: /* alter_table_cmd: SET LOGGED  */
#line 2284 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
#line 27122 "gram.c"
    break;

  case 310: /* alter_table_cmd: SET UNLOGGED  */
#line 2291 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
#line 27132 "gram.c"
    break;

  case 311: /* alter_table_cmd: ENABLE_P TRIGGER name  */
#line 2298 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27143 "gram.c"
    break;

  case 312: /* alter_table_cmd: ENABLE_P ALWAYS TRIGGER name  */
#line 2306 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27154 "gram.c"
    break;

  case 313: /* alter_table_cmd: ENABLE_P REPLICA TRIGGER name  */
#line 2314 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27165 "gram.c"
    break;

  case 314: /* alter_table_cmd: ENABLE_P TRIGGER ALL  */
#line 2322 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 27175 "gram.c"
    break;

  case 315: /* alter_table_cmd: ENABLE_P TRIGGER USER  */
#line 2329 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 27185 "gram.c"
    break;

  case 316: /* alter_table_cmd: DISABLE_P TRIGGER name  */
#line 2336 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27196 "gram.c"
    break;

  case 317: /* alter_table_cmd: DISABLE_P TRIGGER ALL  */
#line 2344 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 27206 "gram.c"
    break;

  case 318: /* alter_table_cmd: DISABLE_P TRIGGER USER  */
#line 2351 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 27216 "gram.c"
    break;

  case 319: /* alter_table_cmd: ENABLE_P RULE name  */
#line 2358 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27227 "gram.c"
    break;

  case 320: /* alter_table_cmd: ENABLE_P ALWAYS RULE name  */
#line 2366 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27238 "gram.c"
    break;

  case 321: /* alter_table_cmd: ENABLE_P REPLICA RULE name  */
#line 2374 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27249 "gram.c"
    break;

  case 322: /* alter_table_cmd: DISABLE_P RULE name  */
#line 2382 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27260 "gram.c"
    break;

  case 323: /* alter_table_cmd: INHERIT qualified_name  */
#line 2390 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 27271 "gram.c"
    break;

  case 324: /* alter_table_cmd: NO INHERIT qualified_name  */
#line 2398 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 27282 "gram.c"
    break;

  case 325: /* alter_table_cmd: OF any_name  */
#line 2406 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 27295 "gram.c"
    break;

  case 326: /* alter_table_cmd: NOT OF  */
#line 2416 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 27305 "gram.c"
    break;

  case 327: /* alter_table_cmd: OWNER TO RoleSpec  */
#line 2423 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 27316 "gram.c"
    break;

  case 328: /* alter_table_cmd: SET TABLESPACE name  */
#line 2431 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27327 "gram.c"
    break;

  case 329: /* alter_table_cmd: SET reloptions  */
#line 2439 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27338 "gram.c"
    break;

  case 330: /* alter_table_cmd: RESET reloptions  */
#line 2447 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27349 "gram.c"
    break;

  case 331: /* alter_table_cmd: REPLICA IDENTITY_P replica_identity  */
#line 2455 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 27360 "gram.c"
    break;

  case 332: /* alter_table_cmd: ENABLE_P ROW LEVEL SECURITY  */
#line 2463 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 27370 "gram.c"
    break;

  case 333: /* alter_table_cmd: DISABLE_P ROW LEVEL SECURITY  */
#line 2470 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 27380 "gram.c"
    break;

  case 334: /* alter_table_cmd: FORCE ROW LEVEL SECURITY  */
#line 2477 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 27390 "gram.c"
    break;

  case 335: /* alter_table_cmd: NO FORCE ROW LEVEL SECURITY  */
#line 2484 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 27400 "gram.c"
    break;

  case 336: /* alter_table_cmd: alter_generic_options  */
#line 2490 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 27411 "gram.c"
    break;

  case 337: /* alter_column_default: SET DEFAULT a_expr  */
#line 2499 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 27417 "gram.c"
    break;

  case 338: /* alter_column_default: DROP DEFAULT  */
#line 2500 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 27423 "gram.c"
    break;

  case 339: /* opt_drop_behavior: CASCADE  */
#line 2504 "gram.y"
                                                                        { (yyval.dbehavior) = DROP_CASCADE; }
#line 27429 "gram.c"
    break;

  case 340: /* opt_drop_behavior: RESTRICT  */
#line 2505 "gram.y"
                                                                        { (yyval.dbehavior) = DROP_RESTRICT; }
#line 27435 "gram.c"
    break;

  case 341: /* opt_drop_behavior: %empty  */
#line 2506 "gram.y"
                                                                { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 27441 "gram.c"
    break;

  case 342: /* opt_collate_clause: COLLATE any_name  */
#line 2511 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 27453 "gram.c"
    break;

  case 343: /* opt_collate_clause: %empty  */
#line 2518 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 27459 "gram.c"
    break;

  case 344: /* alter_using: USING a_expr  */
#line 2522 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 27465 "gram.c"
    break;

  case 345: /* alter_using: %empty  */
#line 2523 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 27471 "gram.c"
    break;

  case 346: /* replica_identity: NOTHING  */
#line 2528 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 27482 "gram.c"
    break;

  case 347: /* replica_identity: FULL  */
#line 2535 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 27493 "gram.c"
    break;

  case 348: /* replica_identity: DEFAULT  */
#line 2542 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 27504 "gram.c"
    break;

  case 349: /* replica_identity: USING INDEX name  */
#line 2549 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 27515 "gram.c"
    break;

  case 350: /* reloptions: '(' reloption_list ')'  */
#line 2558 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 27521 "gram.c"
    break;

  case 351: /* opt_reloptions: WITH reloptions  */
#line 2561 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 27527 "gram.c"
    break;

  case 352: /* opt_reloptions: %empty  */
#line 2562 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 27533 "gram.c"
    break;

  case 353: /* reloption_list: reloption_elem  */
#line 2566 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27539 "gram.c"
    break;

  case 354: /* reloption_list: reloption_list ',' reloption_elem  */
#line 2567 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 27545 "gram.c"
    break;

  case 355: /* reloption_elem: ColLabel '=' def_arg  */
#line 2573 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 27553 "gram.c"
    break;

  case 356: /* reloption_elem: ColLabel  */
#line 2577 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 27561 "gram.c"
    break;

  case 357: /* reloption_elem: ColLabel '.' ColLabel '=' def_arg  */
#line 2581 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 27570 "gram.c"
    break;

  case 358: /* reloption_elem: ColLabel '.' ColLabel  */
#line 2586 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 27578 "gram.c"
    break;

  case 359: /* alter_identity_column_option_list: alter_identity_column_option  */
#line 2593 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27584 "gram.c"
    break;

  case 360: /* alter_identity_column_option_list: alter_identity_column_option_list alter_identity_column_option  */
#line 2595 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27590 "gram.c"
    break;

  case 361: /* alter_identity_column_option: RESTART  */
#line 2600 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 27598 "gram.c"
    break;

  case 362: /* alter_identity_column_option: RESTART opt_with NumericOnly  */
#line 2604 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 27606 "gram.c"
    break;

  case 363: /* alter_identity_column_option: SET SeqOptElem  */
#line 2608 "gram.y"
                                {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 27621 "gram.c"
    break;

  case 364: /* alter_identity_column_option: SET GENERATED generated_when  */
#line 2619 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 27629 "gram.c"
    break;

  case 365: /* ForValues: FOR VALUES IN_P '(' partbound_datum_list ')'  */
#line 2627 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 27643 "gram.c"
    break;

  case 366: /* ForValues: FOR VALUES FROM '(' range_datum_list ')' TO '(' range_datum_list ')'  */
#line 2639 "gram.y"
                                {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 27658 "gram.c"
    break;

  case 367: /* partbound_datum: Sconst  */
#line 2652 "gram.y"
                                                { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 27664 "gram.c"
    break;

  case 368: /* partbound_datum: NumericOnly  */
#line 2653 "gram.y"
                                        { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 27670 "gram.c"
    break;

  case 369: /* partbound_datum: TRUE_P  */
#line 2654 "gram.y"
                                                { (yyval.node) = makeStringConst(pstrdup("true"), (yylsp[0])); }
#line 27676 "gram.c"
    break;

  case 370: /* partbound_datum: FALSE_P  */
#line 2655 "gram.y"
                                                { (yyval.node) = makeStringConst(pstrdup("false"), (yylsp[0])); }
#line 27682 "gram.c"
    break;

  case 371: /* partbound_datum: NULL_P  */
#line 2656 "gram.y"
                                                { (yyval.node) = makeNullAConst((yylsp[0])); }
#line 27688 "gram.c"
    break;

  case 372: /* partbound_datum_list: partbound_datum  */
#line 2660 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 27694 "gram.c"
    break;

  case 373: /* partbound_datum_list: partbound_datum_list ',' partbound_datum  */
#line 2662 "gram.y"
                                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 27700 "gram.c"
    break;

  case 374: /* range_datum_list: PartitionRangeDatum  */
#line 2666 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 27706 "gram.c"
    break;

  case 375: /* range_datum_list: range_datum_list ',' PartitionRangeDatum  */
#line 2668 "gram.y"
                                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 27712 "gram.c"
    break;

  case 376: /* PartitionRangeDatum: MINVALUE  */
#line 2673 "gram.y"
                                {
					PartitionRangeDatum *n = makeNode(PartitionRangeDatum);

					n->kind = PARTITION_RANGE_DATUM_MINVALUE;
					n->value = NULL;
					n->location = (yylsp[0]);

					(yyval.node) = (Node *) n;
				}
#line 27726 "gram.c"
    break;

  case 377: /* PartitionRangeDatum: MAXVALUE  */
#line 2683 "gram.y"
                                {
					PartitionRangeDatum *n = makeNode(PartitionRangeDatum);

					n->kind = PARTITION_RANGE_DATUM_MAXVALUE;
					n->value = NULL;
					n->location = (yylsp[0]);

					(yyval.node) = (Node *) n;
				}
#line 27740 "gram.c"
    break;

  case 378: /* PartitionRangeDatum: partbound_datum  */
#line 2693 "gram.y"
                                {
					PartitionRangeDatum *n = makeNode(PartitionRangeDatum);

					n->kind = PARTITION_RANGE_DATUM_VALUE;
					n->value = (yyvsp[0].node);
					n->location = (yylsp[0]);

					(yyval.node) = (Node *) n;
				}
#line 27754 "gram.c"
    break;

  case 379: /* AlterCompositeTypeStmt: ALTER TYPE_P any_name alter_type_cmds  */
#line 2713 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 27768 "gram.c"
    break;

  case 380: /* alter_type_cmds: alter_type_cmd  */
#line 2725 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 27774 "gram.c"
    break;

  case 381: /* alter_type_cmds: alter_type_cmds ',' alter_type_cmd  */
#line 2726 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 27780 "gram.c"
    break;

  case 382: /* alter_type_cmd: ADD_P ATTRIBUTE TableFuncElement opt_drop_behavior  */
#line 2732 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27792 "gram.c"
    break;

  case 383: /* alter_type_cmd: DROP ATTRIBUTE IF_P EXISTS ColId opt_drop_behavior  */
#line 2741 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 27805 "gram.c"
    break;

  case 384: /* alter_type_cmd: DROP ATTRIBUTE ColId opt_drop_behavior  */
#line 2751 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 27818 "gram.c"
    break;

  case 385: /* alter_type_cmd: ALTER ATTRIBUTE ColId opt_set_data TYPE_P Typename opt_collate_clause opt_drop_behavior  */
#line 2761 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 27837 "gram.c"
    break;

  case 386: /* ClosePortalStmt: CLOSE cursor_name  */
#line 2787 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27847 "gram.c"
    break;

  case 387: /* ClosePortalStmt: CLOSE ALL  */
#line 2793 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 27857 "gram.c"
    break;

  case 388: /* CopyStmt: COPY opt_binary qualified_name opt_column_list opt_oids copy_from opt_program copy_file_name copy_delimiter opt_with copy_options  */
#line 2827 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-5].boolean);
					n->is_program = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-6].defelt))
						n->options = lappend(n->options, (yyvsp[-6].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 27889 "gram.c"
    break;

  case 389: /* CopyStmt: COPY '(' PreparableStmt ')' TO opt_program copy_file_name opt_with copy_options  */
#line 2855 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *)n;
				}
#line 27912 "gram.c"
    break;

  case 390: /* copy_from: FROM  */
#line 2876 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 27918 "gram.c"
    break;

  case 391: /* copy_from: TO  */
#line 2877 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 27924 "gram.c"
    break;

  case 392: /* opt_program: PROGRAM  */
#line 2881 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 27930 "gram.c"
    break;

  case 393: /* opt_program: %empty  */
#line 2882 "gram.y"
                                                                                        { (yyval.boolean) = FALSE; }
#line 27936 "gram.c"
    break;

  case 394: /* copy_file_name: Sconst  */
#line 2891 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 27942 "gram.c"
    break;

  case 395: /* copy_file_name: STDIN  */
#line 2892 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 27948 "gram.c"
    break;

  case 396: /* copy_file_name: STDOUT  */
#line 2893 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 27954 "gram.c"
    break;

  case 397: /* copy_options: copy_opt_list  */
#line 2896 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 27960 "gram.c"
    break;

  case 398: /* copy_options: '(' copy_generic_opt_list ')'  */
#line 2897 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 27966 "gram.c"
    break;

  case 399: /* copy_opt_list: copy_opt_list copy_opt_item  */
#line 2902 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27972 "gram.c"
    break;

  case 400: /* copy_opt_list: %empty  */
#line 2903 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 27978 "gram.c"
    break;

  case 401: /* copy_opt_item: BINARY  */
#line 2908 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 27986 "gram.c"
    break;

  case 402: /* copy_opt_item: OIDS  */
#line 2912 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 27994 "gram.c"
    break;

  case 403: /* copy_opt_item: FREEZE  */
#line 2916 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 28002 "gram.c"
    break;

  case 404: /* copy_opt_item: DELIMITER opt_as Sconst  */
#line 2920 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28010 "gram.c"
    break;

  case 405: /* copy_opt_item: NULL_P opt_as Sconst  */
#line 2924 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28018 "gram.c"
    break;

  case 406: /* copy_opt_item: CSV  */
#line 2928 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"), (yylsp[0]));
				}
#line 28026 "gram.c"
    break;

  case 407: /* copy_opt_item: HEADER_P  */
#line 2932 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 28034 "gram.c"
    break;

  case 408: /* copy_opt_item: QUOTE opt_as Sconst  */
#line 2936 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28042 "gram.c"
    break;

  case 409: /* copy_opt_item: ESCAPE opt_as Sconst  */
#line 2940 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28050 "gram.c"
    break;

  case 410: /* copy_opt_item: FORCE QUOTE columnList  */
#line 2944 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 28058 "gram.c"
    break;

  case 411: /* copy_opt_item: FORCE QUOTE '*'  */
#line 2948 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star), (yylsp[-2]));
				}
#line 28066 "gram.c"
    break;

  case 412: /* copy_opt_item: FORCE NOT NULL_P columnList  */
#line 2952 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list), (yylsp[-3]));
				}
#line 28074 "gram.c"
    break;

  case 413: /* copy_opt_item: FORCE NULL_P columnList  */
#line 2956 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 28082 "gram.c"
    break;

  case 414: /* copy_opt_item: ENCODING Sconst  */
#line 2960 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 28090 "gram.c"
    break;

  case 415: /* opt_binary: BINARY  */
#line 2969 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 28098 "gram.c"
    break;

  case 416: /* opt_binary: %empty  */
#line 2972 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 28104 "gram.c"
    break;

  case 417: /* opt_oids: WITH OIDS  */
#line 2977 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE), (yylsp[-1]));
				}
#line 28112 "gram.c"
    break;

  case 418: /* opt_oids: %empty  */
#line 2980 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 28118 "gram.c"
    break;

  case 419: /* copy_delimiter: opt_using DELIMITERS Sconst  */
#line 2985 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 28126 "gram.c"
    break;

  case 420: /* copy_delimiter: %empty  */
#line 2988 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 28132 "gram.c"
    break;

  case 421: /* opt_using: USING  */
#line 2992 "gram.y"
                                                                                                {}
#line 28138 "gram.c"
    break;

  case 422: /* opt_using: %empty  */
#line 2993 "gram.y"
                                                                                                {}
#line 28144 "gram.c"
    break;

  case 423: /* copy_generic_opt_list: copy_generic_opt_elem  */
#line 2999 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 28152 "gram.c"
    break;

  case 424: /* copy_generic_opt_list: copy_generic_opt_list ',' copy_generic_opt_elem  */
#line 3003 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 28160 "gram.c"
    break;

  case 425: /* copy_generic_opt_elem: ColLabel copy_generic_opt_arg  */
#line 3010 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 28168 "gram.c"
    break;

  case 426: /* copy_generic_opt_arg: opt_boolean_or_string  */
#line 3016 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 28174 "gram.c"
    break;

  case 427: /* copy_generic_opt_arg: NumericOnly  */
#line 3017 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 28180 "gram.c"
    break;

  case 428: /* copy_generic_opt_arg: '*'  */
#line 3018 "gram.y"
                                                                                { (yyval.node) = (Node *) makeNode(A_Star); }
#line 28186 "gram.c"
    break;

  case 429: /* copy_generic_opt_arg: '(' copy_generic_opt_arg_list ')'  */
#line 3019 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 28192 "gram.c"
    break;

  case 430: /* copy_generic_opt_arg: %empty  */
#line 3020 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 28198 "gram.c"
    break;

  case 431: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list_item  */
#line 3025 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 28206 "gram.c"
    break;

  case 432: /* copy_generic_opt_arg_list: copy_generic_opt_arg_list ',' copy_generic_opt_arg_list_item  */
#line 3029 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 28214 "gram.c"
    break;

  case 433: /* copy_generic_opt_arg_list_item: opt_boolean_or_string  */
#line 3036 "gram.y"
                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 28220 "gram.c"
    break;

  case 434: /* CreateStmt: CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec OptWith OnCommitOption OptTableSpace  */
#line 3049 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = (yyvsp[-4].list);
					n->partspec = (yyvsp[-3].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28240 "gram.c"
    break;

  case 435: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit OptPartitionSpec OptWith OnCommitOption OptTableSpace  */
#line 3067 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = (yyvsp[-4].list);
					n->partspec = (yyvsp[-3].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28260 "gram.c"
    break;

  case 436: /* CreateStmt: CREATE OptTemp TABLE qualified_name OF any_name OptTypedTableElementList OptPartitionSpec OptWith OnCommitOption OptTableSpace  */
#line 3085 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-9].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-4].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-3].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-5].list));
					n->ofTypename->location = (yylsp[-5]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28281 "gram.c"
    break;

  case 437: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name OF any_name OptTypedTableElementList OptPartitionSpec OptWith OnCommitOption OptTableSpace  */
#line 3104 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-4].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-3].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-5].list));
					n->ofTypename->location = (yylsp[-5]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28302 "gram.c"
    break;

  case 438: /* CreateStmt: CREATE OptTemp TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList ForValues OptPartitionSpec OptWith OnCommitOption OptTableSpace  */
#line 3123 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = list_make1((yyvsp[-6].range));
					n->partbound = (yyvsp[-4].partboundspec);
					n->partspec = (yyvsp[-3].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28323 "gram.c"
    break;

  case 439: /* CreateStmt: CREATE OptTemp TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList ForValues OptPartitionSpec OptWith OnCommitOption OptTableSpace  */
#line 3142 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = list_make1((yyvsp[-6].range));
					n->partbound = (yyvsp[-4].partboundspec);
					n->partspec = (yyvsp[-3].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28344 "gram.c"
    break;

  case 440: /* OptTemp: TEMPORARY  */
#line 3171 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 28350 "gram.c"
    break;

  case 441: /* OptTemp: TEMP  */
#line 3172 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 28356 "gram.c"
    break;

  case 442: /* OptTemp: LOCAL TEMPORARY  */
#line 3173 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 28362 "gram.c"
    break;

  case 443: /* OptTemp: LOCAL TEMP  */
#line 3174 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 28368 "gram.c"
    break;

  case 444: /* OptTemp: GLOBAL TEMPORARY  */
#line 3176 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 28379 "gram.c"
    break;

  case 445: /* OptTemp: GLOBAL TEMP  */
#line 3183 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 28390 "gram.c"
    break;

  case 446: /* OptTemp: UNLOGGED  */
#line 3189 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 28396 "gram.c"
    break;

  case 447: /* OptTemp: %empty  */
#line 3190 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 28402 "gram.c"
    break;

  case 448: /* OptTableElementList: TableElementList  */
#line 3194 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 28408 "gram.c"
    break;

  case 449: /* OptTableElementList: %empty  */
#line 3195 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 28414 "gram.c"
    break;

  case 450: /* OptTypedTableElementList: '(' TypedTableElementList ')'  */
#line 3199 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 28420 "gram.c"
    break;

  case 451: /* OptTypedTableElementList: %empty  */
#line 3200 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 28426 "gram.c"
    break;

  case 452: /* TableElementList: TableElement  */
#line 3205 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 28434 "gram.c"
    break;

  case 453: /* TableElementList: TableElementList ',' TableElement  */
#line 3209 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 28442 "gram.c"
    break;

  case 454: /* TypedTableElementList: TypedTableElement  */
#line 3216 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 28450 "gram.c"
    break;

  case 455: /* TypedTableElementList: TypedTableElementList ',' TypedTableElement  */
#line 3220 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 28458 "gram.c"
    break;

  case 456: /* TableElement: columnDef  */
#line 3226 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 28464 "gram.c"
    break;

  case 457: /* TableElement: TableLikeClause  */
#line 3227 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 28470 "gram.c"
    break;

  case 458: /* TableElement: TableConstraint  */
#line 3228 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 28476 "gram.c"
    break;

  case 459: /* TypedTableElement: columnOptions  */
#line 3232 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 28482 "gram.c"
    break;

  case 460: /* TypedTableElement: TableConstraint  */
#line 3233 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 28488 "gram.c"
    break;

  case 461: /* columnDef: ColId Typename create_generic_options ColQualList  */
#line 3237 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 28511 "gram.c"
    break;

  case 462: /* columnOptions: ColId ColQualList  */
#line 3258 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 28533 "gram.c"
    break;

  case 463: /* columnOptions: ColId WITH OPTIONS ColQualList  */
#line 3276 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 28555 "gram.c"
    break;

  case 464: /* ColQualList: ColQualList ColConstraint  */
#line 3296 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 28561 "gram.c"
    break;

  case 465: /* ColQualList: %empty  */
#line 3297 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 28567 "gram.c"
    break;

  case 466: /* ColConstraint: CONSTRAINT name ColConstraintElem  */
#line 3302 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 28578 "gram.c"
    break;

  case 467: /* ColConstraint: ColConstraintElem  */
#line 3308 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 28584 "gram.c"
    break;

  case 468: /* ColConstraint: ConstraintAttr  */
#line 3309 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 28590 "gram.c"
    break;

  case 469: /* ColConstraint: COLLATE any_name  */
#line 3311 "gram.y"
                                {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 28607 "gram.c"
    break;

  case 470: /* ColConstraintElem: NOT NULL_P  */
#line 3342 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 28618 "gram.c"
    break;

  case 471: /* ColConstraintElem: NULL_P  */
#line 3349 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 28629 "gram.c"
    break;

  case 472: /* ColConstraintElem: UNIQUE opt_definition OptConsTableSpace  */
#line 3356 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28644 "gram.c"
    break;

  case 473: /* ColConstraintElem: PRIMARY KEY opt_definition OptConsTableSpace  */
#line 3367 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28659 "gram.c"
    break;

  case 474: /* ColConstraintElem: CHECK '(' a_expr ')' opt_no_inherit  */
#line 3378 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 28675 "gram.c"
    break;

  case 475: /* ColConstraintElem: DEFAULT b_expr  */
#line 3390 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 28688 "gram.c"
    break;

  case 476: /* ColConstraintElem: GENERATED generated_when AS IDENTITY_P OptParenthesizedSeqOptList  */
#line 3399 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 28701 "gram.c"
    break;

  case 477: /* ColConstraintElem: REFERENCES qualified_name opt_column_list key_match key_actions  */
#line 3408 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 28720 "gram.c"
    break;

  case 478: /* generated_when: ALWAYS  */
#line 3425 "gram.y"
                                                { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 28726 "gram.c"
    break;

  case 479: /* generated_when: BY DEFAULT  */
#line 3426 "gram.y"
                                        { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 28732 "gram.c"
    break;

  case 480: /* ConstraintAttr: DEFERRABLE  */
#line 3446 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 28743 "gram.c"
    break;

  case 481: /* ConstraintAttr: NOT DEFERRABLE  */
#line 3453 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 28754 "gram.c"
    break;

  case 482: /* ConstraintAttr: INITIALLY DEFERRED  */
#line 3460 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 28765 "gram.c"
    break;

  case 483: /* ConstraintAttr: INITIALLY IMMEDIATE  */
#line 3467 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 28776 "gram.c"
    break;

  case 484: /* TableLikeClause: LIKE qualified_name TableLikeOptionList  */
#line 3478 "gram.y"
                                {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 28788 "gram.c"
    break;

  case 485: /* TableLikeOptionList: TableLikeOptionList INCLUDING TableLikeOption  */
#line 3488 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 28794 "gram.c"
    break;

  case 486: /* TableLikeOptionList: TableLikeOptionList EXCLUDING TableLikeOption  */
#line 3489 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 28800 "gram.c"
    break;

  case 487: /* TableLikeOptionList: %empty  */
#line 3490 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 28806 "gram.c"
    break;

  case 488: /* TableLikeOption: COMMENTS  */
#line 3494 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 28812 "gram.c"
    break;

  case 489: /* TableLikeOption: CONSTRAINTS  */
#line 3495 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 28818 "gram.c"
    break;

  case 490: /* TableLikeOption: DEFAULTS  */
#line 3496 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 28824 "gram.c"
    break;

  case 491: /* TableLikeOption: IDENTITY_P  */
#line 3497 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 28830 "gram.c"
    break;

  case 492: /* TableLikeOption: INDEXES  */
#line 3498 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 28836 "gram.c"
    break;

  case 493: /* TableLikeOption: STATISTICS  */
#line 3499 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 28842 "gram.c"
    break;

  case 494: /* TableLikeOption: STORAGE  */
#line 3500 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 28848 "gram.c"
    break;

  case 495: /* TableLikeOption: ALL  */
#line 3501 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 28854 "gram.c"
    break;

  case 496: /* TableConstraint: CONSTRAINT name ConstraintElem  */
#line 3511 "gram.y"
                                {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 28865 "gram.c"
    break;

  case 497: /* TableConstraint: ConstraintElem  */
#line 3517 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 28871 "gram.c"
    break;

  case 498: /* ConstraintElem: CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 3522 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 28888 "gram.c"
    break;

  case 499: /* ConstraintElem: UNIQUE '(' columnList ')' opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 3536 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 28906 "gram.c"
    break;

  case 500: /* ConstraintElem: UNIQUE ExistingIndex ConstraintAttributeSpec  */
#line 3550 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 28924 "gram.c"
    break;

  case 501: /* ConstraintElem: PRIMARY KEY '(' columnList ')' opt_definition OptConsTableSpace ConstraintAttributeSpec  */
#line 3565 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 28942 "gram.c"
    break;

  case 502: /* ConstraintElem: PRIMARY KEY ExistingIndex ConstraintAttributeSpec  */
#line 3579 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 28960 "gram.c"
    break;

  case 503: /* ConstraintElem: EXCLUDE access_method_clause '(' ExclusionConstraintList ')' opt_definition OptConsTableSpace ExclusionWhereClause ConstraintAttributeSpec  */
#line 3595 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 28980 "gram.c"
    break;

  case 504: /* ConstraintElem: FOREIGN KEY '(' columnList ')' REFERENCES qualified_name opt_column_list key_match key_actions ConstraintAttributeSpec  */
#line 3612 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 29002 "gram.c"
    break;

  case 505: /* opt_no_inherit: NO INHERIT  */
#line 3631 "gram.y"
                                                                                {  (yyval.boolean) = TRUE; }
#line 29008 "gram.c"
    break;

  case 506: /* opt_no_inherit: %empty  */
#line 3632 "gram.y"
                                                                                        {  (yyval.boolean) = FALSE; }
#line 29014 "gram.c"
    break;

  case 507: /* opt_column_list: '(' columnList ')'  */
#line 3636 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 29020 "gram.c"
    break;

  case 508: /* opt_column_list: %empty  */
#line 3637 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 29026 "gram.c"
    break;

  case 509: /* columnList: columnElem  */
#line 3641 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29032 "gram.c"
    break;

  case 510: /* columnList: columnList ',' columnElem  */
#line 3642 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29038 "gram.c"
    break;

  case 511: /* columnElem: ColId  */
#line 3646 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 29046 "gram.c"
    break;

  case 512: /* key_match: MATCH FULL  */
#line 3652 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 29054 "gram.c"
    break;

  case 513: /* key_match: MATCH PARTIAL  */
#line 3656 "gram.y"
                        {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 29066 "gram.c"
    break;

  case 514: /* key_match: MATCH SIMPLE  */
#line 3664 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 29074 "gram.c"
    break;

  case 515: /* key_match: %empty  */
#line 3668 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 29082 "gram.c"
    break;

  case 516: /* ExclusionConstraintList: ExclusionConstraintElem  */
#line 3674 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 29088 "gram.c"
    break;

  case 517: /* ExclusionConstraintList: ExclusionConstraintList ',' ExclusionConstraintElem  */
#line 3676 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 29094 "gram.c"
    break;

  case 518: /* ExclusionConstraintElem: index_elem WITH any_operator  */
#line 3680 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 29102 "gram.c"
    break;

  case 519: /* ExclusionConstraintElem: index_elem WITH OPERATOR '(' any_operator ')'  */
#line 3685 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 29110 "gram.c"
    break;

  case 520: /* ExclusionWhereClause: WHERE '(' a_expr ')'  */
#line 3691 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 29116 "gram.c"
    break;

  case 521: /* ExclusionWhereClause: %empty  */
#line 3692 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 29122 "gram.c"
    break;

  case 522: /* key_actions: key_update  */
#line 3703 "gram.y"
                                { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 29128 "gram.c"
    break;

  case 523: /* key_actions: key_delete  */
#line 3705 "gram.y"
                                { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 29134 "gram.c"
    break;

  case 524: /* key_actions: key_update key_delete  */
#line 3707 "gram.y"
                                { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 29140 "gram.c"
    break;

  case 525: /* key_actions: key_delete key_update  */
#line 3709 "gram.y"
                                { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 29146 "gram.c"
    break;

  case 526: /* key_actions: %empty  */
#line 3711 "gram.y"
                                { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 29152 "gram.c"
    break;

  case 527: /* key_update: ON UPDATE key_action  */
#line 3714 "gram.y"
                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 29158 "gram.c"
    break;

  case 528: /* key_delete: ON DELETE_P key_action  */
#line 3717 "gram.y"
                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 29164 "gram.c"
    break;

  case 529: /* key_action: NO ACTION  */
#line 3721 "gram.y"
                                                                        { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 29170 "gram.c"
    break;

  case 530: /* key_action: RESTRICT  */
#line 3722 "gram.y"
                                                                        { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 29176 "gram.c"
    break;

  case 531: /* key_action: CASCADE  */
#line 3723 "gram.y"
                                                                        { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 29182 "gram.c"
    break;

  case 532: /* key_action: SET NULL_P  */
#line 3724 "gram.y"
                                                                { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 29188 "gram.c"
    break;

  case 533: /* key_action: SET DEFAULT  */
#line 3725 "gram.y"
                                                                { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 29194 "gram.c"
    break;

  case 534: /* OptInherit: INHERITS '(' qualified_name_list ')'  */
#line 3728 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 29200 "gram.c"
    break;

  case 535: /* OptInherit: %empty  */
#line 3729 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 29206 "gram.c"
    break;

  case 536: /* OptPartitionSpec: PartitionSpec  */
#line 3733 "gram.y"
                                { (yyval.partspec) = (yyvsp[0].partspec); }
#line 29212 "gram.c"
    break;

  case 537: /* OptPartitionSpec: %empty  */
#line 3734 "gram.y"
                                                        { (yyval.partspec) = NULL; }
#line 29218 "gram.c"
    break;

  case 538: /* PartitionSpec: PARTITION BY part_strategy '(' part_params ')'  */
#line 3738 "gram.y"
                                {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-3].str);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 29232 "gram.c"
    break;

  case 539: /* part_strategy: IDENT  */
#line 3749 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 29238 "gram.c"
    break;

  case 540: /* part_strategy: unreserved_keyword  */
#line 3750 "gram.y"
                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 29244 "gram.c"
    break;

  case 541: /* part_params: part_elem  */
#line 3753 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 29250 "gram.c"
    break;

  case 542: /* part_params: part_params ',' part_elem  */
#line 3754 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 29256 "gram.c"
    break;

  case 543: /* part_elem: ColId opt_collate opt_class  */
#line 3758 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 29271 "gram.c"
    break;

  case 544: /* part_elem: func_expr_windowless opt_collate opt_class  */
#line 3769 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 29286 "gram.c"
    break;

  case 545: /* part_elem: '(' a_expr ')' opt_collate opt_class  */
#line 3780 "gram.y"
                                {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 29301 "gram.c"
    break;

  case 546: /* OptWith: WITH reloptions  */
#line 3793 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 29307 "gram.c"
    break;

  case 547: /* OptWith: WITH OIDS  */
#line 3794 "gram.y"
                                                                        { (yyval.list) = list_make1(makeDefElem("oids", (Node *) makeInteger(true), (yylsp[-1]))); }
#line 29313 "gram.c"
    break;

  case 548: /* OptWith: WITHOUT OIDS  */
#line 3795 "gram.y"
                                                                { (yyval.list) = list_make1(makeDefElem("oids", (Node *) makeInteger(false), (yylsp[-1]))); }
#line 29319 "gram.c"
    break;

  case 549: /* OptWith: %empty  */
#line 3796 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 29325 "gram.c"
    break;

  case 550: /* OnCommitOption: ON COMMIT DROP  */
#line 3799 "gram.y"
                                                        { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 29331 "gram.c"
    break;

  case 551: /* OnCommitOption: ON COMMIT DELETE_P ROWS  */
#line 3800 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 29337 "gram.c"
    break;

  case 552: /* OnCommitOption: ON COMMIT PRESERVE ROWS  */
#line 3801 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 29343 "gram.c"
    break;

  case 553: /* OnCommitOption: %empty  */
#line 3802 "gram.y"
                                                                                { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 29349 "gram.c"
    break;

  case 554: /* OptTableSpace: TABLESPACE name  */
#line 3805 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 29355 "gram.c"
    break;

  case 555: /* OptTableSpace: %empty  */
#line 3806 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 29361 "gram.c"
    break;

  case 556: /* OptConsTableSpace: USING INDEX TABLESPACE name  */
#line 3809 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 29367 "gram.c"
    break;

  case 557: /* OptConsTableSpace: %empty  */
#line 3810 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 29373 "gram.c"
    break;

  case 558: /* ExistingIndex: USING INDEX index_name  */
#line 3813 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 29379 "gram.c"
    break;

  case 559: /* CreateStatsStmt: CREATE STATISTICS any_name opt_name_list ON expr_list FROM from_list  */
#line 3833 "gram.y"
                                {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 29393 "gram.c"
    break;

  case 560: /* CreateStatsStmt: CREATE STATISTICS IF_P NOT EXISTS any_name opt_name_list ON expr_list FROM from_list  */
#line 3844 "gram.y"
                                {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 29407 "gram.c"
    break;

  case 561: /* CreateAsStmt: CREATE OptTemp TABLE create_as_target AS SelectStmt opt_with_data  */
#line 3867 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 29424 "gram.c"
    break;

  case 562: /* CreateAsStmt: CREATE OptTemp TABLE IF_P NOT EXISTS create_as_target AS SelectStmt opt_with_data  */
#line 3880 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 29441 "gram.c"
    break;

  case 563: /* create_as_target: qualified_name opt_column_list OptWith OnCommitOption OptTableSpace  */
#line 3896 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 29456 "gram.c"
    break;

  case 564: /* opt_with_data: WITH DATA_P  */
#line 3909 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 29462 "gram.c"
    break;

  case 565: /* opt_with_data: WITH NO DATA_P  */
#line 3910 "gram.y"
                                                                                        { (yyval.boolean) = FALSE; }
#line 29468 "gram.c"
    break;

  case 566: /* opt_with_data: %empty  */
#line 3911 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 29474 "gram.c"
    break;

  case 567: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW create_mv_target AS SelectStmt opt_with_data  */
#line 3924 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 29491 "gram.c"
    break;

  case 568: /* CreateMatViewStmt: CREATE OptNoLog MATERIALIZED VIEW IF_P NOT EXISTS create_mv_target AS SelectStmt opt_with_data  */
#line 3937 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 29508 "gram.c"
    break;

  case 569: /* create_mv_target: qualified_name opt_column_list opt_reloptions OptTableSpace  */
#line 3953 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-3].range);
					(yyval.into)->colNames = (yyvsp[-2].list);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 29523 "gram.c"
    break;

  case 570: /* OptNoLog: UNLOGGED  */
#line 3965 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 29529 "gram.c"
    break;

  case 571: /* OptNoLog: %empty  */
#line 3966 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 29535 "gram.c"
    break;

  case 572: /* RefreshMatViewStmt: REFRESH MATERIALIZED VIEW opt_concurrently qualified_name opt_with_data  */
#line 3979 "gram.y"
                                {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 29547 "gram.c"
    break;

  case 573: /* CreateSeqStmt: CREATE OptTemp SEQUENCE qualified_name OptSeqOptList  */
#line 3999 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 29561 "gram.c"
    break;

  case 574: /* CreateSeqStmt: CREATE OptTemp SEQUENCE IF_P NOT EXISTS qualified_name OptSeqOptList  */
#line 4009 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 29575 "gram.c"
    break;

  case 575: /* AlterSeqStmt: ALTER SEQUENCE qualified_name SeqOptList  */
#line 4022 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29587 "gram.c"
    break;

  case 576: /* AlterSeqStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SeqOptList  */
#line 4030 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29599 "gram.c"
    break;

  case 577: /* OptSeqOptList: SeqOptList  */
#line 4040 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 29605 "gram.c"
    break;

  case 578: /* OptSeqOptList: %empty  */
#line 4041 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 29611 "gram.c"
    break;

  case 579: /* OptParenthesizedSeqOptList: '(' SeqOptList ')'  */
#line 4044 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 29617 "gram.c"
    break;

  case 580: /* OptParenthesizedSeqOptList: %empty  */
#line 4045 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 29623 "gram.c"
    break;

  case 581: /* SeqOptList: SeqOptElem  */
#line 4048 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 29629 "gram.c"
    break;

  case 582: /* SeqOptList: SeqOptList SeqOptElem  */
#line 4049 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29635 "gram.c"
    break;

  case 583: /* SeqOptElem: AS SimpleTypename  */
#line 4053 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].typnam), (yylsp[-1]));
				}
#line 29643 "gram.c"
    break;

  case 584: /* SeqOptElem: CACHE NumericOnly  */
#line 4057 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 29651 "gram.c"
    break;

  case 585: /* SeqOptElem: CYCLE  */
#line 4061 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 29659 "gram.c"
    break;

  case 586: /* SeqOptElem: NO CYCLE  */
#line 4065 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE), (yylsp[-1]));
				}
#line 29667 "gram.c"
    break;

  case 587: /* SeqOptElem: INCREMENT opt_by NumericOnly  */
#line 4069 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 29675 "gram.c"
    break;

  case 588: /* SeqOptElem: MAXVALUE NumericOnly  */
#line 4073 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 29683 "gram.c"
    break;

  case 589: /* SeqOptElem: MINVALUE NumericOnly  */
#line 4077 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 29691 "gram.c"
    break;

  case 590: /* SeqOptElem: NO MAXVALUE  */
#line 4081 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 29699 "gram.c"
    break;

  case 591: /* SeqOptElem: NO MINVALUE  */
#line 4085 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 29707 "gram.c"
    break;

  case 592: /* SeqOptElem: OWNED BY any_name  */
#line 4089 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 29715 "gram.c"
    break;

  case 593: /* SeqOptElem: SEQUENCE NAME_P any_name  */
#line 4093 "gram.y"
                                {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 29724 "gram.c"
    break;

  case 594: /* SeqOptElem: START opt_with NumericOnly  */
#line 4098 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 29732 "gram.c"
    break;

  case 595: /* SeqOptElem: RESTART  */
#line 4102 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 29740 "gram.c"
    break;

  case 596: /* SeqOptElem: RESTART opt_with NumericOnly  */
#line 4106 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 29748 "gram.c"
    break;

  case 597: /* opt_by: BY  */
#line 4111 "gram.y"
                                                {}
#line 29754 "gram.c"
    break;

  case 598: /* opt_by: %empty  */
#line 4112 "gram.y"
                                        {}
#line 29760 "gram.c"
    break;

  case 599: /* NumericOnly: FCONST  */
#line 4116 "gram.y"
                                                                                        { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 29766 "gram.c"
    break;

  case 600: /* NumericOnly: '+' FCONST  */
#line 4117 "gram.y"
                                                                                { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 29772 "gram.c"
    break;

  case 601: /* NumericOnly: '-' FCONST  */
#line 4119 "gram.y"
                                {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 29781 "gram.c"
    break;

  case 602: /* NumericOnly: SignedIconst  */
#line 4123 "gram.y"
                                                                                { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 29787 "gram.c"
    break;

  case 603: /* NumericOnly_list: NumericOnly  */
#line 4126 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 29793 "gram.c"
    break;

  case 604: /* NumericOnly_list: NumericOnly_list ',' NumericOnly  */
#line 4127 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 29799 "gram.c"
    break;

  case 605: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE NonReservedWord_or_Sconst  */
#line 4140 "gram.y"
                        {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 29815 "gram.c"
    break;

  case 606: /* CreatePLangStmt: CREATE opt_or_replace opt_trusted opt_procedural LANGUAGE NonReservedWord_or_Sconst HANDLER handler_name opt_inline_handler opt_validator  */
#line 4153 "gram.y"
                        {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 29830 "gram.c"
    break;

  case 607: /* opt_trusted: TRUSTED  */
#line 4166 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 29836 "gram.c"
    break;

  case 608: /* opt_trusted: %empty  */
#line 4167 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 29842 "gram.c"
    break;

  case 609: /* handler_name: name  */
#line 4175 "gram.y"
                                                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 29848 "gram.c"
    break;

  case 610: /* handler_name: name attrs  */
#line 4176 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 29854 "gram.c"
    break;

  case 611: /* opt_inline_handler: INLINE_P handler_name  */
#line 4180 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 29860 "gram.c"
    break;

  case 612: /* opt_inline_handler: %empty  */
#line 4181 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 29866 "gram.c"
    break;

  case 613: /* validator_clause: VALIDATOR handler_name  */
#line 4185 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 29872 "gram.c"
    break;

  case 614: /* validator_clause: NO VALIDATOR  */
#line 4186 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 29878 "gram.c"
    break;

  case 615: /* opt_validator: validator_clause  */
#line 4190 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 29884 "gram.c"
    break;

  case 616: /* opt_validator: %empty  */
#line 4191 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 29890 "gram.c"
    break;

  case 617: /* DropPLangStmt: DROP opt_procedural LANGUAGE NonReservedWord_or_Sconst opt_drop_behavior  */
#line 4196 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(makeString((yyvsp[-1].str)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 29904 "gram.c"
    break;

  case 618: /* DropPLangStmt: DROP opt_procedural LANGUAGE IF_P EXISTS NonReservedWord_or_Sconst opt_drop_behavior  */
#line 4206 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(makeString((yyvsp[-1].str)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 29918 "gram.c"
    break;

  case 619: /* opt_procedural: PROCEDURAL  */
#line 4218 "gram.y"
                                                                                                {}
#line 29924 "gram.c"
    break;

  case 620: /* opt_procedural: %empty  */
#line 4219 "gram.y"
                                                                                                {}
#line 29930 "gram.c"
    break;

  case 621: /* CreateTableSpaceStmt: CREATE TABLESPACE name OptTableSpaceOwner LOCATION Sconst opt_reloptions  */
#line 4230 "gram.y"
                                {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29943 "gram.c"
    break;

  case 622: /* OptTableSpaceOwner: OWNER RoleSpec  */
#line 4240 "gram.y"
                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 29949 "gram.c"
    break;

  case 623: /* OptTableSpaceOwner: %empty  */
#line 4241 "gram.y"
                                                                { (yyval.rolespec) = NULL; }
#line 29955 "gram.c"
    break;

  case 624: /* DropTableSpaceStmt: DROP TABLESPACE name  */
#line 4255 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29966 "gram.c"
    break;

  case 625: /* DropTableSpaceStmt: DROP TABLESPACE IF_P EXISTS name  */
#line 4262 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29977 "gram.c"
    break;

  case 626: /* CreateExtensionStmt: CREATE EXTENSION name opt_with create_extension_opt_list  */
#line 4279 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29989 "gram.c"
    break;

  case 627: /* CreateExtensionStmt: CREATE EXTENSION IF_P NOT EXISTS name opt_with create_extension_opt_list  */
#line 4287 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30001 "gram.c"
    break;

  case 628: /* create_extension_opt_list: create_extension_opt_list create_extension_opt_item  */
#line 4298 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30007 "gram.c"
    break;

  case 629: /* create_extension_opt_list: %empty  */
#line 4300 "gram.y"
                                { (yyval.list) = NIL; }
#line 30013 "gram.c"
    break;

  case 630: /* create_extension_opt_item: SCHEMA name  */
#line 4305 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30021 "gram.c"
    break;

  case 631: /* create_extension_opt_item: VERSION_P NonReservedWord_or_Sconst  */
#line 4309 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30029 "gram.c"
    break;

  case 632: /* create_extension_opt_item: FROM NonReservedWord_or_Sconst  */
#line 4313 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30037 "gram.c"
    break;

  case 633: /* create_extension_opt_item: CASCADE  */
#line 4317 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 30045 "gram.c"
    break;

  case 634: /* AlterExtensionStmt: ALTER EXTENSION name UPDATE alter_extension_opt_list  */
#line 4329 "gram.y"
                                {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30056 "gram.c"
    break;

  case 635: /* alter_extension_opt_list: alter_extension_opt_list alter_extension_opt_item  */
#line 4339 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30062 "gram.c"
    break;

  case 636: /* alter_extension_opt_list: %empty  */
#line 4341 "gram.y"
                                { (yyval.list) = NIL; }
#line 30068 "gram.c"
    break;

  case 637: /* alter_extension_opt_item: TO NonReservedWord_or_Sconst  */
#line 4346 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30076 "gram.c"
    break;

  case 638: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop ACCESS METHOD name  */
#line 4359 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_ACCESS_METHOD;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 30089 "gram.c"
    break;

  case 639: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop AGGREGATE aggregate_with_argtypes  */
#line 4368 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 30102 "gram.c"
    break;

  case 640: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop CAST '(' Typename AS Typename ')'  */
#line 4377 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 30115 "gram.c"
    break;

  case 641: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop COLLATION any_name  */
#line 4386 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30128 "gram.c"
    break;

  case 642: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop CONVERSION_P any_name  */
#line 4395 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30141 "gram.c"
    break;

  case 643: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop DOMAIN_P Typename  */
#line 4404 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 30154 "gram.c"
    break;

  case 644: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FUNCTION function_with_argtypes  */
#line 4413 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 30167 "gram.c"
    break;

  case 645: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop opt_procedural LANGUAGE name  */
#line 4422 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 30180 "gram.c"
    break;

  case 646: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR operator_with_argtypes  */
#line 4431 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 30193 "gram.c"
    break;

  case 647: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR CLASS any_name USING access_method  */
#line 4440 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 30206 "gram.c"
    break;

  case 648: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop OPERATOR FAMILY any_name USING access_method  */
#line 4449 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 30219 "gram.c"
    break;

  case 649: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop SCHEMA name  */
#line 4458 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 30232 "gram.c"
    break;

  case 650: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop EVENT TRIGGER name  */
#line 4467 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 30245 "gram.c"
    break;

  case 651: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TABLE any_name  */
#line 4476 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30258 "gram.c"
    break;

  case 652: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TEXT_P SEARCH PARSER any_name  */
#line 4485 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30271 "gram.c"
    break;

  case 653: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TEXT_P SEARCH DICTIONARY any_name  */
#line 4494 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30284 "gram.c"
    break;

  case 654: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TEXT_P SEARCH TEMPLATE any_name  */
#line 4503 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30297 "gram.c"
    break;

  case 655: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TEXT_P SEARCH CONFIGURATION any_name  */
#line 4512 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30310 "gram.c"
    break;

  case 656: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop SEQUENCE any_name  */
#line 4521 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30323 "gram.c"
    break;

  case 657: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop VIEW any_name  */
#line 4530 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30336 "gram.c"
    break;

  case 658: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop MATERIALIZED VIEW any_name  */
#line 4539 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30349 "gram.c"
    break;

  case 659: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FOREIGN TABLE any_name  */
#line 4548 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30362 "gram.c"
    break;

  case 660: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop FOREIGN DATA_P WRAPPER name  */
#line 4557 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 30375 "gram.c"
    break;

  case 661: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop SERVER name  */
#line 4566 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 30388 "gram.c"
    break;

  case 662: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TRANSFORM FOR Typename LANGUAGE name  */
#line 4575 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 30401 "gram.c"
    break;

  case 663: /* AlterExtensionContentsStmt: ALTER EXTENSION name add_drop TYPE_P Typename  */
#line 4584 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 30414 "gram.c"
    break;

  case 664: /* CreateFdwStmt: CREATE FOREIGN DATA_P WRAPPER name opt_fdw_options create_generic_options  */
#line 4602 "gram.y"
                                {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30426 "gram.c"
    break;

  case 665: /* fdw_option: HANDLER handler_name  */
#line 4612 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 30432 "gram.c"
    break;

  case 666: /* fdw_option: NO HANDLER  */
#line 4613 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 30438 "gram.c"
    break;

  case 667: /* fdw_option: VALIDATOR handler_name  */
#line 4614 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 30444 "gram.c"
    break;

  case 668: /* fdw_option: NO VALIDATOR  */
#line 4615 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 30450 "gram.c"
    break;

  case 669: /* fdw_options: fdw_option  */
#line 4619 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30456 "gram.c"
    break;

  case 670: /* fdw_options: fdw_options fdw_option  */
#line 4620 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30462 "gram.c"
    break;

  case 671: /* opt_fdw_options: fdw_options  */
#line 4624 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 30468 "gram.c"
    break;

  case 672: /* opt_fdw_options: %empty  */
#line 4625 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 30474 "gram.c"
    break;

  case 673: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name opt_fdw_options alter_generic_options  */
#line 4636 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30486 "gram.c"
    break;

  case 674: /* AlterFdwStmt: ALTER FOREIGN DATA_P WRAPPER name fdw_options  */
#line 4644 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 30498 "gram.c"
    break;

  case 675: /* create_generic_options: OPTIONS '(' generic_option_list ')'  */
#line 4655 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 30504 "gram.c"
    break;

  case 676: /* create_generic_options: %empty  */
#line 4656 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 30510 "gram.c"
    break;

  case 677: /* generic_option_list: generic_option_elem  */
#line 4661 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 30518 "gram.c"
    break;

  case 678: /* generic_option_list: generic_option_list ',' generic_option_elem  */
#line 4665 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 30526 "gram.c"
    break;

  case 679: /* alter_generic_options: OPTIONS '(' alter_generic_option_list ')'  */
#line 4672 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 30532 "gram.c"
    break;

  case 680: /* alter_generic_option_list: alter_generic_option_elem  */
#line 4677 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 30540 "gram.c"
    break;

  case 681: /* alter_generic_option_list: alter_generic_option_list ',' alter_generic_option_elem  */
#line 4681 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 30548 "gram.c"
    break;

  case 682: /* alter_generic_option_elem: generic_option_elem  */
#line 4688 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 30556 "gram.c"
    break;

  case 683: /* alter_generic_option_elem: SET generic_option_elem  */
#line 4692 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 30565 "gram.c"
    break;

  case 684: /* alter_generic_option_elem: ADD_P generic_option_elem  */
#line 4697 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 30574 "gram.c"
    break;

  case 685: /* alter_generic_option_elem: DROP generic_option_name  */
#line 4702 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 30582 "gram.c"
    break;

  case 686: /* generic_option_elem: generic_option_name generic_option_arg  */
#line 4709 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 30590 "gram.c"
    break;

  case 687: /* generic_option_name: ColLabel  */
#line 4715 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30596 "gram.c"
    break;

  case 688: /* generic_option_arg: Sconst  */
#line 4720 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 30602 "gram.c"
    break;

  case 689: /* CreateForeignServerStmt: CREATE SERVER name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 4732 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 30617 "gram.c"
    break;

  case 690: /* CreateForeignServerStmt: CREATE SERVER IF_P NOT EXISTS name opt_type opt_foreign_server_version FOREIGN DATA_P WRAPPER name create_generic_options  */
#line 4744 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 30632 "gram.c"
    break;

  case 691: /* opt_type: TYPE_P Sconst  */
#line 4757 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 30638 "gram.c"
    break;

  case 692: /* opt_type: %empty  */
#line 4758 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 30644 "gram.c"
    break;

  case 693: /* foreign_server_version: VERSION_P Sconst  */
#line 4763 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 30650 "gram.c"
    break;

  case 694: /* foreign_server_version: VERSION_P NULL_P  */
#line 4764 "gram.y"
                                                        { (yyval.str) = NULL; }
#line 30656 "gram.c"
    break;

  case 695: /* opt_foreign_server_version: foreign_server_version  */
#line 4768 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 30662 "gram.c"
    break;

  case 696: /* opt_foreign_server_version: %empty  */
#line 4769 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 30668 "gram.c"
    break;

  case 697: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version alter_generic_options  */
#line 4780 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 30681 "gram.c"
    break;

  case 698: /* AlterForeignServerStmt: ALTER SERVER name foreign_server_version  */
#line 4789 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 30693 "gram.c"
    break;

  case 699: /* AlterForeignServerStmt: ALTER SERVER name alter_generic_options  */
#line 4797 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30704 "gram.c"
    break;

  case 700: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 4816 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30726 "gram.c"
    break;

  case 701: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name '(' OptTableElementList ')' OptInherit SERVER name create_generic_options  */
#line 4836 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30748 "gram.c"
    break;

  case 702: /* CreateForeignTableStmt: CREATE FOREIGN TABLE qualified_name PARTITION OF qualified_name OptTypedTableElementList ForValues SERVER name create_generic_options  */
#line 4856 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30771 "gram.c"
    break;

  case 703: /* CreateForeignTableStmt: CREATE FOREIGN TABLE IF_P NOT EXISTS qualified_name PARTITION OF qualified_name OptTypedTableElementList ForValues SERVER name create_generic_options  */
#line 4877 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30794 "gram.c"
    break;

  case 704: /* AlterForeignTableStmt: ALTER FOREIGN TABLE relation_expr alter_table_cmds  */
#line 4906 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 30807 "gram.c"
    break;

  case 705: /* AlterForeignTableStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr alter_table_cmds  */
#line 4915 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 30820 "gram.c"
    break;

  case 706: /* ImportForeignSchemaStmt: IMPORT_P FOREIGN SCHEMA name import_qualification FROM SERVER name INTO name create_generic_options  */
#line 4937 "gram.y"
                        {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 30835 "gram.c"
    break;

  case 707: /* import_qualification_type: LIMIT TO  */
#line 4950 "gram.y"
                                                        { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 30841 "gram.c"
    break;

  case 708: /* import_qualification_type: EXCEPT  */
#line 4951 "gram.y"
                                                        { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 30847 "gram.c"
    break;

  case 709: /* import_qualification: import_qualification_type '(' relation_expr_list ')'  */
#line 4956 "gram.y"
                        {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 30858 "gram.c"
    break;

  case 710: /* import_qualification: %empty  */
#line 4963 "gram.y"
                        {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 30869 "gram.c"
    break;

  case 711: /* CreateUserMappingStmt: CREATE USER MAPPING FOR auth_ident SERVER name create_generic_options  */
#line 4979 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 30882 "gram.c"
    break;

  case 712: /* CreateUserMappingStmt: CREATE USER MAPPING IF_P NOT EXISTS FOR auth_ident SERVER name create_generic_options  */
#line 4988 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 30895 "gram.c"
    break;

  case 713: /* auth_ident: RoleSpec  */
#line 4999 "gram.y"
                                        { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 30901 "gram.c"
    break;

  case 714: /* auth_ident: USER  */
#line 5000 "gram.y"
                                                        { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 30907 "gram.c"
    break;

  case 715: /* DropUserMappingStmt: DROP USER MAPPING FOR auth_ident SERVER name  */
#line 5013 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30919 "gram.c"
    break;

  case 716: /* DropUserMappingStmt: DROP USER MAPPING IF_P EXISTS FOR auth_ident SERVER name  */
#line 5021 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30931 "gram.c"
    break;

  case 717: /* AlterUserMappingStmt: ALTER USER MAPPING FOR auth_ident SERVER name alter_generic_options  */
#line 5038 "gram.y"
                                {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30943 "gram.c"
    break;

  case 718: /* CreatePolicyStmt: CREATE POLICY name ON qualified_name RowSecurityDefaultPermissive RowSecurityDefaultForCmd RowSecurityDefaultToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5064 "gram.y"
                                {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30959 "gram.c"
    break;

  case 719: /* AlterPolicyStmt: ALTER POLICY name ON qualified_name RowSecurityOptionalToRole RowSecurityOptionalExpr RowSecurityOptionalWithCheck  */
#line 5080 "gram.y"
                                {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30973 "gram.c"
    break;

  case 720: /* RowSecurityOptionalExpr: USING '(' a_expr ')'  */
#line 5092 "gram.y"
                                                { (yyval.node) = (yyvsp[-1].node); }
#line 30979 "gram.c"
    break;

  case 721: /* RowSecurityOptionalExpr: %empty  */
#line 5093 "gram.y"
                                                        { (yyval.node) = NULL; }
#line 30985 "gram.c"
    break;

  case 722: /* RowSecurityOptionalWithCheck: WITH CHECK '(' a_expr ')'  */
#line 5097 "gram.y"
                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 30991 "gram.c"
    break;

  case 723: /* RowSecurityOptionalWithCheck: %empty  */
#line 5098 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 30997 "gram.c"
    break;

  case 724: /* RowSecurityDefaultToRole: TO role_list  */
#line 5102 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 31003 "gram.c"
    break;

  case 725: /* RowSecurityDefaultToRole: %empty  */
#line 5103 "gram.y"
                                                        { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 31009 "gram.c"
    break;

  case 726: /* RowSecurityOptionalToRole: TO role_list  */
#line 5107 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 31015 "gram.c"
    break;

  case 727: /* RowSecurityOptionalToRole: %empty  */
#line 5108 "gram.y"
                                                        { (yyval.list) = NULL; }
#line 31021 "gram.c"
    break;

  case 728: /* RowSecurityDefaultPermissive: AS IDENT  */
#line 5113 "gram.y"
                                {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
									 parser_errposition((yylsp[0]))));

				}
#line 31039 "gram.c"
    break;

  case 729: /* RowSecurityDefaultPermissive: %empty  */
#line 5126 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 31045 "gram.c"
    break;

  case 730: /* RowSecurityDefaultForCmd: FOR row_security_cmd  */
#line 5130 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 31051 "gram.c"
    break;

  case 731: /* RowSecurityDefaultForCmd: %empty  */
#line 5131 "gram.y"
                                                        { (yyval.str) = "all"; }
#line 31057 "gram.c"
    break;

  case 732: /* row_security_cmd: ALL  */
#line 5135 "gram.y"
                                                        { (yyval.str) = "all"; }
#line 31063 "gram.c"
    break;

  case 733: /* row_security_cmd: SELECT  */
#line 5136 "gram.y"
                                                { (yyval.str) = "select"; }
#line 31069 "gram.c"
    break;

  case 734: /* row_security_cmd: INSERT  */
#line 5137 "gram.y"
                                                { (yyval.str) = "insert"; }
#line 31075 "gram.c"
    break;

  case 735: /* row_security_cmd: UPDATE  */
#line 5138 "gram.y"
                                                { (yyval.str) = "update"; }
#line 31081 "gram.c"
    break;

  case 736: /* row_security_cmd: DELETE_P  */
#line 5139 "gram.y"
                                                { (yyval.str) = "delete"; }
#line 31087 "gram.c"
    break;

  case 737: /* CreateAmStmt: CREATE ACCESS METHOD name TYPE_P INDEX HANDLER handler_name  */
#line 5150 "gram.y"
                                {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = AMTYPE_INDEX;
					(yyval.node) = (Node *) n;
				}
#line 31099 "gram.c"
    break;

  case 738: /* CreateTrigStmt: CREATE TRIGGER name TriggerActionTime TriggerEvents ON qualified_name TriggerReferencing TriggerForSpec TriggerWhen EXECUTE PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 5170 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 31122 "gram.c"
    break;

  case 739: /* CreateTrigStmt: CREATE CONSTRAINT TRIGGER name AFTER TriggerEvents ON qualified_name OptConstrFromTable ConstraintAttributeSpec FOR EACH ROW TriggerWhen EXECUTE PROCEDURE func_name '(' TriggerFuncArgs ')'  */
#line 5192 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 31146 "gram.c"
    break;

  case 740: /* TriggerActionTime: BEFORE  */
#line 5214 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 31152 "gram.c"
    break;

  case 741: /* TriggerActionTime: AFTER  */
#line 5215 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 31158 "gram.c"
    break;

  case 742: /* TriggerActionTime: INSTEAD OF  */
#line 5216 "gram.y"
                                                                                { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 31164 "gram.c"
    break;

  case 743: /* TriggerEvents: TriggerOneEvent  */
#line 5221 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 31170 "gram.c"
    break;

  case 744: /* TriggerEvents: TriggerEvents OR TriggerOneEvent  */
#line 5223 "gram.y"
                                {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 31193 "gram.c"
    break;

  case 745: /* TriggerOneEvent: INSERT  */
#line 5245 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 31199 "gram.c"
    break;

  case 746: /* TriggerOneEvent: DELETE_P  */
#line 5247 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 31205 "gram.c"
    break;

  case 747: /* TriggerOneEvent: UPDATE  */
#line 5249 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 31211 "gram.c"
    break;

  case 748: /* TriggerOneEvent: UPDATE OF columnList  */
#line 5251 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 31217 "gram.c"
    break;

  case 749: /* TriggerOneEvent: TRUNCATE  */
#line 5253 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 31223 "gram.c"
    break;

  case 750: /* TriggerReferencing: REFERENCING TriggerTransitions  */
#line 5257 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 31229 "gram.c"
    break;

  case 751: /* TriggerReferencing: %empty  */
#line 5258 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 31235 "gram.c"
    break;

  case 752: /* TriggerTransitions: TriggerTransition  */
#line 5262 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31241 "gram.c"
    break;

  case 753: /* TriggerTransitions: TriggerTransitions TriggerTransition  */
#line 5263 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 31247 "gram.c"
    break;

  case 754: /* TriggerTransition: TransitionOldOrNew TransitionRowOrTable opt_as TransitionRelName  */
#line 5268 "gram.y"
                                {
					TriggerTransition *n = makeNode(TriggerTransition);
					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *)n;
				}
#line 31259 "gram.c"
    break;

  case 755: /* TransitionOldOrNew: NEW  */
#line 5278 "gram.y"
                                                                                                        { (yyval.boolean) = TRUE; }
#line 31265 "gram.c"
    break;

  case 756: /* TransitionOldOrNew: OLD  */
#line 5279 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 31271 "gram.c"
    break;

  case 757: /* TransitionRowOrTable: TABLE  */
#line 5283 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 31277 "gram.c"
    break;

  case 758: /* TransitionRowOrTable: ROW  */
#line 5292 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 31283 "gram.c"
    break;

  case 759: /* TransitionRelName: ColId  */
#line 5296 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31289 "gram.c"
    break;

  case 760: /* TriggerForSpec: FOR TriggerForOptEach TriggerForType  */
#line 5301 "gram.y"
                                {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 31297 "gram.c"
    break;

  case 761: /* TriggerForSpec: %empty  */
#line 5305 "gram.y"
                                {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 31309 "gram.c"
    break;

  case 762: /* TriggerForOptEach: EACH  */
#line 5315 "gram.y"
                                                                                                {}
#line 31315 "gram.c"
    break;

  case 763: /* TriggerForOptEach: %empty  */
#line 5316 "gram.y"
                                                                                                {}
#line 31321 "gram.c"
    break;

  case 764: /* TriggerForType: ROW  */
#line 5320 "gram.y"
                                                                                                        { (yyval.boolean) = TRUE; }
#line 31327 "gram.c"
    break;

  case 765: /* TriggerForType: STATEMENT  */
#line 5321 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 31333 "gram.c"
    break;

  case 766: /* TriggerWhen: WHEN '(' a_expr ')'  */
#line 5325 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 31339 "gram.c"
    break;

  case 767: /* TriggerWhen: %empty  */
#line 5326 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31345 "gram.c"
    break;

  case 768: /* TriggerFuncArgs: TriggerFuncArg  */
#line 5330 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 31351 "gram.c"
    break;

  case 769: /* TriggerFuncArgs: TriggerFuncArgs ',' TriggerFuncArg  */
#line 5331 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 31357 "gram.c"
    break;

  case 770: /* TriggerFuncArgs: %empty  */
#line 5332 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 31363 "gram.c"
    break;

  case 771: /* TriggerFuncArg: Iconst  */
#line 5337 "gram.y"
                                {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 31371 "gram.c"
    break;

  case 772: /* TriggerFuncArg: FCONST  */
#line 5340 "gram.y"
                                                                                                { (yyval.value) = makeString((yyvsp[0].str)); }
#line 31377 "gram.c"
    break;

  case 773: /* TriggerFuncArg: Sconst  */
#line 5341 "gram.y"
                                                                                                { (yyval.value) = makeString((yyvsp[0].str)); }
#line 31383 "gram.c"
    break;

  case 774: /* TriggerFuncArg: ColLabel  */
#line 5342 "gram.y"
                                                                                                { (yyval.value) = makeString((yyvsp[0].str)); }
#line 31389 "gram.c"
    break;

  case 775: /* OptConstrFromTable: FROM qualified_name  */
#line 5346 "gram.y"
                                                                                        { (yyval.range) = (yyvsp[0].range); }
#line 31395 "gram.c"
    break;

  case 776: /* OptConstrFromTable: %empty  */
#line 5347 "gram.y"
                                                                                                { (yyval.range) = NULL; }
#line 31401 "gram.c"
    break;

  case 777: /* ConstraintAttributeSpec: %empty  */
#line 5352 "gram.y"
                                { (yyval.ival) = 0; }
#line 31407 "gram.c"
    break;

  case 778: /* ConstraintAttributeSpec: ConstraintAttributeSpec ConstraintAttributeElem  */
#line 5354 "gram.y"
                                {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 31435 "gram.c"
    break;

  case 779: /* ConstraintAttributeElem: NOT DEFERRABLE  */
#line 5380 "gram.y"
                                                                        { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 31441 "gram.c"
    break;

  case 780: /* ConstraintAttributeElem: DEFERRABLE  */
#line 5381 "gram.y"
                                                                        { (yyval.ival) = CAS_DEFERRABLE; }
#line 31447 "gram.c"
    break;

  case 781: /* ConstraintAttributeElem: INITIALLY IMMEDIATE  */
#line 5382 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 31453 "gram.c"
    break;

  case 782: /* ConstraintAttributeElem: INITIALLY DEFERRED  */
#line 5383 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 31459 "gram.c"
    break;

  case 783: /* ConstraintAttributeElem: NOT VALID  */
#line 5384 "gram.y"
                                                                                { (yyval.ival) = CAS_NOT_VALID; }
#line 31465 "gram.c"
    break;

  case 784: /* ConstraintAttributeElem: NO INHERIT  */
#line 5385 "gram.y"
                                                                        { (yyval.ival) = CAS_NO_INHERIT; }
#line 31471 "gram.c"
    break;

  case 785: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel EXECUTE PROCEDURE func_name '(' ')'  */
#line 5400 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 31484 "gram.c"
    break;

  case 786: /* CreateEventTrigStmt: CREATE EVENT TRIGGER name ON ColLabel WHEN event_trigger_when_list EXECUTE PROCEDURE func_name '(' ')'  */
#line 5411 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 31497 "gram.c"
    break;

  case 787: /* event_trigger_when_list: event_trigger_when_item  */
#line 5423 "gram.y"
                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31503 "gram.c"
    break;

  case 788: /* event_trigger_when_list: event_trigger_when_list AND event_trigger_when_item  */
#line 5425 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 31509 "gram.c"
    break;

  case 789: /* event_trigger_when_item: ColId IN_P '(' event_trigger_value_list ')'  */
#line 5430 "gram.y"
                        { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 31515 "gram.c"
    break;

  case 790: /* event_trigger_value_list: SCONST  */
#line 5435 "gram.y"
                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 31521 "gram.c"
    break;

  case 791: /* event_trigger_value_list: event_trigger_value_list ',' SCONST  */
#line 5437 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 31527 "gram.c"
    break;

  case 792: /* AlterEventTrigStmt: ALTER EVENT TRIGGER name enable_trigger  */
#line 5442 "gram.y"
                                {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 31538 "gram.c"
    break;

  case 793: /* enable_trigger: ENABLE_P  */
#line 5451 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 31544 "gram.c"
    break;

  case 794: /* enable_trigger: ENABLE_P REPLICA  */
#line 5452 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 31550 "gram.c"
    break;

  case 795: /* enable_trigger: ENABLE_P ALWAYS  */
#line 5453 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 31556 "gram.c"
    break;

  case 796: /* enable_trigger: DISABLE_P  */
#line 5454 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_DISABLED; }
#line 31562 "gram.c"
    break;

  case 797: /* CreateAssertStmt: CREATE ASSERTION name CHECK '(' a_expr ')' ConstraintAttributeSpec  */
#line 5468 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 31582 "gram.c"
    break;

  case 798: /* DropAssertStmt: DROP ASSERTION name opt_drop_behavior  */
#line 5487 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 31597 "gram.c"
    break;

  case 799: /* DefineStmt: CREATE AGGREGATE func_name aggr_args definition  */
#line 5509 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31611 "gram.c"
    break;

  case 800: /* DefineStmt: CREATE AGGREGATE func_name old_aggr_definition  */
#line 5519 "gram.y"
                                {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31626 "gram.c"
    break;

  case 801: /* DefineStmt: CREATE OPERATOR any_operator definition  */
#line 5530 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31640 "gram.c"
    break;

  case 802: /* DefineStmt: CREATE TYPE_P any_name definition  */
#line 5540 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31654 "gram.c"
    break;

  case 803: /* DefineStmt: CREATE TYPE_P any_name  */
#line 5550 "gram.y"
                                {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 31669 "gram.c"
    break;

  case 804: /* DefineStmt: CREATE TYPE_P any_name AS '(' OptTableFuncElementList ')'  */
#line 5561 "gram.y"
                                {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 31682 "gram.c"
    break;

  case 805: /* DefineStmt: CREATE TYPE_P any_name AS ENUM_P '(' opt_enum_val_list ')'  */
#line 5570 "gram.y"
                                {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 31693 "gram.c"
    break;

  case 806: /* DefineStmt: CREATE TYPE_P any_name AS RANGE definition  */
#line 5577 "gram.y"
                                {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31704 "gram.c"
    break;

  case 807: /* DefineStmt: CREATE TEXT_P SEARCH PARSER any_name definition  */
#line 5584 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31717 "gram.c"
    break;

  case 808: /* DefineStmt: CREATE TEXT_P SEARCH DICTIONARY any_name definition  */
#line 5593 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31730 "gram.c"
    break;

  case 809: /* DefineStmt: CREATE TEXT_P SEARCH TEMPLATE any_name definition  */
#line 5602 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31743 "gram.c"
    break;

  case 810: /* DefineStmt: CREATE TEXT_P SEARCH CONFIGURATION any_name definition  */
#line 5611 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31756 "gram.c"
    break;

  case 811: /* DefineStmt: CREATE COLLATION any_name definition  */
#line 5620 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31769 "gram.c"
    break;

  case 812: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name definition  */
#line 5629 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 31783 "gram.c"
    break;

  case 813: /* DefineStmt: CREATE COLLATION any_name FROM any_name  */
#line 5639 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 31796 "gram.c"
    break;

  case 814: /* DefineStmt: CREATE COLLATION IF_P NOT EXISTS any_name FROM any_name  */
#line 5648 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 31810 "gram.c"
    break;

  case 815: /* definition: '(' def_list ')'  */
#line 5659 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 31816 "gram.c"
    break;

  case 816: /* def_list: def_elem  */
#line 5662 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31822 "gram.c"
    break;

  case 817: /* def_list: def_list ',' def_elem  */
#line 5663 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 31828 "gram.c"
    break;

  case 818: /* def_elem: ColLabel '=' def_arg  */
#line 5667 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 31836 "gram.c"
    break;

  case 819: /* def_elem: ColLabel  */
#line 5671 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 31844 "gram.c"
    break;

  case 820: /* def_arg: func_type  */
#line 5677 "gram.y"
                                                                        { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 31850 "gram.c"
    break;

  case 821: /* def_arg: reserved_keyword  */
#line 5678 "gram.y"
                                                                        { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 31856 "gram.c"
    break;

  case 822: /* def_arg: qual_all_Op  */
#line 5679 "gram.y"
                                                                        { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 31862 "gram.c"
    break;

  case 823: /* def_arg: NumericOnly  */
#line 5680 "gram.y"
                                                                        { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 31868 "gram.c"
    break;

  case 824: /* def_arg: Sconst  */
#line 5681 "gram.y"
                                                                                { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 31874 "gram.c"
    break;

  case 825: /* def_arg: NONE  */
#line 5682 "gram.y"
                                                                                { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 31880 "gram.c"
    break;

  case 826: /* old_aggr_definition: '(' old_aggr_list ')'  */
#line 5685 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 31886 "gram.c"
    break;

  case 827: /* old_aggr_list: old_aggr_elem  */
#line 5688 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31892 "gram.c"
    break;

  case 828: /* old_aggr_list: old_aggr_list ',' old_aggr_elem  */
#line 5689 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 31898 "gram.c"
    break;

  case 829: /* old_aggr_elem: IDENT '=' def_arg  */
#line 5698 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node), (yylsp[-2]));
				}
#line 31906 "gram.c"
    break;

  case 830: /* opt_enum_val_list: enum_val_list  */
#line 5704 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 31912 "gram.c"
    break;

  case 831: /* opt_enum_val_list: %empty  */
#line 5705 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 31918 "gram.c"
    break;

  case 832: /* enum_val_list: Sconst  */
#line 5709 "gram.y"
                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 31924 "gram.c"
    break;

  case 833: /* enum_val_list: enum_val_list ',' Sconst  */
#line 5711 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 31930 "gram.c"
    break;

  case 834: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst  */
#line 5722 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 31945 "gram.c"
    break;

  case 835: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst BEFORE Sconst  */
#line 5733 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 31960 "gram.c"
    break;

  case 836: /* AlterEnumStmt: ALTER TYPE_P any_name ADD_P VALUE_P opt_if_not_exists Sconst AFTER Sconst  */
#line 5744 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 31975 "gram.c"
    break;

  case 837: /* AlterEnumStmt: ALTER TYPE_P any_name RENAME VALUE_P Sconst TO Sconst  */
#line 5755 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 31990 "gram.c"
    break;

  case 838: /* opt_if_not_exists: IF_P NOT EXISTS  */
#line 5767 "gram.y"
                                                { (yyval.boolean) = true; }
#line 31996 "gram.c"
    break;

  case 839: /* opt_if_not_exists: %empty  */
#line 5768 "gram.y"
                                                       { (yyval.boolean) = false; }
#line 32002 "gram.c"
    break;

  case 840: /* CreateOpClassStmt: CREATE OPERATOR CLASS any_name opt_default FOR TYPE_P Typename USING access_method opt_opfamily AS opclass_item_list  */
#line 5786 "gram.y"
                                {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32017 "gram.c"
    break;

  case 841: /* opclass_item_list: opclass_item  */
#line 5799 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32023 "gram.c"
    break;

  case 842: /* opclass_item_list: opclass_item_list ',' opclass_item  */
#line 5800 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32029 "gram.c"
    break;

  case 843: /* opclass_item: OPERATOR Iconst any_operator opclass_purpose opt_recheck  */
#line 5805 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);
					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 32045 "gram.c"
    break;

  case 844: /* opclass_item: OPERATOR Iconst operator_with_argtypes opclass_purpose opt_recheck  */
#line 5818 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 32058 "gram.c"
    break;

  case 845: /* opclass_item: FUNCTION Iconst function_with_argtypes  */
#line 5827 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 32070 "gram.c"
    break;

  case 846: /* opclass_item: FUNCTION Iconst '(' type_list ')' function_with_argtypes  */
#line 5835 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 32083 "gram.c"
    break;

  case 847: /* opclass_item: STORAGE Typename  */
#line 5844 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 32094 "gram.c"
    break;

  case 848: /* opt_default: DEFAULT  */
#line 5852 "gram.y"
                                                                { (yyval.boolean) = TRUE; }
#line 32100 "gram.c"
    break;

  case 849: /* opt_default: %empty  */
#line 5853 "gram.y"
                                                                                { (yyval.boolean) = FALSE; }
#line 32106 "gram.c"
    break;

  case 850: /* opt_opfamily: FAMILY any_name  */
#line 5856 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 32112 "gram.c"
    break;

  case 851: /* opt_opfamily: %empty  */
#line 5857 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 32118 "gram.c"
    break;

  case 852: /* opclass_purpose: FOR SEARCH  */
#line 5860 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 32124 "gram.c"
    break;

  case 853: /* opclass_purpose: FOR ORDER BY any_name  */
#line 5861 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 32130 "gram.c"
    break;

  case 854: /* opclass_purpose: %empty  */
#line 5862 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 32136 "gram.c"
    break;

  case 855: /* opt_recheck: RECHECK  */
#line 5866 "gram.y"
                                {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 32154 "gram.c"
    break;

  case 856: /* opt_recheck: %empty  */
#line 5879 "gram.y"
                                                                                { (yyval.boolean) = FALSE; }
#line 32160 "gram.c"
    break;

  case 857: /* CreateOpFamilyStmt: CREATE OPERATOR FAMILY any_name USING access_method  */
#line 5885 "gram.y"
                                {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32171 "gram.c"
    break;

  case 858: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING access_method ADD_P opclass_item_list  */
#line 5895 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32184 "gram.c"
    break;

  case 859: /* AlterOpFamilyStmt: ALTER OPERATOR FAMILY any_name USING access_method DROP opclass_drop_list  */
#line 5904 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32197 "gram.c"
    break;

  case 860: /* opclass_drop_list: opclass_drop  */
#line 5915 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32203 "gram.c"
    break;

  case 861: /* opclass_drop_list: opclass_drop_list ',' opclass_drop  */
#line 5916 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32209 "gram.c"
    break;

  case 862: /* opclass_drop: OPERATOR Iconst '(' type_list ')'  */
#line 5921 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 32221 "gram.c"
    break;

  case 863: /* opclass_drop: FUNCTION Iconst '(' type_list ')'  */
#line 5929 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 32233 "gram.c"
    break;

  case 864: /* DropOpClassStmt: DROP OPERATOR CLASS any_name USING access_method opt_drop_behavior  */
#line 5941 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32247 "gram.c"
    break;

  case 865: /* DropOpClassStmt: DROP OPERATOR CLASS IF_P EXISTS any_name USING access_method opt_drop_behavior  */
#line 5951 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32261 "gram.c"
    break;

  case 866: /* DropOpFamilyStmt: DROP OPERATOR FAMILY any_name USING access_method opt_drop_behavior  */
#line 5964 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32275 "gram.c"
    break;

  case 867: /* DropOpFamilyStmt: DROP OPERATOR FAMILY IF_P EXISTS any_name USING access_method opt_drop_behavior  */
#line 5974 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32289 "gram.c"
    break;

  case 868: /* DropOwnedStmt: DROP OWNED BY role_list opt_drop_behavior  */
#line 5996 "gram.y"
                                {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 32300 "gram.c"
    break;

  case 869: /* ReassignOwnedStmt: REASSIGN OWNED BY role_list TO RoleSpec  */
#line 6006 "gram.y"
                                {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 32311 "gram.c"
    break;

  case 870: /* DropStmt: DROP drop_type_any_name IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6024 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32325 "gram.c"
    break;

  case 871: /* DropStmt: DROP drop_type_any_name any_name_list opt_drop_behavior  */
#line 6034 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32339 "gram.c"
    break;

  case 872: /* DropStmt: DROP drop_type_name IF_P EXISTS name_list opt_drop_behavior  */
#line 6044 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32353 "gram.c"
    break;

  case 873: /* DropStmt: DROP drop_type_name name_list opt_drop_behavior  */
#line 6054 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 32367 "gram.c"
    break;

  case 874: /* DropStmt: DROP drop_type_name_on_any_name name ON any_name opt_drop_behavior  */
#line 6064 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32381 "gram.c"
    break;

  case 875: /* DropStmt: DROP drop_type_name_on_any_name IF_P EXISTS name ON any_name opt_drop_behavior  */
#line 6074 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32395 "gram.c"
    break;

  case 876: /* DropStmt: DROP TYPE_P type_name_list opt_drop_behavior  */
#line 6084 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32409 "gram.c"
    break;

  case 877: /* DropStmt: DROP TYPE_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6094 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32423 "gram.c"
    break;

  case 878: /* DropStmt: DROP DOMAIN_P type_name_list opt_drop_behavior  */
#line 6104 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32437 "gram.c"
    break;

  case 879: /* DropStmt: DROP DOMAIN_P IF_P EXISTS type_name_list opt_drop_behavior  */
#line 6114 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 32451 "gram.c"
    break;

  case 880: /* DropStmt: DROP INDEX CONCURRENTLY any_name_list opt_drop_behavior  */
#line 6124 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 32465 "gram.c"
    break;

  case 881: /* DropStmt: DROP INDEX CONCURRENTLY IF_P EXISTS any_name_list opt_drop_behavior  */
#line 6134 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 32479 "gram.c"
    break;

  case 882: /* drop_type_any_name: TABLE  */
#line 6147 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TABLE; }
#line 32485 "gram.c"
    break;

  case 883: /* drop_type_any_name: SEQUENCE  */
#line 6148 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 32491 "gram.c"
    break;

  case 884: /* drop_type_any_name: VIEW  */
#line 6149 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_VIEW; }
#line 32497 "gram.c"
    break;

  case 885: /* drop_type_any_name: MATERIALIZED VIEW  */
#line 6150 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_MATVIEW; }
#line 32503 "gram.c"
    break;

  case 886: /* drop_type_any_name: INDEX  */
#line 6151 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_INDEX; }
#line 32509 "gram.c"
    break;

  case 887: /* drop_type_any_name: FOREIGN TABLE  */
#line 6152 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 32515 "gram.c"
    break;

  case 888: /* drop_type_any_name: COLLATION  */
#line 6153 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_COLLATION; }
#line 32521 "gram.c"
    break;

  case 889: /* drop_type_any_name: CONVERSION_P  */
#line 6154 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_CONVERSION; }
#line 32527 "gram.c"
    break;

  case 890: /* drop_type_any_name: STATISTICS  */
#line 6155 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 32533 "gram.c"
    break;

  case 891: /* drop_type_any_name: TEXT_P SEARCH PARSER  */
#line 6156 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSPARSER; }
#line 32539 "gram.c"
    break;

  case 892: /* drop_type_any_name: TEXT_P SEARCH DICTIONARY  */
#line 6157 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 32545 "gram.c"
    break;

  case 893: /* drop_type_any_name: TEXT_P SEARCH TEMPLATE  */
#line 6158 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 32551 "gram.c"
    break;

  case 894: /* drop_type_any_name: TEXT_P SEARCH CONFIGURATION  */
#line 6159 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 32557 "gram.c"
    break;

  case 895: /* drop_type_name: ACCESS METHOD  */
#line 6164 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 32563 "gram.c"
    break;

  case 896: /* drop_type_name: EVENT TRIGGER  */
#line 6165 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 32569 "gram.c"
    break;

  case 897: /* drop_type_name: EXTENSION  */
#line 6166 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_EXTENSION; }
#line 32575 "gram.c"
    break;

  case 898: /* drop_type_name: FOREIGN DATA_P WRAPPER  */
#line 6167 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_FDW; }
#line 32581 "gram.c"
    break;

  case 899: /* drop_type_name: PUBLICATION  */
#line 6168 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 32587 "gram.c"
    break;

  case 900: /* drop_type_name: SCHEMA  */
#line 6169 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SCHEMA; }
#line 32593 "gram.c"
    break;

  case 901: /* drop_type_name: SERVER  */
#line 6170 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 32599 "gram.c"
    break;

  case 902: /* drop_type_name_on_any_name: POLICY  */
#line 6175 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_POLICY; }
#line 32605 "gram.c"
    break;

  case 903: /* drop_type_name_on_any_name: RULE  */
#line 6176 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_RULE; }
#line 32611 "gram.c"
    break;

  case 904: /* drop_type_name_on_any_name: TRIGGER  */
#line 6177 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TRIGGER; }
#line 32617 "gram.c"
    break;

  case 905: /* any_name_list: any_name  */
#line 6181 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 32623 "gram.c"
    break;

  case 906: /* any_name_list: any_name_list ',' any_name  */
#line 6182 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 32629 "gram.c"
    break;

  case 907: /* any_name: ColId  */
#line 6185 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32635 "gram.c"
    break;

  case 908: /* any_name: ColId attrs  */
#line 6186 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 32641 "gram.c"
    break;

  case 909: /* attrs: '.' attr_name  */
#line 6190 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32647 "gram.c"
    break;

  case 910: /* attrs: attrs '.' attr_name  */
#line 6192 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 32653 "gram.c"
    break;

  case 911: /* type_name_list: Typename  */
#line 6196 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 32659 "gram.c"
    break;

  case 912: /* type_name_list: type_name_list ',' Typename  */
#line 6197 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 32665 "gram.c"
    break;

  case 913: /* TruncateStmt: TRUNCATE opt_table relation_expr_list opt_restart_seqs opt_drop_behavior  */
#line 6209 "gram.y"
                                {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 32677 "gram.c"
    break;

  case 914: /* opt_restart_seqs: CONTINUE_P IDENTITY_P  */
#line 6219 "gram.y"
                                                        { (yyval.boolean) = false; }
#line 32683 "gram.c"
    break;

  case 915: /* opt_restart_seqs: RESTART IDENTITY_P  */
#line 6220 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 32689 "gram.c"
    break;

  case 916: /* opt_restart_seqs: %empty  */
#line 6221 "gram.y"
                                                                { (yyval.boolean) = false; }
#line 32695 "gram.c"
    break;

  case 917: /* CommentStmt: COMMENT ON comment_type_any_name any_name IS comment_text  */
#line 6256 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32707 "gram.c"
    break;

  case 918: /* CommentStmt: COMMENT ON comment_type_name name IS comment_text  */
#line 6264 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32719 "gram.c"
    break;

  case 919: /* CommentStmt: COMMENT ON TYPE_P Typename IS comment_text  */
#line 6272 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32731 "gram.c"
    break;

  case 920: /* CommentStmt: COMMENT ON DOMAIN_P Typename IS comment_text  */
#line 6280 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32743 "gram.c"
    break;

  case 921: /* CommentStmt: COMMENT ON AGGREGATE aggregate_with_argtypes IS comment_text  */
#line 6288 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32755 "gram.c"
    break;

  case 922: /* CommentStmt: COMMENT ON FUNCTION function_with_argtypes IS comment_text  */
#line 6296 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32767 "gram.c"
    break;

  case 923: /* CommentStmt: COMMENT ON OPERATOR operator_with_argtypes IS comment_text  */
#line 6304 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32779 "gram.c"
    break;

  case 924: /* CommentStmt: COMMENT ON CONSTRAINT name ON any_name IS comment_text  */
#line 6312 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32791 "gram.c"
    break;

  case 925: /* CommentStmt: COMMENT ON CONSTRAINT name ON DOMAIN_P any_name IS comment_text  */
#line 6320 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32808 "gram.c"
    break;

  case 926: /* CommentStmt: COMMENT ON POLICY name ON any_name IS comment_text  */
#line 6333 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_POLICY;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32820 "gram.c"
    break;

  case 927: /* CommentStmt: COMMENT ON RULE name ON any_name IS comment_text  */
#line 6341 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32832 "gram.c"
    break;

  case 928: /* CommentStmt: COMMENT ON TRANSFORM FOR Typename LANGUAGE name IS comment_text  */
#line 6349 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32844 "gram.c"
    break;

  case 929: /* CommentStmt: COMMENT ON TRIGGER name ON any_name IS comment_text  */
#line 6357 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32856 "gram.c"
    break;

  case 930: /* CommentStmt: COMMENT ON OPERATOR CLASS any_name USING access_method IS comment_text  */
#line 6365 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32868 "gram.c"
    break;

  case 931: /* CommentStmt: COMMENT ON OPERATOR FAMILY any_name USING access_method IS comment_text  */
#line 6373 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32880 "gram.c"
    break;

  case 932: /* CommentStmt: COMMENT ON LARGE_P OBJECT_P NumericOnly IS comment_text  */
#line 6381 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32892 "gram.c"
    break;

  case 933: /* CommentStmt: COMMENT ON CAST '(' Typename AS Typename ')' IS comment_text  */
#line 6389 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32904 "gram.c"
    break;

  case 934: /* comment_type_any_name: COLUMN  */
#line 6400 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_COLUMN; }
#line 32910 "gram.c"
    break;

  case 935: /* comment_type_any_name: INDEX  */
#line 6401 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_INDEX; }
#line 32916 "gram.c"
    break;

  case 936: /* comment_type_any_name: SEQUENCE  */
#line 6402 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 32922 "gram.c"
    break;

  case 937: /* comment_type_any_name: STATISTICS  */
#line 6403 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 32928 "gram.c"
    break;

  case 938: /* comment_type_any_name: TABLE  */
#line 6404 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TABLE; }
#line 32934 "gram.c"
    break;

  case 939: /* comment_type_any_name: VIEW  */
#line 6405 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_VIEW; }
#line 32940 "gram.c"
    break;

  case 940: /* comment_type_any_name: MATERIALIZED VIEW  */
#line 6406 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_MATVIEW; }
#line 32946 "gram.c"
    break;

  case 941: /* comment_type_any_name: COLLATION  */
#line 6407 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_COLLATION; }
#line 32952 "gram.c"
    break;

  case 942: /* comment_type_any_name: CONVERSION_P  */
#line 6408 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_CONVERSION; }
#line 32958 "gram.c"
    break;

  case 943: /* comment_type_any_name: FOREIGN TABLE  */
#line 6409 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 32964 "gram.c"
    break;

  case 944: /* comment_type_any_name: TEXT_P SEARCH CONFIGURATION  */
#line 6410 "gram.y"
                                                                { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 32970 "gram.c"
    break;

  case 945: /* comment_type_any_name: TEXT_P SEARCH DICTIONARY  */
#line 6411 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 32976 "gram.c"
    break;

  case 946: /* comment_type_any_name: TEXT_P SEARCH PARSER  */
#line 6412 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSPARSER; }
#line 32982 "gram.c"
    break;

  case 947: /* comment_type_any_name: TEXT_P SEARCH TEMPLATE  */
#line 6413 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 32988 "gram.c"
    break;

  case 948: /* comment_type_name: ACCESS METHOD  */
#line 6418 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 32994 "gram.c"
    break;

  case 949: /* comment_type_name: DATABASE  */
#line 6419 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_DATABASE; }
#line 33000 "gram.c"
    break;

  case 950: /* comment_type_name: EVENT TRIGGER  */
#line 6420 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 33006 "gram.c"
    break;

  case 951: /* comment_type_name: EXTENSION  */
#line 6421 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_EXTENSION; }
#line 33012 "gram.c"
    break;

  case 952: /* comment_type_name: FOREIGN DATA_P WRAPPER  */
#line 6422 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_FDW; }
#line 33018 "gram.c"
    break;

  case 953: /* comment_type_name: opt_procedural LANGUAGE  */
#line 6423 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 33024 "gram.c"
    break;

  case 954: /* comment_type_name: PUBLICATION  */
#line 6424 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 33030 "gram.c"
    break;

  case 955: /* comment_type_name: ROLE  */
#line 6425 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_ROLE; }
#line 33036 "gram.c"
    break;

  case 956: /* comment_type_name: SCHEMA  */
#line 6426 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SCHEMA; }
#line 33042 "gram.c"
    break;

  case 957: /* comment_type_name: SERVER  */
#line 6427 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 33048 "gram.c"
    break;

  case 958: /* comment_type_name: SUBSCRIPTION  */
#line 6428 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 33054 "gram.c"
    break;

  case 959: /* comment_type_name: TABLESPACE  */
#line 6429 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 33060 "gram.c"
    break;

  case 960: /* comment_text: Sconst  */
#line 6433 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 33066 "gram.c"
    break;

  case 961: /* comment_text: NULL_P  */
#line 6434 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 33072 "gram.c"
    break;

  case 962: /* SecLabelStmt: SECURITY LABEL opt_provider ON security_label_type_any_name any_name IS security_label  */
#line 6450 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33085 "gram.c"
    break;

  case 963: /* SecLabelStmt: SECURITY LABEL opt_provider ON security_label_type_name name IS security_label  */
#line 6460 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33098 "gram.c"
    break;

  case 964: /* SecLabelStmt: SECURITY LABEL opt_provider ON TYPE_P Typename IS security_label  */
#line 6470 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33111 "gram.c"
    break;

  case 965: /* SecLabelStmt: SECURITY LABEL opt_provider ON DOMAIN_P Typename IS security_label  */
#line 6480 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33124 "gram.c"
    break;

  case 966: /* SecLabelStmt: SECURITY LABEL opt_provider ON AGGREGATE aggregate_with_argtypes IS security_label  */
#line 6490 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33137 "gram.c"
    break;

  case 967: /* SecLabelStmt: SECURITY LABEL opt_provider ON FUNCTION function_with_argtypes IS security_label  */
#line 6500 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33150 "gram.c"
    break;

  case 968: /* SecLabelStmt: SECURITY LABEL opt_provider ON LARGE_P OBJECT_P NumericOnly IS security_label  */
#line 6510 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33163 "gram.c"
    break;

  case 969: /* opt_provider: FOR NonReservedWord_or_Sconst  */
#line 6520 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 33169 "gram.c"
    break;

  case 970: /* opt_provider: %empty  */
#line 6521 "gram.y"
                                                                                { (yyval.str) = NULL; }
#line 33175 "gram.c"
    break;

  case 971: /* security_label_type_any_name: COLUMN  */
#line 6526 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_COLUMN; }
#line 33181 "gram.c"
    break;

  case 972: /* security_label_type_any_name: FOREIGN TABLE  */
#line 6527 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 33187 "gram.c"
    break;

  case 973: /* security_label_type_any_name: SEQUENCE  */
#line 6528 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 33193 "gram.c"
    break;

  case 974: /* security_label_type_any_name: TABLE  */
#line 6529 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TABLE; }
#line 33199 "gram.c"
    break;

  case 975: /* security_label_type_any_name: VIEW  */
#line 6530 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_VIEW; }
#line 33205 "gram.c"
    break;

  case 976: /* security_label_type_any_name: MATERIALIZED VIEW  */
#line 6531 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_MATVIEW; }
#line 33211 "gram.c"
    break;

  case 977: /* security_label_type_name: DATABASE  */
#line 6536 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_DATABASE; }
#line 33217 "gram.c"
    break;

  case 978: /* security_label_type_name: EVENT TRIGGER  */
#line 6537 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 33223 "gram.c"
    break;

  case 979: /* security_label_type_name: opt_procedural LANGUAGE  */
#line 6538 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 33229 "gram.c"
    break;

  case 980: /* security_label_type_name: PUBLICATION  */
#line 6539 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 33235 "gram.c"
    break;

  case 981: /* security_label_type_name: ROLE  */
#line 6540 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_ROLE; }
#line 33241 "gram.c"
    break;

  case 982: /* security_label_type_name: SCHEMA  */
#line 6541 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SCHEMA; }
#line 33247 "gram.c"
    break;

  case 983: /* security_label_type_name: SUBSCRIPTION  */
#line 6542 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 33253 "gram.c"
    break;

  case 984: /* security_label_type_name: TABLESPACE  */
#line 6543 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 33259 "gram.c"
    break;

  case 985: /* security_label: Sconst  */
#line 6546 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 33265 "gram.c"
    break;

  case 986: /* security_label: NULL_P  */
#line 6547 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 33271 "gram.c"
    break;

  case 987: /* FetchStmt: FETCH fetch_args  */
#line 6558 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 33281 "gram.c"
    break;

  case 988: /* FetchStmt: MOVE fetch_args  */
#line 6564 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 33291 "gram.c"
    break;

  case 989: /* fetch_args: cursor_name  */
#line 6572 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 33303 "gram.c"
    break;

  case 990: /* fetch_args: from_in cursor_name  */
#line 6580 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 33315 "gram.c"
    break;

  case 991: /* fetch_args: NEXT opt_from_in cursor_name  */
#line 6588 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 33327 "gram.c"
    break;

  case 992: /* fetch_args: PRIOR opt_from_in cursor_name  */
#line 6596 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 33339 "gram.c"
    break;

  case 993: /* fetch_args: FIRST_P opt_from_in cursor_name  */
#line 6604 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 33351 "gram.c"
    break;

  case 994: /* fetch_args: LAST_P opt_from_in cursor_name  */
#line 6612 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 33363 "gram.c"
    break;

  case 995: /* fetch_args: ABSOLUTE_P SignedIconst opt_from_in cursor_name  */
#line 6620 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 33375 "gram.c"
    break;

  case 996: /* fetch_args: RELATIVE_P SignedIconst opt_from_in cursor_name  */
#line 6628 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 33387 "gram.c"
    break;

  case 997: /* fetch_args: SignedIconst opt_from_in cursor_name  */
#line 6636 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 33399 "gram.c"
    break;

  case 998: /* fetch_args: ALL opt_from_in cursor_name  */
#line 6644 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 33411 "gram.c"
    break;

  case 999: /* fetch_args: FORWARD opt_from_in cursor_name  */
#line 6652 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 33423 "gram.c"
    break;

  case 1000: /* fetch_args: FORWARD SignedIconst opt_from_in cursor_name  */
#line 6660 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 33435 "gram.c"
    break;

  case 1001: /* fetch_args: FORWARD ALL opt_from_in cursor_name  */
#line 6668 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 33447 "gram.c"
    break;

  case 1002: /* fetch_args: BACKWARD opt_from_in cursor_name  */
#line 6676 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 33459 "gram.c"
    break;

  case 1003: /* fetch_args: BACKWARD SignedIconst opt_from_in cursor_name  */
#line 6684 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 33471 "gram.c"
    break;

  case 1004: /* fetch_args: BACKWARD ALL opt_from_in cursor_name  */
#line 6692 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 33483 "gram.c"
    break;

  case 1005: /* from_in: FROM  */
#line 6701 "gram.y"
                                                                                        {}
#line 33489 "gram.c"
    break;

  case 1006: /* from_in: IN_P  */
#line 6702 "gram.y"
                                                                                                {}
#line 33495 "gram.c"
    break;

  case 1007: /* opt_from_in: from_in  */
#line 6705 "gram.y"
                                                                                {}
#line 33501 "gram.c"
    break;

  case 1008: /* opt_from_in: %empty  */
#line 6706 "gram.y"
                                                                                        {}
#line 33507 "gram.c"
    break;

  case 1009: /* GrantStmt: GRANT privileges ON privilege_target TO grantee_list opt_grant_grant_option  */
#line 6718 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 33523 "gram.c"
    break;

  case 1010: /* RevokeStmt: REVOKE privileges ON privilege_target FROM grantee_list opt_drop_behavior  */
#line 6734 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 33540 "gram.c"
    break;

  case 1011: /* RevokeStmt: REVOKE GRANT OPTION FOR privileges ON privilege_target FROM grantee_list opt_drop_behavior  */
#line 6748 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 33557 "gram.c"
    break;

  case 1012: /* privileges: privilege_list  */
#line 6773 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 33563 "gram.c"
    break;

  case 1013: /* privileges: ALL  */
#line 6775 "gram.y"
                                { (yyval.list) = NIL; }
#line 33569 "gram.c"
    break;

  case 1014: /* privileges: ALL PRIVILEGES  */
#line 6777 "gram.y"
                                { (yyval.list) = NIL; }
#line 33575 "gram.c"
    break;

  case 1015: /* privileges: ALL '(' columnList ')'  */
#line 6779 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 33586 "gram.c"
    break;

  case 1016: /* privileges: ALL PRIVILEGES '(' columnList ')'  */
#line 6786 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 33597 "gram.c"
    break;

  case 1017: /* privilege_list: privilege  */
#line 6794 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 33603 "gram.c"
    break;

  case 1018: /* privilege_list: privilege_list ',' privilege  */
#line 6795 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 33609 "gram.c"
    break;

  case 1019: /* privilege: SELECT opt_column_list  */
#line 6799 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 33620 "gram.c"
    break;

  case 1020: /* privilege: REFERENCES opt_column_list  */
#line 6806 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 33631 "gram.c"
    break;

  case 1021: /* privilege: CREATE opt_column_list  */
#line 6813 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 33642 "gram.c"
    break;

  case 1022: /* privilege: ColId opt_column_list  */
#line 6820 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 33653 "gram.c"
    break;

  case 1023: /* privilege_target: qualified_name_list  */
#line 6834 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33665 "gram.c"
    break;

  case 1024: /* privilege_target: TABLE qualified_name_list  */
#line 6842 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33677 "gram.c"
    break;

  case 1025: /* privilege_target: SEQUENCE qualified_name_list  */
#line 6850 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33689 "gram.c"
    break;

  case 1026: /* privilege_target: FOREIGN DATA_P WRAPPER name_list  */
#line 6858 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33701 "gram.c"
    break;

  case 1027: /* privilege_target: FOREIGN SERVER name_list  */
#line 6866 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33713 "gram.c"
    break;

  case 1028: /* privilege_target: FUNCTION function_with_argtypes_list  */
#line 6874 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33725 "gram.c"
    break;

  case 1029: /* privilege_target: DATABASE name_list  */
#line 6882 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33737 "gram.c"
    break;

  case 1030: /* privilege_target: DOMAIN_P any_name_list  */
#line 6890 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33749 "gram.c"
    break;

  case 1031: /* privilege_target: LANGUAGE name_list  */
#line 6898 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33761 "gram.c"
    break;

  case 1032: /* privilege_target: LARGE_P OBJECT_P NumericOnly_list  */
#line 6906 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33773 "gram.c"
    break;

  case 1033: /* privilege_target: SCHEMA name_list  */
#line 6914 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33785 "gram.c"
    break;

  case 1034: /* privilege_target: TABLESPACE name_list  */
#line 6922 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33797 "gram.c"
    break;

  case 1035: /* privilege_target: TYPE_P any_name_list  */
#line 6930 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33809 "gram.c"
    break;

  case 1036: /* privilege_target: ALL TABLES IN_P SCHEMA name_list  */
#line 6938 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33821 "gram.c"
    break;

  case 1037: /* privilege_target: ALL SEQUENCES IN_P SCHEMA name_list  */
#line 6946 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33833 "gram.c"
    break;

  case 1038: /* privilege_target: ALL FUNCTIONS IN_P SCHEMA name_list  */
#line 6954 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 33845 "gram.c"
    break;

  case 1039: /* grantee_list: grantee  */
#line 6965 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 33851 "gram.c"
    break;

  case 1040: /* grantee_list: grantee_list ',' grantee  */
#line 6966 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 33857 "gram.c"
    break;

  case 1041: /* grantee: RoleSpec  */
#line 6970 "gram.y"
                                                                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 33863 "gram.c"
    break;

  case 1042: /* grantee: GROUP_P RoleSpec  */
#line 6971 "gram.y"
                                                                                        { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 33869 "gram.c"
    break;

  case 1043: /* opt_grant_grant_option: WITH GRANT OPTION  */
#line 6976 "gram.y"
                                          { (yyval.boolean) = TRUE; }
#line 33875 "gram.c"
    break;

  case 1044: /* opt_grant_grant_option: %empty  */
#line 6977 "gram.y"
                                    { (yyval.boolean) = FALSE; }
#line 33881 "gram.c"
    break;

  case 1045: /* GrantRoleStmt: GRANT privilege_list TO role_list opt_grant_admin_option opt_granted_by  */
#line 6988 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node*)n;
				}
#line 33895 "gram.c"
    break;

  case 1046: /* RevokeRoleStmt: REVOKE privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 7001 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 33909 "gram.c"
    break;

  case 1047: /* RevokeRoleStmt: REVOKE ADMIN OPTION FOR privilege_list FROM role_list opt_granted_by opt_drop_behavior  */
#line 7011 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 33923 "gram.c"
    break;

  case 1048: /* opt_grant_admin_option: WITH ADMIN OPTION  */
#line 7022 "gram.y"
                                                                        { (yyval.boolean) = TRUE; }
#line 33929 "gram.c"
    break;

  case 1049: /* opt_grant_admin_option: %empty  */
#line 7023 "gram.y"
                                                                                                        { (yyval.boolean) = FALSE; }
#line 33935 "gram.c"
    break;

  case 1050: /* opt_granted_by: GRANTED BY RoleSpec  */
#line 7026 "gram.y"
                                                                                { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 33941 "gram.c"
    break;

  case 1051: /* opt_granted_by: %empty  */
#line 7027 "gram.y"
                                                                                                        { (yyval.rolespec) = NULL; }
#line 33947 "gram.c"
    break;

  case 1052: /* AlterDefaultPrivilegesStmt: ALTER DEFAULT PRIVILEGES DefACLOptionList DefACLAction  */
#line 7038 "gram.y"
                                {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 33958 "gram.c"
    break;

  case 1053: /* DefACLOptionList: DefACLOptionList DefACLOption  */
#line 7047 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33964 "gram.c"
    break;

  case 1054: /* DefACLOptionList: %empty  */
#line 7048 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 33970 "gram.c"
    break;

  case 1055: /* DefACLOption: IN_P SCHEMA name_list  */
#line 7053 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 33978 "gram.c"
    break;

  case 1056: /* DefACLOption: FOR ROLE role_list  */
#line 7057 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 33986 "gram.c"
    break;

  case 1057: /* DefACLOption: FOR USER role_list  */
#line 7061 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 33994 "gram.c"
    break;

  case 1058: /* DefACLAction: GRANT privileges ON defacl_privilege_target TO grantee_list opt_grant_grant_option  */
#line 7073 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 34010 "gram.c"
    break;

  case 1059: /* DefACLAction: REVOKE privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 7086 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 34027 "gram.c"
    break;

  case 1060: /* DefACLAction: REVOKE GRANT OPTION FOR privileges ON defacl_privilege_target FROM grantee_list opt_drop_behavior  */
#line 7100 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 34044 "gram.c"
    break;

  case 1061: /* defacl_privilege_target: TABLES  */
#line 7115 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 34050 "gram.c"
    break;

  case 1062: /* defacl_privilege_target: FUNCTIONS  */
#line 7116 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 34056 "gram.c"
    break;

  case 1063: /* defacl_privilege_target: SEQUENCES  */
#line 7117 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 34062 "gram.c"
    break;

  case 1064: /* defacl_privilege_target: TYPES_P  */
#line 7118 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 34068 "gram.c"
    break;

  case 1065: /* defacl_privilege_target: SCHEMAS  */
#line 7119 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_NAMESPACE; }
#line 34074 "gram.c"
    break;

  case 1066: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently opt_index_name ON qualified_name access_method_clause '(' index_params ')' opt_reloptions OptTableSpace where_clause  */
#line 7134 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 34102 "gram.c"
    break;

  case 1067: /* IndexStmt: CREATE opt_unique INDEX opt_concurrently IF_P NOT EXISTS index_name ON qualified_name access_method_clause '(' index_params ')' opt_reloptions OptTableSpace where_clause  */
#line 7160 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-15].boolean);
					n->concurrent = (yyvsp[-13].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 34130 "gram.c"
    break;

  case 1068: /* opt_unique: UNIQUE  */
#line 7186 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 34136 "gram.c"
    break;

  case 1069: /* opt_unique: %empty  */
#line 7187 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 34142 "gram.c"
    break;

  case 1070: /* opt_concurrently: CONCURRENTLY  */
#line 7191 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 34148 "gram.c"
    break;

  case 1071: /* opt_concurrently: %empty  */
#line 7192 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 34154 "gram.c"
    break;

  case 1072: /* opt_index_name: index_name  */
#line 7196 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 34160 "gram.c"
    break;

  case 1073: /* opt_index_name: %empty  */
#line 7197 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 34166 "gram.c"
    break;

  case 1074: /* access_method_clause: USING access_method  */
#line 7201 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34172 "gram.c"
    break;

  case 1075: /* access_method_clause: %empty  */
#line 7202 "gram.y"
                                                                                                { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 34178 "gram.c"
    break;

  case 1076: /* index_params: index_elem  */
#line 7205 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 34184 "gram.c"
    break;

  case 1077: /* index_params: index_params ',' index_elem  */
#line 7206 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 34190 "gram.c"
    break;

  case 1078: /* index_elem: ColId opt_collate opt_class opt_asc_desc opt_nulls_order  */
#line 7215 "gram.y"
                                {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 34205 "gram.c"
    break;

  case 1079: /* index_elem: func_expr_windowless opt_collate opt_class opt_asc_desc opt_nulls_order  */
#line 7226 "gram.y"
                                {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 34220 "gram.c"
    break;

  case 1080: /* index_elem: '(' a_expr ')' opt_collate opt_class opt_asc_desc opt_nulls_order  */
#line 7237 "gram.y"
                                {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 34235 "gram.c"
    break;

  case 1081: /* opt_collate: COLLATE any_name  */
#line 7249 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 34241 "gram.c"
    break;

  case 1082: /* opt_collate: %empty  */
#line 7250 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34247 "gram.c"
    break;

  case 1083: /* opt_class: any_name  */
#line 7253 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 34253 "gram.c"
    break;

  case 1084: /* opt_class: %empty  */
#line 7254 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34259 "gram.c"
    break;

  case 1085: /* opt_asc_desc: ASC  */
#line 7257 "gram.y"
                                                                        { (yyval.ival) = SORTBY_ASC; }
#line 34265 "gram.c"
    break;

  case 1086: /* opt_asc_desc: DESC  */
#line 7258 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DESC; }
#line 34271 "gram.c"
    break;

  case 1087: /* opt_asc_desc: %empty  */
#line 7259 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DEFAULT; }
#line 34277 "gram.c"
    break;

  case 1088: /* opt_nulls_order: NULLS_LA FIRST_P  */
#line 7262 "gram.y"
                                                        { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 34283 "gram.c"
    break;

  case 1089: /* opt_nulls_order: NULLS_LA LAST_P  */
#line 7263 "gram.y"
                                                                        { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 34289 "gram.c"
    break;

  case 1090: /* opt_nulls_order: %empty  */
#line 7264 "gram.y"
                                                                                { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 34295 "gram.c"
    break;

  case 1091: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS func_return createfunc_opt_list opt_definition  */
#line 7282 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34310 "gram.c"
    break;

  case 1092: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults RETURNS TABLE '(' table_func_column_list ')' createfunc_opt_list opt_definition  */
#line 7294 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34326 "gram.c"
    break;

  case 1093: /* CreateFunctionStmt: CREATE opt_or_replace FUNCTION func_name func_args_with_defaults createfunc_opt_list opt_definition  */
#line 7307 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34341 "gram.c"
    break;

  case 1094: /* opt_or_replace: OR REPLACE  */
#line 7320 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 34347 "gram.c"
    break;

  case 1095: /* opt_or_replace: %empty  */
#line 7321 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 34353 "gram.c"
    break;

  case 1096: /* func_args: '(' func_args_list ')'  */
#line 7324 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 34359 "gram.c"
    break;

  case 1097: /* func_args: '(' ')'  */
#line 7325 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34365 "gram.c"
    break;

  case 1098: /* func_args_list: func_arg  */
#line 7329 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 34371 "gram.c"
    break;

  case 1099: /* func_args_list: func_args_list ',' func_arg  */
#line 7330 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 34377 "gram.c"
    break;

  case 1100: /* function_with_argtypes_list: function_with_argtypes  */
#line 7334 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 34383 "gram.c"
    break;

  case 1101: /* function_with_argtypes_list: function_with_argtypes_list ',' function_with_argtypes  */
#line 7336 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 34389 "gram.c"
    break;

  case 1102: /* function_with_argtypes: func_name func_args  */
#line 7341 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 34400 "gram.c"
    break;

  case 1103: /* function_with_argtypes: type_func_name_keyword  */
#line 7353 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 34411 "gram.c"
    break;

  case 1104: /* function_with_argtypes: ColId  */
#line 7360 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 34422 "gram.c"
    break;

  case 1105: /* function_with_argtypes: ColId indirection  */
#line 7367 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 34434 "gram.c"
    break;

  case 1106: /* func_args_with_defaults: '(' func_args_with_defaults_list ')'  */
#line 7381 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 34440 "gram.c"
    break;

  case 1107: /* func_args_with_defaults: '(' ')'  */
#line 7382 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34446 "gram.c"
    break;

  case 1108: /* func_args_with_defaults_list: func_arg_with_default  */
#line 7386 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 34452 "gram.c"
    break;

  case 1109: /* func_args_with_defaults_list: func_args_with_defaults_list ',' func_arg_with_default  */
#line 7388 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 34458 "gram.c"
    break;

  case 1110: /* func_arg: arg_class param_name func_type  */
#line 7403 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 34471 "gram.c"
    break;

  case 1111: /* func_arg: param_name arg_class func_type  */
#line 7412 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 34484 "gram.c"
    break;

  case 1112: /* func_arg: param_name func_type  */
#line 7421 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 34497 "gram.c"
    break;

  case 1113: /* func_arg: arg_class func_type  */
#line 7430 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 34510 "gram.c"
    break;

  case 1114: /* func_arg: func_type  */
#line 7439 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 34523 "gram.c"
    break;

  case 1115: /* arg_class: IN_P  */
#line 7450 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 34529 "gram.c"
    break;

  case 1116: /* arg_class: OUT_P  */
#line 7451 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 34535 "gram.c"
    break;

  case 1117: /* arg_class: INOUT  */
#line 7452 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 34541 "gram.c"
    break;

  case 1118: /* arg_class: IN_P OUT_P  */
#line 7453 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 34547 "gram.c"
    break;

  case 1119: /* arg_class: VARIADIC  */
#line 7454 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 34553 "gram.c"
    break;

  case 1121: /* func_return: func_type  */
#line 7465 "gram.y"
                                {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 34565 "gram.c"
    break;

  case 1122: /* func_type: Typename  */
#line 7479 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 34571 "gram.c"
    break;

  case 1123: /* func_type: type_function_name attrs '%' TYPE_P  */
#line 7481 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 34581 "gram.c"
    break;

  case 1124: /* func_type: SETOF type_function_name attrs '%' TYPE_P  */
#line 7487 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 34592 "gram.c"
    break;

  case 1125: /* func_arg_with_default: func_arg  */
#line 7497 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 34600 "gram.c"
    break;

  case 1126: /* func_arg_with_default: func_arg DEFAULT a_expr  */
#line 7501 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 34609 "gram.c"
    break;

  case 1127: /* func_arg_with_default: func_arg '=' a_expr  */
#line 7506 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 34618 "gram.c"
    break;

  case 1128: /* aggr_arg: func_arg  */
#line 7514 "gram.y"
                                {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 34632 "gram.c"
    break;

  case 1129: /* aggr_args: '(' '*' ')'  */
#line 7555 "gram.y"
                                {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 34640 "gram.c"
    break;

  case 1130: /* aggr_args: '(' aggr_args_list ')'  */
#line 7559 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 34648 "gram.c"
    break;

  case 1131: /* aggr_args: '(' ORDER BY aggr_args_list ')'  */
#line 7563 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 34656 "gram.c"
    break;

  case 1132: /* aggr_args: '(' aggr_args_list ORDER BY aggr_args_list ')'  */
#line 7567 "gram.y"
                                {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 34665 "gram.c"
    break;

  case 1133: /* aggr_args_list: aggr_arg  */
#line 7574 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 34671 "gram.c"
    break;

  case 1134: /* aggr_args_list: aggr_args_list ',' aggr_arg  */
#line 7575 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 34677 "gram.c"
    break;

  case 1135: /* aggregate_with_argtypes: func_name aggr_args  */
#line 7580 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 34688 "gram.c"
    break;

  case 1136: /* aggregate_with_argtypes_list: aggregate_with_argtypes  */
#line 7589 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 34694 "gram.c"
    break;

  case 1137: /* aggregate_with_argtypes_list: aggregate_with_argtypes_list ',' aggregate_with_argtypes  */
#line 7591 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 34700 "gram.c"
    break;

  case 1138: /* createfunc_opt_list: createfunc_opt_item  */
#line 7596 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34706 "gram.c"
    break;

  case 1139: /* createfunc_opt_list: createfunc_opt_list createfunc_opt_item  */
#line 7597 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34712 "gram.c"
    break;

  case 1140: /* common_func_opt_item: CALLED ON NULL_P INPUT_P  */
#line 7605 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE), (yylsp[-3]));
				}
#line 34720 "gram.c"
    break;

  case 1141: /* common_func_opt_item: RETURNS NULL_P ON NULL_P INPUT_P  */
#line 7609 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE), (yylsp[-4]));
				}
#line 34728 "gram.c"
    break;

  case 1142: /* common_func_opt_item: STRICT_P  */
#line 7613 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 34736 "gram.c"
    break;

  case 1143: /* common_func_opt_item: IMMUTABLE  */
#line 7617 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"), (yylsp[0]));
				}
#line 34744 "gram.c"
    break;

  case 1144: /* common_func_opt_item: STABLE  */
#line 7621 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"), (yylsp[0]));
				}
#line 34752 "gram.c"
    break;

  case 1145: /* common_func_opt_item: VOLATILE  */
#line 7625 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"), (yylsp[0]));
				}
#line 34760 "gram.c"
    break;

  case 1146: /* common_func_opt_item: EXTERNAL SECURITY DEFINER  */
#line 7629 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE), (yylsp[-2]));
				}
#line 34768 "gram.c"
    break;

  case 1147: /* common_func_opt_item: EXTERNAL SECURITY INVOKER  */
#line 7633 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE), (yylsp[-2]));
				}
#line 34776 "gram.c"
    break;

  case 1148: /* common_func_opt_item: SECURITY DEFINER  */
#line 7637 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE), (yylsp[-1]));
				}
#line 34784 "gram.c"
    break;

  case 1149: /* common_func_opt_item: SECURITY INVOKER  */
#line 7641 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE), (yylsp[-1]));
				}
#line 34792 "gram.c"
    break;

  case 1150: /* common_func_opt_item: LEAKPROOF  */
#line 7645 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 34800 "gram.c"
    break;

  case 1151: /* common_func_opt_item: NOT LEAKPROOF  */
#line 7649 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE), (yylsp[-1]));
				}
#line 34808 "gram.c"
    break;

  case 1152: /* common_func_opt_item: COST NumericOnly  */
#line 7653 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 34816 "gram.c"
    break;

  case 1153: /* common_func_opt_item: ROWS NumericOnly  */
#line 7657 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 34824 "gram.c"
    break;

  case 1154: /* common_func_opt_item: FunctionSetResetClause  */
#line 7661 "gram.y"
                                {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 34833 "gram.c"
    break;

  case 1155: /* common_func_opt_item: PARALLEL ColId  */
#line 7666 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34841 "gram.c"
    break;

  case 1156: /* createfunc_opt_item: AS func_as  */
#line 7673 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 34849 "gram.c"
    break;

  case 1157: /* createfunc_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 7677 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34857 "gram.c"
    break;

  case 1158: /* createfunc_opt_item: TRANSFORM transform_type_list  */
#line 7681 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 34865 "gram.c"
    break;

  case 1159: /* createfunc_opt_item: WINDOW  */
#line 7685 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE), (yylsp[0]));
				}
#line 34873 "gram.c"
    break;

  case 1160: /* createfunc_opt_item: common_func_opt_item  */
#line 7689 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 34881 "gram.c"
    break;

  case 1161: /* func_as: Sconst  */
#line 7694 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34887 "gram.c"
    break;

  case 1162: /* func_as: Sconst ',' Sconst  */
#line 7696 "gram.y"
                                {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 34895 "gram.c"
    break;

  case 1163: /* transform_type_list: FOR TYPE_P Typename  */
#line 7702 "gram.y"
                                            { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 34901 "gram.c"
    break;

  case 1164: /* transform_type_list: transform_type_list ',' FOR TYPE_P Typename  */
#line 7703 "gram.y"
                                                                      { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 34907 "gram.c"
    break;

  case 1165: /* opt_definition: WITH definition  */
#line 7707 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 34913 "gram.c"
    break;

  case 1166: /* opt_definition: %empty  */
#line 7708 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34919 "gram.c"
    break;

  case 1167: /* table_func_column: param_name func_type  */
#line 7712 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 34932 "gram.c"
    break;

  case 1168: /* table_func_column_list: table_func_column  */
#line 7724 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 34940 "gram.c"
    break;

  case 1169: /* table_func_column_list: table_func_column_list ',' table_func_column  */
#line 7728 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 34948 "gram.c"
    break;

  case 1170: /* AlterFunctionStmt: ALTER FUNCTION function_with_argtypes alterfunc_opt_list opt_restrict  */
#line 7743 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34959 "gram.c"
    break;

  case 1171: /* alterfunc_opt_list: common_func_opt_item  */
#line 7753 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34965 "gram.c"
    break;

  case 1172: /* alterfunc_opt_list: alterfunc_opt_list common_func_opt_item  */
#line 7754 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34971 "gram.c"
    break;

  case 1175: /* RemoveFuncStmt: DROP FUNCTION function_with_argtypes_list opt_drop_behavior  */
#line 7776 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34985 "gram.c"
    break;

  case 1176: /* RemoveFuncStmt: DROP FUNCTION IF_P EXISTS function_with_argtypes_list opt_drop_behavior  */
#line 7786 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34999 "gram.c"
    break;

  case 1177: /* RemoveAggrStmt: DROP AGGREGATE aggregate_with_argtypes_list opt_drop_behavior  */
#line 7799 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35013 "gram.c"
    break;

  case 1178: /* RemoveAggrStmt: DROP AGGREGATE IF_P EXISTS aggregate_with_argtypes_list opt_drop_behavior  */
#line 7809 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35027 "gram.c"
    break;

  case 1179: /* RemoveOperStmt: DROP OPERATOR operator_with_argtypes_list opt_drop_behavior  */
#line 7822 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35041 "gram.c"
    break;

  case 1180: /* RemoveOperStmt: DROP OPERATOR IF_P EXISTS operator_with_argtypes_list opt_drop_behavior  */
#line 7832 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35055 "gram.c"
    break;

  case 1181: /* oper_argtypes: '(' Typename ')'  */
#line 7845 "gram.y"
                                {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 35067 "gram.c"
    break;

  case 1182: /* oper_argtypes: '(' Typename ',' Typename ')'  */
#line 7853 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 35073 "gram.c"
    break;

  case 1183: /* oper_argtypes: '(' NONE ',' Typename ')'  */
#line 7855 "gram.y"
                                        { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 35079 "gram.c"
    break;

  case 1184: /* oper_argtypes: '(' Typename ',' NONE ')'  */
#line 7857 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 35085 "gram.c"
    break;

  case 1185: /* any_operator: all_Op  */
#line 7862 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35091 "gram.c"
    break;

  case 1186: /* any_operator: ColId '.' any_operator  */
#line 7864 "gram.y"
                                        { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 35097 "gram.c"
    break;

  case 1187: /* operator_with_argtypes_list: operator_with_argtypes  */
#line 7868 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 35103 "gram.c"
    break;

  case 1188: /* operator_with_argtypes_list: operator_with_argtypes_list ',' operator_with_argtypes  */
#line 7870 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 35109 "gram.c"
    break;

  case 1189: /* operator_with_argtypes: any_operator oper_argtypes  */
#line 7875 "gram.y"
                                {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 35120 "gram.c"
    break;

  case 1190: /* DoStmt: DO dostmt_opt_list  */
#line 7893 "gram.y"
                                {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35130 "gram.c"
    break;

  case 1191: /* dostmt_opt_list: dostmt_opt_item  */
#line 7901 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35136 "gram.c"
    break;

  case 1192: /* dostmt_opt_list: dostmt_opt_list dostmt_opt_item  */
#line 7902 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35142 "gram.c"
    break;

  case 1193: /* dostmt_opt_item: Sconst  */
#line 7907 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 35150 "gram.c"
    break;

  case 1194: /* dostmt_opt_item: LANGUAGE NonReservedWord_or_Sconst  */
#line 7911 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 35158 "gram.c"
    break;

  case 1195: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH FUNCTION function_with_argtypes cast_context  */
#line 7924 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 35172 "gram.c"
    break;

  case 1196: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITHOUT FUNCTION cast_context  */
#line 7935 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 35186 "gram.c"
    break;

  case 1197: /* CreateCastStmt: CREATE CAST '(' Typename AS Typename ')' WITH INOUT cast_context  */
#line 7946 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 35200 "gram.c"
    break;

  case 1198: /* cast_context: AS IMPLICIT_P  */
#line 7957 "gram.y"
                                                                { (yyval.ival) = COERCION_IMPLICIT; }
#line 35206 "gram.c"
    break;

  case 1199: /* cast_context: AS ASSIGNMENT  */
#line 7958 "gram.y"
                                                                                { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 35212 "gram.c"
    break;

  case 1200: /* cast_context: %empty  */
#line 7959 "gram.y"
                                                                                        { (yyval.ival) = COERCION_EXPLICIT; }
#line 35218 "gram.c"
    break;

  case 1201: /* DropCastStmt: DROP CAST opt_if_exists '(' Typename AS Typename ')' opt_drop_behavior  */
#line 7964 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35232 "gram.c"
    break;

  case 1202: /* opt_if_exists: IF_P EXISTS  */
#line 7975 "gram.y"
                                                                        { (yyval.boolean) = TRUE; }
#line 35238 "gram.c"
    break;

  case 1203: /* opt_if_exists: %empty  */
#line 7976 "gram.y"
                                                                                        { (yyval.boolean) = FALSE; }
#line 35244 "gram.c"
    break;

  case 1204: /* CreateTransformStmt: CREATE opt_or_replace TRANSFORM FOR Typename LANGUAGE name '(' transform_element_list ')'  */
#line 7987 "gram.y"
                                {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 35258 "gram.c"
    break;

  case 1205: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes ',' TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 7999 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 35266 "gram.c"
    break;

  case 1206: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes ',' FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 8003 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 35274 "gram.c"
    break;

  case 1207: /* transform_element_list: FROM SQL_P WITH FUNCTION function_with_argtypes  */
#line 8007 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 35282 "gram.c"
    break;

  case 1208: /* transform_element_list: TO SQL_P WITH FUNCTION function_with_argtypes  */
#line 8011 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 35290 "gram.c"
    break;

  case 1209: /* DropTransformStmt: DROP TRANSFORM opt_if_exists FOR Typename LANGUAGE name opt_drop_behavior  */
#line 8018 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *)n;
				}
#line 35303 "gram.c"
    break;

  case 1210: /* ReindexStmt: REINDEX reindex_target_type qualified_name  */
#line 8038 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 35316 "gram.c"
    break;

  case 1211: /* ReindexStmt: REINDEX reindex_target_multitable name  */
#line 8047 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = 0;
					(yyval.node) = (Node *)n;
				}
#line 35329 "gram.c"
    break;

  case 1212: /* ReindexStmt: REINDEX '(' reindex_option_list ')' reindex_target_type qualified_name  */
#line 8056 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->options = (yyvsp[-3].ival);
					(yyval.node) = (Node *)n;
				}
#line 35342 "gram.c"
    break;

  case 1213: /* ReindexStmt: REINDEX '(' reindex_option_list ')' reindex_target_multitable name  */
#line 8065 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-1].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->options = (yyvsp[-3].ival);
					(yyval.node) = (Node *)n;
				}
#line 35355 "gram.c"
    break;

  case 1214: /* reindex_target_type: INDEX  */
#line 8075 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 35361 "gram.c"
    break;

  case 1215: /* reindex_target_type: TABLE  */
#line 8076 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 35367 "gram.c"
    break;

  case 1216: /* reindex_target_multitable: SCHEMA  */
#line 8079 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 35373 "gram.c"
    break;

  case 1217: /* reindex_target_multitable: SYSTEM_P  */
#line 8080 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 35379 "gram.c"
    break;

  case 1218: /* reindex_target_multitable: DATABASE  */
#line 8081 "gram.y"
                                                                { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 35385 "gram.c"
    break;

  case 1219: /* reindex_option_list: reindex_option_elem  */
#line 8084 "gram.y"
                                                                                                        { (yyval.ival) = (yyvsp[0].ival); }
#line 35391 "gram.c"
    break;

  case 1220: /* reindex_option_list: reindex_option_list ',' reindex_option_elem  */
#line 8085 "gram.y"
                                                                        { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 35397 "gram.c"
    break;

  case 1221: /* reindex_option_elem: VERBOSE  */
#line 8088 "gram.y"
                                { (yyval.ival) = REINDEXOPT_VERBOSE; }
#line 35403 "gram.c"
    break;

  case 1222: /* AlterTblSpcStmt: ALTER TABLESPACE name SET reloptions  */
#line 8099 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 35416 "gram.c"
    break;

  case 1223: /* AlterTblSpcStmt: ALTER TABLESPACE name RESET reloptions  */
#line 8108 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 35429 "gram.c"
    break;

  case 1224: /* RenameStmt: ALTER AGGREGATE aggregate_with_argtypes RENAME TO name  */
#line 8125 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35442 "gram.c"
    break;

  case 1225: /* RenameStmt: ALTER COLLATION any_name RENAME TO name  */
#line 8134 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35455 "gram.c"
    break;

  case 1226: /* RenameStmt: ALTER CONVERSION_P any_name RENAME TO name  */
#line 8143 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35468 "gram.c"
    break;

  case 1227: /* RenameStmt: ALTER DATABASE database_name RENAME TO database_name  */
#line 8152 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35481 "gram.c"
    break;

  case 1228: /* RenameStmt: ALTER DOMAIN_P any_name RENAME TO name  */
#line 8161 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35494 "gram.c"
    break;

  case 1229: /* RenameStmt: ALTER DOMAIN_P any_name RENAME CONSTRAINT name TO name  */
#line 8170 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 35507 "gram.c"
    break;

  case 1230: /* RenameStmt: ALTER FOREIGN DATA_P WRAPPER name RENAME TO name  */
#line 8179 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35520 "gram.c"
    break;

  case 1231: /* RenameStmt: ALTER FUNCTION function_with_argtypes RENAME TO name  */
#line 8188 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35533 "gram.c"
    break;

  case 1232: /* RenameStmt: ALTER GROUP_P RoleId RENAME TO RoleId  */
#line 8197 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35546 "gram.c"
    break;

  case 1233: /* RenameStmt: ALTER opt_procedural LANGUAGE name RENAME TO name  */
#line 8206 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35559 "gram.c"
    break;

  case 1234: /* RenameStmt: ALTER OPERATOR CLASS any_name USING access_method RENAME TO name  */
#line 8215 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35572 "gram.c"
    break;

  case 1235: /* RenameStmt: ALTER OPERATOR FAMILY any_name USING access_method RENAME TO name  */
#line 8224 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35585 "gram.c"
    break;

  case 1236: /* RenameStmt: ALTER POLICY name ON qualified_name RENAME TO name  */
#line 8233 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35599 "gram.c"
    break;

  case 1237: /* RenameStmt: ALTER POLICY IF_P EXISTS name ON qualified_name RENAME TO name  */
#line 8243 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35613 "gram.c"
    break;

  case 1238: /* RenameStmt: ALTER PUBLICATION name RENAME TO name  */
#line 8253 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35626 "gram.c"
    break;

  case 1239: /* RenameStmt: ALTER SCHEMA name RENAME TO name  */
#line 8262 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35639 "gram.c"
    break;

  case 1240: /* RenameStmt: ALTER SERVER name RENAME TO name  */
#line 8271 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35652 "gram.c"
    break;

  case 1241: /* RenameStmt: ALTER SUBSCRIPTION name RENAME TO name  */
#line 8280 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35665 "gram.c"
    break;

  case 1242: /* RenameStmt: ALTER TABLE relation_expr RENAME TO name  */
#line 8289 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35679 "gram.c"
    break;

  case 1243: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 8299 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35693 "gram.c"
    break;

  case 1244: /* RenameStmt: ALTER SEQUENCE qualified_name RENAME TO name  */
#line 8309 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35707 "gram.c"
    break;

  case 1245: /* RenameStmt: ALTER SEQUENCE IF_P EXISTS qualified_name RENAME TO name  */
#line 8319 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35721 "gram.c"
    break;

  case 1246: /* RenameStmt: ALTER VIEW qualified_name RENAME TO name  */
#line 8329 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35735 "gram.c"
    break;

  case 1247: /* RenameStmt: ALTER VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 8339 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35749 "gram.c"
    break;

  case 1248: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME TO name  */
#line 8349 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35763 "gram.c"
    break;

  case 1249: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME TO name  */
#line 8359 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35777 "gram.c"
    break;

  case 1250: /* RenameStmt: ALTER INDEX qualified_name RENAME TO name  */
#line 8369 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35791 "gram.c"
    break;

  case 1251: /* RenameStmt: ALTER INDEX IF_P EXISTS qualified_name RENAME TO name  */
#line 8379 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35805 "gram.c"
    break;

  case 1252: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME TO name  */
#line 8389 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35819 "gram.c"
    break;

  case 1253: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME TO name  */
#line 8399 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35833 "gram.c"
    break;

  case 1254: /* RenameStmt: ALTER TABLE relation_expr RENAME opt_column name TO name  */
#line 8409 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35848 "gram.c"
    break;

  case 1255: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 8420 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35863 "gram.c"
    break;

  case 1256: /* RenameStmt: ALTER MATERIALIZED VIEW qualified_name RENAME opt_column name TO name  */
#line 8431 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35878 "gram.c"
    break;

  case 1257: /* RenameStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name RENAME opt_column name TO name  */
#line 8442 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35893 "gram.c"
    break;

  case 1258: /* RenameStmt: ALTER TABLE relation_expr RENAME CONSTRAINT name TO name  */
#line 8453 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35907 "gram.c"
    break;

  case 1259: /* RenameStmt: ALTER TABLE IF_P EXISTS relation_expr RENAME CONSTRAINT name TO name  */
#line 8463 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35921 "gram.c"
    break;

  case 1260: /* RenameStmt: ALTER FOREIGN TABLE relation_expr RENAME opt_column name TO name  */
#line 8473 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35936 "gram.c"
    break;

  case 1261: /* RenameStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr RENAME opt_column name TO name  */
#line 8484 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 35951 "gram.c"
    break;

  case 1262: /* RenameStmt: ALTER RULE name ON qualified_name RENAME TO name  */
#line 8495 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35965 "gram.c"
    break;

  case 1263: /* RenameStmt: ALTER TRIGGER name ON qualified_name RENAME TO name  */
#line 8505 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 35979 "gram.c"
    break;

  case 1264: /* RenameStmt: ALTER EVENT TRIGGER name RENAME TO name  */
#line 8515 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 35991 "gram.c"
    break;

  case 1265: /* RenameStmt: ALTER ROLE RoleId RENAME TO RoleId  */
#line 8523 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36004 "gram.c"
    break;

  case 1266: /* RenameStmt: ALTER USER RoleId RENAME TO RoleId  */
#line 8532 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36017 "gram.c"
    break;

  case 1267: /* RenameStmt: ALTER TABLESPACE name RENAME TO name  */
#line 8541 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36030 "gram.c"
    break;

  case 1268: /* RenameStmt: ALTER STATISTICS any_name RENAME TO name  */
#line 8550 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36043 "gram.c"
    break;

  case 1269: /* RenameStmt: ALTER TEXT_P SEARCH PARSER any_name RENAME TO name  */
#line 8559 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36056 "gram.c"
    break;

  case 1270: /* RenameStmt: ALTER TEXT_P SEARCH DICTIONARY any_name RENAME TO name  */
#line 8568 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36069 "gram.c"
    break;

  case 1271: /* RenameStmt: ALTER TEXT_P SEARCH TEMPLATE any_name RENAME TO name  */
#line 8577 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36082 "gram.c"
    break;

  case 1272: /* RenameStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name RENAME TO name  */
#line 8586 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36095 "gram.c"
    break;

  case 1273: /* RenameStmt: ALTER TYPE_P any_name RENAME TO name  */
#line 8595 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36108 "gram.c"
    break;

  case 1274: /* RenameStmt: ALTER TYPE_P any_name RENAME ATTRIBUTE name TO name opt_drop_behavior  */
#line 8604 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36124 "gram.c"
    break;

  case 1275: /* opt_column: COLUMN  */
#line 8617 "gram.y"
                                                                                        { (yyval.ival) = COLUMN; }
#line 36130 "gram.c"
    break;

  case 1276: /* opt_column: %empty  */
#line 8618 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 36136 "gram.c"
    break;

  case 1277: /* opt_set_data: SET DATA_P  */
#line 8621 "gram.y"
                                                                                { (yyval.ival) = 1; }
#line 36142 "gram.c"
    break;

  case 1278: /* opt_set_data: %empty  */
#line 8622 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 36148 "gram.c"
    break;

  case 1279: /* AlterObjectDependsStmt: ALTER FUNCTION function_with_argtypes DEPENDS ON EXTENSION name  */
#line 8633 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-4].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 36160 "gram.c"
    break;

  case 1280: /* AlterObjectDependsStmt: ALTER TRIGGER name ON qualified_name DEPENDS ON EXTENSION name  */
#line 8641 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-4].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-6].str)));
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 36173 "gram.c"
    break;

  case 1281: /* AlterObjectDependsStmt: ALTER MATERIALIZED VIEW qualified_name DEPENDS ON EXTENSION name  */
#line 8650 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-4].range);
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 36185 "gram.c"
    break;

  case 1282: /* AlterObjectDependsStmt: ALTER INDEX qualified_name DEPENDS ON EXTENSION name  */
#line 8658 "gram.y"
                                {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-4].range);
					n->extname = makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 36197 "gram.c"
    break;

  case 1283: /* AlterObjectSchemaStmt: ALTER AGGREGATE aggregate_with_argtypes SET SCHEMA name  */
#line 8675 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36210 "gram.c"
    break;

  case 1284: /* AlterObjectSchemaStmt: ALTER COLLATION any_name SET SCHEMA name  */
#line 8684 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36223 "gram.c"
    break;

  case 1285: /* AlterObjectSchemaStmt: ALTER CONVERSION_P any_name SET SCHEMA name  */
#line 8693 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36236 "gram.c"
    break;

  case 1286: /* AlterObjectSchemaStmt: ALTER DOMAIN_P any_name SET SCHEMA name  */
#line 8702 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36249 "gram.c"
    break;

  case 1287: /* AlterObjectSchemaStmt: ALTER EXTENSION name SET SCHEMA name  */
#line 8711 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36262 "gram.c"
    break;

  case 1288: /* AlterObjectSchemaStmt: ALTER FUNCTION function_with_argtypes SET SCHEMA name  */
#line 8720 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36275 "gram.c"
    break;

  case 1289: /* AlterObjectSchemaStmt: ALTER OPERATOR operator_with_argtypes SET SCHEMA name  */
#line 8729 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36288 "gram.c"
    break;

  case 1290: /* AlterObjectSchemaStmt: ALTER OPERATOR CLASS any_name USING access_method SET SCHEMA name  */
#line 8738 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36301 "gram.c"
    break;

  case 1291: /* AlterObjectSchemaStmt: ALTER OPERATOR FAMILY any_name USING access_method SET SCHEMA name  */
#line 8747 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36314 "gram.c"
    break;

  case 1292: /* AlterObjectSchemaStmt: ALTER TABLE relation_expr SET SCHEMA name  */
#line 8756 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36327 "gram.c"
    break;

  case 1293: /* AlterObjectSchemaStmt: ALTER TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 8765 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 36340 "gram.c"
    break;

  case 1294: /* AlterObjectSchemaStmt: ALTER STATISTICS any_name SET SCHEMA name  */
#line 8774 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36353 "gram.c"
    break;

  case 1295: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH PARSER any_name SET SCHEMA name  */
#line 8783 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36366 "gram.c"
    break;

  case 1296: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH DICTIONARY any_name SET SCHEMA name  */
#line 8792 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36379 "gram.c"
    break;

  case 1297: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH TEMPLATE any_name SET SCHEMA name  */
#line 8801 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36392 "gram.c"
    break;

  case 1298: /* AlterObjectSchemaStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name SET SCHEMA name  */
#line 8810 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36405 "gram.c"
    break;

  case 1299: /* AlterObjectSchemaStmt: ALTER SEQUENCE qualified_name SET SCHEMA name  */
#line 8819 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36418 "gram.c"
    break;

  case 1300: /* AlterObjectSchemaStmt: ALTER SEQUENCE IF_P EXISTS qualified_name SET SCHEMA name  */
#line 8828 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 36431 "gram.c"
    break;

  case 1301: /* AlterObjectSchemaStmt: ALTER VIEW qualified_name SET SCHEMA name  */
#line 8837 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36444 "gram.c"
    break;

  case 1302: /* AlterObjectSchemaStmt: ALTER VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 8846 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 36457 "gram.c"
    break;

  case 1303: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW qualified_name SET SCHEMA name  */
#line 8855 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36470 "gram.c"
    break;

  case 1304: /* AlterObjectSchemaStmt: ALTER MATERIALIZED VIEW IF_P EXISTS qualified_name SET SCHEMA name  */
#line 8864 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 36483 "gram.c"
    break;

  case 1305: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE relation_expr SET SCHEMA name  */
#line 8873 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36496 "gram.c"
    break;

  case 1306: /* AlterObjectSchemaStmt: ALTER FOREIGN TABLE IF_P EXISTS relation_expr SET SCHEMA name  */
#line 8882 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 36509 "gram.c"
    break;

  case 1307: /* AlterObjectSchemaStmt: ALTER TYPE_P any_name SET SCHEMA name  */
#line 8891 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 36522 "gram.c"
    break;

  case 1308: /* AlterOperatorStmt: ALTER OPERATOR operator_with_argtypes SET '(' operator_def_list ')'  */
#line 8909 "gram.y"
                                {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 36533 "gram.c"
    break;

  case 1309: /* operator_def_list: operator_def_elem  */
#line 8917 "gram.y"
                                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36539 "gram.c"
    break;

  case 1310: /* operator_def_list: operator_def_list ',' operator_def_elem  */
#line 8918 "gram.y"
                                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 36545 "gram.c"
    break;

  case 1311: /* operator_def_elem: ColLabel '=' NONE  */
#line 8922 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 36551 "gram.c"
    break;

  case 1312: /* operator_def_elem: ColLabel '=' operator_def_arg  */
#line 8924 "gram.y"
                                                { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 36557 "gram.c"
    break;

  case 1313: /* operator_def_arg: func_type  */
#line 8929 "gram.y"
                                                                                { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 36563 "gram.c"
    break;

  case 1314: /* operator_def_arg: reserved_keyword  */
#line 8930 "gram.y"
                                                                        { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 36569 "gram.c"
    break;

  case 1315: /* operator_def_arg: qual_all_Op  */
#line 8931 "gram.y"
                                                                        { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 36575 "gram.c"
    break;

  case 1316: /* operator_def_arg: NumericOnly  */
#line 8932 "gram.y"
                                                                        { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 36581 "gram.c"
    break;

  case 1317: /* operator_def_arg: Sconst  */
#line 8933 "gram.y"
                                                                                { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 36587 "gram.c"
    break;

  case 1318: /* AlterOwnerStmt: ALTER AGGREGATE aggregate_with_argtypes OWNER TO RoleSpec  */
#line 8943 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36599 "gram.c"
    break;

  case 1319: /* AlterOwnerStmt: ALTER COLLATION any_name OWNER TO RoleSpec  */
#line 8951 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36611 "gram.c"
    break;

  case 1320: /* AlterOwnerStmt: ALTER CONVERSION_P any_name OWNER TO RoleSpec  */
#line 8959 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36623 "gram.c"
    break;

  case 1321: /* AlterOwnerStmt: ALTER DATABASE database_name OWNER TO RoleSpec  */
#line 8967 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36635 "gram.c"
    break;

  case 1322: /* AlterOwnerStmt: ALTER DOMAIN_P any_name OWNER TO RoleSpec  */
#line 8975 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36647 "gram.c"
    break;

  case 1323: /* AlterOwnerStmt: ALTER FUNCTION function_with_argtypes OWNER TO RoleSpec  */
#line 8983 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36659 "gram.c"
    break;

  case 1324: /* AlterOwnerStmt: ALTER opt_procedural LANGUAGE name OWNER TO RoleSpec  */
#line 8991 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36671 "gram.c"
    break;

  case 1325: /* AlterOwnerStmt: ALTER LARGE_P OBJECT_P NumericOnly OWNER TO RoleSpec  */
#line 8999 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].value);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36683 "gram.c"
    break;

  case 1326: /* AlterOwnerStmt: ALTER OPERATOR operator_with_argtypes OWNER TO RoleSpec  */
#line 9007 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36695 "gram.c"
    break;

  case 1327: /* AlterOwnerStmt: ALTER OPERATOR CLASS any_name USING access_method OWNER TO RoleSpec  */
#line 9015 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36707 "gram.c"
    break;

  case 1328: /* AlterOwnerStmt: ALTER OPERATOR FAMILY any_name USING access_method OWNER TO RoleSpec  */
#line 9023 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36719 "gram.c"
    break;

  case 1329: /* AlterOwnerStmt: ALTER SCHEMA name OWNER TO RoleSpec  */
#line 9031 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36731 "gram.c"
    break;

  case 1330: /* AlterOwnerStmt: ALTER TYPE_P any_name OWNER TO RoleSpec  */
#line 9039 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36743 "gram.c"
    break;

  case 1331: /* AlterOwnerStmt: ALTER TABLESPACE name OWNER TO RoleSpec  */
#line 9047 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36755 "gram.c"
    break;

  case 1332: /* AlterOwnerStmt: ALTER STATISTICS any_name OWNER TO RoleSpec  */
#line 9055 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36767 "gram.c"
    break;

  case 1333: /* AlterOwnerStmt: ALTER TEXT_P SEARCH DICTIONARY any_name OWNER TO RoleSpec  */
#line 9063 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36779 "gram.c"
    break;

  case 1334: /* AlterOwnerStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name OWNER TO RoleSpec  */
#line 9071 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36791 "gram.c"
    break;

  case 1335: /* AlterOwnerStmt: ALTER FOREIGN DATA_P WRAPPER name OWNER TO RoleSpec  */
#line 9079 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36803 "gram.c"
    break;

  case 1336: /* AlterOwnerStmt: ALTER SERVER name OWNER TO RoleSpec  */
#line 9087 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36815 "gram.c"
    break;

  case 1337: /* AlterOwnerStmt: ALTER EVENT TRIGGER name OWNER TO RoleSpec  */
#line 9095 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36827 "gram.c"
    break;

  case 1338: /* AlterOwnerStmt: ALTER PUBLICATION name OWNER TO RoleSpec  */
#line 9103 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36839 "gram.c"
    break;

  case 1339: /* AlterOwnerStmt: ALTER SUBSCRIPTION name OWNER TO RoleSpec  */
#line 9111 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 36851 "gram.c"
    break;

  case 1340: /* CreatePublicationStmt: CREATE PUBLICATION name opt_publication_for_tables opt_definition  */
#line 9129 "gram.y"
                                {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					if ((yyvsp[-1].node) != NULL)
					{
						/* FOR TABLE */
						if (IsA((yyvsp[-1].node), List))
							n->tables = (List *)(yyvsp[-1].node);
						/* FOR ALL TABLES */
						else
							n->for_all_tables = TRUE;
					}
					(yyval.node) = (Node *)n;
				}
#line 36871 "gram.c"
    break;

  case 1341: /* opt_publication_for_tables: publication_for_tables  */
#line 9147 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 36877 "gram.c"
    break;

  case 1342: /* opt_publication_for_tables: %empty  */
#line 9148 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 36883 "gram.c"
    break;

  case 1343: /* publication_for_tables: FOR TABLE relation_expr_list  */
#line 9153 "gram.y"
                                {
					(yyval.node) = (Node *) (yyvsp[0].list);
				}
#line 36891 "gram.c"
    break;

  case 1344: /* publication_for_tables: FOR ALL TABLES  */
#line 9157 "gram.y"
                                {
					(yyval.node) = (Node *) makeInteger(TRUE);
				}
#line 36899 "gram.c"
    break;

  case 1345: /* AlterPublicationStmt: ALTER PUBLICATION name SET definition  */
#line 9177 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 36910 "gram.c"
    break;

  case 1346: /* AlterPublicationStmt: ALTER PUBLICATION name ADD_P TABLE relation_expr_list  */
#line 9184 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_ADD;
					(yyval.node) = (Node *)n;
				}
#line 36922 "gram.c"
    break;

  case 1347: /* AlterPublicationStmt: ALTER PUBLICATION name SET TABLE relation_expr_list  */
#line 9192 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_SET;
					(yyval.node) = (Node *)n;
				}
#line 36934 "gram.c"
    break;

  case 1348: /* AlterPublicationStmt: ALTER PUBLICATION name DROP TABLE relation_expr_list  */
#line 9200 "gram.y"
                                {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_DROP;
					(yyval.node) = (Node *)n;
				}
#line 36946 "gram.c"
    break;

  case 1349: /* CreateSubscriptionStmt: CREATE SUBSCRIPTION name CONNECTION Sconst PUBLICATION publication_name_list opt_definition  */
#line 9217 "gram.y"
                                {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 36960 "gram.c"
    break;

  case 1350: /* publication_name_list: publication_name_item  */
#line 9230 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].value));
				}
#line 36968 "gram.c"
    break;

  case 1351: /* publication_name_list: publication_name_list ',' publication_name_item  */
#line 9234 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value));
				}
#line 36976 "gram.c"
    break;

  case 1352: /* publication_name_item: ColLabel  */
#line 9240 "gram.y"
                                                        { (yyval.value) = makeString((yyvsp[0].str)); }
#line 36982 "gram.c"
    break;

  case 1353: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET definition  */
#line 9250 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 36995 "gram.c"
    break;

  case 1354: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name CONNECTION Sconst  */
#line 9259 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37008 "gram.c"
    break;

  case 1355: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name REFRESH PUBLICATION opt_definition  */
#line 9268 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37021 "gram.c"
    break;

  case 1356: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name SET PUBLICATION publication_name_list opt_definition  */
#line 9277 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37035 "gram.c"
    break;

  case 1357: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name ENABLE_P  */
#line 9287 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(TRUE), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 37049 "gram.c"
    break;

  case 1358: /* AlterSubscriptionStmt: ALTER SUBSCRIPTION name DISABLE_P  */
#line 9297 "gram.y"
                                {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(FALSE), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 37063 "gram.c"
    break;

  case 1359: /* DropSubscriptionStmt: DROP SUBSCRIPTION name opt_drop_behavior  */
#line 9315 "gram.y"
                                {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37075 "gram.c"
    break;

  case 1360: /* DropSubscriptionStmt: DROP SUBSCRIPTION IF_P EXISTS name opt_drop_behavior  */
#line 9323 "gram.y"
                                {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37087 "gram.c"
    break;

  case 1361: /* RuleStmt: CREATE opt_or_replace RULE name AS ON event TO qualified_name where_clause DO opt_instead RuleActionList  */
#line 9341 "gram.y"
                                {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37103 "gram.c"
    break;

  case 1362: /* RuleActionList: NOTHING  */
#line 9355 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 37109 "gram.c"
    break;

  case 1363: /* RuleActionList: RuleActionStmt  */
#line 9356 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37115 "gram.c"
    break;

  case 1364: /* RuleActionList: '(' RuleActionMulti ')'  */
#line 9357 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 37121 "gram.c"
    break;

  case 1365: /* RuleActionMulti: RuleActionMulti ';' RuleActionStmtOrEmpty  */
#line 9363 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 37131 "gram.c"
    break;

  case 1366: /* RuleActionMulti: RuleActionStmtOrEmpty  */
#line 9369 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 37141 "gram.c"
    break;

  case 1372: /* RuleActionStmtOrEmpty: RuleActionStmt  */
#line 9385 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 37147 "gram.c"
    break;

  case 1373: /* RuleActionStmtOrEmpty: %empty  */
#line 9386 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 37153 "gram.c"
    break;

  case 1374: /* event: SELECT  */
#line 9389 "gram.y"
                                                                                        { (yyval.ival) = CMD_SELECT; }
#line 37159 "gram.c"
    break;

  case 1375: /* event: UPDATE  */
#line 9390 "gram.y"
                                                                                                { (yyval.ival) = CMD_UPDATE; }
#line 37165 "gram.c"
    break;

  case 1376: /* event: DELETE_P  */
#line 9391 "gram.y"
                                                                                                { (yyval.ival) = CMD_DELETE; }
#line 37171 "gram.c"
    break;

  case 1377: /* event: INSERT  */
#line 9392 "gram.y"
                                                                                                { (yyval.ival) = CMD_INSERT; }
#line 37177 "gram.c"
    break;

  case 1378: /* opt_instead: INSTEAD  */
#line 9396 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 37183 "gram.c"
    break;

  case 1379: /* opt_instead: ALSO  */
#line 9397 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 37189 "gram.c"
    break;

  case 1380: /* opt_instead: %empty  */
#line 9398 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 37195 "gram.c"
    break;

  case 1381: /* NotifyStmt: NOTIFY ColId notify_payload  */
#line 9411 "gram.y"
                                {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37206 "gram.c"
    break;

  case 1382: /* notify_payload: ',' Sconst  */
#line 9420 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 37212 "gram.c"
    break;

  case 1383: /* notify_payload: %empty  */
#line 9421 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 37218 "gram.c"
    break;

  case 1384: /* ListenStmt: LISTEN ColId  */
#line 9425 "gram.y"
                                {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37228 "gram.c"
    break;

  case 1385: /* UnlistenStmt: UNLISTEN ColId  */
#line 9434 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37238 "gram.c"
    break;

  case 1386: /* UnlistenStmt: UNLISTEN '*'  */
#line 9440 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 37248 "gram.c"
    break;

  case 1387: /* TransactionStmt: ABORT_P opt_transaction  */
#line 9459 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 37259 "gram.c"
    break;

  case 1388: /* TransactionStmt: BEGIN_P opt_transaction transaction_mode_list_or_empty  */
#line 9466 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37270 "gram.c"
    break;

  case 1389: /* TransactionStmt: START TRANSACTION transaction_mode_list_or_empty  */
#line 9473 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37281 "gram.c"
    break;

  case 1390: /* TransactionStmt: COMMIT opt_transaction  */
#line 9480 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 37292 "gram.c"
    break;

  case 1391: /* TransactionStmt: END_P opt_transaction  */
#line 9487 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 37303 "gram.c"
    break;

  case 1392: /* TransactionStmt: ROLLBACK opt_transaction  */
#line 9494 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 37314 "gram.c"
    break;

  case 1393: /* TransactionStmt: SAVEPOINT ColId  */
#line 9501 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37326 "gram.c"
    break;

  case 1394: /* TransactionStmt: RELEASE SAVEPOINT ColId  */
#line 9509 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-2])));
					(yyval.node) = (Node *)n;
				}
#line 37338 "gram.c"
    break;

  case 1395: /* TransactionStmt: RELEASE ColId  */
#line 9517 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37350 "gram.c"
    break;

  case 1396: /* TransactionStmt: ROLLBACK opt_transaction TO SAVEPOINT ColId  */
#line 9525 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-4])));
					(yyval.node) = (Node *)n;
				}
#line 37362 "gram.c"
    break;

  case 1397: /* TransactionStmt: ROLLBACK opt_transaction TO ColId  */
#line 9533 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str)), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 37374 "gram.c"
    break;

  case 1398: /* TransactionStmt: PREPARE TRANSACTION Sconst  */
#line 9541 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37385 "gram.c"
    break;

  case 1399: /* TransactionStmt: COMMIT PREPARED Sconst  */
#line 9548 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37396 "gram.c"
    break;

  case 1400: /* TransactionStmt: ROLLBACK PREPARED Sconst  */
#line 9555 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37407 "gram.c"
    break;

  case 1401: /* opt_transaction: WORK  */
#line 9563 "gram.y"
                                                                                {}
#line 37413 "gram.c"
    break;

  case 1402: /* opt_transaction: TRANSACTION  */
#line 9564 "gram.y"
                                                                                        {}
#line 37419 "gram.c"
    break;

  case 1403: /* opt_transaction: %empty  */
#line 9565 "gram.y"
                                                                                                {}
#line 37425 "gram.c"
    break;

  case 1404: /* transaction_mode_item: ISOLATION LEVEL iso_level  */
#line 9570 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 37432 "gram.c"
    break;

  case 1405: /* transaction_mode_item: READ ONLY  */
#line 9573 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1])), (yylsp[-1])); }
#line 37439 "gram.c"
    break;

  case 1406: /* transaction_mode_item: READ WRITE  */
#line 9576 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1])), (yylsp[-1])); }
#line 37446 "gram.c"
    break;

  case 1407: /* transaction_mode_item: DEFERRABLE  */
#line 9579 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0])), (yylsp[0])); }
#line 37453 "gram.c"
    break;

  case 1408: /* transaction_mode_item: NOT DEFERRABLE  */
#line 9582 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1])), (yylsp[-1])); }
#line 37460 "gram.c"
    break;

  case 1409: /* transaction_mode_list: transaction_mode_item  */
#line 9589 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37466 "gram.c"
    break;

  case 1410: /* transaction_mode_list: transaction_mode_list ',' transaction_mode_item  */
#line 9591 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37472 "gram.c"
    break;

  case 1411: /* transaction_mode_list: transaction_mode_list transaction_mode_item  */
#line 9593 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37478 "gram.c"
    break;

  case 1413: /* transaction_mode_list_or_empty: %empty  */
#line 9599 "gram.y"
                                        { (yyval.list) = NIL; }
#line 37484 "gram.c"
    break;

  case 1414: /* ViewStmt: CREATE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 9613 "gram.y"
                                {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 37500 "gram.c"
    break;

  case 1415: /* ViewStmt: CREATE OR REPLACE OptTemp VIEW qualified_name opt_column_list opt_reloptions AS SelectStmt opt_check_option  */
#line 9626 "gram.y"
                                {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 37516 "gram.c"
    break;

  case 1416: /* ViewStmt: CREATE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 9639 "gram.y"
                                {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 37537 "gram.c"
    break;

  case 1417: /* ViewStmt: CREATE OR REPLACE OptTemp RECURSIVE VIEW qualified_name '(' columnList ')' opt_reloptions AS SelectStmt opt_check_option  */
#line 9657 "gram.y"
                                {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 37558 "gram.c"
    break;

  case 1418: /* opt_check_option: WITH CHECK OPTION  */
#line 9676 "gram.y"
                                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 37564 "gram.c"
    break;

  case 1419: /* opt_check_option: WITH CASCADED CHECK OPTION  */
#line 9677 "gram.y"
                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 37570 "gram.c"
    break;

  case 1420: /* opt_check_option: WITH LOCAL CHECK OPTION  */
#line 9678 "gram.y"
                                                        { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 37576 "gram.c"
    break;

  case 1421: /* opt_check_option: %empty  */
#line 9679 "gram.y"
                                                                { (yyval.ival) = NO_CHECK_OPTION; }
#line 37582 "gram.c"
    break;

  case 1422: /* LoadStmt: LOAD file_name  */
#line 9690 "gram.y"
                                {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37592 "gram.c"
    break;

  case 1423: /* CreatedbStmt: CREATE DATABASE database_name opt_with createdb_opt_list  */
#line 9706 "gram.y"
                                {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37603 "gram.c"
    break;

  case 1424: /* createdb_opt_list: createdb_opt_items  */
#line 9715 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 37609 "gram.c"
    break;

  case 1425: /* createdb_opt_list: %empty  */
#line 9716 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 37615 "gram.c"
    break;

  case 1426: /* createdb_opt_items: createdb_opt_item  */
#line 9720 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37621 "gram.c"
    break;

  case 1427: /* createdb_opt_items: createdb_opt_items createdb_opt_item  */
#line 9721 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37627 "gram.c"
    break;

  case 1428: /* createdb_opt_item: createdb_opt_name opt_equal SignedIconst  */
#line 9726 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 37635 "gram.c"
    break;

  case 1429: /* createdb_opt_item: createdb_opt_name opt_equal opt_boolean_or_string  */
#line 9730 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 37643 "gram.c"
    break;

  case 1430: /* createdb_opt_item: createdb_opt_name opt_equal DEFAULT  */
#line 9734 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 37651 "gram.c"
    break;

  case 1431: /* createdb_opt_name: IDENT  */
#line 9751 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 37657 "gram.c"
    break;

  case 1432: /* createdb_opt_name: CONNECTION LIMIT  */
#line 9752 "gram.y"
                                                                        { (yyval.str) = pstrdup("connection_limit"); }
#line 37663 "gram.c"
    break;

  case 1433: /* createdb_opt_name: ENCODING  */
#line 9753 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37669 "gram.c"
    break;

  case 1434: /* createdb_opt_name: LOCATION  */
#line 9754 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37675 "gram.c"
    break;

  case 1435: /* createdb_opt_name: OWNER  */
#line 9755 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37681 "gram.c"
    break;

  case 1436: /* createdb_opt_name: TABLESPACE  */
#line 9756 "gram.y"
                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37687 "gram.c"
    break;

  case 1437: /* createdb_opt_name: TEMPLATE  */
#line 9757 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 37693 "gram.c"
    break;

  case 1438: /* opt_equal: '='  */
#line 9764 "gram.y"
                                                                                                {}
#line 37699 "gram.c"
    break;

  case 1439: /* opt_equal: %empty  */
#line 9765 "gram.y"
                                                                                                {}
#line 37705 "gram.c"
    break;

  case 1440: /* AlterDatabaseStmt: ALTER DATABASE database_name WITH createdb_opt_list  */
#line 9777 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 37716 "gram.c"
    break;

  case 1441: /* AlterDatabaseStmt: ALTER DATABASE database_name createdb_opt_list  */
#line 9784 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 37727 "gram.c"
    break;

  case 1442: /* AlterDatabaseStmt: ALTER DATABASE database_name SET TABLESPACE name  */
#line 9791 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *)makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *)n;
				 }
#line 37739 "gram.c"
    break;

  case 1443: /* AlterDatabaseSetStmt: ALTER DATABASE database_name SetResetClause  */
#line 9802 "gram.y"
                                {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 37750 "gram.c"
    break;

  case 1444: /* DropdbStmt: DROP DATABASE database_name  */
#line 9819 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 37761 "gram.c"
    break;

  case 1445: /* DropdbStmt: DROP DATABASE IF_P EXISTS database_name  */
#line 9826 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 37772 "gram.c"
    break;

  case 1446: /* AlterCollationStmt: ALTER COLLATION any_name REFRESH VERSION_P  */
#line 9842 "gram.y"
                                {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);
					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 37782 "gram.c"
    break;

  case 1447: /* AlterSystemStmt: ALTER SYSTEM_P SET generic_set  */
#line 9859 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 37792 "gram.c"
    break;

  case 1448: /* AlterSystemStmt: ALTER SYSTEM_P RESET generic_reset  */
#line 9865 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 37802 "gram.c"
    break;

  case 1449: /* CreateDomainStmt: CREATE DOMAIN_P any_name opt_as Typename ColQualList  */
#line 9881 "gram.y"
                                {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 37815 "gram.c"
    break;

  case 1450: /* AlterDomainStmt: ALTER DOMAIN_P any_name alter_column_default  */
#line 9894 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 37827 "gram.c"
    break;

  case 1451: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP NOT NULL_P  */
#line 9903 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 37838 "gram.c"
    break;

  case 1452: /* AlterDomainStmt: ALTER DOMAIN_P any_name SET NOT NULL_P  */
#line 9911 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 37849 "gram.c"
    break;

  case 1453: /* AlterDomainStmt: ALTER DOMAIN_P any_name ADD_P TableConstraint  */
#line 9919 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 37861 "gram.c"
    break;

  case 1454: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT name opt_drop_behavior  */
#line 9928 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37875 "gram.c"
    break;

  case 1455: /* AlterDomainStmt: ALTER DOMAIN_P any_name DROP CONSTRAINT IF_P EXISTS name opt_drop_behavior  */
#line 9939 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 37889 "gram.c"
    break;

  case 1456: /* AlterDomainStmt: ALTER DOMAIN_P any_name VALIDATE CONSTRAINT name  */
#line 9950 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37901 "gram.c"
    break;

  case 1457: /* opt_as: AS  */
#line 9959 "gram.y"
                                                                                                {}
#line 37907 "gram.c"
    break;

  case 1458: /* opt_as: %empty  */
#line 9960 "gram.y"
                                                                                        {}
#line 37913 "gram.c"
    break;

  case 1459: /* AlterTSDictionaryStmt: ALTER TEXT_P SEARCH DICTIONARY any_name definition  */
#line 9972 "gram.y"
                                {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37924 "gram.c"
    break;

  case 1460: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ADD_P MAPPING FOR name_list any_with any_name_list  */
#line 9982 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 37939 "gram.c"
    break;

  case 1461: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list any_with any_name_list  */
#line 9993 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 37954 "gram.c"
    break;

  case 1462: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING REPLACE any_name any_with any_name  */
#line 10004 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 37969 "gram.c"
    break;

  case 1463: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name ALTER MAPPING FOR name_list REPLACE any_name any_with any_name  */
#line 10015 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 37984 "gram.c"
    break;

  case 1464: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING FOR name_list  */
#line 10026 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 37997 "gram.c"
    break;

  case 1465: /* AlterTSConfigurationStmt: ALTER TEXT_P SEARCH CONFIGURATION any_name DROP MAPPING IF_P EXISTS FOR name_list  */
#line 10035 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 38010 "gram.c"
    break;

  case 1466: /* any_with: WITH  */
#line 10046 "gram.y"
                                                                                        {}
#line 38016 "gram.c"
    break;

  case 1467: /* any_with: WITH_LA  */
#line 10047 "gram.y"
                                                                                                {}
#line 38022 "gram.c"
    break;

  case 1468: /* CreateConversionStmt: CREATE opt_default CONVERSION_P any_name FOR Sconst TO Sconst FROM any_name  */
#line 10063 "gram.y"
                        {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 38036 "gram.c"
    break;

  case 1469: /* ClusterStmt: CLUSTER opt_verbose qualified_name cluster_index_specification  */
#line 10085 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 38048 "gram.c"
    break;

  case 1470: /* ClusterStmt: CLUSTER opt_verbose  */
#line 10093 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 38060 "gram.c"
    break;

  case 1471: /* ClusterStmt: CLUSTER opt_verbose index_name ON qualified_name  */
#line 10102 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 38072 "gram.c"
    break;

  case 1472: /* cluster_index_specification: USING index_name  */
#line 10112 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 38078 "gram.c"
    break;

  case 1473: /* cluster_index_specification: %empty  */
#line 10113 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 38084 "gram.c"
    break;

  case 1474: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose  */
#line 10126 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 38102 "gram.c"
    break;

  case 1475: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose qualified_name  */
#line 10140 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 38120 "gram.c"
    break;

  case 1476: /* VacuumStmt: VACUUM opt_full opt_freeze opt_verbose AnalyzeStmt  */
#line 10154 "gram.y"
                                {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FREEZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					(yyval.node) = (Node *)n;
				}
#line 38136 "gram.c"
    break;

  case 1477: /* VacuumStmt: VACUUM '(' vacuum_option_list ')'  */
#line 10166 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 38148 "gram.c"
    break;

  case 1478: /* VacuumStmt: VACUUM '(' vacuum_option_list ')' qualified_name opt_name_list  */
#line 10174 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 38162 "gram.c"
    break;

  case 1479: /* vacuum_option_list: vacuum_option_elem  */
#line 10186 "gram.y"
                                                                                                        { (yyval.ival) = (yyvsp[0].ival); }
#line 38168 "gram.c"
    break;

  case 1480: /* vacuum_option_list: vacuum_option_list ',' vacuum_option_elem  */
#line 10187 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 38174 "gram.c"
    break;

  case 1481: /* vacuum_option_elem: analyze_keyword  */
#line 10191 "gram.y"
                                                { (yyval.ival) = VACOPT_ANALYZE; }
#line 38180 "gram.c"
    break;

  case 1482: /* vacuum_option_elem: VERBOSE  */
#line 10192 "gram.y"
                                                        { (yyval.ival) = VACOPT_VERBOSE; }
#line 38186 "gram.c"
    break;

  case 1483: /* vacuum_option_elem: FREEZE  */
#line 10193 "gram.y"
                                                        { (yyval.ival) = VACOPT_FREEZE; }
#line 38192 "gram.c"
    break;

  case 1484: /* vacuum_option_elem: FULL  */
#line 10194 "gram.y"
                                                        { (yyval.ival) = VACOPT_FULL; }
#line 38198 "gram.c"
    break;

  case 1485: /* vacuum_option_elem: IDENT  */
#line 10196 "gram.y"
                                {
					if (strcmp((yyvsp[0].str), "disable_page_skipping") == 0)
						(yyval.ival) = VACOPT_DISABLE_PAGE_SKIPPING;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized VACUUM option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 38212 "gram.c"
    break;

  case 1486: /* AnalyzeStmt: analyze_keyword opt_verbose  */
#line 10209 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 38226 "gram.c"
    break;

  case 1487: /* AnalyzeStmt: analyze_keyword opt_verbose qualified_name opt_name_list  */
#line 10219 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38240 "gram.c"
    break;

  case 1488: /* analyze_keyword: ANALYZE  */
#line 10231 "gram.y"
                                                                                                {}
#line 38246 "gram.c"
    break;

  case 1489: /* analyze_keyword: ANALYSE  */
#line 10232 "gram.y"
                                                                                {}
#line 38252 "gram.c"
    break;

  case 1490: /* opt_verbose: VERBOSE  */
#line 10236 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 38258 "gram.c"
    break;

  case 1491: /* opt_verbose: %empty  */
#line 10237 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 38264 "gram.c"
    break;

  case 1492: /* opt_full: FULL  */
#line 10240 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 38270 "gram.c"
    break;

  case 1493: /* opt_full: %empty  */
#line 10241 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 38276 "gram.c"
    break;

  case 1494: /* opt_freeze: FREEZE  */
#line 10244 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 38282 "gram.c"
    break;

  case 1495: /* opt_freeze: %empty  */
#line 10245 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 38288 "gram.c"
    break;

  case 1496: /* opt_name_list: '(' name_list ')'  */
#line 10249 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 38294 "gram.c"
    break;

  case 1497: /* opt_name_list: %empty  */
#line 10250 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 38300 "gram.c"
    break;

  case 1498: /* ExplainStmt: EXPLAIN ExplainableStmt  */
#line 10264 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 38311 "gram.c"
    break;

  case 1499: /* ExplainStmt: EXPLAIN analyze_keyword opt_verbose ExplainableStmt  */
#line 10271 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 38325 "gram.c"
    break;

  case 1500: /* ExplainStmt: EXPLAIN VERBOSE ExplainableStmt  */
#line 10281 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 38336 "gram.c"
    break;

  case 1501: /* ExplainStmt: EXPLAIN '(' explain_option_list ')' ExplainableStmt  */
#line 10288 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 38347 "gram.c"
    break;

  case 1511: /* explain_option_list: explain_option_elem  */
#line 10310 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 38355 "gram.c"
    break;

  case 1512: /* explain_option_list: explain_option_list ',' explain_option_elem  */
#line 10314 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 38363 "gram.c"
    break;

  case 1513: /* explain_option_elem: explain_option_name explain_option_arg  */
#line 10321 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 38371 "gram.c"
    break;

  case 1514: /* explain_option_name: NonReservedWord  */
#line 10327 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 38377 "gram.c"
    break;

  case 1515: /* explain_option_name: analyze_keyword  */
#line 10328 "gram.y"
                                                        { (yyval.str) = "analyze"; }
#line 38383 "gram.c"
    break;

  case 1516: /* explain_option_arg: opt_boolean_or_string  */
#line 10332 "gram.y"
                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 38389 "gram.c"
    break;

  case 1517: /* explain_option_arg: NumericOnly  */
#line 10333 "gram.y"
                                                        { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 38395 "gram.c"
    break;

  case 1518: /* explain_option_arg: %empty  */
#line 10334 "gram.y"
                                                        { (yyval.node) = NULL; }
#line 38401 "gram.c"
    break;

  case 1519: /* PrepareStmt: PREPARE name prep_type_clause AS PreparableStmt  */
#line 10345 "gram.y"
                                {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38413 "gram.c"
    break;

  case 1520: /* prep_type_clause: '(' type_list ')'  */
#line 10354 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 38419 "gram.c"
    break;

  case 1521: /* prep_type_clause: %empty  */
#line 10355 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 38425 "gram.c"
    break;

  case 1526: /* ExecuteStmt: EXECUTE name execute_param_clause  */
#line 10373 "gram.y"
                                {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38436 "gram.c"
    break;

  case 1527: /* ExecuteStmt: CREATE OptTemp TABLE create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 10381 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 38456 "gram.c"
    break;

  case 1528: /* ExecuteStmt: CREATE OptTemp TABLE IF_P NOT EXISTS create_as_target AS EXECUTE name execute_param_clause opt_with_data  */
#line 10398 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 38476 "gram.c"
    break;

  case 1529: /* execute_param_clause: '(' expr_list ')'  */
#line 10415 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 38482 "gram.c"
    break;

  case 1530: /* execute_param_clause: %empty  */
#line 10416 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 38488 "gram.c"
    break;

  case 1531: /* DeallocateStmt: DEALLOCATE name  */
#line 10427 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 38498 "gram.c"
    break;

  case 1532: /* DeallocateStmt: DEALLOCATE PREPARE name  */
#line 10433 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 38508 "gram.c"
    break;

  case 1533: /* DeallocateStmt: DEALLOCATE ALL  */
#line 10439 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 38518 "gram.c"
    break;

  case 1534: /* DeallocateStmt: DEALLOCATE PREPARE ALL  */
#line 10445 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 38528 "gram.c"
    break;

  case 1535: /* InsertStmt: opt_with_clause INSERT INTO insert_target insert_rest opt_on_conflict returning_clause  */
#line 10462 "gram.y"
                                {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 38540 "gram.c"
    break;

  case 1536: /* insert_target: qualified_name  */
#line 10479 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 38548 "gram.c"
    break;

  case 1537: /* insert_target: qualified_name AS ColId  */
#line 10483 "gram.y"
                                {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 38557 "gram.c"
    break;

  case 1538: /* insert_rest: SelectStmt  */
#line 10491 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 38567 "gram.c"
    break;

  case 1539: /* insert_rest: OVERRIDING override_kind VALUE_P SelectStmt  */
#line 10497 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 38578 "gram.c"
    break;

  case 1540: /* insert_rest: '(' insert_column_list ')' SelectStmt  */
#line 10504 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 38588 "gram.c"
    break;

  case 1541: /* insert_rest: '(' insert_column_list ')' OVERRIDING override_kind VALUE_P SelectStmt  */
#line 10510 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 38599 "gram.c"
    break;

  case 1542: /* insert_rest: DEFAULT VALUES  */
#line 10517 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 38609 "gram.c"
    break;

  case 1543: /* override_kind: USER  */
#line 10525 "gram.y"
                                        { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 38615 "gram.c"
    break;

  case 1544: /* override_kind: SYSTEM_P  */
#line 10526 "gram.y"
                                        { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 38621 "gram.c"
    break;

  case 1545: /* insert_column_list: insert_column_item  */
#line 10531 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 38627 "gram.c"
    break;

  case 1546: /* insert_column_list: insert_column_list ',' insert_column_item  */
#line 10533 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 38633 "gram.c"
    break;

  case 1547: /* insert_column_item: ColId opt_indirection  */
#line 10538 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 38645 "gram.c"
    break;

  case 1548: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO UPDATE SET set_clause_list where_clause  */
#line 10549 "gram.y"
                                {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 38658 "gram.c"
    break;

  case 1549: /* opt_on_conflict: ON CONFLICT opt_conf_expr DO NOTHING  */
#line 10559 "gram.y"
                                {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 38671 "gram.c"
    break;

  case 1550: /* opt_on_conflict: %empty  */
#line 10568 "gram.y"
                                {
					(yyval.onconflict) = NULL;
				}
#line 38679 "gram.c"
    break;

  case 1551: /* opt_conf_expr: '(' index_params ')' where_clause  */
#line 10575 "gram.y"
                                {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 38691 "gram.c"
    break;

  case 1552: /* opt_conf_expr: ON CONSTRAINT name  */
#line 10584 "gram.y"
                                {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 38703 "gram.c"
    break;

  case 1553: /* opt_conf_expr: %empty  */
#line 10592 "gram.y"
                                {
					(yyval.infer) = NULL;
				}
#line 38711 "gram.c"
    break;

  case 1554: /* returning_clause: RETURNING target_list  */
#line 10598 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 38717 "gram.c"
    break;

  case 1555: /* returning_clause: %empty  */
#line 10599 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 38723 "gram.c"
    break;

  case 1556: /* DeleteStmt: opt_with_clause DELETE_P FROM relation_expr_opt_alias using_clause where_or_current_clause returning_clause  */
#line 10612 "gram.y"
                                {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 38737 "gram.c"
    break;

  case 1557: /* using_clause: USING from_list  */
#line 10624 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 38743 "gram.c"
    break;

  case 1558: /* using_clause: %empty  */
#line 10625 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 38749 "gram.c"
    break;

  case 1559: /* LockStmt: LOCK_P opt_table relation_expr_list opt_lock opt_nowait  */
#line 10637 "gram.y"
                                {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38762 "gram.c"
    break;

  case 1560: /* opt_lock: IN_P lock_type MODE  */
#line 10647 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival); }
#line 38768 "gram.c"
    break;

  case 1561: /* opt_lock: %empty  */
#line 10648 "gram.y"
                                                                                { (yyval.ival) = AccessExclusiveLock; }
#line 38774 "gram.c"
    break;

  case 1562: /* lock_type: ACCESS SHARE  */
#line 10651 "gram.y"
                                                                { (yyval.ival) = AccessShareLock; }
#line 38780 "gram.c"
    break;

  case 1563: /* lock_type: ROW SHARE  */
#line 10652 "gram.y"
                                                                                { (yyval.ival) = RowShareLock; }
#line 38786 "gram.c"
    break;

  case 1564: /* lock_type: ROW EXCLUSIVE  */
#line 10653 "gram.y"
                                                                        { (yyval.ival) = RowExclusiveLock; }
#line 38792 "gram.c"
    break;

  case 1565: /* lock_type: SHARE UPDATE EXCLUSIVE  */
#line 10654 "gram.y"
                                                                { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 38798 "gram.c"
    break;

  case 1566: /* lock_type: SHARE  */
#line 10655 "gram.y"
                                                                                { (yyval.ival) = ShareLock; }
#line 38804 "gram.c"
    break;

  case 1567: /* lock_type: SHARE ROW EXCLUSIVE  */
#line 10656 "gram.y"
                                                                { (yyval.ival) = ShareRowExclusiveLock; }
#line 38810 "gram.c"
    break;

  case 1568: /* lock_type: EXCLUSIVE  */
#line 10657 "gram.y"
                                                                                { (yyval.ival) = ExclusiveLock; }
#line 38816 "gram.c"
    break;

  case 1569: /* lock_type: ACCESS EXCLUSIVE  */
#line 10658 "gram.y"
                                                                        { (yyval.ival) = AccessExclusiveLock; }
#line 38822 "gram.c"
    break;

  case 1570: /* opt_nowait: NOWAIT  */
#line 10661 "gram.y"
                                                                        { (yyval.boolean) = TRUE; }
#line 38828 "gram.c"
    break;

  case 1571: /* opt_nowait: %empty  */
#line 10662 "gram.y"
                                                                                { (yyval.boolean) = FALSE; }
#line 38834 "gram.c"
    break;

  case 1572: /* opt_nowait_or_skip: NOWAIT  */
#line 10666 "gram.y"
                                                                                { (yyval.ival) = LockWaitError; }
#line 38840 "gram.c"
    break;

  case 1573: /* opt_nowait_or_skip: SKIP LOCKED  */
#line 10667 "gram.y"
                                                                        { (yyval.ival) = LockWaitSkip; }
#line 38846 "gram.c"
    break;

  case 1574: /* opt_nowait_or_skip: %empty  */
#line 10668 "gram.y"
                                                                                { (yyval.ival) = LockWaitBlock; }
#line 38852 "gram.c"
    break;

  case 1575: /* UpdateStmt: opt_with_clause UPDATE relation_expr_opt_alias SET set_clause_list from_clause where_or_current_clause returning_clause  */
#line 10684 "gram.y"
                                {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 38867 "gram.c"
    break;

  case 1576: /* set_clause_list: set_clause  */
#line 10697 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 38873 "gram.c"
    break;

  case 1577: /* set_clause_list: set_clause_list ',' set_clause  */
#line 10698 "gram.y"
                                                                { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 38879 "gram.c"
    break;

  case 1578: /* set_clause: set_target '=' a_expr  */
#line 10703 "gram.y"
                                {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 38888 "gram.c"
    break;

  case 1579: /* set_clause: '(' set_target_list ')' '=' a_expr  */
#line 10708 "gram.y"
                                {
					int ncolumns = list_length((yyvsp[-3].list));
					int i = 1;
					ListCell *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 38913 "gram.c"
    break;

  case 1580: /* set_target: ColId opt_indirection  */
#line 10732 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 38925 "gram.c"
    break;

  case 1581: /* set_target_list: set_target  */
#line 10742 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 38931 "gram.c"
    break;

  case 1582: /* set_target_list: set_target_list ',' set_target  */
#line 10743 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 38937 "gram.c"
    break;

  case 1583: /* DeclareCursorStmt: DECLARE cursor_name cursor_options CURSOR opt_hold FOR SelectStmt  */
#line 10754 "gram.y"
                                {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 38950 "gram.c"
    break;

  case 1584: /* cursor_name: name  */
#line 10764 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 38956 "gram.c"
    break;

  case 1585: /* cursor_options: %empty  */
#line 10767 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 38962 "gram.c"
    break;

  case 1586: /* cursor_options: cursor_options NO SCROLL  */
#line 10768 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 38968 "gram.c"
    break;

  case 1587: /* cursor_options: cursor_options SCROLL  */
#line 10769 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 38974 "gram.c"
    break;

  case 1588: /* cursor_options: cursor_options BINARY  */
#line 10770 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 38980 "gram.c"
    break;

  case 1589: /* cursor_options: cursor_options INSENSITIVE  */
#line 10771 "gram.y"
                                                        { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 38986 "gram.c"
    break;

  case 1590: /* opt_hold: %empty  */
#line 10774 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 38992 "gram.c"
    break;

  case 1591: /* opt_hold: WITH HOLD  */
#line 10775 "gram.y"
                                                                                { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 38998 "gram.c"
    break;

  case 1592: /* opt_hold: WITHOUT HOLD  */
#line 10776 "gram.y"
                                                                        { (yyval.ival) = 0; }
#line 39004 "gram.c"
    break;

  case 1595: /* select_with_parens: '(' select_no_parens ')'  */
#line 10829 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 39010 "gram.c"
    break;

  case 1596: /* select_with_parens: '(' select_with_parens ')'  */
#line 10830 "gram.y"
                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 39016 "gram.c"
    break;

  case 1597: /* select_no_parens: simple_select  */
#line 10845 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 39022 "gram.c"
    break;

  case 1598: /* select_no_parens: select_clause sort_clause  */
#line 10847 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 39033 "gram.c"
    break;

  case 1599: /* select_no_parens: select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 10854 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 39045 "gram.c"
    break;

  case 1600: /* select_no_parens: select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 10862 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 39057 "gram.c"
    break;

  case 1601: /* select_no_parens: with_clause select_clause  */
#line 10870 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 39069 "gram.c"
    break;

  case 1602: /* select_no_parens: with_clause select_clause sort_clause  */
#line 10878 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 39081 "gram.c"
    break;

  case 1603: /* select_no_parens: with_clause select_clause opt_sort_clause for_locking_clause opt_select_limit  */
#line 10886 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 39093 "gram.c"
    break;

  case 1604: /* select_no_parens: with_clause select_clause opt_sort_clause select_limit opt_for_locking_clause  */
#line 10894 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 39105 "gram.c"
    break;

  case 1605: /* select_clause: simple_select  */
#line 10904 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 39111 "gram.c"
    break;

  case 1606: /* select_clause: select_with_parens  */
#line 10905 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 39117 "gram.c"
    break;

  case 1607: /* simple_select: SELECT opt_all_clause opt_target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 10935 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39133 "gram.c"
    break;

  case 1608: /* simple_select: SELECT distinct_clause target_list into_clause from_clause where_clause group_clause having_clause window_clause  */
#line 10949 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39150 "gram.c"
    break;

  case 1609: /* simple_select: values_clause  */
#line 10961 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 39156 "gram.c"
    break;

  case 1610: /* simple_select: TABLE relation_expr  */
#line 10963 "gram.y"
                                {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 39179 "gram.c"
    break;

  case 1611: /* simple_select: select_clause UNION all_or_distinct select_clause  */
#line 10982 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 39187 "gram.c"
    break;

  case 1612: /* simple_select: select_clause INTERSECT all_or_distinct select_clause  */
#line 10986 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 39195 "gram.c"
    break;

  case 1613: /* simple_select: select_clause EXCEPT all_or_distinct select_clause  */
#line 10990 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 39203 "gram.c"
    break;

  case 1614: /* with_clause: WITH cte_list  */
#line 11007 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 39214 "gram.c"
    break;

  case 1615: /* with_clause: WITH_LA cte_list  */
#line 11014 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 39225 "gram.c"
    break;

  case 1616: /* with_clause: WITH RECURSIVE cte_list  */
#line 11021 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 39236 "gram.c"
    break;

  case 1617: /* cte_list: common_table_expr  */
#line 11030 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 39242 "gram.c"
    break;

  case 1618: /* cte_list: cte_list ',' common_table_expr  */
#line 11031 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 39248 "gram.c"
    break;

  case 1619: /* common_table_expr: name opt_name_list AS '(' PreparableStmt ')'  */
#line 11035 "gram.y"
                        {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 39261 "gram.c"
    break;

  case 1620: /* opt_with_clause: with_clause  */
#line 11046 "gram.y"
                                                                                        { (yyval.with) = (yyvsp[0].with); }
#line 39267 "gram.c"
    break;

  case 1621: /* opt_with_clause: %empty  */
#line 11047 "gram.y"
                                                                                        { (yyval.with) = NULL; }
#line 39273 "gram.c"
    break;

  case 1622: /* into_clause: INTO OptTempTableName  */
#line 11052 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 39288 "gram.c"
    break;

  case 1623: /* into_clause: %empty  */
#line 11063 "gram.y"
                                { (yyval.into) = NULL; }
#line 39294 "gram.c"
    break;

  case 1624: /* OptTempTableName: TEMPORARY opt_table qualified_name  */
#line 11072 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 39303 "gram.c"
    break;

  case 1625: /* OptTempTableName: TEMP opt_table qualified_name  */
#line 11077 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 39312 "gram.c"
    break;

  case 1626: /* OptTempTableName: LOCAL TEMPORARY opt_table qualified_name  */
#line 11082 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 39321 "gram.c"
    break;

  case 1627: /* OptTempTableName: LOCAL TEMP opt_table qualified_name  */
#line 11087 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 39330 "gram.c"
    break;

  case 1628: /* OptTempTableName: GLOBAL TEMPORARY opt_table qualified_name  */
#line 11092 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 39342 "gram.c"
    break;

  case 1629: /* OptTempTableName: GLOBAL TEMP opt_table qualified_name  */
#line 11100 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 39354 "gram.c"
    break;

  case 1630: /* OptTempTableName: UNLOGGED opt_table qualified_name  */
#line 11108 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 39363 "gram.c"
    break;

  case 1631: /* OptTempTableName: TABLE qualified_name  */
#line 11113 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 39372 "gram.c"
    break;

  case 1632: /* OptTempTableName: qualified_name  */
#line 11118 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 39381 "gram.c"
    break;

  case 1633: /* opt_table: TABLE  */
#line 11124 "gram.y"
                                                                                        {}
#line 39387 "gram.c"
    break;

  case 1634: /* opt_table: %empty  */
#line 11125 "gram.y"
                                                                                                {}
#line 39393 "gram.c"
    break;

  case 1635: /* all_or_distinct: ALL  */
#line 11129 "gram.y"
                                                                                                        { (yyval.boolean) = TRUE; }
#line 39399 "gram.c"
    break;

  case 1636: /* all_or_distinct: DISTINCT  */
#line 11130 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 39405 "gram.c"
    break;

  case 1637: /* all_or_distinct: %empty  */
#line 11131 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 39411 "gram.c"
    break;

  case 1638: /* distinct_clause: DISTINCT  */
#line 11138 "gram.y"
                                                                                                { (yyval.list) = list_make1(NIL); }
#line 39417 "gram.c"
    break;

  case 1639: /* distinct_clause: DISTINCT ON '(' expr_list ')'  */
#line 11139 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 39423 "gram.c"
    break;

  case 1640: /* opt_all_clause: ALL  */
#line 11143 "gram.y"
                                                                                                        { (yyval.list) = NIL;}
#line 39429 "gram.c"
    break;

  case 1641: /* opt_all_clause: %empty  */
#line 11144 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39435 "gram.c"
    break;

  case 1642: /* opt_sort_clause: sort_clause  */
#line 11148 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list);}
#line 39441 "gram.c"
    break;

  case 1643: /* opt_sort_clause: %empty  */
#line 11149 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39447 "gram.c"
    break;

  case 1644: /* sort_clause: ORDER BY sortby_list  */
#line 11153 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 39453 "gram.c"
    break;

  case 1645: /* sortby_list: sortby  */
#line 11157 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 39459 "gram.c"
    break;

  case 1646: /* sortby_list: sortby_list ',' sortby  */
#line 11158 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 39465 "gram.c"
    break;

  case 1647: /* sortby: a_expr USING qual_all_Op opt_nulls_order  */
#line 11162 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 39478 "gram.c"
    break;

  case 1648: /* sortby: a_expr opt_asc_desc opt_nulls_order  */
#line 11171 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 39491 "gram.c"
    break;

  case 1649: /* select_limit: limit_clause offset_clause  */
#line 11183 "gram.y"
                                                                        { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 39497 "gram.c"
    break;

  case 1650: /* select_limit: offset_clause limit_clause  */
#line 11184 "gram.y"
                                                                { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 39503 "gram.c"
    break;

  case 1651: /* select_limit: limit_clause  */
#line 11185 "gram.y"
                                                                                { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 39509 "gram.c"
    break;

  case 1652: /* select_limit: offset_clause  */
#line 11186 "gram.y"
                                                                                { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 39515 "gram.c"
    break;

  case 1653: /* opt_select_limit: select_limit  */
#line 11190 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 39521 "gram.c"
    break;

  case 1654: /* opt_select_limit: %empty  */
#line 11191 "gram.y"
                                                                                { (yyval.list) = list_make2(NULL,NULL); }
#line 39527 "gram.c"
    break;

  case 1655: /* limit_clause: LIMIT select_limit_value  */
#line 11196 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 39533 "gram.c"
    break;

  case 1656: /* limit_clause: LIMIT select_limit_value ',' select_offset_value  */
#line 11198 "gram.y"
                                {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 39546 "gram.c"
    break;

  case 1657: /* limit_clause: FETCH first_or_next select_fetch_first_value row_or_rows ONLY  */
#line 11214 "gram.y"
                                { (yyval.node) = (yyvsp[-2].node); }
#line 39552 "gram.c"
    break;

  case 1658: /* limit_clause: FETCH first_or_next row_or_rows ONLY  */
#line 11216 "gram.y"
                                { (yyval.node) = makeIntConst(1, -1); }
#line 39558 "gram.c"
    break;

  case 1659: /* offset_clause: OFFSET select_offset_value  */
#line 11221 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 39564 "gram.c"
    break;

  case 1660: /* offset_clause: OFFSET select_fetch_first_value row_or_rows  */
#line 11224 "gram.y"
                                { (yyval.node) = (yyvsp[-1].node); }
#line 39570 "gram.c"
    break;

  case 1661: /* select_limit_value: a_expr  */
#line 11228 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 39576 "gram.c"
    break;

  case 1662: /* select_limit_value: ALL  */
#line 11230 "gram.y"
                                {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 39585 "gram.c"
    break;

  case 1663: /* select_offset_value: a_expr  */
#line 11237 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 39591 "gram.c"
    break;

  case 1664: /* select_fetch_first_value: c_expr  */
#line 11257 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 39597 "gram.c"
    break;

  case 1665: /* select_fetch_first_value: '+' I_or_F_const  */
#line 11259 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 39603 "gram.c"
    break;

  case 1666: /* select_fetch_first_value: '-' I_or_F_const  */
#line 11261 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 39609 "gram.c"
    break;

  case 1667: /* I_or_F_const: Iconst  */
#line 11265 "gram.y"
                                                                                                { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 39615 "gram.c"
    break;

  case 1668: /* I_or_F_const: FCONST  */
#line 11266 "gram.y"
                                                                                                { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 39621 "gram.c"
    break;

  case 1669: /* row_or_rows: ROW  */
#line 11270 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 39627 "gram.c"
    break;

  case 1670: /* row_or_rows: ROWS  */
#line 11271 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 39633 "gram.c"
    break;

  case 1671: /* first_or_next: FIRST_P  */
#line 11274 "gram.y"
                                                                                { (yyval.ival) = 0; }
#line 39639 "gram.c"
    break;

  case 1672: /* first_or_next: NEXT  */
#line 11275 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 39645 "gram.c"
    break;

  case 1673: /* group_clause: GROUP_P BY group_by_list  */
#line 11300 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 39651 "gram.c"
    break;

  case 1674: /* group_clause: %empty  */
#line 11301 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39657 "gram.c"
    break;

  case 1675: /* group_by_list: group_by_item  */
#line 11305 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 39663 "gram.c"
    break;

  case 1676: /* group_by_list: group_by_list ',' group_by_item  */
#line 11306 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 39669 "gram.c"
    break;

  case 1677: /* group_by_item: a_expr  */
#line 11310 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 39675 "gram.c"
    break;

  case 1678: /* group_by_item: empty_grouping_set  */
#line 11311 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 39681 "gram.c"
    break;

  case 1679: /* group_by_item: cube_clause  */
#line 11312 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 39687 "gram.c"
    break;

  case 1680: /* group_by_item: rollup_clause  */
#line 11313 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 39693 "gram.c"
    break;

  case 1681: /* group_by_item: grouping_sets_clause  */
#line 11314 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 39699 "gram.c"
    break;

  case 1682: /* empty_grouping_set: '(' ')'  */
#line 11319 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 39707 "gram.c"
    break;

  case 1683: /* rollup_clause: ROLLUP '(' expr_list ')'  */
#line 11332 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39715 "gram.c"
    break;

  case 1684: /* cube_clause: CUBE '(' expr_list ')'  */
#line 11339 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 39723 "gram.c"
    break;

  case 1685: /* grouping_sets_clause: GROUPING SETS '(' group_by_list ')'  */
#line 11346 "gram.y"
                                {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 39731 "gram.c"
    break;

  case 1686: /* having_clause: HAVING a_expr  */
#line 11352 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 39737 "gram.c"
    break;

  case 1687: /* having_clause: %empty  */
#line 11353 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 39743 "gram.c"
    break;

  case 1688: /* for_locking_clause: for_locking_items  */
#line 11357 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 39749 "gram.c"
    break;

  case 1689: /* for_locking_clause: FOR READ ONLY  */
#line 11358 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 39755 "gram.c"
    break;

  case 1690: /* opt_for_locking_clause: for_locking_clause  */
#line 11362 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 39761 "gram.c"
    break;

  case 1691: /* opt_for_locking_clause: %empty  */
#line 11363 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 39767 "gram.c"
    break;

  case 1692: /* for_locking_items: for_locking_item  */
#line 11367 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 39773 "gram.c"
    break;

  case 1693: /* for_locking_items: for_locking_items for_locking_item  */
#line 11368 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 39779 "gram.c"
    break;

  case 1694: /* for_locking_item: for_locking_strength locked_rels_list opt_nowait_or_skip  */
#line 11373 "gram.y"
                                {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 39791 "gram.c"
    break;

  case 1695: /* for_locking_strength: FOR UPDATE  */
#line 11383 "gram.y"
                                                                                        { (yyval.ival) = LCS_FORUPDATE; }
#line 39797 "gram.c"
    break;

  case 1696: /* for_locking_strength: FOR NO KEY UPDATE  */
#line 11384 "gram.y"
                                                                        { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 39803 "gram.c"
    break;

  case 1697: /* for_locking_strength: FOR SHARE  */
#line 11385 "gram.y"
                                                                                { (yyval.ival) = LCS_FORSHARE; }
#line 39809 "gram.c"
    break;

  case 1698: /* for_locking_strength: FOR KEY SHARE  */
#line 11386 "gram.y"
                                                                                { (yyval.ival) = LCS_FORKEYSHARE; }
#line 39815 "gram.c"
    break;

  case 1699: /* locked_rels_list: OF qualified_name_list  */
#line 11390 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 39821 "gram.c"
    break;

  case 1700: /* locked_rels_list: %empty  */
#line 11391 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 39827 "gram.c"
    break;

  case 1701: /* values_clause: VALUES '(' expr_list ')'  */
#line 11402 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 39837 "gram.c"
    break;

  case 1702: /* values_clause: values_clause ',' '(' expr_list ')'  */
#line 11408 "gram.y"
                                {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 39847 "gram.c"
    break;

  case 1703: /* from_clause: FROM from_list  */
#line 11425 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 39853 "gram.c"
    break;

  case 1704: /* from_clause: %empty  */
#line 11426 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39859 "gram.c"
    break;

  case 1705: /* from_list: table_ref  */
#line 11430 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 39865 "gram.c"
    break;

  case 1706: /* from_list: from_list ',' table_ref  */
#line 11431 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 39871 "gram.c"
    break;

  case 1707: /* table_ref: relation_expr opt_alias_clause  */
#line 11438 "gram.y"
                                {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 39880 "gram.c"
    break;

  case 1708: /* table_ref: relation_expr opt_alias_clause tablesample_clause  */
#line 11443 "gram.y"
                                {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);
					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 39892 "gram.c"
    break;

  case 1709: /* table_ref: func_table func_alias_clause  */
#line 11451 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 39903 "gram.c"
    break;

  case 1710: /* table_ref: LATERAL_P func_table func_alias_clause  */
#line 11458 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 39915 "gram.c"
    break;

  case 1711: /* table_ref: xmltable opt_alias_clause  */
#line 11466 "gram.y"
                                {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 39925 "gram.c"
    break;

  case 1712: /* table_ref: LATERAL_P xmltable opt_alias_clause  */
#line 11472 "gram.y"
                                {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 39936 "gram.c"
    break;

  case 1713: /* table_ref: select_with_parens opt_alias_clause  */
#line 11479 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 39975 "gram.c"
    break;

  case 1714: /* table_ref: LATERAL_P select_with_parens opt_alias_clause  */
#line 11514 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 40004 "gram.c"
    break;

  case 1715: /* table_ref: joined_table  */
#line 11539 "gram.y"
                                {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 40012 "gram.c"
    break;

  case 1716: /* table_ref: '(' joined_table ')' alias_clause  */
#line 11543 "gram.y"
                                {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 40021 "gram.c"
    break;

  case 1717: /* joined_table: '(' joined_table ')'  */
#line 11569 "gram.y"
                                {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 40029 "gram.c"
    break;

  case 1718: /* joined_table: table_ref CROSS JOIN table_ref  */
#line 11573 "gram.y"
                                {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 40045 "gram.c"
    break;

  case 1719: /* joined_table: table_ref join_type JOIN table_ref join_qual  */
#line 11585 "gram.y"
                                {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 40062 "gram.c"
    break;

  case 1720: /* joined_table: table_ref JOIN table_ref join_qual  */
#line 11598 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 40080 "gram.c"
    break;

  case 1721: /* joined_table: table_ref NATURAL join_type JOIN table_ref  */
#line 11612 "gram.y"
                                {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 40095 "gram.c"
    break;

  case 1722: /* joined_table: table_ref NATURAL JOIN table_ref  */
#line 11623 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 40111 "gram.c"
    break;

  case 1723: /* alias_clause: AS ColId '(' name_list ')'  */
#line 11638 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 40121 "gram.c"
    break;

  case 1724: /* alias_clause: AS ColId  */
#line 11644 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 40130 "gram.c"
    break;

  case 1725: /* alias_clause: ColId '(' name_list ')'  */
#line 11649 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 40140 "gram.c"
    break;

  case 1726: /* alias_clause: ColId  */
#line 11655 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 40149 "gram.c"
    break;

  case 1727: /* opt_alias_clause: alias_clause  */
#line 11661 "gram.y"
                                                                        { (yyval.alias) = (yyvsp[0].alias); }
#line 40155 "gram.c"
    break;

  case 1728: /* opt_alias_clause: %empty  */
#line 11662 "gram.y"
                                                                                                { (yyval.alias) = NULL; }
#line 40161 "gram.c"
    break;

  case 1729: /* func_alias_clause: alias_clause  */
#line 11671 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 40169 "gram.c"
    break;

  case 1730: /* func_alias_clause: AS '(' TableFuncElementList ')'  */
#line 11675 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 40177 "gram.c"
    break;

  case 1731: /* func_alias_clause: AS ColId '(' TableFuncElementList ')'  */
#line 11679 "gram.y"
                                {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 40187 "gram.c"
    break;

  case 1732: /* func_alias_clause: ColId '(' TableFuncElementList ')'  */
#line 11685 "gram.y"
                                {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 40197 "gram.c"
    break;

  case 1733: /* func_alias_clause: %empty  */
#line 11691 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 40205 "gram.c"
    break;

  case 1734: /* join_type: FULL join_outer  */
#line 11696 "gram.y"
                                                                                { (yyval.jtype) = JOIN_FULL; }
#line 40211 "gram.c"
    break;

  case 1735: /* join_type: LEFT join_outer  */
#line 11697 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_LEFT; }
#line 40217 "gram.c"
    break;

  case 1736: /* join_type: RIGHT join_outer  */
#line 11698 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_RIGHT; }
#line 40223 "gram.c"
    break;

  case 1737: /* join_type: INNER_P  */
#line 11699 "gram.y"
                                                                                                { (yyval.jtype) = JOIN_INNER; }
#line 40229 "gram.c"
    break;

  case 1738: /* join_outer: OUTER_P  */
#line 11703 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 40235 "gram.c"
    break;

  case 1739: /* join_outer: %empty  */
#line 11704 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 40241 "gram.c"
    break;

  case 1740: /* join_qual: USING '(' name_list ')'  */
#line 11716 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 40247 "gram.c"
    break;

  case 1741: /* join_qual: ON a_expr  */
#line 11717 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 40253 "gram.c"
    break;

  case 1742: /* relation_expr: qualified_name  */
#line 11723 "gram.y"
                                {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 40264 "gram.c"
    break;

  case 1743: /* relation_expr: qualified_name '*'  */
#line 11730 "gram.y"
                                {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 40275 "gram.c"
    break;

  case 1744: /* relation_expr: ONLY qualified_name  */
#line 11737 "gram.y"
                                {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 40286 "gram.c"
    break;

  case 1745: /* relation_expr: ONLY '(' qualified_name ')'  */
#line 11744 "gram.y"
                                {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 40297 "gram.c"
    break;

  case 1746: /* relation_expr_list: relation_expr  */
#line 11754 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 40303 "gram.c"
    break;

  case 1747: /* relation_expr_list: relation_expr_list ',' relation_expr  */
#line 11755 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 40309 "gram.c"
    break;

  case 1748: /* relation_expr_opt_alias: relation_expr  */
#line 11769 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 40317 "gram.c"
    break;

  case 1749: /* relation_expr_opt_alias: relation_expr ColId  */
#line 11773 "gram.y"
                                {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 40328 "gram.c"
    break;

  case 1750: /* relation_expr_opt_alias: relation_expr AS ColId  */
#line 11780 "gram.y"
                                {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 40339 "gram.c"
    break;

  case 1751: /* tablesample_clause: TABLESAMPLE func_name '(' expr_list ')' opt_repeatable_clause  */
#line 11793 "gram.y"
                                {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 40353 "gram.c"
    break;

  case 1752: /* opt_repeatable_clause: REPEATABLE '(' a_expr ')'  */
#line 11805 "gram.y"
                                                        { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 40359 "gram.c"
    break;

  case 1753: /* opt_repeatable_clause: %empty  */
#line 11806 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 40365 "gram.c"
    break;

  case 1754: /* func_table: func_expr_windowless opt_ordinality  */
#line 11822 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 40379 "gram.c"
    break;

  case 1755: /* func_table: ROWS FROM '(' rowsfrom_list ')' opt_ordinality  */
#line 11832 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 40393 "gram.c"
    break;

  case 1756: /* rowsfrom_item: func_expr_windowless opt_col_def_list  */
#line 11844 "gram.y"
                                { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 40399 "gram.c"
    break;

  case 1757: /* rowsfrom_list: rowsfrom_item  */
#line 11848 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 40405 "gram.c"
    break;

  case 1758: /* rowsfrom_list: rowsfrom_list ',' rowsfrom_item  */
#line 11849 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 40411 "gram.c"
    break;

  case 1759: /* opt_col_def_list: AS '(' TableFuncElementList ')'  */
#line 11852 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 40417 "gram.c"
    break;

  case 1760: /* opt_col_def_list: %empty  */
#line 11853 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 40423 "gram.c"
    break;

  case 1761: /* opt_ordinality: WITH_LA ORDINALITY  */
#line 11856 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 40429 "gram.c"
    break;

  case 1762: /* opt_ordinality: %empty  */
#line 11857 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 40435 "gram.c"
    break;

  case 1763: /* where_clause: WHERE a_expr  */
#line 11862 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 40441 "gram.c"
    break;

  case 1764: /* where_clause: %empty  */
#line 11863 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 40447 "gram.c"
    break;

  case 1765: /* where_or_current_clause: WHERE a_expr  */
#line 11868 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 40453 "gram.c"
    break;

  case 1766: /* where_or_current_clause: WHERE CURRENT_P OF cursor_name  */
#line 11870 "gram.y"
                                {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 40465 "gram.c"
    break;

  case 1767: /* where_or_current_clause: %empty  */
#line 11877 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 40471 "gram.c"
    break;

  case 1768: /* OptTableFuncElementList: TableFuncElementList  */
#line 11882 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 40477 "gram.c"
    break;

  case 1769: /* OptTableFuncElementList: %empty  */
#line 11883 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 40483 "gram.c"
    break;

  case 1770: /* TableFuncElementList: TableFuncElement  */
#line 11888 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 40491 "gram.c"
    break;

  case 1771: /* TableFuncElementList: TableFuncElementList ',' TableFuncElement  */
#line 11892 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 40499 "gram.c"
    break;

  case 1772: /* TableFuncElement: ColId Typename opt_collate_clause  */
#line 11898 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 40521 "gram.c"
    break;

  case 1773: /* xmltable: XMLTABLE '(' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 11922 "gram.y"
                                {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 40535 "gram.c"
    break;

  case 1774: /* xmltable: XMLTABLE '(' XMLNAMESPACES '(' xml_namespace_list ')' ',' c_expr xmlexists_argument COLUMNS xmltable_column_list ')'  */
#line 11933 "gram.y"
                                {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *)n;
				}
#line 40549 "gram.c"
    break;

  case 1775: /* xmltable_column_list: xmltable_column_el  */
#line 11944 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40555 "gram.c"
    break;

  case 1776: /* xmltable_column_list: xmltable_column_list ',' xmltable_column_el  */
#line 11945 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 40561 "gram.c"
    break;

  case 1777: /* xmltable_column_el: ColId Typename  */
#line 11950 "gram.y"
                                {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 40579 "gram.c"
    break;

  case 1778: /* xmltable_column_el: ColId Typename xmltable_column_option_list  */
#line 11964 "gram.y"
                                {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);
					ListCell		   *option;
					bool				nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = intVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 40640 "gram.c"
    break;

  case 1779: /* xmltable_column_el: ColId FOR ORDINALITY  */
#line 12021 "gram.y"
                                {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 40655 "gram.c"
    break;

  case 1780: /* xmltable_column_option_list: xmltable_column_option_el  */
#line 12035 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40661 "gram.c"
    break;

  case 1781: /* xmltable_column_option_list: xmltable_column_option_list xmltable_column_option_el  */
#line 12037 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40667 "gram.c"
    break;

  case 1782: /* xmltable_column_option_el: IDENT b_expr  */
#line 12042 "gram.y"
                                { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 40673 "gram.c"
    break;

  case 1783: /* xmltable_column_option_el: DEFAULT b_expr  */
#line 12044 "gram.y"
                                { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 40679 "gram.c"
    break;

  case 1784: /* xmltable_column_option_el: NOT NULL_P  */
#line 12046 "gram.y"
                                { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(true), (yylsp[-1])); }
#line 40685 "gram.c"
    break;

  case 1785: /* xmltable_column_option_el: NULL_P  */
#line 12048 "gram.y"
                                { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(false), (yylsp[0])); }
#line 40691 "gram.c"
    break;

  case 1786: /* xml_namespace_list: xml_namespace_el  */
#line 12053 "gram.y"
                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 40697 "gram.c"
    break;

  case 1787: /* xml_namespace_list: xml_namespace_list ',' xml_namespace_el  */
#line 12055 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 40703 "gram.c"
    break;

  case 1788: /* xml_namespace_el: b_expr AS ColLabel  */
#line 12060 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 40715 "gram.c"
    break;

  case 1789: /* xml_namespace_el: DEFAULT b_expr  */
#line 12068 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 40727 "gram.c"
    break;

  case 1790: /* Typename: SimpleTypename opt_array_bounds  */
#line 12088 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 40736 "gram.c"
    break;

  case 1791: /* Typename: SETOF SimpleTypename opt_array_bounds  */
#line 12093 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 40746 "gram.c"
    break;

  case 1792: /* Typename: SimpleTypename ARRAY '[' Iconst ']'  */
#line 12100 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 40755 "gram.c"
    break;

  case 1793: /* Typename: SETOF SimpleTypename ARRAY '[' Iconst ']'  */
#line 12105 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 40765 "gram.c"
    break;

  case 1794: /* Typename: SimpleTypename ARRAY  */
#line 12111 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 40774 "gram.c"
    break;

  case 1795: /* Typename: SETOF SimpleTypename ARRAY  */
#line 12116 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 40784 "gram.c"
    break;

  case 1796: /* opt_array_bounds: opt_array_bounds '[' ']'  */
#line 12125 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 40790 "gram.c"
    break;

  case 1797: /* opt_array_bounds: opt_array_bounds '[' Iconst ']'  */
#line 12127 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 40796 "gram.c"
    break;

  case 1798: /* opt_array_bounds: %empty  */
#line 12129 "gram.y"
                                        {  (yyval.list) = NIL; }
#line 40802 "gram.c"
    break;

  case 1799: /* SimpleTypename: GenericType  */
#line 12133 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40808 "gram.c"
    break;

  case 1800: /* SimpleTypename: Numeric  */
#line 12134 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40814 "gram.c"
    break;

  case 1801: /* SimpleTypename: Bit  */
#line 12135 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40820 "gram.c"
    break;

  case 1802: /* SimpleTypename: Character  */
#line 12136 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40826 "gram.c"
    break;

  case 1803: /* SimpleTypename: ConstDatetime  */
#line 12137 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40832 "gram.c"
    break;

  case 1804: /* SimpleTypename: ConstInterval opt_interval  */
#line 12139 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 40841 "gram.c"
    break;

  case 1805: /* SimpleTypename: ConstInterval '(' Iconst ')'  */
#line 12144 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 40851 "gram.c"
    break;

  case 1806: /* ConstTypename: Numeric  */
#line 12163 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40857 "gram.c"
    break;

  case 1807: /* ConstTypename: ConstBit  */
#line 12164 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40863 "gram.c"
    break;

  case 1808: /* ConstTypename: ConstCharacter  */
#line 12165 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40869 "gram.c"
    break;

  case 1809: /* ConstTypename: ConstDatetime  */
#line 12166 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40875 "gram.c"
    break;

  case 1810: /* GenericType: type_function_name opt_type_modifiers  */
#line 12178 "gram.y"
                                {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 40885 "gram.c"
    break;

  case 1811: /* GenericType: type_function_name attrs opt_type_modifiers  */
#line 12184 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 40895 "gram.c"
    break;

  case 1812: /* opt_type_modifiers: '(' expr_list ')'  */
#line 12191 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 40901 "gram.c"
    break;

  case 1813: /* opt_type_modifiers: %empty  */
#line 12192 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 40907 "gram.c"
    break;

  case 1814: /* Numeric: INT_P  */
#line 12199 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 40916 "gram.c"
    break;

  case 1815: /* Numeric: INTEGER  */
#line 12204 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 40925 "gram.c"
    break;

  case 1816: /* Numeric: SMALLINT  */
#line 12209 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 40934 "gram.c"
    break;

  case 1817: /* Numeric: BIGINT  */
#line 12214 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 40943 "gram.c"
    break;

  case 1818: /* Numeric: REAL  */
#line 12219 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 40952 "gram.c"
    break;

  case 1819: /* Numeric: FLOAT_P opt_float  */
#line 12224 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 40961 "gram.c"
    break;

  case 1820: /* Numeric: DOUBLE_P PRECISION  */
#line 12229 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 40970 "gram.c"
    break;

  case 1821: /* Numeric: DECIMAL_P opt_type_modifiers  */
#line 12234 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 40980 "gram.c"
    break;

  case 1822: /* Numeric: DEC opt_type_modifiers  */
#line 12240 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 40990 "gram.c"
    break;

  case 1823: /* Numeric: NUMERIC opt_type_modifiers  */
#line 12246 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 41000 "gram.c"
    break;

  case 1824: /* Numeric: BOOLEAN_P  */
#line 12252 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 41009 "gram.c"
    break;

  case 1825: /* opt_float: '(' Iconst ')'  */
#line 12259 "gram.y"
                                {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 41034 "gram.c"
    break;

  case 1826: /* opt_float: %empty  */
#line 12280 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 41042 "gram.c"
    break;

  case 1827: /* Bit: BitWithLength  */
#line 12290 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 41050 "gram.c"
    break;

  case 1828: /* Bit: BitWithoutLength  */
#line 12294 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 41058 "gram.c"
    break;

  case 1829: /* ConstBit: BitWithLength  */
#line 12302 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 41066 "gram.c"
    break;

  case 1830: /* ConstBit: BitWithoutLength  */
#line 12306 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 41075 "gram.c"
    break;

  case 1831: /* BitWithLength: BIT opt_varying '(' expr_list ')'  */
#line 12314 "gram.y"
                                {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 41088 "gram.c"
    break;

  case 1832: /* BitWithoutLength: BIT opt_varying  */
#line 12326 "gram.y"
                                {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 41106 "gram.c"
    break;

  case 1833: /* Character: CharacterWithLength  */
#line 12347 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 41114 "gram.c"
    break;

  case 1834: /* Character: CharacterWithoutLength  */
#line 12351 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 41122 "gram.c"
    break;

  case 1835: /* ConstCharacter: CharacterWithLength  */
#line 12357 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 41130 "gram.c"
    break;

  case 1836: /* ConstCharacter: CharacterWithoutLength  */
#line 12361 "gram.y"
                                {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 41145 "gram.c"
    break;

  case 1837: /* CharacterWithLength: character '(' Iconst ')'  */
#line 12374 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 41155 "gram.c"
    break;

  case 1838: /* CharacterWithoutLength: character  */
#line 12382 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 41167 "gram.c"
    break;

  case 1839: /* character: CHARACTER opt_varying  */
#line 12392 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 41173 "gram.c"
    break;

  case 1840: /* character: CHAR_P opt_varying  */
#line 12394 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 41179 "gram.c"
    break;

  case 1841: /* character: VARCHAR  */
#line 12396 "gram.y"
                                                                                { (yyval.str) = "varchar"; }
#line 41185 "gram.c"
    break;

  case 1842: /* character: NATIONAL CHARACTER opt_varying  */
#line 12398 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 41191 "gram.c"
    break;

  case 1843: /* character: NATIONAL CHAR_P opt_varying  */
#line 12400 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 41197 "gram.c"
    break;

  case 1844: /* character: NCHAR opt_varying  */
#line 12402 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 41203 "gram.c"
    break;

  case 1845: /* opt_varying: VARYING  */
#line 12406 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 41209 "gram.c"
    break;

  case 1846: /* opt_varying: %empty  */
#line 12407 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 41215 "gram.c"
    break;

  case 1847: /* ConstDatetime: TIMESTAMP '(' Iconst ')' opt_timezone  */
#line 12415 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 41228 "gram.c"
    break;

  case 1848: /* ConstDatetime: TIMESTAMP opt_timezone  */
#line 12424 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 41240 "gram.c"
    break;

  case 1849: /* ConstDatetime: TIME '(' Iconst ')' opt_timezone  */
#line 12432 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 41253 "gram.c"
    break;

  case 1850: /* ConstDatetime: TIME opt_timezone  */
#line 12441 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 41265 "gram.c"
    break;

  case 1851: /* ConstInterval: INTERVAL  */
#line 12452 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 41274 "gram.c"
    break;

  case 1852: /* opt_timezone: WITH_LA TIME ZONE  */
#line 12459 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 41280 "gram.c"
    break;

  case 1853: /* opt_timezone: WITHOUT TIME ZONE  */
#line 12460 "gram.y"
                                                                                        { (yyval.boolean) = FALSE; }
#line 41286 "gram.c"
    break;

  case 1854: /* opt_timezone: %empty  */
#line 12461 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 41292 "gram.c"
    break;

  case 1855: /* opt_interval: YEAR_P  */
#line 12466 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 41298 "gram.c"
    break;

  case 1856: /* opt_interval: MONTH_P  */
#line 12468 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 41304 "gram.c"
    break;

  case 1857: /* opt_interval: DAY_P  */
#line 12470 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 41310 "gram.c"
    break;

  case 1858: /* opt_interval: HOUR_P  */
#line 12472 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 41316 "gram.c"
    break;

  case 1859: /* opt_interval: MINUTE_P  */
#line 12474 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 41322 "gram.c"
    break;

  case 1860: /* opt_interval: interval_second  */
#line 12476 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 41328 "gram.c"
    break;

  case 1861: /* opt_interval: YEAR_P TO MONTH_P  */
#line 12478 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 41337 "gram.c"
    break;

  case 1862: /* opt_interval: DAY_P TO HOUR_P  */
#line 12483 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 41346 "gram.c"
    break;

  case 1863: /* opt_interval: DAY_P TO MINUTE_P  */
#line 12488 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 41356 "gram.c"
    break;

  case 1864: /* opt_interval: DAY_P TO interval_second  */
#line 12494 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 41368 "gram.c"
    break;

  case 1865: /* opt_interval: HOUR_P TO MINUTE_P  */
#line 12502 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 41377 "gram.c"
    break;

  case 1866: /* opt_interval: HOUR_P TO interval_second  */
#line 12507 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 41388 "gram.c"
    break;

  case 1867: /* opt_interval: MINUTE_P TO interval_second  */
#line 12514 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 41398 "gram.c"
    break;

  case 1868: /* opt_interval: %empty  */
#line 12520 "gram.y"
                                { (yyval.list) = NIL; }
#line 41404 "gram.c"
    break;

  case 1869: /* interval_second: SECOND_P  */
#line 12525 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 41412 "gram.c"
    break;

  case 1870: /* interval_second: SECOND_P '(' Iconst ')'  */
#line 12529 "gram.y"
                                {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 41421 "gram.c"
    break;

  case 1871: /* a_expr: c_expr  */
#line 12564 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 41427 "gram.c"
    break;

  case 1872: /* a_expr: a_expr TYPECAST Typename  */
#line 12566 "gram.y"
                                        { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 41433 "gram.c"
    break;

  case 1873: /* a_expr: a_expr COLLATE any_name  */
#line 12568 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 41445 "gram.c"
    break;

  case 1874: /* a_expr: a_expr AT TIME ZONE a_expr  */
#line 12576 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 41455 "gram.c"
    break;

  case 1875: /* a_expr: '+' a_expr  */
#line 12591 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 41461 "gram.c"
    break;

  case 1876: /* a_expr: '-' a_expr  */
#line 12593 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 41467 "gram.c"
    break;

  case 1877: /* a_expr: a_expr '+' a_expr  */
#line 12595 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41473 "gram.c"
    break;

  case 1878: /* a_expr: a_expr '-' a_expr  */
#line 12597 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41479 "gram.c"
    break;

  case 1879: /* a_expr: a_expr '*' a_expr  */
#line 12599 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41485 "gram.c"
    break;

  case 1880: /* a_expr: a_expr '/' a_expr  */
#line 12601 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41491 "gram.c"
    break;

  case 1881: /* a_expr: a_expr '%' a_expr  */
#line 12603 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41497 "gram.c"
    break;

  case 1882: /* a_expr: a_expr '^' a_expr  */
#line 12605 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41503 "gram.c"
    break;

  case 1883: /* a_expr: a_expr '<' a_expr  */
#line 12607 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41509 "gram.c"
    break;

  case 1884: /* a_expr: a_expr '>' a_expr  */
#line 12609 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41515 "gram.c"
    break;

  case 1885: /* a_expr: a_expr '=' a_expr  */
#line 12611 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41521 "gram.c"
    break;

  case 1886: /* a_expr: a_expr LESS_EQUALS a_expr  */
#line 12613 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41527 "gram.c"
    break;

  case 1887: /* a_expr: a_expr GREATER_EQUALS a_expr  */
#line 12615 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41533 "gram.c"
    break;

  case 1888: /* a_expr: a_expr NOT_EQUALS a_expr  */
#line 12617 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41539 "gram.c"
    break;

  case 1889: /* a_expr: a_expr qual_Op a_expr  */
#line 12620 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41545 "gram.c"
    break;

  case 1890: /* a_expr: qual_Op a_expr  */
#line 12622 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 41551 "gram.c"
    break;

  case 1891: /* a_expr: a_expr qual_Op  */
#line 12624 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 41557 "gram.c"
    break;

  case 1892: /* a_expr: a_expr AND a_expr  */
#line 12627 "gram.y"
                                { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41563 "gram.c"
    break;

  case 1893: /* a_expr: a_expr OR a_expr  */
#line 12629 "gram.y"
                                { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 41569 "gram.c"
    break;

  case 1894: /* a_expr: NOT a_expr  */
#line 12631 "gram.y"
                                { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 41575 "gram.c"
    break;

  case 1895: /* a_expr: NOT_LA a_expr  */
#line 12633 "gram.y"
                                { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 41581 "gram.c"
    break;

  case 1896: /* a_expr: a_expr LIKE a_expr  */
#line 12636 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 41590 "gram.c"
    break;

  case 1897: /* a_expr: a_expr LIKE a_expr ESCAPE a_expr  */
#line 12641 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 41602 "gram.c"
    break;

  case 1898: /* a_expr: a_expr NOT_LA LIKE a_expr  */
#line 12649 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 41611 "gram.c"
    break;

  case 1899: /* a_expr: a_expr NOT_LA LIKE a_expr ESCAPE a_expr  */
#line 12654 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 41623 "gram.c"
    break;

  case 1900: /* a_expr: a_expr ILIKE a_expr  */
#line 12662 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 41632 "gram.c"
    break;

  case 1901: /* a_expr: a_expr ILIKE a_expr ESCAPE a_expr  */
#line 12667 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 41644 "gram.c"
    break;

  case 1902: /* a_expr: a_expr NOT_LA ILIKE a_expr  */
#line 12675 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 41653 "gram.c"
    break;

  case 1903: /* a_expr: a_expr NOT_LA ILIKE a_expr ESCAPE a_expr  */
#line 12680 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 41665 "gram.c"
    break;

  case 1904: /* a_expr: a_expr SIMILAR TO a_expr  */
#line 12689 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 41677 "gram.c"
    break;

  case 1905: /* a_expr: a_expr SIMILAR TO a_expr ESCAPE a_expr  */
#line 12697 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 41689 "gram.c"
    break;

  case 1906: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr  */
#line 12705 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 41701 "gram.c"
    break;

  case 1907: /* a_expr: a_expr NOT_LA SIMILAR TO a_expr ESCAPE a_expr  */
#line 12713 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 41713 "gram.c"
    break;

  case 1908: /* a_expr: a_expr IS NULL_P  */
#line 12731 "gram.y"
                                {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 41725 "gram.c"
    break;

  case 1909: /* a_expr: a_expr ISNULL  */
#line 12739 "gram.y"
                                {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 41737 "gram.c"
    break;

  case 1910: /* a_expr: a_expr IS NOT NULL_P  */
#line 12747 "gram.y"
                                {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 41749 "gram.c"
    break;

  case 1911: /* a_expr: a_expr NOTNULL  */
#line 12755 "gram.y"
                                {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 41761 "gram.c"
    break;

  case 1912: /* a_expr: row OVERLAPS row  */
#line 12763 "gram.y"
                                {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 41781 "gram.c"
    break;

  case 1913: /* a_expr: a_expr IS TRUE_P  */
#line 12779 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 41793 "gram.c"
    break;

  case 1914: /* a_expr: a_expr IS NOT TRUE_P  */
#line 12787 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 41805 "gram.c"
    break;

  case 1915: /* a_expr: a_expr IS FALSE_P  */
#line 12795 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 41817 "gram.c"
    break;

  case 1916: /* a_expr: a_expr IS NOT FALSE_P  */
#line 12803 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 41829 "gram.c"
    break;

  case 1917: /* a_expr: a_expr IS UNKNOWN  */
#line 12811 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 41841 "gram.c"
    break;

  case 1918: /* a_expr: a_expr IS NOT UNKNOWN  */
#line 12819 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 41853 "gram.c"
    break;

  case 1919: /* a_expr: a_expr IS DISTINCT FROM a_expr  */
#line 12827 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 41861 "gram.c"
    break;

  case 1920: /* a_expr: a_expr IS NOT DISTINCT FROM a_expr  */
#line 12831 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 41869 "gram.c"
    break;

  case 1921: /* a_expr: a_expr IS OF '(' type_list ')'  */
#line 12835 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 41877 "gram.c"
    break;

  case 1922: /* a_expr: a_expr IS NOT OF '(' type_list ')'  */
#line 12839 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 41885 "gram.c"
    break;

  case 1923: /* a_expr: a_expr BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 12843 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 41897 "gram.c"
    break;

  case 1924: /* a_expr: a_expr NOT_LA BETWEEN opt_asymmetric b_expr AND a_expr  */
#line 12851 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 41909 "gram.c"
    break;

  case 1925: /* a_expr: a_expr BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 12859 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 41921 "gram.c"
    break;

  case 1926: /* a_expr: a_expr NOT_LA BETWEEN SYMMETRIC b_expr AND a_expr  */
#line 12867 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 41933 "gram.c"
    break;

  case 1927: /* a_expr: a_expr IN_P in_expr  */
#line 12875 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 41957 "gram.c"
    break;

  case 1928: /* a_expr: a_expr NOT_LA IN_P in_expr  */
#line 12895 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 41983 "gram.c"
    break;

  case 1929: /* a_expr: a_expr subquery_Op sub_type select_with_parens  */
#line 12917 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 41998 "gram.c"
    break;

  case 1930: /* a_expr: a_expr subquery_Op sub_type '(' a_expr ')'  */
#line 12928 "gram.y"
                                {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 42009 "gram.c"
    break;

  case 1931: /* a_expr: UNIQUE select_with_parens  */
#line 12935 "gram.y"
                                {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 42029 "gram.c"
    break;

  case 1932: /* a_expr: a_expr IS DOCUMENT_P  */
#line 12951 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 42038 "gram.c"
    break;

  case 1933: /* a_expr: a_expr IS NOT DOCUMENT_P  */
#line 12956 "gram.y"
                                {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 42048 "gram.c"
    break;

  case 1934: /* a_expr: DEFAULT  */
#line 12962 "gram.y"
                                {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);
					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 42066 "gram.c"
    break;

  case 1935: /* b_expr: c_expr  */
#line 12987 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 42072 "gram.c"
    break;

  case 1936: /* b_expr: b_expr TYPECAST Typename  */
#line 12989 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 42078 "gram.c"
    break;

  case 1937: /* b_expr: '+' b_expr  */
#line 12991 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 42084 "gram.c"
    break;

  case 1938: /* b_expr: '-' b_expr  */
#line 12993 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 42090 "gram.c"
    break;

  case 1939: /* b_expr: b_expr '+' b_expr  */
#line 12995 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42096 "gram.c"
    break;

  case 1940: /* b_expr: b_expr '-' b_expr  */
#line 12997 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42102 "gram.c"
    break;

  case 1941: /* b_expr: b_expr '*' b_expr  */
#line 12999 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42108 "gram.c"
    break;

  case 1942: /* b_expr: b_expr '/' b_expr  */
#line 13001 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42114 "gram.c"
    break;

  case 1943: /* b_expr: b_expr '%' b_expr  */
#line 13003 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42120 "gram.c"
    break;

  case 1944: /* b_expr: b_expr '^' b_expr  */
#line 13005 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42126 "gram.c"
    break;

  case 1945: /* b_expr: b_expr '<' b_expr  */
#line 13007 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42132 "gram.c"
    break;

  case 1946: /* b_expr: b_expr '>' b_expr  */
#line 13009 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42138 "gram.c"
    break;

  case 1947: /* b_expr: b_expr '=' b_expr  */
#line 13011 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42144 "gram.c"
    break;

  case 1948: /* b_expr: b_expr LESS_EQUALS b_expr  */
#line 13013 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42150 "gram.c"
    break;

  case 1949: /* b_expr: b_expr GREATER_EQUALS b_expr  */
#line 13015 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42156 "gram.c"
    break;

  case 1950: /* b_expr: b_expr NOT_EQUALS b_expr  */
#line 13017 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42162 "gram.c"
    break;

  case 1951: /* b_expr: b_expr qual_Op b_expr  */
#line 13019 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 42168 "gram.c"
    break;

  case 1952: /* b_expr: qual_Op b_expr  */
#line 13021 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 42174 "gram.c"
    break;

  case 1953: /* b_expr: b_expr qual_Op  */
#line 13023 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 42180 "gram.c"
    break;

  case 1954: /* b_expr: b_expr IS DISTINCT FROM b_expr  */
#line 13025 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 42188 "gram.c"
    break;

  case 1955: /* b_expr: b_expr IS NOT DISTINCT FROM b_expr  */
#line 13029 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 42196 "gram.c"
    break;

  case 1956: /* b_expr: b_expr IS OF '(' type_list ')'  */
#line 13033 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 42204 "gram.c"
    break;

  case 1957: /* b_expr: b_expr IS NOT OF '(' type_list ')'  */
#line 13037 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 42212 "gram.c"
    break;

  case 1958: /* b_expr: b_expr IS DOCUMENT_P  */
#line 13041 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 42221 "gram.c"
    break;

  case 1959: /* b_expr: b_expr IS NOT DOCUMENT_P  */
#line 13046 "gram.y"
                                {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 42231 "gram.c"
    break;

  case 1960: /* c_expr: columnref  */
#line 13061 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 42237 "gram.c"
    break;

  case 1961: /* c_expr: AexprConst  */
#line 13062 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 42243 "gram.c"
    break;

  case 1962: /* c_expr: PARAM opt_indirection  */
#line 13064 "gram.y"
                                {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 42262 "gram.c"
    break;

  case 1963: /* c_expr: '(' a_expr ')' opt_indirection  */
#line 13079 "gram.y"
                                {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else if (operator_precedence_warning)
					{
						/*
						 * If precedence warnings are enabled, insert
						 * AEXPR_PAREN nodes wrapping all explicitly
						 * parenthesized subexpressions; this prevents bogus
						 * warnings from being issued when the ordering has
						 * been forced by parentheses.  Take care that an
						 * AEXPR_PAREN node has the same exprLocation as its
						 * child, so as not to cause surprising changes in
						 * error cursor positioning.
						 *
						 * In principle we should not be relying on a GUC to
						 * decide whether to insert AEXPR_PAREN nodes.
						 * However, since they have no effect except to
						 * suppress warnings, it's probably safe enough; and
						 * we'd just as soon not waste cycles on dummy parse
						 * nodes if we don't have to.
						 */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_PAREN, NIL, (yyvsp[-2].node), NULL,
												 exprLocation((yyvsp[-2].node)));
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 42300 "gram.c"
    break;

  case 1964: /* c_expr: case_expr  */
#line 13113 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 42306 "gram.c"
    break;

  case 1965: /* c_expr: func_expr  */
#line 13115 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 42312 "gram.c"
    break;

  case 1966: /* c_expr: select_with_parens  */
#line 13117 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 42327 "gram.c"
    break;

  case 1967: /* c_expr: select_with_parens indirection  */
#line 13128 "gram.y"
                                {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 42355 "gram.c"
    break;

  case 1968: /* c_expr: EXISTS select_with_parens  */
#line 13152 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 42370 "gram.c"
    break;

  case 1969: /* c_expr: ARRAY select_with_parens  */
#line 13163 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 42385 "gram.c"
    break;

  case 1970: /* c_expr: ARRAY array_expr  */
#line 13174 "gram.y"
                                {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 42396 "gram.c"
    break;

  case 1971: /* c_expr: explicit_row  */
#line 13181 "gram.y"
                                {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 42410 "gram.c"
    break;

  case 1972: /* c_expr: implicit_row  */
#line 13191 "gram.y"
                                {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 42424 "gram.c"
    break;

  case 1973: /* c_expr: GROUPING '(' expr_list ')'  */
#line 13201 "gram.y"
                          {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *)g;
			  }
#line 42435 "gram.c"
    break;

  case 1974: /* func_application: func_name '(' ')'  */
#line 13210 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 42443 "gram.c"
    break;

  case 1975: /* func_application: func_name '(' func_arg_list opt_sort_clause ')'  */
#line 13214 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 42453 "gram.c"
    break;

  case 1976: /* func_application: func_name '(' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 13220 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 42464 "gram.c"
    break;

  case 1977: /* func_application: func_name '(' func_arg_list ',' VARIADIC func_arg_expr opt_sort_clause ')'  */
#line 13227 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 42475 "gram.c"
    break;

  case 1978: /* func_application: func_name '(' ALL func_arg_list opt_sort_clause ')'  */
#line 13234 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 42489 "gram.c"
    break;

  case 1979: /* func_application: func_name '(' DISTINCT func_arg_list opt_sort_clause ')'  */
#line 13244 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 42500 "gram.c"
    break;

  case 1980: /* func_application: func_name '(' '*' ')'  */
#line 13251 "gram.y"
                                {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 42520 "gram.c"
    break;

  case 1981: /* func_expr: func_application within_group_clause filter_clause over_clause  */
#line 13279 "gram.y"
                                {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 42559 "gram.c"
    break;

  case 1982: /* func_expr: func_expr_common_subexpr  */
#line 13314 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 42565 "gram.c"
    break;

  case 1983: /* func_expr_windowless: func_application  */
#line 13324 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 42571 "gram.c"
    break;

  case 1984: /* func_expr_windowless: func_expr_common_subexpr  */
#line 13325 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 42577 "gram.c"
    break;

  case 1985: /* func_expr_common_subexpr: COLLATION FOR '(' a_expr ')'  */
#line 13333 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 42587 "gram.c"
    break;

  case 1986: /* func_expr_common_subexpr: CURRENT_DATE  */
#line 13339 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 42595 "gram.c"
    break;

  case 1987: /* func_expr_common_subexpr: CURRENT_TIME  */
#line 13343 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 42603 "gram.c"
    break;

  case 1988: /* func_expr_common_subexpr: CURRENT_TIME '(' Iconst ')'  */
#line 13347 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 42611 "gram.c"
    break;

  case 1989: /* func_expr_common_subexpr: CURRENT_TIMESTAMP  */
#line 13351 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 42619 "gram.c"
    break;

  case 1990: /* func_expr_common_subexpr: CURRENT_TIMESTAMP '(' Iconst ')'  */
#line 13355 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 42627 "gram.c"
    break;

  case 1991: /* func_expr_common_subexpr: LOCALTIME  */
#line 13359 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 42635 "gram.c"
    break;

  case 1992: /* func_expr_common_subexpr: LOCALTIME '(' Iconst ')'  */
#line 13363 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 42643 "gram.c"
    break;

  case 1993: /* func_expr_common_subexpr: LOCALTIMESTAMP  */
#line 13367 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 42651 "gram.c"
    break;

  case 1994: /* func_expr_common_subexpr: LOCALTIMESTAMP '(' Iconst ')'  */
#line 13371 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 42659 "gram.c"
    break;

  case 1995: /* func_expr_common_subexpr: CURRENT_ROLE  */
#line 13375 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 42667 "gram.c"
    break;

  case 1996: /* func_expr_common_subexpr: CURRENT_USER  */
#line 13379 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 42675 "gram.c"
    break;

  case 1997: /* func_expr_common_subexpr: SESSION_USER  */
#line 13383 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 42683 "gram.c"
    break;

  case 1998: /* func_expr_common_subexpr: USER  */
#line 13387 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 42691 "gram.c"
    break;

  case 1999: /* func_expr_common_subexpr: CURRENT_CATALOG  */
#line 13391 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 42699 "gram.c"
    break;

  case 2000: /* func_expr_common_subexpr: CURRENT_SCHEMA  */
#line 13395 "gram.y"
                                {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 42707 "gram.c"
    break;

  case 2001: /* func_expr_common_subexpr: CAST '(' a_expr AS Typename ')'  */
#line 13399 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 42713 "gram.c"
    break;

  case 2002: /* func_expr_common_subexpr: EXTRACT '(' extract_list ')'  */
#line 13401 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42721 "gram.c"
    break;

  case 2003: /* func_expr_common_subexpr: OVERLAY '(' overlay_list ')'  */
#line 13405 "gram.y"
                                {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42734 "gram.c"
    break;

  case 2004: /* func_expr_common_subexpr: POSITION '(' position_list ')'  */
#line 13414 "gram.y"
                                {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42743 "gram.c"
    break;

  case 2005: /* func_expr_common_subexpr: SUBSTRING '(' substr_list ')'  */
#line 13419 "gram.y"
                                {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42754 "gram.c"
    break;

  case 2006: /* func_expr_common_subexpr: TREAT '(' a_expr AS Typename ')'  */
#line 13426 "gram.y"
                                {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 42773 "gram.c"
    break;

  case 2007: /* func_expr_common_subexpr: TRIM '(' BOTH trim_list ')'  */
#line 13441 "gram.y"
                                {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 42784 "gram.c"
    break;

  case 2008: /* func_expr_common_subexpr: TRIM '(' LEADING trim_list ')'  */
#line 13448 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 42792 "gram.c"
    break;

  case 2009: /* func_expr_common_subexpr: TRIM '(' TRAILING trim_list ')'  */
#line 13452 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 42800 "gram.c"
    break;

  case 2010: /* func_expr_common_subexpr: TRIM '(' trim_list ')'  */
#line 13456 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42808 "gram.c"
    break;

  case 2011: /* func_expr_common_subexpr: NULLIF '(' a_expr ',' a_expr ')'  */
#line 13460 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 42816 "gram.c"
    break;

  case 2012: /* func_expr_common_subexpr: COALESCE '(' expr_list ')'  */
#line 13464 "gram.y"
                                {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 42827 "gram.c"
    break;

  case 2013: /* func_expr_common_subexpr: GREATEST '(' expr_list ')'  */
#line 13471 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 42839 "gram.c"
    break;

  case 2014: /* func_expr_common_subexpr: LEAST '(' expr_list ')'  */
#line 13479 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 42851 "gram.c"
    break;

  case 2015: /* func_expr_common_subexpr: XMLCONCAT '(' expr_list ')'  */
#line 13487 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42859 "gram.c"
    break;

  case 2016: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ')'  */
#line 13491 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 42867 "gram.c"
    break;

  case 2017: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ')'  */
#line 13495 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 42875 "gram.c"
    break;

  case 2018: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' expr_list ')'  */
#line 13499 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 42883 "gram.c"
    break;

  case 2019: /* func_expr_common_subexpr: XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ',' expr_list ')'  */
#line 13503 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 42891 "gram.c"
    break;

  case 2020: /* func_expr_common_subexpr: XMLEXISTS '(' c_expr xmlexists_argument ')'  */
#line 13507 "gram.y"
                                {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 42901 "gram.c"
    break;

  case 2021: /* func_expr_common_subexpr: XMLFOREST '(' xml_attribute_list ')'  */
#line 13513 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 42909 "gram.c"
    break;

  case 2022: /* func_expr_common_subexpr: XMLPARSE '(' document_or_content a_expr xml_whitespace_option ')'  */
#line 13517 "gram.y"
                                {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 42922 "gram.c"
    break;

  case 2023: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ')'  */
#line 13526 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 42930 "gram.c"
    break;

  case 2024: /* func_expr_common_subexpr: XMLPI '(' NAME_P ColLabel ',' a_expr ')'  */
#line 13530 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 42938 "gram.c"
    break;

  case 2025: /* func_expr_common_subexpr: XMLROOT '(' a_expr ',' xml_root_version opt_xml_root_standalone ')'  */
#line 13534 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 42947 "gram.c"
    break;

  case 2026: /* func_expr_common_subexpr: XMLSERIALIZE '(' document_or_content a_expr AS SimpleTypename ')'  */
#line 13539 "gram.y"
                                {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 42960 "gram.c"
    break;

  case 2027: /* xml_root_version: VERSION_P a_expr  */
#line 13553 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 42966 "gram.c"
    break;

  case 2028: /* xml_root_version: VERSION_P NO VALUE_P  */
#line 13555 "gram.y"
                                { (yyval.node) = makeNullAConst(-1); }
#line 42972 "gram.c"
    break;

  case 2029: /* opt_xml_root_standalone: ',' STANDALONE_P YES_P  */
#line 13559 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 42978 "gram.c"
    break;

  case 2030: /* opt_xml_root_standalone: ',' STANDALONE_P NO  */
#line 13561 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 42984 "gram.c"
    break;

  case 2031: /* opt_xml_root_standalone: ',' STANDALONE_P NO VALUE_P  */
#line 13563 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 42990 "gram.c"
    break;

  case 2032: /* opt_xml_root_standalone: %empty  */
#line 13565 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 42996 "gram.c"
    break;

  case 2033: /* xml_attributes: XMLATTRIBUTES '(' xml_attribute_list ')'  */
#line 13568 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 43002 "gram.c"
    break;

  case 2034: /* xml_attribute_list: xml_attribute_el  */
#line 13571 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43008 "gram.c"
    break;

  case 2035: /* xml_attribute_list: xml_attribute_list ',' xml_attribute_el  */
#line 13572 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 43014 "gram.c"
    break;

  case 2036: /* xml_attribute_el: a_expr AS ColLabel  */
#line 13576 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 43026 "gram.c"
    break;

  case 2037: /* xml_attribute_el: a_expr  */
#line 13584 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 43038 "gram.c"
    break;

  case 2038: /* document_or_content: DOCUMENT_P  */
#line 13593 "gram.y"
                                                                        { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 43044 "gram.c"
    break;

  case 2039: /* document_or_content: CONTENT_P  */
#line 13594 "gram.y"
                                                                                                { (yyval.ival) = XMLOPTION_CONTENT; }
#line 43050 "gram.c"
    break;

  case 2040: /* xml_whitespace_option: PRESERVE WHITESPACE_P  */
#line 13597 "gram.y"
                                                        { (yyval.boolean) = TRUE; }
#line 43056 "gram.c"
    break;

  case 2041: /* xml_whitespace_option: STRIP_P WHITESPACE_P  */
#line 13598 "gram.y"
                                                                                { (yyval.boolean) = FALSE; }
#line 43062 "gram.c"
    break;

  case 2042: /* xml_whitespace_option: %empty  */
#line 13599 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 43068 "gram.c"
    break;

  case 2043: /* xmlexists_argument: PASSING c_expr  */
#line 13605 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 43076 "gram.c"
    break;

  case 2044: /* xmlexists_argument: PASSING c_expr BY REF_P  */
#line 13609 "gram.y"
                                {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 43084 "gram.c"
    break;

  case 2045: /* xmlexists_argument: PASSING BY REF_P c_expr  */
#line 13613 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 43092 "gram.c"
    break;

  case 2046: /* xmlexists_argument: PASSING BY REF_P c_expr BY REF_P  */
#line 13617 "gram.y"
                                {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 43100 "gram.c"
    break;

  case 2047: /* within_group_clause: WITHIN GROUP_P '(' sort_clause ')'  */
#line 13627 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 43106 "gram.c"
    break;

  case 2048: /* within_group_clause: %empty  */
#line 13628 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43112 "gram.c"
    break;

  case 2049: /* filter_clause: FILTER '(' WHERE a_expr ')'  */
#line 13632 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 43118 "gram.c"
    break;

  case 2050: /* filter_clause: %empty  */
#line 13633 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 43124 "gram.c"
    break;

  case 2051: /* window_clause: WINDOW window_definition_list  */
#line 13641 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 43130 "gram.c"
    break;

  case 2052: /* window_clause: %empty  */
#line 13642 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43136 "gram.c"
    break;

  case 2053: /* window_definition_list: window_definition  */
#line 13646 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 43142 "gram.c"
    break;

  case 2054: /* window_definition_list: window_definition_list ',' window_definition  */
#line 13648 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 43148 "gram.c"
    break;

  case 2055: /* window_definition: ColId AS window_specification  */
#line 13653 "gram.y"
                                {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 43158 "gram.c"
    break;

  case 2056: /* over_clause: OVER window_specification  */
#line 13661 "gram.y"
                                { (yyval.windef) = (yyvsp[0].windef); }
#line 43164 "gram.c"
    break;

  case 2057: /* over_clause: OVER ColId  */
#line 13663 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 43181 "gram.c"
    break;

  case 2058: /* over_clause: %empty  */
#line 13676 "gram.y"
                                { (yyval.windef) = NULL; }
#line 43187 "gram.c"
    break;

  case 2059: /* window_specification: '(' opt_existing_window_name opt_partition_clause opt_sort_clause opt_frame_clause ')'  */
#line 13681 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 43205 "gram.c"
    break;

  case 2060: /* opt_existing_window_name: ColId  */
#line 13706 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 43211 "gram.c"
    break;

  case 2061: /* opt_existing_window_name: %empty  */
#line 13707 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 43217 "gram.c"
    break;

  case 2062: /* opt_partition_clause: PARTITION BY expr_list  */
#line 13710 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 43223 "gram.c"
    break;

  case 2063: /* opt_partition_clause: %empty  */
#line 13711 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43229 "gram.c"
    break;

  case 2064: /* opt_frame_clause: RANGE frame_extent  */
#line 13723 "gram.y"
                                {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 43251 "gram.c"
    break;

  case 2065: /* opt_frame_clause: ROWS frame_extent  */
#line 13741 "gram.y"
                                {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 43261 "gram.c"
    break;

  case 2066: /* opt_frame_clause: %empty  */
#line 13747 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 43273 "gram.c"
    break;

  case 2067: /* frame_extent: frame_bound  */
#line 13757 "gram.y"
                                {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 43294 "gram.c"
    break;

  case 2068: /* frame_extent: BETWEEN frame_bound AND frame_bound  */
#line 13774 "gram.y"
                                {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 43335 "gram.c"
    break;

  case 2069: /* frame_bound: UNBOUNDED PRECEDING  */
#line 13819 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 43347 "gram.c"
    break;

  case 2070: /* frame_bound: UNBOUNDED FOLLOWING  */
#line 13827 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 43359 "gram.c"
    break;

  case 2071: /* frame_bound: CURRENT_P ROW  */
#line 13835 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 43371 "gram.c"
    break;

  case 2072: /* frame_bound: a_expr PRECEDING  */
#line 13843 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 43383 "gram.c"
    break;

  case 2073: /* frame_bound: a_expr FOLLOWING  */
#line 13851 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 43395 "gram.c"
    break;

  case 2074: /* row: ROW '(' expr_list ')'  */
#line 13871 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 43401 "gram.c"
    break;

  case 2075: /* row: ROW '(' ')'  */
#line 13872 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 43407 "gram.c"
    break;

  case 2076: /* row: '(' expr_list ',' a_expr ')'  */
#line 13873 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 43413 "gram.c"
    break;

  case 2077: /* explicit_row: ROW '(' expr_list ')'  */
#line 13876 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 43419 "gram.c"
    break;

  case 2078: /* explicit_row: ROW '(' ')'  */
#line 13877 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 43425 "gram.c"
    break;

  case 2079: /* implicit_row: '(' expr_list ',' a_expr ')'  */
#line 13880 "gram.y"
                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 43431 "gram.c"
    break;

  case 2080: /* sub_type: ANY  */
#line 13883 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 43437 "gram.c"
    break;

  case 2081: /* sub_type: SOME  */
#line 13884 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 43443 "gram.c"
    break;

  case 2082: /* sub_type: ALL  */
#line 13885 "gram.y"
                                                                                                { (yyval.ival) = ALL_SUBLINK; }
#line 43449 "gram.c"
    break;

  case 2083: /* all_Op: Op  */
#line 13888 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 43455 "gram.c"
    break;

  case 2084: /* all_Op: MathOp  */
#line 13889 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 43461 "gram.c"
    break;

  case 2085: /* MathOp: '+'  */
#line 13892 "gram.y"
                                                                                        { (yyval.str) = "+"; }
#line 43467 "gram.c"
    break;

  case 2086: /* MathOp: '-'  */
#line 13893 "gram.y"
                                                                                                { (yyval.str) = "-"; }
#line 43473 "gram.c"
    break;

  case 2087: /* MathOp: '*'  */
#line 13894 "gram.y"
                                                                                                { (yyval.str) = "*"; }
#line 43479 "gram.c"
    break;

  case 2088: /* MathOp: '/'  */
#line 13895 "gram.y"
                                                                                                { (yyval.str) = "/"; }
#line 43485 "gram.c"
    break;

  case 2089: /* MathOp: '%'  */
#line 13896 "gram.y"
                                                                                                { (yyval.str) = "%"; }
#line 43491 "gram.c"
    break;

  case 2090: /* MathOp: '^'  */
#line 13897 "gram.y"
                                                                                                { (yyval.str) = "^"; }
#line 43497 "gram.c"
    break;

  case 2091: /* MathOp: '<'  */
#line 13898 "gram.y"
                                                                                                { (yyval.str) = "<"; }
#line 43503 "gram.c"
    break;

  case 2092: /* MathOp: '>'  */
#line 13899 "gram.y"
                                                                                                { (yyval.str) = ">"; }
#line 43509 "gram.c"
    break;

  case 2093: /* MathOp: '='  */
#line 13900 "gram.y"
                                                                                                { (yyval.str) = "="; }
#line 43515 "gram.c"
    break;

  case 2094: /* MathOp: LESS_EQUALS  */
#line 13901 "gram.y"
                                                                                        { (yyval.str) = "<="; }
#line 43521 "gram.c"
    break;

  case 2095: /* MathOp: GREATER_EQUALS  */
#line 13902 "gram.y"
                                                                                        { (yyval.str) = ">="; }
#line 43527 "gram.c"
    break;

  case 2096: /* MathOp: NOT_EQUALS  */
#line 13903 "gram.y"
                                                                                        { (yyval.str) = "<>"; }
#line 43533 "gram.c"
    break;

  case 2097: /* qual_Op: Op  */
#line 13907 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 43539 "gram.c"
    break;

  case 2098: /* qual_Op: OPERATOR '(' any_operator ')'  */
#line 13909 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 43545 "gram.c"
    break;

  case 2099: /* qual_all_Op: all_Op  */
#line 13914 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 43551 "gram.c"
    break;

  case 2100: /* qual_all_Op: OPERATOR '(' any_operator ')'  */
#line 13916 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 43557 "gram.c"
    break;

  case 2101: /* subquery_Op: all_Op  */
#line 13921 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 43563 "gram.c"
    break;

  case 2102: /* subquery_Op: OPERATOR '(' any_operator ')'  */
#line 13923 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 43569 "gram.c"
    break;

  case 2103: /* subquery_Op: LIKE  */
#line 13925 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~")); }
#line 43575 "gram.c"
    break;

  case 2104: /* subquery_Op: NOT_LA LIKE  */
#line 13927 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~")); }
#line 43581 "gram.c"
    break;

  case 2105: /* subquery_Op: ILIKE  */
#line 13929 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~*")); }
#line 43587 "gram.c"
    break;

  case 2106: /* subquery_Op: NOT_LA ILIKE  */
#line 13931 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~*")); }
#line 43593 "gram.c"
    break;

  case 2107: /* expr_list: a_expr  */
#line 13943 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 43601 "gram.c"
    break;

  case 2108: /* expr_list: expr_list ',' a_expr  */
#line 13947 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 43609 "gram.c"
    break;

  case 2109: /* func_arg_list: func_arg_expr  */
#line 13954 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 43617 "gram.c"
    break;

  case 2110: /* func_arg_list: func_arg_list ',' func_arg_expr  */
#line 13958 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 43625 "gram.c"
    break;

  case 2111: /* func_arg_expr: a_expr  */
#line 13964 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 43633 "gram.c"
    break;

  case 2112: /* func_arg_expr: param_name COLON_EQUALS a_expr  */
#line 13968 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 43646 "gram.c"
    break;

  case 2113: /* func_arg_expr: param_name EQUALS_GREATER a_expr  */
#line 13977 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 43659 "gram.c"
    break;

  case 2114: /* type_list: Typename  */
#line 13987 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 43665 "gram.c"
    break;

  case 2115: /* type_list: type_list ',' Typename  */
#line 13988 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 43671 "gram.c"
    break;

  case 2116: /* array_expr: '[' expr_list ']'  */
#line 13992 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 43679 "gram.c"
    break;

  case 2117: /* array_expr: '[' array_expr_list ']'  */
#line 13996 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 43687 "gram.c"
    break;

  case 2118: /* array_expr: '[' ']'  */
#line 14000 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 43695 "gram.c"
    break;

  case 2119: /* array_expr_list: array_expr  */
#line 14005 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43701 "gram.c"
    break;

  case 2120: /* array_expr_list: array_expr_list ',' array_expr  */
#line 14006 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 43707 "gram.c"
    break;

  case 2121: /* extract_list: extract_arg FROM a_expr  */
#line 14012 "gram.y"
                                {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 43715 "gram.c"
    break;

  case 2122: /* extract_list: %empty  */
#line 14015 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43721 "gram.c"
    break;

  case 2123: /* extract_arg: IDENT  */
#line 14022 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 43727 "gram.c"
    break;

  case 2124: /* extract_arg: YEAR_P  */
#line 14023 "gram.y"
                                                                                                { (yyval.str) = "year"; }
#line 43733 "gram.c"
    break;

  case 2125: /* extract_arg: MONTH_P  */
#line 14024 "gram.y"
                                                                                                { (yyval.str) = "month"; }
#line 43739 "gram.c"
    break;

  case 2126: /* extract_arg: DAY_P  */
#line 14025 "gram.y"
                                                                                                { (yyval.str) = "day"; }
#line 43745 "gram.c"
    break;

  case 2127: /* extract_arg: HOUR_P  */
#line 14026 "gram.y"
                                                                                                { (yyval.str) = "hour"; }
#line 43751 "gram.c"
    break;

  case 2128: /* extract_arg: MINUTE_P  */
#line 14027 "gram.y"
                                                                                                { (yyval.str) = "minute"; }
#line 43757 "gram.c"
    break;

  case 2129: /* extract_arg: SECOND_P  */
#line 14028 "gram.y"
                                                                                                { (yyval.str) = "second"; }
#line 43763 "gram.c"
    break;

  case 2130: /* extract_arg: Sconst  */
#line 14029 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 43769 "gram.c"
    break;

  case 2131: /* overlay_list: a_expr overlay_placing substr_from substr_for  */
#line 14040 "gram.y"
                                {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 43777 "gram.c"
    break;

  case 2132: /* overlay_list: a_expr overlay_placing substr_from  */
#line 14044 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 43785 "gram.c"
    break;

  case 2133: /* overlay_placing: PLACING a_expr  */
#line 14051 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 43791 "gram.c"
    break;

  case 2134: /* position_list: b_expr IN_P b_expr  */
#line 14057 "gram.y"
                                                                                        { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 43797 "gram.c"
    break;

  case 2135: /* position_list: %empty  */
#line 14058 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 43803 "gram.c"
    break;

  case 2136: /* substr_list: a_expr substr_from substr_for  */
#line 14075 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 43811 "gram.c"
    break;

  case 2137: /* substr_list: a_expr substr_for substr_from  */
#line 14079 "gram.y"
                                {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 43820 "gram.c"
    break;

  case 2138: /* substr_list: a_expr substr_from  */
#line 14084 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 43828 "gram.c"
    break;

  case 2139: /* substr_list: a_expr substr_for  */
#line 14088 "gram.y"
                                {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 43847 "gram.c"
    break;

  case 2140: /* substr_list: expr_list  */
#line 14103 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
				}
#line 43855 "gram.c"
    break;

  case 2141: /* substr_list: %empty  */
#line 14107 "gram.y"
                                { (yyval.list) = NIL; }
#line 43861 "gram.c"
    break;

  case 2142: /* substr_from: FROM a_expr  */
#line 14111 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 43867 "gram.c"
    break;

  case 2143: /* substr_for: FOR a_expr  */
#line 14114 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 43873 "gram.c"
    break;

  case 2144: /* trim_list: a_expr FROM expr_list  */
#line 14117 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 43879 "gram.c"
    break;

  case 2145: /* trim_list: FROM expr_list  */
#line 14118 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 43885 "gram.c"
    break;

  case 2146: /* trim_list: expr_list  */
#line 14119 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 43891 "gram.c"
    break;

  case 2147: /* in_expr: select_with_parens  */
#line 14123 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 43902 "gram.c"
    break;

  case 2148: /* in_expr: '(' expr_list ')'  */
#line 14129 "gram.y"
                                                                                        { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 43908 "gram.c"
    break;

  case 2149: /* case_expr: CASE case_arg when_clause_list case_default END_P  */
#line 14140 "gram.y"
                                {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 43922 "gram.c"
    break;

  case 2150: /* when_clause_list: when_clause  */
#line 14153 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43928 "gram.c"
    break;

  case 2151: /* when_clause_list: when_clause_list when_clause  */
#line 14154 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 43934 "gram.c"
    break;

  case 2152: /* when_clause: WHEN a_expr THEN a_expr  */
#line 14159 "gram.y"
                                {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 43946 "gram.c"
    break;

  case 2153: /* case_default: ELSE a_expr  */
#line 14169 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 43952 "gram.c"
    break;

  case 2154: /* case_default: %empty  */
#line 14170 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 43958 "gram.c"
    break;

  case 2155: /* case_arg: a_expr  */
#line 14173 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 43964 "gram.c"
    break;

  case 2156: /* case_arg: %empty  */
#line 14174 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 43970 "gram.c"
    break;

  case 2157: /* columnref: ColId  */
#line 14178 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 43978 "gram.c"
    break;

  case 2158: /* columnref: ColId indirection  */
#line 14182 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 43986 "gram.c"
    break;

  case 2159: /* indirection_el: '.' attr_name  */
#line 14189 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 43994 "gram.c"
    break;

  case 2160: /* indirection_el: '.' '*'  */
#line 14193 "gram.y"
                                {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 44002 "gram.c"
    break;

  case 2161: /* indirection_el: '[' a_expr ']'  */
#line 14197 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 44014 "gram.c"
    break;

  case 2162: /* indirection_el: '[' opt_slice_bound ':' opt_slice_bound ']'  */
#line 14205 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 44026 "gram.c"
    break;

  case 2163: /* opt_slice_bound: a_expr  */
#line 14215 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 44032 "gram.c"
    break;

  case 2164: /* opt_slice_bound: %empty  */
#line 14216 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 44038 "gram.c"
    break;

  case 2165: /* indirection: indirection_el  */
#line 14220 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44044 "gram.c"
    break;

  case 2166: /* indirection: indirection indirection_el  */
#line 14221 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 44050 "gram.c"
    break;

  case 2167: /* opt_indirection: %empty  */
#line 14225 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 44056 "gram.c"
    break;

  case 2168: /* opt_indirection: opt_indirection indirection_el  */
#line 14226 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 44062 "gram.c"
    break;

  case 2171: /* opt_target_list: target_list  */
#line 14240 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 44068 "gram.c"
    break;

  case 2172: /* opt_target_list: %empty  */
#line 14241 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 44074 "gram.c"
    break;

  case 2173: /* target_list: target_el  */
#line 14245 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 44080 "gram.c"
    break;

  case 2174: /* target_list: target_list ',' target_el  */
#line 14246 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 44086 "gram.c"
    break;

  case 2175: /* target_el: a_expr AS ColLabel  */
#line 14250 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 44098 "gram.c"
    break;

  case 2176: /* target_el: a_expr IDENT  */
#line 14266 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 44110 "gram.c"
    break;

  case 2177: /* target_el: a_expr  */
#line 14274 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 44122 "gram.c"
    break;

  case 2178: /* target_el: '*'  */
#line 14282 "gram.y"
                                {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 44138 "gram.c"
    break;

  case 2179: /* qualified_name_list: qualified_name  */
#line 14303 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 44144 "gram.c"
    break;

  case 2180: /* qualified_name_list: qualified_name_list ',' qualified_name  */
#line 14304 "gram.y"
                                                                 { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 44150 "gram.c"
    break;

  case 2181: /* qualified_name: ColId  */
#line 14316 "gram.y"
                                {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 44158 "gram.c"
    break;

  case 2182: /* qualified_name: ColId indirection  */
#line 14320 "gram.y"
                                {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 44187 "gram.c"
    break;

  case 2183: /* name_list: name  */
#line 14347 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 44193 "gram.c"
    break;

  case 2184: /* name_list: name_list ',' name  */
#line 14349 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 44199 "gram.c"
    break;

  case 2185: /* name: ColId  */
#line 14353 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44205 "gram.c"
    break;

  case 2186: /* database_name: ColId  */
#line 14356 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 44211 "gram.c"
    break;

  case 2187: /* access_method: ColId  */
#line 14359 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 44217 "gram.c"
    break;

  case 2188: /* attr_name: ColLabel  */
#line 14361 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44223 "gram.c"
    break;

  case 2189: /* index_name: ColId  */
#line 14363 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44229 "gram.c"
    break;

  case 2190: /* file_name: Sconst  */
#line 14365 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44235 "gram.c"
    break;

  case 2191: /* func_name: type_function_name  */
#line 14376 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 44241 "gram.c"
    break;

  case 2192: /* func_name: ColId indirection  */
#line 14378 "gram.y"
                                        {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 44250 "gram.c"
    break;

  case 2193: /* AexprConst: Iconst  */
#line 14389 "gram.y"
                                {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 44258 "gram.c"
    break;

  case 2194: /* AexprConst: FCONST  */
#line 14393 "gram.y"
                                {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 44266 "gram.c"
    break;

  case 2195: /* AexprConst: Sconst  */
#line 14397 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 44274 "gram.c"
    break;

  case 2196: /* AexprConst: BCONST  */
#line 14401 "gram.y"
                                {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 44282 "gram.c"
    break;

  case 2197: /* AexprConst: XCONST  */
#line 14405 "gram.y"
                                {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 44295 "gram.c"
    break;

  case 2198: /* AexprConst: func_name Sconst  */
#line 14414 "gram.y"
                                {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 44306 "gram.c"
    break;

  case 2199: /* AexprConst: func_name '(' func_arg_list opt_sort_clause ')' Sconst  */
#line 14421 "gram.y"
                                {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 44342 "gram.c"
    break;

  case 2200: /* AexprConst: ConstTypename Sconst  */
#line 14453 "gram.y"
                                {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 44350 "gram.c"
    break;

  case 2201: /* AexprConst: ConstInterval Sconst opt_interval  */
#line 14457 "gram.y"
                                {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 44360 "gram.c"
    break;

  case 2202: /* AexprConst: ConstInterval '(' Iconst ')' Sconst  */
#line 14463 "gram.y"
                                {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 44371 "gram.c"
    break;

  case 2203: /* AexprConst: TRUE_P  */
#line 14470 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 44379 "gram.c"
    break;

  case 2204: /* AexprConst: FALSE_P  */
#line 14474 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 44387 "gram.c"
    break;

  case 2205: /* AexprConst: NULL_P  */
#line 14478 "gram.y"
                                {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 44395 "gram.c"
    break;

  case 2206: /* Iconst: ICONST  */
#line 14483 "gram.y"
                                                                                        { (yyval.ival) = (yyvsp[0].ival); }
#line 44401 "gram.c"
    break;

  case 2207: /* Sconst: SCONST  */
#line 14484 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44407 "gram.c"
    break;

  case 2208: /* SignedIconst: Iconst  */
#line 14486 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 44413 "gram.c"
    break;

  case 2209: /* SignedIconst: '+' Iconst  */
#line 14487 "gram.y"
                                                                                        { (yyval.ival) = + (yyvsp[0].ival); }
#line 44419 "gram.c"
    break;

  case 2210: /* SignedIconst: '-' Iconst  */
#line 14488 "gram.y"
                                                                                        { (yyval.ival) = - (yyvsp[0].ival); }
#line 44425 "gram.c"
    break;

  case 2211: /* RoleId: RoleSpec  */
#line 14493 "gram.y"
                                {
					RoleSpec *spc = (RoleSpec *) (yyvsp[0].rolespec);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
					}
				}
#line 44457 "gram.c"
    break;

  case 2212: /* RoleSpec: NonReservedWord  */
#line 14523 "gram.y"
                                        {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[0].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[0].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[0]))));
						}
						else
						{
							n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
							n->rolename = pstrdup((yyvsp[0].str));
						}
						(yyval.rolespec) = n;
					}
#line 44488 "gram.c"
    break;

  case 2213: /* RoleSpec: CURRENT_USER  */
#line 14550 "gram.y"
                                        {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
					}
#line 44496 "gram.c"
    break;

  case 2214: /* RoleSpec: SESSION_USER  */
#line 14554 "gram.y"
                                        {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
					}
#line 44504 "gram.c"
    break;

  case 2215: /* role_list: RoleSpec  */
#line 14560 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 44510 "gram.c"
    break;

  case 2216: /* role_list: role_list ',' RoleSpec  */
#line 14562 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 44516 "gram.c"
    break;

  case 2217: /* ColId: IDENT  */
#line 14578 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44522 "gram.c"
    break;

  case 2218: /* ColId: unreserved_keyword  */
#line 14579 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44528 "gram.c"
    break;

  case 2219: /* ColId: col_name_keyword  */
#line 14580 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44534 "gram.c"
    break;

  case 2220: /* type_function_name: IDENT  */
#line 14585 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 44540 "gram.c"
    break;

  case 2221: /* type_function_name: unreserved_keyword  */
#line 14586 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44546 "gram.c"
    break;

  case 2222: /* type_function_name: type_func_name_keyword  */
#line 14587 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44552 "gram.c"
    break;

  case 2223: /* NonReservedWord: IDENT  */
#line 14592 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 44558 "gram.c"
    break;

  case 2224: /* NonReservedWord: unreserved_keyword  */
#line 14593 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44564 "gram.c"
    break;

  case 2225: /* NonReservedWord: col_name_keyword  */
#line 14594 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44570 "gram.c"
    break;

  case 2226: /* NonReservedWord: type_func_name_keyword  */
#line 14595 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44576 "gram.c"
    break;

  case 2227: /* ColLabel: IDENT  */
#line 14601 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 44582 "gram.c"
    break;

  case 2228: /* ColLabel: unreserved_keyword  */
#line 14602 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44588 "gram.c"
    break;

  case 2229: /* ColLabel: col_name_keyword  */
#line 14603 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44594 "gram.c"
    break;

  case 2230: /* ColLabel: type_func_name_keyword  */
#line 14604 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44600 "gram.c"
    break;

  case 2231: /* ColLabel: reserved_keyword  */
#line 14605 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44606 "gram.c"
    break;


#line 44610 "gram.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 15094 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Value	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	Node	   *lexp = lexpr;

	/* Look through AEXPR_PAREN nodes so they don't affect flattening */
	while (IsA(lexp, A_Expr) &&
		   ((A_Expr *) lexp)->kind == AEXPR_PAREN)
		lexp = ((A_Expr *) lexp)->lexpr;
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexp, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexp;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
